!
!  -- LAPACK95 interface driver routine (version 2.1) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     August 15, 2000
!
! ----------------------  LAPACK90 directory  --------------

  This directory contains the following:
  1) Fife subdirectories:
    a) SRC (directory): Source code for all LAPACK95 routines.
    b) EXAMPLES1 (directory): Simple program examples for all
       LAPACK95 driver routines. These programs have been used
       for the numerical examples in Part 2 of the LAPACK95
       Users' Guide.
    c) EXAMPLES2 (directory): More program examples; see the
       README file of this directory for details.
    d) TESTING (directory): Procedures for testing the entire
       LAPACK95 package or individual routines.
    e) TIMING (directory): Source code of the timing programs
       used in the LAPACK95 Users' Guide Chapter 4.
  2) make.inc file which is used by the makefiles in all the
     the above mentioned directories. This make.inc must be
     verify by the installer of LAPACK95 library, and adapt
     to his computer system necessity. The following compiler
     options and library names "OPTS0", "MODLIB", "LAPACK77",
     "BLAS" and "SUF" should be redefined (LAPACK version 3
     or higher should be linked with this LAPACK95 version).
  3) There are several others make.inc files which were use
     for testing of the LAPACK95 library on another machines.
  4) lapack95_redhat.tgz, the prebuilt LAPACK95 library for
     the Linux Redhat system.

  The installation procedure:

  1) Verify the make.inc file ("OPTS0", "MODLIB", "LAPACK77",
     "BLAS" and "SUF").
  2) cd SRC
  3) Read the README file.
  4) Run the make file with one of the selected library name.
  5) cd ../TESTING
  6) Read the README file.
  7) Run the tests as described in README file.
  8) run for a few tests from the directories EXAMPLES1 and
     EXAMPLES2.

!
!  -- LAPACK95 Makefile (version 2.1) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     August, 2000
!
! --------------  LAPACK95/TESTING directory  -----------------------

   The directory contains testing files for all the routines, included
in the library (currently all the driver routines from LAPACK are
implemented) and for all four data types. The names follow the convention:
               la_test_<precision><routine_name>
The testing is modified LAPACK testing. To make the executable test files
you need to run the make command, followed by the name of the executable,
that you need, for example: 
                make linsingle
    or 
                make eigdcomplex
If you need all the executables you can do simply
                make all
The executables are separated in two groups - one for testing the linear
equation routines (linsingle, lindouble, lincomplex, lindcomplex) and
another for testing the eigenvalue problem routines (eigsingle, eigdouble,
eigcomplex, eigdcomplex).

   The make.inc file at the LAPACK95 directory should be adjusted for
the particular environment. Note, that LAPACK95 testing needs library
testlib.a which contains all the testing routines from LAPACK. To produce
this library you need to have access to LAPACK/TESTING directory.
The variable LAPACK_PATH in the make.inc file should give the LAPACK 
directory path. For example, if the LAPACK directory is /usr/local/lib/LAPACK3/
the make.inc should include the following line:

LAPACK_PATH = /usr/local/lib/LAPACK3

   To start a test you should supply an input file. There is a directory,
called INFILES, containing all the input files, that you might need to run
the testings. They are the same files, that LAPACK uses to run LAPACK
testings. In the next few lines there is a short description of the target 
for these input files.
   There are four groups of files : 
     = for single real version of the testings. They usually start with
letter "s", excluding glm.in, gsv.in, lse.in.
   sed.in - (input file for eigsingle) - runs error and computational tests
for  SGEES, SGEEV, SGEESX, SGEEVX
   sgd.in - (eigsingle) - SGGES, SGGEV, SGGESX, SGGEVX
   sgg.in - (eigsingle) - SGEGS, SGEGV
   ssb.in - (eigsingle) - SSBEV, SSBEVD, SSBEVX
   ssg.in - (eigsingle) - SSYGV, SSYGVD, SSYGVX, SSPGV, SSPGVD, SSPGVX,
                          SSBGV, SSBGVD, SSBGVX
   svd.in- (eigsingle)  - SGESVD, SGESDD
   stest.in - (single)  - SGETRF, SGETRI, SGETRS, SGERFS, SGECON, SGESV,
SGESVX, SGEEQU, SGBSV, SGBSVX, SGTSV, SGTSVX, SPOSV, SPOSVX, SPPSV, SPPSVX,
SPBSV, SPBSVX, SPTSV, SPTSVX, SSYSV, SSYSVX, SSPSV, SSPSVX, SGELS, SGELSS,
SGELSX, SGELSY, SGELSD
   glm.in - (eigsingle) - SGGGLM
   gsv.in - (eigsingle) - SGGSVD
   lse.in - (eigsingle) - SGGLSE
   sep.in - (eigsingle) - SSTEV, SSTEVD, SSTEVX, SSTEVR, SSYEV, SSYEVD,
SSYEVX, SSYEVR, SSPEV, SSPEVD, SSPEVX, SSBEV, SSBEVD, SSBEVX
   
      = starting with "c" - for single complex version
      = starting with "d" - for double real version
      = starting with "z" - for double complex version
   The input files  glm.in, gsv.in, lse.in and sep.in are common for all 
four data types.  
   
   An example of running a testing routine is:
   
   ./eigcomplex < INFILES/cgg.in 
   

!
!  -- LAPACK95 README file (version 2.1) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     August, 2000
!
! --------------  LAPACK95/SRC directory  -----------------------

  This directory contains Fortran95 subroutines of the LAPACK95
library and the Fortran95 generic interface blocks of all LAPACK
driver and computational routines, and the Fortran95 generic interface
blocks of all LAPACK95 routines. Every
LAPACK95 driver subroutine has all needed precision and arithmetic
versions; single precision, double precision, complex and double
complex. There are several versions of Fortran95 generic interface
blocks. Every combination of the library needs different Fortran95
interface block (see below). There are here: 1) LAPACK95 library
routines (auxiliary and user callable). 2) Fortran95 generic
interface
blocks for LAPACK driver and computational routines are:
f77_lapack_single.f90 -- for single precision library,
f77_lapack_double.f90 -- for double precision library,
f77_lapack_single_complex.f90 -- for single precision and complex
library, f77_lapack_single_double.f90 -- for single and double
precisions library, f77_lapack_double_dcomplex.f90 -- for double
precision and double complex library,
f77_lapack_single_double_complex.f90 -- for single and double
precision, and complex library,
f77_lapack_single_double_complex_dcomplex.f90 -- for single and double
precision, complex and double complex library 3) Fortran95 generic
interface blocks for LAPACK5 auxiliary routines (this module is needed
for every library version): la_auxmod.f90 -- for LAPACK95 auxiliary
routines. 4) Fortran95 generic interface blocks for LAPACK5 driver
routines are: f95_lapack_single.f90 -- for single precision library,
f95_lapack_double.f90 -- for double precision library,
f95_lapack_single_complex.f90 -- for single precision and complex
library, f95_lapack_single_double.f90 -- for single and double
precisions library, f95_lapack_double_dcomplex.f90 -- for double
precision and double complex library,
f95_lapack_single_double_complex.f90 -- for single and double
precision, and complex library,
f95_lapack_single_double_complex_dcomplex.f90 -- for single and double
precision, complex and double complex library. 5) The makefile by
which the LAPACK95 library can be generated. And 6) this README file.

  The compiler and libraries options "OPTS0", "MODLIB", "LAPACK77",
"BLAS" and "SUF" in the make.inc file at the LAPACK95 directory should
be verified before starting to generate the LAPACK95 library.

  The makefile should be executed as follows:

    make single # for single precision library,
    make double # for double precision library,
    make single_complex # for single precision and complex library,
    make single_double # for single and double precisions library,
    make double_dcomplex # for double precision and double complex
                           library,
    make single_double_complex # for single and double precision, and
                                 complex library,
    make single_double_complex_dcomplex # for single and double
                                          precision, complex and
                                          double complex library.

  If the control of the program fails during the makefile execution do

    make clean

  before generating the next time the library.

!
!  -- LAPACK95 README file (version 2.1) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     August 15, 2000
!
! --------------  LAPACK95/EXAMPLES2 directory  -----------------------

  This directory contains Fortran95 example test programs for all the
LAPACK95 driver subroutines. Every LAPACK95 driver subroutine has all
needed precision and arithmetic versions; single precision, double
precision, complex and double complex. There are here: 1) Fortran95
example test programs 2) the input data for these example programs if
necessary, 3) the makefile by which an executable program can be
generated, executed (results are stored on the file), there are for
scripts by which one can run all test at once and 5) this README file.

  Before running the example programs one must

    1. verify the compiler options and library names "OPTS0",
       "MODLIB", "LAPACK77", "BLAS" and "SUF" in the make.inc
       file at the LAPACK95 directory (LAPACK version 3 or higher
       should be linked with this LAPACK95 version).
    2. generate the LAPACK95 library, go to SRC directory (README
       file)
    3. run the example programs:

           make xnameet, where x can be s, d, c and z, name is the
                         LAPACK routine name (for example gesv) and
                         et indicates an example test. For example

           make sgesvet # single precision test
           make dgesvet # double precision test
           make cgesvet # complex precision test
           make zgesvet # dcomplex precision test

  The results are stored on
           sgesvet.res # single precision results
           dgesvet.res # double precision results
           cgesvet.res # complex precision results
           zgesvet.res # dcomplex precision results

  The rest of the Fortran example test programs can be run in the same
way as the above "xgesvet" tests of "la_gesv" LAPACK95 driver.

  All test can be ran at once using the following four scripts:

  runsingle -- script runs the single precision example test programs
  rundouble -- script runs the double precision example test programs
  runcomplex -- script runs the complex single precision example test
                programs
  rundcomplex -- script runs the complex double precision example test
                 programs

!
!  -- LAPACK95 interface driver routine (version 2.1) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     August 15, 2000
!
! --------------  LAPACK95/EXAMPLES1 directory  -----------------------

  This directory contains Fortran95 programs by which were obtained
the results in the LAPACK95 Users' Guide. There are here: 1) Fortran
example main programs with the same name as in the LAPACK95 Users'
Guide, but in lower case letters, 2) the input data for the example
programs if necessary (the input data are automatically read in by the
example programs), 3) the makefile by which an executable program can
be generated, 4) a script file "go = make clean; make la_$1_example;
la_$1_example" and 5) this README file.

  Before running the example programs one must
    1. verify the compiler options and library names "OPTS0",
       "MODLIB", "LAPACK77", "BLAS" and "SUF" in the make.inc file
       at the LAPACK95 directory (LAPACK version 3 or higher should
       be linked with this LAPACK95 version).
    2. generate the LAPACK95 library, go to SRC directory (README
       file)
    3. run example programs. For example,
          
           make la_gesv_example

  This "make" statement will compile the example Fortran program

                  la_gesv_example.f90,

link with the necessary libraries

                  lapack95.a, lapack.a and blas.a,

and generate the executable program

                  la_gesv_example

  One has to run this executable program now. All programs run in
single precision.

                   ./la_gesv_example

  The script should be run as follows

           go gesv

It compiles the Fortran95 example program, links and runs the
executable program.

!
!  -- LAPACK95 Timing routines (version 2.1) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     August, 2000
!
! --------------  LAPACK95/TIMING directory  -----------------------

   The TIMING directory contains Fortran95 example timing routines that 
produce performance measurements for some basic computational routines.
   To produce the executable files
 
 make xtimingd
   or 
 make xtimings  
 - this will produce the program for testing the real (double and single
precision ) versions of the routines. 

 make xtimingz
    or
 make xtimingc
 - this will produce the program for the complex (double and single precision)
versions.
 
 The  real versions of the routines has calling sequences to the following
routines: LA_GESV, LA_GEEV - eigenvalues are required only, LA_GEEV - 
eigenvalues and right eigenvectors, LA_GESDD - singular values only, 
LA_GESDD - singular values and left and right singular vectors, 
LA_GESVD - singular values and left and right singular vectors.
To provide the comparison the corresponding routines from LAPACK are called.
The time is measured using the Fortran95 cpu_time routine and rtc() (Real
Time Clock) function.
 The complex versions has calling sequences to two lapack95 routines -
LA_GESV and LA_GESDD - singular values and left and right singular vectors.

For the different architectures the optimal value of NB (the blocksize) is 
different. Thus we provide the ilaenv function changed so, that it will 
supply the program with a particular value of NB. The default value is 28
and if another value is desired the ilaenv function should be changed.
Some good values for NB are:
DEC Alpha:         NB=28
COMPAC AS DS-20:   NB=28
Intel Pentium II:  NB=40
Intel Pentium III: NB=40
IBM Power2:        NB=32
IBM Power3:        NB=32
SUN UltraSpark II: NB=64
SGI Origin 2000:   NB=64

 The directory is supplied with Makefile which includes the make.inc file
from the LAPACK95 directory. To compile the program you need to chose the
right options for your architecture.

 The program can be run either by typing:
 
 echo 100 | ./xtimings
(suppose that 100 is the desired value of N)

 or 
 
 ./xtimings 
 and then supplying the desired value for N

  For convenience there is a script called go which is compiling and
running a chosen timing program. The script needs two arguments - 
the precision that is needed and the value of N for which the timing routine
will be executed. 
  To compile and run the single real version of the timing program for value
of N=100 do:
              ./go single 100

SUBROUTINE ZHPGVD_F95( AP, BP, W, ITYPE, UPLO, Z, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: HPGVD_F77 => LA_HPGVD
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
   INTEGER, INTENT(IN), OPTIONAL :: ITYPE
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(INOUT) :: AP(:), BP(:)
   REAL(WP), INTENT(OUT) :: W(:)
   COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!     LA_SPGV, LA_SPGVD, LA_HPGV and LA_HPGVD compute all eigenvalues 
! and, optionally, all eigenvectors of generalized eigenvalue problems 
! of the form A*z = lambda*B*z, A*B*z = lambda*z; and B*A*z = lambda*z,
! where A and B are real symmetric in the cases of LA_SPGV and LA_SPGVD
! and complex Hermitian in the cases of LA_HPGV and LA_HPGVD. In all 
! four cases B is positive definite. Matrices A and B are stored in a 
! packed format.
!     LA_SPGVD and LA_HPGVD use a divide and conquer algorithm. If 
! eigenvectors are desired, they can be much faster than LA_SPGV and
! LA_HPGV for large matrices but use more workspace.
! 
! =========
! 
!       SUBROUTINE LA_SPGV / LA_SPGVD / LA_HPGV / LA_HPGVD( AP, BP, &
!                         W, ITYPE=itype, UPLO=uplo, Z=z, INFO=info )
!            <type>(<wp>), INTENT(INOUT) :: AP(:), BP(:)
!            REAL(<wp>), INTENT(OUT) :: W(:)
!            INTEGER, INTENT(IN), OPTIONAL :: ITYPE
!            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!            <type>(<wp>), INTENT(OUT), OPTIONAL :: Z(:,:)
!            INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!            <type> ::= REAL | COMPLEX
!            <wp>   ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! AP       (input/output) REAL or COMPLEX array, shape (:) with
!          size(AP) = n*(n + 1)/2, where n is the order of A and B.
!          On entry, the upper or lower triangle of matrix A in packed 
! 	   storage. The elements are stored columnwise as follows:
! 	   if UPLO = 'U', AP(i +(j-1)*j/2) = A(i,j) for 1<=i<=j<=n;
! 	   if UPLO = 'L', AP(i +(j-1)*(2*n-j)/2) = A(i,j) for 1<=j<=i<=n.
!          On exit, the contents of AP are destroyed.
! BP       (input/output) REAL or COMPLEX array, shape (:) and 
!          size(BP) = size(AP).
!          On entry, the upper or lower triangle of matrix B in packed 
! 	   storage. The elements are stored columnwise as follows:
! 	   if UPLO = 'U', BP(i +(j-1)*j/2) = B(i,j) for 1<=i<=j<=n;
! 	   if UPLO = 'L', BP(i +(j-1)*(2*n-j)/2) = B(i,j) for 1<=j<=i<=n.
!          On exit, the triangular factor U or L of the Cholesky 
! 	   factorization B = U^H*U or B = L*L^H, in the same storage
! 	   format as B.
! W        (output) REAL array, shape (:) with size(W) = n.
!          The eigenvalues in ascending order.
! ITYPE    Optional (input) INTEGER.
!          Specifies the problem type to be solved:
!             = 1: A*z = lambda*B*z
!             = 2: A*B*z = lambda*z
!             = 3: B*A*z = lambda*z
!          Default value: 1.
! UPLO     Optional (input) CHARACTER(LEN=1).
!             = 'U': Upper triangles of A and B are stored;
!             = 'L': Lower triangles of A and B are stored.
!          Default value: 'U'.
! Z        Optional (output) REAL or COMPLEX square array, shape (:,:)
!          with size(Z,1) = n.
!          The matrix Z of eigenvectors, normalized as follows:
!             if ITYPE = 1 or 2: Z^H * B * Z = I ,
!             if ITYPE = 3: Z^H * B^-1 * Z = I .
! INFO     Optional (output) INTEGER.
!          = 0: successful exit.
!          < 0: if INFO = -i, the i-th argument had an illegal value.
!          > 0: the algorithm failed to converge or matrix B is not 
! 	      positive definite:
!              <= n: if INFO = i, i off-diagonal elements of an 
! 	          intermediate tridiagonal form did not converge to 
! 		  zero.
!              > n: if INFO = n+i, for 1<=i<=n, then the leading minor 
! 	          of order i of B is not positive definite. The 
! 		  factorization of B could not be completed and no
!                   eigenvalues or eigenvectors were computed.
!          If INFO is not present and an error occurs, then the program
! 	   is terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_HPGVD'
!  .. LOCAL SCALARS ..
      CHARACTER(LEN=1) ::  LJOBZ, LUPLO
      INTEGER :: LINFO, N, NN, LD, LITYPE, ISTAT, S1Z, S2Z
      INTEGER :: LWORK, LIWORK, LRWORK 
!  .. LOCAL ARRAYS ..
      COMPLEX(WP), TARGET :: LLZ(1,1), WORKMIN(1)
      COMPLEX(WP), POINTER :: WORK(:)
      REAL(WP), POINTER :: RWORK(:)
      REAL(WP):: RWORKMIN(1)
      INTEGER :: IWORKMIN(1)
      COMPLEX(WP) :: WW
      INTEGER, POINTER :: IWORK(:)
!  .. INTRINSIC FUNCTIONS ..
      INTRINSIC SIZE, MAX, PRESENT
!  .. EXECUTABLE STATEMENTS ..
      LINFO = 0; ISTAT = 0; NN = SIZE(AP)
      WW = (-1+SQRT(1+8*REAL(NN,WP)))*0.5; N = INT(WW);  LD = MAX(1,N)
      IF( PRESENT(ITYPE) )THEN; LITYPE = ITYPE; ELSE; LITYPE = 1; END IF
        IF( PRESENT(Z) )THEN; S1Z = SIZE(Z,1); S2Z = SIZE(Z,2); LJOBZ = 'V'
        ELSE; S1Z = 1; S2Z = 1; LJOBZ = 'N'; END IF
          IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
!  .. TEST THE ARGUMENTS
            IF( NN < 0 .OR. AIMAG(WW) /= 0 .OR. REAL(N,WP) /= REAL(WW) ) THEN; LINFO = -1
            ELSE IF( SIZE(BP) /= SIZE(AP)  )THEN; LINFO = -2
            ELSE IF( SIZE(W) /= N )THEN; LINFO = -3
            ELSE IF( LITYPE < 1 .OR. LITYPE > 3 )THEN; LINFO = -4
            ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -5
            ELSE IF( PRESENT(Z) .AND. ( S1Z /= LD .OR. S2Z /= N ) )THEN; LINFO = -6
            ELSE IF( N > 0 )THEN
!  QUERING THE SIZE OF WORKSPACE ...
                LWORK = -1
		LRWORK = -1
		LIWORK = -1
		IF (PRESENT (Z)) THEN
		  CALL HPGVD_F77( LITYPE, LJOBZ, LUPLO, N, AP, BP, W, &
     &               Z, S1Z, WORKMIN, LWORK, RWORKMIN, LRWORK, IWORKMIN, &
     &               LIWORK, LINFO )
                ELSE
		  CALL HPGVD_F77( LITYPE, LJOBZ, LUPLO, N, AP, BP, W, &
     &               LLZ, S1Z, WORKMIN, LWORK, RWORKMIN, LRWORK, IWORKMIN, &
     &               LIWORK, LINFO )
                ENDIF
     
                LWORK = WORKMIN(1)
		LRWORK = RWORKMIN(1)
		LIWORK= IWORKMIN(1)

                ALLOCATE(WORK(LWORK), RWORK(LRWORK), IWORK(LIWORK), STAT=ISTAT)
                IF( ISTAT == 0 )THEN
                 IF (PRESENT(Z)) THEN
		    CALL HPGVD_F77( LITYPE, LJOBZ, LUPLO, N, AP, BP, W, &
     &                Z, S1Z, WORK, LWORK, RWORK, LRWORK, IWORK, LIWORK, &
     &                LINFO )
                 ELSE
		     CALL HPGVD_F77( LITYPE, LJOBZ, LUPLO, N, AP, BP, W, &
     &                LLZ, S1Z, WORK, LWORK, RWORK, LRWORK, IWORK, LIWORK, &
     &                LINFO )
                 ENDIF
                ELSE; LINFO = -100; ENDIF
                ENDIF
                DEALLOCATE(WORK, RWORK, IWORK, STAT=ISTAT)
                CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE ZHPGVD_F95

                

      PROGRAM LA_GGEV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GGEV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N
!  .. "Local Arrays" ..
      COMPLEX(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:), ALPHA(:)
      COMPLEX(WP), ALLOCATABLE :: VL(:,:), VR(:,:), BETA(:)
      REAL(WP), ALLOCATABLE :: AR(:,:), BR(:,:), ALPHAR(:), ALPHAI(:), BETAR(:), &
                               VLR(:,:), VRR(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GGEV Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), B(N,N), BB(N,N), ALPHA(N), BETA(N), VL(N,N), VR(N,N) )
      ALLOCATE( AR(N,N), BR(N,N), ALPHAR(N), ALPHAI(N), BETAR(N), VLR(N,N), VRR(N,N) )

      WRITE (*,*) 'Example 1, Real Example'
      OPEN(UNIT=21,FILE='gges.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) AR(I,J)
         ENDDO
      ENDDO
      CLOSE(21)
      WRITE(*,*)'Matrix AR : '
      DO I=1,N;
         WRITE(*,"(5(I3,1X))") INT(AR(I,:));
      ENDDO

      OPEN(UNIT=21,FILE='gges.mb',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) BR(I,J)
         ENDDO
      ENDDO
      CLOSE(21)
      WRITE(*,*)'Matrix BR : '
      DO I=1,N;
         WRITE(*,"(5(I3,1X))") INT(BR(I,:));
      ENDDO
      WRITE(*,*)
      WRITE(*,*) 'CALL LA_GGEV( A, B, ALPHAR, ALPHAI, BETAR, VLR, VRR )'
      CALL LA_GGEV( AR, BR, ALPHAR, ALPHAI, BETAR, VLR, VRR )

      WRITE(*,*); WRITE(*,*)'ALPHAR on exit : '; WRITE(*,*) ALPHAR(1:N)
      WRITE(*,*); WRITE(*,*)'ALPHAI on exit : '; WRITE(*,*) ALPHAI(1:N)
      WRITE(*,*); WRITE(*,*)'BETA on exit : '; WRITE(*,*) BETAR(1:N)
      WRITE(*,*)'Array VL:'; DO I =1,N; WRITE(*,*)I, VLR(I,1:N); ENDDO
      WRITE(*,*)'Array VR:'; DO I =1,N; WRITE(*,*)I, VRR(I,1:N); ENDDO

      WRITE(*,*)
      WRITE(*,*)' Generalized eigenvalues : '
      DO I=1,N
         WRITE(*,*) '(',ALPHAR(I)/BETAR(I),',',ALPHAI(I)/BETAR(I),')'
      ENDDO

      WRITE (*,*) 'Example 2, Complex Example'
      OPEN(UNIT=21,FILE='ggev.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=A
    
      WRITE(*,*)'Matrix A : '
      DO I=1,N
         WRITE(*,"(5('('(I3,1X,',',I3)')',1X,1X))") INT(A(I,:)), INT(AIMAG(A(I,:)))
      ENDDO
    
      OPEN(UNIT=21,FILE='ggev.mb',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      BB=B

      WRITE(*,*)'Matrix B : '
      DO I=1,N
         WRITE(*,"(5('('(I3,1X,',',I3)')',1X,1X))") INT(B(I,:)), INT(AIMAG(B(I,:)))
      ENDDO
      WRITE(*,*)
      WRITE(*,*) 'CALL LA_GGEV( A, B, ALPHA, BETA, INFO=INFO )'
      CALL LA_GGEV( A, B, ALPHA, BETA,  INFO=INFO )
   
      WRITE(*,*)
      WRITE(*,*)'ALPHA on exit : '
      DO I=1,N
         WRITE(*,*) ALPHA(I)
      ENDDO

      WRITE(*,*)
      WRITE(*,*)'BETA on exit : '
      DO I=1,N
         WRITE(*,*) BETA(I)
      ENDDO
      WRITE(*,*)
      WRITE(*,*)'INFO = ', INFO

      WRITE(*,*) 
      WRITE(*,*)' Generalized eigenvalues : '
      DO I=1,N 
         WRITE(*,*)  ALPHA(I)/BETA(I)
      ENDDO

      WRITE(*,*)
!     WRITE(*,*)' * EXAMPLE 2 * '
      WRITE(*,*) 'CALL LA_GGEV( A, B, ALPHAR, ALPHAI, BETA, VL, VR )'
      CALL LA_GGEV( A, B, ALPHA, BETA, VL, VR )

      WRITE(*,*)
      WRITE(*,*)'Matrix VL on exit : '
      DO I=1,N;
         WRITE(*,"(5('('(F8.5,1X,',',F8.5)')'))") REAL(VL(I,:)), AIMAG(VL(I,:))
      ENDDO

      WRITE(*,*)
      WRITE(*,*)'Matrix VR on exit : '
      DO I=1,N;
         WRITE(*,"(5('('(F8.5,1X,',',F8.5)')'))") REAL(VR(I,:)), AIMAG(VR(I,:))
      ENDDO

      END PROGRAM LA_GGEV_EXAMPLE

SUBROUTINE ZGTSVX_F95(DL, D, DU, B, X, DLF, DF, DUF, DU2, &
                           IPIV, FACT, TRANS, FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: GTSVX_F77 => LA_GTSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(IN) :: DL(:), D(:), DU(:), B(:,:)
   INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: IPIV(:)
   COMPLEX(WP), INTENT(INOUT), OPTIONAL, TARGET :: DLF(:), DF(:), DUF(:), DU2(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: FERR(:), BERR(:)
   COMPLEX(WP), INTENT(OUT) :: X(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!     LA_GTSVX computes the solution to a real or complex linear system 
! of equations of the form A*X = B, A^T*X = B or A^H*X = B, where A is a
! square tridiagonal matrix and X and B are rectangular matrices or
! vectors.
!     LA_GTSVX can also optionally estimate the condition number of A and 
! compute error bounds.
! 
! =========
! 
!       SUBROUTINE LA_GTSVX( DL, D, DU, B, X, DLF=dlf, DF=df, DUF=duf, &
!               DU2=du2, IPIV=ipiv, FACT=fact, TRANS=trans, FERR=ferr, &
!               BERR=berr, RCOND=rcond, INFO=info )
!           <type>(<wp>), INTENT(IN) :: DL(:), D(:), DU(:), <rhs>
!           <type>(<wp>), INTENT(OUT) :: <sol>
!           <type>(<wp>), INTENT(INOUT), OPTIONAL :: DLF(:), DF(:), &
!                                                   DUF(:), DU2(:)
!           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
!           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT, TRANS
!           REAL(<wp>), INTENT(OUT), OPTIONAL :: <err>
!           REAL(<wp>), INTENT(OUT), OPTIONAL :: RCOND
!           INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!           <type> ::= REAL | COMPLEX
!           <wp>   ::= KIND(1.0) | KIND(1.0D0)
!           <rhs>  ::= B(:,:) | B(:)
!           <sol>  ::= X(:,:) | X(:)
!           <err>  ::= FERR(:), BERR(:) | FERR, BERR
! 
! Arguments
! =========
! 
! DL     (input) REAL or COMPLEX array, shape (:) with size(DL) = n-1.
!        The subdiagonal of A.
! D      (input) REAL or COMPLEX array, shape (:) with size(D) = n.
!        The diagonal of A.
! DU     (input) REAL or COMPLEX array, shape (:) with size(DU) = n-1.
!        The superdiagonal of A.
! B      (input/output) REAL or COMPLEX array, shape (:,:) with 
!        size(B,1) = n or shape (:) with size(B) = n.
!        The matrix B.
! X      (output) REAL or COMPLEX array, shape (:,:) with size(X,1) = n
!        and size(X,2) = size(B,2), or shape (:) with size(X) = n.
!        The solution matrix X .
! DLF    Optional (input or output) REAL or COMPLEX array, shape (:) with
!        size(DLF)= n-1.
!        If FACT = 'F' then DLF is an input argument that contains the 
!        multipliers that define the matrix L from the LU factorization
!        of A.
!        If FACT = 'N' then DLF is an output argument that contains the 
!        multipliers that define the matrix L from the LU factorization
!        of A.
! DF     Optional (input or output) REAL or COMPLEX array, shape (:) with
!        size(DF)= n.
!        If FACT = 'F' then DF is an input argument that contains the 
!        diagonal of the matrix U .
!        If FACT = 'N' then DF is an output argument that contains the 
!        diagonal of the matrix U .
! DUF    Optional (input or output) REAL or COMPLEX array, shape (:) with
!        size(DUF) = n-1.
!        If FACT = 'F' then DUF is an input argument that contains the
!        first superdiagonal of U.
!        If FACT = 'N' then DUF is an output argument that contains the
!        first superdiagonal of U.
! DU2    Optional (input or output) REAL or COMPLEX array, shape (:) with
!        size(DU2) = n-2.
!        If FACT = 'F', then DU2 is an input argument that contains the 
!        second superdiagonal of U.
!        If FACT = 'N', then DU2 is an output argument that contains the
!        second superdiagonal of U.
! IPIV   Optional (input or output) INTEGER array, shape (:) with 
!        size(IPIV) = n.
!        If FACT = 'F' then IPIV is an input argument that contains the
!        pivot indices from the LU factorization of A.
!        If FACT = 'N', then IPIV is an output argument that contains the
!        pivot indices from the LU factorization of A; row i of the 
!        matrix was interchanged with row IPIV(i). IPIV(i) will always
!        be either i or i+1; IPIV(i) = i indicates a row interchange was
!        not required.
! FACT   Optional (input) CHARACTER(LEN=1).
!        Specifies whether the factored form of A is supplied on entry.
!            = 'N': The matrix will be copied to DLF, DF and DUF and
! 	          factored.
!            = 'F': DLF, DF, DUF, DU2 and IPIV contain the factored form
! 	          of A.
!        Default value: 'N'.
! TRANS  Optional (input) CHARACTER(LEN=1).
!        Specifies the form of the system of equations:
!            = 'N': A*X = B (No transpose)
!            = 'T': A^T*X = B (Transpose)
!            = 'C': A^H*X = B (Conjugate transpose)
!        Default value: 'N'.
! FERR   Optional (output) REAL array of shape (:), with size(FERR) =
!        size(X,2), or REAL scalar.
!        The estimated forward error bound for each solution vector X(j)
!        (the j-th column of the solution matrix X). If XTRUE is the true
!        solution corresponding to X(j) , FERR(j) is an estimated upper
!        bound for the magnitude of the largest element in (X(j)-XTRUE)
!        divided by the magnitude of the largest element in X(j). The 
!        estimate is as reliable as the estimate for RCOND and is almost
!        always a slight overestimate of the true error.
! BERR   Optional (output) REAL array of shape (:), with size(BERR) = 
!        size(X,2), or REAL scalar.
!        The componentwise relative backward error of each solution 
!        vector X(j) (i.e.,the smallest relative change in any element of
!        A or B that makes X(j) an exact solution).
! RCOND  Optional (output) REAL.
!        The estimate of the reciprocal condition number of the matrix A.
!        If RCOND is less than the machine precision, the matrix is 
!        singular to working precision. This condition is indicated by
!        a return code of INFO > 0.
! INFO   Optional (output) INTEGER
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value.
!        > 0: if INFO = i, and i is 
!           <= n: U(i,i) = 0. The factorization has not been completed 
! 	        unless i = n. The factor U is singular, so the solution
! 		could not be computed.
!           = n+1: U is nonsingular, but RCOND is less than machine 
! 	        precision, meaning that the matrix is singular to 
! 		working precision. Nevertheless, the solution and
!                 error bounds are computed because the computed solution
! 		can be more accurate than the value of RCOND would 
! 		suggest.
!        If INFO is not present and an error occurs, then the program is
!        terminated with an error message.
!----------------------------------------------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GTSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LTRANS
   INTEGER :: LINFO, NRHS, N, ISTAT, ISTAT1, SIPIV, SDLF, SDF, SDUF, SDU2, &
              SFERR, SBERR
   REAL(WP) :: LRCOND
!  .. LOCAL POINTERS ..
   INTEGER, POINTER :: LPIV(:)
   REAL(WP),  POINTER :: RWORK(:), LFERR(:), LBERR(:)
   COMPLEX(WP),  POINTER :: WORK(:), LDLF(:), LDF(:), LDUF(:), LDU2(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0
   N = SIZE(D); NRHS = SIZE(B,2)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; END IF
   IF( PRESENT(DLF) )THEN; SDLF = SIZE(DLF); ELSE; SDLF = N-1; END IF
   IF( PRESENT(DF) )THEN; SDF = SIZE(DF); ELSE; SDF = N; END IF
   IF( PRESENT(DUF) )THEN; SDUF = SIZE(DUF); ELSE; SDUF = N-1; END IF
   IF( PRESENT(DU2) )THEN; SDU2 = SIZE(DU2); ELSE; SDU2 = N-2; END IF
   IF( PRESENT(FERR) )THEN; SFERR = SIZE(FERR); ELSE; SFERR = NRHS; END IF
   IF( PRESENT(BERR) )THEN; SBERR = SIZE(BERR); ELSE; SBERR = NRHS; END IF
   IF(PRESENT(TRANS))THEN; LTRANS = TRANS; ELSE; LTRANS='N'; END IF
!  PRINT *, LINFO, ISTAT, N, NRHS, LFACT, SIPIV, SDLF, SDF, SDUF, SDU2, SFERR, SBERR, LTRANS
!  .. TEST THE ARGUMENTS
   IF( SIZE( DL ) /= N-1 .AND. N/=0 ) THEN; LINFO = -1
   ELSE IF( N < 0 ) THEN; LINFO = -2
   ELSE IF( SIZE( DU ) /= N-1 .AND. N/=0) THEN; LINFO = -3
   ELSE IF( SIZE(B, 1) /= N .OR. NRHS < 0 )THEN; LINFO = -4
   ELSE IF( SIZE(X, 1) /= N .OR. SIZE(X, 2) /= NRHS )THEN; LINFO = -5
   ELSE IF( SDLF /= N-1 .AND. N/=0) THEN; LINFO = -6
   ELSE IF( SDF /= N ) THEN; LINFO = -7
   ELSE IF( SDUF /= N-1 .AND. N/=0 ) THEN; LINFO = -8
   ELSE IF( SDU2 /= N-2 .AND. N>1 ) THEN; LINFO = -9
   ELSE IF( SIPIV /= N )THEN; LINFO = -10
   ELSE IF( SFERR /= NRHS )THEN; LINFO = -13
   ELSE IF( SBERR /= NRHS )THEN; LINFO = -14
   ELSE IF( ( .NOT. ( LSAME(LFACT,'F') .OR. LSAME(LFACT,'N') ) ) .OR. &
       ( LSAME(LFACT,'F') .AND. .NOT.( PRESENT(DF) .AND. PRESENT(IPIV) ) ) )THEN
      LINFO = -11
   ELSE IF( .NOT.( LSAME(LTRANS,'N') .OR.  LSAME(LTRANS,'T') .OR. &
                  LSAME(LTRANS,'C') ) )THEN; LINFO = -12
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(DF) ) THEN
         ALLOCATE( LDLF(N-1),LDF(N),LDUF(N-1),LDU2(N-2), STAT=ISTAT )
      ELSE; LDLF => DLF; LDF => DF; LDUF => DUF; LDU2 => DU2; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(IPIV) )THEN; ALLOCATE( LPIV(N), STAT=ISTAT )
         ELSE; LPIV => IPIV; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(FERR) )THEN; ALLOCATE( LFERR(NRHS), STAT=ISTAT )
         ELSE; LFERR => FERR; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(BERR) )THEN; ALLOCATE( LBERR(NRHS), STAT=ISTAT )
         ELSE; LBERR => BERR; END IF
      END IF
      IF( ISTAT == 0 ) ALLOCATE( WORK(2*N), RWORK(N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
         CALL GTSVX_F77( LFACT, LTRANS, N, NRHS, DL, D, DU, LDLF, LDF, LDUF, &
                         LDU2, LPIV, B, N, X, N, LRCOND, LFERR, LBERR, &
                         WORK, RWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(DLF) ) DEALLOCATE( LDLF, LDF, LDUF, LDU2, STAT=ISTAT1 )
      IF( .NOT.PRESENT(IPIV) ) DEALLOCATE( LPIV, STAT=ISTAT1 )
      IF( .NOT.PRESENT(FERR) ) DEALLOCATE( LFERR, STAT=ISTAT1 )
      IF( .NOT.PRESENT(BERR) ) DEALLOCATE( LBERR, STAT=ISTAT1 )
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      DEALLOCATE( WORK, RWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE ZGTSVX_F95

 SUBROUTINE ZGBSV1_F95( A, B, K, IPIV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO
    USE F77_LAPACK, ONLY: GBSV_F77 => LA_GBSV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    INTEGER, INTENT(IN), OPTIONAL :: K
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IPIV(:)
    COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GBSV'
!   .. LOCAL SCALARS ..
    INTEGER :: LINFO, ISTAT, ISTAT1, SIPIV, LDA, N, LK, KU
!   .. LOCAL POINTERS ..
    INTEGER, POINTER :: LPIV(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0
    LDA = SIZE(A,1); N = SIZE(A,2)
    IF( PRESENT(K) ) THEN; LK = K; ELSE; LK = (LDA-1)/3; ENDIF
    IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; ENDIF
!   .. TEST THE ARGUMENTS
    IF( LDA - 2*LK -1 < 0 .OR. LDA < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B ) /= N ) THEN; LINFO = -2
    ELSE IF( LDA - 2*LK -1 < 0 .OR. LK < 0 ) THEN; LINFO = -3
    ELSE IF( SIPIV /= N )THEN; LINFO = -4
    ELSE IF ( N > 0 ) THEN
       IF( PRESENT(IPIV) )THEN; LPIV => IPIV; ELSE
           ALLOCATE( LPIV(N), STAT = ISTAT ); END IF
       IF ( ISTAT == 0 ) THEN
          KU = LDA -2*LK -1
          CALL GBSV_F77( N, LK, KU, 1, A, LDA, LPIV, B, N, LINFO )
       ELSE
          LINFO = -100
       END IF
       IF( .NOT.PRESENT(IPIV) )THEN
          DEALLOCATE(LPIV, STAT = ISTAT1 )
       END IF
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE ZGBSV1_F95

SUBROUTINE SGGLSE_F95( A, B, C, D, X, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => SP
    USE LA_AUXMOD, ONLY: ERINFO
    USE F77_LAPACK, ONLY: GGLSE_F77 => LA_GGLSE
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:), C(:), D(:)
    REAL(WP), INTENT(OUT) :: X(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!       LA_GGLSE solves the linear equality-constrained least squares 
! (LSE) problem:
!      min || c - A*x||2 subject to B*x = d,
! where A and B are real or complex rectangular matrices and c and d are
! real or complex vectors. Further, A is m by n, B is p by n, c is m by 1
! and d is p by 1, and it is assumed that
!       p <= n <=  m + p, rank(B) = p,  rank [ A ] = n.
!                                            [ B ]
! These conditions ensure that the LSE problem has a unique solution x. 
! This is obtained using the generalized RQ factorization of the matrices
! B and A.
! 
! =========
! 
!        SUBROUTINE LA_GGLSE( A, B, C, D, X, INFO=info )
!          <type>(<wp>), INTENT( INOUT ) :: A(:,:), B(:,:), C(:), D(:)
!          <type>(<wp>), INTENT( OUT ) :: X(:)
!          INTEGER, INTENT(OUT), OPTIONAL :: INFO
!        where
!          <type> ::= REAL | COMPLEX
!          <wp>   ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! A       (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(A,1) = m and size(A,2) = n.
!         On entry, the matrix A.
!         On exit, the contents of A are destroyed.
! B       (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(B,1) = p and size(B,2) = n.
!         On entry, the matrix B.
!         On exit, the contents of B are destroyed.
! C       (input/output) REAL or COMPLEX array, shape (:) with 
!         size(C) = m.
!         On entry, the vector c.
!         On exit, the residual sum of squares for the solution is given
!  	  by the sum of squares of elements n-p+1 to m.
! D       (input/output) REAL or COMPLEX array, shape (:) with 
!         size(D) = p.
!         On entry, The vectors d.
!         On exit, the contents of D are destroyed.
! X       (output) REAL or COMPLEX array, shape (:) with size(X) = n.
!         The solution vector x.
! INFO    Optional (output) INTEGER.
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         If INFO is not present and an error occurs, then the program
!         is terminated with an error message.
!----------------------------------------------------------------------	
!   .. PARAMETERS ..
    CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GGLSE'
!   .. LOCAL SCALARS ..
    INTEGER :: LINFO, ISTAT, ISTAT1, N, M, MN, P
!   .. LOCAL SAVE SCALARS ..
    INTEGER, SAVE :: LWORK = 0
!   .. LOCAL POINTERS ..
    REAL(WP), POINTER :: WORK(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, MAX, MIN
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2); P = SIZE(B,1)
    MN = MIN(M,N)
!   .. TEST THE ARGUMENTS
    IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( P < 0 .OR. P > N .OR. P < N-M .OR. SIZE(B,2) /= N ) THEN; LINFO = -2
    ELSE IF( SIZE(C) /= M ) THEN; LINFO = -3
    ELSE IF( SIZE(D) /= P ) THEN; LINFO = -4
    ELSE IF( SIZE(X) /= N ) THEN; LINFO = -5
    ELSE
       LWORK = MAX( 1, M + N + P , LWORK )
       ALLOCATE( WORK(LWORK), STAT = ISTAT )
       IF( ISTAT /= 0 ) THEN
          DEALLOCATE( WORK, STAT=ISTAT1 )
          LWORK = MAX( 1, M + N + P )
          ALLOCATE( WORK(LWORK), STAT = ISTAT )
          IF( ISTAT == 0 ) CALL ERINFO( -200, SRNAME, LINFO )
       END IF
       IF ( ISTAT == 0 ) THEN
!      .. CALL LAPACK77 ROUTINE
          CALL GGLSE_F77( M, N, P, A, MAX(1,M), B, MAX(1,P), &
                          C, D, X, WORK, LWORK, LINFO )
          IF( LINFO == 0 ) LWORK = INT(WORK(1))
       ELSE; LINFO = -100; END IF
       DEALLOCATE(WORK, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE SGGLSE_F95

SUBROUTINE LA_TEST_ZHEGVD( ITYPE, JOBZ, UPLO, N, A, LDA, B, LDB, W, WORK, LWORK, RWORK, LRWORK, IWORK, LIWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     August 19, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => DP
      USE F95_LAPACK, ONLY: LA_HEGVD
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: ITYPE, N, LDA, LDB, LWORK, LIWORK, LRWORK
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: JOBZ, UPLO
!  .. Array Arguments ..
      COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB, 1:N)
      REAL(WP), INTENT(OUT)::  W(1:N)
      COMPLEX(WP), INTENT(OUT) :: WORK(1:LWORK)
      INTEGER, INTENT(OUT) :: IWORK(1:LIWORK)
      REAL(WP), INTENT(OUT) :: RWORK(1: LRWORK)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_HEGVD'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZHEGVD'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, IW, IB1, IB2, IITYPE
      CHARACTER*1 :: IUPLO, IJOBZ   
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IA1 = N; IA2 = N; IUPLO = UPLO; IW = N; IJOBZ = JOBZ
      IB1 = N; IB2 = N; IITYPE = ITYPE
      I = INFO / 100; J = INFO - I*100

      SELECT CASE(I)
       CASE (1)
         IA2 = IA1 - 1
       CASE (2)
         IB1 = IA1 - 1
       CASE (3)
         IW = IA1 - 1
       CASE (4)
         IITYPE = 22   
       CASE (5)
         IJOBZ = 'T'
       CASE (6)
         IUPLO = 'T'
       CASE(:-1,7:)
         CALL UESTOP(SRNAMT)
      END SELECT
      CALL LA_HEGVD( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), W(1 :IW), &
     &  IITYPE, IJOBZ, IUPLO, INFO )
      
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      END SUBROUTINE LA_TEST_ZHEGVD
      
      
      

SUBROUTINE SSYGVX_F95( A, B, W, ITYPE, JOBZ, UPLO, VL, VU, IL, IU, &
     &  M, IFAIL, ABSTOL, INFO ) 
!  .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => SP
      USE LA_AUXMOD, ONLY: ERINFO, LSAME
      USE F77_LAPACK, ONLY: LAMCH_F77 => SLAMCH
      USE F77_LAPACK, ONLY: SYGVX_F77 => LA_SYGVX
!  .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!  .. CHARACTER ARGUMENTS ..
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
!  .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(IN), OPTIONAL :: IL, IU, ITYPE
      INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
      REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
!  .. ARRAY ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
      REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
      REAL(WP), INTENT(OUT) :: W(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_SYGVX and LA_HEGVX compute selected eigenvalues and, optionally,
! the corresponding eigenvectors of generalized eigenvalue problems of 
! the form 
!      A*z = lambda*B*z, A*B*z = lambda*z,  and  B*A*z = lambda*z,
! where A and B are real symmetric in the case of LA_SYGVX and complex
! Hermitian in the case of LA_HEGVX. In both cases B is positive 
! definite. Eigenvalues and eigenvectors can be selected by specifying
! either a range of values or a range of indices for the desired 
! eigenvalues.
! 
! =========
! 
!        SUBROUTINE LA_SYGVX / LA_HEGVX (A, B, W, ITYPE= itype, &
!             JOBZ= jobz, UPLO= uplo, VL= vl, VU= vu, IL= il, &
!             IU= iu, M= m, IFAIL= ifail, ABSTOL= abstol, INFO= info )
!          <type>(<wp>), INTENT(INOUT) :: A(:,:), B(:,:)
!          REAL(<wp>), INTENT(OUT) :: W(:)
!          INTEGER, INTENT(IN), OPTIONAL :: ITYPE
!          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
!          REAL(<wp>), INTENT(IN), OPTIONAL :: VL, VU
!          INTEGER, INTENT(IN), OPTIONAL :: IL, IU
!          INTEGER, INTENT(OUT), OPTIONAL :: M
!          INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
!          REAL(<wp>), INTENT(IN), OPTIONAL :: ABSTOL
!          INTEGER, INTENT(OUT), OPTIONAL :: INFO
!        where
!          <type> ::= REAL | COMPLEX
!          <wp>   ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! A      (input/output) REAL or COMPLEX square array, shape (:,:).
!        On entry, the matrix A.
!        If UPLO = 'U', the upper triangular part of A contains the 
!        upper triangular part of matrix A. If UPLO = 'L', the lower
!        triangular part of A contains the lower triangular part of 
!        matrix A.
!        On exit, if JOBZ = 'V', the first M columns of A contain the
!        orthonormal eigenvectors corresponding to the selected 
!        eigenvalues, with the i-th column of A holding the eigenvector
!        associated with the eigenvalue in W(i).
!        The eigenvectors are normalized as follows:
!          if ITYPE = 1 or 2: Z^H * B * Z = I ,
!          if ITYPE = 3: Z^H * B^-1 * Z = I .
!        If an eigenvector fails to converge, then that column of A 
!        contains the latest approximation to the eigenvector and the 
!        index of the eigenvector is returned in IFAIL.
!        If JOBZ = 'N', then the upper triangle (if UPLO = 'U') or the 
!        lower triangle (if UPLO = 'L') of A, including the diagonal, is
!        destroyed.
! B      (input/output) REAL or COMPLEX square array, shape (:,:) with 
!        size(B,1) = size(A,1).
!        On entry, the matrix B.
!        If UPLO = 'U', the upper triangular part of B contains the 
!        upper triangular part of matrix B. If UPLO = 'L', the lower
!        triangular part of B contains the lower triangular part of 
!        matrix B.
!        On exit, the part of B containing the matrix is overwritten by 
!        the triangular factor U or L of the Cholesky factorization 
!              B = U^H*U or B = L*L^H.
! W      (output) REAL array, shape (:) with size(W) = size(A,1).
!        The first M elements contain the selected eigenvalues in 
!        ascending order.
! ITYPE  Optional (input) INTEGER.
!        Specifies the problem type to be solved:
!           = 1: A*z = lambda*B*z
!           = 2: A*B*z = lambda*z
!           = 3: B*A*z = lambda*z
!        Default value: 1.
! JOBZ   Optional (input) CHARACTER(LEN=1).
!           = 'N': Computes eigenvalues only;
!           = 'V': Computes eigenvalues and eigenvectors.
!        Default value: 'N'.
! UPLO   Optional (input) CHARACTER(LEN=1).
!           = 'U': Upper triangles of A and B are stored;
!           = 'L': Lower triangles of A and B are stored.
!        Default value: 'U'.
! VL,VU  Optional (input) REAL.
!        The lower and upper bounds of the interval to be searched for
!        eigenvalues. VL < VU.
!        Default values: VL = -HUGE(<wp>) and VU = HUGE(<wp>), where 
!        <wp> ::= KIND(1.0) | KIND(1.0D0).
!        Note: Neither VL nor VU may be present if IL and/or IU is
!        present.
! IL,IU  Optional (input) INTEGER.
!        The indices of the smallest and largest eigenvalues to be 
!        returned. The IL-th through IU-th eigenvalues will be found. 
!        1<=IL<=IU<=size(A,1).
!        Default values: IL = 1 and IU = size(A,1).
!        Note: Neither IL nor IU may be present if VL and/or VU is
!        present.
!        Note: All eigenvalues are calculated if none of the arguments
!        VL, VU, IL and IU are present.
! M      Optional (output) INTEGER.
!        The total number of eigenvalues found. 0 <= M <= size(A,1).
!        Note: If IL and IU are present then M = IU - IL + 1.
! IFAIL  Optional (output) INTEGER array, shape (:) with size(IFAIL) = 
!        size(A,1).
!        If INFO = 0, the first M elements of IFAIL are zero.
!        If INFO > 0, then IFAIL contains the indices of the 
!        eigenvectors that failed to converge.
!        Note: IFAIL should be present if JOBZ = 'V'.
! ABSTOL Optional (input) REAL.
!        The absolute error tolerance for the eigenvalues. An approximate
!        eigenvalue is accepted as converged when it is determined to lie
!        in an interval [a,b] of width less than or equal to
!             ABSTOL + EPSILON(1.0_<wp>) * max(| a |, | b |),
!        where <wp> is the working precision. If ABSTOL <= 0, then
!        EPSILON(1.0_<wp>)* ||T||1 will be used in its place, where 
!        ||T||1 is the l1 norm of the tridiagonal matrix obtained by 
!        reducing the generalized eigenvalue problem to tridiagonal form. 
!        Eigenvalues will be computed most accurately when ABSTOL is set
!        to twice the underflow threshold 2 * LA_LAMCH(1.0_<wp>, 'S'),
!        not zero.
!        Default value: 0.0_<wp>.
!        Note: If this routine returns with 0 < INFO <= n, then some 
!        eigenvectors did not converge.
!        Try setting ABSTOL to 2 * LA_LAMCH(1.0_<wp>, 'S').
! INFO   Optional (output) INTEGER.
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value.
!        > 0: the algorithm failed to converge or matrix B is not
!        positive definite:
!           <= n: the algorithm failed to converge; if INFO = i, then i
! 	      eigenvectors failed to converge. Their indices are stored
! 	      in array IFAIL.
!           > n: if INFO = n+i, for 1 <= i <= n, then the leading minor 
! 	      of order i of B is not positive definite. The 
! 	      factorization of B could not be completed and no 
! 	      eigenvalues or eigenvectors were computed.
! 	  n is the order of A.
!        If INFO is not present and an error occurs, then the program is
!        terminated with an error message.
!-----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_SYGVX'
      CHARACTER(LEN=6), PARAMETER :: BSNAME = 'DSYTRD'
!  .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: LJOBZ, LUPLO, LRANGE
      INTEGER :: N, LINFO, LDA, LDZ, LZ, LIL, LIU, LM, LWORK, ISTAT, &
      &     SIFAIL, LDB, LITYPE
      INTEGER, TARGET :: ISTAT1(1)
      REAL(WP) :: LABSTOL, LVL, LVU
!  .. LOCAL ARRAYS ..
      INTEGER, POINTER :: IWORK(:), LIFAIL(:)
      REAL(WP), POINTER :: WORK(:), Z(:,:)
      REAL(WP) :: WORKMIN(1)
!  .. INTRINSIC FUNCTIONS ..
      INTRINSIC HUGE, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   IF (PRESENT(M)) M = 0
   N = SIZE(A,1); LDA = MAX(1,N); LDB=MAX(1,SIZE(B,1)); LINFO = 0; ISTAT = 0
   IF( PRESENT(ITYPE) )THEN; LITYPE = ITYPE; ELSE; LITYPE = 1; END IF 
   IF( PRESENT(IFAIL) )THEN; SIFAIL = SIZE(IFAIL);ELSE; SIFAIL = N; END IF
   IF (PRESENT (JOBZ)) THEN; LJOBZ=JOBZ; ELSE; LJOBZ = 'N'; ENDIF
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
   IF( PRESENT(VL) )THEN; LVL = VL; ELSE; LVL = -HUGE(LVL); ENDIF
   IF( PRESENT(VU) )THEN;  LVU = VU; ELSE; LVU = HUGE(LVU); ENDIF
   IF( PRESENT(IL) )THEN; LIL = IL; ELSE; LIL = 1; ENDIF
   IF( PRESENT(IU) )THEN; LIU = IU; ELSE; LIU = N; ENDIF
!  .. TEST THE ARGUMENTS
   IF( PRESENT(VL) .OR. PRESENT(VU) )THEN ; LRANGE = 'V'; LM=N
   ELSE IF( PRESENT(IL) .OR. PRESENT(IU) )THEN ; LRANGE = 'I'; LM=LIU-LIL+1
   ELSE ; LRANGE = 'A'; LM=N; END IF
   IF( SIZE( A, 2 ) /= N .OR. N < 0 )THEN; LINFO = -1
   ELSE IF (SIZE (B, 2) /= N ) THEN; LINFO = -2
   ELSE IF( SIZE( W ) /= N )THEN;  LINFO = -3
   ELSE IF( LITYPE < 1 .OR. LITYPE > 3 )THEN; LINFO = -4
   ELSE IF( .NOT.LSAME(LJOBZ,'V') .AND. .NOT.LSAME(LJOBZ,'N') )THEN; LINFO = -5
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -6
   ELSE IF( LVU < LVL )THEN ; LINFO = -7
   ELSE IF( (PRESENT(VL) .OR. PRESENT(VU)) .AND. &
            (PRESENT(IL) .OR. PRESENT(IU)) )THEN; LINFO = -8
   ELSE IF( LSAME(LRANGE, 'I') .AND. ( LIU < MIN( N, LIL ) .OR. LIU>N))THEN; LINFO = -9
   ELSE IF( N < LIU )THEN; LINFO = -10
   ELSE IF( SIFAIL /= N )THEN; LINFO = -12
   ELSE IF( N > 0 )THEN
     IF(LSAME(LJOBZ, 'V')) THEN
         LDZ = MAX(1,N); LZ=LM
     ELSE
         LDZ = 1; LZ=1
     ENDIF
       IF( PRESENT(IFAIL) )THEN; LIFAIL => IFAIL
       ELSE; ALLOCATE( LIFAIL(N), STAT=ISTAT )
         IF (ISTAT /= 0) THEN; LINFO = -100; GOTO 200; ENDIF         
         END IF
!     .. DETERMINE THE WORKSPACE
         ALLOCATE(IWORK(5*N), STAT=ISTAT)
         IF (ISTAT /= 0) THEN; LINFO = -100
           GOTO 300
         ENDIF
         ALLOCATE(Z(LDZ, LZ), STAT=ISTAT)
	 IF (ISTAT /= 0) THEN; LINFO = -100
	    GOTO 400
	 ENDIF
         
	 LWORK = -1
             CALL SYGVX_F77( LITYPE, LJOBZ, LRANGE, LUPLO, N, A, LDA, B, &
&                  LDB, LVL, LVU, LIL, LIU, LABSTOL, LM, W, Z, LDZ, WORKMIN, &
&                  LWORK, IWORK, LIFAIL, LINFO )
! NEXT LINE SHOULD BE LWORK = WORKMIN(1) 	   
           LWORK = 2*WORKMIN(1)

           ALLOCATE (WORK(LWORK), STAT = ISTAT)
           IF( ISTAT /= 0 )THEN; LINFO = -100
             GOTO 500
           ENDIF
             IF( LINFO == 0 )THEN
               IF( PRESENT(ABSTOL) )THEN; LABSTOL = ABSTOL
               ELSE; LABSTOL = 2*LAMCH_F77('Safe minimum');  ENDIF
!     .. CALL LAPACK77 ROUTINE
                 CALL SYGVX_F77( LITYPE, LJOBZ, LRANGE, LUPLO, N, A, LDA, B, &
&                  LDB, LVL, LVU, LIL, LIU, LABSTOL, LM, W, Z, LDZ, WORK, &
                   LWORK, IWORK, LIFAIL, LINFO )

                 IF( PRESENT(M) ) M = LM
		 IF (LSAME(LJOBZ,'V'))  A(1:LDZ, 1:LM)=Z(1:LDZ, 1:LM)
              END IF
         DEALLOCATE (WORK, STAT = ISTAT1(1))
500      DEALLOCATE(Z)	      
400      DEALLOCATE (IWORK, STAT = ISTAT)
300      IF (.NOT.PRESENT(IFAIL)) DEALLOCATE(LIFAIL, STAT=ISTAT1(1)); END IF
200       CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE SSYGVX_F95

SUBROUTINE LA_TEST_CGEEVX( BALANC, JOBVL, JOBVR,  SENSE, N, A, LDA,&
     &  W, VL, LDVL, VR, LDVR,  ILO, IHI, SCALE, ABNRM, &
     &  RCONDE, RCONDV, WORK, LWORK, RWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 29, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GEEVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, LDA, LDVL, LDVR, LWORK
      INTEGER, INTENT(INOUT) :: INFO
      INTEGER, INTENT(OUT) :: ILO, IHI
      CHARACTER*1, INTENT(IN) :: BALANC, JOBVL, JOBVR, SENSE
      REAL(WP), INTENT(OUT) :: ABNRM
!  .. Array Arguments ..
      COMPLEX(WP), INTENT(INOUT) :: A(1: LDA, 1:N)
      COMPLEX(WP), INTENT(OUT)::  W(1: N), VL(1: LDVL, 1: N), &
     &  VR(1: LDVR, 1:N)
      COMPLEX(WP), INTENT(OUT) :: WORK(1:LWORK)
      REAL(WP), INTENT(OUT) :: SCALE(1:N), RCONDE(1:N), RCONDV(1:N)
      REAL(WP), INTENT(OUT) :: RWORK(1: 2*N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GEEVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_CGEEVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, IW, IVL1, IVL2, IVR1, IVR2,&
     &  IRCONDE, IRCONDV, ISCALE
      CHARACTER*1 :: IBALANC, IJOBVR, IJOBVL   
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      LOGICAL LSAME
!  .. Executable Statements ..
      IA1 = N; IA2 = N; IW = N; IVL1 = N; IVL2 = N
      IVR1 = N; IVR2 = N; IJOBVL = JOBVL; IJOBVR = JOBVR
      IRCONDE = N; IRCONDV = N; ISCALE=N; IBALANC=BALANC
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE (1)
      IA2 = IA1 - 1
      CASE (2)
      IW = IW - 1
      CASE (3)
      IVL1 = IVL1 - 1
      IJOBVL = 'V'; IJOBVR = 'V'
      CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
     &  VL(1: IVL1, 1:IVL2), VR(1: IVR1, 1: IVR2), &
     &  IBALANC, ILO, IHI, SCALE(1:ISCALE), ABNRM, &
     &  RCONDE(1:IRCONDE),& 
     &  RCONDV(1:IRCONDV), INFO)
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (4)
      IVR1 = IVR1 - 1
      IJOBVR = 'V'; IJOBVR = 'V'
      CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
     &  VL(1: IVL1, 1:IVL2), VR(1: IVR1, 1: IVR2), &
     &  IBALANC, ILO, IHI, SCALE(1:ISCALE), ABNRM, &
     &  RCONDE(1:IRCONDE),& 
     &  RCONDV(1:IRCONDV), INFO)
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (5)
      IBALANC = 'T'
      CASE(8)
      ISCALE = IA1 - 1
      CASE (10)
      IRCONDE = IA1 - 1
      IJOBVR = 'V'; IJOBVR = 'V'
      CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
     &  VL(1: IVL1, 1:IVL2), VR(1: IVR1, 1: IVR2), &
     &  IBALANC, ILO, IHI, SCALE(1:ISCALE), ABNRM, &
     &  RCONDE(1:IRCONDE),& 
     &  RCONDV(1:IRCONDV), INFO)
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      Case (11)
      IRCONDV = IA1 - 1
      IJOBVR = 'V'; IJOBVR = 'V'
      CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
     &  VL(1: IVL1, 1:IVL2), VR(1: IVR1, 1: IVR2), &
     &  IBALANC, ILO, IHI, SCALE(1:ISCALE), ABNRM, &
     &  RCONDE(1:IRCONDE),& 
     &  RCONDV(1:IRCONDV), INFO)
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE(:-1,6,7,9,12:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF (LSAME(IJOBVR, 'V')) THEN
        IF (LSAME(IJOBVL,'V')) THEN
          SELECT CASE (SENSE)
            CASE ('B')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VL(1: IVL1, 1:IVL2), VR(1: IVR1, 1: IVR2), &
&               IBALANC, ILO, IHI, SCALE(1:ISCALE), ABNRM, &
&               RCONDE(1:IRCONDE),&
&               RCONDV(1:IRCONDV), INFO)
            CASE ('E')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VL(1: IVL1, 1:IVL2), VR(1: IVR1, 1: IVR2), &
&               IBALANC, ILO, IHI, SCALE(1:ISCALE), ABNRM, &
&               RCONDE(1:IRCONDE),&
&               INFO=INFO)
            CASE ('V')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VL(1: IVL1, 1:IVL2), VR(1: IVR1, 1: IVR2), &
&               IBALANC, ILO, IHI, SCALE(1:ISCALE), ABNRM, &
&               RCONDV=RCONDV(1:IRCONDV), INFO=INFO)
            CASE ('N')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VL(1: IVL1, 1:IVL2), VR(1: IVR1, 1: IVR2), &
&               IBALANC, ILO, IHI, SCALE(1:ISCALE), ABNRM, &
&               INFO=INFO)
          END SELECT
        ELSE
          SELECT CASE(SENSE)
            CASE ('B')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VR=VR(1: IVR1, 1: IVR2), BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               RCONDE = RCONDE(1:IRCONDE), &
&               RCONDV = RCONDV(1:IRCONDV), INFO = INFO)
            CASE ('E')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VR=VR(1: IVR1, 1: IVR2), BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               RCONDE = RCONDE(1:IRCONDE), &
&               INFO = INFO)
            CASE ('V')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VR=VR(1: IVR1, 1: IVR2), BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               RCONDV = RCONDV(1:IRCONDV), INFO = INFO)
            CASE ('N')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VR=VR(1: IVR1, 1: IVR2), BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               INFO = INFO)
          END SELECT
        END IF
      ELSE
        IF (LSAME(IJOBVL,'V')) THEN
          SELECT CASE(SENSE)
            CASE ('B')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VL(1: IVL1, 1:IVL2),  BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               RCONDE=RCONDE(1:IRCONDE),&
&               RCONDV = RCONDV(1:IRCONDV), INFO = INFO)
            CASE ('E')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VL(1: IVL1, 1:IVL2),  BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               RCONDE=RCONDE(1:IRCONDE),&
&               INFO = INFO)
            CASE ('V')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VL(1: IVL1, 1:IVL2),  BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               RCONDV = RCONDV(1:IRCONDV), INFO = INFO)
            CASE ('N')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               VL(1: IVL1, 1:IVL2),  BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               INFO = INFO)
          END SELECT
        ELSE
          SELECT CASE(SENSE)
            CASE ('B')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               RCONDE=RCONDE(1:IRCONDE),&
&               RCONDV=RCONDV(1:IRCONDV), INFO = INFO)
            CASE ('E')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               RCONDE=RCONDE(1:IRCONDE),&
&               INFO = INFO)
            CASE ('V')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               RCONDV = RCONDV(1:IRCONDV), INFO = INFO)
            CASE ('N')
              CALL LA_GEEVX(A(1:IA1, 1:IA2), W(1: IW), &
&               BALANC=IBALANC, ILO=ILO, &
&               IHI=IHI, SCALE=SCALE(1:ISCALE), ABNRM=ABNRM,&
&               INFO = INFO)
          END SELECT
        END IF                                         
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
    END SUBROUTINE LA_TEST_CGEEVX
    
    

 SUBROUTINE ZGELSS_F95( A, B, RANK, S, RCOND, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO, LA_WS_GELSS
    USE F77_LAPACK, ONLY: GELSS_F77 => LA_GELSS
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL :: RANK
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
    REAL(WP), INTENT(IN), OPTIONAL :: RCOND
!   .. ARRAY ARGUMENTS ..
    COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
    REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: S(:)
!----------------------------------------------------------------------
! 
! Purpose
! ======= 
!
!       LA_GELSS and LA_GELSD compute the minimum-norm least squares 
! solution to one or more real or complex linear systems A*x = b using
! the singular value decomposition of A. Matrix A is rectangular and may
! be rank-deficient. The vectors b and corresponding solution vectors x
! are the columns of matrices denoted B and X , respectively.
!       The effective rank of A is determined by treating as zero those 
! singular values which are less than RCOND times the largest singular 
! value. In addition to X , the routines also return the right singular
! vectors and, optionally, the rank and singular values of A.
!       LA_GELSD combines the singular value decomposition with a divide
! and conquer technique. For large matrices it is often much faster than 
! LA_GELSS but uses more workspace.
! 
! ==========
! 
!        SUBROUTINE LA_GELSS / LA_GELSD( A, B, RANK=rank, S=s, &
!                                          RCOND=rcond, INFO=info )
!             <type>(<wp>), INTENT( INOUT ) :: A( :, : ), <rhs>
!             INTEGER, INTENT(OUT), OPTIONAL :: RANK
!             REAL(<wp>), INTENT(OUT), OPTIONAL :: S(:)
!             REAL(<wp>), INTENT(IN), OPTIONAL :: RCOND
!             INTEGER, INTENT(OUT), OPTIONAL :: INFO
!        where
!             <type> ::= REAL | COMPLEX
!             <wp>   ::= KIND(1.0) | KIND(1.0D0)
!             <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! A       (input/output) REAL or COMPLEX array, shape (:,:).
!         On entry, the matrix A.
!         On exit, the first min(size(A,1), size(A,2)) rows of A are 
!         overwritten with its right singular vectors, stored rowwise.
! B       (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(B,1) = max(size(A,1), size(A,2)) or shape (:) with 
!         size(B) = max(size(A,1), size(A,2)).
!         On entry, the matrix B.
!         On exit, the solution matrix X .
!         If size(A,1) >= size(A,2) and RANK = size(A,2), the residual 
!         sum-of-squares for the solution in a column of B is given by 
!         the sum of squares of elements in rows size(A,2)+1:size(A,1)
!         of that column.
! RANK    Optional (output) INTEGER.
!         The effective rank of A, i.e., the number of singular values 
!         of A which are greater than the product RCOND*sigma1 , where
!  	  sigma1 is the greatest singular value.
! S       Optional (output) REAL array, shape (:) with size(S) = 
!         min(size(A,1), size(A,2)).
!         The singular values of A in decreasing order.
!         The condition number of A in the 2-norm is
! 	  K2(A)= sigma1/sigma(min(size(A,1),size(A,2)) .
! RCOND   Optional (input) REAL.
!         RCOND is used to determine the effective rank of A.
!         Singular values sigma(i)<=RCOND*sigma1  are treated as zero.
!         Default value: 10*max(size(A,1), size(A,2))*EPSILON(1.0_<wp>),
!         where <wp> is the working precision.
! INFO    Optional (output) INTEGER.
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: the algorithm for computing the SVD failed to converge; 
! 	  if INFO = i,i off-diagonal elements of an intermediate 
! 	  bidiagonal form did not converge to zero.
!         If INFO is not present and an error occurs, then the program 
! 	  is terminated with an error message.
!----------------------------------------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GELSS'
    CHARACTER(LEN=1), PARAMETER :: VER = 'Z'
!   .. LOCAL SCALARS ..
    INTEGER :: LINFO, ISTAT, ISTAT1, LWORK, N, M, MN, NRHS, LRANK, SS
    REAL(WP) :: LRCOND
!   .. LOCAL POINTERS ..
    REAL(WP), POINTER :: RWORK(:), LS(:)
    COMPLEX(WP), POINTER :: WORK(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT, MAX, MIN, EPSILON
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2); NRHS = SIZE(B,2)
    MN = MIN(M,N)
    IF( PRESENT(RCOND) )THEN; LRCOND = RCOND; ELSE
        LRCOND = 100*EPSILON(1.0_WP) ; ENDIF
    IF( PRESENT(S) )THEN; SS = SIZE(S); ELSE; SS =MN; ENDIF
!   .. TEST THE ARGUMENTS
    IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B, 1 ) /= MAX(1,M,N) .OR. NRHS < 0 ) THEN; LINFO = -2
    ELSE IF( SS /= MN ) THEN; LINFO = -4
    ELSE IF( LRCOND <= 0.0_WP ) THEN; LINFO = -5
    ELSE
       IF( PRESENT(S) )THEN; LS => S
       ELSE; ALLOCATE( LS(MN), STAT = ISTAT ); END IF
       IF( ISTAT == 0 ) THEN
          ALLOCATE( RWORK( MAX(1, 5*MIN(M,N) -4)), STAT = ISTAT )
       END IF
       IF( ISTAT == 0 ) THEN
          LWORK = LA_WS_GELSS( VER, M, N, NRHS )
          ALLOCATE( WORK(LWORK), STAT = ISTAT )
          IF( ISTAT /= 0 ) THEN
             DEALLOCATE( WORK, STAT=ISTAT1 )
             LWORK = MAX( 1, 2*MIN(M,N) + MAX( M, N, NRHS ) )
             ALLOCATE( WORK(LWORK), STAT = ISTAT )
             IF( ISTAT /= 0 ) CALL ERINFO( -200, SRNAME, LINFO )
          END IF
       END IF
       IF ( ISTAT == 0 ) THEN
          CALL GELSS_F77( M, N, NRHS, A, MAX(1,M), B, MAX(1,M,N), &
                         LS, LRCOND, LRANK, WORK, LWORK, RWORK, LINFO )
       ELSE; LINFO = -100; END IF
       IF( PRESENT(RANK) ) RANK = LRANK
       DEALLOCATE(WORK, RWORK, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE ZGELSS_F95

SUBROUTINE LA_TEST_SGGLSE( M, N, P, A, LDA, B, LDB, C, D, X, WORK, LWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     June 09, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GGLSE
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: M, N, P, LDA, LDB, LWORK
   INTEGER, INTENT(INOUT) :: INFO
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB,1:N)
   REAL(WP), INTENT(INOUT) :: C(1: M), D(1: P)
   REAL(WP), INTENT(OUT) :: WORK(1: LWORK), X(1: N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GGLSE'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGGLSE'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IC, ID, IX
!  .. Local Arrays ..
   INTEGER, SAVE, POINTER :: IWORK(:)
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = M; IA2 = N; IB1 = P; IB2 = N; IC = M; ID = P; IX = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE (2)
     IB2 = IB2 - 1
   CASE(3)
     IC = IC - 1
   CASE (4)
     ID = ID - 1
   CASE (5)
     IX = IX - 1
   CASE(:-1,1,6:)
      CALL UESTOP(SRNAMT)
   END SELECT

   CALL LA_GGLSE( A(1:IA1,1:IA2), B(1:IB1,1:IB2), C(1: IC), D(1: ID), &
&                 X(1: IX), INFO )
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_SGGLSE

 SUBROUTINE ZGBSV_F95( A, B, KL, IPIV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO
    USE F77_LAPACK, ONLY: GBSV_F77 => LA_GBSV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    INTEGER, INTENT(IN), OPTIONAL :: KL
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IPIV(:)
    COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!      LA_GBSV computes the solution to a real or complex linear system
! of equations A*X = B, where A is a square band matrix and X and B are
! rectangular matrices or vectors. The LU decomposition with row
! interchanges is used to factor A as A = L*U , where L is a product of
! permutation and unit lower triangular matrices with kl subdiagonals, 
! and U is upper triangular with kl + ku superdiagonals. The factored 
! form of A is then used to solve the above system.
! 
! =========
! 
!       SUBROUTINE LA_GBSV( AB, B, KL=kl, IPIV=ipiv, INFO=info )
!             <type>(<wp>), INTENT(INOUT) :: AB(:,:), <rhs>
!             INTEGER, INTENT(IN), OPTIONAL :: KL
!             INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
!             INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!             <type> ::= REAL | COMPLEX
!             <wp>   ::= KIND(1.0) | KIND(1.0D0)
!             <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! AB      (input/output) REAL or COMPLEX rectangular array, shape (:,:)
!         with size(AB,1) = 2*kl+ku+1 and size(AB,2) = n, where kl and ku
!         are, respectively, the numbers of subdiagonals and 
!         superdiagonals in the band of A, and n is the order of A.
!         On entry, the matrix A in band storage. The (kl + ku + 1) 
! 	  diagonals of A are stored in rows (kl + 1) to (2*kl + ku + 1) 
! 	  of AB, so that the j-th column of A is stored in the j-th 
! 	  column of AB as follows:
! 	  AB(kl+ku+1+i-j,j) = A(i,j) for max(1,j-ku)<=i<=min(n,j+kl)
! 	                                 1<=j<=n
!         The remaining elements in AB need not be set.
!         On exit, details of the factorization. U is an upper triangular 
!         band matrix with (kl + ku + 1) diagonals. These are stored in
! 	  the first (kl + ku + 1) rows of AB. The multipliers that arise
!         during the factorization are stored in the remaining rows.
! B       (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(B,1) = n or shape (:) with size(B) = n.
!         On entry, the matrix B.
!         On exit, the solution matrix X.
! KL      Optional (input) INTEGER.
!         The number of subdiagonals in the band of A (KL = kl).
!         The number of superdiagonals in the band is given by
! 	  ku = size(AB,1) - 2 * kl - 1.
!         Default value: (size(AB,1)-1)/3.
! IPIV    Optional (output) INTEGER array, shape (:) with size(IPIV) = n.
!         The pivot indices that define the row interchanges; row i of the
!         matrix was interchanged with row IPIV(i).
! INFO    Optional (output) INTEGER
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: if INFO = i, U(i,i) = 0. The factorization has been 
!         completed, but the factor U is singular, so the solution could 
!         not be computed. 
!         If INFO is not present and an error occurs, then the program 
!         is terminated with an error message.
!----------------------------------------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GBSV'
!   .. LOCAL SCALARS ..
    INTEGER :: LINFO, ISTAT, ISTAT1, SIPIV, LDA, N, NRHS, LKL, KU
!   .. LOCAL POINTERS ..
    INTEGER, POINTER :: LPIV(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0
    LDA = SIZE(A,1); N = SIZE(A,2); NRHS = SIZE(B,2)
    IF( PRESENT(KL) ) THEN; LKL = KL; ELSE; LKL = (LDA-1)/3; ENDIF
    IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; ENDIF
!   .. TEST THE ARGUMENTS
    IF( LDA - 2*LKL -1 < 0 .OR. LDA < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B, 1 ) /= N .OR. NRHS < 0 ) THEN; LINFO = -2
    ELSE IF( LDA - 2*LKL -1 < 0 .OR. LKL < 0 ) THEN; LINFO = -3
    ELSE IF( SIPIV /= N )THEN; LINFO = -4
    ELSE IF ( N > 0 ) THEN
       IF( PRESENT(IPIV) )THEN; LPIV => IPIV; ELSE
           ALLOCATE( LPIV(N), STAT = ISTAT ); END IF
       IF ( ISTAT == 0 ) THEN
          KU = LDA -2*LKL -1
          CALL GBSV_F77( N, LKL, KU, NRHS, A, LDA, LPIV, B, N, LINFO )
       ELSE
          LINFO = -100
       END IF
       IF( .NOT.PRESENT(IPIV) )THEN
          DEALLOCATE(LPIV, STAT = ISTAT1 )
       END IF
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE ZGBSV_F95

SUBROUTINE LA_TEST_DGGESX(JOBVSL, JOBVSR, SORT, SELECT, SENSE, N, A, LDA, B, LDB, SDIM, &
     &  ALPHAR, ALPHAI, BETA, VSL, LDVSL, VSR, LDVSR, RCONDE, RCONDV, WORK, LWORK, IWORK, &
     &  LIWORK,  BWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     September 25, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GGESX
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDA, LDB, LDVSL, LDVSR, LWORK, LIWORK
      INTEGER, INTENT(INOUT) :: INFO
      INTEGER, INTENT(OUT) :: SDIM
      CHARACTER*1, INTENT(IN) :: JOBVSL, JOBVSR, SORT, SENSE
      REAL(WP), INTENT(OUT) :: RCONDE(1:2), RCONDV(1:2) 
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB, 1:N)
      REAL(WP), INTENT(OUT):: WORK(1:LWORK)
      LOGICAL :: BWORK(1: N)
      INTEGER :: IWORK (1: LIWORK)
      REAL(WP), INTENT(OUT) :: ALPHAR(1:N), ALPHAI(1:N), BETA(1:N), &
     &  VSL(1: LDVSL, 1:N), VSR(1: LDVSR, 1:N)
      INTERFACE
      LOGICAL FUNCTION SELECT(ALPHAR, ALPHAI, BETA)
      USE LA_PRECISION, ONLY: WP => DP
      REAL(WP), INTENT(IN) :: ALPHAR, ALPHAI, BETA
      END FUNCTION SELECT
      END INTERFACE
      OPTIONAL :: SELECT
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GGESX'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DGGESX'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IALPHAI, IALPHAR, IBETA, IVSL1, &
     &  IVSL2, IVSR1, IVSR2
   CHARACTER*1 :: IJOBVSL, IJOBVSR, ISORT
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IJOBVSL = JOBVSL; IJOBVSR = JOBVSR
   IB1 = N; IB2 = N; IALPHAR = N; IALPHAI = N; IBETA = N
   IVSL1 = N; IVSL2 = N; IVSR1 = N; IVSR2 = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
       IA2 = IA1 - 1
     CASE (2)
       IB1 = IA1 - 1
      CASE (3)
       IALPHAR = IA1 - 1
       CASE (4)
       IALPHAI = IA1 - 1 
       CASE (5)
       IBETA  = IA1 - 1
     CASE (6)
       IVSL1 = IA1 - 1
       CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&        ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&        BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&        VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&        RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO)
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN
     CASE (7)
        IVSR1 = IA1 - 1 
       CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&        ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&        BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&        VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&        RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO) 
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN
       CASE(:-1, 8:)
       CALL UESTOP(SRNAMT)
   END SELECT

   IF(LSAME(SENSE,'B')) THEN
     IF (LSAME(SORT, 'N')) THEN
       IF (LSAME(IJOBVSL,'V')) THEN
         IF (LSAME (IJOBVSR, 'V')) THEN
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&            ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&            BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&            VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&            RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO)
         ELSE
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&            ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&            BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2),  SELECT=SELECT, & 
&            SDIM=SDIM, RCONDE=RCONDE, RCONDV=RCONDV,INFO=INFO)    
         END IF
       ELSE 
         IF (LSAME (IJOBVSR, 'V')) THEN
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&            ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&            BETA=BETA(1: IBETA), VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, &
&            SDIM=SDIM, RCONDE=RCONDE, RCONDV=RCONDV,INFO = INFO)
         ELSE
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&            ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&            BETA=BETA(1: IBETA), SELECT=SELECT, SDIM=SDIM, RCONDE=RCONDE, &
&            RCONDV=RCONDV, INFO = INFO)
         END IF
       END IF
     ELSE
       IF (LSAME(IJOBVSL,'V')) THEN
         IF (LSAME (IJOBVSR, 'V')) THEN
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&            ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA), &
&            VSL(1:IVSL1,1:IVSL2), VSR(1:IVSR1,1:IVSR2),  SELECT, SDIM,&
&            RCONDE, RCONDV,INFO)    
         ELSE
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&            ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA),&
&            VSL(1:IVSL1,1:IVSL2), SELECT=SELECT,  SDIM=SDIM, &
&            RCONDE=RCONDE, RCONDV=RCONDV,INFO=INFO) 
         END IF
       ELSE 
         IF (LSAME (IJOBVSR, 'V')) THEN
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&            ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA),&
&            VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&            RCONDE=RCONDE, RCONDV=RCONDV, &
&            INFO = INFO)
         ELSE
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&            ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA), &
&            SELECT=SELECT,  SDIM=SDIM, RCONDE=RCONDE, &
&            RCONDV=RCONDV,INFO = INFO)
         END IF
       END IF
     END IF
   ELSE IF (LSAME (SENSE,'V')) THEN
     IF (LSAME(SORT, 'N')) THEN
       IF (LSAME(IJOBVSL,'V')) THEN
         IF (LSAME (IJOBVSR, 'V')) THEN
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&            ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&            BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&            VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&            RCONDV=RCONDV, INFO=INFO)
         ELSE
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&            ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&            BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2),  SELECT=SELECT, & 
&            SDIM=SDIM, RCONDV=RCONDV,INFO=INFO)    
         END IF
       ELSE 
         IF (LSAME (IJOBVSR, 'V')) THEN
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&            ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&            BETA=BETA(1: IBETA), VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, &
&            SDIM=SDIM, RCONDV=RCONDV,INFO = INFO)
         ELSE
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&            ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&            BETA=BETA(1: IBETA), SELECT=SELECT, SDIM=SDIM, &
&            RCONDV=RCONDV,INFO = INFO)
         END IF
       END IF
     ELSE
       IF (LSAME(IJOBVSL,'V')) THEN
         IF (LSAME (IJOBVSR, 'V')) THEN
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&            ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA), &
&            VSL(1:IVSL1,1:IVSL2), VSR(1:IVSR1,1:IVSR2),  SELECT, SDIM,&
&            RCONDV=RCONDV, INFO=INFO)    
         ELSE
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&            ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA),&
&            VSL(1:IVSL1,1:IVSL2), SELECT=SELECT,  SDIM=SDIM, &
&            RCONDV=RCONDV,INFO=INFO) 
         END IF
       ELSE 
         IF (LSAME (IJOBVSR, 'V')) THEN
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&            ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA),&
&            VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&            RCONDV=RCONDV, INFO = INFO)
         ELSE
           CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&            ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA), &
&            SELECT=SELECT,  SDIM=SDIM,  &
&            RCONDV=RCONDV,INFO = INFO)
         END IF
       END IF
     END IF
   ELSE
     IF (LSAME (SENSE, 'E')) THEN
       IF (LSAME(SORT, 'N')) THEN
         IF (LSAME(IJOBVSL,'V')) THEN
           IF (LSAME (IJOBVSR, 'V')) THEN
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&              ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&              BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&              VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&              RCONDE=RCONDE, INFO=INFO)
           ELSE
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&              ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&              BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2),  SELECT=SELECT, & 
&              SDIM=SDIM, RCONDE=RCONDE, INFO=INFO)    
           END IF
         ELSE 
           IF (LSAME (IJOBVSR, 'V')) THEN
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&              ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&              BETA=BETA(1: IBETA), VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, &
&              SDIM=SDIM, RCONDE=RCONDE, INFO = INFO)
           ELSE
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&              ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&              BETA=BETA(1: IBETA), SELECT=SELECT, SDIM=SDIM, RCONDE=RCONDE, &
&              INFO = INFO)
           END IF
         END IF
       ELSE
         IF (LSAME(IJOBVSL,'V')) THEN
           IF (LSAME (IJOBVSR, 'V')) THEN
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&              ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA), &
&              VSL(1:IVSL1,1:IVSL2), VSR(1:IVSR1,1:IVSR2),  SELECT, SDIM,&
&              RCONDE, INFO = INFO)    
           ELSE
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&              ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA),&
&              VSL(1:IVSL1,1:IVSL2), SELECT=SELECT,  SDIM=SDIM, &
&              RCONDE=RCONDE, INFO=INFO) 
           END IF
         ELSE 
           IF (LSAME (IJOBVSR, 'V')) THEN
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&              ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA),&
&              VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&              RCONDE=RCONDE, INFO = INFO)
           ELSE
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&              ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA), &
&              SELECT=SELECT,  SDIM=SDIM, RCONDE=RCONDE, &
&              INFO = INFO)
           END IF
         END IF
       END IF
     ELSE
       IF (LSAME(SORT, 'N')) THEN
         IF (LSAME(IJOBVSL,'V')) THEN
           IF (LSAME (IJOBVSR, 'V')) THEN
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&              ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&              BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&              VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&              INFO=INFO)
           ELSE
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&              ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&              BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2),  SELECT=SELECT, & 
&              SDIM=SDIM, INFO=INFO)    
           END IF
         ELSE 
           IF (LSAME (IJOBVSR, 'V')) THEN
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&              ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&              BETA=BETA(1: IBETA), VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, &
&              SDIM=SDIM, INFO = INFO)
           ELSE
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&              ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
&              BETA=BETA(1: IBETA), SELECT=SELECT, SDIM=SDIM, INFO = INFO)
           END IF
         END IF
       ELSE
         IF (LSAME(IJOBVSL,'V')) THEN
           IF (LSAME (IJOBVSR, 'V')) THEN
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&              ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA), &
&              VSL(1:IVSL1,1:IVSL2), VSR(1:IVSR1,1:IVSR2),  SELECT, SDIM,&
&              INFO = INFO)    
           ELSE
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&              ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA),&
&              VSL(1:IVSL1,1:IVSL2), SELECT=SELECT,  SDIM=SDIM, &
&              INFO=INFO) 
           END IF
         ELSE 
           IF (LSAME (IJOBVSR, 'V')) THEN
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&              ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA),&
&              VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&              INFO = INFO)
           ELSE
             CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&              ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA), &
&              SELECT=SELECT,  SDIM=SDIM, INFO = INFO)
           END IF
         END IF
       END IF
     ENDIF
   ENDIF

CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_DGGESX

      SUBROUTINE CERRST( PATH, NUNIT )
*
*  -- LAPACK test routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     April 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  CERRST tests the error exits for CHETRD, CUNGTR, CUNMTR, CHPTRD,
*  CUNGTR, CUPMTR, CSTEQR, CSTEIN, CPTEQR, CHBTRD,
*  CHEEV, CHEEVX, CHEEVD, CHBEV, CHBEVX, CHBEVD,
*  CHPEV, CHPEVX, CHPEVD, and CSTEDC.
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX, LIW, LW
      PARAMETER          ( NMAX = 3, LIW = 12*NMAX, LW = 20*NMAX )
*     ..
*     .. Local Scalars ..
      CHARACTER*2        C2
      INTEGER            I, INFO, J, M, NT
*     ..
*     .. Local Arrays ..
      INTEGER            I1( NMAX ), I2( NMAX ), I3( NMAX ), IW( LIW ),
     &                   IN(100)
      REAL               D( NMAX ), E( NMAX ), R( LW ), RW( LW ),
     $                   X( NMAX )
      COMPLEX            A( NMAX, NMAX ), C( NMAX, NMAX ),
     $                   Q( NMAX, NMAX ), TAU( NMAX ), W( LW ),
     $                   Z( NMAX, NMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAMEN
      EXTERNAL           LSAMEN
*     ..
*     .. External Subroutines ..
      EXTERNAL           LA_TEST_CHBEV, LA_TEST_CHBEVD, LA_TEST_CHBEVX,
     &  CHBTRD,
     $                   LA_TEST_CHEEV, LA_TEST_CHEEVD, CHEEVR, CHEEVX,
     $                   CHETRD, CHKXER, LA_TEST_CHPEV, LA_TEST_CHPEVD,
     $                   CHPEVX, CHPTRD, CPTEQR, CSTEDC, CSTEIN, CSTEQR,
     $                   CUNGTR, CUNMTR, CUPGTR, CUPMTR
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          REAL
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )
*
*     Set the variables to innocuous values.
*
      DO 20 J = 1, NMAX
         DO 10 I = 1, NMAX
            A( I, J ) = 1. / REAL( I+J )
   10    CONTINUE
   20 CONTINUE
      DO 30 J = 1, NMAX
         D( J ) = REAL( J )
         E( J ) = 0.0
         I1( J ) = J
         I2( J ) = J
         TAU( J ) = 1.
   30 CONTINUE
      OK = .TRUE.
      NT = 0
*
*     Test error exits for the ST path.
*
      IF( LSAMEN( 2, C2, 'ST' ) ) THEN
*
*        CHETRD
*
         SRNAMT = 'CHETRD'
         INFOT = 1
         CALL CHETRD( '/', 0, A, 1, D, E, TAU, W, 1, INFO )
         CALL CHKXER( 'CHETRD', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CHETRD( 'U', -1, A, 1, D, E, TAU, W, 1, INFO )
         CALL CHKXER( 'CHETRD', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CHETRD( 'U', 2, A, 1, D, E, TAU, W, 1, INFO )
         CALL CHKXER( 'CHETRD', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL CHETRD( 'U', 0, A, 1, D, E, TAU, W, 0, INFO )
         CALL CHKXER( 'CHETRD', INFOT, NOUT, LERR, OK )
         NT = NT + 4
*
*        CUNGTR
*
         SRNAMT = 'CUNGTR'
         INFOT = 1
         CALL CUNGTR( '/', 0, A, 1, TAU, W, 1, INFO )
         CALL CHKXER( 'CUNGTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CUNGTR( 'U', -1, A, 1, TAU, W, 1, INFO )
         CALL CHKXER( 'CUNGTR', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CUNGTR( 'U', 2, A, 1, TAU, W, 1, INFO )
         CALL CHKXER( 'CUNGTR', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL CUNGTR( 'U', 3, A, 3, TAU, W, 1, INFO )
         CALL CHKXER( 'CUNGTR', INFOT, NOUT, LERR, OK )
         NT = NT + 4
*
*        CUNMTR
*
         SRNAMT = 'CUNMTR'
         INFOT = 1
         CALL CUNMTR( '/', 'U', 'N', 0, 0, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'CUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CUNMTR( 'L', '/', 'N', 0, 0, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'CUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CUNMTR( 'L', 'U', '/', 0, 0, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'CUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CUNMTR( 'L', 'U', 'N', -1, 0, A, 1, TAU, C, 1, W, 1,
     $                INFO )
         CALL CHKXER( 'CUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CUNMTR( 'L', 'U', 'N', 0, -1, A, 1, TAU, C, 1, W, 1,
     $                INFO )
         CALL CHKXER( 'CUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL CUNMTR( 'L', 'U', 'N', 2, 0, A, 1, TAU, C, 2, W, 1, INFO )
         CALL CHKXER( 'CUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL CUNMTR( 'R', 'U', 'N', 0, 2, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'CUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CUNMTR( 'L', 'U', 'N', 2, 0, A, 2, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'CUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL CUNMTR( 'L', 'U', 'N', 0, 2, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'CUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL CUNMTR( 'R', 'U', 'N', 2, 0, A, 1, TAU, C, 2, W, 1, INFO )
         CALL CHKXER( 'CUNMTR', INFOT, NOUT, LERR, OK )
         NT = NT + 10
*
*        CHPTRD
*
         SRNAMT = 'CHPTRD'
         INFOT = 1
         CALL CHPTRD( '/', 0, A, D, E, TAU, INFO )
         CALL CHKXER( 'CHPTRD', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CHPTRD( 'U', -1, A, D, E, TAU, INFO )
         CALL CHKXER( 'CHPTRD', INFOT, NOUT, LERR, OK )
         NT = NT + 2
*
*        CUPGTR
*
         SRNAMT = 'CUPGTR'
         INFOT = 1
         CALL CUPGTR( '/', 0, A, TAU, Z, 1, W, INFO )
         CALL CHKXER( 'CUPGTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CUPGTR( 'U', -1, A, TAU, Z, 1, W, INFO )
         CALL CHKXER( 'CUPGTR', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CUPGTR( 'U', 2, A, TAU, Z, 1, W, INFO )
         CALL CHKXER( 'CUPGTR', INFOT, NOUT, LERR, OK )
         NT = NT + 3
*
*        CUPMTR
*
         SRNAMT = 'CUPMTR'
         INFOT = 1
         CALL CUPMTR( '/', 'U', 'N', 0, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'CUPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CUPMTR( 'L', '/', 'N', 0, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'CUPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CUPMTR( 'L', 'U', '/', 0, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'CUPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CUPMTR( 'L', 'U', 'N', -1, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'CUPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CUPMTR( 'L', 'U', 'N', 0, -1, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'CUPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL CUPMTR( 'L', 'U', 'N', 2, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'CUPMTR', INFOT, NOUT, LERR, OK )
         NT = NT + 6
*
*        CPTEQR
*
         SRNAMT = 'CPTEQR'
         INFOT = 1
         CALL CPTEQR( '/', 0, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'CPTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CPTEQR( 'N', -1, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'CPTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CPTEQR( 'V', 2, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'CPTEQR', INFOT, NOUT, LERR, OK )
         NT = NT + 3
*
*        CSTEIN
*
         SRNAMT = 'CSTEIN'
         INFOT = 1
         CALL CSTEIN( -1, D, E, 0, X, I1, I2, Z, 1, RW, IW, I3, INFO )
         CALL CHKXER( 'CSTEIN', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CSTEIN( 0, D, E, -1, X, I1, I2, Z, 1, RW, IW, I3, INFO )
         CALL CHKXER( 'CSTEIN', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CSTEIN( 0, D, E, 1, X, I1, I2, Z, 1, RW, IW, I3, INFO )
         CALL CHKXER( 'CSTEIN', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL CSTEIN( 2, D, E, 0, X, I1, I2, Z, 1, RW, IW, I3, INFO )
         CALL CHKXER( 'CSTEIN', INFOT, NOUT, LERR, OK )
         NT = NT + 4
*
*        CSTEQR
*
         SRNAMT = 'CSTEQR'
         INFOT = 1
         CALL CSTEQR( '/', 0, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'CSTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CSTEQR( 'N', -1, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'CSTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CSTEQR( 'V', 2, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'CSTEQR', INFOT, NOUT, LERR, OK )
         NT = NT + 3
*
*        CSTEDC
*
         SRNAMT = 'CSTEDC'
         INFOT = 1
         CALL CSTEDC( '/', 0, D, E, Z, 1, W, 1, RW, 1, IW, 1, INFO )
         CALL CHKXER( 'CSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CSTEDC( 'N', -1, D, E, Z, 1, W, 1, RW, 1, IW, 1, INFO )
         CALL CHKXER( 'CSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CSTEDC( 'V', 2, D, E, Z, 1, W, 4, RW, 23, IW, 28, INFO )
         CALL CHKXER( 'CSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL CSTEDC( 'N', 2, D, E, Z, 1, W, 0, RW, 1, IW, 1, INFO )
         CALL CHKXER( 'CSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL CSTEDC( 'V', 2, D, E, Z, 2, W, 3, RW, 23, IW, 28, INFO )
         CALL CHKXER( 'CSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CSTEDC( 'N', 2, D, E, Z, 1, W, 1, RW, 0, IW, 1, INFO )
         CALL CHKXER( 'CSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CSTEDC( 'I', 2, D, E, Z, 2, W, 1, RW, 16, IW, 12, INFO )
         CALL CHKXER( 'CSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CSTEDC( 'V', 2, D, E, Z, 2, W, 4, RW, 22, IW, 28, INFO )
         CALL CHKXER( 'CSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL CSTEDC( 'N', 2, D, E, Z, 1, W, 1, RW, 1, IW, 0, INFO )
         CALL CHKXER( 'CSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL CSTEDC( 'I', 2, D, E, Z, 2, W, 1, RW, 23, IW, 11, INFO )
         CALL CHKXER( 'CSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL CSTEDC( 'V', 2, D, E, Z, 2, W, 4, RW, 23, IW, 27, INFO )
         CALL CHKXER( 'CSTEDC', INFOT, NOUT, LERR, OK )
         NT = NT + 11
*
*        CHEEVD
*
         SRNAMT = 'CHEEVD'
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_CHEEVD('N', 'U', NMAX, A, NMAX, X, W, 1,
     &         RW, 1 , IW, 1, INFO )
             CALL CHKXER( 'CHEEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVD('N', 'L', NMAX, A, NMAX, X, W, 1,
     &         RW, 1 , IW, 1, INFO )
             CALL CHKXER( 'CHEEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVD('V', 'U', NMAX, A, NMAX, X, W, 1,
     &         RW,  1, IW, 1, INFO )
             CALL CHKXER( 'CHEEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVD('V', 'L', NMAX, A, NMAX, X, W, 1,
     &         RW, 1, IW, 1, INFO )
             CALL CHKXER( 'CHEEVD ', INFOT, NOUT, LERR, OK )
           END DO
         END DO 
*
*        CHEEV
*
         SRNAMT = 'CHEEV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_CHEEV('N', 'U', NMAX, A, NMAX, X, W, 1,
     &         RW, INFO )
             CALL CHKXER( 'CHEEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEV('N', 'L', NMAX, A, NMAX, X, W, 1,
     &         RW, INFO )
             CALL CHKXER( 'CHEEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEV('V', 'U', NMAX, A, NMAX, X, W, 1,
     &         RW, INFO )
             CALL CHKXER( 'CHEEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEV('V', 'L', NMAX, A, NMAX, X, W, 1,
     &         RW, INFO )
             CALL CHKXER( 'CHEEV ', INFOT, NOUT, LERR, OK )
           END DO
         END DO  

*
*        CHEEVX
*
         SRNAMT = 'CHEEVX'
         DO I = 1, 10
           IF (I/=9) THEN
             INFOT = I
             DO J = 1, 1
               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'N', 'A', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'N', 'A', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'N', 'V', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'N', 'V', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'N', 'I', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'N', 'I', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'V', 'A', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'V', 'A', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'V', 'V', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'V', 'V', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'V', 'I', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHEEVX( 'V', 'I', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'CHEEVX', INFOT, NOUT, LERR, OK )
               
             ENDDO
           ENDIF
         ENDDO
         NT = NT + 10
*
*        CHEEVR
*
         SRNAMT = 'CHEEVR'
         DO I = 1,10
           IF(I/=9) THEN
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_CHEEVR( 'N', 'A', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVR( 'N', 'A', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVR( 'N', 'V', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVR( 'N', 'V', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVR( 'N', 'I', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVR( 'N', 'I', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVR( 'V', 'A', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVR( 'V', 'A', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVR( 'V', 'V', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVR( 'V', 'V', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHEEVR( 'V', 'I', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )

             INFO = J + 1             00*I
             CALL LA_TEST_CHEEVR( 'V', 'I', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'CHEEVR', INFOT, NOUT, LERR, OK )
           ENDDO
         ENDIF
       ENDDO                                          
         NT = NT + 12
*
*        CHPEVD
*
         SRNAMT = 'CHPEVD'
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_CHPEVD('N', 'U', NMAX, A, X, Z, 1,
     &         W, 1, RW, 1, IW, 1, INFO )
             CALL CHKXER( 'CHPEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHPEVD('N', 'L', NMAX, A, X, Z, 1,
     &         W, 1, RW, 1, IW, 1, INFO )
             CALL CHKXER( 'CHPEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHPEVD('V', 'U', NMAX, A, X, Z, 1,
     &         W, 1, RW, 1, IW, 1, INFO )
             CALL CHKXER( 'CHPEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHPEVD('V', 'L', NMAX, A, X, Z, 1,
     &         W, 1, RW, 1, IW, 1, INFO )
             CALL CHKXER( 'CHPEVD ', INFOT, NOUT, LERR, OK )
           END DO
         END DO 
*
*        CHPEV
*
         SRNAMT = 'CHPEV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_CHPEV('N', 'U', NMAX, A, X, Z, 1,
     &         W, RW,  INFO )
             CALL CHKXER( 'CHPEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHPEV('N', 'L', NMAX, A, X, Z, 1,
     &          W, RW, INFO )
             CALL CHKXER( 'CHPEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHPEV('V', 'U', NMAX, A, X, Z, 1,
     &          W, RW, INFO )
             CALL CHKXER( 'CHPEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHPEV('V', 'L', NMAX, A, X, Z, 1,
     &          W, RW, INFO )
             CALL CHKXER( 'CHPEV ', INFOT, NOUT, LERR, OK )
           END DO
         END DO 

*
*        CHPEVX
*
         SRNAMT = 'CHPEVX'
         DO I = 1, 10
           INFOT = I
           IF (I/=9) THEN
             DO J = 1, 1
               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'V', 'A', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'V', 'A', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'V', 'V', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'V', 'V', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'V', 'I', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'V', 'I', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'N', 'A', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'N', 'A', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'N', 'V', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'N', 'V', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'N', 'I', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPEVX( 'N', 'I', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHPEVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDIF
         ENDDO
         
         NT = NT + 8
*
*     Test error exits for the HB path.
*
      ELSE IF( LSAMEN( 2, C2, 'HB' ) ) THEN
*
*        CHBTRD
*
         SRNAMT = 'CHBTRD'
         INFOT = 1
         CALL CHBTRD( '/', 'U', 0, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'CHBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CHBTRD( 'N', '/', 0, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'CHBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CHBTRD( 'N', 'U', -1, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'CHBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CHBTRD( 'N', 'U', 0, -1, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'CHBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CHBTRD( 'N', 'U', 1, 1, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'CHBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CHBTRD( 'V', 'U', 2, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'CHBTRD', INFOT, NOUT, LERR, OK )
         NT = NT + 6
*
*        CHBEVD
*
         SRNAMT = 'CHBEVD'
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_CHBEVD('N', 'U', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, 1, RW, 1 , IW, 1, INFO )
             CALL CHKXER( 'CHBEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHBEVD('N', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, 1, RW, 1 , IW, 1, INFO )                      
             CALL CHKXER( 'CHBEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHBEVD('N', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, 1, RW, 1 , IW, 1, INFO )
             CALL CHKXER( 'CHBEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHBEVD('N', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, 1, RW, 1 , IW, 1, INFO )
             CALL CHKXER( 'CHBEVD ', INFOT, NOUT, LERR, OK )
           END DO
         END DO
*
*        CHBEV
*
         SRNAMT = 'CHBEV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_CHBEV('N', 'U', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, RW, INFO )
             CALL CHKXER( 'CHBEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHBEV('N', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, RW, INFO )
             CALL CHKXER( 'CHBEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHBEV('V', 'U', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, RW, INFO )
             CALL CHKXER( 'CHBEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CHBEV('V', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, RW, INFO )
             CALL CHKXER( 'CHBEV ', INFOT, NOUT, LERR, OK )
           END DO
         END DO 

*
*        CHBEVX
*
         SRNAMT = 'CHBEVX'
         DO I = 1, 11
           INFOT = I
           IF (I/=9) THEN
             DO J = 1, 11
               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'N', 'A', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'N', 'A', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'N', 'V', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'N', 'V', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'N', 'I', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'N', 'I', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'V', 'A', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )


               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'V', 'A', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'V', 'V', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'V', 'V', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'V', 'I', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHBEVX( 'V', 'I', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'CHBEVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDIF
         ENDDO                                       
         
         NT = NT + 11
      END IF
*
*     Print a summary line.
*
      IF( OK ) THEN
         WRITE( NOUT, FMT = 9999 )PATH, NT
      ELSE
         WRITE( NOUT, FMT = 9998 )PATH
      END IF
*
 9999 FORMAT( 1X, A3, ' routines passed the tests of the error exits',
     $      ' (', I3, ' tests done)' )
 9998 FORMAT( ' *** ', A3, ' routines failed the tests of the error ',
     $      'exits ***' )
*
      RETURN
*
*     End of CERRST
*
      END

PROGRAM LA_CPTSVX_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_PTSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMTR = '(8(1X,F10.3))'
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, INFO, N, NRHS
   REAL(WP) :: RCOND
!  .. LOCAL ARRAYS ..
   COMPLEX(WP), ALLOCATABLE :: E(:), B(:,:), EF(:), X(:,:)
   REAL(WP), ALLOCATABLE :: D(:), DD(:), EE(:), BB(:,:), DF(:), FERR(:), BERR(:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'SPTSVX ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, NRHS
   PRINT *, 'N = ', N, ' NRHS = ', NRHS
   ALLOCATE ( D(N), DD(N), E(N-1), EE(N-1), B(N,NRHS), BB(N,NRHS), &
             DF(N), EF(N-1), X(N,NRHS), FERR(NRHS), BERR(NRHS) )
!
   READ (NIN, *) DD(:), EE(:)
   DO I = 1, NRHS
      BB(1,I) = (DD(1) + EE(1))*I
      BB(2:N-1,I) = (EE(1:N-2) + DD(2:N-1) + EE(2:N-1))*I
      BB(N,I) = (EE(N-1) + DD(N))*I
   ENDDO
   D=DD; E=EE; B=BB
   WRITE(NOUT,*) 'The matrix A:'
   WRITE (NOUT,*) 'D '; WRITE (NOUT,FMTR) D
   WRITE (NOUT,*) 'E '; WRITE (NOUT,FMT) E
   WRITE(NOUT,*) 'The RHS matrix B:'
   DO J = 1, NRHS
     WRITE (NOUT,*) 'RHS', J; WRITE (NOUT,FMT) B(:,J)
   ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_CPTSVX LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX( D, E, B, X, INFO=INFO )'
   D=DD; E=EE; B=BB
   CALL LA_PTSVX( D, E, B, X, INFO=INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PTSVX, INFO = ', INFO
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX( D, E, B(1:N,1), X(1:N,1), RCOND=RCOND, INFO=INFO )'
   D=DD; E=EE; B=BB
   CALL LA_PTSVX( D, E, B(1:N,1), X(1:N,1), RCOND=RCOND, INFO=INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PTSVX, INFO = ', INFO
   WRITE (NOUT,FMT) X(:,1)
   WRITE(NOUT,*) 'RCOND = ', RCOND
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX( D, E, B, X )'
   D=DD; E=EE; B=BB
   CALL LA_PTSVX( D, E, B, X )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PTSVX:'
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX(D, E, B(1:N,1), X(1:N,1) )'
   D=DD; E=EE; B=BB
   CALL LA_PTSVX(D, E, B(1:N,1), X(1:N,1) )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PTSVX:'
   WRITE (NOUT,FMT) X(:,1)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX( D, E, B, X, RCOND=RCOND)'
   D=DD; E=EE; B=BB
   CALL LA_PTSVX( D, E, B, X, RCOND=RCOND)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PTSVX:'
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*) 'RCOND = ', RCOND
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX( D, E, B(1:N,1), X(1:N,1), RCOND=RCOND )'
   D=DD; E=EE; B=BB
   CALL LA_PTSVX( D, E, B(1:N,1), X(1:N,1), RCOND=RCOND )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PTSVX:'
   WRITE (NOUT,FMT) X(1:N,1)
   WRITE(NOUT,*) 'RCOND = ', RCOND
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX(D, E, B(1:N-1,:), X, INFO =INFO )'
   D=DD; E=EE; B=BB; X=HUGE(1.0_WP)
   CALL LA_PTSVX( D, E, B(1:N-1,:), X, INFO=INFO)
   WRITE(NOUT,*)' INFO = ', INFO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX( D, E(1:N-2), B(1:N,1), X(1:N,1), INFO=INFO )'
   D=DD; E=EE; B=BB; X=HUGE(1.0_WP)
   CALL LA_PTSVX( D, E(1:N-2), B(1:N,1), X(1:N,1), INFO=INFO )
   WRITE(NOUT,*)'   B - the RHS vector.'
   WRITE (NOUT,FMT) B(1:N,1)
   WRITE(NOUT,*)'   INFO = ', INFO
   WRITE (NOUT,*) INFO
      
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX(D, E, B, X, FACT=''F'', INFO =INFO )'
   D=DD; E=EE; B=BB; X=HUGE(1.0_WP)
   CALL LA_PTSVX( D, E, B, X, FACT='F', INFO=INFO)
   WRITE(NOUT,*)'  INFO = ', INFO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX( D, E, B(1:N,1), X(1:N,1), FACT=''4'', INFO=INFO )'
   D=DD; E=EE; B=BB; X=HUGE(1.0_WP)
   CALL LA_PTSVX( D, E, B(1:N,1), X(1:N,1), FACT='4', INFO=INFO )
   WRITE(NOUT,*)'   INFO = ', INFO
   WRITE (NOUT,*) INFO
      
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX(D, E, B, X, DF, EF, FACT=''F'', INFO =INFO )'
   D=DD; E=EE; B=BB; X=HUGE(1.0_WP)
   CALL LA_PTSVX( D, E, B, X, DF, EF, FACT='N' )
   CALL LA_PTSVX( D, E, B, X, DF, EF, FACT='F', INFO=INFO)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PTSVX, INFO = ', INFO
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSVX( D, E, B(1:N,1), X(1:N,1), DF, FACT=''N'', INFO=INFO )'
   D=DD; E=EE; B=BB; X=HUGE(1.0_WP)
   CALL LA_PTSVX( D, E, B(1:N,1), X(1:N,1), DF, FACT='N', INFO=INFO )
   WRITE(NOUT,*)'   INFO = ', INFO
   WRITE (NOUT,*) INFO
   
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PPSVX(D, E, B, X, DF, EF, ''N'', FERR, BERR, RCOND, INFO)'
   D=DD; E=EE; B=BB; X=HUGE(1.0_WP)
   CALL LA_PTSVX(D, E, B, X, DF, EF, 'N', FERR, BERR, RCOND, INFO)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PPSVX, INFO = ', INFO
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PPSVX(D, E, B(1:N,1), X(1:N,1), DF, EF, ''N'', ', &
                 'FERR, BERR, RCOND, INFO) '
   D=DD; E=EE; B=BB; X=HUGE(1.0_WP)
   CALL LA_PTSVX(D, E, B(1:N,1), X(1:N,1), DF, EF, 'N', FERR(1), BERR(1), RCOND, INFO)
   WRITE(NOUT,*)'   INFO = ', INFO
   WRITE (NOUT,*) INFO
!
END PROGRAM LA_CPTSVX_ET_EXAMPLE

PROGRAM LA_ZGEEVX_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GEEVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, INFO, N, ILO, IHI
   REAL(WP) :: ABNRM
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), SCALE(:), RCONDE(:), RCONDV(:)
   COMPLEX(WP), ALLOCATABLE :: A(:,:), W(:), VL(:,:), VR(:,:), DUMMY(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'ZGEEVX ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N
   PRINT *, 'N = ', N
   ALLOCATE ( A(N,N), AA(N,N), W(N), VL(N,N), VR(N,N), SCALE(N), RCONDE(N), &
              RCONDV(N) )
!
   READ (NIN, *) AA
   A=AA
   WRITE(NOUT,*) 'The matrix A:'
   DO I = 1, N; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,:); ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_ZGEEVX LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, VL, VR, BALANC, &'
   WRITE(NOUT,*) '               ILO, IHI, SCALE, ABNRM, RCONDE, RCONDV, INFO )'
   A=AA
   CALL LA_GEEVX( A, W, VL, VR, 'N', ILO, IHI, SCALE, &
                  ABNRM, RCONDE, RCONDV, INFO )
   WRITE(NOUT,*) ' ILO, IHI, INFO:', ILO, IHI, INFO
   WRITE(NOUT,*) ' SCALE, ABNRM, RCONDE, RCONDV:'
   WRITE(NOUT,*)   SCALE, ABNRM, RCONDE, RCONDV
   WRITE(NOUT,*) ' Eigenvalues:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'Eigenvectors ( VL and VR ):'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VL(:,I); END DO
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VR(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, VL )'
   A=AA
   CALL LA_GEEVX( A, W, VL )
   WRITE(NOUT,*) 'INFO = ', INFO, ' Eigenvalues:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'Eigenvectors ( Only VL ):'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VL(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, VR )'
   A=AA
   CALL LA_GEEVX( A, W, VR )
   WRITE(NOUT,*) 'INFO = ', INFO, ' Eigenvalues:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'Eigenvectors ( Only VR ):'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VR(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, INFO=INFO )'
   A=AA
   CALL LA_GEEVX( A, W, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' Eigenvalues:'
   WRITE(NOUT,FMT) W
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, BALANC=''P'', INFO=INFO )'
   A=AA
   CALL LA_GEEVX( A, W, BALANC='P', INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' Eigenvalues:'
   WRITE(NOUT,FMT) W
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, BALANC=''S'', INFO=INFO )'
   A=AA
   CALL LA_GEEVX( A, W, BALANC='S', INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' Eigenvalues:'
   WRITE(NOUT,FMT) W
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, BALANC=''B'', INFO=INFO )'
   A=AA
   CALL LA_GEEVX( A, W, BALANC='B', INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' Eigenvalues:'
   WRITE(NOUT,FMT) W
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, BALANC=''1'', INFO=INFO )'
   A=AA
   CALL LA_GEEVX( A, W, BALANC='1', INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' Eigenvalues:'
   WRITE(NOUT,FMT) W
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( DUMMY, W, VL, VR, INFO=INFO )'
   A=AA
   CALL LA_GEEVX( DUMMY, W, VL, VR, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W(1:N-1), VL, VR, INFO=INFO )'
   A=AA
   CALL LA_GEEVX( A, W(1:N-1), VL, VR, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W(1:N-1), VL, VR, INFO=INFO )'
   A=AA
   CALL LA_GEEVX( A, W(1:N-1), VL, VR, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, VL(1:N-1,:), VR, INFO=INFO )'
   A=AA
   CALL LA_GEEVX( A, W, VL(1:N-1,:), VR, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, VL(:,1:N-1), VR, INFO=INFO )'
   A=AA
   CALL LA_GEEVX( A, W, VL(:,1:N-1), VR, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, VL, VR(1:N-1,:), INFO=INFO )'
   A=AA
   CALL LA_GEEVX( A, W, VL, VR(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEEVX( A, W, VL, VR(:,1:N-1), INFO=INFO )'
   A=AA
   CALL LA_GEEVX( A, W, VL, VR(:,1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
END PROGRAM LA_ZGEEVX_ET_EXAMPLE

PROGRAM LA_DSTEVR_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_STEVR
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
   CHARACTER(LEN=*), PARAMETER :: FMTR = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
      INTEGER :: I, INFO, N, M, IL, IU, NNN
      REAL(WP) :: VL, VU
!  .. LOCAL ARRAYS ..
      INTEGER,ALLOCATABLE :: ISUPPZ(:) 
   REAL(WP), ALLOCATABLE :: D(:), DD(:), E(:), EE(:), W(:), Z(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'DSTEVR ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N
      PRINT *, 'N = ', N
      NNN=2*MAX(1,N)
      ALLOCATE ( D(N), DD(N), E(N), EE(N), W(N), Z(N,N), ISUPPZ(NNN) )
      INFO = 0; M=N
!
      READ (NIN, *) DD
      READ (NIN, *) EE
   WRITE(NOUT,*) 'The matrix A:'
   WRITE (NOUT,*) 'D'; WRITE (NOUT,FMTR) DD
   WRITE (NOUT,*) 'E'; WRITE (NOUT,FMTR) EE
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_DSTEVR LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, INFO=INFO )'
      D=DD; E=EE
      CALL LA_STEVR( D, E, W, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
      WRITE(NOUT,FMTR) W
!      
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, Z=Z, INFO=INFO )'
      D=DD; E=EE
      CALL LA_STEVR( D, E, W, Z=Z, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
      WRITE(NOUT,FMTR) W
      WRITE(NOUT,*) 'EIGENVECTORS:'
      DO I = 1, M; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMTR) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, VL=3.0_WP, M=M, INFO=INFO )'
   D=DD; E=EE
      CALL LA_STEVR( D, E, W, VL=3.0_WP, M=M, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
   WRITE(NOUT,*) 'The total number of eigenvalues found is ', M
   WRITE(NOUT,FMTR) W(1:M)
!
      VL= -HUGE(1.0_WP); VU=HUGE(1.0_WP)
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, Z, -HUGE(1.0_WP), HUGE(1.0_WP), M=M, ISUPPZ=ISUPPZ, INFO=INFO)'
      D=DD; E=EE; M=N; Z = HUGE(1.0_WP); W = HUGE(1.0_WP)
      CALL LA_STEVR( D, E, W, Z, -HUGE(1.0_WP), HUGE(1.0_WP), M=M, ISUPPZ=ISUPPZ, INFO=INFO)
      WRITE(NOUT,*) 'M, INFO, EIGENVALUES:', M, INFO
      WRITE(NOUT,FMTR) W
      WRITE(NOUT,*) 'EIGENVECTORS:'
      DO I = 1, M; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMTR) Z(:,I); END DO
        WRITE(NOUT,*) 'ISUPPZ:'; WRITE (NOUT,*) ISUPPZ
!
      IL=2; IU=N
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, Z, IL=2, IU=N, M=M, ISUPPZ=ISUPPZ, INFO=INFO)'
      D=DD; E=EE; M=N; Z = HUGE(1.0_WP); W = HUGE(1.0_WP)
      CALL LA_STEVR( D, E, W, Z, IL=IL, IU=IU, M=M, ISUPPZ=ISUPPZ, INFO=INFO)
      WRITE(NOUT,*) 'M, INFO, EIGENVALUES:', M, INFO
      WRITE(NOUT,FMTR) W
      WRITE(NOUT,*) 'EIGENVECTORS:'
      DO I = 1, M; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMTR) Z(:,I); END DO
        WRITE(NOUT,*) 'ISUPPZ:'; WRITE (NOUT,*) ISUPPZ     
! ERROR 2
      VL = 1; VU = 10;
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E(1:N+3), W, Z, VL, VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )'
      D=DD; E=EE; Z = HUGE(1.0_WP)
      CALL LA_STEVR(  D, E(1:N+3), W, Z, VL, VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 3
      VL = 1; VU = 10;
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W(1:N-1), Z, VL, VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )'
      D=DD; E=EE; Z = HUGE(1.0_WP)
      CALL LA_STEVR(  D, E, W(1:N-1), Z, VL, VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 4
      VL = 1; VU = 10;
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, Z(:,1:N-1), VL, VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )'
      D=DD; E=EE; Z = HUGE(1.0_WP)
      CALL LA_STEVR(  D, E, W, Z(:,1:N-1), VL, VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 4
      VL = 1; VU = 10;
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, Z(1:N-1,:), VL, VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )'
      D=DD; E=EE; Z = HUGE(1.0_WP)
      CALL LA_STEVR(  D, E, W, Z(1:N-1,:), VL, VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 5
      VL = 1; VU = 10;
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, VL=VL, VU=VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )'
      D=DD; E=EE; Z = HUGE(1.0_WP)
      CALL LA_STEVR(  D, E, W, VL=VL, VU=VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO      
! ERROR 5
      VL = 1; VU = 10;
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, Z, VL, VU, M=M, ISUPPZ=ISUPPZ(1:MAX(1,N)-3), INFO=INFO )'
      D=DD; E=EE; Z = HUGE(1.0_WP)
      CALL LA_STEVR(  D, E, W, Z, VL, VU, M=M, ISUPPZ=ISUPPZ(1:MAX(1,N)-3), INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 6
      VL = 2; VU = VL-1;
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, Z, VL, VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )'
      D=DD; E=EE; Z = HUGE(1.0_WP)
      CALL LA_STEVR(  D, E, W, Z, VL, VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 7
      IL = 1; IU = N; VL = 1; VU =10;
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, Z, VL, VU, IL, IU, M, ISUPPZ=ISUPPZ, INFO=INFO )'
      D=DD; E=EE; Z = HUGE(1.0_WP)
      CALL LA_STEVR(  D, E, W, Z, VL, VU, IL, IU, M, ISUPPZ=ISUPPZ, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 8
      IL=1; IU=IL-1
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, Z, IL=IL, IU=IU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )'
      D=DD; E=EE; Z = HUGE(1.0_WP)
      CALL LA_STEVR(  D, E, W, Z, IL=IL, IU=IU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 8
      IL=-1; IU=N
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, Z, ISUPPZ, IL=IL, IU=IU, M=M, INFO=INFO )'
      D=DD; E=EE; Z = HUGE(1.0_WP)
      CALL LA_STEVR(  D, E, W, Z, IL=IL, IU=IU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 9
      IL=1; IU=N+1
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_STEVR( D, E, W, Z, IL=IL, IU=IU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )'
      D=DD; E=EE; Z = HUGE(1.0_WP)
      CALL LA_STEVR(  D, E, W, Z, IL=IL, IU=IU, M=M, ISUPPZ=ISUPPZ, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
END!PROGRAM LA_DSTEVR_ET_EXAMPLE

SUBROUTINE DSYGV_F95( A, B, W, ITYPE, JOBZ, UPLO, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: SYGV_F77 => LA_SYGV, ILAENV_F77 => ILAENV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
   INTEGER, INTENT(IN), OPTIONAL :: ITYPE
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
   REAL(WP), INTENT(OUT) :: W(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!        LA_SYGV, LA_SYGVD, LA_HEGV and LA_HEGVD compute all eigenvalues
! and, optionally, all eigenvectors of generalized eigenvalue problems of
! the form A*z = lambda*B*z, A*B*z = lambda*z, and B*A*z = lambda*z,
! where A and B are real symmetric in the cases of LA_SYGV and LA_SYGVD 
! and complex Hermitian in the cases of LA_HEGV and LA_HEGVD. In all four
! cases B is positive deffinite.
!        LA_SYGVD and LA_HEGVD use a divide and conquer algorithm. If 
! eigenvectors are desired, they can be much faster than LA_SYGV and
! LA_HEGV for large matrices but use more workspace.
! 
! =========
! 
!       SUBROUTINE LA_SYGV / LA_SYGVD / LA_HEGV / LA_HEGVD( A, B, &
!                  W, ITYPE=itype, JOBZ=jobz, UPLO=uplo, INFO=info )
!            <type>(<wp>), INTENT(INOUT) :: A(:,:), B(:,:)
!            REAL(<wp>), INTENT(OUT) :: W(:)
!            INTEGER, INTENT(IN), OPTIONAL :: ITYPE
!            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
!            INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!            <type> ::= REAL | COMPLEX
!            <wp>   ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! A       (input/output) REAL or COMPLEX square array, shape (:,:).
!         On entry, the matrix A.
!         If UPLO = 'U', the upper triangular part of A contains the 
!         upper triangular part of matrix A. If UPLO = 'L', the lower 
!         triangular part of A contains the lower triangular part of 
!         matrix A.
!         On exit, if JOBZ = 'V', then the columns of A contain the 
!         eigenvectors, normalized as follows:
!            if ITYPE = 1 or 2: Z^H*B*Z = I ,
!            if ITYPE = 3: Z^H*B^-1*Z = I .
!         If JOBZ = 'N', then the upper triangle (if UPLO = 'U') or the
!         lower triangle (if UPLO = 'L') of A, including the diagonal, 
!         is destroyed. 
! B       (input/output) REAL or COMPLEX square array, shape (:,:) with 
!         size(B,1) = size(A,1).
!         On entry, the matrix B. If UPLO = 'U', the upper triangular 
!         part of B contains the upper triangular part of matrix B. If 
! 	  UPLO = 'L', the lower triangular part of B contains the lower
!         triangular part of matrix B. 
!         On exit, if the part of B containing the matrix is overwritten 
!         by the triangular factor U or L of the Cholesky factorization 
!         B = U^H*U or B = L*L^H , respectively.
! W       (output) REAL array, shape (:) with size(W) = size(A,1).
!         The eigenvalues in ascending order.
! ITYPE   Optional (input) INTEGER.
!         Specifies the problem type to be solved:
!           = 1: A*z = lambda*B*z
!           = 2: A*B*z = lambda*z
!           = 3: B*A*z = lambda*z
!         Default value: 1.
! JOBZ    Optional (input) CHARACTER(LEN=1).
!           = 'N': Compute eigenvalues only;
!           = 'V': Compute eigenvalues and eigenvectors.
!         Default value: 'N'.
! UPLO    Optional (input) CHARACTER(LEN=1).
!           = 'U': Upper triangles of A and B are stored;
!           = 'L': Lower triangles of A and B are stored.
!         Default value: 'U'.
! INFO    Optional (output) INTEGER.
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: the algorithm failed to converge or matrix B is not 
! 	  positive deffinite:
!             <= n: if INFO = i, i off-diagonal elements of an 
!                   intermediate tridiagonal form did not converge to 
!                   zero.
!             > n: if INFO = n+i, for 1 <= i <= n, then the leading minor
!                   of order i of B is not positive deffinite. The 
!                   factorization of B could not be completed and no
!                   eigenvalues or eigenvectors were computed.
!             n is the order of A.
!         If INFO is not present and an error occurs, then the program is 
!         terminated with an error message.
!------------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_SYGV'
   CHARACTER(LEN=6), PARAMETER :: BSNAME = 'DSYTRD'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBZ, LUPLO
   INTEGER :: LINFO, N, LD, LITYPE, LWORK, NB, ISTAT, ISTAT1
!  .. LOCAL ARRAYS ..
   REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC SIZE, MAX, PRESENT
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; N = SIZE(A,1); LD = MAX(1,N); ISTAT = 0
   IF( PRESENT(ITYPE) )THEN
      LITYPE = ITYPE
   ELSE
      LITYPE = 1
   END IF
   IF( PRESENT(JOBZ) ) THEN
      LJOBZ = JOBZ
   ELSE
      LJOBZ = 'N'
   END IF
   IF( PRESENT(UPLO) ) THEN
      LUPLO = UPLO
   ELSE
      LUPLO = 'U'
   END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE( A, 2 ) /= N .OR. N < 0 )THEN
      LINFO = -1
   ELSE IF( SIZE( B, 1 ) /= N .OR. SIZE( B, 2 ) /= N  )THEN
      LINFO = -2
   ELSE IF( SIZE( W ) /= N )THEN
      LINFO = -3
   ELSE IF( LITYPE < 1 .OR. LITYPE > 3 )THEN
      LINFO = -4
   ELSE IF( .NOT.LSAME(LJOBZ,'N') .AND. .NOT.LSAME(LJOBZ,'V') )THEN
      LINFO = -5
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN
      LINFO = -6
   ELSE IF( N > 0 )THEN
!     .. DETERMINE THE WORKSPACE
      NB = ILAENV_F77( 1, BSNAME, LUPLO, N, -1, -1, -1 )
      IF( NB <= 1 .OR. NB >= N )THEN
         NB = 1
      ENDIF
      LWORK = N*(2+NB)
      ALLOCATE(WORK(LWORK), STAT=ISTAT)
      IF( ISTAT /= 0 )THEN
         DEALLOCATE(WORK, STAT=ISTAT1)
         LWORK = N*3-1
         ALLOCATE(WORK(LWORK), STAT=ISTAT)
         IF( ISTAT /= 0 ) THEN
            LINFO = - 100
         ELSE
            CALL ERINFO( -200, SRNAME, LINFO )
         ENDIF
      ENDIF
      IF( LINFO == 0 .OR. LINFO <= -200 )THEN
!        .. CALL LAPACK77 ROUTINE
         CALL SYGV_F77( LITYPE, LJOBZ, LUPLO, N, A, LD, B, LD, W, &
                        WORK, LWORK, LINFO )
      END IF
      DEALLOCATE(WORK, STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO, SRNAME, INFO, ISTAT)
END SUBROUTINE DSYGV_F95

SUBROUTINE SGETRS1_F95( A, IPIV, B, TRANS, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: GETRS_F77 => LA_GETRS
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   INTEGER, INTENT(IN) :: IPIV(:)
   REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GETRS'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LTRANS
   INTEGER    :: LINFO, NRHS, N, LD
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC SIZE, MAX, PRESENT
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; N = SIZE(A, 1); NRHS = 1; LD = MAX(1,N)
   IF(PRESENT(TRANS))THEN; LTRANS = TRANS; ELSE; LTRANS='N'; END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE( A, 2 ) /= N .OR. N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE( IPIV ) /= N ) THEN; LINFO = -2
   ELSE IF( SIZE( B ) /= N ) THEN; LINFO = -3
   ELSE IF(.NOT.LSAME(LTRANS,'N') .AND. .NOT.LSAME(LTRANS,'T').AND. &
           .NOT.LSAME(LTRANS,'C'))THEN; LINFO = -4
   ELSE
!  .. CALL LAPACK77 ROUTINE
      CALL GETRS_F77( LTRANS, N, NRHS, A, LD, IPIV, B, LD, LINFO )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO )
END SUBROUTINE SGETRS1_F95

      FUNCTION SLANGE1_F95( A, NORM, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!     .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE LA_AUXMOD, ONLY: ERINFO, LSAME
      USE F77_LAPACK, ONLY: LANGE_F77 => LA_LANGE
!     .. "Implicit Statement" ..
      IMPLICIT NONE
!     .. "Function Type" ..
      REAL(WP) :: SLANGE1_F95
!     .. "Scalar Arguments" ..
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
!     .. "Array Arguments" ..
      REAL(WP), INTENT(IN) :: A(:)
!     .. "Parameters" ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_LANGE'
!     .. "Local Scalars" ..
      CHARACTER(LEN=1) :: LNORM
      INTEGER :: ISTAT, ISTAT1, LDA, LINFO, M, N
      REAL(WP), TARGET :: LLWORK(1)
!     .. "Local Pointers" ..
      REAL(WP), POINTER :: WORK(:)
!     .. "Intrinsic Functions" ..
      INTRINSIC SIZE, PRESENT, MAX
!     .. "Executable Statements" ..
      LINFO = 0; M = SIZE(A); N = 1; LDA = MAX(1,M)
      ISTAT = 0
      IF( PRESENT(NORM) )THEN; LNORM = NORM; ELSE; LNORM = '1'; ENDIF
!     .. "Testing The Arguments" ..
      IF( M < 0 )THEN; LINFO = -1
      ELSE IF( .NOT. ( LSAME(LNORM,'M') .OR. LSAME(LNORM,'1') .OR. &
         LSAME(LNORM,'I') .OR. LSAME(LNORM,'F') .OR. &
         LSAME(LNORM,'E') ) )THEN; LINFO = -2
      ELSE
         IF( LSAME(LNORM,'I') )THEN; ALLOCATE( WORK( M), STAT=ISTAT )
         ELSE; WORK => LLWORK; ENDIF
         IF( ISTAT == 0 ) &
           SLANGE1_F95 = LANGE_F77( LNORM, M, N, A, LDA, WORK )
         IF( LSAME(LNORM,'I') )DEALLOCATE( WORK, STAT=ISTAT1 )
      ENDIF
      CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
      END FUNCTION SLANGE1_F95

PROGRAM LA_DGBSVX_ET_EXAMPLE
!
!  -- LAPACK95 INTERFACE DRIVER ROUTINE (VERSION 3.0) --
!     UNI-C, DENMARK; UNIV. OF TENNESSEE, USA; NAG LTD., UK
!     SEPTEMBER, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GBSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
   CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: K, KL, KU, I, J, INFO, N, NRHS
!  .. LOCAL ARRAYS ..
   INTEGER, ALLOCATABLE :: IPIV(:)
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:)
   REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), X(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'DGBSVX ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, KL, KU, NRHS
   PRINT *, 'N = ', N, ' KL = ', KL, ' KU = ', KU, ' NRHS = ', NRHS
   ALLOCATE ( A(KL+KU+1,N), AA(KL+KU+1,N), B(N,NRHS), BB(N,NRHS), X(N,NRHS), IPIV(N) )
!
      AA = HUGE(1.0_WP)
      DO I = 1, 1+KU
        READ (NIN, *) (AA(I, J), J = KU-I+2,N)
      ENDDO
      DO I = 2+KU, KL+KU+1
        READ (NIN, *) (AA(I, J), J = 1, N-I+KU+1)
      ENDDO
      B = 0.0_WP
      DO I = 1, NRHS
         DO J = 1, N
            DO K = MAX(1,J-KL), MIN(J+KU,N)
               BB(J,I) = AA(KU+1+J-K,K) + BB(J,I)
            ENDDO
         ENDDO
         BB(:,I) = BB(:,I)*I
      ENDDO
      A=AA; B=BB
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, KL+KU+1
        WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,:)
      ENDDO
      WRITE(NOUT,*) 'The RHS matrix B:'
      DO J = 1, NRHS
        WRITE (NOUT,*) 'RHS', J; WRITE (NOUT,FMT) B(:,J)
      ENDDO
!
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_DGBSVX LAPACK SUBROUTINE Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX( A, B, X, KL, IPIV=IPIV, INFO=INFO )'
   A=AA; B=BB
   CALL LA_GBSVX( A, B, X, KL, IPIV=IPIV, INFO=INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GBSVX, INFO = ', INFO
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*) 'Pivots: ', IPIV
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX( A, B(1:N,1), X(1:N,1), KL, IPIV=IPIV, INFO=INFO )'
   A=AA; B=BB
   CALL LA_GBSVX( A, B(1:N,1), X(1:N,1), KL, IPIV=IPIV, INFO=INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GBSVX, INFO = ', INFO
   WRITE (NOUT,FMT) X(:,1)
   WRITE(NOUT,*) 'Pivots: ', IPIV
! 
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GBSVX:'
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX( A, B, X, KL )'
   A=AA; B=BB
   CALL LA_GBSVX( A, B, X, KL )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GBSVX:'
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX(A, B(1:N,1), X(1:N,1), KL)'
   A=AA; B=BB
   CALL LA_GBSVX(A, B(1:N,1), X(1:N,1), KL)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GBSVX:'
   WRITE (NOUT,FMT) X(:,1)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX(A, B, X, IPIV=IPIV)'
   A=AA; B=BB
   CALL LA_GBSVX( A, B, X, IPIV=IPIV)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GBSVX:'
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*) 'Pivots: ', IPIV
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX( A, B(1:N,1), X(1:N,1), IPIV=IPIV )'
   A=AA; B=BB
   CALL LA_GBSVX( A, B(1:N,1), X(1:N,1), IPIV=IPIV )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GBSVX:'
   WRITE (NOUT,FMT) X(1:N,1)
   WRITE(NOUT,*) 'Pivots: ', IPIV
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX(A(4:4,:), B, X, INFO =INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_GBSVX( A(4:4,:), B, X, INFO=INFO)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GBSVX, INFO = ', INFO
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX( A(4:4,:), B(1:N,1), X(1:N,1), INFO=INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_GBSVX( A(4:4,:), B(1:N,1), X(1:N,1), INFO=INFO )
   WRITE(NOUT,*)'   B - the RHS vector.'
   WRITE (NOUT,FMT) B(1:N,1)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GBSVX, INFO = ', INFO
   WRITE (NOUT,FMT) X(1:N,1)
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX(A(4:4,:), B, X, 1, INFO =INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_GBSVX( A(4:4,:), B, X, 1, INFO=INFO)
   WRITE(NOUT,*)' INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX(A(4:4,:), B, X, 6, INFO =INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_GBSVX( A(4:4,:), B, X, 1, INFO=INFO)
   WRITE(NOUT,*)' INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX( A, B(1:N,1), X(1:N,1), 1, INFO=INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_GBSVX( A, B(1:N,1), X(1:N,1), 6, INFO=INFO )
   WRITE(NOUT,*)'    INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GBSVX( A, B(1:N,1), X(1:N,1), 6 )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_GBSVX( A, B(1:N,1), X(1:N,1), 6 )
   WRITE(NOUT,*)'   INFO = ', INFO
!
END PROGRAM LA_DGBSVX_ET_EXAMPLE

 SUBROUTINE ZHPSV_F95( AP, B, UPLO, IPIV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO, LSAME
    USE F77_LAPACK, ONLY: HPSV_F77 => LA_HPSV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IPIV(:)
    COMPLEX(WP), INTENT(INOUT) :: AP(:), B(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!     LA_SPSV computes the solution to a linear system of equations
! A*X = B, where A is a real or complex symmetric matrix stored in packed
! format and X and B are rectangular matrices or vectors. A diagonal
! pivoting method is used to factor A as
!    A = U*D*U^T if UPLO = 'U', or A = L*D*L^T if UPLO = 'L'
! where U (or L) is a product of permutation and unit upper (or lower)
! triangular matrices, and D is a symmetric block diagonal matrix with 
! 1 by 1 and 2 by 2 diagonal blocks. The factored form of A is then used 
! to solve the above system.
!     LA_HPSV computes the solution to a linear system of equations 
! A*X = B, where A is a complex Hermitian matrix stored in packed format
! and X and B are rectangular matrices or vectors. A diagonal pivoting 
! method is used to factor A as
!     A = U*D*U^H if UPLO = 'U', or A = L*D*L^H if UPLO = 'L'
! where U (or L) is a product of permutation and unit upper (or lower)
! triangular matrices, and D is a complex Hermitian block diagonal matrix
! with 1 by 1 and 2 by 2 diagonal blocks. The factored form of A is then 
! used to solve the above system.
! 
! =========
! 
!      SUBROUTINE LA_SPSV / LA_HESV( AP, B, UPLO=uplo, &
!                                 IPIV=ipiv, INFO=info )
!          <type>(<wp>), INTENT(INOUT) :: AP(:), <rhs>
!          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!          INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
!          INTEGER, INTENT(OUT), OPTIONAL :: INFO
!      where
!          <type> ::= REAL | COMPLEX
!          <wp>   ::= KIND(1.0) | KIND(1.0D0)
!          <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! AP       (input/output) REAL or COMPLEX array, shape (:) with size(AP)=
!          n*(n + 1)=2, where n is the order of A.
!          On entry, the upper or lower triangle of matrix A in packed 
! 	   storage. The elements are stored columnwise as follows:
!          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j<=n;
!          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for 1<=j<=i<=n.
!          On exit, the block diagonal matrix D and the multipliers used
! 	   to obtain U or L from the factorization of A, stored as a
! 	   packed triangular matrix in the same storage format as A.
! B        (input/output) REAL or COMPLEX array, shape (:,:) with 
!          size(B,1) = n or shape (:) with size(B) = n.
!          On entry, the matrix B.
!          On exit, the solution matrix X .
! UPLO     Optional (input) CHARACTER(LEN=1)
!             = 'U': Upper triangle of A is stored;
!             = 'L': Lower triangle of A is stored.
!          Default value: 'U'.
! IPIV     Optional (output) INTEGER array, shape (:) with size(IPIV)=n.
!          Details of the row and column interchanges and the block 
! 	   structure of D.
!          If IPIV(k) > 0, then rows and columns k and IPIV(k) were 
! 	   interchanged, and D(k,k) is a 1 by 1 diagonal block.
!          If IPIV k < 0, then there are two cases:
!            1. If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0, then rows 
! 	      and columns (k-1) and -IPIV(k) were interchanged and
! 	      D(k-1:k,k-1:k) is a 2 by 2 diagonal block.
!            2. If UPLO = 'L' and IPIV(k) = IPIV(k+1) < 0, then rows 
! 	      and columns (k + 1) and -IPIV(k) were interchanged and
! 	      D(k:k+1,k:k+1) is a 2 by 2 diagonal block.
! INFO     Optional (output) INTEGER.
!          = 0: successful exit
!          < 0: if INFO = -i, the i-th argument had an illegal value.
!          > 0: if INFO = i, D(i,i) = 0. The factorization has been 
! 	     completed, but the block diagonal matrix D is singular,
! 	     so the solution could not be computed.
!          If INFO is not present and an error occurs, then the program 
! 	   is terminated with an error message.
!----------------------------------------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_HPSV'
!   .. LOCAL SCALARS ..
    CHARACTER(LEN=1) :: LUPLO
    INTEGER :: LINFO, N, NN, NRHS, SIPIV, ISTAT, ISTAT1
    COMPLEX(WP) :: WW
!   .. LOCAL POINTERS ..
    INTEGER, POINTER :: LPIV(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT, REAL, INT, AIMAG
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; NN = SIZE(AP); NRHS = SIZE(B,2)
    WW = (-1+SQRT(1+8*REAL(NN,WP)))*0.5; N = INT(WW)
    IF( PRESENT(UPLO) )THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
    IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; END IF
!   .. TEST THE ARGUMENTS
    IF( NN < 0 .OR. AIMAG(WW) /= 0 .OR. REAL(N,WP) /= REAL(WW) ) THEN; LINFO = -1
    ELSE IF( SIZE( B, 1 ) /= N .OR. NRHS < 0 ) THEN; LINFO = -2
    ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
    ELSE IF( SIPIV /= N )THEN; LINFO = -4
    ELSE IF ( N > 0 ) THEN
      IF( PRESENT(IPIV) )THEN; LPIV => IPIV
      ELSE; ALLOCATE( LPIV(N), STAT = ISTAT ); END IF
      IF( ISTAT == 0 ) THEN
         CALL HPSV_F77( LUPLO, N, NRHS, AP, LPIV, B, N, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(IPIV) )DEALLOCATE(LPIV, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE ZHPSV_F95

SUBROUTINE LA_TEST_DPBSV(UPLO, N, KD, NRHS, AB, LDAB, B, LDB, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     April 5, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_PBSV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, KD, NRHS, LDAB, LDB
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: UPLO
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: AB(1:LDAB,1:N), B(1:LDB,1:NRHS)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_PBSV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DPBSV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IAB1, IAB2, IB1, IB2
   CHARACTER*1 :: IUPLO   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IAB1 = LDAB; IAB2 = N; IB1 = N; IB2 = NRHS; IUPLO=UPLO
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
      IF ( NRHS == 1 ) THEN
        CALL LA_PBSV( AB(1:IAB1,1:IAB2), B(1:IB1,1), IUPLO )
        INFO = INFOTC
      ELSE
        CALL LA_PBSV( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), IUPLO )
        INFO = INFOTC
      END IF
   CASE (1)
      IAB1 = -1
   CASE (2)
      IB1 = IAB1-1
   CASE(3)
      IUPLO = 'T'
   CASE(:-1,4:)
      CALL UESTOP(SRNAMT)
   END SELECT
      IF( I /= 0 ) THEN
      SELECT CASE (NRHS)
      CASE (2:)
         CALL LA_PBSV( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), IUPLO, INFO )
      CASE(1)
         CALL LA_PBSV( AB(1:IAB1,1:IAB2), B(1:IB1,1), IUPLO, INFO )
      CASE(:-1)
         CALL UESTOP(SRNAMT)
      END SELECT
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_DPBSV

      PROGRAM LA_SGELSY_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GELSY
    !  USE F77_LAPACK, ONLY: GEESX_F77 => LA_GEESX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, M, N, NRHS, RANK
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE :: JPVT(:)
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GELSY Example Program Results'
      M=6; N = 4; NRHS = 3
      WRITE(*,'(5H M = , I4, 5H N = , I4, 9H; NRHS = , I4)') M, N, NRHS
      ALLOCATE( A(M,N), AA(M,N), B(MAX(M,N),NRHS), BB(MAX(M,N),NRHS), JPVT(N) )

      OPEN(UNIT=21,FILE='gelss.ma',STATUS='UNKNOWN')
      DO I=1,M
         DO J=1,N 
            READ(21,'(F2.0)') A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix A :'
      DO I=1,M;
         WRITE(*,"(24(F9.5))") A(I,:);
      ENDDO

      OPEN(UNIT=22,FILE='gelss.mb',STATUS='UNKNOWN')
      DO I=1,MAX(M,N)
         DO J=1,NRHS
            READ(22,'(F3.0)') B(I,J)
         ENDDO
      ENDDO
      CLOSE(22)
      
      WRITE(*,*)'Matrix B :'
      DO I=1,M; 
         WRITE(*,"(3(F9.5))") B(I,:); 
      ENDDO
      
      AA=A
      BB=B
    
      JPVT(1)=0; JPVT(2)=0; JPVT(3)=1; JPVT(4)=0;

      WRITE(*,*) 'CALL LA_GELSY( A, B, RANK, JPVT, 1.0E-5_WP )'
      
      CALL LA_GELSY( A, B, RANK, JPVT, 1.0E-5_WP )
      
      WRITE(*,*) 'The matrix B on exit :'
      DO I=1,M; 
         WRITE(*,"(3(E15.7),1X)") B(I,:); 
      ENDDO
          
    
      WRITE(*,*)'RANK = ', RANK
      WRITE(*,*)'JPVT = ', JPVT
    
      END PROGRAM LA_SGELSY_EXAMPLE

SUBROUTINE DGGESX_F95( A, B,  ALPHAR, ALPHAI, &
&   BETA, VSL, VSR, SELECT, SDIM, RCONDE, RCONDV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: GGESX_F77 => LA_GGESX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      INTEGER, INTENT(OUT), OPTIONAL :: SDIM
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
   REAL(WP), INTENT(OUT) :: ALPHAR(:), ALPHAI(:), BETA(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VSL(:,:), VSR(:,:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: RCONDE(2), RCONDV(2)
!  .. FUNCTIONAL ARGUMENTS ..
      INTERFACE
      LOGICAL FUNCTION SELECT(ALPHAR, ALPHAI, BETA)
      USE LA_PRECISION, ONLY: WP => DP
      REAL(WP), INTENT(IN) :: ALPHAR, ALPHAI, BETA
      END FUNCTION SELECT
      END INTERFACE
      OPTIONAL :: SELECT
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!      LA_GGESX computes for a pair of n by n real or complex matrices
! (A, B) the (generalized) real or complex Schur form, the generalized
! eigenvalues in the form of scalar pairs (alpha,beta), and, optionally,
! the left and/or right Schur vectors.
!      If A and B are real then the real-Schur form is computed, 
! otherwise the complex-Schur form is computed. The real-Schur form is a
! pair of real matrices (S,T) such that 1) S has block upper triangular 
! form, with 1 by 1 and 2 by 2 blocks along the main diagonal, 2) T has
! upper triangular form with nonnegative elements on the main diagonal,
! and 3) S = Q^T*A*Z and T = Q^T*B*Z, where Q and Z are orthogonal 
! matrices. The 2 by 2 blocks of S are "standardized" by making the 
! corresponding elements of T have the form
!                        [ a  0 ]
! 		         [ 0  b ]
! The complex-Schur form is a pair of matrices (S,T) such that 1) S has
! upper triangular form, 2) T has upper triangular form with nonnegative 
! elements on the main diagonal, and 3) S = Q^H*A*Z and T = Q^H*B*Z,
! where Q and Z are unitary matrices.
!       In both cases the columns of Q and Z are called, respectively, 
! the left and right (generalized) Schur vectors.
! A generalized eigenvalue of the pair (A,B) is, roughly speaking, a 
! scalar of the form lambda = alpha/beta such that the matrix 
! A -lambda*B is singular. It is usually represented as the pair
! (alpha, beta), as there is a reasonable interpretation of the case 
! beta = 0 (even if alpha = 0).
!       LA_GGESX also computes two reciprocal condition numbers for the
! average of the selected eigenvalues and reciprocal condition numbers 
! for the right and left deflating subspaces corresponding to the 
! selected eigenvalues.
! 
! =========
! 
!           SUBROUTINE LA_GGESX( A, B, <alpha>, BETA, VSL=vsl, &
!                      VSR=vsr, SELECT=select, SDIM=sdim, 
!                      RCONDE=rconde, RCONDV=rcondv, INFO=info )
!              <type>(<wp>), INTENT(INOUT) :: A(:,:), B(:,:)
!              <type>(<wp>), INTENT(OUT) :: <alpha(:)>, BETA(:)
!              <type>(<wp>), INTENT(OUT), OPTIONAL :: VSL(:,:), VSR(:,:)
!              INTERFACE
!                 LOGICAL FUNCTION SELECT(<alpha(j)> , BETA(j))
!                     <type>(<wp>), INTENT(IN) :: <alpha(j)> , BETA(j)
!                 END FUNCTION SELECT
!              END INTERFACE
!              OPTIONAL :: SELECT
!              INTEGER, INTENT(OUT), OPTIONAL :: SDIM
!              REAL(<wp>), INTENT(OUT), OPTIONAL :: RCONDE(2), RCONDV(2)
!              INTEGER, INTENT(OUT), OPTIONAL :: INFO
!           where
!              <type>     ::= REAL | COMPLEX
!              <wp>       ::= KIND(1.0) | KIND(1.0D0)
!              <alpha>    ::= ALPHAR, ALPHAI | ALPHA
!              <alpha(:)> ::= ALPHAR(:), ALPHAI(:) | ALPHA(:)
!              <alpha(j)> ::= ALPHAR(j) , ALPHAI(j) | ALPHA(j)
! 
! Arguments
! =========
! 
! A        (input/output) REAL or COMPLEX square array, shape (:,:).
!          On entry, the matrix A.
!          On exit, the matrix S.
! B        (input/output) REAL or COMPLEX square array, shape (:,:) with
!          size(B,1) = size(A,1).
!          On entry, the matrix B.
!          On exit, the matrix T .
! <alpha>  (output) REAL or COMPLEX array, shape (:) with size(alpha) =
!          size(A,1).
! 	   The values of alpha.
!          <alpha(:)> ::= ALPHAR(:), ALPHAI(:) | ALPHA(:),
!          where
!          ALPHAR(:), ALPHAI(:) are of REAL type (for the real and 
! 	   imaginary parts) and ALPHA(:) is of COMPLEX type.
! BETA     (output) REAL or COMPLEX array, shape (:) with size(BETA) =
!          size(A,1).
!          The values of beta.
!          Note: The generalized eigenvalues of the pair (A,B) are the 
! 	   scalars lambda(j) = alpha(j)/beta(j). These quotients may 
! 	   easily over- or underflow, and beta(j) may even be zero. Thus,
! 	   the user should avoid computing them naively.
!          Note: If A and B are real then complex eigenvalues occur in 
! 	   complex conjugate pairs. Each pair is stored consecutively. 
! 	   Thus a complex conjugate pair is given by
!            lambda(j) = (ALPHAR(j) + i*ALPHAI(j))/BETA(j)
!            lambda(j+1) = (ALPHAR(j+1) + i*ALPHAI(j+1))/BETA(j+1)
!          where
!          ALPHAI(j)/BETA(j) = -( ALPHAI(j+1)/BETA(j+1))
! VSL      Optional (output) REAL or COMPLEX square array, shape (:,:)
!          with size(VSL,1) = size(A,1).
!          The left Schur vectors.
! VSR      Optional (output) REAL or COMPLEX square array, shape (:,:)
!          with size(VSR,1) = size(A,1).
!          The right Schur vectors.
! SELECT   Optional (input) LOGICAL FUNCTION
!          LOGICAL FUNCTION SELECT( <alpha(j)> , BETA(j))
!             <type>(<wp>), INTENT(IN) :: <alpha(j)> , BETA(j)
!          where
!             <type> ::= REAL | COMPLEX
!             <wp> ::= KIND(1.0) | KIND(1.0D0)
!             <alpha(j)> ::= ALPHAR(j) , ALPHAI(j) | ALPHA(j)
!          1. SELECT must be declared as EXTERNAL or as an explicit 
! 	   interface in the calling (sub)program.
!          2. SELECT is called by LA_GGESX for every computed eigenvalue
! 	   (<alpha(j)> , BETA(j)) (but only once for a complex conjugate
! 	   pair when A and B are real). It is used to select the
!          eigenvalues that will be ordered to the top left of the Schur 
! 	   form. The eigenvalue (<alpha(j)>, BETA(j)) is selected if 
! 	   SELECT(<alpha(j)>, BETA(j)) has the value .TRUE.
!          3. A selected complex eigenvalue may no longer satisfy 
! 	   SELECT(<alpha(j)>, BETA(j)) = .TRUE. after ordering, since 
! 	   ordering may change the value of complex eigenvalues
! 	   (especially if the eigenvalue is ill-conditioned); in this case
! 	   INFO is set to size(A,1) + 2 (see INFO below).
!          Note: Select must be present if SDIM is desired.
! SDIM     Optional (output) INTEGER.
!          The number of eigenvalues (after sorting) for which SELECT = 
! 	   .TRUE. (If A and B are real, then complex conjugate pairs for 
! 	   which SELECT = .TRUE. for either eigenvalue count as 2).
! RCONDE   Optional (output) REAL array, shape (:) with size(RCONDE)=2.
!          The reciprocal condition numbers for the average of the 
!          selected eigenvalues.
! RCONDV   Optional (output) REAL array, shape (:) with size(RCONDV)=2.
!          The reciprocal condition numbers for the left and right 
!          deflating subspaces corresponding to the selected 
!          eigenvalues.
! INFO     Optional (output) INTEGER.
!          = 0: successful exit.
!          < 0: if INFO = -i, the i-th argument had an illegal value.
!          > 0: if INFO = i, and i is
!            <= n: the QZ iteration failed. The matrix pair (A,B) has not
! 	      been reduced to Schur form, but (<alpha(j)>,BETA(j)) 
! 	      should be correct for j = INFO + 1,..., n.
!            = n+1: another part of the algorithm failed.
!            = n+2: after reordering, roundoff changed values of some 
! 	      complex eigenvalues so that leading eigenvalues in the 
! 	      Schur form no longer satisfy SELECT = .TRUE. This can be
! 	      caused by ordinary roundoff or underflow due to scaling.
!            = n+3: the reordering failed.
!          If INFO is not present and an error occurs, then the program 
!          is terminated with an error message.
!-----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GGESX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBVSL, LJOBVSR, LSORT, LSENSE
   INTEGER, SAVE :: LWORK = 0
   INTEGER :: N, LINFO, LDA, LDB, ISTAT, S1VSL, S2VSL, S1VSR, S2VSR, &
     &  SALPHAR, SALPHAI, SBETA, LIWORK
   INTEGER :: LSDIM
!  .. LOCAL ARRAYS ..
   REAL(WP), TARGET :: LLVSL(1,1), LLVSR(1,1)
   REAL(WP), TARGET :: LLRCONDE(2), LLRCONDV(2)
   REAL(WP), POINTER :: WORK(:)
   LOGICAL, POINTER :: BWORK(:)
   INTEGER, POINTER :: IWORK(:)
   LOGICAL, TARGET :: LLBWORK(1)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(A,1); LDA = MAX(1,N); LDB = MAX(1,SIZE(B,1))
   SALPHAR = SIZE(ALPHAR); SALPHAI = SIZE(ALPHAI)
   IF  (PRESENT (SELECT)) THEN
     LSORT = 'S'; ELSE ; LSORT = 'N'; ENDIF 
   SBETA = SIZE(BETA)
   IF( PRESENT(RCONDE).AND.PRESENT(RCONDV) )THEN; LSENSE = 'B'
   ELSE IF( PRESENT(RCONDE) )THEN; LSENSE = 'E'
   ELSE IF( PRESENT(RCONDV) )THEN; LSENSE = 'V'; ELSE; LSENSE = 'N'; ENDIF
   IF( .NOT. LSAME(LSENSE,'N') ) LSORT = 'S'
   IF( PRESENT(VSL) )THEN; S1VSL = SIZE(VSL,1); S2VSL = SIZE(VSL,2); LJOBVSL = 'V'
   ELSE; S1VSL = 1; S2VSL = 1; LJOBVSL = 'N'; END IF
   IF( PRESENT(VSR) )THEN; S1VSR = SIZE(VSR,1); S2VSR = SIZE(VSR,2); LJOBVSR = 'V'
   ELSE; S1VSR = 1; S2VSR = 1; LJOBVSR = 'N'; END IF
!  .. TEST THE ARGUMENTS
   IF( N < 0 .OR. SIZE(A,2) /= N )THEN; LINFO = -1
      ELSE IF( SIZE(B,1) /= N .OR. SIZE(B,2) /= N )THEN; LINFO = -2
      ELSE IF( SALPHAR /= N )THEN; LINFO = -3
      ELSE IF( SALPHAI /= N )THEN; LINFO = -4
      ELSE IF( SBETA /= N )THEN; LINFO = -5
      ELSE IF( PRESENT(VSL) .AND. ( S1VSL /= N .OR. S2VSL /= N ) )THEN; LINFO = -6
      ELSE IF( PRESENT(VSR) .AND. ( S1VSR /= N .OR. S2VSR /= N ) )THEN; LINFO = -7

   ELSE IF( N >= 0 )THEN
      IF(LSAME(LSORT,'S')) THEN;  ALLOCATE(BWORK(N),STAT=ISTAT)
        IF (ISTAT /= 0) THEN ; LINFO=-101; GOTO 100; ENDIF
      ELSE; BWORK => LLBWORK; END IF

      IF (LSAME (LSENSE, 'N')) THEN
        LWORK =   8 * (N+1)+16 
      ELSE
        LWORK = MAX( 8*(N+1)+16, N*N/2+1 )
      ENDIF
      ALLOCATE (WORK(LWORK), STAT=ISTAT)
      IF (ISTAT /= 0) THEN ; LINFO=-105; GOTO 500; ENDIF
      LIWORK = 8*(N+6)+10
      ALLOCATE ( IWORK (LIWORK), STAT=ISTAT)
      IF (ISTAT /= 0) THEN ; LINFO=-106; GOTO 600; ENDIF

      IF (PRESENT (RCONDV)) THEN
        IF (PRESENT (RCONDE)) THEN
          IF (PRESENT (VSR)) THEN
            IF (PRESENT (VSL)) THEN
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, VSL, MAX(1,S1VSL), VSR, MAX(1,S1VSR), &
&               RCONDE, RCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ELSE
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, LLVSL, MAX(1,S1VSL), VSR, MAX(1,S1VSR), &
&               RCONDE, RCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ENDIF
          ELSE
            IF (PRESENT (VSL)) THEN
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, VSL, MAX(1,S1VSL), LLVSR, MAX(1,S1VSR), &
&               RCONDE, RCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ELSE
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, LLVSL, MAX(1,S1VSL), LLVSR, MAX(1,S1VSR), &
&               RCONDE, RCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ENDIF
          ENDIF
        ELSE
          IF (PRESENT (VSR)) THEN
            IF (PRESENT (VSL)) THEN
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, VSL, MAX(1,S1VSL), VSR, MAX(1,S1VSR), &
&               LLRCONDE, RCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ELSE
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, LLVSL, MAX(1,S1VSL), VSR, MAX(1,S1VSR), &
&               LLRCONDE, RCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ENDIF
          ELSE
            IF (PRESENT (VSL)) THEN
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, VSL, MAX(1,S1VSL), LLVSR, MAX(1,S1VSR), &
&               LLRCONDE, RCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ELSE
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, LLVSL, MAX(1,S1VSL), LLVSR, MAX(1,S1VSR), &
&               LLRCONDE, RCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ENDIF
          ENDIF
        ENDIF
      ELSE
        IF (PRESENT (RCONDE)) THEN
          IF (PRESENT (VSR)) THEN
            IF (PRESENT (VSL)) THEN
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, VSL, MAX(1,S1VSL), VSR, MAX(1,S1VSR), &
&               RCONDE, LLRCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ELSE
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, LLVSL, MAX(1,S1VSL), VSR, MAX(1,S1VSR), &
&               RCONDE, LLRCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ENDIF
          ELSE
            IF (PRESENT (VSL)) THEN
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, VSL, MAX(1,S1VSL), LLVSR, MAX(1,S1VSR), &
&               RCONDE, LLRCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ELSE
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, LLVSL, MAX(1,S1VSL), LLVSR, MAX(1,S1VSR), &
&               RCONDE, LLRCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ENDIF
          ENDIF
        ELSE
          IF (PRESENT (VSR)) THEN
            IF (PRESENT (VSL)) THEN
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, VSL, MAX(1,S1VSL), VSR, MAX(1,S1VSR), &
&               LLRCONDE, LLRCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ELSE
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, LLVSL, MAX(1,S1VSL), VSR, MAX(1,S1VSR), &
&               LLRCONDE, LLRCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ENDIF
          ELSE
            IF (PRESENT (VSL)) THEN
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, VSL, MAX(1,S1VSL), LLVSR, MAX(1,S1VSR), &
&               LLRCONDE, LLRCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ELSE
              CALL GGESX_F77( LJOBVSL, LJOBVSR, LSORT, SELECT, LSENSE, N, A, LDA, B, LDB, &
&               LSDIM, ALPHAR, ALPHAI, BETA, LLVSL, MAX(1,S1VSL), LLVSR, MAX(1,S1VSR), &
&               LLRCONDE, LLRCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, LINFO )
            ENDIF
          ENDIF
        ENDIF
      ENDIF
      
      IF (PRESENT(SDIM)) SDIM = LSDIM
      
      DEALLOCATE(WORK, STAT=ISTAT)
600   DEALLOCATE(IWORK, STAT=ISTAT)
500   IF(LSAME(LSORT,'S')) DEALLOCATE(BWORK, STAT=ISTAT)

    ENDIF
100   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE DGGESX_F95

SUBROUTINE LA_TEST_CGELSS( M, N, NRHS, A, LDA, B, LDB, S, RCOND, RANK, WORK, LWORK, RWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     October 31, 1996
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GELSS
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: M, N, NRHS, LDA, LDB, LWORK
   INTEGER, INTENT(INOUT) :: INFO
   REAL(WP), INTENT(IN) :: RCOND
   INTEGER, INTENT(OUT) :: RANK
!  .. Array Arguments ..
   COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB,1:NRHS)
   COMPLEX(WP), INTENT(OUT) :: WORK(1:LWORK)
   REAL(WP), INTENT(OUT) :: S(1: MIN(M,N))
   REAL(WP) :: RWORK(1: 5*min(M,N)-1)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GELSS'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_CGELSS'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, IB1, IB2, IS
      REAL:: IRCOND
!  .. Local Arrays ..
   INTEGER, SAVE, POINTER :: IWORK(:)
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IA1 = M; IA2 = N; IB1 = MAX(1,m,n); IB2 = NRHS; IS = MIN(M,N)
      IRCOND = RCOND
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
      IF (NRHS == 1) THEN
        CALL LA_GELSS( A(1:IA1,1:IA2), B(1:IB1,1), RANK, S(1:IS), &
     &    IRCOND, INFO)
        INFO = INFOTC
      ELSE
        CALL LA_GELSS( A(1:IA1,1:IA2), B(1:IB1,1:IB2),  RANK, S(1:IS), &
     &    IRCOND, INFO)                               
        INFO = INFOTC
      END IF            
   CASE (2)
      IB1 = MAX(1,M, N) - 2
   CASE(4)
      IS = MIN(M,N) - 1 
      CASE(:-1,1,3 ,5:)
      CALL UESTOP(SRNAMT)
   END SELECT
   IF( I /= 0 ) THEN
      SELECT CASE (NRHS)
      CASE (2:)
      CALL LA_GELSS( A(1:IA1,1:IA2), B(1:IB1,1:IB2), RANK, S(1:IS), &
     &  IRCOND, INFO)                               
      CASE(1)
      CALL LA_GELSS( A(1:IA1,1:IA2), B(1:IB1,1),  RANK, S(1:IS), &
     &  IRCOND, INFO)                               
      CASE(:-1)
         CALL UESTOP(SRNAMT)
      END SELECT
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_CGELSS

      PROGRAM LA_SPTSVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_PTSVX
!  .. "IMPLICIT STATEMENT" ..
      IMPLICIT NONE
!  .. "Parameters" ..
      REAL(WP), PARAMETER :: ONE = 1.0_WP, THREE = 3.0_WP
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N, NRHS
      REAL(WP) ::  RCOND
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:), D(:), E(:), B(:,:), X(:,:), FERR(:), BERR(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SPTSVX Program Results.'
      N = 5; NRHS = 3
      WRITE(*,'(5H N = , I4, 9H; NRHS = , I4)') N, NRHS  
      ALLOCATE ( A(N), D(N), E(N-1), B(N,NRHS), X(N,NRHS), FERR(NRHS), BERR(NRHS) )
   
      OPEN(UNIT=21,FILE='ptsv.ma',STATUS='UNKNOWN')
      DO I=1,N
         READ(21,'(F3.0)') A(I);
      ENDDO;
      CLOSE(21)

      E = THREE; D(1) = 2*E(1)+ONE; D(2:N) = 2*E+ONE
      B(1,1) = D(1)+E(1); B(N,1) = E(N-1)+D(N)
      B(2:N-1,1) = 2*E + D(2:N-1)
      DO I = 2, NRHS; B(:,I) = B(:,1)*I; ENDDO
         WRITE(*,*) '  on entry:'
         WRITE (*,'(2HD:,8(1X,F9.2))') D
         WRITE (*,'(2HE:,8(1X,F9.2))') E
         WRITE(*,*) 'The RHS matrix B:'
         DO J = 1, N; WRITE (*,'(3(F9.5))') B(J,:); 
         ENDDO   
   
      CALL LA_PTSVX( D, E, B, X, FERR=FERR, BERR=BERR, RCOND=RCOND, INFO=INFO)

      WRITE(*,*) 'FERR on exit :'
      DO I = 1, N-1; WRITE (*,'(E13.5)') FERR(I); 
      ENDDO
      WRITE(*,*)'BERR on exit :'
      DO I = 1, N-1; WRITE (*,'(E13.5)') BERR(I); 
      ENDDO
      WRITE(*,*) 'RCOND =', RCOND
      WRITE(*,*) 'The matrix X on exit:'
      DO J = 1, N; WRITE (*,'(7(F9.5))') X(J,:); 
      ENDDO
      WRITE(*,*)'INFO = ' ,INFO

      WRITE(*,*) '\noindent'
      WRITE(*,*) 'The solution of the system $ A\,X = B $ is:'
      WRITE(*,*) '$$ X = \left( \begin{array}{rrr}'
      DO I=1,N; WRITE(*,"(2(F9.5,' & '),F9.5,' \\')") X(I,:); ENDDO
      WRITE(*,*) '\end{array} \right). $$'

      END PROGRAM LA_SPTSVX_EXAMPLE

SUBROUTINE DGELSD1_F95( A, B, RANK, S, RCOND, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => DP
      USE LA_AUXMOD, ONLY: ERINFO
      USE F77_LAPACK, ONLY: GELSD_F77 => LA_GELSD,  ILAENV_F77 => ILAENV
!   .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL :: RANK
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(IN), OPTIONAL :: RCOND
!   .. ARRAY ARGUMENTS ..
      REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: S(:)
!   .. PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GELSD'
!   .. LOCAL SCALARS ..
      INTEGER :: LINFO, ISTAT,  LWORK, N, M, MN, LRANK, SS, &
     &  LIWORK, SMLSIZ, NLVL
      REAL(WP) :: LRCOND
!   .. LOCAL POINTERS ..
      REAL(WP), POINTER :: WORK(:)
      REAL(WP), POINTER :: LS(:)
      INTEGER, POINTER :: IWORK(:)
      REAL(WP) :: WORKMIN(1)
      INTEGER :: IWORKMIN(1) 
      DOUBLE PRECISION  TWO
      PARAMETER       ( TWO = 2.0D0 ) 
!   .. INTRINSIC FUNCTIONS ..
      INTRINSIC SIZE, PRESENT, MAX, MIN, EPSILON
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2)
    MN = MIN(M,N)
    SMLSIZ = ILAENV_F77( 9, 'DGELSD', ' ', 0, 0, 0, 0 )
    NLVL = INT( LOG( DBLE( MAX(1,MN) ) / DBLE( SMLSIZ+1 ) ) / LOG( TWO ) )
      LIWORK = 3*MAX(M,N)*(3 * NLVL + 11 )
    IF( PRESENT(RCOND) )THEN; LRCOND = RCOND; ELSE
      LRCOND = 100*EPSILON(1.0_WP) ; ENDIF
    IF( PRESENT(S) )THEN; SS = SIZE(S); ELSE; SS =MN; ENDIF
!   .. TEST THE ARGUMENTS
    IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B, 1 ) /= MAX(1,M,N)) THEN; LINFO = -2
    ELSE IF( SS /= MN ) THEN; LINFO = -4
    ELSE IF( LRCOND <= 0.0_WP ) THEN; LINFO = -5
    ELSE
      IF( PRESENT(S) )THEN; LS => S
      ELSE; ALLOCATE( LS(MN), STAT = ISTAT );
        IF (ISTAT /= 0) THEN
          LINFO = -100
          GOTO 100
        ENDIF
      END IF
! .. DETERMINE THE WORKSPACE ..
! .. QUERING THE SIZE OF WORKSPACE .. 
      LWORK = -1
      CALL GELSD_F77( M, N, 1, A, MAX(1,M), B, MAX(1,M,N), &
&       LS, LRCOND, LRANK, WORKMIN, LWORK, IWORKMIN,  LINFO )
      LWORK = WORKMIN(1)
      
      ALLOCATE( WORK(LWORK), STAT = ISTAT )
      IF (ISTAT /= 0) THEN
        LINFO = -100
        GOTO 200
      ENDIF  
      ALLOCATE( IWORK(LIWORK), STAT = ISTAT )
      IF (ISTAT /= 0) THEN
        LINFO = -100
        GOTO 250
      ENDIF
      CALL GELSD_F77( M, N, 1, A, MAX(1,M), B, SIZE(B,1), &
&       LS, LRCOND, LRANK, WORK, LWORK, IWORK, LINFO )
      IF( PRESENT(RANK) ) RANK = LRANK
      
300     DEALLOCATE(IWORK)
250	DEALLOCATE(WORK)
200     IF (.NOT. PRESENT(S)) DEALLOCATE(LS)
ENDIF
100     CALL ERINFO( LINFO, SRNAME, INFO, ISTAT ) 
END SUBROUTINE DGELSD1_F95

SUBROUTINE LA_TEST_SGEEV( JOBVL, JOBVR, N, A, LDA, WR, WI, VL, LDVL, VR, LDVR, WORK, LWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 29, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GEEV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDA, LDVL, LDVR, LWORK
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBVL, JOBVR
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1: LDA, 1:N)
   REAL(WP), INTENT(OUT)::  WR(1: N), WI(1: N), VL(1: LDVL, 1: N), &
&    VR(1: LDVR, 1:N)
   REAL(WP), INTENT(OUT) :: WORK(1:LWORK)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GEEV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGEEV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IWR, IWI, IVL1, IVL2, IVR1, IVR2
   CHARACTER*1 :: IJOBVR, IJOBVL   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IWI = N; IWR = N; IVL1 = N; IVL2 = N
   IVR1 = N; IVR2 = N; IJOBVL = JOBVL; IJOBVR = JOBVR
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
       IA1 = IA1 - 1
     CASE (2)
       IWR = IWR - 1
     CASE (3)
       IWI = IWI - 1
     CASE (4)
       IVL1 = IVL1 - 1
       IJOBVL = 'V'
     CASE (5)
       IVR1 = IVR1 - 1
       IJOBVR = 'V' 
     CASE(:-1,6:)
       CALL UESTOP(SRNAMT)
   END SELECT
   IF (LSAME(IJOBVR, 'V')) THEN
     IF (LSAME(IJOBVL,'V')) THEN
       CALL LA_GEEV(A(1:IA1, 1:IA2), WR(1:IWR), WI(1: IWI), &
&        VL(1: IVL1, 1:IVL2), VR(1: IVR1, 1: IVR2), INFO)
     ELSE
       CALL LA_GEEV(A(1:IA1, 1:IA2), WR(1:IWR), WI(1: IWI), &
&        VR=VR(1: IVR1, 1: IVR2), INFO=INFO)
     END IF
   ELSE
     IF (LSAME(IJOBVL,'V')) THEN
       CALL LA_GEEV(A(1:IA1, 1:IA2), WR(1:IWR), WI(1: IWI), &
&        VL(1: IVL1, 1:IVL2),INFO = INFO)
     ELSE
       CALL LA_GEEV(A(1:IA1, 1:IA2), WR(1:IWR), WI(1: IWI), &
&        INFO = INFO)
     END IF                                         
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_SGEEV
 
      

SUBROUTINE LA_TEST_SSYGVX(ITYPE, JOBZ, RANGE, UPLO, N, A, LDA, B,&
     &  LDB, VL, VU, IL, IU, ABSTOL, M, W, Z, LDZ, WORK, LWORK, IWORK, &
     &  IFAIL, INFO )
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark
!     August 20, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
!      USE LA_AUXMOD, ONLY: ERINFO
      USE F95_LAPACK, ONLY: LA_SYGVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      CHARACTER(LEN=1), INTENT(INOUT) :: JOBZ, RANGE, UPLO
      INTEGER, INTENT(IN) :: N, IL, IU, LDZ, LDA, LDB, LWORK
      INTEGER, INTENT(OUT) :: M
      INTEGER, INTENT(IN) :: ITYPE
      INTEGER, INTENT(INOUT) :: INFO
      REAL(WP), INTENT(IN) ::  ABSTOL, VL, VU 
!  .. Array Arguments ..
      INTEGER, INTENT(OUT) ::  IWORK(1:5*N)
      REAL(WP), INTENT(INOUT) :: A(1:LDA, 1:N), B(1:LDB, 1:N)
      REAL(WP), INTENT(OUT) :: WORK(1:LWORK), W(1:N), &
&       Z(1:LDZ,1:MAX(1,N))
      INTEGER, INTENT(OUT) :: IFAIL(1:N)
      LOGICAL LSAME
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SYGVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SSYGVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      CHARACTER(LEN=1) :: IJOBZ, IRANGE, IUPLO
      INTEGER :: I, J, IA1, IA2, IB1, IB2, IW, IZ1, IZ2, IITYPE
      INTEGER :: IIL, IIU, IIFAIL
      REAL(WP) :: IVL, IVU, IABSTOL
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IA1 =  N; IA2 = N; IB1 = LDB; IB2=N; IITYPE= ITYPE
      IW = N;  IZ1 = N; IZ2 = N; IIL = IL; IIU = IU; IIFAIL = N
      IJOBZ = JOBZ; IRANGE = RANGE; IUPLO = UPLO
      IVL = VL; IVU = VU; IABSTOL = ABSTOL
      I =  INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE(1)
        IA2 = IA2 - 1
      CASE (2)
        IB2 = IB2 - 1 
      CASE (3)
        IW = IW - 1
      CASE (4)
        IITYPE = 5
      CASE (5)
        IJOBZ = 'T'
        CALL LA_SYGVX(A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W, &
&         IITYPE, IJOBZ, IUPLO, IVL, IVU, IIL, &
&         IIU, M, IFAIL(1:IIFAIL), IABSTOL, INFO )
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
        RETURN
      CASE (6)
        IUPLO = 'T'
      CASE (7)   
        IVU = IVL -1
      CASE (8)
        CALL LA_SYGVX(A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W, &
&         IITYPE, IJOBZ, IUPLO, IVL, IVU, IIL, &
&         IIU, M, IFAIL(1:IIFAIL), IABSTOL, INFO )
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )  
        RETURN
      CASE (9)
        IIU = IIL - 1
      CASE (10)
        IIU = N+1
      CASE (12)
        IIFAIL = IA2 - 1
      CASE (:-1, 11, 13:)
        CALL UESTOP(SRNAMT)
    END SELECT
    IF (LSAME(IJOBZ, 'V')) THEN
      IF (LSAME(IRANGE,'A')) THEN
        CALL LA_SYGVX( A(1:IA1, 1:IA2), B(1:IB1,1:IB2), W,  &
&         IITYPE, IJOBZ, IUPLO, M=M, IFAIL=IFAIL(1:IIFAIL), &
&         ABSTOL=IABSTOL, INFO=INFO )
      ELSE IF (LSAME(IRANGE,'I')) THEN
        CALL LA_SYGVX(A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W,  &
&         IITYPE, IJOBZ, IUPLO, IL=IIL, IU=IIU, M=M, &
&         IFAIL=IFAIL(1:IIFAIL), ABSTOL=IABSTOL, INFO=INFO ) 
      ELSE
        CALL LA_SYGVX( A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W, &
&         IITYPE, IJOBZ, IUPLO, IVL, IVU, M=M, &
&         IFAIL=IFAIL(1:IIFAIL), ABSTOL=IABSTOL, INFO=INFO )
      ENDIF
    ELSE
      IF (LSAME(IRANGE,'A')) THEN
        CALL LA_SYGVX( A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W, IITYPE, &
&         UPLO=IUPLO, M=M, ABSTOL=IABSTOL, INFO=INFO )
      ELSE IF (LSAME(IRANGE,'I')) THEN
        CALL LA_SYGVX( A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W, IITYPE, &
&         UPLO=IUPLO, IL=IIL, IU=IIU, M=M, ABSTOL=IABSTOL, INFO=INFO )  
      ELSE
        CALL LA_SYGVX( A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W, IITYPE, &
&         UPLO=IUPLO, VL=IVL, VU=IVU,  M=M, ABSTOL=IABSTOL,  INFO=INFO )
      END IF
    ENDIF
    IF (N/=0) Z(1:IA1, 1:M) = A(1:IA1, 1:M)
    CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_SSYGVX

      PROGRAM LA_SPPSV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements"
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_PPSV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N, NN, NRHS
!  .. Local Arrays ..
      REAL(WP), ALLOCATABLE :: AP(:) ,B(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SPPSV Example Program Results.'
      N = 5; NRHS = 1
      NN = N*(N+1)/2
      ALLOCATE ( AP(NN), B(N,NRHS) )
 
      OPEN(UNIT=21,FILE='posv.ma',STATUS='UNKNOWN')
      DO I=1,NN
         READ(21,'(F3.0)') AP(I);
      ENDDO;
      CLOSE(21)
  
      WRITE(*,*) 'The array AP :'
      DO I=1,NN
      WRITE(*,'(10(I3,1X,1X),I3,1X)') INT(AP(I)); 
      ENDDO

      OPEN(UNIT=21,FILE='ppsv.mb',STATUS='UNKNOWN')
      DO I=1,N
      DO J=1,NRHS
         READ(21,'(F3.0)') B(I,J);
      ENDDO;
      ENDDO;
      CLOSE(21)
  
      WRITE(*,*) 'The array B :'
      DO I=1,N
       WRITE(*,'(10(I3,1X,1X),I3,1X)') INT(B(I,:)); 
      ENDDO;

      WRITE(*,*) "CALL LA_PPSV( AP, B, 'L' )"
      CALL LA_PPSV(  AP, B, 'L' )
      
      WRITE(*,*)'AP on exit :'
      DO I=1,NN; WRITE(*,"(5(E13.6))") AP(I); 
      ENDDO
     
      WRITE(*,*)'B on exit :'
      DO I=1,N; WRITE(*,"(5(E13.6))") B(I,:); 
      ENDDO
 
      END PROGRAM LA_SPPSV_EXAMPLE

      SUBROUTINE CERRGG( PATH, NUNIT )
*
*  -- LAPACK test routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     April 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  CERRGG tests the error exits for CGGES, CGGESX, CGGEV, CGGEVX,
*  CGGGLM, CGGHRD, CGGLSE, CGGQRF, CGGRQF, CGGSVD, CGGSVP, CHGEQZ,
*  CTGEVC, CTGEXC, CTGSEN, CTGSJA, CTGSNA, and CTGSYL.
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX, LW
      PARAMETER          ( NMAX = 3, LW = 6*NMAX )
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      CHARACTER*2        C2
      INTEGER            DUMMYK, DUMMYL, I, IFST, ILST, INFO, J, M,
     $                   NCYCLE, NT, SDIM
      REAL               ANRM, BNRM, DIF, SCALE, TOLA, TOLB
*     ..
*     .. Local Arrays ..
      LOGICAL            BW( NMAX ), SEL( NMAX )
      INTEGER            IW( LW ), IN(100)
      REAL               LS( NMAX ), R1( NMAX ), R2( NMAX ),
     $                   RCE( NMAX ), RCV( NMAX ), RS( NMAX ), RW( LW )
      COMPLEX            A( NMAX, NMAX ), ALPHA( NMAX ),
     $                   B( NMAX, NMAX ), BETA( NMAX ), Q( NMAX, NMAX ),
     $                   TAU( NMAX ), U( NMAX, NMAX ), V( NMAX, NMAX ),
     $                   W( LW ), Z( NMAX, NMAX )
*     ..
*     .. External Functions ..
      LOGICAL            CLCTES, CLCTSX, LSAMEN
      EXTERNAL           CLCTES, CLCTSX, LSAMEN
*     ..
*     .. External Subroutines ..
      EXTERNAL           LA_TEST_CGGES, LA_TEST_CGGESX, LA_TEST_CGGEV,
     &                   LA_TEST_CGGEVX, LA_TEST_CGGGLM, CGGHRD,
     $                   LA_TEST_CGGLSE, CGGQRF, CGGRQF, LA_TEST_CGGSVD,
     &                   CGGSVP,
     &                   CHGEQZ, CHKXER, CTGEVC, CTGEXC, CTGSEN, CTGSJA,
     &                   CTGSNA, CTGSYL
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )
*
*     Set the variables to innocuous values.
*
      DO 20 J = 1, NMAX
         SEL( J ) = .TRUE.
         DO 10 I = 1, NMAX
            A( I, J ) = ZERO
            B( I, J ) = ZERO
   10    CONTINUE
   20 CONTINUE
      DO 30 I = 1, NMAX
         A( I, I ) = ONE
         B( I, I ) = ONE
   30 CONTINUE
      OK = .TRUE.
      TOLA = 1.0E0
      TOLB = 1.0E0
      IFST = 1
      ILST = 1
      NT = 0
*
*     Test error exits for the GG path.
*
      IF( LSAMEN( 2, C2, 'GG' ) ) THEN
*
*        CGGHRD
*
         SRNAMT = 'CGGHRD'
         INFOT = 1
         CALL CGGHRD( '/', 'N', 0, 1, 0, A, 1, B, 1, Q, 1, Z, 1, INFO )
         CALL CHKXER( 'CGGHRD', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CGGHRD( 'N', '/', 0, 1, 0, A, 1, B, 1, Q, 1, Z, 1, INFO )
         CALL CHKXER( 'CGGHRD', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CGGHRD( 'N', 'N', -1, 0, 0, A, 1, B, 1, Q, 1, Z, 1, INFO )
         CALL CHKXER( 'CGGHRD', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CGGHRD( 'N', 'N', 0, 0, 0, A, 1, B, 1, Q, 1, Z, 1, INFO )
         CALL CHKXER( 'CGGHRD', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CGGHRD( 'N', 'N', 0, 1, 1, A, 1, B, 1, Q, 1, Z, 1, INFO )
         CALL CHKXER( 'CGGHRD', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL CGGHRD( 'N', 'N', 2, 1, 1, A, 1, B, 2, Q, 1, Z, 1, INFO )
         CALL CHKXER( 'CGGHRD', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL CGGHRD( 'N', 'N', 2, 1, 1, A, 2, B, 1, Q, 1, Z, 1, INFO )
         CALL CHKXER( 'CGGHRD', INFOT, NOUT, LERR, OK )
         INFOT = 11
         CALL CGGHRD( 'V', 'N', 2, 1, 1, A, 2, B, 2, Q, 1, Z, 1, INFO )
         CALL CHKXER( 'CGGHRD', INFOT, NOUT, LERR, OK )
         INFOT = 13
         CALL CGGHRD( 'N', 'V', 2, 1, 1, A, 2, B, 2, Q, 1, Z, 1, INFO )
         CALL CHKXER( 'CGGHRD', INFOT, NOUT, LERR, OK )
         NT = NT + 9
*
*        CHGEQZ
*
         SRNAMT = 'CHGEQZ'
         INFOT = 1
         CALL CHGEQZ( '/', 'N', 'N', 0, 1, 0, A, 1, B, 1, ALPHA, BETA,
     $                Q, 1, Z, 1, W, 1, RW, INFO )
         CALL CHKXER( 'CHGEQZ', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CHGEQZ( 'E', '/', 'N', 0, 1, 0, A, 1, B, 1, ALPHA, BETA,
     $                Q, 1, Z, 1, W, 1, RW, INFO )
         CALL CHKXER( 'CHGEQZ', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CHGEQZ( 'E', 'N', '/', 0, 1, 0, A, 1, B, 1, ALPHA, BETA,
     $                Q, 1, Z, 1, W, 1, RW, INFO )
         CALL CHKXER( 'CHGEQZ', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CHGEQZ( 'E', 'N', 'N', -1, 0, 0, A, 1, B, 1, ALPHA, BETA,
     $                Q, 1, Z, 1, W, 1, RW, INFO )
         CALL CHKXER( 'CHGEQZ', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CHGEQZ( 'E', 'N', 'N', 0, 0, 0, A, 1, B, 1, ALPHA, BETA,
     $                Q, 1, Z, 1, W, 1, RW, INFO )
         CALL CHKXER( 'CHGEQZ', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CHGEQZ( 'E', 'N', 'N', 0, 1, 1, A, 1, B, 1, ALPHA, BETA,
     $                Q, 1, Z, 1, W, 1, RW, INFO )
         CALL CHKXER( 'CHGEQZ', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL CHGEQZ( 'E', 'N', 'N', 2, 1, 1, A, 1, B, 2, ALPHA, BETA,
     $                Q, 1, Z, 1, W, 1, RW, INFO )
         CALL CHKXER( 'CHGEQZ', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CHGEQZ( 'E', 'N', 'N', 2, 1, 1, A, 2, B, 1, ALPHA, BETA,
     $                Q, 1, Z, 1, W, 1, RW, INFO )
         CALL CHKXER( 'CHGEQZ', INFOT, NOUT, LERR, OK )
         INFOT = 14
         CALL CHGEQZ( 'E', 'V', 'N', 2, 1, 1, A, 2, B, 2, ALPHA, BETA,
     $                Q, 1, Z, 1, W, 1, RW, INFO )
         CALL CHKXER( 'CHGEQZ', INFOT, NOUT, LERR, OK )
         INFOT = 16
         CALL CHGEQZ( 'E', 'N', 'V', 2, 1, 1, A, 2, B, 2, ALPHA, BETA,
     $                Q, 1, Z, 1, W, 1, RW, INFO )
         CALL CHKXER( 'CHGEQZ', INFOT, NOUT, LERR, OK )
         NT = NT + 10
*
*        CTGEVC
*
         SRNAMT = 'CTGEVC'
         INFOT = 1
         CALL CTGEVC( '/', 'A', SEL, 0, A, 1, B, 1, Q, 1, Z, 1, 0, M, W,
     $                RW, INFO )
         CALL CHKXER( 'CTGEVC', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CTGEVC( 'R', '/', SEL, 0, A, 1, B, 1, Q, 1, Z, 1, 0, M, W,
     $                RW, INFO )
         CALL CHKXER( 'CTGEVC', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CTGEVC( 'R', 'A', SEL, -1, A, 1, B, 1, Q, 1, Z, 1, 0, M,
     $                W, RW, INFO )
         CALL CHKXER( 'CTGEVC', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CTGEVC( 'R', 'A', SEL, 2, A, 1, B, 2, Q, 1, Z, 2, 0, M, W,
     $                RW, INFO )
         CALL CHKXER( 'CTGEVC', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL CTGEVC( 'R', 'A', SEL, 2, A, 2, B, 1, Q, 1, Z, 2, 0, M, W,
     $                RW, INFO )
         CALL CHKXER( 'CTGEVC', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CTGEVC( 'L', 'A', SEL, 2, A, 2, B, 2, Q, 1, Z, 1, 0, M, W,
     $                RW, INFO )
         CALL CHKXER( 'CTGEVC', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL CTGEVC( 'R', 'A', SEL, 2, A, 2, B, 2, Q, 1, Z, 1, 0, M, W,
     $                RW, INFO )
         CALL CHKXER( 'CTGEVC', INFOT, NOUT, LERR, OK )
         INFOT = 13
         CALL CTGEVC( 'R', 'A', SEL, 2, A, 2, B, 2, Q, 1, Z, 2, 1, M, W,
     $                RW, INFO )
         CALL CHKXER( 'CTGEVC', INFOT, NOUT, LERR, OK )
         NT = NT + 8
*
*     Test error exits for the GSV path.
*
      ELSE IF( LSAMEN( 3, PATH, 'GSV' ) ) THEN
*
*        CGGSVD
*
        SRNAMT = 'CGGSVD'
        DO I = 2, 9
          IN(I) = 1
        END DO
        DO I = 2, 9
          IF ((I /= 5).AND.(I/=6)) THEN
            INFOT = I
            DO J = 1, 1
              INFO = J + 100*I
              CALL LA_TEST_CGGSVD('U', 'V',  'Q', NMAX, NMAX, NMAX,
     &          DUMMYK, DUMMYL, A, NMAX, B, NMAX, R1, R2, U, NMAX, V,
     &          NMAX, Q, NMAX, W, RW, IW, INFO )
              CALL CHKXER( 'CGGSVD', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGGSVD('U', 'V', 'N', NMAX, NMAX, NMAX,
     &          DUMMYK, DUMMYL, A, NMAX, B, NMAX, R1, R2, U, NMAX, V,
     &          NMAX, Q, NMAX, W, RW,  IW, INFO )
              CALL CHKXER( 'CGGSVD', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGGSVD('U', 'N', 'Q', NMAX, NMAX, NMAX,
     &          DUMMYK, DUMMYL, A, NMAX, B, NMAX, R1, R2, U, NMAX, V,
     &          NMAX, Q, NMAX, W, RW,  IW, INFO )
              CALL CHKXER( 'CGGSVD', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGGSVD('U', 'N', 'N', NMAX, NMAX, NMAX,
     &          DUMMYK, DUMMYL, A, NMAX, B, NMAX, R1, R2, U, NMAX, V,
     &          NMAX, Q, NMAX, W, RW, IW, INFO )
              CALL CHKXER( 'CGGSVD', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGGSVD('N', 'V', 'Q', NMAX, NMAX, NMAX,
     &          DUMMYK, DUMMYL, A, NMAX, B, NMAX, R1, R2, U, NMAX, V,
     &          NMAX, Q, NMAX, W, RW, IW, INFO )
              CALL CHKXER( 'CGGSVD', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGGSVD('N', 'V', 'N', NMAX, NMAX, NMAX,
     &          DUMMYK, DUMMYL, A, NMAX, B, NMAX, R1, R2, U, NMAX, V,
     &          NMAX, Q, NMAX, W, RW, IW, INFO )
              CALL CHKXER( 'CGGSVD', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGGSVD('N', 'N', 'Q', NMAX, NMAX, NMAX,
     &          DUMMYK, DUMMYL, A, NMAX, B, NMAX, R1, R2, U, NMAX, V,
     &          NMAX, Q, NMAX, W, RW, IW, INFO )
              CALL CHKXER( 'CGGSVD', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGGSVD('N', 'N', 'N', NMAX, NMAX, NMAX,
     &          DUMMYK, DUMMYL, A, NMAX, B, NMAX, R1, R2, U, NMAX, V,
     &          NMAX, Q, NMAX, W, RW, IW, INFO )
              CALL CHKXER( 'CGGSVD', INFOT, NOUT, LERR, OK )
            END DO
          ENDIF
        END DO

*
*        CGGSVP
*
         SRNAMT = 'CGGSVP'
         INFOT = 1
         CALL CGGSVP( '/', 'N', 'N', 0, 0, 0, A, 1, B, 1, TOLA, TOLB,
     $                DUMMYK, DUMMYL, U, 1, V, 1, Q, 1, IW, RW, TAU, W,
     $                INFO )
         CALL CHKXER( 'CGGSVP', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CGGSVP( 'N', '/', 'N', 0, 0, 0, A, 1, B, 1, TOLA, TOLB,
     $                DUMMYK, DUMMYL, U, 1, V, 1, Q, 1, IW, RW, TAU, W,
     $                INFO )
         CALL CHKXER( 'CGGSVP', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CGGSVP( 'N', 'N', '/', 0, 0, 0, A, 1, B, 1, TOLA, TOLB,
     $                DUMMYK, DUMMYL, U, 1, V, 1, Q, 1, IW, RW, TAU, W,
     $                INFO )
         CALL CHKXER( 'CGGSVP', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CGGSVP( 'N', 'N', 'N', -1, 0, 0, A, 1, B, 1, TOLA, TOLB,
     $                DUMMYK, DUMMYL, U, 1, V, 1, Q, 1, IW, RW, TAU, W,
     $                INFO )
         CALL CHKXER( 'CGGSVP', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CGGSVP( 'N', 'N', 'N', 0, -1, 0, A, 1, B, 1, TOLA, TOLB,
     $                DUMMYK, DUMMYL, U, 1, V, 1, Q, 1, IW, RW, TAU, W,
     $                INFO )
         CALL CHKXER( 'CGGSVP', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CGGSVP( 'N', 'N', 'N', 0, 0, -1, A, 1, B, 1, TOLA, TOLB,
     $                DUMMYK, DUMMYL, U, 1, V, 1, Q, 1, IW, RW, TAU, W,
     $                INFO )
         CALL CHKXER( 'CGGSVP', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL CGGSVP( 'N', 'N', 'N', 0, 0, 0, A, 0, B, 1, TOLA, TOLB,
     $                DUMMYK, DUMMYL, U, 1, V, 1, Q, 1, IW, RW, TAU, W,
     $                INFO )
         CALL CHKXER( 'CGGSVP', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CGGSVP( 'N', 'N', 'N', 0, 0, 0, A, 1, B, 0, TOLA, TOLB,
     $                DUMMYK, DUMMYL, U, 1, V, 1, Q, 1, IW, RW, TAU, W,
     $                INFO )
         CALL CHKXER( 'CGGSVP', INFOT, NOUT, LERR, OK )
         INFOT = 16
         CALL CGGSVP( 'U', 'N', 'N', 0, 0, 0, A, 1, B, 1, TOLA, TOLB,
     $                DUMMYK, DUMMYL, U, 0, V, 1, Q, 1, IW, RW, TAU, W,
     $                INFO )
         CALL CHKXER( 'CGGSVP', INFOT, NOUT, LERR, OK )
         INFOT = 18
         CALL CGGSVP( 'N', 'V', 'N', 0, 0, 0, A, 1, B, 1, TOLA, TOLB,
     $                DUMMYK, DUMMYL, U, 1, V, 0, Q, 1, IW, RW, TAU, W,
     $                INFO )
         CALL CHKXER( 'CGGSVP', INFOT, NOUT, LERR, OK )
         INFOT = 20
         CALL CGGSVP( 'N', 'N', 'Q', 0, 0, 0, A, 1, B, 1, TOLA, TOLB,
     $                DUMMYK, DUMMYL, U, 1, V, 1, Q, 0, IW, RW, TAU, W,
     $                INFO )
         CALL CHKXER( 'CGGSVP', INFOT, NOUT, LERR, OK )
         NT = NT + 11
*
*        CTGSJA
*
         SRNAMT = 'CTGSJA'
         INFOT = 1
         CALL CTGSJA( '/', 'N', 'N', 0, 0, 0, DUMMYK, DUMMYL, A, 1, B,
     $                1, TOLA, TOLB, R1, R2, U, 1, V, 1, Q, 1, W,
     $                NCYCLE, INFO )
         CALL CHKXER( 'CTGSJA', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CTGSJA( 'N', '/', 'N', 0, 0, 0, DUMMYK, DUMMYL, A, 1, B,
     $                1, TOLA, TOLB, R1, R2, U, 1, V, 1, Q, 1, W,
     $                NCYCLE, INFO )
         CALL CHKXER( 'CTGSJA', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CTGSJA( 'N', 'N', '/', 0, 0, 0, DUMMYK, DUMMYL, A, 1, B,
     $                1, TOLA, TOLB, R1, R2, U, 1, V, 1, Q, 1, W,
     $                NCYCLE, INFO )
         CALL CHKXER( 'CTGSJA', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CTGSJA( 'N', 'N', 'N', -1, 0, 0, DUMMYK, DUMMYL, A, 1, B,
     $                1, TOLA, TOLB, R1, R2, U, 1, V, 1, Q, 1, W,
     $                NCYCLE, INFO )
         CALL CHKXER( 'CTGSJA', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CTGSJA( 'N', 'N', 'N', 0, -1, 0, DUMMYK, DUMMYL, A, 1, B,
     $                1, TOLA, TOLB, R1, R2, U, 1, V, 1, Q, 1, W,
     $                NCYCLE, INFO )
         CALL CHKXER( 'CTGSJA', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CTGSJA( 'N', 'N', 'N', 0, 0, -1, DUMMYK, DUMMYL, A, 1, B,
     $                1, TOLA, TOLB, R1, R2, U, 1, V, 1, Q, 1, W,
     $                NCYCLE, INFO )
         CALL CHKXER( 'CTGSJA', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CTGSJA( 'N', 'N', 'N', 0, 0, 0, DUMMYK, DUMMYL, A, 0, B,
     $                1, TOLA, TOLB, R1, R2, U, 1, V, 1, Q, 1, W,
     $                NCYCLE, INFO )
         CALL CHKXER( 'CTGSJA', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL CTGSJA( 'N', 'N', 'N', 0, 0, 0, DUMMYK, DUMMYL, A, 1, B,
     $                0, TOLA, TOLB, R1, R2, U, 1, V, 1, Q, 1, W,
     $                NCYCLE, INFO )
         CALL CHKXER( 'CTGSJA', INFOT, NOUT, LERR, OK )
         INFOT = 18
         CALL CTGSJA( 'U', 'N', 'N', 0, 0, 0, DUMMYK, DUMMYL, A, 1, B,
     $                1, TOLA, TOLB, R1, R2, U, 0, V, 1, Q, 1, W,
     $                NCYCLE, INFO )
         CALL CHKXER( 'CTGSJA', INFOT, NOUT, LERR, OK )
         INFOT = 20
         CALL CTGSJA( 'N', 'V', 'N', 0, 0, 0, DUMMYK, DUMMYL, A, 1, B,
     $                1, TOLA, TOLB, R1, R2, U, 1, V, 0, Q, 1, W,
     $                NCYCLE, INFO )
         CALL CHKXER( 'CTGSJA', INFOT, NOUT, LERR, OK )
         INFOT = 22
         CALL CTGSJA( 'N', 'N', 'Q', 0, 0, 0, DUMMYK, DUMMYL, A, 1, B,
     $                1, TOLA, TOLB, R1, R2, U, 1, V, 1, Q, 0, W,
     $                NCYCLE, INFO )
         CALL CHKXER( 'CTGSJA', INFOT, NOUT, LERR, OK )
         NT = NT + 11
*
*     Test error exits for the GLM path.
*
      ELSE IF( LSAMEN( 3, PATH, 'GLM' ) ) THEN
*
*        CGGGLM
*
        SRNAMT = 'CGGGLM'
        DO I = 2, 5
          IN(I) = 1
        END DO
        DO I = 2, 5
          INFOT = I
          DO J = 1, 1
            INFO = J + 100*I
            CALL LA_TEST_CGGGLM( NMAX, NMAX, NMAX, A, NMAX, B, NMAX,
     &        TAU, ALPHA, BETA, W, LW, INFO)
            CALL CHKXER( 'CGGGLM', INFOT, NOUT, LERR, OK )
          END DO
        END DO
        NT = NT + 8
*
*     Test error exits for the LSE path.
*
      ELSE IF( LSAMEN( 3, PATH, 'LSE' ) ) THEN
*
*        CGGLSE
*
        SRNAMT = 'CGGLSE'
        DO I = 2, 5
          IN(I) = 1
        END DO
        DO I = 2, 5
          INFOT = I
          DO J = 1, 1
            INFO = J + 100*I
            CALL LA_TEST_CGGLSE( NMAX, NMAX, NMAX, A, NMAX, B, NMAX,
     &        TAU, ALPHA, BETA, W, LW, INFO) 
            CALL CHKXER( 'CGGLSE', INFOT, NOUT, LERR, OK )
          END DO
        END DO 
        NT = NT + 8
*
*     Test error exits for the GQR path.
*
      ELSE IF( LSAMEN( 3, PATH, 'GQR' ) ) THEN
*
*        CGGQRF
*
         SRNAMT = 'CGGQRF'
         INFOT = 1
         CALL CGGQRF( -1, 0, 0, A, 1, ALPHA, B, 1, BETA, W, LW, INFO )
         CALL CHKXER( 'CGGQRF', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CGGQRF( 0, -1, 0, A, 1, ALPHA, B, 1, BETA, W, LW, INFO )
         CALL CHKXER( 'CGGQRF', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CGGQRF( 0, 0, -1, A, 1, ALPHA, B, 1, BETA, W, LW, INFO )
         CALL CHKXER( 'CGGQRF', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CGGQRF( 0, 0, 0, A, 0, ALPHA, B, 1, BETA, W, LW, INFO )
         CALL CHKXER( 'CGGQRF', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL CGGQRF( 0, 0, 0, A, 1, ALPHA, B, 0, BETA, W, LW, INFO )
         CALL CHKXER( 'CGGQRF', INFOT, NOUT, LERR, OK )
         INFOT = 11
         CALL CGGQRF( 1, 1, 2, A, 1, ALPHA, B, 1, BETA, W, 1, INFO )
         CALL CHKXER( 'CGGQRF', INFOT, NOUT, LERR, OK )
         NT = NT + 6
*
*        CGGRQF
*
         SRNAMT = 'CGGRQF'
         INFOT = 1
         CALL CGGRQF( -1, 0, 0, A, 1, ALPHA, B, 1, BETA, W, LW, INFO )
         CALL CHKXER( 'CGGRQF', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CGGRQF( 0, -1, 0, A, 1, ALPHA, B, 1, BETA, W, LW, INFO )
         CALL CHKXER( 'CGGRQF', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CGGRQF( 0, 0, -1, A, 1, ALPHA, B, 1, BETA, W, LW, INFO )
         CALL CHKXER( 'CGGRQF', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CGGRQF( 0, 0, 0, A, 0, ALPHA, B, 1, BETA, W, LW, INFO )
         CALL CHKXER( 'CGGRQF', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL CGGRQF( 0, 0, 0, A, 1, ALPHA, B, 0, BETA, W, LW, INFO )
         CALL CHKXER( 'CGGRQF', INFOT, NOUT, LERR, OK )
         INFOT = 11
         CALL CGGRQF( 1, 1, 2, A, 1, ALPHA, B, 1, BETA, W, 1, INFO )
         CALL CHKXER( 'CGGRQF', INFOT, NOUT, LERR, OK )
         NT = NT + 6
*
*     Test error exits for the CGS, CGV, CGX, and CXV paths.
*
      ELSE IF( LSAMEN( 3, PATH, 'CGS' ) .OR.
     $         LSAMEN( 3, PATH, 'CGV' ) .OR.
     $         LSAMEN( 3, PATH, 'CGX' ) .OR. LSAMEN( 3, PATH, 'CXV' ) )
     $          THEN
*
*        CGGES
*
      SRNAMT = 'CGGES '
      DO I = 1, 6
        IN(I) = 1
      END DO
      DO I = 1, 6
        INFOT = I
        DO J = 1, 1
             INFO = J + 100*I
            CALL LA_TEST_CGGES( 'N', 'N', 'N', CLCTES, 1, A, 1, B, 1,
     &        SDIM, ALPHA,
     &        BETA, Q, 1, U, 1, W, 1, RW, BW, INFO )
            CALL CHKXER( 'CGGES ', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGGES( 'N', 'N', 'S', CLCTES, 1, A, 1, B, 1,
     &        SDIM, ALPHA,
     &        BETA, Q, 1, U, 1, W, 1, RW, BW, INFO )
            CALL CHKXER( 'CGGES ', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGGES( 'N', 'V', 'N', CLCTES, 1, A, 1, B, 1,
     &        SDIM, ALPHA,
     &        BETA, Q, 1, U, 1, W, 1, RW, BW, INFO )
            CALL CHKXER( 'CGGES ', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGGES( 'N', 'V', 'S', CLCTES, 1, A, 1, B, 1,
     &        SDIM, ALPHA,
     &        BETA, Q, 1, U, 1, W, 1, RW, BW, INFO )
            CALL CHKXER( 'CGGES ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
            CALL LA_TEST_CGGES( 'V', 'N', 'N', CLCTES, 1, A, 1, B, 1,
     &        SDIM, ALPHA,
     &        BETA, Q, 1, U, 1, W, 1, RW, BW, INFO )
            CALL CHKXER( 'CGGES ', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGGES( 'V', 'N', 'S', CLCTES, 1, A, 1, B, 1,
     &        SDIM, ALPHA,
     &        BETA, Q, 1, U, 1, W, 1, RW, BW, INFO )
            CALL CHKXER( 'CGGES ', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGGES( 'V', 'V', 'N', CLCTES, 1, A, 1, B, 1,
     &        SDIM, ALPHA,
     &        BETA, Q, 1, U, 1, W, 1, RW, BW, INFO )
            CALL CHKXER( 'CGGES ', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGGES( 'V', 'V', 'S', CLCTES, 1, A, 1, B, 1,
     &        SDIM, ALPHA,
     &        BETA, Q, 1, U, 1, W, 1, RW, BW, INFO )
            CALL CHKXER( 'CGGES ', INFOT, NOUT, LERR, OK )
        ENDDO
      ENDDO
      
         NT = NT + 11
*
*        CGGESX
*
         SRNAMT = 'CGGESX'
         DO I = 1, 6
           IN(I) = 1
         END DO
         DO I = 1, 6
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'N', 'S', CLCTSX, 'N', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'N', 'N', CLCTSX, 'N', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'V', 'S', CLCTSX, 'N', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'V', 'N', CLCTSX, 'N', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'N', 'S', CLCTSX, 'N', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'N', 'N', CLCTSX, 'N', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'V', 'S', CLCTSX, 'N', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'V', 'N', CLCTSX, 'N', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'N', 'S', CLCTSX, 'E', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'N', 'N', CLCTSX, 'E', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'V', 'S', CLCTSX, 'E', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'V', 'N', CLCTSX, 'E', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'N', 'S', CLCTSX, 'E', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'N', 'N', CLCTSX, 'E', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'V', 'S', CLCTSX, 'E', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'V', 'N', CLCTSX, 'E', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'N', 'S', CLCTSX, 'V', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'N', 'N', CLCTSX, 'V', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'V', 'S', CLCTSX, 'V', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'V', 'N', CLCTSX, 'V', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'N', 'S', CLCTSX, 'V', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'N', 'N', CLCTSX, 'V', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'V', 'S', CLCTSX, 'V', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'V', 'N', CLCTSX, 'V', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )
             
             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'N', 'S', CLCTSX, 'B', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'N', 'N', CLCTSX, 'B', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'V', 'S', CLCTSX, 'B', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'N', 'V', 'N', CLCTSX, 'B', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'N', 'S', CLCTSX, 'B', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'N', 'N', CLCTSX, 'B', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'V', 'S', CLCTSX, 'B', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGESX( 'V', 'V', 'N', CLCTSX, 'B', NMAX, A,
     &         NMAX, B, NMAX, SDIM,
     &         ALPHA, BETA, Q, NMAX, U, NMAX, RCE, RCV, W, NMAX, RW, IW,
     &         NMAX, BW, INFO )
             CALL CHKXER( 'CGGESX', INFOT, NOUT, LERR, OK )
           ENDDO
         ENDDO
         NT = NT + 13
*
*        CGGEV
*
         SRNAMT = 'CGGEV '
         DO I = 1, 6
           IN(I) = 1
         END DO
         DO I = 1, 6
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_CGGEV( 'N', 'N', 1, A, 1, B, 1, ALPHA,
     &         BETA, Q, 1, U, 1, W, 1, RW, INFO )
             CALL CHKXER( 'CGGEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGEV( 'V', 'N', 1, A, 1, B, 1, ALPHA,
     &         BETA, Q, 1, U, 1, W, 1, RW, INFO )
             CALL CHKXER( 'CGGEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGEV( 'N', 'V', 1, A, 1, B, 1, ALPHA,
     &         BETA, Q, 1, U, 1, W, 1, RW, INFO )
             CALL CHKXER( 'CGGEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_CGGEV( 'V', 'V', 1, A, 1, B, 1, ALPHA,
     &         BETA, Q, 1, U, 1, W, 1, RW, INFO )
             CALL CHKXER( 'CGGEV ', INFOT, NOUT, LERR, OK )
           ENDDO
         ENDDO     
         NT = NT + 10
*
*        CGGEVX
*
         SRNAMT = 'CGGEVX'
         DO I = 1, 15
           IN(I) = 1
         END DO
         DO I = 1, 15
           IF (I/=8 .AND. I/=9 .AND. I/=12 .AND. I/=13) THEN
             INFOT = I
             DO J = 1, 1
               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'N', 'N', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'N', 'N', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'N', 'N', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'N', 'N', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'N', 'V', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'V', 'N', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'N', 'V', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'N', 'V', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 
               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'N', 'V', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'V', 'N', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'V', 'N', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'V', 'N', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 
               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'V', 'V', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'V', 'V', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'V', 'V', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'N', 'V', 'V', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'N', 'N', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'N', 'N', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'N', 'N', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'N', 'N', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'N', 'V', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'V', 'N', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'N', 'V', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'N', 'V', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 
               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'N', 'V', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'V', 'N', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'V', 'N', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'V', 'N', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 
               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'V', 'V', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'V', 'V', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'V', 'V', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'P', 'V', 'V', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'N', 'N', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'N', 'N', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'N', 'N', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'N', 'N', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'N', 'V', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'V', 'N', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'N', 'V', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'N', 'V', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 
               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'N', 'V', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'V', 'N', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'V', 'N', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'V', 'N', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 
               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'V', 'V', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'V', 'V', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'V', 'V', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'S', 'V', 'V', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'N', 'N', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'N', 'N', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'N', 'N', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'N', 'N', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'N', 'V', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'V', 'N', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'N', 'V', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'N', 'V', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 
               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'N', 'V', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'V', 'N', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'V', 'N', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'V', 'N', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 
               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'V', 'V', 'N', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'V', 'V', 'E', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'V', 'V', 'V', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_CGGEVX( 'B', 'V', 'V', 'B', NMAX, A,
     &           NMAX, B, NMAX, ALPHA, BETA, Q,
     &           NMAX, U, NMAX, NMAX, NMAX, LS, RS, ANRM, BNRM,
     &           RCE, RCV, W, NMAX,
     &           RW, IW, BW, INFO )
               CALL CHKXER( 'CGGEVX', INFOT, NOUT, LERR, OK ) 
             ENDDO
           ENDIF
         ENDDO
         
         NT = NT + 12
*
*        CTGEXC
*
         SRNAMT = 'CTGEXC'
         INFOT = 3
         CALL CTGEXC( .TRUE., .TRUE., -1, A, 1, B, 1, Q, 1, Z, 1, IFST,
     $                ILST, INFO )
         CALL CHKXER( 'CTGEXC', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CTGEXC( .TRUE., .TRUE., 1, A, 0, B, 1, Q, 1, Z, 1, IFST,
     $                ILST, INFO )
         CALL CHKXER( 'CTGEXC', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL CTGEXC( .TRUE., .TRUE., 1, A, 1, B, 0, Q, 1, Z, 1, IFST,
     $                ILST, INFO )
         CALL CHKXER( 'CTGEXC', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL CTGEXC( .FALSE., .TRUE., 1, A, 1, B, 1, Q, 0, Z, 1, IFST,
     $                ILST, INFO )
         CALL CHKXER( 'CTGEXC', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL CTGEXC( .TRUE., .TRUE., 1, A, 1, B, 1, Q, 0, Z, 1, IFST,
     $                ILST, INFO )
         CALL CHKXER( 'CTGEXC', INFOT, NOUT, LERR, OK )
         INFOT = 11
         CALL CTGEXC( .TRUE., .FALSE., 1, A, 1, B, 1, Q, 1, Z, 0, IFST,
     $                ILST, INFO )
         CALL CHKXER( 'CTGEXC', INFOT, NOUT, LERR, OK )
         INFOT = 11
         CALL CTGEXC( .TRUE., .TRUE., 1, A, 1, B, 1, Q, 1, Z, 0, IFST,
     $                ILST, INFO )
         CALL CHKXER( 'CTGEXC', INFOT, NOUT, LERR, OK )
         NT = NT + 7
*
*        CTGSEN
*
         SRNAMT = 'CTGSEN'
         INFOT = 1
         CALL CTGSEN( -1, .TRUE., .TRUE., SEL, 1, A, 1, B, 1, ALPHA,
     $                BETA, Q, 1, Z, 1, M, TOLA, TOLB, RCV, W, 1, IW, 1,
     $                INFO )
         CALL CHKXER( 'CTGSEN', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CTGSEN( 1, .TRUE., .TRUE., SEL, -1, A, 1, B, 1, ALPHA,
     $                BETA, Q, 1, Z, 1, M, TOLA, TOLB, RCV, W, 1, IW, 1,
     $                INFO )
         CALL CHKXER( 'CTGSEN', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL CTGSEN( 1, .TRUE., .TRUE., SEL, 1, A, 0, B, 1, ALPHA,
     $                BETA, Q, 1, Z, 1, M, TOLA, TOLB, RCV, W, 1, IW, 1,
     $                INFO )
         CALL CHKXER( 'CTGSEN', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL CTGSEN( 1, .TRUE., .TRUE., SEL, 1, A, 1, B, 0, ALPHA,
     $                BETA, Q, 1, Z, 1, M, TOLA, TOLB, RCV, W, 1, IW, 1,
     $                INFO )
         CALL CHKXER( 'CTGSEN', INFOT, NOUT, LERR, OK )
         INFOT = 13
         CALL CTGSEN( 1, .TRUE., .TRUE., SEL, 1, A, 1, B, 1, ALPHA,
     $                BETA, Q, 0, Z, 1, M, TOLA, TOLB, RCV, W, 1, IW, 1,
     $                INFO )
         CALL CHKXER( 'CTGSEN', INFOT, NOUT, LERR, OK )
         INFOT = 15
         CALL CTGSEN( 1, .TRUE., .TRUE., SEL, 1, A, 1, B, 1, ALPHA,
     $                BETA, Q, 1, Z, 0, M, TOLA, TOLB, RCV, W, 1, IW, 1,
     $                INFO )
         CALL CHKXER( 'CTGSEN', INFOT, NOUT, LERR, OK )
         INFOT = 21
         CALL CTGSEN( 3, .TRUE., .TRUE., SEL, 1, A, 1, B, 1, ALPHA,
     $                BETA, Q, 1, Z, 1, M, TOLA, TOLB, RCV, W, -5, IW,
     $                1, INFO )
         CALL CHKXER( 'CTGSEN', INFOT, NOUT, LERR, OK )
         INFOT = 23
         CALL CTGSEN( 0, .TRUE., .TRUE., SEL, 1, A, 1, B, 1, ALPHA,
     $                BETA, Q, 1, Z, 1, M, TOLA, TOLB, RCV, W, 20, IW,
     $                0, INFO )
         CALL CHKXER( 'CTGSEN', INFOT, NOUT, LERR, OK )
         INFOT = 23
         CALL CTGSEN( 1, .TRUE., .TRUE., SEL, 1, A, 1, B, 1, ALPHA,
     $                BETA, Q, 1, Z, 1, M, TOLA, TOLB, RCV, W, 20, IW,
     $                0, INFO )
         CALL CHKXER( 'CTGSEN', INFOT, NOUT, LERR, OK )
         INFOT = 23
         CALL CTGSEN( 5, .TRUE., .TRUE., SEL, 1, A, 1, B, 1, ALPHA,
     $                BETA, Q, 1, Z, 1, M, TOLA, TOLB, RCV, W, 20, IW,
     $                1, INFO )
         CALL CHKXER( 'CTGSEN', INFOT, NOUT, LERR, OK )
         NT = NT + 11
*
*        CTGSNA
*
         SRNAMT = 'CTGSNA'
         INFOT = 1
         CALL CTGSNA( '/', 'A', SEL, 1, A, 1, B, 1, Q, 1, U, 1, R1, R2,
     $                1, M, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSNA', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CTGSNA( 'B', '/', SEL, 1, A, 1, B, 1, Q, 1, U, 1, R1, R2,
     $                1, M, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSNA', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CTGSNA( 'B', 'A', SEL, -1, A, 1, B, 1, Q, 1, U, 1, R1, R2,
     $                1, M, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSNA', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CTGSNA( 'B', 'A', SEL, 1, A, 0, B, 1, Q, 1, U, 1, R1, R2,
     $                1, M, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSNA', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL CTGSNA( 'B', 'A', SEL, 1, A, 1, B, 0, Q, 1, U, 1, R1, R2,
     $                1, M, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSNA', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CTGSNA( 'E', 'A', SEL, 1, A, 1, B, 1, Q, 0, U, 1, R1, R2,
     $                1, M, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSNA', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL CTGSNA( 'E', 'A', SEL, 1, A, 1, B, 1, Q, 1, U, 0, R1, R2,
     $                1, M, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSNA', INFOT, NOUT, LERR, OK )
         INFOT = 15
         CALL CTGSNA( 'E', 'A', SEL, 1, A, 1, B, 1, Q, 1, U, 1, R1, R2,
     $                0, M, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSNA', INFOT, NOUT, LERR, OK )
         INFOT = 18
         CALL CTGSNA( 'E', 'A', SEL, 1, A, 1, B, 1, Q, 1, U, 1, R1, R2,
     $                1, M, W, 0, IW, INFO )
         CALL CHKXER( 'CTGSNA', INFOT, NOUT, LERR, OK )
         NT = NT + 9
*
*        CTGSYL
*
         SRNAMT = 'CTGSYL'
         INFOT = 1
         CALL CTGSYL( '/', 0, 1, 1, A, 1, B, 1, Q, 1, U, 1, V, 1, Z, 1,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CTGSYL( 'N', -1, 1, 1, A, 1, B, 1, Q, 1, U, 1, V, 1, Z, 1,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CTGSYL( 'N', 0, 0, 1, A, 1, B, 1, Q, 1, U, 1, V, 1, Z, 1,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CTGSYL( 'N', 0, 1, 0, A, 1, B, 1, Q, 1, U, 1, V, 1, Z, 1,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CTGSYL( 'N', 0, 1, 1, A, 0, B, 1, Q, 1, U, 1, V, 1, Z, 1,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL CTGSYL( 'N', 0, 1, 1, A, 1, B, 0, Q, 1, U, 1, V, 1, Z, 1,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CTGSYL( 'N', 0, 1, 1, A, 1, B, 1, Q, 0, U, 1, V, 1, Z, 1,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL CTGSYL( 'N', 0, 1, 1, A, 1, B, 1, Q, 1, U, 0, V, 1, Z, 1,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         INFOT = 14
         CALL CTGSYL( 'N', 0, 1, 1, A, 1, B, 1, Q, 1, U, 1, V, 0, Z, 1,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         INFOT = 16
         CALL CTGSYL( 'N', 0, 1, 1, A, 1, B, 1, Q, 1, U, 1, V, 1, Z, 0,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         INFOT = 20
         CALL CTGSYL( 'N', 1, 1, 1, A, 1, B, 1, Q, 1, U, 1, V, 1, Z, 1,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         INFOT = 20
         CALL CTGSYL( 'N', 2, 1, 1, A, 1, B, 1, Q, 1, U, 1, V, 1, Z, 1,
     $                SCALE, DIF, W, 1, IW, INFO )
         CALL CHKXER( 'CTGSYL', INFOT, NOUT, LERR, OK )
         NT = NT + 12
      END IF
*
*     Print a summary line.
*
      IF( OK ) THEN
         WRITE( NOUT, FMT = 9999 )PATH, NT
      ELSE
         WRITE( NOUT, FMT = 9998 )PATH
      END IF
*
 9999 FORMAT( 1X, A3, ' routines passed the tests of the error exits (',
     $      I3, ' tests done)' )
 9998 FORMAT( ' *** ', A3, ' routines failed the tests of the error ',
     $      'exits ***' )
*
      RETURN
*
*     End of CERRGG
*
      END

      SUBROUTINE DERRVX( PATH, NUNIT )
*
*  -- LAPACK90 test routine (version 1.1) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*     UNI-C, Denmark
*     April 8, 1999      
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  DERRVX tests the error exits for the DOUBLE PRECISION driver routines
*  for solving linear systems of equations.
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*     .. Local Scalar ..
      CHARACTER*3 PATH1
      SAVE PATH1
      DATA PATH1/'   '/
*     
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX
      PARAMETER          ( NMAX = 4 )
*     ..
*     .. Local Scalars ..
      CHARACTER          EQ
      CHARACTER*2        C2
      CHARACTER*1        CHAR, IEQUED
      INTEGER            I, INFO, J, NRHS
      INTEGER		 KL, KU
      DOUBLE PRECISION   RCOND
*     ..
*     .. Local Arrays ..
      INTEGER            IP( NMAX ), IW( NMAX ), IN( 100 )
      DOUBLE PRECISION   A( NMAX, NMAX ), AF( NMAX, NMAX ), B( NMAX ),
     $                   C( NMAX ), R( NMAX ), R1( NMAX ), R2( NMAX ),
     $                   W( 2*NMAX ), X( NMAX )

*     ..
*     .. External Functions ..
      LOGICAL            LSAMEN
      EXTERNAL           LSAMEN
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHKXER, LA_TEST_DGBSV, DGBSVX, LA_TEST_DGESV,
     $                   LA_TEST_DGESVX, LA_TEST_DGTSV,
     $                   DGTSVX, LA_TEST_DPBSV, LA_TEST_DPBSVX,
     $                   LA_TEST_DPOSV, LA_TEST_DPOSVX, LA_TEST_DPPSV,
     $                   LA_TEST_DPPSVX, LA_TEST_DPTSV, LA_TEST_DPTSVX,
     $                   LA_TEST_DSPSV,
     $                   LA_TEST_DSPSVX, LA_TEST_DSYSV, LA_TEST_DSYSVX
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT, INFOTC
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
      COMMON /LINFO90/ INFOTC
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )

!     .. Data statements ..



*
*     Set the variables to innocuous values.
*
      DO 20 J = 1, NMAX
         DO 10 I = 1, NMAX
            A( I, J ) = 1.D0 / DBLE( I+J )
            AF( I, J ) = 1.D0 / DBLE( I+J )
   10    CONTINUE
         B( J ) = 0.D0
         R1( J ) = 0.D0
         R2( J ) = 0.D0
         W( J ) = 0.D0
         X( J ) = 0.D0
*          
         C( J ) = 0.1D0
         R( J ) = 0.D0
         IP( J ) = J
   20 CONTINUE
      OK = .TRUE.
*
      IF( LSAMEN( 2, C2, 'GE' ) ) THEN
*
*        GESV 
*
         SRNAMT = 'DGESV '
         DO I = 1, 3
            IN(I) = 1
         END DO
         DO I = 1, 3
            INFOT = I
            DO J = 1, IN(I)
               DO NRHS = 1, 2
                  INFO = J + 100*I
                  CALL LA_TEST_DGESV( NMAX, NRHS, A, NMAX, IP, B, NMAX,
     $                 INFO )
                  CALL CHKXER( 'DGESV ', INFOT, NOUT, LERR, OK )
               END DO
            END DO
         END DO
*
*        DGESVX
*
         SRNAMT = 'DGESVX'
         DO I = 1, 12
            IN(I) = 1
         END DO
         IN(3) = 2
         IN(4) = 2
         IN(6) = 4
         IN(8) = 4
         IN(9) = 3
         IN(10) = 3
         DO I = 1, 12
            INFOT = I
            DO J = 1, IN(I)
               DO NRHS = 1, 2
                  INFO = J + 100*I
                  CALL LA_TEST_DGESVX( CHAR, CHAR, NMAX, NRHS, A, NMAX,
     $               AF, NMAX, IP, EQ, R, C, B, NMAX, X, NMAX, RCOND,
     $               R1, R2, W, IW, INFO)
                  CALL CHKXER( 'DGESVX', INFOT, NOUT, LERR, OK )
               END DO
            END DO
         END DO
*
      ELSE IF( LSAMEN( 2, C2, 'GB' ) ) THEN
*
*        DGBSV
*
         SRNAMT = 'DGBSV '
         DO I = 1, 4
           INFOT = I
            DO J = 1, 1
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 KL = (NMAX-1)/3
                 KU = NMAX-2*KL-1
                 CALL LA_TEST_DGBSV( NMAX, KL, KU, NRHS, A, NMAX, IP, B,
     $             NMAX, INFO )
                  CALL CHKXER( 'DGBSV ', INFOT, NOUT, LERR, OK )
               END DO
            END DO
         END DO
*
*        DGBSVX
*
         SRNAMT = 'DGBSVX'
         DO I = 1, 13
           IN(I) = 1
         END DO
         IN(3) = 2
         IN(4) = 2
         IN(5) = 2
         IN(7) = 4
         IN(9) = 4
         IN(10) = 3
         IN(11) = 3
         DO I = 1, 13
            INFOT = I
            DO J = 1, IN(I)
              DO NRHS = 1, 2
                IF (I /= 1) THEN
                INFO = J + 100*I
                IEQUED = 'N'
                  CALL LA_TEST_DGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                  INFO = J + 100*I
                  IEQUED = 'R'
                  CALL LA_TEST_DGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_DGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                 CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )
                 
                INFO = J + 100*I
                IEQUED = 'B'
                  CALL LA_TEST_DGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )
                  
                  INFO = J + 100*I
                  IEQUED = 'N' 
                  CALL LA_TEST_DGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                  INFO = J + 100*I
                  IEQUED = 'R'
                  CALL LA_TEST_DGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                IEQUED = 'C'
                  CALL LA_TEST_DGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                  INFO = J + 100*I
                  IEQUED = 'B'
                  CALL LA_TEST_DGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )
                   
                  INFO = J + 100*I
                  IEQUED = 'N' 
                  CALL LA_TEST_DGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                  INFO = J + 100*I
                  IEQUED = 'R'
                  CALL LA_TEST_DGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                IEQUED = 'C'
                  CALL LA_TEST_DGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                  CALL LA_TEST_DGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'N'
                  CALL LA_TEST_DGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                  INFO = J + 100*I
                  IEQUED = 'R'
                  CALL LA_TEST_DGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                IEQUED = 'C'
                  CALL LA_TEST_DGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                  CALL LA_TEST_DGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )
                  
                  INFO = J + 100*I
                  IEQUED = 'N' 
                  CALL LA_TEST_DGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                  INFO = J + 100*I
                  IEQUED = 'R'
                  CALL LA_TEST_DGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                  CALL LA_TEST_DGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                  CALL LA_TEST_DGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )
                   
                  INFO = J + 100*I
                  IEQUED = 'N' 
                  CALL LA_TEST_DGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                  INFO = J + 100*I
                  IEQUED = 'R'
                  CALL LA_TEST_DGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                IEQUED = 'C'
                  CALL LA_TEST_DGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                  INFO = J + 100*I
                IEQUED = 'B'
                  CALL LA_TEST_DGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'N'
                  CALL LA_TEST_DGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                  INFO = J + 100*I
                  IEQUED = 'R'
                  CALL LA_TEST_DGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                IEQUED = 'C'
                  CALL LA_TEST_DGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                  CALL LA_TEST_DGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )
                  
                  INFO = J + 100*I
                  IEQUED = 'N' 
                  CALL LA_TEST_DGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                  INFO = J + 100*I
                  IEQUED = 'R'
                  CALL LA_TEST_DGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                IEQUED = 'C'
                  CALL LA_TEST_DGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                  CALL LA_TEST_DGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )
                   
                  INFO = J + 100*I
                  IEQUED = 'N' 
                  CALL LA_TEST_DGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                  INFO = J + 100*I
                  IEQUED = 'R'
                  CALL LA_TEST_DGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                IEQUED = 'C'
                  CALL LA_TEST_DGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                  CALL LA_TEST_DGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &              A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &              B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'DGBSVX', INFOT, NOUT, LERR, OK )

                END IF
              ENDDO
            ENDDO
          ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'GT' ) ) THEN
*
*        DGTSV
*
        
        SRNAMT = 'DGTSV '
        DO I = 1, 4
          IF (I/=2)  THEN 
            INFOT = I
            DO J = 1, 1
              DO NRHS = 1, 2
                INFO = J + 100*I
                CALL LA_TEST_DGTSV( NMAX, NRHS, A(1,1), A(1,2),A(1, 3),
     $            B, NMAX, INFO )
                CALL CHKXER( 'DGTSV ', INFOT, NOUT, LERR, OK )
              END DO
            END DO
          END IF
        END DO       

*
*        DGTSVX
*
        SRNAMT = 'DGTSVX'
        DO I = 1, 14
          IF (I/=2)  THEN
            INFOT = I
            DO J = 1, 1
              DO NRHS = 1, 2
                INFO = J + 100*I 
                CALL LA_TEST_DGTSVX( 'N', 'N', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'DGTSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I  
                CALL LA_TEST_DGTSVX( 'F', 'N', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'DGTSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I 
                CALL LA_TEST_DGTSVX( 'N', 'T', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'DGTSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I  
                CALL LA_TEST_DGTSVX( 'F', 'T', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'DGTSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I 
                CALL LA_TEST_DGTSVX( 'N', 'C', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'DGTSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I  
                CALL LA_TEST_DGTSVX( 'F', 'C', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'DGTSVX', INFOT, NOUT, LERR, OK )
                
              ENDDO
            ENDDO
          ENDIF
        ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'PO' ) ) THEN
*
*        DPOSV
*
        SRNAMT = 'DPOSV '
        DO I = 1, 3
          IN(I) = 1
        END DO
        DO I = 1, 3
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_DPOSV( 'U', NMAX, NRHS, A, NMAX, B, NMAX,
     $                 INFO )
              CALL CHKXER( 'DPOSV ', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I 
              CALL LA_TEST_DPOSV( 'L', NMAX, NRHS, A, NMAX, B, NMAX,
     $                 INFO )
              CALL CHKXER( 'DPOSV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO     
*
*        DPOSVX
*
         SRNAMT = 'DPOSVX'
         DO I = 1, 10
           IN(I) = 1
         END DO
         DO I = 1, 10
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'F', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'F', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'F', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'F', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'N', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'N', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'N', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'N', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'E', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'E', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'E', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPOSVX( 'E', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, IW, INFO )
               CALL CHKXER( 'DPOSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'PP' ) ) THEN
*
*        DPPSV
*
         SRNAMT = 'DPPSV '

         DO I = 1, 3
           IN(I) = 1
         END DO
         DO I = 1, 3
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_DPPSV( 'U', NMAX, NRHS, A(1,1), B,
     $                             NMAX, INFO)
               CALL CHKXER( 'DPPSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_DPPSV( 'L', NMAX, NRHS, A(1,1), B,
     $                             NMAX, INFO)
               CALL CHKXER( 'DPPSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO         
*
*        DPPSVX
*
         SRNAMT = 'DPPSVX'
         DO I = 1, 10
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'F', 'U', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'F', 'U', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'F', 'L', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'F', 'L', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'N', 'U', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'N', 'U', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'N', 'L', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'N', 'L', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'E', 'U', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'E', 'U', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'E', 'L', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPPSVX( 'E', 'L', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPPSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'PB' ) ) THEN
*
*        DPBSV
*
         SRNAMT = 'DPBSV '

         DO I = 1, 3
           IN(I) = 1
         END DO
         DO I = 1, 3
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
                CALL LA_TEST_DPBSV( 'U', NMAX, 1, NRHS, A, NMAX,
     $                               B, NMAX, INFO)
               CALL CHKXER( 'DPBSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_DPBSV( 'L', NMAX, 1, NRHS, A, NMAX,
     $                              B, NMAX, INFO)
                CALL CHKXER( 'DPBSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO          

*
*        DPBSVX
*
         SRNAMT = 'DPBSVX'
         DO I = 1, 10
           IN(I) = 1
         END DO
         DO I = 2, 10
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I 
               CALL LA_TEST_DPBSVX( 'F', 'U', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPBSVX( 'F', 'U', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK )  

               INFO = J + 100*I
               CALL LA_TEST_DPBSVX( 'F', 'L', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPBSVX( 'F', 'L', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DPBSVX( 'N', 'U', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DPBSVX( 'N', 'U', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_DPBSVX( 'N', 'L', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPBSVX( 'N', 'L', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPBSVX( 'E', 'U', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DPBSVX( 'E', 'U', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_DPBSVX( 'E', 'L', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPBSVX( 'E', 'L', NMAX, NMAX-1, NMAX, A, 
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, 
     &           R1, R2, W, IW, INFO )
               CALL CHKXER( 'DPBSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO

*
      ELSE IF( LSAMEN( 2, C2, 'PT' ) ) THEN
*
*        DPTSV
*
        SRNAMT = 'DPTSV '
        DO I = 1, 3
          IN(I) = 1
        END DO 
         DO I = 2, 3
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_DPTSV( NMAX, NRHS, A(1,1), A(1,2),
     $                            B, NMAX, INFO )
               CALL CHKXER( 'DPTSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO 
*
*        DPTSVX
*
         SRNAMT = 'DPTSVX'
         DO I = 1, 3
           IN(I) = 1
         END DO
         DO I = 2, 3
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_DPTSVX( 'F', NMAX, NMAX, A( 1, 1 ),
     &           A( 1, 2 ), AF( 1, 1 ), AF( 1, 2 ), B, NMAX, X,
     &           NMAX, RCOND, R1, R2, W, INFO ) 
               CALL CHKXER( 'DPTSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DPTSVX( 'N', NMAX, NMAX, A( 1, 1 ),
     &           A( 1, 2 ), AF( 1, 1 ), AF( 1, 2 ), B, NMAX, X,
     &           NMAX, RCOND, R1, R2, W, INFO ) 
               CALL CHKXER( 'DPTSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'SY' ) ) THEN
*
*        DSYSV
*
         SRNAMT = 'DSYSV '
         DO I = 1, 4
           IN(I) = 1
         END DO   
         DO I = 1, 4
              INFOT = I
             DO J = 1, 1
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_DSYSV('U', NMAX, NRHS, A, NMAX,
     $                               A(1,2), B, NMAX, W, 1 ,INFO )
                 CALL CHKXER( 'DSYSV ', INFOT, NOUT, LERR, OK )
                 INFO = J + 100*I
                 CALL LA_TEST_DSYSV('L', NMAX, NRHS, A, NMAX,
     $                               A(1,2), B, NMAX, W, 1 ,INFO )
                 CALL CHKXER( 'DSYSV ', INFOT, NOUT, LERR, OK ) 
               END DO
             END DO
         END DO         
*
*        DSYSVX
*
         SRNAMT = 'DSYSVX'
         DO I = 1, 9
           IN(I) = 1
         END DO
         DO I = 1, 9
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_DSYSVX( 'N', 'L', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           IW, INFO )
               CALL CHKXER( 'DSYSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYSVX( 'N', 'U', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           IW, INFO )
               CALL CHKXER( 'DSYSVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSYSVX( 'F', 'L', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           IW, INFO )
               CALL CHKXER( 'DSYSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYSVX( 'F', 'U', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           IW, INFO )
               CALL CHKXER( 'DSYSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'SP' ) ) THEN
*
*        DSPSV
*
         SRNAMT = 'DSPSV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_DSPSV( 'U', NMAX, NRHS, A(1,1), A(1,2),
     $                              B, NMAX, INFO)
               CALL CHKXER( 'DSPSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_DSPSV( 'L', NMAX, NRHS, A(1,1), A(1 ,2),
     $                              B, NMAX, INFO)
               CALL CHKXER( 'DSPSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO    
*
*        DSPSVX
*
         SRNAMT = 'DSPSVX'
         DO I = 1, 9
           IN(I) = 1
         END DO
         DO I = 1, 9
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_DSPSVX( 'N', 'U', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'DSPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSPSVX( 'N', 'L', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'DSPSVX', INFOT, NOUT, LERR, OK ) 

               INFO = J + 100*I
               CALL LA_TEST_DSPSVX( 'F', 'U', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'DSPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSPSVX( 'F', 'L', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'DSPSVX', INFOT, NOUT, LERR, OK ) 
             END DO
           END DO
         END DO  

      END IF
*
*     Print a summary line.
*
      IF( PATH1 /= PATH ) THEN
         PATH1 = PATH
         IF( OK ) THEN
            WRITE( NOUT, FMT = 9999 )PATH
         ELSE
            WRITE( NOUT, FMT = 9998 )PATH
         END IF
      END IF
*
 9999 FORMAT( 1X, A3, ' drivers passed the tests of the error exits' )
 9998 FORMAT( ' *** ', A3, ' drivers failed the tests of the error ',
     $      'exits ***' )
*
      RETURN
*
*     End of DERRVX
*
      END

SUBROUTINE SSTEVD_F95( D, E, Z, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: STEVD_F77 => LA_STEVD
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: D(:), E(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_STEV and LA_STEVD compute all eigenvalues and, optionally, all
! eigenvectors of a real symmetric tridiagonal matrix A.
!    LA_STEVD uses a divide and conquer algorithm. If eigenvectors are 
! desired, they can be much faster than LA_STEV for large matrices but
! uses more workspace.
! =========
! 
!      SUBROUTINE LA_STEV / LA_STEVD( D, E, Z=z, INFO=info )
!         REAL(<wp>), INTENT(INOUT) :: D(:), E(:)
!         REAL(<wp>), INTENT(OUT), OPTIONAL :: Z(:,:)
!         INTEGER, INTENT(OUT), OPTIONAL :: INFO
!      where
!         <wp> ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! D    (input/output) REAL array shape (:) with size(D) = n, where n is 
!      the order of A.
!      On entry, the diagonal elements of the matrix A.
!      On exit, the eigenvalues in ascending order.
! E    (input/output) REAL array, shape (:) with size(E) = n.
!      On entry, the n - 1 subdiagonal elements of A in E(1) to E(n-1).
!      E(n) need not be set but is used by the routine.
!      On exit, the contents of E are destroyed.
! Z    Optional (output) REAL square array, shape(:,:) with size(Z,1)=n.
!      The columns of Z contain the orthonormal eigenvectors of A in the
!      order of the eigenvalues.
! INFO Optional (output) INTEGER.
!      = 0: successful exit.
!      < 0: if INFO = -i, the i-th argument had an illegal value.
!      > 0: if INFO = i, then i elements of E did not converge to zero.
!      If INFO is not present and an error occurs, then the program is 
!      terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_STEVD'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBZ
   INTEGER :: N, LD, ISTAT1, S1Z, S2Z, LWORK, LIWORK
   INTEGER :: LINFO, ISTAT
   INTEGER, SAVE :: LWORKN = 0, LIWORKN = 0, LWORKV = 0, LIWORKV = 0
!  .. LOCAL ARRAYS ..
   REAL(WP), TARGET :: LLZ(1,1)
   INTEGER, POINTER :: IWORK(:)
   REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(D); LD = MAX(1,N)
   IF( PRESENT(Z) )THEN; S1Z = SIZE(Z,1); S2Z = SIZE(Z,2); LJOBZ = 'V'
   ELSE; S1Z = 1; S2Z = 1; LJOBZ = 'N'; END IF
!  .. TEST THE ARGUMENTS
    IF( N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE( E ) /= N .AND. N > 0 )THEN; LINFO = -2
   ELSE IF( PRESENT(Z) .AND. ( S1Z /= LD .OR. S2Z /= N ) )THEN; LINFO = -3
   ELSE IF( N > 0 )THEN
!  .. DETERMINE THE WORKSPACE
      IF( LSAME(LJOBZ,'N') )THEN
         LWORK = MAX( 1, LWORKN ); LIWORK = MAX( 1, LIWORKN )
      ELSE
         LWORK = MAX( 1+ 4*N + N**2, LWORKV ) 
         LIWORK = MAX( 3+5*N, LIWORKV )
      END IF
      ALLOCATE(WORK(LWORK), IWORK(LIWORK), STAT=ISTAT)
      IF( ISTAT /= 0 )THEN
         DEALLOCATE( WORK, IWORK, STAT=ISTAT1 )
         IF( LSAME(LJOBZ,'N') )THEN; LWORK = 1; LIWORK = 1
         ELSE
	   LWORK = 1+ 4*N + N**2
	   LIWORK = 3+5*N; END IF
         ALLOCATE(WORK(LWORK), IWORK(LIWORK), STAT=ISTAT)
         IF( ISTAT == 0 ) CALL ERINFO( -200, SRNAME, LINFO )
      END IF
      IF( ISTAT == 0 ) THEN
         IF( PRESENT(Z) )THEN
            CALL STEVD_F77( LJOBZ, N, D, E, Z, S1Z, WORK, LWORK, &
                         IWORK, LIWORK, LINFO )
	 ELSE
	    CALL STEVD_F77( LJOBZ, N, D, E, LLZ, S1Z, WORK, LWORK, &
                         IWORK, LIWORK, LINFO )
	 ENDIF		 
         IF (LINFO == 0 ) THEN
            IF (LSAME(LJOBZ,'N')) THEN
               LWORKN = INT(WORK(1)); LIWORKN = IWORK(1)
            ELSE; LWORKV = INT(WORK(1)); LIWORKV = IWORK(1); END IF
         END IF
      ELSE; LINFO = -100; ENDIF
      DEALLOCATE(WORK,IWORK,STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE SSTEVD_F95

SUBROUTINE SGTSVX1_F95(DL, D, DU, B, X, DLF, DF, DUF, DU2, &
                            IPIV, FACT, TRANS, FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: GTSVX_F77 => LA_GTSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(IN) :: DL(:), D(:), DU(:), B(:)
   INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: IPIV(:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: DLF(:), DF(:), DUF(:), DU2(:)
   REAL(WP), INTENT(OUT) :: X(:)
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GTSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LTRANS
   INTEGER :: LINFO, N, ISTAT, ISTAT1, SIPIV, SDLF, SDF, SDUF, SDU2
   REAL(WP) :: LRCOND, LFERR, LBERR
!  .. LOCAL POINTERS ..
   INTEGER, POINTER :: IWORK(:), LPIV(:)
   REAL(WP),  POINTER :: WORK(:), LDLF(:), LDF(:), LDUF(:), LDU2(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(D)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; END IF
   IF( PRESENT(DLF) )THEN; SDLF = SIZE(DLF); ELSE; SDLF = N-1; END IF
   IF( PRESENT(DF) )THEN; SDF = SIZE(DF); ELSE; SDF = N; END IF
   IF( PRESENT(DUF) )THEN; SDUF = SIZE(DUF); ELSE; SDUF = N-1; END IF
   IF( PRESENT(DU2) )THEN; SDU2 = SIZE(DU2); ELSE; SDU2 = N-2; END IF
   IF(PRESENT(TRANS))THEN; LTRANS = TRANS; ELSE; LTRANS='N'; END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE( DL ) /= N-1 .AND. N/=0 ) THEN; LINFO = -1
   ELSE IF( N < 0 ) THEN; LINFO = -2
   ELSE IF( SIZE( DU ) /= N-1 .AND. N/=0 ) THEN; LINFO = -3
   ELSE IF( SIZE(B) /= N )THEN; LINFO = -4
   ELSE IF( SIZE(X) /= N )THEN; LINFO = -5
   ELSE IF( SDLF /= N-1 .AND. N/=0 ) THEN; LINFO = -6
   ELSE IF( SDF /= N ) THEN; LINFO = -7
   ELSE IF( SDUF /= N-1 .AND. N/=0 ) THEN; LINFO = -8
   ELSE IF( SDU2 /= N-2 .AND. N>1 ) THEN; LINFO = -9
   ELSE IF( SIPIV /= N )THEN; LINFO = -10
   ELSE IF( ( .NOT. ( LSAME(LFACT,'F') .OR. LSAME(LFACT,'N') ) ) .OR. &
       ( LSAME(LFACT,'F') .AND. .NOT.( PRESENT(DF) .AND. PRESENT(IPIV) ) ) )THEN
      LINFO = -11
   ELSE IF( .NOT.( LSAME(LTRANS,'N') .OR.  LSAME(LTRANS,'T') .OR. &
                  LSAME(LTRANS,'C') ) )THEN; LINFO = -12
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(DF) ) THEN
         ALLOCATE( LDLF(N-1),LDF(N),LDUF(N-1),LDU2(N-2), STAT=ISTAT )
      ELSE; LDLF => DLF; LDF => DF; LDUF => DUF; LDU2 => DU2; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(IPIV) )THEN; ALLOCATE( LPIV(N), STAT=ISTAT )
         ELSE; LPIV => IPIV; END IF
      END IF
      IF( ISTAT == 0 ) ALLOCATE( WORK(3*N), IWORK(N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
         CALL GTSVX_F77( LFACT, LTRANS, N, 1, DL, D, DU, LDLF, LDF, LDUF, &
                         LDU2, LPIV, B, N, X, N, LRCOND, LFERR, LBERR, &
                         WORK, IWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(DLF) ) DEALLOCATE( LDLF, LDF, LDUF, LDU2, STAT=ISTAT1 )
      IF( .NOT.PRESENT(IPIV) ) DEALLOCATE( LPIV, STAT=ISTAT1 )
      IF( PRESENT(FERR) ) FERR = LFERR
      IF( PRESENT(BERR) ) BERR = LBERR
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      DEALLOCATE( WORK, IWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE SGTSVX1_F95

      SUBROUTINE DGELSY_F95( A, B, RANK, JPVT, RCOND, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => DP
      USE LA_AUXMOD, ONLY: ERINFO
      USE F77_LAPACK, ONLY: GELSY_F77 => LA_GELSY
!   .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL :: RANK
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(IN), OPTIONAL :: RCOND
!   .. ARRAY ARGUMENTS ..
      INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: JPVT(:)
      REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!     LA_GELSY computes the minimum-norm least squares solution to one 
! or more real or complex linear systems A*x = b using a complete 
! orthogonal factorization of A. Matrix A is rectangular and may be 
! rankdeficient. The vectors b and corresponding solution vectors x are 
! the columns of matrices denoted B and X, respectively.
!     The routine computes a QR factorization of A with column pivoting:
!           A * P = Q * [ R11 R12 ]
!                       [  0  R22 ]
! where R11 is the largest leading submatrix whose estimated condition 
! number is less than 1/RCOND. The order of R11, RANK, is the effective 
! rank of A. R22 is considered to be negligible, and R12 is annihilated 
! by orthogonal (unitary) transformations from the right, yielding the 
! complete orthogonal (unitary) factorization
!           A * P = Q * [ T11  0  ] * Z
! 	              [  0   0  ]
! The minimum-norm least squares solution is then
!           x = P * Z^H [ T11^-1 * Q1^H * b ]
! 	              [        0          ]
! where Q1 consists of the first RANK columns of Q.
! 
! =========
! 
!          SUBROUTINE LA_GELSY( A, B, RANK=rank, &
!                     JPVT= jpvt, RCOND= rcond, INFO= info )
!              <type>(<wp>), INTENT(INOUT) :: A(:,:), <rhs>
!              INTEGER, INTENT(OUT), OPTIONAL :: RANK
!              INTEGER, INTENT(INOUT), OPTIONAL :: JPVT(:)
!              REAL(<wp>), INTENT(IN), OPTIONAL :: RCOND
!              INTEGER, INTENT(OUT), OPTIONAL :: INFO
!          where
!              <type> ::= REAL | COMPLEX
!              <wp>   ::= KIND(1.0) | KIND(1.0D0)
!              <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! A       (input/output) REAL or COMPLEX array, shape (:,:).
!         On entry, the matrix A.
!   	  On exit, A has been overwritten by details of its complete
!         orthogonal factorization.
! B       (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(B,1) = max(size(A,1),size(A,2)) or shape (:) with 
! 	  size(B) = max(size(A,1), size(A,2)).
! 	  On entry, the matrix B.
! 	  On exit, rows 1 to size(A,2) contain the solution matrix X .
! 	  If size(A,1) >= size(A,2) and RANK = size(A,2), the residual
! 	  sum-of-squares for the solution vector in a column of B is 
!   	  given by the sum of squares of elements in rows size(A,2)+1 :
!         size(A,1) of that column.
! RANK    Optional (output) INTEGER.
!         The effective rank of A, i.e., the order of the submatrix R11.
! 	  This is the same as the order of the submatrix T11 in the 
! 	  complete orthogonal factorization of A.
! JPVT    Optional (input/output) INTEGER array, shape (:) with 
!         size(JPVT) = size(A,2).
! 	  On entry, if JPVT(i) /= 0, the i-th column of A is an initial 
! 	  column, otherwise it is a free column.
! 	  Before the QR factorization of A, all initial columns are  
! 	  permuted to the leading positions; only the remaining free 
! 	  columns are moved as a result of column pivoting during the 
! 	  factorization.
! 	  On exit, if JPVT(i) = k, then the i-th column of the matrix 
! 	  product A*P was the k-th column of A.
! RCOND   Optional (input) REAL.
!         RCOND is used to determine the effective rank of A. This is 
! 	  defined as the order of the largest leading triangular 
! 	  submatrix R11 in the QR factorization of A, with pivoting, 
! 	  whose estimated condition number < 1/RCOND.
!         Default value: 10*max(size(A,1),size(A,2))*BEPSILON(1.0_<wp>),
! 	  where <wp> is the working precision.
! INFO    Optional (output) INTEGER.
!         = 0: successful exit
! 	  < 0: if INFO = -i, the i-th argument had an illegal value
! 	  If INFO is not present and an error occurs, then the program 
! 	  is terminated with an error message.
!----------------------------------------------------------------------
!   .. PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GELSY'
!   .. LOCAL SCALARS ..
      INTEGER :: LINFO, ISTAT, ISTAT1, LWORK, N, M, MN, NRHS, LRANK, SJPVT
      REAL(WP) :: LRCOND
!   .. LOCAL POINTERS ..
      INTEGER, POINTER :: LJPVT(:)
      REAL(WP), POINTER :: WORK(:)
      REAL(WP) :: WORKMIN(1)
!   .. INTRINSIC FUNCTIONS ..
      INTRINSIC SIZE, PRESENT, MAX, MIN, EPSILON
!   .. EXECUTABLE STATEMENTS ..
      LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2); NRHS = SIZE(B,2)
      MN = MIN(M,N)
      IF( PRESENT(RCOND) )THEN; LRCOND = RCOND; ELSE
          LRCOND = 100*EPSILON(1.0_WP) ; ENDIF
      IF( PRESENT(JPVT) )THEN; SJPVT = SIZE(JPVT); ELSE; SJPVT = N; ENDIF
!   .. TEST THE ARGUMENTS
      IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
      ELSE IF( SIZE( B, 1 ) /= MAX(1,M,N) .OR. NRHS < 0 ) THEN; LINFO = -2
      ELSE IF( SJPVT /= N ) THEN; LINFO = -4
      ELSE IF( LRCOND <= 0.0_WP ) THEN; LINFO = -5
      ELSE
        IF( PRESENT(JPVT) )THEN; LJPVT => JPVT
        ELSE; ALLOCATE( LJPVT(N), STAT = ISTAT ); LJPVT = 0; END IF
	
	
! .. DETERMINE THE WORKSPACE ..
! .. QUERING THE SIZE OF WORKSPACE ..
          LWORK = -1
          CALL GELSY_F77( M, N, NRHS, A, MAX(1,M), B, MAX(1,M,N), &
     &      LJPVT, LRCOND, LRANK, WORKMIN, LWORK, LINFO )  
          LWORK = WORKMIN(1)
          IF( ISTAT == 0 ) THEN
            ALLOCATE( WORK(LWORK), STAT = ISTAT )
            IF( ISTAT /= 0 ) CALL ERINFO( -200, SRNAME, LINFO )
          END IF

          IF ( ISTAT == 0 ) THEN
            CALL GELSY_F77( M, N, NRHS, A, MAX(1,M), B, MAX(1,M,N), &
     &      LJPVT, LRCOND, LRANK, WORK, LWORK, LINFO )
          ELSE; LINFO = -100; END IF
            IF( PRESENT(RANK) ) RANK = LRANK
            IF( PRESENT(JPVT) ) JPVT = LJPVT
            DEALLOCATE(WORK, STAT = ISTAT1 )
          END IF
          CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
        END SUBROUTINE DGELSY_F95

      SUBROUTINE DGBTRF_F95( A, K, M, IPIV, RCOND, NORM, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => DP
      USE LA_AUXMOD, ONLY: LSAME, ERINFO
      USE F77_LAPACK, ONLY: GBTRF_F77 => LA_GBTRF, LANGB_F77 => LA_LANGB, &
                                          GBCON_F77 => LA_GBCON
!  .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
      INTEGER, INTENT(IN), OPTIONAL :: K, M
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT( OUT ), OPTIONAL :: RCOND
!  .. ARRAY ARGUMENTS ..
      INTEGER, INTENT( OUT ), OPTIONAL, TARGET :: IPIV( : )
      REAL(WP), INTENT( INOUT ) :: A( :, : )
!  .. PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GBTRF'
!  .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: LNORM
      INTEGER :: LINFO, N, LD, ISTAT, ISTAT1, MINMN, LWORK, SIPIV, &
                 LK, KU, LM
      REAL(WP) :: LANORM
!  .. LOCAL POINTERS ..
      INTEGER, POINTER :: LIPIV(:), IWORK(:)
      REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
      INTRINSIC PRESENT, MIN, SIZE, TINY
!  .. EXECUTABLE STATEMENTS ..
      LD = SIZE(A,1); N = SIZE(A,2); LINFO = 0; ISTAT = 0
      IF( PRESENT(K) ) THEN; LK = K; ELSE; LK = (LD-1)/3; ENDIF
      IF( PRESENT(M) ) THEN; LM = M; ELSE; LM = N; ENDIF; MINMN = MIN(LM,N)
      IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = MINMN; ENDIF
      IF ( PRESENT(NORM) ) THEN; LNORM = NORM; ELSE; LNORM = '1'; END IF
!  .. TEST THE ARGUMENTS
      IF( N < 0 .OR. LD < 0 )THEN; LINFO = -1
      ELSE IF( LD - 2*LK -1 < 0 .OR. LK < 0 ) THEN; LINFO = -2
      ELSE IF( LM < 0 )THEN; LINFO = -3
      ELSE IF( SIPIV /= MINMN )THEN; LINFO = -4
      ELSE IF( PRESENT(RCOND) .AND. M /= N )THEN; LINFO = -5
      ELSE IF( ( .NOT.PRESENT(RCOND) .AND. PRESENT(NORM) ) .OR. &
               ( .NOT.LSAME(LNORM,'I') .AND. .NOT.LSAME(LNORM,'O') &
                                       .AND. LNORM /= '1' ) ) THEN; LINFO = -6
      ELSE IF( M > 0 .AND. N > 0 ) THEN
         IF( PRESENT(RCOND) .AND. M == N ) THEN
!        .. COMPUTE THE NORM OF THE MATRIX A
            IF( LNORM == 'I' ) THEN; LWORK = MINMN; ELSE; LWORK = 1; END IF
            ALLOCATE( WORK(LWORK), STAT=ISTAT )
            IF( ISTAT == 0 )THEN
               LANORM = LANGB_F77( LNORM, MINMN, LK, KU, A, LD, WORK )
            ELSE
               LINFO = -100
            END IF
            DEALLOCATE(WORK, STAT=ISTAT1)
         END IF
         IF( LINFO == 0 ) THEN
            IF( PRESENT(IPIV) )THEN; LIPIV => IPIV
            ELSE; ALLOCATE( LIPIV( MINMN ), STAT=ISTAT ); ENDIF
            IF( ISTAT /= 0 )LINFO = -100
         END IF
         IF( LINFO == 0 ) THEN
!           .. COMPUTE THE LU FACTORS OF THE MATRIX A
            CALL GBTRF_F77( LM, N, LK, KU, A, LD, LIPIV, LINFO )
            IF( .NOT. PRESENT(IPIV) )DEALLOCATE( LIPIV, STAT=ISTAT )
            IF( PRESENT(RCOND) ) THEN
!              .. COMPUTE THE RECIPROCAL OF THE CONDITION NUMBER OF A
               IF( LANORM <= TINY(1.0_WP) .OR. M /= N .OR. LINFO /= 0 ) THEN
                  RCOND = 0.0_WP
               ELSE 
                  ALLOCATE(WORK(3*MINMN), IWORK(MINMN), STAT=ISTAT)
                  IF( ISTAT == 0 )THEN
                     CALL GBCON_F77( LNORM, MINMN, LK, KU, A, LD, LIPIV, &
                                     LANORM, RCOND, WORK, IWORK, LINFO )
                  ELSE
                     LINFO = -100
                  END IF
                  DEALLOCATE( WORK, IWORK, STAT=ISTAT1 )
               END IF
            END IF
         END IF
      ELSE IF( PRESENT(RCOND) ) THEN
         IF( M == N )THEN
            RCOND = 1.0_WP
         ELSE
            RCOND = 0.0_WP
         END IF
      END IF
      CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
      END SUBROUTINE DGBTRF_F95

 SUBROUTINE ZSYSV1_F95( A, B, UPLO, IPIV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO, LSAME
    USE F77_LAPACK, ONLY: SYSV_F77 => LA_SYSV, ILAENV_F77 => ILAENV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IPIV(:)
    COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_SYSV'
    CHARACTER(LEN=6), PARAMETER :: BSNAME = 'ZSYTRF'
!   .. LOCAL SCALARS ..
    CHARACTER(LEN=1) :: LUPLO
    INTEGER :: LINFO, ISTAT, ISTAT1, SIPIV, N, LWORK, NB
!   .. LOCAL POINTERS ..
    INTEGER, POINTER :: LPIV(:)
    COMPLEX(WP), POINTER :: WORK(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; N = SIZE(A,1)
    IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
    IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = SIZE(A,1); END IF
!   .. TEST THE ARGUMENTS
    IF( SIZE( A, 2 ) /= N .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B ) /= N ) THEN; LINFO = -2
    ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
    ELSE IF( SIPIV /= N )THEN; LINFO = -4
    ELSE IF ( N > 0 ) THEN
!  .. DETERMINE THE WORKSPACE
      IF( PRESENT(IPIV) )THEN; LPIV => IPIV
      ELSE; ALLOCATE( LPIV(SIZE(A,1)), STAT = ISTAT ); END IF
      IF( ISTAT == 0 )THEN
         NB = ILAENV_F77( 1, BSNAME, LUPLO, N, -1, -1, -1 )
         IF( NB <= 1 .OR. NB >= N ) NB = 1; LWORK = N*NB
         ALLOCATE(WORK(LWORK), STAT=ISTAT)
         IF( ISTAT /= 0 )THEN
            DEALLOCATE(WORK, STAT=ISTAT1); LWORK = 3*N-1
            ALLOCATE(WORK(LWORK), STAT=ISTAT)
            IF( ISTAT /= 0 ) THEN; LINFO = - 100
            ELSE; CALL ERINFO( -200, SRNAME, LINFO ); ENDIF
         ENDIF
         IF ( ISTAT == 0 ) &
!           .. CALL LAPACK77 ROUTINE
            CALL SYSV_F77( LUPLO, N, 1, A, N, LPIV, B, N, WORK, LWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(IPIV) )DEALLOCATE(LPIV, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE ZSYSV1_F95

SUBROUTINE LA_TEST_SGBSV( N, KL, KU, NRHS, AB, LDAB, IPIV, B, LDB, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     March 25, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GBSV
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, NRHS, LDAB, LDB, KL, KU
      INTEGER, INTENT(INOUT) :: INFO
!  .. Array Arguments ..
      INTEGER, INTENT(OUT) :: IPIV(1:N)
      REAL(WP), INTENT(INOUT) :: AB(1:LDAB,1:N), B(1:LDB,1:N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GBSV '
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGBSV '
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IAB1, IAB2, IB1, IB2, IIPIV, ISTAT, K
!  .. Local Arrays ..
      INTEGER, SAVE, POINTER :: IWORK(:)
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IAB1 = LDAB; IAB2 = N; IB1 = N; IB2 = NRHS; IIPIV = N; K = KL
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE(0)
      IF (NRHS == 1) THEN
        CALL LA_GBSV( AB(1:IAB1,1:IAB2), B(1:IB1,1), KL, &
     &    IPIV(1:IIPIV) )
        INFO = INFOTC
      ELSE
        CALL LA_GBSV( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), KL, &
     &    IPIV(1:IIPIV) )
        INFO = INFOTC
      END IF              
      CASE (1)
        IAB1 = 2*K
      CASE (2)
        IB1 = IAB1-1
      CASE(3)
        K = KU
        K= -1
      CASE(4)
        IIPIV = IAB1-1
      CASE(:-1,5:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF( I /= 0  ) THEN
        SELECT CASE (NRHS)
        CASE (2:)
          CALL LA_GBSV( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), K, &
     &                       IPIV(1:IIPIV), INFO )
        CASE(1)
          CALL LA_GBSV( AB(1:IAB1,1:IAB2), B(1:IB1,1), K, &
     &                       IPIV(1:IIPIV),INFO )
        CASE(:-1)
        CALL UESTOP(SRNAMT)
      END SELECT
      END IF
      IF( I == 0 .AND. J == 1 )THEN
        ALLOCATE( IWORK(N), STAT=ISTAT )
        IF(ISTAT == 0 )THEN
          IWORK(1:N) = IPIV(1:N)
        ELSE
          WRITE(*,*)'STOP in ', SRNAMT, 'Memory allocation failed.'
        END IF
      ELSE IF( I == 0 .AND. J == 4 )THEN
        DEALLOCATE( IWORK, STAT=ISTAT )
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_SGBSV
      

SUBROUTINE LA_TEST_CGTSV(N, NRHS, DL, D, DU, B, LDB, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     April 12, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GTSV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, NRHS, LDB
   INTEGER, INTENT(INOUT) :: INFO
!  .. Array Arguments ..
   COMPLEX(WP), INTENT(INOUT) :: B(1:LDB,1:NRHS)
   COMPLEX(WP), INTENT(INOUT) :: DL(1:N-1), D(1:N), DU(1:N-1)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GTSV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_CGTSV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IDU, ID, IDL,IB1, IB2
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IDL = N-1; ID = N; IDU = N-1; IB1 = N; IB2 = NRHS; 
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
      IF ( NRHS == 1 ) THEN
        CALL LA_GTSV( DL(1:IDL), D(1:ID), DU(1:IDU), B(1:IB1, 1))
        INFO = INFOTC
      ELSE
        CALL LA_GTSV( DL(1:IDL), D(1:ID), DU(1:IDU), B(1:IB1,1:IB2) )
        INFO = INFOTC
      END IF
   CASE (1)
      IDL = ID
   CASE(3)
      IDU = ID 
   CASE(4)
      IB1 = ID - 1
   CASE(:-1,2,5:)
      CALL UESTOP(SRNAMT)
   END SELECT
   IF( I /= 0 ) THEN
      SELECT CASE (NRHS)
      CASE (2:)
          CALL LA_GTSV( DL(1:IDL), D(1:ID), DU(1:IDU),&
     &       B(1:IB1, 1:IB2),  INFO)
      CASE(1)
      CALL LA_GTSV( DL(1:IDL), D(1:ID), DU(1:IDU), &
     &      B(1:IB1, 1), INFO )
      CASE(:-1)
         CALL UESTOP(SRNAMT)
      END SELECT
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_CGTSV

      PROGRAM LA_SGELSS_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GELSS, LA_LANGE
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" .
      REAL(WP) ::  R1, R2, R3
      INTEGER :: RANK, I, J, INFO, M, N, NRHS
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:), S(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GELSS Example Program Results'
      M=6; N = 4; NRHS = 3
      WRITE(*,'(5H N = , I4, 9H; NRHS = , I4)') N, NRHS
      ALLOCATE( A(M,N), AA(M,N), B(M,NRHS), BB(M,NRHS), S(N) )

      OPEN(UNIT=21,FILE='gelss.ma',STATUS='UNKNOWN')
      DO I=1,M 
         DO J=1,N
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      OPEN(UNIT=22,FILE='gelss.mb',STATUS='UNKNOWN')
      DO I=1,M 
         DO J=1,NRHS
            READ(22,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(22)
      
      WRITE(*,*)'Matrix A :'
      DO I=1,M;
         WRITE(*,"(24(F9.5))") A(I,:);
      ENDDO
      
      WRITE(*,*)'Matrix B :'
      DO I=1,M; 
         WRITE(*,"(3(F9.5))") B(I,:); 
      ENDDO
     
      WRITE(*,*) 'CALL LA_GELSS( A, B, RANK, S, 0.00001_WP, INFO )'
      CALL LA_GELSS( A, B, RANK, S, 0.00001_WP, INFO=INFO )
      
      WRITE(*,*) ' A on exit : '
      DO I=1,M; 
         WRITE(*,"(4(E14.6))") A(I,:); 
      ENDDO
    
      WRITE(*,*) ' B on exit : '
      DO I=1,M; 
         WRITE(*,"(3(E14.6))") B(I,:); 
      ENDDO
    
      WRITE(*,*) ' S on exit : '
      DO I=1,N; 
         WRITE(*,"(E14.6)") S(I); 
      ENDDO
     
      WRITE(*,*) 'RANK = ', RANK
      WRITE(*,*)'INFO = ',INFO
       
      R1=LA_LANGE(B(N+1:M,1),NORM='F')
      R2=LA_LANGE(B(N+1:M,2),NORM='F')
      R3=LA_LANGE(B(N+1:M,3),NORM='F')
      WRITE(*,*)'The residual r = ',R1,R2,R3
     
      END PROGRAM LA_SGELSS_EXAMPLE

SUBROUTINE CHPEVX_F95( A, W, UPLO, Z, VL, VU, IL, IU, &
                       M, IFAIL, ABSTOL, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: LAMCH_F77 => SLAMCH
   USE F77_LAPACK, ONLY: HPEVX_F77 => LA_HPEVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. CHARACTER ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(IN), OPTIONAL :: IL, IU
   INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
   REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
!  .. ARRAY ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
   COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
   COMPLEX(WP), INTENT(INOUT) :: A(:)
   REAL(WP), INTENT(OUT) :: W(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!      LA_SPEVX / LA_HPEVX compute selected eigenvalues and, optionally,
! the corresponding eigenvectors of a real symmetric/complex hermitian
! matrix A in packed storage. Eigenvalues and eigenvectors can be
! selected by specifying either a range of values or a range of indices
! for the desired eigenvalues.
! 
! =========
! 
!        SUBROUTINE LA_SPEVX / LA_HPEVX( AP, W, UPLO=uplo, Z=z, &
!                 VL=vl, VU=vu, IL=il, IU=iu, M=m, IFAIL=ifail, &
!                 ABSTOL=abstol, INFO=info )
!          <type>(<wp>), INTENT(INOUT) :: AP(:)
!          REAL(<wp>), INTENT(OUT) :: W(:)
!          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!          <type>(<wp>), INTENT(OUT), OPTIONAL :: Z(:,:)
!          REAL(<wp>), INTENT(IN), OPTIONAL :: VL, VU
!          INTEGER, INTENT(IN), OPTIONAL :: IL, IU
!          INTEGER, INTENT(OUT), OPTIONAL :: M
!          INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
!          REAL(<wp>), INTENT(IN), OPTIONAL :: ABSTOL
!          INTEGER, INTENT(OUT), OPTIONAL :: INFO
!        where
!          <type> ::= REAL | COMPLEX
!          <wp> ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
!  AP      (input/output) REAL or COMPLEX array, shape (:) with size(AP)=
!          n*(n+1)/2, where n is the order of A.
!          On entry, the upper or lower triangle of matrix A in packed
!          storage. The elements are stored columnwise as follows:
!          if UPLO = 'U', AP(i+(j-1)*j/2)=A(i,j) for 1<=i<=j<=n;
!          if UPLO = 'L', AP(i+(j-1)*(2*n-j)/2)=A(i,j) for 1<=j<=i<=n.
!          On exit, AP is overwritten by values generated during the
!          reduction of A to a tridiagonal matrix T . If UPLO = 'U', the
!          diagonal and first superdiagonal of T overwrite the correspond-
!          ing diagonals of A. If UPLO = 'L', the diagonal and first
!          subdiagonal of T overwrite the corresponding diagonals of A.
!  W       (output) REAL array, shape (:) with size(W) = n.
!          The eigenvalues in ascending order.
!  UPLO    Optional (input) CHARACTER(LEN=1).
!          = 'U': Upper triangle of A is stored;
!          = 'L': Lower triangle of A is stored.
!          Default value: 'U'.
! Z        Optional (output) REAL or COMPLEX array, shape (:,:) with 
!          size(Z,1) = n and size(Z,2) = M.
!          The first M columns of Z contain the orthonormal eigenvectors of 
! 	   the matrix A corresponding to the selected eigenvalues, with the
! 	   i-th column of Z containing the eigenvector associated with
!          the eigenvalue in W(i) . If an eigenvector fails to converge, 
! 	   then that column of Z contains the latest approximation to the 
!    	   eigenvector, and the index of the eigenvector is returned in 
! 	   IFAIL.
!          Note: The user must ensure that at least M columns are supplied
! 	   in the array Z. When the exact value of M is not known in 
! 	   advance, an upper bound must be used. In all cases M <= n.
! VL,VU    Optional (input) REAL.
!          The lower and upper bounds of the interval to be searched for 
! 	   eigenvalues. VL < VU.
!          Default values: VL = -HUGE(<wp>) and VU = HUGE(<wp>), where 
! 	   <wp> ::= KIND(1.0) | KIND(1.0D0).
!          Note: Neither VL nor VU may be present if IL and/or IU is 
! 	   present.
! IL,IU    Optional (input) INTEGER.
!          The indices of the smallest and largest eigenvalues to be 
!          returned. The IL-th through IU-th
!          eigenvalues will be found. 1<=IL<=IU<=size(A,1).
!          Default values: IL = 1 and IU = size(A,1).
!          Note: Neither IL nor IU may be present if VL and/or VU is 
!          present.
!          Note: All eigenvalues are calculated if none of the arguments
! 	   VL, VU, IL and IU are present.
! M        Optional (output) INTEGER.
!          The total number of eigenvalues found. 0<=M<=size(A,1).
!          Note: If IL and IU are present then M = IU - IL + 1.
! IFAIL    Optional (output) INTEGER array, shape (:) with 
!          size(IFAIL) = n.
!          If INFO = 0, the first M elements of IFAIL are zero.
!          If INFO > 0, then IFAIL contains the indices of the 
! 	   eigenvectors that failed to converge.
!          Note: If Z is present then IFAIL should also be present.
! ABSTOL   Optional (input) REAL.
!          The absolute error tolerance for the eigenvalues. An 
! 	   approximate eigenvalue is accepted as converged when it is
! 	   determined to lie in an interval [a,b] of width less than or
! 	   equal to ABSTOL+EPSILON(1.0_<wp>) * max(|a|,|b|),
!          where <wp> is the working precision. If ABSTOL<=0, then 
! 	   EPSILON(1.0_<wp>)*||T||1 will be used in its place, where
! 	   ||T||1 is the l1 norm of the tridiagonal matrix obtained by 
! 	   reducing A to tridiagonal form. Eigenvalues will be computed 
! 	   most accurately when ABSTOL is set to twice the underflow 
! 	   threshold 2*LA_LAMCH(1.0_<wp>, 'Safe minimum'), not zero.
!          Default value: 0.0_<wp>.
!          Note: If this routine returns with INFO > 0, then some 
! 	   eigenvectors did not converge. Try setting ABSTOL to 
! 	   2*LA_LAMCH(1.0_<wp>, 'Safe minimum').
! INFO     Optional (output) INTEGER.
!          = 0: successful exit.
!          < 0: if INFO = -i, the i-th argument had an illegal value.
!          > 0: if INFO = i, then i eigenvectors failed to converge. Their
! 	   indices are stored in array IFAIL.
!          If INFO is not present and an error occurs, then the program is
! 	   terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_HPEVX'
   CHARACTER(LEN=1) :: LJOBZ, LUPLO, LRANGE
!  .. LOCAL SCALARS ..
   INTEGER :: N, LINFO, LD, LIL, LIU, LM, ISTAT, &
              SIFAIL, S1Z, S2Z, NN
   INTEGER, TARGET :: ISTAT1(1)
   COMPLEX(WP), TARGET :: LLZ(1,1)
   REAL(WP) :: LABSTOL, LVL, LVU
   COMPLEX(WP) :: WW
!  .. LOCAL ARRAYS ..
   INTEGER, POINTER :: IWORK(:), LIFAIL(:)
   COMPLEX(WP), POINTER :: WORK(:)
   REAL(WP), POINTER :: RWORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC HUGE, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; NN = SIZE(A)
   WW = (-1+SQRT(1+8*REAL(NN,WP)))*0.5; N = INT(WW);  LD = MAX(1,N)
   IF( PRESENT(IFAIL) )THEN; SIFAIL = SIZE(IFAIL); ELSE; SIFAIL = N; END IF
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
   IF( PRESENT(VL) )THEN; LVL = VL; ELSE; LVL = -HUGE(LVL); ENDIF
   IF( PRESENT(VU) )THEN; LVU = VU; ELSE; LVU = HUGE(LVU); ENDIF
   IF( PRESENT(IL) )THEN; LIL = IL; ELSE; LIL = 1; ENDIF
   IF( PRESENT(IU) )THEN; LIU = IU; ELSE; LIU = N; ENDIF
   IF( PRESENT(Z) )THEN; S1Z = SIZE(Z,1); S2Z = SIZE(Z,2)
    ELSE; S1Z = 1; S2Z = 1; ENDIF
!  .. TEST THE ARGUMENTS
   IF( NN < 0 .OR. AIMAG(WW) /= 0 .OR. REAL(N,WP) /= REAL(WW) ) THEN; LINFO = -1
   ELSE IF( SIZE( W ) /= N )THEN; LINFO = -2
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
   ELSE IF( PRESENT(Z) .AND. ( S1Z /= LD .OR. S2Z /= N ) )THEN; LINFO = -4
   ELSE IF( LVU < LVL )THEN; LINFO = -5
   ELSE IF( (PRESENT(VL) .OR. PRESENT(VU)) .AND. &
     &      (PRESENT(IL) .OR. PRESENT(IU)) )THEN; LINFO = -6
   ELSE IF(( LIU < LIL .OR. LIL < 1) .AND. N > 0 )THEN; LINFO = -7
   ELSE IF( N < LIU )THEN; LINFO = -8
   ELSE IF( SIFAIL /= N .OR. PRESENT(IFAIL).AND..NOT.PRESENT(Z) )THEN; LINFO = -10
   ELSE IF( N > 0 )THEN
      IF( PRESENT(VL) .OR. PRESENT(VU) )THEN; LRANGE = 'V'; LM = N
      ELSE IF( PRESENT(IL) .OR. PRESENT(IU) )THEN; LRANGE = 'I'; LM = LIU-LIL+1
      ELSE; LRANGE = 'A'; LM = N; END IF
      IF( PRESENT(Z) ) THEN; LJOBZ = 'V'
         IF( PRESENT(IFAIL) )THEN; LIFAIL => IFAIL
         ELSE; ALLOCATE( LIFAIL(N), STAT=ISTAT ); END IF
      ELSE; LJOBZ = 'N'; LIFAIL => ISTAT1; ENDIF
!     .. DETERMINE THE WORKSPACE
      IF( ISTAT == 0 ) THEN
         ALLOCATE(IWORK(MAX(1,5*N)), RWORK(MAX(1,7*N)), WORK(MAX(1,2*N)), STAT=ISTAT)
         IF( ISTAT == 0 )THEN
            IF( PRESENT(ABSTOL) )THEN; LABSTOL = ABSTOL
            ELSE; LABSTOL = 2*LAMCH_F77('Safe minimum'); ENDIF
	    IF (PRESENT (Z)) THEN 
                CALL HPEVX_F77( LJOBZ, LRANGE, LUPLO, N, A, LVL, LVU, &
     &                       LIL, LIU, LABSTOL, LM, W, Z, S1Z, WORK, &
     &                       RWORK, IWORK, LIFAIL, LINFO )
            ELSE
	       CALL HPEVX_F77( LJOBZ, LRANGE, LUPLO, N, A, LVL, LVU, &
     &                       LIL, LIU, LABSTOL, LM, W, LLZ, S1Z, WORK, &
     &                       RWORK, IWORK, LIFAIL, LINFO )
            ENDIF
            IF( PRESENT(M) ) M = LM
            W(LM+1:N) = 0.0_WP
         ELSE; LINFO = -100; END IF
      END IF
      IF( PRESENT(Z) .AND. .NOT.PRESENT(IFAIL) ) DEALLOCATE( LIFAIL, STAT=ISTAT1(1) )
      DEALLOCATE(IWORK, RWORK, WORK, STAT=ISTAT1(1))
   END IF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE CHPEVX_F95

SUBROUTINE CPPSVX_F95(A, B, X, UPLO, AF, FACT, EQUED, S, FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: PPSVX_F77 => LA_PPSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
   CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(INOUT) :: A(:), B(:,:)
   COMPLEX(WP), INTENT(OUT) :: X(:,:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: S(:)
   COMPLEX(WP), INTENT(INOUT), OPTIONAL, TARGET :: AF(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: FERR(:), BERR(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!     LA_PPSVX computes the solution to a linear system of equations 
! A*X = B, where A is real symmetric or complex Hermitian and, in either
! case, positive definite, and where X and B are rectangular matrices or 
! vectors. A is stored in packed format.
!     LA_PPSVX can also optionally equilibrate the system if A is poorly
! scaled, estimate the condition number of (the equilibrated) A, and 
! compute error bounds.
! 
! =========
! 
!       SUBROUTINE LA_PPSVX( AP, B, X, UPLO=uplo, AFP=afp, &
!                  FACT=fact, EQUED=equed, S=s, FERR=ferr, &
!                  BERR=berr, RCOND=rcond, INFO=info )
!           <type>(<wp>), INTENT(INOUT) :: AP(:), <rhs>
!           <type>(<wp>), INTENT(OUT) :: <sol>
!           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!           <type>(<wp>), INTENT(INOUT), OPTIONAL :: AFP(:)
!           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
!           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
!           REAL(<wp>), INTENT(INOUT), OPTIONAL :: S(:)
!           REAL(<wp>), INTENT(OUT), OPTIONAL :: <err>
!           REAL(<wp>), INTENT(OUT), OPTIONAL :: RCOND
!           INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!           <type> ::= REAL | COMPLEX
!           <wp>   ::= KIND(1.0) | KIND(1.0D0)
!           <rhs>  ::= B(:,:) | B(:)
!           <sol>  ::= X(:,:) | X(:)
!           <err>  ::= FERR(:), BERR(:) | FERR, BERR
! 
! Arguments
! =========
! 
! AP      (input/output) REAL or COMPLEX square array, shape (:) with
!         size(AP) = n*(n + 1)=2, where n is a rank of the matrix A.
!         On entry, the upper or lower triangle of matrix A, or its 
!         equilibration, in packed storage. The elements are stored 
! 	  columnwise as follows:
! 	  if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j<=n;
! 	  if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for 1<=j<=i<=n.
!         On exit, if FACT = 'E', then the equilibrated version of A is
! 	  stored in AP; otherwise, AP is unchanged.
! B       (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(B,1) = n or shape (:) with size(B) = n.
!         On entry, the matrix B.
!         On exit, the scaled version of B if the system has been 
!         equilibrated; otherwise, B is unchanged.
! X       (output) REAL or COMPLEX array, shape (:,:) with size(X,1)=n
!         and size(X,2) = size(B,2), or shape (:) with size(X) = n.
!         The solution matrix X .
! UPLO    Optional (input) CHARACTER(LEN=1).
!           = 'U': Upper triangle of A is stored;
!           = 'L': Lower triangle of A is stored.
!         Default value: 'U'.
! AFP     Optional (input or output) REAL or COMPLEX array, shape (:) 
!         with the same size as AP.
!         If FACT = 'F' then AFP is an input argument that contains the
! 	  factor U or L from the Cholesky factorization of (the 
! 	  equilibrated) A, in the same storage format as A, returned by
! 	  a previous call to LA_PPSVX.
!         If FACT 6= 'F' then AFP is an output argument that contains the
!         factor U or L from the Cholesky factorization of (the
!   	  equilibrated) A in the same storage format as A.
! FACT    Optional (input) CHARACTER(LEN=1).
!         Specifies whether the factored form of the matrix A is supplied
! 	  on entry, and, if not, whether A should be equilibrated before
! 	  it is factored.
!           = 'N': The matrix A will be copied to AFP and factored 
! 	         (no equilibration).
!           = 'E': The matrix A will be equilibrated, then copied to AFP 
! 	         and factored.
!           = 'F': AFP contains the factored form of (the equilibrated) A.
!         Default value: 'N'.
! EQUED   Optional (input or output) CHARACTER(LEN=1).
!         Specifies the form of equilibration that was done.
!         EQUED is an input argument if FACT = 'F', otherwise it is an 
!         output argument:
!           = 'N': No equilibration (always true if FACT = 'N').
!           = 'Y': Equilibration, i.e., A has been premultiplied and 
!                postmultiplied by diag(S).
!         Default value: 'N'.
! S       Optional (input or output) REAL array, shape (:) with size(S)
!         = size(A,1).
!         The scaling factors for A.
!         S is an input argument if FACT = 'F' and EQUED = 'Y'.
!         S is an output argument if FACT = 'E' and EQUED = 'Y'.
! FERR    Optional (output) REAL array of shape (:), with size(FERR) = 
!         size(X,2), or REAL scalar.
!         The estimated forward error bound for each solution vector X(j)
! 	  (the j-th column of the solution matrix X). If XTRUE is the
! 	  true solution corresponding to X(j) , FERR(j) is an estimated 
! 	  upper bound for the magnitude of the largest element in 
! 	  (X(j)-XTRUE) divided by the magnitude of the largest element 
! 	  in X(j). The estimate is as reliable as the estimate for RCOND,
! 	  and is almost always a slight overestimate of the true error.
! BERR    Optional (output) REAL array of shape (:), with size(BERR) = 
!         size(X,2), or REAL scalar.
!         The componentwise relative backward error of each solution 
! 	  vector X(j) (i.e., the smallest relative change in any element
! 	  of A or B that makes X(j) an exact solution).
! RCOND   Optional (output) REAL
!         The estimate of the reciprocal condition number of (the 
! 	  equilibrated) A. If RCOND is less than the machine precision, 
! 	  the matrix is singular to working precision. This condition is
!         indicated by a return code of INFO > 0.
! INFO    Optional (output) INTEGER
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: if INFO = i, and i is
!             <= n: the leading minor of order i of (the equilibrated) A
! 	        is not positive definite, so the factorization could 
! 		not be completed and the solution and error bounds 
! 		could not be computed. RCOND= 0 is returned.
!             = n+1: U or L is nonsingular, but RCOND is less than 
! 	        machine precision, so the matrix is singular to
! 		working precision. Nevertheless, the solution and 
! 		error bounds are computed because the computed solution
! 		can be more accurate than the value of RCOND would 
! 		suggest.
!         If INFO is not present and an error occurs, then the program is
! 	  terminated with an error message.
!-----------------------------------------------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_PPSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LUPLO, LEQUED
   INTEGER :: LINFO, NRHS, N, NN, ISTAT, ISTAT1, SAF, SS, SFERR, SBERR
   REAL(WP) :: LRCOND, MVS
   COMPLEX(WP) :: WW
!  .. LOCAL POINTERS ..
   REAL(WP),  POINTER :: RWORK(:), LS(:), LFERR(:), LBERR(:)
   COMPLEX(WP),  POINTER :: WORK(:), LAF( :)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE, MINVAL, TINY, REAL, INT, AIMAG
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; NN = SIZE(A, 1); NRHS = SIZE(B, 2)
   WW = (-1+SQRT(1+8*REAL(NN,WP)))*0.5; N = INT(WW)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(EQUED) .AND. LSAME(LFACT,'F') )THEN; LEQUED = EQUED
   ELSE; LEQUED='N'; END IF
   IF( PRESENT(AF) )THEN; SAF = SIZE(AF); ELSE; SAF = N*(N+1)/2; END IF
   IF( ( PRESENT(S) ) )THEN; SS = SIZE(S); ELSE; SS = N; END IF
   IF( PRESENT(S) .AND. LSAME(LFACT,'F') .AND. LSAME(LEQUED,'Y') ) THEN
       MVS = MINVAL(S); ELSE; MVS = TINY(1.0_WP); ENDIF
   IF( PRESENT(FERR) )THEN; SFERR = SIZE(FERR); ELSE; SFERR = NRHS; END IF
   IF( PRESENT(BERR) )THEN; SBERR = SIZE(BERR); ELSE; SBERR = NRHS; END IF
   IF(PRESENT(UPLO))THEN; LUPLO = UPLO; ELSE; LUPLO='U'; END IF
!  .. TEST THE ARGUMENTS
   IF( NN < 0 .OR. AIMAG(WW) /= 0 .OR. REAL(N,WP) /= REAL(WW) ) THEN; LINFO = -1
   ELSE IF( SIZE(B, 1) /= N .OR. NRHS < 0 )THEN; LINFO = -2
   ELSE IF( SIZE(X, 1) /= N .OR. SIZE(X, 2) /= NRHS )THEN; LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
   ELSE IF( SAF /= N*(N+1)/2 ) THEN; LINFO = -5
   ELSE IF( ( .NOT. ( LSAME(LFACT,'F') .OR. LSAME(LFACT,'N') .OR. &
                    LSAME(LFACT,'E') ) ) .OR. &
      ( LSAME(LFACT,'F') .AND. .NOT.PRESENT(AF) ) )THEN; LINFO = -6
   ELSE IF( .NOT.LSAME(LEQUED,'N') .AND. .NOT.LSAME(LEQUED,'Y') )THEN; LINFO = -7
   ELSE IF( SS /= N .OR. LSAME(LFACT,'F') .AND. LSAME(LEQUED,'Y') &
      .AND. MVS  <= 0.0_WP )THEN; LINFO = -8
   ELSE IF( SFERR /= NRHS )THEN; LINFO = -9
   ELSE IF( SBERR /= NRHS )THEN; LINFO = -10
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(AF) ) THEN; ALLOCATE( LAF(N*(N+1)/2), STAT=ISTAT )
      ELSE; LAF => AF; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(S) )THEN; ALLOCATE( LS(N), STAT=ISTAT )
         ELSE; LS => S; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(FERR) )THEN; ALLOCATE( LFERR(NRHS), STAT=ISTAT )
         ELSE; LFERR => FERR; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(BERR) )THEN; ALLOCATE( LBERR(NRHS), STAT=ISTAT )
         ELSE; LBERR => BERR; END IF
      END IF
      IF( ISTAT == 0 ) ALLOCATE(WORK(2*N), RWORK(N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
         CALL PPSVX_F77( LFACT, LUPLO, N, NRHS, A, LAF, LEQUED, LS, &
                  B, N, X, N, LRCOND, LFERR, LBERR, WORK, RWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(S) ) DEALLOCATE( LS, STAT=ISTAT1 )
      IF( .NOT.PRESENT(AF) ) DEALLOCATE( LAF, STAT=ISTAT1 )
      IF( .NOT.PRESENT(FERR) ) DEALLOCATE( LFERR, STAT=ISTAT1 )
      IF( .NOT.PRESENT(BERR) ) DEALLOCATE( LBERR, STAT=ISTAT1 )
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      IF( PRESENT(EQUED) .AND. .NOT.LSAME(LFACT,'F') ) EQUED=LEQUED
      DEALLOCATE( WORK, RWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE CPPSVX_F95

      PROGRAM LA_SSYGVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SYGVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, M, N
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE :: IFAIL(:)
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:), W(:), Z(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_SYEVX Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), B(N,N), BB(N,N), W(N), IFAIL(N), Z(N,N) )

      OPEN(UNIT=21,FILE='sygv.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=A

      WRITE(*,*)'Matrix A:'
      DO I=1,N; 
         WRITE(*,"(5(I3,1X))") INT(A(I,:)); 
      ENDDO
    
      OPEN(UNIT=21,FILE='sygv.mb',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      BB=B

      WRITE(*,*)'Matrix B:'
      DO I=1,N; 
         WRITE(*,"(5(I3,1X))") INT(B(I,:)); 
      ENDDO
  
      WRITE(*,*) 'CALL LA_SYGVX( A, B, W, 3, VL=-10.0_WP, VU=10.0_WP, M=M, IFAIL=IFAIL )'
      CALL LA_SYGVX(  A, B, W, 3, VL=-10.0_WP, VU=10.0_WP, M=M, IFAIL=IFAIL )
    
      WRITE(*,*)'Matrix B on exit:'
      DO I=1,N; 
         WRITE(*,"(5(F12.7,1X))") B(I,:); 
      ENDDO
        
      WRITE(*,*) 'W on exit : '
      DO I=1,N
      WRITE(*,"(5(F12.7,1X))") W(I)
      ENDDO

      WRITE(*,*) 'M=',M

      WRITE(*,*)'IFAIL = ', IFAIL
        
      WRITE(*,*) 'Z on exit : '
      DO J=1,M
      WRITE(*,"(5(F12.6,1X))") (A(I,J), I = 1,N)
      ENDDO

      END PROGRAM LA_SSYGVX_EXAMPLE

SUBROUTINE LA_TEST_SGGEVX(BALANC, JOBVL, JOBVR, SENSE, N, A, LDA, B, LDB,&
     &  ALPHAR, ALPHAI, BETA, VL, LDVL, VR, LDVR, ILO, IHI, LSCALE, RSCALE,&
     &  ABNRM, BBNRM, RCONDE, RCONDV, WORK, LWORK, IWORK, BWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     SEPTEMBER 5, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GGEVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, LDA, LDB, LDVL, LDVR, LWORK
      INTEGER, INTENT(INOUT) :: INFO
      INTEGER, INTENT(OUT):: ILO, IHI
      CHARACTER*1, INTENT(IN) :: BALANC, JOBVL, JOBVR, SENSE
      REAL(WP), INTENT(OUT) :: ABNRM, BBNRM
!  .. Array Arguments ..
      REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB, 1:N)
      REAL(WP), INTENT(OUT):: WORK(1:LWORK)
      REAL(WP), INTENT(OUT) :: ALPHAR(1:N), ALPHAI(1:N), BETA(1:N), &
     &  VL(1: LDVL, 1:N), VR(1: LDVR, 1:N), LSCALE(1:N), RSCALE(1:N), &
     &  RCONDE(1:N), RCONDV(1:N)
      INTEGER :: IWORK(1: N+6)
      LOGICAL :: BWORK(1:N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GGEVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGGEVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, IB1, IB2, IALPHAI, IALPHAR, IBETA, IVL1, &
     &  IVL2, IVR1, IVR2, ILSCALE, IRSCALE, IRCONDE, IRCONDV
      CHARACTER*1 :: IJOBVL, IJOBVR, IBALANC
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      LOGICAL LSAME
!  .. Executable Statements ..
      IA1 = N; IA2 = N; IJOBVL = JOBVL; IJOBVR = JOBVR; IBALANC = BALANC
      IB1 = N; IB2 = N; IALPHAR = N; IALPHAI = N; IBETA = N
      IVL1 = N; IVL2 = N; IVR1 = N; IVR2 = N; ILSCALE = N; IRSCALE = N
      IRCONDE = N; IRCONDV = N
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE (1)
      IA2 = IA1 - 1
      CASE (2)
      IB1 = IA1 - 1
      CASE (3)
      IALPHAR = IA1 - 1
      CASE (4)
      IALPHAI = IA1 - 1
      CASE (5)
      IBETA  = IA1 - 1
      CASE (6)
      IJOBVL = 'V'
      IVL1 = IA1 - 1
      CASE (7)
      IJOBVR = 'V'
      IVR1 = IA1 - 1
      CASE (8)
      IBALANC = 'T'
      CASE (11)
      ILSCALE = IA2 - 1
      CASE (12)
      IRSCALE = IA2 - 1
      CASE (15)
      IRCONDE = IA2 - 1
      CASE (16)
      IRCONDV = IA2 - 1
      CASE(:-1,9,10,13, 14, 17:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF (LSAME(IJOBVL,'V')) THEN
        IF (LSAME (IJOBVR, 'V')) THEN
          CALL LA_GGEVX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
     &      ALPHAI(1:IALPHAI), BETA(1: IBETA), VL(1:IVL1,1:IVL2), &
     &      VR(1:IVR1,1:IVR2), IBALANC, ILO, IHI, LSCALE(1:ILSCALE), RSCALE(1: IRSCALE), &
     &      ABNRM, BBNRM, RCONDE(1: IRCONDE), RCONDV(1: IRCONDV), INFO)    
        ELSE
          CALL LA_GGEVX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
     &      ALPHAI(1:IALPHAI), BETA(1: IBETA), VL(1:IVL1,1:IVL2), BALANC=IBALANC, &
     &      ILO=ILO, IHI=IHI, LSCALE=LSCALE(1:ILSCALE), RSCALE=RSCALE(1 : IRSCALE), &
     &      ABNRM=ABNRM, BBNRM=BBNRM, RCONDE=RCONDE(1: IRCONDE), &
     &      RCONDV=RCONDV(1 : IRCONDV), INFO = INFO)
        END IF
      ELSE
        IF (LSAME (IJOBVR, 'V')) THEN
          CALL LA_GGEVX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
     &      ALPHAI(1:IALPHAI), BETA(1: IBETA), VR = VR(1:IVR1,1:IVR2), ILO=ILO, IHI=IHI, &
     &      BALANC=IBALANC, LSCALE=LSCALE(1 :ILSCALE), &
     &      RSCALE=RSCALE(1: IRSCALE), ABNRM=ABNRM, BBNRM=BBNRM, RCONDE=RCONDE(1 : IRCONDE), &
     &      RCONDV=RCONDV(1 : IRCONDV), INFO = INFO)
        ELSE
          CALL LA_GGEVX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
     &      ALPHAI(1:IALPHAI), BETA(1: IBETA), BALANC=IBALANC, ILO=ILO, IHI=IHI, &
     &      LSCALE=LSCALE(1  :ILSCALE), RSCALE=RSCALE(1: IRSCALE), ABNRM=ABNRM, &
     &      BBNRM=BBNRM,  RCONDE=RCONDE(1 : IRCONDE), &
     &      RCONDV=RCONDV(1 : IRCONDV), INFO = INFO)
        END IF
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      END SUBROUTINE LA_TEST_SGGEVX
      

SUBROUTINE CHPGVX_F95( AP, BP, W, ITYPE, UPLO, Z, VL, VU, IL, IU, &
     &  M, IFAIL, ABSTOL, INFO )
!  .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => SP
      USE LA_AUXMOD, ONLY: ERINFO, LSAME
      USE F77_LAPACK, ONLY: LAMCH_F77 => SLAMCH
      USE F77_LAPACK, ONLY: HPGVX_F77 => LA_HPGVX
!  .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!  .. CHARACTER ARGUMENTS ..
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!  .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(IN), OPTIONAL :: IL, IU, ITYPE
      INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
      REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
!  .. ARRAY ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
      COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
      COMPLEX(WP), INTENT(INOUT) :: AP(:), BP(:)
      REAL(WP), INTENT(OUT) :: W(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_SPGVX and LA_HPGVX compute selected eigenvalues and, optionally, 
! the corresponding eigenvectors of generalized eigenvalue problems of 
! the form
!       A*z = lambda*B*z, A*B*z = lambda*z, and B*A*z = lambda*z,
! where A and B are real symmetric in the case of LA_SPGVX and complex
! Hermitian in the case of LA_HPGVX. In both cases B is positive
! definite. Eigenvalues and eigenvectors can be selected by specifying
! either a range of values or a range of indices for the desired 
! eigenvalues. Matrices A and B are stored in a packed format.
! 
! =========
! 
!       SUBROUTINE LA_SPGVX / LA_HPGVX( AP, BP, W, ITYPE= itype, &
!             UPLO= uplo, Z= z, VL= vl, VU= vu, IL= il, IU= iu, M= m, &
!             IFAIL= ifail, ABSTOL= abstol, INFO= info )
!         <type>(<wp>), INTENT(INOUT) :: AP(:), BP(:)
!         REAL(<wp>), INTENT(OUT) :: W(:)
!         INTEGER, INTENT(IN), OPTIONAL :: ITYPE
!         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!         <type>(<wp>), INTENT(OUT), OPTIONAL :: Z(:,:)
!         REAL(<wp>), INTENT(IN), OPTIONAL :: VL, VU
!         INTEGER, INTENT(IN), OPTIONAL :: IL, IU
!         INTEGER, INTENT(OUT), OPTIONAL :: M
!         INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
!         REAL(<wp>), INTENT(IN), OPTIONAL :: ABSTOL
!         INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!         <type> ::= REAL | COMPLEX
!         <wp>   ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! AP       (input/output) REAL or COMPLEX array, shape (:) with 
!          size(AP) = n*(n + 1)/2, where n is the order of A and B.
!          On entry, the upper or lower triangle of matrix A in packed
! 	   storage. The elements are stored columnwise as follows:
! 	   if UPLO = 'U', AP(i +(j-1)*j/2) = A(i,j) for 1<=i<=j<=n;
! 	   if UPLO = 'L', AP(i +(j-1)*(2*n-j)/2) = A(i,j) for 1<=j<=i<=n.
!          On exit, the contents of AP are destroyed.
! BP       (input/output) REAL or COMPLEX array, shape (:) with 
!          size(BP) = size(AP).
!          On entry, the upper or lower triangle of matrix B in packed 
! 	   storage. The elements are stored columnwise as follows:
! 	   if UPLO = 'U', BP(i +(j-1)*j/2) = B(i,j) for 1<=i<=j<=n;
! 	   if UPLO = 'L', BP(i +(j-1)*(2*n-j)/2) = B(i,j) for 1<=j<=i<=n.
!          On exit, the triangular factor U or L of the Cholesky 
! 	   factorization B = U^T*U or B = L*L^T, in the same storage 
! 	   format as B.
! W        (output) REAL array, shape (:) with size(W) = n.
!          The eigenvalues in ascending order.
! ITYPE    Optional (input) INTEGER.
!          Specifies the problem type to be solved:
!             = 1: A*z = lambda*B*z
!             = 2: A*B*z = lambda*z
!             = 3: B*A*z = lambda*z
!          Default value: 1.
! UPLO     Optional (input) CHARACTER(LEN=1).
!             = 'U': Upper triangles of A and B are stored;
!             = 'L': Lower triangles of A and B are stored.
!          Default value: 'U'.
! Z        Optional (output) REAL or COMPLEX rectangular array, shape 
!          (:,:) with size(Z,1) = n and size(Z,2) = M.
!          The first M columns of Z contain the orthonormal eigenvectors
! 	   corresponding to the selected eigenvalues, with the i-th 
! 	   column of Z holding the eigenvector associated with the 
! 	   eigenvalue in W(i). The eigenvectors are normalized as 
! 	   follows:
!            if ITYPE = 1 or 2: Z^H * B * Z = I ,
!            if ITYPE = 3: Z^H * B^-1 * Z = I .
!          If an eigenvector fails to converge, then that column of Z
! 	   contains the latest approximation to the eigenvector and the
! 	   index of the eigenvector is returned in IFAIL.
! VL,VU    Optional (input) REAL.
!          The lower and upper bounds of the interval to be searched for
! 	   eigenvalues. VL < VU.
!          Default values: VL = -HUGE(<wp>) and VU = HUGE(<wp>), where 
! 	   <wp> ::= KIND(1.0) | KIND(1.0D0).
!          Note: Neither VL nor VU may be present if IL and/or IU is 
! 	   present.
! IL,IU    Optional (input) INTEGER.
!          The indices of the smallest and largest eigenvalues to be 
! 	   returned. The IL-th through IU-th eigenvalues will be found. 
! 	   1 <= IL <= IU <= size(A,1).
!          Default values: IL = 1 and IU = size(A,1).
!          Note: Neither IL nor IU may be present if VL and/or VU is 
! 	   present.
!          Note: All eigenvalues are calculated if none of the arguments
! 	   VL, VU, IL and IU are present.
! M        Optional (output) INTEGER.
!          The total number of eigenvalues found. 0 <= M <= size(A,1).
!          Note: If IL and IU are present then M = IU - IL + 1.
! IFAIL    Optional (output) INTEGER array, shape (:) with size(IFAIL) =
!          size(A,1).
!          If INFO = 0, the first M elements of IFAIL are zero.
!          If INFO > 0, then IFAIL contains the indices of the 
! 	   eigenvectors that failed to converge.
!          Note: If Z is present then IFAIL should also be present.
! ABSTOL   Optional (input) REAL.
!          The absolute error tolerance for the eigenvalues. An 
! 	   approximate eigenvalue is accepted as converged when it is
! 	   determined to lie in an interval [a,b] of width less than or
! 	   equal to
!              ABSTOL + EPSILON(1.0_<wp>) * max(|a|,|b|),
!          where <wp> is the working precision. If ABSTOL <= 0, then 
! 	   EPSILON(1.0_<wp>) * ||T||1 will be used in its place, where 
! 	   ||T||1 is the l1 norm of the tridiagonal matrix obtained by
! 	   reducing the generalized eigenvalue problem to tridiagonal
! 	   form. Eigenvalues will be computed most accurately when
! 	   ABSTOL is set to twice the underflow threshold 
! 	   2 * LA_LAMCH(1.0_<wp>, 'S'), not zero.
!          Default value: 0.0_<wp>.
!          Note: If this routine returns with 0 < INFO <= n, then some 
! 	   eigenvectors did not converge.
!          Try setting ABSTOL to 2 * LA_LAMCH(1.0_<wp>, 'S').
! INFO     Optional (output) INTEGER.
!          = 0: successful exit.
!          < 0: if INFO = -i, the i-th argument had an illegal value
!          > 0: the algorithm failed to converge or matrix B is not 
! 	     positive definite:
!             <= n: the algorithm failed to converge; if INFO = i, then 
! 	       i eigenvectors failed to converge. Their indices are 
! 	       stored in array IFAIL.
!             > n: if INFO = n + i, for 1 <= i <= n, then the leading
! 	       minor of order i of B is not positive definite. The 
! 	       factorization of B could not be completed and no
!                eigenvalues or eigenvectors were computed.
!          If INFO is not present and an error occurs, then the program
! 	   is terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_HPGVX'
      CHARACTER(LEN=1) :: LJOBZ, LUPLO, LRANGE
!  .. LOCAL SCALARS ..
      INTEGER :: N, LINFO, LIL, LIU, LM, ISTAT, &
     &  SIFAIL, S1Z, S2Z, NN, LITYPE
      INTEGER, TARGET :: ISTAT1(1)
      COMPLEX(WP), TARGET :: LLZ(1,1)
      REAL(WP) :: LABSTOL, LVL, LVU
      COMPLEX(WP) :: WW
!  .. LOCAL ARRAYS ..
      INTEGER, POINTER :: IWORK(:), LIFAIL(:)
      COMPLEX(WP), POINTER :: WORK(:)
      REAL(WP), POINTER :: RWORK(:)
!  .. INTRINSIC FUNCTIONS ..
      INTRINSIC HUGE, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; NN = SIZE(AP)
   WW = (-1+SQRT(1+8*REAL(NN,WP)))*0.5; N = INT(WW)
   IF( PRESENT(ITYPE) )THEN; LITYPE = ITYPE; ELSE; LITYPE = 1; END IF 
   IF( PRESENT(IFAIL) )THEN; SIFAIL = SIZE(IFAIL); ELSE; SIFAIL = N; END IF
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
   IF( PRESENT(VL) )THEN; LVL = VL; ELSE; LVL = -HUGE(LVL); ENDIF
   IF( PRESENT(VU) )THEN; LVU = VU; ELSE; LVU = HUGE(LVU); ENDIF
   IF( PRESENT(IL) )THEN; LIL = IL; ELSE; LIL = 1; ENDIF
   IF( PRESENT(IU) )THEN; LIU = IU; ELSE; LIU = N; ENDIF
   IF( PRESENT(Z) )THEN; S1Z = SIZE(Z,1); S2Z = SIZE(Z,2)
    ELSE; S1Z = 1; S2Z = 1; ENDIF
!  .. TEST THE ARGUMENTS
   IF( PRESENT(VL) .OR. PRESENT(VU) )THEN; LRANGE = 'V'
   ELSE IF( PRESENT(IL) .OR. PRESENT(IU) )THEN; LRANGE = 'I'
   ELSE ; LRANGE = 'A'; END IF                                                 

   IF( NN < 0 .OR. AIMAG(WW) /= 0 .OR. REAL(N,WP) /= REAL(WW) ) THEN; LINFO = -1
   ELSE IF( SIZE(BP) /= SIZE(AP)  )THEN; LINFO = -2 
   ELSE IF( SIZE( W ) /= N )THEN; LINFO = -3
   ELSE IF (LITYPE <1 .OR. LITYPE >3) THEN; LINFO = -4
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -5
   ELSE IF( PRESENT(Z) .AND. ( S1Z /= N .OR. S2Z /= N ) )THEN; LINFO = -6
   ELSE IF( LVU < LVL )THEN; LINFO = -7
   ELSE IF( (PRESENT(VL) .OR. PRESENT(VU)) .AND. &
     &  (PRESENT(IL) .OR. PRESENT(IU)) )THEN; LINFO = -8
   ELSE IF( LSAME(LRANGE,'I') .AND. ( LIU < MIN(N, LIL) .OR. LIU > N ))THEN; LINFO = -9
   ELSE IF( N < LIU )THEN; LINFO = -10
   ELSE IF( SIFAIL /= N .OR. PRESENT(IFAIL).AND..NOT.PRESENT(Z) )THEN; LINFO = -12
   ELSE IF( N > 0 )THEN
      IF( PRESENT(Z) ) THEN; LJOBZ = 'V'
        IF( PRESENT(IFAIL) )THEN; LIFAIL => IFAIL
        ELSE; ALLOCATE( LIFAIL(N), STAT=ISTAT ); END IF
        ELSE; LJOBZ = 'N'; LIFAIL => ISTAT1; ENDIF
!     .. DETERMINE THE WORKSPACE
       IF( ISTAT == 0 ) THEN
	 ALLOCATE(IWORK(MAX(1,5*N)), WORK(MAX(1,8*N)), RWORK(MAX(1,7*N)), STAT=ISTAT)
         IF( ISTAT == 0 )THEN
           IF( PRESENT(ABSTOL) )THEN; LABSTOL = ABSTOL
           ELSE; LABSTOL = 2*LAMCH_F77('Safe minimum'); ENDIF
             IF (PRESENT (Z)) THEN
   	          CALL HPGVX_F77( LITYPE, LJOBZ, LRANGE, LUPLO, N, AP, BP, LVL, &
     &                   LVU, LIL, LIU, LABSTOL, LM, W, Z, S1Z, WORK, RWORK, IWORK, LIFAIL, &
     &                   LINFO )
             ELSE
	          CALL HPGVX_F77( LITYPE, LJOBZ, LRANGE, LUPLO, N, AP, BP, LVL, &
     &                   LVU, LIL, LIU, LABSTOL, LM, W, LLZ, S1Z, WORK, RWORK, IWORK, LIFAIL, &
     &                   LINFO )
             ENDIF
             IF( PRESENT(M) ) M = LM
           ELSE; LINFO = -100; END IF
           END IF
           IF( PRESENT(Z) .AND. .NOT.PRESENT(IFAIL) ) DEALLOCATE( LIFAIL, STAT=ISTAT1(1) )
	   DEALLOCATE(IWORK, WORK, RWORK, STAT=ISTAT1(1))
         END IF
         CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE CHPGVX_F95

      PROGRAM LA_CGEEV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     March, 2000
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GEEV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, INFO, N
      REAL(WP), ALLOCATABLE ::  WR(:), WI(:), VL(:,:), VR(:,:)
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:)
      COMPLEX(WP), ALLOCATABLE :: AA(:,:), W(:), VLC(:,:), VRC(:,:)
!  .. "Intrinsic Functions" ..
!     INTRINSIC  REAL, AIMAG, INT
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GEEV V.A. Barker Program Results'
      N = 3
      ALLOCATE( A(N,N), AA(N,N), W(N), WR(N), WI(N), VL(N,N), VR(N,N), &
                VLC(N,N), VRC(N,N) )

      A(1,1) =  0.0; A(1,2) = 1.0; A(1,3) = 0.0
      A(2,1) = -1.0; A(2,2) = 0.0; A(2,3) = 0.0
      A(3,1) =  0.0; A(3,2) = 0.0; A(3,3) = 1.0

      WRITE(*,*)'Matrix A:'
      DO I=1,N
         WRITE(*,*) A(I,:)
      ENDDO

      WRITE(*,*) "CALL LA_GEEV( A, WR, WI, VL, VR, INFO ) "
      CALL LA_GEEV( A, WR, WI, VL, VR, INFO )
     
      WRITE(*,*) ' INFO = ', INFO

      WRITE(*,*) 'WR on exit : '
      WRITE(*,*) WR(1:N)
   
      WRITE(*,*) 'WI on exit : '
      WRITE(*,*) WI(1:N)

      WRITE(*,*)'Matrix VR:'
      DO I=1,N
         WRITE(*,*) VR(I,:)
      ENDDO

      WRITE(*,*)'Matrix VL:'
      DO I=1,N
         WRITE(*,*) VL(I,:)
      ENDDO
   
      WRITE(*,*)
      WRITE(*,*) ' * EXAMPLE 2 * '

      AA(1,1) =  0.0; AA(1,2) = 1.0; AA(1,3) = 0.0
      AA(2,1) = -1.0; AA(2,2) = 0.0; AA(2,3) = 0.0
      AA(3,1) =  0.0; AA(3,2) = 0.0; AA(3,3) = (0.0,1.0)

      WRITE(*,*)'Matrix AA:'
      DO I=1,N
         WRITE(*,*) AA(I,:)
      ENDDO

      WRITE(*,*) "CALL LA_GEEV( AA, W, VLC, VRC, INFO ) "
      CALL LA_GEEV( AA, W, VLC, VRC, INFO )

      WRITE(*,*) ' INFO = ', INFO

      WRITE(*,*) 'W on exit : '
      WRITE(*,*) W(1:N)

      WRITE(*,*)'Matrix VRC:'
      DO I=1,N
         WRITE(*,*) VRC(I,:)
      ENDDO

      WRITE(*,*)'Matrix VLC:'
      DO I=1,N
         WRITE(*,*) VLC(I,:)
      ENDDO

      END PROGRAM LA_CGEEV_EXAMPLE

      SUBROUTINE CLAGGE_F95( A, KL, KU, D, ISEED, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!     .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE LA_AUXMOD, ONLY: ERINFO
      USE F77_LAPACK, ONLY: LAGGE_F77 => LA_LAGGE
!     .. "Implicit Statement" ..
      IMPLICIT NONE
!     .. "Scalar Arguments" ..
      INTEGER, INTENT(IN), OPTIONAL :: KL, KU
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
!     .. "Array Arguments" ..
      INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: ISEED(4)
      REAL(WP), INTENT(IN), OPTIONAL, TARGET :: D(:)
      COMPLEX(WP), INTENT(OUT) :: A(:,:)
!-----------------------------------------------------------------
!
!  Purpose
!  =======
!
!  LA_LAGGE generates a real general m by n matrix A, by pre- and post-
!  multiplying a real diagonal matrix D with random orthogonal matrices:
!  A = U*D*V. The lower and upper bandwidths may then be reduced to
!  kl and ku by additional orthogonal transformations.
!
!  Arguments
!  =========
!
!  SUBROUTINE LA_LAGGE( A, KL, KU, D, ISEED, INFO )
!     <type>(<wp>), INTENT(OUT) :: A(:,:)
!     INTEGER, INTENT(IN), OPTIONAL :: KL, KU
!     REAL(<wp>), INTENT(IN), OPTIONAL, TARGET :: D(:)
!     INTEGER, INTENT(INOUT), OPTIONAL :: ISEED(4)
!     INTEGER, INTENT(OUT), OPTIONAL :: INFO
!     <type> ::= REAL | COMPLEX
!     <wp>   ::= KIND(1.0) | KIND(1.0D0)
!
!  =====================
!
!  A       (output) REAL array, shape (:,:), SIZE(A,1) == m,
!          SIZE(A,2) == n.
!          The generated m by n matrix A.
!
!  KL      (input) INTEGER
!          The number of nonzero subdiagonals within the band of A.
!          0 <= KL <= M-1.
!
!  KU      (input) INTEGER
!          The number of nonzero superdiagonals within the band of A.
!          0 <= KU <= N-1.
!
!  D       (input) REAL array, dimension (min(M,N))
!          The diagonal elements of the diagonal matrix D.
!
!  ISEED   Optional (input/output) INTEGER array, shape (:),
!          SIZE(ISEED) == 4.
!          On entry, the seed of the random number generator; the array
!          elements must be between 0 and 4095, and ISEED(4) must be
!          odd.
!          On exit, the seed is updated.
!
!  INFO    (output) INTEGER
!          = 0: successful exit
!          < 0: if INFO = -i, the i-th argument had an illegal value
!      If INFO is not present and an error occurs, then the program is
!         terminated with an error message.
!
!  ---------------------------------------------------------------------
!     .. "Parameters" ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_LAGGE'
!     .. "LOCAL Scalars" ..
      INTEGER :: ISTAT, ISTAT1, LDA, LINFO, LKL, LKU, M, MN, N, SD, SISEED
!     .. "Local Arrays" ..
      INTEGER :: LISEED(4)
!     .. "Local Pointers" ..
      REAL(WP), POINTER :: LD(:)
      COMPLEX(WP), POINTER :: WORK(:)
!     .. "Intrinsic Functions" ..
      INTRINSIC SIZE, PRESENT, MAX, MIN
!     .. "Executable Statements" ..
      LINFO = 0; M = SIZE(A,1); N = SIZE(A,2); LDA = MAX(1,M)
      MN = MIN(M,N); ISTAT = 0
      IF( PRESENT(KL) )THEN; LKL = KL; ELSE; LKL = M-1; ENDIF
      IF( PRESENT(KU) )THEN; LKU = KU; ELSE; LKU = M-1; ENDIF
      IF( PRESENT(D) )THEN; SD = SIZE(D); ELSE; SD = MN; ENDIF
      IF( PRESENT(ISEED) )THEN; SISEED = SIZE(ISEED); LISEED = ISEED
      ELSE; SISEED = 4
            LISEED(1) = 15; LISEED(2) = 1926
            LISEED(3) = 16; LISEED(4) = 1931; ENDIF
!     .. "Test the arguments" ..
      IF( M < 0 .OR. N < 0 )THEN; LINFO = -1
      ELSE IF( LKL < 0 .OR. LKL > M-1 )THEN; LINFO = -2
      ELSE IF( LKU < 0 .OR. LKU > N-1 )THEN; LINFO = -3
      ELSE IF( SD /= MN )THEN; LINFO = -4
      ELSE IF( SISEED /= 4 .OR. PRESENT(ISEED) .AND. (                  &
     &   ( LISEED(1) < 0 .OR. LISEED(1) > 4095 ) .OR.                   &
     &   ( LISEED(2) < 0 .OR. LISEED(2) > 4095 ) .OR.                   &
     &   ( LISEED(3) < 0 .OR. LISEED(3) > 4095 ) .OR.                   &
     &   ( LISEED(4) < 0 .OR. LISEED(4) > 4095 ) .OR.                   &
     &   ( MOD( LISEED(4), 2 ) == 0 ) ) )THEN; LINFO = -5
      ELSE
         IF( PRESENT(D) )THEN; LD => D
         ELSE; ALLOCATE( LD( MN ), STAT=ISTAT); ENDIF
         IF( ISTAT == 0 )THEN
            ALLOCATE( WORK( M + N ), STAT=ISTAT )
            IF( ISTAT == 0 )THEN
               IF( .NOT. PRESENT(D) )THEN
                  LD(1:MN-1) = 1.0_WP; LD(MN) = 0.5_WP; ENDIF
               CALL LAGGE_F77( M, N, LKL, LKU, LD, A, LDA, LISEED, WORK, LINFO )
               IF( PRESENT(ISEED) )ISEED = LISEED
            ELSE; LINFO = -100; END IF
            DEALLOCATE( WORK, STAT=ISTAT1 )
         ENDIF
         IF( .NOT. PRESENT(D) )DEALLOCATE( LD, STAT=ISTAT1)
      ENDIF
      CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
      END SUBROUTINE CLAGGE_F95

    SUBROUTINE DGEGV_F95( A, B, ALPHAR, ALPHAI, BETA, VL, VR, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO
   USE F77_LAPACK, ONLY: GEGV_F77 => LA_GEGV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: ALPHAR(:), ALPHAI(:), BETA(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
!-----------------------------------------------------------------
!
! Purpose
! =======
!
!  LA_GEGV computes for a pair of N-by-N complex nonsymmetric
!  matrices A and B, the generalized eigenvalues (alpha, beta),
!  and optionally, the left and/or right generalized eigenvectors
!  (VL and VR).
!  A generalized eigenvalue for a pair of matrices (A,B) is, roughly
!  speaking, a scalar w or a ratio  alpha/beta = w, such that  A - w*B
!  is singular.  It is usually represented as the pair (alpha,beta),
!  as there is a reasonable interpretation for beta=0, and even for
!  both being zero.  A good beginning reference is the book, "Matrix
!  Computations", by G. Golub & C. van Loan (Johns Hopkins U. Press)
!  A right generalized eigenvector corresponding to a generalized
!  eigenvalue  w  for a pair of matrices (A,B) is a vector  r  such
!  that  (A - w B) r = 0 .  A left generalized eigenvector is a vector
!  l such that l**H * (A - w B) = 0, where l**H is the
!  conjugate-transpose of l.
!  Note: this routine performs "full balancing" on A and B -- see
!  "Further Details", below.
!
! =========
!
!   SUBROUTINE LA_GEGV( A, B, <alpha>, BETA, VL, VR, INFO )
!      INTEGER, INTENT(OUT), OPTIONAL :: INFO
!      <type>(<wp>), INTENT(INOUT) :: A(:,:), B(:,:)
!      <type>(<wp>), INTENT(OUT), OPTIONAL :: <alpha'>, BETA(:)
!      <type>(<wp>), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
!   where
!      <type>   ::= REAL | COMPLEX
!      <wp>     ::= KIND(1.0) | KIND(1.0D0)
!      <alpha>  ::= ALPHAR, ALPHAI | ALPHA
!      <alpha'> ::= ALPHAR(:), ALPHAI(:) | ALPHA(:)
!
! Arguments
! =========
!
! A    (input/output) REAL / COMPLEX array, shape (:,:),
!      SIZE(A,1) == SIZE(A,2) == n.
!      On entry, the first of the pair of matrices whose
!      generalized eigenvalues and (optionally) generalized
!      eigenvectors are to be computed.
!      On exit, the contents will have been destroyed.  (For a
!      description of the contents of A on exit, see "Further
!      Details", below.)
!
! B    (input/output) REAL / COMPLEX array, shape (:,:),
!      SIZE(rBA,1) == SIZE(rBA,2) == n.
!      On entry, the second of the pair of matrices whose
!      generalized eigenvalues and (optionally) generalized
!      eigenvectors are to be computed.
!      On exit, the contents will have been destroyed.  (For a
!      description of the contents of B on exit, see "Further
!      Details", below.)
!
! ALPHAR  Only for the real case. Optional (output) REAL array,
! ALPHAI  shape (:), SIZE(ALPHA') == n. ALPHA ::= ALPHAR | ALPHAI
! ALPHA   Only for the complex case. Optional (output) COMPLEX
!         array, shape (:), SIZE(ALPHAI) == n.
! BETA Optional (output) REAL / COMPLEX array, shape (:),
!      SIZE(BETA) == n.
!      On exit, (ALPHAR(j) + ALPHAI(j)*i)/BETA(j), j=1,...,n, will
!      be the generalized eigenvalues.  If ALPHAI(j) is zero, then
!      the j-th eigenvalue is real; if positive, then the j-th and
!      (j+1)-st eigenvalues are a complex conjugate pair, with
!      ALPHAI(j+1) negative.
!      Note: the quotients ALPHAR(j)/BETA(j) and ALPHAI(j)/BETA(j)
!      may easily over- or underflow, and BETA(j) may even be zero.
!      Thus, the user should avoid naively computing the ratio
!      alpha/beta.  However, ALPHAR and ALPHAI will be always less
!      than and usually comparable with norm(A) in magnitude, and
!      BETA always less than and usually comparable with norm(B).
!
! VL   Optional (output) REAL / COMPLEX array, shape (:,:),
!      SIZE(VL,1) == SIZE(VL,2) == n.
!      The left generalized eigenvectors.  (See "Purpose", above.)
!      Real eigenvectors take one column,
!      complex take two columns, the first for the real part and
!      the second for the imaginary part.  Complex eigenvectors
!      correspond to an eigenvalue with positive imaginary part.
!      Each eigenvector will be scaled so the largest component
!      will have abs(real part) + abs(imag. part) = 1, *except*
!      that for eigenvalues with alpha=beta=0, a zero vector will
!      be returned as the corresponding eigenvector.
!
! VR   Optional (output) REAL / COMPLEX array, shape (:,:),
!      SIZE(VR,1) == SIZE(VR,2) == n.
!      The right generalized eigenvectors.  (See "Purpose", above.)
!      Real eigenvectors take one column,
!      complex take two columns, the first for the real part and
!      the second for the imaginary part.  Complex eigenvectors
!      correspond to an eigenvalue with positive imaginary part.
!      Each eigenvector will be scaled so the largest component
!      will have abs(real part) + abs(imag. part) = 1, *except*
!      that for eigenvalues with alpha=beta=0, a zero vector will
!      be returned as the corresponding eigenvector.
!
! INFO (output) INTEGER
!      = 0:  successful exit
!      < 0:  if INFO = -i, the i-th argument had an illegal value.
!      = 1,...,n:
!            The QZ iteration failed.  No eigenvectors have been
!            calculated, but ALPHAR(j), ALPHAI(j), and BETA(j)
!            should be correct for j=INFO+1,...,n.
!      > n:  errors that usually indicate LAPACK problems:
!            =n+1: error return from LA_GGBAL
!            =n+2: error return from LA_GEQRF
!            =n+3: error return from LA_ORMQR
!            =n+4: error return from LA_ORGQR
!            =n+5: error return from LA_GGHRD
!            =n+6: error return from LA_HGEQZ (other than failed
!                                            iteration)
!            =n+7: error return from LA_TGEVC
!            =n+8: error return from LA_GGBAK (computing VL)
!            =n+9: error return from LA_GGBAK (computing VR)
!            =n+10: error return from LA_LASCL (various calls)
!      If INFO is not present and an error occurs, then the program is
!         terminated with an error message.
!
! Further Details
! ===============
!
! Balancing
! ---------
!
! This driver calls SGGBAL to both permute and scale rows and columns
! of A and B.  The permutations PL and PR are chosen so that PL*A*PR
! and PL*B*R will be upper triangular except for the diagonal blocks
! A(i:j,i:j) and B(i:j,i:j), with i and j as close together as
! possible.  The diagonal scaling matrices DL and DR are chosen so
! that the pair  DL*PL*A*PR*DR, DL*PL*B*PR*DR have elements close to
! one (except for the elements that start out zero.)
!
! After the eigenvalues and eigenvectors of the balanced matrices
! have been computed, SGGBAK transforms the eigenvectors back to what
! they would have been (in perfect arithmetic) if they had not been
! balanced.
!
! Contents of A and B on Exit
! -------- -- - --- - -- ----
!
! If any eigenvectors are computed (either VL or VR or both), then on
! exit the arrays A and B will contain the real Schur form[*] of the
! "balanced" versions of A and B. If no eigenvectors are computed,
! then only the diagonal blocks will be correct.
!
! [*] See LA_HGEQZ, LA_GEGS, or read the book "Matrix Computations",
!     by Golub & van Loan, pub. by Johns Hopkins U. Press.
!--------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GEGV'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBVL, LJOBVR
   INTEGER, SAVE :: LWORK = 0
   INTEGER :: N, LINFO, LD, ISTAT, ISTAT1, S1VL, S2VL, S1VR, S2VR, &
              SALPHAR, SALPHAI, SBETA
!  .. LOCAL ARRAYS ..
   REAL(WP), TARGET :: LLVL(1,1), LLVR(1,1)
   REAL(WP), POINTER :: WORK(:), LALPHAR(:), &
                        LALPHAI(:), LBETA(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(A,1); LD = MAX(1,N)
   IF( PRESENT(ALPHAR) )THEN; SALPHAR = SIZE(ALPHAR); ELSE; SALPHAR = N; ENDIF
   IF( PRESENT(ALPHAI) )THEN; SALPHAI = SIZE(ALPHAI); ELSE; SALPHAI = N; ENDIF
   IF( PRESENT(BETA) )THEN; SBETA = SIZE(BETA); ELSE; SBETA = N; ENDIF
   IF( PRESENT(VL) )THEN; S1VL = SIZE(VL,1); S2VL = SIZE(VL,2); LJOBVL = 'V'
   ELSE; S1VL = 1; S2VL = 1; LJOBVL = 'N'; END IF
   IF( PRESENT(VR) )THEN; S1VR = SIZE(VR,1); S2VR = SIZE(VR,2); LJOBVR = 'V'
   ELSE; S1VR = 1; S2VR = 1; LJOBVR = 'N'; END IF
!  .. TEST THE ARGUMENTS
   IF( N < 0 .OR. SIZE(A,2) /= N )THEN; LINFO = -1
   ELSE IF( SIZE(B,1) /= N .OR. SIZE(B,2) /= N )THEN; LINFO = -2
   ELSE IF( SALPHAR /= N )THEN; LINFO = -3
   ELSE IF( SALPHAI /= N )THEN; LINFO = -4
   ELSE IF( SBETA /= N )THEN; LINFO = -5
   ELSE IF( PRESENT(VL) .AND. ( S1VL /= N .OR. S2VL /= N ) )THEN; LINFO = -6
   ELSE IF( PRESENT(VR) .AND. ( S1VR /= N .OR. S2VR /= N ) )THEN; LINFO = -7
   ELSE IF( N > 0 )THEN
      IF( PRESENT(ALPHAR) )THEN; LALPHAR => ALPHAR
      ELSE; ALLOCATE(LALPHAR(N),STAT=ISTAT); ENDIF
      IF( ISTAT == 0 )THEN
         IF( PRESENT(ALPHAI) )THEN; LALPHAI => ALPHAI
         ELSE; ALLOCATE(LALPHAI(N),STAT=ISTAT); ENDIF
      END IF
      IF( ISTAT == 0 )THEN
         IF( PRESENT(BETA) )THEN; LBETA => BETA
         ELSE; ALLOCATE(LBETA(N),STAT=ISTAT); ENDIF
      END IF
      IF( ISTAT == 0 )THEN
         LWORK = MAX( 1, 8*N, LWORK); ALLOCATE(WORK(LWORK), STAT=ISTAT)
         IF( ISTAT /= 0 )THEN; DEALLOCATE(WORK,STAT=ISTAT1)
            LWORK = MAX( 1, 8*N ); ALLOCATE(WORK(LWORK), STAT=ISTAT)
            IF( ISTAT == 0) CALL ERINFO( -200, SRNAME, LINFO )
         END IF
      END IF
      IF( ISTAT == 0 ) THEN
         IF( PRESENT(VL) )THEN
          IF( PRESENT(VR) )THEN
            CALL GEGV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, LALPHAR, LALPHAI, &
                        LBETA, VL, S1VL, VR, S1VR, WORK, LWORK, LINFO )
	   ELSE
	     CALL GEGV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, LALPHAR, LALPHAI, &
                        LBETA, VL, S1VL, LLVR, S1VR, WORK, LWORK, LINFO )
	   ENDIF
	  ELSE
	   IF( PRESENT(VR) )THEN
	     CALL GEGV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, LALPHAR, LALPHAI, &
                        LBETA, LLVL, S1VL, VR, S1VR, WORK, LWORK, LINFO )
	   ELSE
	      CALL GEGV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, LALPHAR, LALPHAI, &
                        LBETA, LLVL, S1VL, LLVR, S1VR, WORK, LWORK, LINFO )
	  ENDIF
	 ENDIF 
         IF( LINFO == 0 ) LWORK = INT(WORK(1)+1)
      ELSE; LINFO = -100; ENDIF
      DEALLOCATE(WORK, STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE DGEGV_F95

SUBROUTINE SSBEVD_F95( A, W, UPLO, Z, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: SBEVD_F77 => LA_SBEVD
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. CHARACTER ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:)
   REAL(WP), INTENT(OUT) :: W(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!     LA_SBEV and LA_SBEVD compute all eigenvalues and, optionally, all
! eigenvectors of a real symmetric matrix A in band form.
!     LA_HBEV and LA_HBEVD compute all eigenvalues and, optionally, all
! eigenvectors of a complex Hermitian matrix A in band form.
!     LA_SBEVD and LA_HBEVD use a divide and conquer algorithm. They are
! much faster than LA_SBEV and LA_HBEV for large matrices but use more 
! workspace.
! 
! =========
! 
!         SUBROUTINE LA_SBEV / LA_HBEV / LA_SBEVD /
!                  LA_HBEVD( AB, W, UPLO=uplo, Z=z, INFO=info )
!             <type>(<wp>), INTENT(INOUT) :: AB(:,:)
!             REAL(<wp>), INTENT(OUT) :: W(:)
!             CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!             <type>(<wp>), INTENT(OUT), OPTIONAL :: Z(:,:)
!             INTEGER, INTENT(OUT), OPTIONAL :: INFO
!         where
!             <type> ::= REAL | COMPLEX
!             <wp> ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! AB     (input/output) REAL or COMPLEX array, shape (:,:) with 
!        size(AB,1) = kd + 1 and
!        size(AB,2) = n, where kd is the number of subdiagonals or 
!        superdiagonals in the band and n is the order of A.
!        On entry, the upper (if UPLO = 'U') or lower (if UPLO = 'L') 
!        triangle of matrix A in band storage. The kd + 1 diagonals of A
!        are stored in the rows of AB so that the j-th column of A is 
!        stored in the j-th column of AB as follows:
!         if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j
!                                                    1<=j<=n
!         if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd)
!                                                    1<=j<=n.
!        On exit, AB is overwritten by values generated during the 
!        reduction of A to a tridiagonal matrix T . If UPLO = 'U', the
!        first superdiagonal and the diagonal of T are returned in rows
!        kd and kd + 1 of AB. If UPLO = 'L', the diagonal and first 
!        subdiagonal of T are returned in the first two rows of AB.
! W      (output) REAL array, shape (:) with size(W) = n.
!        The eigenvalues in ascending order.
! UPLO   Optional (input) CHARACTER(LEN=1).
!        = 'U': Upper triangle of A is stored;
!        = 'L': Lower triangle of A is stored.
!        Default value: 'U'.
! Z      Optional (output) REAL or COMPLEX square array, shape (:,:) with
!        size(Z,1) = n.
!        The columns of Z contain the orthonormal eigenvectors of A in 
!        the order of the eigenvalues.
! INFO   Optional (output) INTEGER.
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value.
!        > 0: if INFO = i, then i off-diagonal elements of an intermediate
!             tridiagonal form did not converge to zero.
!        If INFO is not present and an error occurs, then the program is
!        terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_SBEVD'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LUPLO, LJOBZ
   INTEGER :: N, KD, LINFO, LD, ISTAT, ISTAT1, S1Z, S2Z, LWORK, LIWORK, LGN
   INTEGER, SAVE :: LWORKN = 0, LIWORKN = 0, LWORKV = 0, LIWORKV = 0
!  .. LOCAL ARRAYS ..
   REAL(WP), TARGET :: LLZ(1,1)
   INTEGER, POINTER :: IWORK(:)
   REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; KD = SIZE(A,1)-1; N = SIZE(A,2); LD = MAX(1,SIZE(A,1)); ISTAT = 0
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
   IF( PRESENT(Z) )THEN; S1Z = SIZE(Z,1); S2Z = SIZE(Z,2); LJOBZ = 'V'
   ELSE; S1Z = 1; S2Z = 1; LJOBZ = 'N'; END IF
!  .. TEST THE ARGUMENTS
   IF( KD < 0 .OR. N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE( W ) /= N )THEN; LINFO = -2
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
   ELSE IF( PRESENT(Z) .AND. ( S1Z /= N .OR. S2Z /= N ) )THEN; LINFO = -4
   ELSE IF( N > 0 )THEN
!  .. DETERMINE THE WORKSPACE
      LGN = 1+INT( LOG(REAL(N,WP))/LOG(REAL(2,WP)) )
      IF( LSAME(LJOBZ,'N') )THEN
         LWORK = MAX( 1, 2*N, LWORKN ); LIWORK = MAX( 1, LIWORKN )
      ELSE
         LWORK = MAX( 1 + 5*N + 2*N**2, LWORKV )
         LIWORK = MAX( 3+5*N, LIWORKV )
      END IF
      ALLOCATE(WORK(LWORK), IWORK(LIWORK), STAT=ISTAT)
      IF( ISTAT /= 0 )THEN
         DEALLOCATE( WORK, IWORK, STAT=ISTAT1 )
         IF( LSAME(LJOBZ,'N') )THEN; LWORK = MAX( 1, 2*N ); LIWORK = 1
         ELSE; LWORK = 1 + 5*N + 2*N**2; LIWORK = 3+5*N; END IF
         ALLOCATE(WORK(LWORK), IWORK(LIWORK), STAT=ISTAT)
         IF( ISTAT == 0 ) CALL ERINFO( -200, SRNAME, LINFO )
      END IF
      IF( ISTAT == 0 ) THEN
         IF( PRESENT(Z) )THEN
          CALL SBEVD_F77( LJOBZ, LUPLO, N, KD, A, LD, W, Z, S2Z, WORK, LWORK, &
                         IWORK, LIWORK, LINFO )
	ELSE
	  CALL SBEVD_F77( LJOBZ, LUPLO, N, KD, A, LD, W, LLZ, S2Z, WORK, LWORK, &
                         IWORK, LIWORK, LINFO )
	ENDIF		 
         IF (LINFO == 0 ) THEN
            IF (LSAME(LJOBZ,'N')) THEN
               LWORKN = INT(WORK(1)); LIWORKN = IWORK(1)
            ELSE; LWORKV = INT(WORK(1)); LIWORKV = IWORK(1); END IF
         END IF
      ELSE; LINFO = -100; ENDIF
      DEALLOCATE(WORK,IWORK,STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE SSBEVD_F95

      PROGRAM LA_SGBSVX_EXAMPLE
 
!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!     
!  .. "Use Statements"
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GBSVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: K, KL, KU, I, J, N, NRHS
      CHARACTER(LEN=1) :: EQUED
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: AB(:,:), B(:,:), X(:,:), R(:), C(:), &
                               FERR(:), BERR(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GBSVX Example Program Results.'
      N = 6; KL = 2; KU = 1; NRHS = 2
!     ALLOCATE ( AB(2*KL+KU+1,N), B(N,NRHS), X(N,NRHS), R(N), C(N), &
      ALLOCATE ( AB(  KL+KU+1,N), B(N,NRHS), X(N,NRHS), R(N), C(N), &
                 FERR(NRHS),BERR(NRHS) )
 
      OPEN(UNIT=21,FILE='gbsv.ma',STATUS='UNKNOWN')
!     DO I=KL+1,2*KL+KU+1 
      DO I=   1,  KL+KU+1 
      DO J=1,N
         READ(21,'(F2.0)') AB(I,J)
      ENDDO  
      ENDDO
      CLOSE(21)

      AB(:,1:1)=1e-6*AB(:,1:1)
      DO J = 1, N
        DO K = 1, 1+KU-MIN(J-1,KU)-1; AB(K,J) = HUGE(1.0_WP); END DO
        DO K = 1+ KU+MIN(N-J,KL)+KL+1, 1+KU+KL; AB(K,J) = HUGE(1.0_WP); END DO
      END DO
      WRITE(*,*) 'The array AB:'
      DO I=1,N; WRITE(*,*) AB(I,:); ENDDO
     
      B = 0.0_WP
      DO I = 1, NRHS;
        DO J = 1, N
          DO K = 1+KU-MIN(J-1,KU), 1+ KU+MIN(N-J,KL)
            B(J,I) = AB(K,J)+B(J,I); 
          ENDDO
        ENDDO; 
        B(:,I) = B(:,I)*I; 
      ENDDO
    
      WRITE(*,*) 'The RHS matrix B:'
      DO I=1,N; WRITE(*,"(1(I3,1X),I3,1X)") INT(B(I,:)); ENDDO
     
      WRITE(*,*) "CALL LA_GBSVX( AB, B, X, 2, TRANS='T', EQUED=EQUED,", &
                 " R=R, C=C, FERR=FERR, BERR=BERR )"

      CALL LA_GBSVX( AB, B, X, 2, FACT='E',TRANS='T',EQUED=EQUED, &
                     R=R, C=C, FERR=FERR, BERR=BERR )

      WRITE(*,*)'X on exit: '
      DO I=1,N; WRITE(*,"(1(E12.6,1X),E12.6,1X)") X(I,:); ENDDO
      WRITE(*,*)'EQUED = ', EQUED
      WRITE(*,*)'R = ', R
      WRITE(*,*)'C = ', C
      WRITE(*,*)'FERR = ', FERR
      WRITE(*,*)'BERR = ', BERR

      END PROGRAM LA_SGBSVX_EXAMPLE

      SUBROUTINE DERRST( PATH, NUNIT )
*
*  -- LAPACK test routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     April 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  DERRST tests the error exits for DSYTRD, DORGTR, DORMTR, DSPTRD,
*  DOPGTR, DOPMTR, DSTEQR, SSTERF, SSTEBZ, SSTEIN, DPTEQR, DSBTRD,
*  DSYEV, SSYEVX, SSYEVD, DSBEV, SSBEVX, SSBEVD,
*  DSPEV, SSPEVX, SSPEVD, DSTEV, SSTEVX, SSTEVD, and SSTEDC.
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*  =====================================================================
*
*     NMAX has to be at least 3 or LIW may be too small
*     .. Parameters ..
      INTEGER            NMAX, LIW, LW
      PARAMETER          ( NMAX = 3, LIW = 12*NMAX, LW = 20*NMAX )
*     ..
*     .. Local Scalars ..
      CHARACTER*2        C2
      INTEGER            I, INFO, J, M, N, NSPLIT, NT
*     ..
*     .. Local Arrays ..
      INTEGER            I1( NMAX ), I2( NMAX ), I3( NMAX ), IW( LIW )
      DOUBLE PRECISION   A( NMAX, NMAX ), C( NMAX, NMAX ), D( NMAX ),
     $                   E( NMAX ), Q( NMAX, NMAX ), R( NMAX ),
     $                   TAU( NMAX ), W( LW ), X( NMAX ),
     $                   Z( NMAX, NMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAMEN
      EXTERNAL           LSAMEN
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHKXER, DOPGTR, DOPMTR, DORGTR, DORMTR, DPTEQR,
     $                   LA_TEST_DSBEV,  LA_TEST_DSBEVD, DSBEVX, DSBTRD,
     $                   LA_TEST_DSPEV, LA_TEST_DSPEVD, LA_TEST_DSPEVX,
     $                   DSPTRD, DSTEBZ, DSTEDC, DSTEIN, DSTEQR, DSTERF,
     $                   LA_TEST_DSTEV, LA_TEST_DSTEVD, LA_TEST_DSTEVR,
     $                   LA_TEST_DSTEVX, LA_TEST_DSYEV, LA_TEST_DSYEVD,
     $                   LA_TEST_DSYEVR, DSYEVX, DSYTRD
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )
*
*     Set the variables to innocuous values.
*
      DO 20 J = 1, NMAX
         DO 10 I = 1, NMAX
            A( I, J ) = 1.D0 / DBLE( I+J )
   10    CONTINUE
   20 CONTINUE
      DO 30 J = 1, NMAX
         D( J ) = DBLE( J )
         E( J ) = 0.0D0
         I1( J ) = J
         I2( J ) = J
         TAU( J ) = 1.D0
   30 CONTINUE
      OK = .TRUE.
      NT = 0
*
*     Test error exits for the ST path.
*
!      
      IF( LSAMEN( 2, C2, 'ST' ) ) THEN
*
*        DSYTRD
*
         SRNAMT = 'DSYTRD'
         INFOT = 1
         CALL DSYTRD( '/', 0, A, 1, D, E, TAU, W, 1, INFO )
         CALL CHKXER( 'DSYTRD', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL DSYTRD( 'U', -1, A, 1, D, E, TAU, W, 1, INFO )
         CALL CHKXER( 'DSYTRD', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL DSYTRD( 'U', 2, A, 1, D, E, TAU, W, 1, INFO )
         CALL CHKXER( 'DSYTRD', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL DSYTRD( 'U', 0, A, 1, D, E, TAU, W, 0, INFO )
         CALL CHKXER( 'DSYTRD', INFOT, NOUT, LERR, OK )
         NT = NT + 4
*
*        DORGTR
*
         SRNAMT = 'DORGTR'
         INFOT = 1
         CALL DORGTR( '/', 0, A, 1, TAU, W, 1, INFO )
         CALL CHKXER( 'DORGTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL DORGTR( 'U', -1, A, 1, TAU, W, 1, INFO )
         CALL CHKXER( 'DORGTR', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL DORGTR( 'U', 2, A, 1, TAU, W, 1, INFO )
         CALL CHKXER( 'DORGTR', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL DORGTR( 'U', 3, A, 3, TAU, W, 1, INFO )
         CALL CHKXER( 'DORGTR', INFOT, NOUT, LERR, OK )
         NT = NT + 4
*
*        DORMTR
*
         SRNAMT = 'DORMTR'
         INFOT = 1
         CALL DORMTR( '/', 'U', 'N', 0, 0, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'DORMTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL DORMTR( 'L', '/', 'N', 0, 0, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'DORMTR', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL DORMTR( 'L', 'U', '/', 0, 0, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'DORMTR', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL DORMTR( 'L', 'U', 'N', -1, 0, A, 1, TAU, C, 1, W, 1,
     $                INFO )
         CALL CHKXER( 'DORMTR', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL DORMTR( 'L', 'U', 'N', 0, -1, A, 1, TAU, C, 1, W, 1,
     $                INFO )
         CALL CHKXER( 'DORMTR', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL DORMTR( 'L', 'U', 'N', 2, 0, A, 1, TAU, C, 2, W, 1, INFO )
         CALL CHKXER( 'DORMTR', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL DORMTR( 'R', 'U', 'N', 0, 2, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'DORMTR', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL DORMTR( 'L', 'U', 'N', 2, 0, A, 2, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'DORMTR', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL DORMTR( 'L', 'U', 'N', 0, 2, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'DORMTR', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL DORMTR( 'R', 'U', 'N', 2, 0, A, 1, TAU, C, 2, W, 1, INFO )
         CALL CHKXER( 'DORMTR', INFOT, NOUT, LERR, OK )
         NT = NT + 10
*
*        DSPTRD
*
         SRNAMT = 'DSPTRD'
         INFOT = 1
         CALL DSPTRD( '/', 0, A, D, E, TAU, INFO )
         CALL CHKXER( 'DSPTRD', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL DSPTRD( 'U', -1, A, D, E, TAU, INFO )
         CALL CHKXER( 'DSPTRD', INFOT, NOUT, LERR, OK )
         NT = NT + 2
*
*        DOPGTR
*
         SRNAMT = 'DOPGTR'
         INFOT = 1
         CALL DOPGTR( '/', 0, A, TAU, Z, 1, W, INFO )
         CALL CHKXER( 'DOPGTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL DOPGTR( 'U', -1, A, TAU, Z, 1, W, INFO )
         CALL CHKXER( 'DOPGTR', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL DOPGTR( 'U', 2, A, TAU, Z, 1, W, INFO )
         CALL CHKXER( 'DOPGTR', INFOT, NOUT, LERR, OK )
         NT = NT + 3
*
*        DOPMTR
*
         SRNAMT = 'DOPMTR'
         INFOT = 1
         CALL DOPMTR( '/', 'U', 'N', 0, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'DOPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL DOPMTR( 'L', '/', 'N', 0, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'DOPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL DOPMTR( 'L', 'U', '/', 0, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'DOPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL DOPMTR( 'L', 'U', 'N', -1, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'DOPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL DOPMTR( 'L', 'U', 'N', 0, -1, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'DOPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL DOPMTR( 'L', 'U', 'N', 2, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'DOPMTR', INFOT, NOUT, LERR, OK )
         NT = NT + 6
*
*        DPTEQR
*
         SRNAMT = 'DPTEQR'
         INFOT = 1
         CALL DPTEQR( '/', 0, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DPTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL DPTEQR( 'N', -1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DPTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL DPTEQR( 'V', 2, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DPTEQR', INFOT, NOUT, LERR, OK )
         NT = NT + 3
*
*        DSTEBZ
*
         SRNAMT = 'DSTEBZ'
         INFOT = 1
         CALL DSTEBZ( '/', 'E', 0, 0.0D0, 1.0D0, 1, 0, 0.0D0, D, E, M,
     $                NSPLIT, X, I1, I2, W, IW, INFO )
         CALL CHKXER( 'DSTEBZ', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL DSTEBZ( 'A', '/', 0, 0.0D0, 0.0D0, 0, 0, 0.0D0, D, E, M,
     $                NSPLIT, X, I1, I2, W, IW, INFO )
         CALL CHKXER( 'DSTEBZ', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL DSTEBZ( 'A', 'E', -1, 0.0D0, 0.0D0, 0, 0, 0.0D0, D, E, M,
     $                NSPLIT, X, I1, I2, W, IW, INFO )
         CALL CHKXER( 'DSTEBZ', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL DSTEBZ( 'V', 'E', 0, 0.0D0, 0.0D0, 0, 0, 0.0D0, D, E, M,
     $                NSPLIT, X, I1, I2, W, IW, INFO )
         CALL CHKXER( 'DSTEBZ', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL DSTEBZ( 'I', 'E', 0, 0.0D0, 0.0D0, 0, 0, 0.0D0, D, E, M,
     $                NSPLIT, X, I1, I2, W, IW, INFO )
         CALL CHKXER( 'DSTEBZ', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL DSTEBZ( 'I', 'E', 1, 0.0D0, 0.0D0, 2, 1, 0.0D0, D, E, M,
     $                NSPLIT, X, I1, I2, W, IW, INFO )
         CALL CHKXER( 'DSTEBZ', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL DSTEBZ( 'I', 'E', 1, 0.0D0, 0.0D0, 1, 0, 0.0D0, D, E, M,
     $                NSPLIT, X, I1, I2, W, IW, INFO )
         CALL CHKXER( 'DSTEBZ', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL DSTEBZ( 'I', 'E', 1, 0.0D0, 0.0D0, 1, 2, 0.0D0, D, E, M,
     $                NSPLIT, X, I1, I2, W, IW, INFO )
         CALL CHKXER( 'DSTEBZ', INFOT, NOUT, LERR, OK )
         NT = NT + 8
*
*        DSTEIN
*
         SRNAMT = 'DSTEIN'
         INFOT = 1
         CALL DSTEIN( -1, D, E, 0, X, I1, I2, Z, 1, W, IW, I3, INFO )
         CALL CHKXER( 'DSTEIN', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL DSTEIN( 0, D, E, -1, X, I1, I2, Z, 1, W, IW, I3, INFO )
         CALL CHKXER( 'DSTEIN', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL DSTEIN( 0, D, E, 1, X, I1, I2, Z, 1, W, IW, I3, INFO )
         CALL CHKXER( 'DSTEIN', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL DSTEIN( 2, D, E, 0, X, I1, I2, Z, 1, W, IW, I3, INFO )
         CALL CHKXER( 'DSTEIN', INFOT, NOUT, LERR, OK )
         NT = NT + 4
*
*        DSTEQR
*
         SRNAMT = 'DSTEQR'
         INFOT = 1
         CALL DSTEQR( '/', 0, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DSTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL DSTEQR( 'N', -1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DSTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL DSTEQR( 'V', 2, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DSTEQR', INFOT, NOUT, LERR, OK )
         NT = NT + 3
*
*        DSTERF
*
         SRNAMT = 'DSTERF'
         INFOT = 1
         CALL DSTERF( -1, D, E, INFO )
         CALL CHKXER( 'DSTERF', INFOT, NOUT, LERR, OK )
         NT = NT + 1
*
*        DSTEDC
*
         SRNAMT = 'DSTEDC'
         INFOT = 1
         CALL DSTEDC( '/', 0, D, E, Z, 1, W, 1, IW, 1, INFO )
         CALL CHKXER( 'DSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL DSTEDC( 'N', -1, D, E, Z, 1, W, 1, IW, 1, INFO )
         CALL CHKXER( 'DSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL DSTEDC( 'V', 2, D, E, Z, 1, W, 23, IW, 28, INFO )
         CALL CHKXER( 'DSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL DSTEDC( 'N', 1, D, E, Z, 1, W, 0, IW, 1, INFO )
         CALL CHKXER( 'DSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL DSTEDC( 'I', 2, D, E, Z, 2, W, 12, IW, 12, INFO )
         CALL CHKXER( 'DSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL DSTEDC( 'V', 2, D, E, Z, 2, W, 22, IW, 28, INFO )
         CALL CHKXER( 'DSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL DSTEDC( 'N', 1, D, E, Z, 1, W, 1, IW, 0, INFO )
         CALL CHKXER( 'DSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL DSTEDC( 'I', 2, D, E, Z, 2, W, 19, IW, 11, INFO )
         CALL CHKXER( 'DSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL DSTEDC( 'V', 2, D, E, Z, 2, W, 23, IW, 27, INFO )
         CALL CHKXER( 'DSTEDC', INFOT, NOUT, LERR, OK )
         NT = NT + 9
*
*        DSTEVD
*
         SRNAMT = 'DSTEVD'
         DO I = 2,3
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_DSTEVD('N', NMAX, D, E, Z, NMAX, W, NMAX, IW,
     $         NMAX, INFO)
             CALL CHKXER( 'DSTEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSTEVD('V', NMAX, D, E, Z, NMAX, W, NMAX, IW,
     $         NMAX, INFO)
             CALL CHKXER( 'DSTEVD ', INFOT, NOUT, LERR, OK )
           END DO
         END DO 
         
*
*        DSTEV
*
         SRNAMT = 'DSTEV '
         DO I = 2,3
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_DSTEV('N', NMAX, D, E, Z, NMAX, W, INFO)
             CALL CHKXER( 'DSTEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSTEV('V', NMAX, D, E, Z, NMAX, W, INFO)
             CALL CHKXER( 'DSTEV ', INFOT, NOUT, LERR, OK )
           END DO
         END DO 
         
*
*        DSTEVX
*
         SRNAMT = 'DSTEVX'
         DO I = 2, 10
           INFOT = I
           IF (I/=9) THEN
             DO J = 1, 1
               INFO = J + 100*I
               CALL LA_TEST_DSTEVX( 'V', 'A', NMAX, D, E, 0.0D0, 0.0D0,
     &           0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSTEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSTEVX( 'N', 'A', NMAX, D, E, 0.0D0, 0.0D0,
     &           0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSTEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSTEVX( 'V', 'I', NMAX, D, E, 0.0D0, 0.0D0,
     &           0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSTEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSTEVX( 'N', 'I', NMAX, D, E, 0.0D0, 0.0D0,
     &           0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSTEVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSTEVX( 'V', 'V', NMAX, D, E, 0.0D0, 0.0D0,
     &           0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSTEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSTEVX( 'N', 'V', NMAX, D, E, 0.0D0, 0.0D0,
     &           0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSTEVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDIF
         ENDDO
         NT = NT + 9
*
*        DSTEVR
*
         N = 1
         SRNAMT = 'DSTEVR'
         DO I = 2,8
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_DSTEVR( 'N', 'A', NMAX, D, E, 0.0D0,
     $           0.0D0, NMAX-1, NMAX, 0.0D0, M,
     $           R, Z, NMAX, IW, X, 20*N, IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSTEVR', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSTEVR( 'N', 'V', NMAX, D, E, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M,
     $           R, Z, NMAX, IW, X, 20*N, IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSTEVR', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSTEVR( 'N', 'I', NMAX, D, E, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M,
     $           R, Z, NMAX, IW, X, 20*N, IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSTEVR', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSTEVR( 'V', 'A', NMAX, D, E, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M,
     $           R, Z, NMAX, IW, X, 20*N, IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSTEVR', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSTEVR( 'V', 'V', NMAX, D, E, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M,
     $           R, Z, NMAX, IW, X, 20*N, IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSTEVR', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSTEVR( 'V', 'I', NMAX, D, E, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M,
     $           R, Z, NMAX, IW, X, 20*N, IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSTEVR', INFOT, NOUT, LERR, OK ) 
             ENDDO
           ENDDO
         NT = NT + 9
*
*        DSYEVD
*
         SRNAMT = 'DSYEVD'
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_DSYEVD('N', 'U', NMAX, A, NMAX, X, W, 1,
     $         IW, 1, INFO )
             CALL CHKXER( 'DSYEVD', INFOT, NOUT, LERR, OK )
             
             INFO = J + 100*I
             CALL LA_TEST_DSYEVD('N', 'L', NMAX, A, NMAX, X, W, 1,
     $         IW, 1, INFO )
             CALL CHKXER( 'DSYEVD', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSYEVD('V', 'U', NMAX, A, NMAX, X, W, 1,
     $         IW, 1, INFO )
             CALL CHKXER( 'DSYEVD', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSYEVD('V', 'L', NMAX, A, NMAX, X, W, 1,
     $         IW, 1, INFO )
             CALL CHKXER( 'DSYEVD', INFOT, NOUT, LERR, OK )
           END DO
         END DO             

*
*        DSYEVR
*
         SRNAMT = 'DSYEVR'
         DO I = 1,10
           IF (I/=9) THEN
             INFOT = I
             DO J = 1, 1
               INFO = J + 100*I
               CALL LA_TEST_DSYEVR( 'N', 'A', 'U', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )
      
               INFO = J + 100*I 
               CALL LA_TEST_DSYEVR( 'N', 'A', 'L', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSYEVR( 'N', 'V', 'U', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSYEVR( 'N', 'V', 'L', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVR( 'N', 'I', 'U', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSYEVR( 'N', 'I', 'L', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVR( 'V', 'A', 'U', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVR( 'V', 'A', 'L', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVR( 'V', 'V', 'U', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVR( 'V', 'V', 'L', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVR( 'V', 'I', 'U', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVR( 'V', 'I', 'L', NMAX, A, NMAX, 0.0D0,
     $           0.0D0, NMAX, NMAX, 0.0D0, M, R, Z, NMAX, IW, Q, 26*N,
     $           IW( 2*N+1 ), 10*N, INFO )
               CALL CHKXER( 'DSYEVR', INFOT, NOUT, LERR, OK )
 
             ENDDO
           ENDIF
         ENDDO
         NT = NT + 11
*
*        DSYEV
*
         SRNAMT = 'DSYEV '
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_DSYEV('N', 'U', NMAX, A, NMAX, X, W, 1,
     $         INFO )
             CALL CHKXER( 'DSYEV ', INFOT, NOUT, LERR, OK )
             
             INFO = J + 100*I
             CALL LA_TEST_DSYEV('N', 'L', NMAX, A, NMAX, X, W, 1,
     $         INFO )
             CALL CHKXER( 'DSYEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSYEV('V', 'U', NMAX, A, NMAX, X, W, 1,
     $         INFO )
             CALL CHKXER( 'DSYEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSYEV('V', 'L', NMAX, A, NMAX, X, W, 1,
     $         INFO )
             CALL CHKXER( 'DSYEV ', INFOT, NOUT, LERR, OK )
           END DO
         END DO      
*
*        DSYEVX
*
         SRNAMT = 'DSYEVX'
         DO I = 1, 10
           IF (I/=9) THEN
             INFOT = I
             DO J = 1, 1
               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'N', 'A', 'U', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'N', 'A', 'L', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'N', 'V', 'U', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'N', 'V', 'L', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'N', 'I', 'U', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'N', 'I', 'L', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'V', 'A', 'U', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'V', 'A', 'L', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'V', 'V', 'U', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'V', 'V', 'L', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'V', 'I', 'U', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSYEVX( 'V', 'I', 'L', NMAX, A, NMAX, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, IW, I3, INFO ) 
               CALL CHKXER( 'DSYEVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDIF
         ENDDO
         NT = NT + 12
*
*        DSPEVD
*
         SRNAMT = 'DSPEVD'
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_DSPEVD('N', 'U', NMAX, A, X, Z, 1,
     $         W, 1, IW, 1, INFO )
             CALL CHKXER( 'DSPEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSPEVD('N', 'L', NMAX, A, X, Z, 1,
     $         W, 1 , IW, 1, INFO )
             CALL CHKXER( 'DSPEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSPEVD('V', 'U', NMAX, A, X, Z, 1,
     $         W, 1 , IW, 1, INFO )
             CALL CHKXER( 'DSPEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSPEVD('V', 'L', NMAX, A, X, Z, 1,
     $         W, 1 , IW, 1, INFO )
             CALL CHKXER( 'DSPEVD ', INFOT, NOUT, LERR, OK )
           END DO
         END DO 
         
*
*        DSPEV
*
         SRNAMT = 'DSPEV '
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_DSPEV('N', 'U', NMAX, A, W, Z, 1,
     $         X, INFO )
             CALL CHKXER( 'DSPEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSPEV('N', 'L', NMAX, A, W, Z, 1,
     $         X, INFO )
             CALL CHKXER( 'DSPEV ', INFOT, NOUT, LERR, OK )
             
             INFO = J + 100*I
             CALL LA_TEST_DSPEV('V', 'U', NMAX, A, W, Z, 1,
     $         X, INFO )
             CALL CHKXER( 'DSPEV ', INFOT, NOUT, LERR, OK )
             
             INFO = J + 100*I
             CALL LA_TEST_DSPEV('V', 'L', NMAX, A, W, Z, 1,
     $         X, INFO )
             CALL CHKXER( 'DSPEV ', INFOT, NOUT, LERR, OK )
           END DO
         END DO 
*
*        DSPEVX
*
         SRNAMT = 'DSPEVX'
         DO I = 1, 10
           INFOT = I
           IF (I/=9) THEN
             DO J = 1, 1
               INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'V', 'A', 'U', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'V', 'A', 'L', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'V', 'V', 'U', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'V', 'V', 'L', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'V', 'I', 'U', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'V', 'I', 'L', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'N', 'A', 'U', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'N', 'A', 'L', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )

                              INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'N', 'V', 'U', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'N', 'V', 'L', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'N', 'I', 'U', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_DSPEVX( 'N', 'I', 'L', NMAX, A, 0.0D0,
     &           0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, IW, I3, INFO ) 
               CALL CHKXER( 'DSPEVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDIF
         ENDDO
         NT = NT + 10
*
*     Test error exits for the SB path.
*
      ELSE IF( LSAMEN( 2, C2, 'SB' ) ) THEN
*
*        DSBTRD
*
         SRNAMT = 'DSBTRD'
         INFOT = 1
         CALL DSBTRD( '/', 'U', 0, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DSBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL DSBTRD( 'N', '/', 0, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DSBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL DSBTRD( 'N', 'U', -1, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DSBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL DSBTRD( 'N', 'U', 0, -1, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DSBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL DSBTRD( 'N', 'U', 1, 1, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DSBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL DSBTRD( 'V', 'U', 2, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'DSBTRD', INFOT, NOUT, LERR, OK )
         NT = NT + 6
*
*        DSBEVD
*
         SRNAMT = 'DSBEVD'
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_DSBEVD('N', 'U', NMAX, NMAX, A, 1, X, Z, 1,
     $         W, 1, IW, 1, INFO )
             CALL CHKXER( 'DSBEVD', INFOT, NOUT, LERR, OK )
             INFO = J + 100*I
             CALL LA_TEST_DSBEVD('N', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     $         W, 1, IW, 1, INFO )
             CALL CHKXER( 'DSBEVD', INFOT, NOUT, LERR, OK )
             INFO = J + 100*I
             CALL LA_TEST_DSBEVD('V', 'U', NMAX, NMAX, A, 1, X, Z, 1,
     $         W, 1 , IW, 1, INFO )
             CALL CHKXER( 'DSBEVD', INFOT, NOUT, LERR, OK )
             INFO = J + 100*I
             CALL LA_TEST_DSBEVD('V', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     $         W, 1, IW, 1, INFO )
             CALL CHKXER( 'DSBEVD', INFOT, NOUT, LERR, OK )
           END DO
         END DO  

*
*        DSBEV
*
         SRNAMT = 'DSBEV '
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_DSBEV('N', 'U', NMAX, NMAX, A, 1, X, Z, 1,
     $        W, INFO )
             CALL CHKXER( 'DSBEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSBEV('N', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     $         W, INFO )
             CALL CHKXER( 'DSBEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSBEV('V', 'U', NMAX, NMAX, A, 1, X, Z, 1,
     $         W, INFO )
             CALL CHKXER( 'DSBEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_DSBEV('V', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     $         W, INFO )
             CALL CHKXER( 'DSBEV ', INFOT, NOUT, LERR, OK )
           END DO
         END DO                  
*
*        DSBEVX
*
         SRNAMT = 'DSBEVX'
         DO I = 1, 11
           INFOT = I
           IF (I/=9) THEN
             DO J = 1, 11
               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'N', 'A', 'U', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'N', 'A', 'L', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'N', 'V', 'U', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'N', 'V', 'L', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'N', 'I', 'U', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'N', 'I', 'L', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'V', 'A', 'U', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'V', 'A', 'L', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'V', 'V', 'U', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'V', 'V', 'L', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'V', 'I', 'U', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I 
               CALL LA_TEST_DSBEVX( 'V', 'I', 'L', NMAX, NMAX, A, NMAX,
     &           Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, IW, I3, INFO )
               CALL CHKXER( 'DSBEVX', INFOT, NOUT, LERR, OK )

             ENDDO
           ENDIF
         ENDDO
         NT = NT + 13
      END IF
*
*     Print a summary line.
*
      IF( OK ) THEN
         WRITE( NOUT, FMT = 9999 )PATH, NT
      ELSE
         WRITE( NOUT, FMT = 9998 )PATH
      END IF
*
 9999 FORMAT( 1X, A3, ' routines passed the tests of the error exits',
     $      ' (', I3, ' tests done)' )
 9998 FORMAT( ' *** ', A3, ' routines failed the tests of the error ',
     $      'exits ***' )
*
      RETURN
*
*     End of DERRST
*
      END

SUBROUTINE LA_TEST_SPTSV( N, NRHS, D, E, B, LDB, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     April 9, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_PTSV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, NRHS, LDB
   INTEGER, INTENT(INOUT) :: INFO
!  .. Array Arguments ..
      REAL(WP), INTENT(INOUT) :: D(1:N), E(1:N-1), B(1:LDB,1:N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_PTSV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SPTSV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, ID, IE, IB1, IB2
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   ID = N; IE = N-1; IB1 = N; IB2 = NRHS
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
      IF (NRHS == 1) THEN
        CALL LA_PTSV( D(1:ID), E(1:IE),  B(1:IB1,1), INFO )
        INFO = INFOTC
      ELSE
        CALL LA_PTSV( D(1:ID),  E(1:IE),  B(1:IB1,1:IB2), INFO )
        INFO = INFOTC
      END IF               
   CASE (2)
      IE = ID - 2
   CASE(3)
      IB1 = ID - 1
   CASE(:-1, 1, 4:)
      CALL UESTOP(SRNAMT)
   END SELECT
   IF( I /= 0  ) THEN
      SELECT CASE (NRHS)
      CASE (2:)
         CALL LA_PTSV( D(1:ID), E(1 :IE), B(1:IB1,1:IB2),  INFO )
      CASE(1)
         CALL LA_PTSV( D(1:ID), E(1:IE), B(1:IB1,1), INFO )
      CASE(:-1)
         CALL UESTOP(SRNAMT)
      END SELECT
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_SPTSV

      PROGRAM LA_SPTSV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_PTSV
!  .. "IMPLICIT STATEMENT" ..
      IMPLICIT NONE
!  .. "Parameters" ..
      REAL(WP), PARAMETER :: ONE = 1.0_WP, THREE = 3.0_WP
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N, NRHS
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:), D(:), E(:), B(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SPTSV Example Program Results.'
      N = 5; NRHS = 3
      WRITE(*,'(5H N = , I4, 9H; NRHS = , I4)') N, NRHS  
      ALLOCATE (A(N), D(N), E(N-1), B(N,NRHS) )
   
      OPEN(UNIT=21,FILE='ptsv.ma',STATUS='UNKNOWN')
      DO I=1,N
         READ(21,'(F3.0)') A(I);
      ENDDO;
      CLOSE(21)
  

      E = THREE; D(1) = 2*E(1)+ONE; D(2:N) = 2*E+ONE
      B(1,1) = D(1)+E(1); B(N,1) = E(N-1)+D(N)
      B(2:N-1,1) = 2*E + D(2:N-1)
      DO I = 2, NRHS; B(:,I) = B(:,1)*I; 
      ENDDO
      WRITE(*,*) '  on entry:'
      WRITE (*,'(2HD:,8(1X,F9.2))') D
      WRITE (*,'(2HE:,8(1X,F9.2))') E
      WRITE(*,*) 'The RHS matrix B:'
      DO J = 1, N; WRITE (*,*) B(J,:); 
      ENDDO
    
      WRITE(*,*)' CALL LA_PTSV( D, E, B, INFO )'
      CALL LA_PTSV( D, E, B, INFO )

      WRITE(*,*) 'Vector D on exit:'
      DO I = 1, N; WRITE (*,'(F8.5)') D(I); 
      ENDDO

      WRITE(*,*) 'Vector E on exit:'
      DO I = 1, N-1; WRITE (*,'(E15.5)') E(I); 
      ENDDO


      WRITE(*,*) 'The matrix B on exit:'
      DO J = 1, N; WRITE (*,*) B(J,:); 
      ENDDO
    
      WRITE(*,*)'INFO = ',INFO 
      
      END PROGRAM LA_SPTSV_EXAMPLE

      PROGRAM LA_SSYSVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SYSVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Parameters" ..
      REAL(WP), PARAMETER :: ONE = 1.0_WP, ZERO = 0.0_WP
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N, NRHS
      REAL(WP) :: RCOND
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE :: IPIV(:)
      REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), X(:,:), FERR(:), BERR(:)
!  .. "Intrinsic Functions" ..
      INTRINSIC  SUM
!  .. "Executable Statements" ..
      WRITE (*,*) 'SSYSVX Example Program Results'
      N = 5; NRHS = 3
      WRITE(*,'(5H N = , I4, 9H; NRHS = , I4)') N, NRHS
      ALLOCATE ( A(N,N), B(N,NRHS), X(N,NRHS), IPIV(N), FERR(NRHS), BERR(NRHS) )
    
      OPEN(UNIT=21,FILE='sysv.ma',STATUS='UNKNOWN')
      DO I=1,N
         DO J=I,N
         READ(21,'(F3.0)') A(I,J);
         ENDDO
      ENDDO;
      CLOSE(21)

      WRITE(*,*) 'The array A :'
      DO I=1,N
      WRITE(*,'(10(I3,1X,1X),I3,1X)') INT(A(I,1:N)); 
      ENDDO

      DO J = 1, NRHS; 
         DO I = 1, N
            B(I,J) = (SUM(A(I,I:N)) + SUM(A(1:I,I)) - A(I,I))*J
         ENDDO;
      ENDDO
   
      WRITE(*,*) 'The array B :'
      DO I=1,N
            WRITE(*,'(3(I3,1X,1X))') INT(B(I,1:NRHS));
      ENDDO

      WRITE(*,*)'CALL LA_SYSVX(A, B, X, IPIV=IPIV, FERR=FERR, BERR=BERR, RCOND=RCOND, INFO=INFO)'
      CALL LA_SYSVX(A, B, X, IPIV=IPIV, FERR=FERR, BERR=BERR, RCOND=RCOND, INFO=INFO)
   
      WRITE(*,*) 'FERR on exit :'
      DO I = 1, NRHS; WRITE (*,'(E13.5)') FERR(I); 
      ENDDO
      WRITE(*,*)'BERR on exit :'
      DO I = 1, NRHS; WRITE (*,'(E13.5)') BERR(I); 
      ENDDO
      WRITE(*,*) 'RCOND =', RCOND
      WRITE(*,*)'INFO = ' ,INFO      

      END PROGRAM LA_SSYSVX_EXAMPLE

PROGRAM LA_DSYGVX_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_SYGVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: UPLO
      INTEGER :: I, J, INFO, N
      INTEGER :: IL, IU, ITYPE
      REAL(WP) :: VL, VU
      INTEGER  ::  M 
!  .. LOCAL ARRAYS ..
      INTEGER, ALLOCATABLE :: IFAIL(:)
      REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:), W(:)
      REAL(WP), ALLOCATABLE :: A(:,:), B(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE(NOUT,*) 'DSYGVX ET_Example Program Results.'
   READ(NIN,*) ! SKIP HEADING IN DATA FILE
      READ(NIN,*) N
      ITYPE = 1; UPLO = 'L'
      VL = -10; VU = 10; IL = 1; IU = N;
   ALLOCATE ( A(N,N), B(N,N), W(N), AA(N,N), BB(N,N), IFAIL(N))
      DO I = 1, N
        READ(NIN,*) (AA(I, J), J = 1, N)
      ENDDO
      DO I = 1, N
        READ(NIN,*) (BB(I, J), J = 1, N)
      ENDDO
      A=AA; B=BB
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      ENDDO
      WRITE(NOUT,*) 'The matrix B:'
      DO I = 1, N
        WRITE(NOUT,FMT) B(I,:)
      ENDDO
!
      WRITE(NOUT,*) '---------------------------------------------------------'
      WRITE(NOUT,*)
      WRITE ( NOUT, * )'Details of LA_DSYGVX LAPACK Subroutine Results.'
      WRITE(NOUT,*)
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_SYGVX(A, B, W, INFO=INFO)'
      WRITE(NOUT,*) 'LA_SYGVX computes all the eigenvalues of a real'
      WRITE(NOUT,*) 'symmetric-definite generalized eigenproblem'
      WRITE(NOUT,*) 'A*x = lambda*B*x'
      WRITE(NOUT,*) 'ON ENTRY: A, B'
      WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
      WRITE(NOUT,*) '   B - the original matrix (upper triangular)'
      WRITE(NOUT,*) 'ON EXIT: A, B, W'
      WRITE(NOUT,*) '   A - destroyed matrix A'
      WRITE(NOUT,*) '   B - the triangular factor U from the Cholesky'
      WRITE(NOUT,*) '       factorization'
      WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
      A=AA
      B=BB
      CALL LA_SYGVX(A, B, W, INFO=INFO)
      WRITE(NOUT,*) 'The eigenvalues computed by LA_SYGVX:'
      WRITE(NOUT,FMT) W(:)
      WRITE(NOUT,*) 'INFO = ',INFO
!      
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W, JOBZ='V', IL=IL, IU=IU, INFO=INFO)"
      WRITE(NOUT,*) 'LA_SYGVX computes all the eigenvalues and eigenvectors'
      WRITE(NOUT,*) 'of a real symmetric-definite generalized eigenproblem'
      WRITE(NOUT,*) 'A*x = lambda*B*x'
      WRITE(NOUT,*) 'ON ENTRY: A, B'
      WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
      WRITE(NOUT,*) '   B - the original matrix (upper triangular)'
      WRITE(NOUT,*) 'ON EXIT: A, B, W'
      WRITE(NOUT,*) '   A - the eigenvectors normalized as follows:'
      WRITE(NOUT,*) '       Z**T*B*Z = I'
      WRITE(NOUT,*) '   B - the triangular factor U from the Cholesky'
      WRITE(NOUT,*) '       factorization'
      WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
      A=AA
      B=BB
      CALL LA_SYGVX(A, B, W, JOBZ='V', IL=IL, IU=IU, INFO=INFO)
      WRITE(NOUT,*) 'The eigenvalues computed by LA_SYGVX: '
      WRITE(NOUT,FMT) W(:)
      WRITE(NOUT,*) 'The normalized eigenvectors computed by LA_SYGVX:'
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      END DO
      WRITE(NOUT, *) 'The indices of the smallest eigenvalue to be returned: IL= ', IL
      WRITE(NOUT, *) 'The indices of the largest eigenvalue to be returned: IU= ', IU
      WRITE(NOUT,*) 'The orthonormal eigenvectors of the matrix A '
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      END DO          
      WRITE(NOUT,*) 'INFO = ',INFO
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W, JOBZ='V', VL=VL, VU=VU, INFO=INFO)"
      WRITE(NOUT,*) 'LA_SYGVX computes all the eigenvalues and eigenvectors'
      WRITE(NOUT,*) 'of a real symmetric-definite generalized eigenproblem'
      WRITE(NOUT,*) 'A*x = lambda*B*x'
      WRITE(NOUT,*) 'ON ENTRY: A, B'
      WRITE(NOUT,*) '   A - the original matrix (lower triangular)'
      WRITE(NOUT,*) '   B - the original matrix (lower triangular)'
      WRITE(NOUT,*) 'ON EXIT: A, B, W'
      WRITE(NOUT,*) '   A - the eigenvectors normalized as follows:'
      WRITE(NOUT,*) '       Z**T*B*Z = I'
      WRITE(NOUT,*) '   B - the triangular factor L from the Cholesky'
      WRITE(NOUT,*) '       factorization'
      WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
      A=AA
      B=BB
      CALL LA_SYGVX(A, B, W, ITYPE, 'V', VL=VL, VU=VU, INFO=INFO)
      WRITE(NOUT,*) 'The eigenvalues computed by LA_SYGVX:'
      WRITE(NOUT,FMT) W(:)
      WRITE(NOUT,*) 'The normalized eigenvectors computed by LA_SYGVX:'
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      END DO
      WRITE(NOUT, *) 'The lower bound of the interval to be searched for eigenvalues VL= ', VL
      WRITE(NOUT, *) 'The upper bound of the interval to be searched for eigenvalues VU= ', VU 
      WRITE(NOUT,*) 'The orthonormal eigenvectors of the matrix A '
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      END DO
      WRITE(NOUT,*) 'INFO = ',INFO

      ITYPE = 2
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W, ITYPE, 'V', M=M, IFAIL=IFAIL, INFO=INFO)"
      WRITE(NOUT,*) 'LA_SYGVX computes all the eigenvalues and eigenvectors'
      WRITE(NOUT,*) 'of a real symmetric-definite generalized eigenproblem'
      WRITE(NOUT,*) 'A*B*x = lambda*x'
      WRITE(NOUT,*) 'ON ENTRY: A, B'
      WRITE(NOUT,*) '   A - the original matrix (lower triangular)'
      WRITE(NOUT,*) '   B - the original matrix (lower triangular)'
      WRITE(NOUT,*) 'ON EXIT: A, B, W'
      WRITE(NOUT,*) '   A - the eigenvectors normalized as follows:'
      WRITE(NOUT,*) '       Z**T*B*Z = I'
      WRITE(NOUT,*) '   B - the triangular factor L from the Cholesky'
      WRITE(NOUT,*) '       factorization'
      WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
      A=AA
      B=BB
      CALL LA_SYGVX(A, B, W, ITYPE, 'V', M=M, IFAIL=IFAIL, INFO=INFO)
      WRITE(NOUT,*) 'The eigenvalues computed by LA_SYGVX:'
      WRITE(NOUT,FMT) W(:)
      WRITE(NOUT,*) 'The normalized eigenvectors computed by LA_SYGVX:'
      DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
      END DO
      WRITE(NOUT,*) ' IFAIL  computed by LA_SYGVX:'
      WRITE(NOUT, *) IFAIL(:)
      WRITE(NOUT, *) 'The total number of eigenvalues found ', M
      WRITE(NOUT,*) 'The orthonormal eigenvectors of the matrix A '
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      END DO   
      WRITE(NOUT,*) 'INFO = ',INFO

      ITYPE = 3
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W, ITYPE, 'V', 'L', VL, VU, M=M, IFAIL=IFAIL, INFO=INFO)"
      WRITE(NOUT,*) 'LA_SYGVX computes all the eigenvalues and eigenvectors'
      WRITE(NOUT,*) 'of a real symmetric-definite generalized eigenproblem'
      WRITE(NOUT,*) 'B*A*x = lambda*x'
      WRITE(NOUT,*) 'ON ENTRY: A, B'
      WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
      WRITE(NOUT,*) '   B - the original matrix (upper triangular)'
      WRITE(NOUT,*) 'ON EXIT: A, B, W'
      WRITE(NOUT,*) '   A - the eigenvectors normalized as follows:'
      WRITE(NOUT,*) '       Z**T*inv(B)*Z = I'
      WRITE(NOUT,*) '   B - the triangular factor U from the Cholesky'
      WRITE(NOUT,*) '       factorization'
      WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
      A=AA
      B=BB
      CALL LA_SYGVX(A, B, W, ITYPE, 'V', 'L', VL, VU, M=M, IFAIL=IFAIL, INFO=INFO)
      WRITE(NOUT,*) 'The eigenvalues computed by LA_SYGVX:'
      WRITE(NOUT,FMT) W(:)
      WRITE(NOUT,*) 'The normalized eigenvectors computed by LA_SYGVX:'
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      END DO
      WRITE(NOUT,*) ' IFAIL  computed by LA_SYGVX:'
      WRITE(NOUT, *) IFAIL(:)
      WRITE(NOUT, *) 'The total number of eigenvalues found ', M
      WRITE(NOUT, *) 'The lower bound of the interval to be searched for eigenvalues VL= ', VL
      WRITE(NOUT, *) 'The upper bound of the interval to be searched for eigenvalues VU= ', VU
      WRITE(NOUT,*) 'The orthonormal eigenvectors of the matrix A '
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      END DO                                                                   
      WRITE(NOUT,*) 'INFO = ',INFO

! STARTING ERROR TESTS
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A(1:N-1,1:N), B, W, INFO=INFO)"
      A=AA; B=BB
      CALL LA_SYGVX(A(1:N-1,1:N), B, W, INFO=INFO)
      WRITE(NOUT,*) 'INFO = ',INFO
      
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B(1:N,1:N-1), W, INFO=INFO)"
      A=AA; B=BB
      CALL LA_SYGVX(A, B(1:N,1:N-1), W, INFO=INFO)
      WRITE(NOUT,*) 'INFO = ',INFO
      
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W(1:N-2), INFO=INFO)"
      A=AA; B=BB
      CALL LA_SYGVX(A, B, W(1:N-2), INFO=INFO)
      WRITE(NOUT,*) 'INFO = ',INFO
      
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W, 5, INFO=INFO)"
      A=AA; B=BB
      CALL LA_SYGVX(A, B, W, 5, INFO=INFO)
      WRITE(NOUT,*) 'INFO = ',INFO
      
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W, JOBZ='T', INFO=INFO)"
      A=AA; B=BB
      CALL LA_SYGVX(A, B, W, JOBZ='T', INFO=INFO)
      WRITE(NOUT,*) 'INFO = ',INFO
      
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W, UPLO='T', INFO=INFO)"
      A=AA; B=BB
      CALL LA_SYGVX(A, B, W, UPLO='T', INFO=INFO)
      WRITE(NOUT,*) 'INFO = ',INFO
      
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W, JOBZ='V', VL=10.0, VU=2.0, INFO=INFO)"
      A=AA; B=BB
      CALL LA_SYGVX(A, B, W, JOBZ='V', VL=10.0, VU=2.0, INFO=INFO)
      WRITE(NOUT,*) 'INFO = ',INFO
      
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W, JOBZ='V', VL=1.0, VU=10.0, IL=1, IU=3, INFO=INFO)"
      A=AA; B=BB
      CALL LA_SYGVX(A, B, W, JOBZ='V', VL=1.0, VU=10.0, IL=1, IU=3, INFO=INFO)
      WRITE(NOUT,*) 'INFO = ',INFO
      
      
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W, JOBZ='V', IL=100, IU=3, INFO=INFO)"
      A=AA; B=BB
      CALL LA_SYGVX(A, B, W, JOBZ='V', IL=100, IU=3, INFO=INFO)
      WRITE(NOUT,*) 'INFO = ',INFO
      
      WRITE(NOUT,*)
      WRITE(NOUT,*) "CALL LA_SYGVX(A, B, W, JOBZ='V', IFAIL=IFAIL(1:N-3), INFO=INFO)"
      A=AA; B=BB
      CALL LA_SYGVX(A, B, W, JOBZ='V', IFAIL=IFAIL(1:N-3), INFO=INFO)
      WRITE(NOUT,*) 'INFO = ',INFO
      
      
 END PROGRAM LA_DSYGVX_ET_EXAMPLE

SUBROUTINE CGETRS_F95( A, IPIV, B, TRANS, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: GETRS_F77 => LA_GETRS
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   INTEGER, INTENT(IN) :: IPIV(:)
   COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
!-----------------------------------------------------------------
!
! Purpose
! =======
!
! LA_GETRS solves a system of linear equations
!    A X = B, A^T X = B or  A^H X = B
! with a general square matrix A using the LU factorization computed
! by LA_GETRF.
!
! Arguments
! =========
! SUBROUTINE LA_GETRS (A, IPIV, B, TRANS, INFO)
!    <type>(<wp>), INTENT(IN)  :: A(:,:)
!    <type>(<wp>), INTENT(INOUT) :: <rhs>
!    INTEGER, INTENT(IN) :: IPIV(:)
!    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
!    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!    where
!    <type> ::= REAL | COMPLEX
!    <wp>   ::= KIND(1.0) | KIND(1.0D0)
!    <rhs>  ::= B(:,:) | B(:)
!
! =====================
!
! A     (input) either REAL or COMPLEX square array,
!       shape (:,:), size(A,1) == size(A,2).
!       The factors L and U from the factorization A = PLU as computed 
!       by LA_GETRF.
!
! IPIV  (input) INTEGER array, shape (:), size(IPIV) == size(A,1).
!       The pivot indices from LA_GETRF; for 1<=i<=size(A,1), row i
!       of the matrix was interchanged with row IPIV(i).
!
! B     (input/output) either REAL or COMPLEX rectangular array,
!       shape either (:,:) or (:), size(B,1) or size(B) == size(A,1).
!       On entry, the right hand side vector(s) of matrix B for
!          the system of equations AX = B.
!       On exit, if there is no error, the matrix of solution
!          vector(s) X.
!
! TRANS Optional (input) CHARACTER*1
!       If TRANS is present, it specifies the form of the system 
!          of equations:
!          = 'N':  A X = B    (No transpose)
!          = 'T':  A^T X = B  (Transpose)
!          = 'C':  A^H X = B  (Conjugate transpose = Transpose)
!       otherwise TRANS = 'N' is assumed.
!
! INFO  Optional (output) INTEGER.
!       If INFO is present
!          = 0: successful exit
!          < 0: if INFO = -k, the k-th argument had an illegal value
!       If INFO is not present and an error occurs, then the program is
!          terminated with an error message.
!---------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GETRS'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LTRANS
   INTEGER    :: LINFO, NRHS, N, LD
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC SIZE, MAX, PRESENT
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; N = SIZE(A, 1); NRHS = SIZE(B,2); LD = MAX(1,N)
   IF(PRESENT(TRANS))THEN; LTRANS = TRANS; ELSE; LTRANS='N'; END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE( A, 2 ) /= N .OR. N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE( IPIV ) /= N ) THEN; LINFO = -2
   ELSE IF( SIZE( B, 1 ) /= N ) THEN; LINFO = -3
   ELSE IF(.NOT.LSAME(LTRANS,'N') .AND. .NOT.LSAME(LTRANS,'T').AND. &
           .NOT.LSAME(LTRANS,'C'))THEN; LINFO = -4
   ELSE
!  .. CALL LAPACK77 ROUTINE
      CALL GETRS_F77( LTRANS, N, NRHS, A, LD, IPIV, B, LD, LINFO )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO )
END SUBROUTINE CGETRS_F95

SUBROUTINE LA_TEST_CGERFS( TRANS, N, NRHS, A, LDA, AF, LDAF, IPIV, B, LDB, &
                           X, LDX, FERR, BERR, WORK, RWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     October 31, 1996
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO
   USE F95_LAPACK, ONLY: LA_GERFS
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   CHARACTER(LEN=1), INTENT(IN) :: TRANS
   INTEGER, INTENT(IN) :: N, NRHS, LDA, LDAF, LDB, LDX
   INTEGER, INTENT(INOUT) :: INFO
!  .. Array Arguments ..
   INTEGER, INTENT(INOUT) :: IPIV(1:N)
   COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N), AF(1:LDAF,1:N), &
                B(1:LDB,1:NRHS), X(1:LDX,1:NRHS), WORK( * )
   REAL(WP), INTENT(INOUT) :: BERR(1:NRHS), FERR(1:NRHS), RWORK(*)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GERFS'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_CGERFS'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   CHARACTER(LEN=1) :: LTRANS
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IX1, IX2, IAF1, IAF2, IIPIV, &
              IFERR, IBERR
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IB1 = N; IB2 = NRHS; IX1 = N; IX2 = NRHS; IAF1 = N
   IAF2 = N; IIPIV = N; LTRANS = TRANS; IFERR = NRHS; IBERR = NRHS
!  .. Executable Statements ..
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
      IF (NRHS == 1) THEN
        IF( LTRANS == 'N' )THEN
          CALL LA_GERFS(A(1:IA1,1:IA2), AF(1:IAF1,1:IAF2), &
     &      IPIV(1:IIPIV), B(1:IB1,1),  X(1:IX1,1), FERR=FERR(1), &
     &      BERR=BERR(1) )
        ELSE
          CALL LA_GERFS(A(1:IA1,1:IA2), AF(1:IAF1,1:IAF2), &
     &      IPIV(1:IIPIV), B(1:IB1,1),  X(1:IX1,1), LTRANS, FERR(1), &
     &      BERR(1) )
        END IF
        INFO = INFOTC
      ELSE
        IF( LTRANS == 'N' )THEN
          CALL LA_GERFS(A(1:IA1,1:IA2), AF(1:IAF1,1:IAF2), &
     &      IPIV(1:IIPIV), B(1:IB1,1:IB2),  X(1:IX1,1:IX2), &
     &      FERR=FERR(1:IFERR), BERR=BERR(1:IBERR) )
        ELSE
          CALL LA_GERFS(A(1:IA1,1:IA2), AF(1:IAF1,1:IAF2), &
     &      IPIV(1:IIPIV), B(1:IB1,1:IB2),  X(1:IX1,1:IX2), LTRANS, &
     &      FERR(1:IFERR), BERR(1:IBERR) )
        END IF
        INFO = INFOTC
      ENDIF
   CASE (1)
      IA2 = IA1-1
   CASE (2)
I2:   SELECT CASE(J)
      CASE(1)
         IAF1 = IA1-1
      CASE(2)
         IAF2 = IA1-1
      CASE (3:)
         CALL UESTOP(SRNAMT)
      END SELECT I2
   CASE(3)
      IIPIV = IA1-1
   CASE(4)
      IB1 = IA1-1
   CASE (5)
I5:   SELECT CASE(J)
      CASE(1)
         IX1 = IA1-1
      CASE (2)
         IX2 = IB2-1
      CASE (3:)
         CALL UESTOP(SRNAMT)
      END SELECT I5
   CASE(6)
      LTRANS = '/'
   CASE(7)
      IFERR = IB2-1
   CASE(8)
      IBERR = IB2-1
   CASE(:-1,9:)
      CALL UESTOP(SRNAMT)
   END SELECT
   IF( I /= 0 ) THEN
      SELECT CASE (NRHS)
      CASE (2:)
         CALL LA_GERFS(A(1:IA1,1:IA2), AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), &
              B(1:IB1,1:IB2),  X(1:IX1,1:IX2), LTRANS, FERR(1:IFERR),  &
              BERR(1:IBERR), INFO)
      CASE (1)
         IF( I /= 4 .AND. INFO /= 502 .AND. I /= 7 .AND. I /= 8 ) THEN
            CALL LA_GERFS(A(1:IA1,1:IA2), AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), &
                 B(1:IB1,1),  X(1:IX1,1), LTRANS, FERR(1),  BERR(1), INFO)
         ELSE
            CALL ERINFO( -I, SRNAME, INFO )
         END IF
      CASE(:-1)
         CALL UESTOP(SRNAMT)
      END SELECT
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_CGERFS

SUBROUTINE LA_TEST_SGEEQU( M, N, A, LDA, R, C, ROWCND, COLCND, AMAX, INFO )
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     October 31, 1996
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GEEQU
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: M, N, LDA
   INTEGER, INTENT(INOUT) :: INFO
   REAL(WP), INTENT(OUT) :: AMAX, COLCND, ROWCND
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N)
   REAL(WP), INTENT(OUT) :: C(1:N), R(1:N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GEEQU'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGEEQU'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IR, IC
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = M; IA2 = N; IR = M; IC = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
         CALL LA_GEEQU( A(1:IA1,1:IA2), R(1:IR), C(1:IC), ROWCND, COLCND, AMAX )
         INFO = INFOTC
   CASE (2)
      IR = IA1-1
   CASE (3)
      IC = IA2-1
   CASE(:-1,1,4:)
      CALL UESTOP(SRNAMT)
   END SELECT
   IF( I /= 0 ) THEN
         CALL LA_GEEQU( A(1:IA1,1:IA2), R(1:IR), C(1:IC), ROWCND, &
              COLCND, AMAX, INFO )
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_SGEEQU

      SUBROUTINE CERRLS( PATH, NUNIT )
*
*  -- LAPACK90 test routine (version 1.1) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     April 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  CERRLS tests the error exits for the COMPLEX least squares
*  driver routines (CGELS, CGELSS, CGELSX, CGELSY, CGELSD).
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX
      PARAMETER          ( NMAX = 2 )
*     ..
*     .. Local Scalars ..
      CHARACTER*2        C2
      INTEGER            INFO, IRNK, I, J, NRHS
      REAL               RCOND
*     ..
*     .. Local Arrays ..
      INTEGER            IP( NMAX ), IN(100)
      REAL               RW( NMAX ), S( NMAX )
      COMPLEX            A( NMAX, NMAX ), B( NMAX, NMAX ), W( NMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAMEN
      EXTERNAL           LSAMEN
*     ..
*     .. External Subroutines ..
      EXTERNAL           ALAESM, LA_TEST_CGELS, LA_TEST_CGELSD,
     &                   LA_TEST_CGELSS,
     $                   LA_TEST_CGELSX, LA_TEST_CGELSY, CHKXER
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      C2 = PATH( 2: 3 )
      A( 1, 1 ) = ( 1.0E+0, 0.0E+0 )
      A( 1, 2 ) = ( 2.0E+0, 0.0E+0 )
      A( 2, 2 ) = ( 3.0E+0, 0.0E+0 )
      A( 2, 1 ) = ( 4.0E+0, 0.0E+0 )
      OK = .TRUE.
      WRITE( NOUT, FMT = * )
*
*     Test error exits for the least squares driver routines.
*
      IF( LSAMEN( 2, C2, 'LS' ) ) THEN
*
*        CGELS
*
        SRNAMT = 'CGELS '
        DO I = 2, 3
          IN(I) = 1
        END DO
        DO I = 2, 3
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_CGELS('N', NMAX, NMAX, NRHS, A,
     &          NMAX, B, NMAX, A(1,1), NMAX, INFO )
              CALL CHKXER( 'CGELS ', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_CGELS('T', NMAX, NMAX, NRHS, A, NMAX, B,
     &          NMAX, A(1,1), NMAX, INFO )
              CALL CHKXER( 'CGELS ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO 


*        CGELSS
*
        SRNAMT = 'CGELSS'
        DO I = 2, 4
          IN(I) = 1
         END DO
         DO I = 2, 4
           IF (I /= 3) THEN
             INFOT = I
             DO J = 1, IN(I)
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_CGELSS( NMAX, NMAX, NRHS, A,
     &             NMAX, B, NMAX, S, RCOND,
     &             IRNK, W, 1 , RW, INFO )
                 CALL CHKXER( 'CGELSS ', INFOT, NOUT, LERR, OK )
               END DO
             END DO
           END IF
         END DO 


*        CGELSX
*
         SRNAMT = 'CGELSX'
         DO I = 2, 4
           IN(I) = 1
         END DO
         DO I = 2, 4
          IF (I /= 3) THEN
             INFOT = I
            DO J = 1, IN(I)
              DO NRHS = 1, 2
                INFO = J + 100*I
                 CALL LA_TEST_CGELSX( NMAX, NMAX, NRHS, A,
     &             NMAX, B, NMAX, A(1,1), RCOND,
     &             IRNK, W, RW, INFO )
                 CALL CHKXER( 'CGELSX ', INFOT, NOUT, LERR, OK )
               END DO
             END DO
          END IF
         END DO
*
*        CGELSY
*
         SRNAMT = 'CGELSY'
         DO I = 2 , 4
           IN(I) = 1
         END DO
         DO I = 2, 4
           IF (I /= 3) THEN
             INFOT = I
             DO J = 1, IN(I)
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_CGELSY( NMAX, NMAX, NRHS, A, NMAX, B,
     &             NMAX, IP, RCOND, IRNK, W, 10, RW, INFO )
                 CALL CHKXER( 'CGELSY', INFOT, NOUT, LERR, OK )
               ENDDO
             ENDDO
           ENDIF
         ENDDO    
         
!         INFOT = 1
!         CALL CGELSY( -1, 0, 0, A, 1, B, 1, IP, RCOND, IRNK, W, 10, RW,
!     $                INFO )
!         CALL CHKXER( 'CGELSY', INFOT, NOUT, LERR, OK )
!         INFOT = 2
!         CALL CGELSY( 0, -1, 0, A, 1, B, 1, IP, RCOND, IRNK, W, 10, RW,
!     $                INFO )
!         CALL CHKXER( 'CGELSY', INFOT, NOUT, LERR, OK )
!         INFOT = 3
!         CALL CGELSY( 0, 0, -1, A, 1, B, 1, IP, RCOND, IRNK, W, 10, RW,
!     $                INFO )
!         CALL CHKXER( 'CGELSY', INFOT, NOUT, LERR, OK )
!         INFOT = 5
!         CALL CGELSY( 2, 0, 0, A, 1, B, 2, IP, RCOND, IRNK, W, 10, RW,
!     $                INFO )
!         CALL CHKXER( 'CGELSY', INFOT, NOUT, LERR, OK )
!         INFOT = 7
!         CALL CGELSY( 2, 0, 0, A, 2, B, 1, IP, RCOND, IRNK, W, 10, RW,
!     $                INFO )
!         CALL CHKXER( 'CGELSY', INFOT, NOUT, LERR, OK )
!         INFOT = 12
!         CALL CGELSY( 0, 3, 0, A, 1, B, 3, IP, RCOND, IRNK, W, 1, RW,
!     $                INFO )
!         CALL CHKXER( 'CGELSY', INFOT, NOUT, LERR, OK )
*
*        CGELSD
*
         SRNAMT = 'CGELSD'
         DO I = 2, 4
           IN(I) = 1
         END DO
         DO I = 2, 4
           IF (I /= 3) THEN
             INFOT = I
             DO J = 1, IN(I)
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_CGELSD( NMAX, NMAX, NRHS, A, NMAX, B,
     &             NMAX, S, RCOND, IRNK, W, 10, RW,
     &             IP, INFO )
                 CALL CHKXER( 'CGELSD', INFOT, NOUT, LERR, OK )
               ENDDO
             ENDDO
           ENDIF
         ENDDO    
         
!         INFOT = 1
!         CALL CGELSD( -1, 0, 0, A, 1, B, 1, S, RCOND, IRNK, W, 10,
!     $                RW, IP, INFO )
!         CALL CHKXER( 'CGELSD', INFOT, NOUT, LERR, OK )
!         INFOT = 2
!         CALL CGELSD( 0, -1, 0, A, 1, B, 1, S, RCOND, IRNK, W, 10,
!     $                RW, IP, INFO )
!         CALL CHKXER( 'CGELSD', INFOT, NOUT, LERR, OK )
!         INFOT = 3
!         CALL CGELSD( 0, 0, -1, A, 1, B, 1, S, RCOND, IRNK, W, 10,
!     $                RW, IP, INFO )
!         CALL CHKXER( 'CGELSD', INFOT, NOUT, LERR, OK )
!         INFOT = 5
!         CALL CGELSD( 2, 0, 0, A, 1, B, 2, S, RCOND, IRNK, W, 10,
!     $                RW, IP, INFO )
!         CALL CHKXER( 'CGELSD', INFOT, NOUT, LERR, OK )
!         INFOT = 7
!         CALL CGELSD( 2, 0, 0, A, 2, B, 1, S, RCOND, IRNK, W, 10,
!     $                RW, IP, INFO )
!         CALL CHKXER( 'CGELSD', INFOT, NOUT, LERR, OK )
!         INFOT = 12
!         CALL CGELSD( 2, 2, 1, A, 2, B, 2, S, RCOND, IRNK, W, 1,
!     $                RW, IP, INFO )
!         CALL CHKXER( 'CGELSD', INFOT, NOUT, LERR, OK )
      END IF
*
*     Print a summary line.
*
      CALL ALAESM( PATH, OK, NOUT )
*
      RETURN
*
*     End of CERRLS
*
      END

SUBROUTINE LA_TEST_SSTEVD( JOBS, N, D, E, Z, LDZ, WORK, LWORK, IWORK, LIWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 29, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_STEVD
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDZ, LWORK, LIWORK
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBS
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: D(1:N), E(1:N)
   REAL(WP), INTENT(OUT)::  Z(1:LDZ, 1:N), WORK(1: LWORK)
   INTEGER, INTENT(OUT) :: IWORK(1: LIWORK)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_STEVD'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SSTEVD'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IE, IZ1, IZ2, ID
   CHARACTER*1 :: IJOBS   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   logical lsame
!  .. Executable Statements ..
   IJOBS = JOBS; ID = N; IE = N; IZ1 = MAX (1,N); IZ2 = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (2)
       IE = IE - 1
     CASE (3)
       IZ1 = IZ1 - 1
       IJOBS = 'V'
     CASE(:-1,1,4:)
       CALL UESTOP(SRNAMT)
   END SELECT
   IF (LSAME(IJOBS,'V')) THEN
     CALL LA_STEVD( D(1:ID), E(1:IE), Z(1:IZ1, 1:IZ2), INFO)
   ELSE
     CALL LA_STEVD( D(1:ID), E(1:IE), INFO=INFO)
   END IF

   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_SSTEVD
      
      

      PROGRAM LA_SPPSVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements"
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_PPSVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N, NN, NRHS
      REAL(WP) :: RCOND
!  .. Local Arrays ..
      REAL(WP), ALLOCATABLE :: A(:), B(:,:),X(:,:), FERR(:), BERR(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SPPSVX Example Program Results.'
      N = 5; NRHS = 1
      NN = N*(N+1)/2
      ALLOCATE ( A(NN), B(N,NRHS), X(N,NRHS),FERR(NRHS), BERR(NRHS) )
 
      OPEN(UNIT=21,FILE='posv.ma',STATUS='UNKNOWN')
      DO I=1,NN
         READ(21,'(F3.0)') A(I);
      ENDDO;
      CLOSE(21)
  
      WRITE(*,*) 'The array A :'
      DO I=1,NN
      WRITE(*,'(10(I3,1X,1X),I3,1X)') INT(A(I)); 
      ENDDO

      OPEN(UNIT=21,FILE='ppsv.mb',STATUS='UNKNOWN')
      DO I=1,N
      DO J=1,NRHS
         READ(21,'(F3.0)') B(I,J);
      ENDDO;
      ENDDO;
      CLOSE(21)
  
      WRITE(*,*) 'The array B :'
      DO I=1,N
      WRITE(*,'(10(I3,1X,1X),I3,1X)') INT(B(I,:)); 
      ENDDO;

      WRITE(*,*) 'CALL LA_PPSVX( A, B, X, "L", FERR=FERR, BERR=BERR, RCOND=RCOND )'
      CALL LA_PPSVX(  A, B, X, 'L', FERR=FERR, BERR=BERR, RCOND=RCOND )

      WRITE(*,*)'X on exit :'
      DO I=1,N; WRITE(*,"(5(E13.6))") X(I,:); 
      ENDDO
      WRITE(*,*)'FERR on exit :'
      DO I=1,NRHS; WRITE(*,"(5(E13.6))") FERR(I); 
      ENDDO
      WRITE(*,*)'BERR = '
      DO I=1,NRHS; WRITE(*,"(5(E13.6))") BERR(I); 
      ENDDO
      WRITE(*,*)'RCOND = ', RCOND

      WRITE(*,*) '\noindent'
      WRITE(*,*) 'The solution of the system $ A\,X = B $ is:'
      WRITE(*,*) '$$ X = \left( \begin{array}{rrr}'
      DO I=1,N; WRITE(*,"(2(F9.5,' & '),F9.5,' \\')") X(I,:); ENDDO
      WRITE(*,*) '\end{array} \right). $$'
   
      END PROGRAM LA_SPPSVX_EXAMPLE

SUBROUTINE LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     October 31, 1996
!
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   CHARACTER(LEN=*), INTENT(IN) :: SRNAMT
   INTEGER, INTENT(IN) :: I
   LOGICAL, INTENT(INOUT) :: CTEST, ETEST
!  .. Executable Statements ..
   IF( I == 0 )THEN
      IF( CTEST ) THEN
         WRITE(*,*)'Computational tests of the procedure ', SRNAMT
         CTEST = .FALSE.
      END IF
   ELSE
      IF( ETEST )THEN
         WRITE(*,*)'Error exit tests of the procedure ', SRNAMT
         ETEST = .FALSE.
      END IF
   END IF
END SUBROUTINE LA_AUX_AA01

      PROGRAM LA_SSBGV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SBGV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N, KD
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), W(:), Z(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_SBGV Example Program Results'
      N = 5; KD = 2;
      ALLOCATE( A(KD+1,N), B(KD+1,N), W(N), Z(N,N) )

      OPEN(UNIT=21,FILE='sbgvu.ma',STATUS='UNKNOWN')
      DO I=1,KD+1 
         DO J=1,N
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix AB : '
      DO I=1,KD+1; 
         WRITE(*,"(5(I3,1X))") INT(A(I,:)); 
      ENDDO
    
      OPEN(UNIT=21,FILE='sbgvu.mb',STATUS='UNKNOWN')
      DO I=1,KD+1 
         DO J=1,N
            READ(21,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix BB : '
      DO I=1,KD+1; 
         WRITE(*,"(5(I3,1X))") INT(B(I,:)); 
      ENDDO
  
      WRITE(*,*) 'CALL LA_SBGV( AB, BB, W )'
      CALL LA_SBGV(  A, B, W)
    
      WRITE(*,*) 'W on exit : '
      DO I=1,N
         WRITE(*,"(5(E14.6,1X))") W(I)
      ENDDO

      WRITE(*,*) 'BB on exit : '
      DO I=1,KD+1; 
         WRITE(*,"(5(E14.6,1X))") B(I,:); 
      ENDDO
    
      WRITE(*,*)
      WRITE(*,*) ' * EXAMPLE 2 * '

      OPEN(UNIT=21,FILE='sbgvl.ma',STATUS='UNKNOWN')
      DO I=1,KD+1 
         DO J=1,N
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix AB : '
      DO I=1,KD+1; 
         WRITE(*,"(5(I3,1X))") INT(A(I,:)); 
      ENDDO
    

      OPEN(UNIT=21,FILE='sbgvl.mb',STATUS='UNKNOWN')
      DO I=1,KD+1 
         DO J=1,N
            READ(21,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix BB : '
      DO I=1,KD+1; 
         WRITE(*,"(5(I3,1X))") INT(B(I,:)); 
      ENDDO
   
      WRITE(*,*) "CALL LA_SBGV( AB, BB, W, 'L', Z, INFO )"
      CALL LA_SBGV( A, B, W, 'L', Z, INFO )
      
      WRITE(*,*)'W on exit : '
      DO I=1,N
         WRITE(*,"(5(E14.6,1X))") W(I)
      ENDDO

      WRITE(*,*) 'Z on exit : '
      DO I=1,N; 
         WRITE(*,"(5(E14.6,1X))") Z(I,:); 
      ENDDO
   
      WRITE(*,*) ' INFO = ', INFO

      END PROGRAM LA_SSBGV_EXAMPLE

PROGRAM LA_SPOSV_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_POSV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, INFO, N, NRHS
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: A(:,:), B(:,:)
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'SPOSV ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, NRHS
   PRINT *, 'N = ', N, ' NRHS = ', NRHS
   ALLOCATE ( A(N,N), AA(N,N), B(N,NRHS), BB(N,NRHS) )
!
        READ (NIN, *) AA
      DO J = 1, NRHS
         BB(:,J) = SUM( AA, DIM=2)*J
      ENDDO
      DO I = 2, N
         AA(I,1:I-1) = 0.0_WP
      ENDDO
!
   A=AA; B=BB
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N
        WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,:)
      ENDDO
      WRITE(NOUT,*) 'The RHS matrix B:'
      DO J = 1, NRHS
        WRITE (NOUT,*) 'RHS', J; WRITE (NOUT,FMT) B(:,J)
      ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_SPOSV LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_POSV(A, B )'
   A=AA; B=BB
   IF (NRHS .GT. 1) THEN
      CALL LA_POSV( A, B )
   ELSE
      CALL LA_POSV( A, B(1:N,1) )
   END IF
   WRITE(NOUT,*)'   B - the solution vectors computed by LA_POSV:'
   DO J = 1, NRHS
      WRITE (NOUT,FMT) B(:,J)
   END DO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_POSV( A, B, ''L'' )'
   A=TRANSPOSE(AA); B=BB
   CALL LA_POSV( A, B, 'L' )
   WRITE(NOUT,*)'   B - the solution vectors computed by LA_POSV:'
   DO J = 1, NRHS
      WRITE (NOUT,FMT) B(:,J)
   END DO
   A=AA; B=BB
   CALL LA_POSV( A, B(1:N,1), 'U', INFO )
   WRITE(NOUT,*)'B - the solution vectors computed by LA_POSV, INFO = ', INFO
   WRITE (NOUT,FMT) B(1:N,1)
!
END PROGRAM LA_SPOSV_ET_EXAMPLE

PROGRAM LA_SPBSVX_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_PBSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: EQU
   INTEGER :: I, J, K, INFO, N, NRHS, KD
   REAL(WP) :: RCOND
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), X(:,:), AF(:,:)
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:), S(:), FERR(:), BERR(:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'SPBSVX ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, KD, NRHS
   PRINT *, 'N = ', N, ' NRHS = ', NRHS
   ALLOCATE ( A(KD+1,N), AA(KD+1,N), B(N,NRHS), BB(N,NRHS), X(N,NRHS), AF(KD+1,N), &
              S(N), FERR(NRHS), BERR(NRHS) )
!
      AA = HUGE(1.0_WP)
      DO I = 1, KD+1
        READ (NIN, *) (AA(I, J), J = KD-I+2, N)
      ENDDO
!     DO J = 1, NRHS
!        BB(:,J) = SUM( AA, DIM=2)*J
!     ENDDO
      B = 0.0_WP
      DO K = 1, NRHS
         DO I = 1, N
            DO J = MAX(1,-N+I+KD+1), KD
!              PRINT *, K, I, J, I-J+KD+1, AA(J,I-J+KD+1)
               BB(I,K) = AA(J,I-J+KD+1) + BB(I,K)
            ENDDO
            DO J = MAX(1,KD+2-I), KD+1
               BB(I,K) = AA(J,I) + BB(I,K)
!              PRINT *, K, I, J, AA(J,I)
            ENDDO
         ENDDO
         BB(:,K) = BB(:,K)*K
      ENDDO
   A=AA; B=BB
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, KD+1
        WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) AA(I,1:N)
      ENDDO
      WRITE(NOUT,*) 'The RHS matrix B:'
      DO J = 1, NRHS
        WRITE (NOUT,*) 'RHS', J; WRITE (NOUT,FMT) BB(:,J)
      ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_SPBSVX LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSVX( A, B, X, INFO=INFO )'
   A=AA; B=BB
   CALL LA_PBSVX( A, B, X, INFO=INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PBSVX, INFO = ', INFO
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSVX( A, B(1:N,1), X(1:N,1), RCOND=RCOND, INFO=INFO )'
   A=AA; B=BB
   CALL LA_PBSVX( A, B(1:N,1), X(1:N,1), RCOND=RCOND, INFO=INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PBSVX, INFO = ', INFO
   WRITE (NOUT,FMT) X(:,1)
   WRITE(NOUT,*) 'RCOND = ', RCOND
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSVX( A, B, X )'
   A=AA; B=BB
   CALL LA_PBSVX( A, B, X )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PBSVX:'
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSVX(A, B(1:N,1), X(1:N,1) )'
   A=AA; B=BB
   CALL LA_PBSVX(A, B(1:N,1), X(1:N,1) )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PBSVX:'
   WRITE (NOUT,FMT) X(:,1)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSVX(A, B, X, ''L'', RCOND=RCOND)'
   B=BB; A = HUGE(1.0_WP)
   DO I = 1, KD+1
      A(I,1:N-I+1) = AA(KD+2-I,I:N)
      WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,1:N)
   ENDDO
   CALL LA_PBSVX( A, B, X, 'L', RCOND=RCOND)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PBSVX:'
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*) 'RCOND = ', RCOND
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSVX( A, B(1:N,1), X(1:N,1), ''L'', RCOND=RCOND )'
   B=BB; A = HUGE(1.0_WP)
   DO I = 1, KD+1; A(I,1:N-I+1) = AA(KD+2-I,I:N); ENDDO
   CALL LA_PBSVX( A, B(1:N,1), X(1:N,1), 'L', RCOND=RCOND )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PBSVX:'
   WRITE (NOUT,FMT) X(1:N,1)
   WRITE(NOUT,*) 'RCOND = ', RCOND
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSVX(A(:,:), B(1:N-1,:), X, INFO =INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_PBSVX( A(:,:), B(1:N-1,:), X, INFO=INFO)
   WRITE(NOUT,*)' INFO = ', INFO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSVX( A(4:4), B(1:N,1), X(1:N,1), INFO=INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_PBSVX( A(4:4,:), B(1:N,1), X(1:N,1), INFO=INFO )
   WRITE(NOUT,*)'   B - the RHS vector.'
   WRITE (NOUT,FMT) B(1:N,1)
   WRITE(NOUT,*)' INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSVX(A, B, X, FACT=''F'', INFO =INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_PBSVX( A, B, X, FACT='F', INFO=INFO)
   WRITE(NOUT,*)'   INFO = ', INFO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSVX( A, B(1:N,1), X(1:N,1), FACT=''4'', INFO=INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_PBSVX( A, B(1:N,1), X(1:N,1), FACT='4', INFO=INFO )
   WRITE(NOUT,*)'   INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PPSVX(A, B, X, ''U'', AF, ''N'', EQU, S, FERR, BERR, RCOND, INFO)'
   A=AA; B=BB; X=HUGE(1.0_WP); EQU = 'N'
   CALL LA_PBSVX(A, B, X, 'U', AF, 'N', EQU, S, FERR, BERR, RCOND, INFO)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PPSVX, INFO = ', INFO
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PPSVX(A, B(1:N,1), X(1:N,1), ''U'', AF, ''N'', EQU, S, ', &
                 'FERR, BERR, RCOND, INFO) '
   A=AA; B=BB; X=HUGE(1.0_WP); EQU = 'N'
   CALL LA_PBSVX(A, B(1:N,1), X(1:N,1), 'U', AF, 'N', EQU, S, FERR(1), BERR(1), RCOND, INFO)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_PPSVX, INFO = ', INFO
   WRITE (NOUT,FMT) X(1:N,1)
!
END PROGRAM LA_SPBSVX_ET_EXAMPLE

      PROGRAM LA_SSYEVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SYEVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, M, N
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), W(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_SYEVX Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), W(N) )

      OPEN(UNIT=21,FILE='syev.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=A

      WRITE(*,*)'Matrix A:'
      DO I=1,N; 
         WRITE(*,"(5(F9.5))") A(I,:); 
      ENDDO
   
      WRITE(*,*) 'CALL LA_SYEVX( A, W, VL=-7.0_WP, VU=7.0_WP, M=M, ABSTOL=1.0E-4_WP )'
      CALL LA_SYEVX( A, W, VL=-7.0_WP, VU=7.0_WP, M=M, ABSTOL=1.0E-4_WP )
      WRITE(*,*) 'W on exit'
      DO I=1,N
      WRITE(*,"(5(F9.5))") W(I)
      ENDDO
      WRITE(*,*)' M =',M

      END PROGRAM LA_SSYEVX_EXAMPLE

SUBROUTINE ZGERFS1_F95(A, AF, IPIV, B, X, TRANS, FERR, BERR, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: GERFS_F77 => LA_GERFS
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: FERR, BERR
!  .. ARRAY ARGUMENTS ..
   INTEGER, INTENT(IN) :: IPIV(:)
   COMPLEX(WP), INTENT(IN) :: A(:,:), AF(:,:)
   COMPLEX(WP), INTENT(IN) :: B(:)
   COMPLEX(WP), INTENT(INOUT) :: X(:)
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GERFS'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LTRANS
   INTEGER    :: N, LINFO, ISTAT, ISTAT1, LD
   REAL(WP) :: LFERR, LBERR
!  .. LOCAL ARRAYS ..
   REAL(WP), POINTER :: RWORK(:)
   COMPLEX(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; N = SIZE(A, 1); ISTAT = 0; LD = MAX(1,N)
   IF(PRESENT(TRANS))THEN; LTRANS = TRANS; ELSE; LTRANS='N'; END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE(A, 2) /= N .OR. N < 0 )THEN; LINFO = -1
   ELSE IF( SIZE(AF, 1) /= N .OR. SIZE(AF, 2) /= N )THEN; LINFO = -2
   ELSE IF( SIZE( IPIV ) /= N ) THEN; LINFO = -3
   ELSE IF( SIZE(B) /= N ) THEN; LINFO = -4
   ELSE IF( SIZE(X) /= N ) THEN; LINFO = -5
   ELSE IF( .NOT.( LSAME(LTRANS,'N') .OR.  LSAME(LTRANS,'T') .OR. &
                  LSAME(LTRANS,'C') ) )THEN; LINFO = -6
   ELSE IF( N > 0 )THEN
      ALLOCATE( WORK(2*N), RWORK(N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
!        .. CALL LAPACK77 ROUTINE
         CALL GERFS_F77( LTRANS, N, 1, A, LD, AF, LD, IPIV, &
                    B, LD, X, LD, LFERR, LBERR, WORK, RWORK, LINFO )
         IF( PRESENT(FERR) ) FERR = LFERR
         IF( PRESENT(BERR) ) BERR = LBERR
      ELSE; LINFO = -100; END IF
      DEALLOCATE(WORK, RWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE ZGERFS1_F95

SUBROUTINE DSYEVD_F95( A, W, JOBZ, UPLO, INFO )
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: SYEVD_F77 => LA_SYEVD, ILAENV_F77 => ILAENV
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. CHARACTER ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:)
   REAL(WP), INTENT(OUT) :: W(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!      LA_SYEV and LA_SYEVD compute all eigenvalues and, optionally, all
! eigenvectors of a real symmetric matrix A.
!      LA_HEEV and LA_HEEVD compute all eigenvalues and, optionally, all
! eigenvectors of a complex Hermitian matrix A.
!      LA_SYEVD and LA_HEEVD use a divide and conquer algorithm. If 
! eigenvectors are desired, they can be much faster than LA_SYEV and 
! LA_HEEV for large matrices but use more workspace.
! 
! =========
! 
!       SUBROUTINE LA_SYEV / LA_HEEV / LA_SYEVD / LA_HEEVD( A, W, &
!                       JOBZ=jobz, UPLO=uplo, INFO=info )
!           <type>(<wp>), INTENT(INOUT) :: A(:,:)
!           REAL(<wp>), INTENT(OUT) :: W(:)
!           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
!           INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!           <type> ::= REAL | COMPLEX
!           <wp> ::= KIND(1.0) | KIND(1.0D0)
! 
! 
! Arguments
! =========
! 
! A      (input/output) REAL or COMPLEX square array, shape (:,:).
!        On entry, the matrix A.
!        If UPLO = 'U', the upper triangular part of A contains the upper
!        triangular part of the matrix A. If UPLO = 'L', the lower 
!        triangular part of A contains the lower triangular part of the
!        matrix A.
!        On exit:
!        If JOBZ = 'V', then the columns of A contain the orthonormal 
!        eigenvectors of the matrix A in the order of the eigenvalues.
!        If JOBZ = 'N', then the upper triangle (if UPLO = 'U') or the 
!        lower triangle (if UPLO = 'L') of A, including the diagonal, is
!        destroyed.
! W      (output) REAL array, shape (:) with size(W) = size(A,1).
!        The eigenvalues in ascending order.
! JOBZ   Optional (input) CHARACTER(LEN=1).
!        = 'N': Computes eigenvalues only;
!        = 'V': Computes eigenvalues and eigenvectors.
!        Default value: 'N'.
! UPLO   Optional (input) CHARACTER(LEN=1).
!        = 'U': Upper triangle of A is stored;
!        = 'L': Lower triangle of A is stored.
!        Default value: 'U'.
! INFO   Optional (output) INTEGER.
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value
!        > 0: if INFO = i, then i off-diagonal elements of an
!        intermediate tridiagonal form did not converge to zero.
!        If INFO is not present and an error occurs, then the program is 
!        terminated with an error message.
!-----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_SYEVD'
   CHARACTER(LEN=6), PARAMETER :: BSNAME = 'DSYTRD'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBZ, LUPLO
   INTEGER :: N, LINFO, LD, ISTAT, ISTAT1, LIWORK, LMWORK, LWORK, NB
!  .. LOCAL ARRAYS ..
   REAL(WP), POINTER :: WORK(:)
   INTEGER, POINTER :: IWORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT
!  .. EXECUTABLE STATEMENTS ..
   N = SIZE( A, 1 ); LINFO = 0; LD = MAX(1,N); ISTAT = 0
   IF( PRESENT(JOBZ) ) THEN
      LJOBZ = JOBZ
   ELSE
      LJOBZ = 'N'
   END IF
   IF( PRESENT(UPLO) ) THEN
      LUPLO = UPLO
   ELSE
      LUPLO = 'U'
   END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE( A, 2 ) /= N .OR. N < 0 )THEN
      LINFO = -1
   ELSE IF( SIZE( W ) /= N )THEN
      LINFO = -2
   ELSE IF( .NOT.LSAME(LJOBZ,'N') .AND. .NOT.LSAME(LJOBZ,'V') )THEN
      LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN
      LINFO = -4
   ELSE IF( N > 0 )THEN
!  .. DETERMINE THE WORKSPACE
      IF( LSAME(LJOBZ,'V') )THEN
         LMWORK = 1+6*N+2*N**2 
         LIWORK = 3+5*N
      ELSE
         LMWORK = 2*N+1
         LIWORK = 1
      END IF
      NB = ILAENV_F77( 1, BSNAME, LUPLO, N, -1, -1, -1 )
      IF( NB <= 1 .OR. NB >= N )THEN
         NB = 1
      END IF
      LWORK = MAX( LMWORK, (NB+2)*N )
      ALLOCATE(WORK(LWORK), IWORK(LIWORK), STAT=ISTAT)
      IF( ISTAT /= 0 )THEN
         DEALLOCATE(WORK, IWORK, STAT=ISTAT1)
         LWORK = LMWORK
         ALLOCATE(WORK(LWORK), IWORK(LIWORK), STAT=ISTAT)
         IF( ISTAT /= 0 ) THEN
            LINFO = - 100
         ELSE
            CALL ERINFO( -200, SRNAME, LINFO )
         ENDIF
      ENDIF
!
      IF( LINFO == 0 )THEN
!        .. CALL LAPACK77 ROUTINE
         CALL SYEVD_F77( LJOBZ, LUPLO, N, A, LD, W, WORK, LWORK, &
                         IWORK, LIWORK,  LINFO )
      ENDIF
      DEALLOCATE(WORK, IWORK, STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE DSYEVD_F95

PROGRAM LA_ZGESVD_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GESVD
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, INFO, M, N, MN
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), S(:), WW(:)
   COMPLEX(WP), ALLOCATABLE :: A(:,:), U(:,:), VT(:,:), DUMMY(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'ZGESVD ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) M, N
   PRINT *, 'M = ', M, ' N = ', N
   MN = MIN(M,N)
   ALLOCATE ( A(M,N), AA(M,N), S(MN), U(M,M), VT(N,N), WW(1:MN-1) )
!
      READ (NIN, *) AA
      A=AA
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, M; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,:); ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_ZGESVD LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U, VT, WW, ''N'', INFO )'
   A=AA
   CALL LA_GESVD( A, S, U, VT, WW, 'N', INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' Singular values:'
   WRITE(NOUT,FMT) S
   WRITE(NOUT,*) 'Orthogonal/unitary matrix U):'
   DO I = 1, M; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) U(:,I); END DO
   WRITE(NOUT,*) 'Orthogonal/unitary matrix V**H):'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VT(:,I); END DO
   IF( INFO > 0 )THEN
      WRITE(NOUT,*) 'Unconverged superdiagonal elements:'
      WRITE(NOUT,FMT) WW
   ENDIF
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U, VT, WW, ''U'', INFO )'
   A=AA
   CALL LA_GESVD( A, S, U, VT, WW, 'U', INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U, VT, WW, ''V'', INFO )'
   A=AA
   CALL LA_GESVD( A, S, U, VT, WW, 'V', INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U, VT, WW, ''B'', INFO )'
   A=AA
   CALL LA_GESVD( A, S, U, VT, WW, 'B', INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, VT=VT, WW=WW, JOB=''U'', INFO=INFO )'
   A=AA
   CALL LA_GESVD( A, S, VT=VT, WW=WW, JOB='U', INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U=U, WW=WW, JOB=''V'', INFO=INFO )'
   A=AA
   CALL LA_GESVD( A, S, U=U, WW=WW, JOB='V', INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, WW=WW, JOB=''V'', INFO=INFO )'
   A=AA
   CALL LA_GESVD( A, S, WW=WW, JOB='V', INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, WW=WW, JOB=''U'', INFO=INFO )'
   A=AA
   CALL LA_GESVD( A, S, WW=WW, JOB='U', INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, WW=WW, JOB=''N'', INFO=INFO )'
   A=AA
   CALL LA_GESVD( A, S, WW=WW, JOB='N', INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U, VT )'
   A=AA
   CALL LA_GESVD( A, S, U, VT )
   WRITE(NOUT,*) ' Singular values:'
   WRITE(NOUT,FMT) S
   WRITE(NOUT,*) 'Orthogonal/unitary matrix U):'
   DO I = 1, M; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) U(:,I); END DO
   WRITE(NOUT,*) 'Orthogonal/unitary matrix V**H):'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VT(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U(:,1:MN), VT(1:MN,:) )'
   A=AA; U = HUGE(1.0_WP); VT = HUGE(1.0_WP)
   CALL LA_GESVD( A, S, U(:,1:MN), VT(1:MN,:) )
   WRITE(NOUT,*) ' Singular values:'
   WRITE(NOUT,FMT) S
   WRITE(NOUT,*) 'Orthogonal/unitary matrix U):'
   DO I = 1, M; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) U(:,I); END DO
   WRITE(NOUT,*) 'Orthogonal/unitary matrix V**H):'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VT(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S )'
   A=AA
   CALL LA_GESVD( A, S )
   WRITE(NOUT,*) ' Singular values:'
   WRITE(NOUT,FMT) S
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( DUMMY, S, INFO=INFO )'
   A=AA
   CALL LA_GESVD( DUMMY, S, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S(1:MAX(M,N)+1), INFO=INFO )'
   A=AA
   CALL LA_GESVD( A, S(1:MAX(M,N)+1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U(1:M-1,:), VT, WW, ''N'',INFO )'
   A=AA
   CALL LA_GESVD( A, S, U(1:M-1,:), VT, WW, 'N', INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U(:,1:MN-1), VT, WW, ''N'',INFO )'
   A=AA
   CALL LA_GESVD( A, S, U(:,1:MN-1), VT, WW, 'N', INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U, VT(1:MN-1,:), WW, ''N'',INFO )'
   A=AA
   CALL LA_GESVD( A, S, U, VT(1:MN-1,:), WW, 'N', INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U, VT(:,1:N-1), WW, ''N'',INFO )'
   A=AA
   CALL LA_GESVD( A, S, U, VT(:,1:N-1), WW, 'N', INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVD( A, S, U, VT, WW(1:MN) )'
   A=AA
   CALL LA_GESVD( A, S, U, VT, WW(1:MN) )
!
END PROGRAM LA_ZGESVD_ET_EXAMPLE

SUBROUTINE LA_TEST_ZHPGV( ITYPE, JOBZ, UPLO, N, AP, BP, W, Z, LDZ, WORK, RWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 21, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_HPGV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, ITYPE, LDZ
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBZ, UPLO  
!  .. Array Arguments ..
   COMPLEX(WP), INTENT(INOUT) :: AP(1:N*(N+1)/2), BP(1: N*(N+1)/2)
   COMPLEX(WP), INTENT(OUT) ::Z(1: LDZ, 1: N)
   COMPLEX(WP) :: WORK(1: MAX(1, 2*N-1))
   REAL(WP), INTENT(OUT) :: W(1:N)
   REAL(WP) :: RWORK(1: MAX(1, 3*N-2))
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_HPGV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZHPGV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IAP, IBP, IZ1, IZ2, IW, IITYPE
   CHARACTER*1 :: IUPLO, IJOBZ   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IAP= N*(N+1)/2; IBP = N*(N+1)/2;  IUPLO= UPLO; IJOBZ = JOBZ
   IZ1 = MAX(1,N); IZ2 = N; IW= N
   IITYPE = ITYPE; 
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)

   CASE (1)
      IAP = IAP - 1
   CASE (2)
      IBP = IAP - 1
   CASE (3)
     IW = IW -1
   CASE (4)
     IITYPE = 22
   CASE (5)
     IUPLO = 'T'
   CASE (6)
     IZ2 = IZ2 - 1
   CASE(:-1,7:)
      CALL UESTOP(SRNAMT)
  END SELECT 
  IF (LSAME (IJOBZ ,'V')) THEN
    CALL LA_HPGV( AP(1:IAP), BP(1: IBP), W(1:IW), IITYPE, IUPLO, &
&     Z(1: IZ1, 1: IZ2), INFO)
  ELSE
    CALL LA_HPGV( AP(1:IAP), BP(1: IBP), W(1:IW), IITYPE, IUPLO, &
&     INFO = INFO)
  END IF
  
  CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_ZHPGV

      PROGRAM LA_SSTEV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_STEV, LA_STEVD
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: D(:), E(:), Z(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_STEV Example Program Results'
      N = 5; 
      ALLOCATE( D(N), E(N), Z(N,N) )

      OPEN(UNIT=21,FILE='stevd.ma',STATUS='UNKNOWN')
      DO J=1,N
         READ(21,*) D(J) 
      ENDDO
      CLOSE(21)
    
      OPEN(UNIT=21,FILE='steve.ma',STATUS='UNKNOWN')
      DO J=1,N
         READ(21,*) E(J) 
      ENDDO
      CLOSE(21)

      WRITE(*,*)' Vector D : '
      DO I=1,N
      WRITE(*,"(5(I5,1X))") INT(D(I))
      ENDDO

      WRITE(*,*)' Vector E : '
      DO I=1,N
      WRITE(*,"(5(I5,1X))") INT(E(I))
      ENDDO

      WRITE(*,*) 'CALL LA_STEV( D, E )'
      CALL LA_STEV( D, E )
      
      WRITE(*,*) ' D on exit : '
      DO I=1,N
      WRITE(*,"(5(F12.5,1X))") D(I)
      ENDDO
      WRITE(*,*)
      WRITE(*,*) ' * EXAMPLE 2 * '  
      
      OPEN(UNIT=21,FILE='stevd.ma',STATUS='UNKNOWN')
      DO J=1,N
         READ(21,*) D(J) 
      ENDDO
      CLOSE(21)

      OPEN(UNIT=21,FILE='steve.ma',STATUS='UNKNOWN')
      DO J=1,N
         READ(21,*) E(J) 
      ENDDO
      CLOSE(21)

      WRITE(*,*)' Vector D : '
      DO I=1,N
      WRITE(*,"(5(I5,1X))") INT(D(I))
      ENDDO

      WRITE(*,*)' Vector E : '
      DO I=1,N
      WRITE(*,"(5(I5,1X))") INT(E(I))
      ENDDO

      WRITE(*,*) "CALL LA_STEVD( D, E, Z, INFO )"
      CALL LA_STEVD( D, E, Z, INFO )
      
      WRITE(*,*)' Z on exit : '
      DO I=1,N; 
         WRITE(*,"(5(F12.6,1X))") Z(I,:); 
      ENDDO
      
      WRITE(*,*)' D on exit : ' 
      DO I=1,N
      WRITE(*,"(5(F12.5,1X))") D(I)
      ENDDO
      
      WRITE(*,*) ' INFO = ', INFO

      END PROGRAM LA_SSTEV_EXAMPLE

SUBROUTINE SPTSVX1_F95(D, E, B, X, DF, EF, FACT, FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: PTSVX_F77 => LA_PTSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(IN) :: D(:)
   REAL(WP), INTENT(IN) :: E(:), B(:)
   REAL(WP), INTENT(OUT) :: X(:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: DF(:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: EF(:)
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_PTSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT
   INTEGER :: LINFO, N, ISTAT, ISTAT1, SDF, SEF
   REAL(WP) :: LRCOND, LFERR, LBERR
!  .. LOCAL POINTERS ..
   REAL(WP),  POINTER :: LDF(:)
   REAL(WP),  POINTER :: WORK(:), LEF(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0
   N = SIZE(D)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(DF) )THEN; SDF = SIZE(DF); ELSE; SDF = N; END IF
   IF( PRESENT(EF) )THEN; SEF = SIZE(EF); ELSE; SEF = N-1; END IF
!  .. TEST THE ARGUMENTS
   IF( N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE( E ) /= N-1 .AND. N /= 0 ) THEN; LINFO = -2
   ELSE IF( SIZE(B) /= N )THEN; LINFO = -3
   ELSE IF( SIZE(X) /= N )THEN; LINFO = -4
   ELSE IF( SDF /= N ) THEN; LINFO = -5
   ELSE IF( .NOT.( PRESENT(DF).AND.PRESENT(EF) ) &
       .AND.( PRESENT(DF).OR.PRESENT(EF) ) )THEN; LINFO = -5
   ELSE IF( SEF /= N-1 .AND. N>0 ) THEN; LINFO = -6
   ELSE IF( ( .NOT.LSAME(LFACT,'F') .AND. .NOT.LSAME(LFACT,'N') ) .OR. &
            ( LSAME(LFACT,'F') .AND. .NOT.PRESENT(DF) ) )THEN; LINFO = -7
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(DF) ) THEN; ALLOCATE( LDF(N), LEF(N-1), STAT=ISTAT )
      ELSE; LDF => DF; LEF => EF; END IF
      IF( ISTAT == 0 ) ALLOCATE(WORK(2*N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
         CALL PTSVX_F77( LFACT, N, 1, D, E, LDF, LEF, B, N, X, N, LRCOND, &
                         LFERR, LBERR, WORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(DF) ) DEALLOCATE( LDF, LEF, STAT=ISTAT1 )
      IF( PRESENT(FERR) ) FERR = LFERR
      IF( PRESENT(BERR) ) BERR = LBERR
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      DEALLOCATE( WORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE SPTSVX1_F95

      PROGRAM LA_SGESVD_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GESVD
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, M, N
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), S(:), U(:,:), V(:,:), VT(:,:), WW(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GESVD Example Program Results'
      N = 5; M=3
      ALLOCATE( A(M,N), AA(M,N), S(MIN(M,N)), U(M,M), V(N,N), VT(N,N), WW(MIN(M,N)-1)) 

      OPEN(UNIT=21,FILE='gesvd.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,M 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=A

      WRITE(*,*)'Matrix A:'
      DO I=1,M; WRITE(*,"(5(I3,1X))") INT(A(I,:)); ENDDO
 
      WRITE(*,*)
      WRITE(*,*) 'CALL LA_GESVD( A, S )'
!      CALL LA_GESVD( A, S )
     
      WRITE(*,*) 'S on exit : '
      WRITE(*,"(3(F10.5,1X))") S(:)
     
      WRITE(*,*)
      WRITE(*,*)' * EXAMPLE 2 * '
      WRITE(*,*) "CALL LA_GESVD( A, S, VT=VT, WW=WW, JOB='U', INFO=INFO )"
      CALL LA_GESVD( AA, S, VT=VT, WW=WW, JOB='U', INFO=INFO )
      
      WRITE(*,*) 'A on exit : '
      DO I=1,M; 
         WRITE(*,"(5(E14.6,1X))") AA(I,:); 
      ENDDO
 
      WRITE(*,*) 'VT on exit : '
      DO I=1,N; 
         WRITE(*,"(5(E14.6,1X))") VT(I,:); 
      ENDDO
    
      WRITE(*,*)'WW on exit : '
      WRITE(*,"(5(E14.6,1X))") WW(:)

      WRITE(*,*) ' INFO = ', INFO

      END PROGRAM LA_SGESVD_EXAMPLE

FUNCTION DLAMCH_F95( PRECISION, CMACH, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. "Use Statements" ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: DLAMCH
!  .. "Implicit Statement" ..
   IMPLICIT NONE
!  .. "Scalar Arguments" ..
   CHARACTER(LEN=1), INTENT(IN) :: CMACH
   REAL(WP), INTENT(IN) :: PRECISION
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP) :: DLAMCH_F95
!--------------------------------------------------
! .. "Parameters" ..
   CHARACTER( LEN=10 ), PARAMETER :: CHR='ESBPNRMULO'
   CHARACTER( LEN=10 ), PARAMETER :: SRNAME = 'LA_LAMCH'
! .. "Local Scalars" ..
   INTEGER :: I, LINFO
!  .. "Executable Statements" ..
   LINFO = 2; DLAMCH_F95 = PRECISION
   DO I = 1, 10
     IF( LSAME(CMACH, CHR(I:I)) ) LINFO = 0
   END DO
   DLAMCH_F95 = DLAMCH(CMACH)
   CALL ERINFO( LINFO, SRNAME, INFO )
END FUNCTION DLAMCH_F95

SUBROUTINE DGGGLM_F95( A, B, D, X, Y, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO
    USE F77_LAPACK, ONLY: GGGLM_F77 => LA_GGGLM
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:), D(:)
    REAL(WP), INTENT(OUT) :: X(:), Y(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!        LA_GGGLM solves the general (Gauss-Markov) linear model (GLM) 
! problem:
!      min ||y||2  subject to d=A*x + B*y
!       x
! where A and B are real or complex rectangular matrices and d is a real
! or complex vector. Further, A is n by m, B is n by p, and d is n by 1,
! and it is assumed that m <= n <= m+p, rank(A) = m, rank(A, B) = n.
! These conditions ensure that the GLM problem has unique solution 
! vectors x and y. The problem is solved using the generalized QR 
! factorization of A and B.
!        If matrix B is square and nonsingular, then the GLM problem is 
! equivalent to the weighted linear least squares problem
!         min ||B^-1 * (d-A*x)||2 
! 	   x
! 
! =========
! 
!       SUBROUTINE LA_GGGLM( A, B, D, X, Y, INFO=info )
!           <type>(<wp>), INTENT( INOUT ) :: A( :, : ), B(:,:), D(:)
!           <type>(<wp>), INTENT( OUT ) :: X(:), Y(:)
!           INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!           <type> ::= REAL | COMPLEX
!           <wp>   ::= KIND(1.0) | KIND(1.0D0)
! 
! 
! Arguments
! =========
! 
! A     (input/output) REAL or COMPLEX array, shape (:,:) with 
!       size(A,1) = n and size(A,2) = m.
!       On entry, the matrix A.
!       On exit, the contents of A are destroyed.
! B     (input/output) REAL or COMPLEX array, shape (:,:) with 
!       size(B,1) = n and size(B,2) = p.
!       On entry, the matrix B.
!       On exit, the contents of B are destroyed.
! D     (input/output) REAL or COMPLEX array, shape (:) with 
!       size(D) = n.
!       On entry, the vector d.
!       On exit, the contents of D are destroyed.
! X     (output) REAL or COMPLEX array, shape (:) with size(X) = m.
!       The solution vector x.
! Y     (output) REAL or COMPLEX array, shape (:) with size(Y) = p.
!       The solution vector y.
! INFO  Optional (output) INTEGER.
!       = 0: successful exit
!       < 0: if INFO = -i, the i-th argument had an illegal value.
!       If INFO is not present and an error occurs, then the program is
!       terminated with an error message.
!----------------------------------------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GGGLM'
!   .. LOCAL SCALARS ..
    INTEGER :: LINFO, ISTAT, ISTAT1, N, M, MN, P
!   .. LOCAL SAVE SCALARS ..
    INTEGER, SAVE :: LWORK = 0
!   .. LOCAL POINTERS ..
    REAL(WP), POINTER :: WORK(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, MAX, MIN
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; N = SIZE(A,1); M = SIZE(A,2); P = SIZE(B,2)
    MN = MIN(M,N)
!   .. TEST THE ARGUMENTS
    IF( M < 0 .OR. N < M ) THEN; LINFO = -1
    ELSE IF( P < 0 .OR. P < N-M .OR. SIZE(B,1) /= N ) THEN; LINFO = -2
    ELSE IF( SIZE(D) /= N ) THEN; LINFO = -3
    ELSE IF( SIZE(X) /= M ) THEN; LINFO = -4
    ELSE IF( SIZE(Y) /= P ) THEN; LINFO = -5
    ELSE
       LWORK = MAX( 1, M + N + P , LWORK )
       ALLOCATE( WORK(LWORK), STAT = ISTAT )
       IF( ISTAT /= 0 ) THEN
          DEALLOCATE( WORK, STAT=ISTAT1 )
          LWORK = MAX( 1, M + N + P )
          ALLOCATE( WORK(LWORK), STAT = ISTAT )
          IF( ISTAT == 0 ) CALL ERINFO( -200, SRNAME, LINFO )
       END IF
       IF ( ISTAT == 0 ) THEN
!      .. CALL LAPACK77 ROUTINE
          CALL GGGLM_F77( N, M, P, A, MAX(1,N), B, MAX(1,N), &
                          D, X, Y, WORK, LWORK, LINFO )
          IF( LINFO == 0 ) LWORK = INT( WORK(1) )
       ELSE; LINFO = -100; END IF
       DEALLOCATE(WORK, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE DGGGLM_F95

SUBROUTINE ZUNGTR_F95( A, TAU, UPLO, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: UNGTR_F77 => LA_UNGTR, ILAENV_F77 => LA_ILAENV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. CHARACTER ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(IN) :: TAU(:)
   COMPLEX(WP), INTENT(INOUT) :: A(:,:)
!-----------------------------------------------------------------
!
! Purpose
! =======
!
! LA_ORGTR / LA_UNGTR generates a real orthogonal / complex unitary
! matrix Q which is defined as the product of elementary reflectors,
! as returned by LA_SYTRD / LA_HETRD:
! 
! if UPLO = 'U', Q = H(n-1) . . . H(2) H(1),
!
! if UPLO = 'L', Q = H(1) H(2) . . . H(n-1).
!
! =======
!
!    SUBROUTINE LA_ORGTR / LA_UNGTR( A, TAU, UPLO, INFO )
!    .. Scalar Arguments ..
!       CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!       INTEGER, INTENT(OUT), OPTIONAL :: INFO
!    .. Array Arguments ..
!       <type>(<wp>), INTENT(IN) :: TAU(:)
!       <type>(<wp>), INTENT(INOUT) :: A(:,:)
!    where
!       <type> ::= REAL | COMPLEX
!       <wp>   ::= KIND(1.0) | KIND(1.0D0)
!
! Defaults
! ========
!
! 1. If UPLO is not present then UPLO = 'U' is assumed.
!
! Arguments
! =========
!
! A       (input/output) either REAL or COMPLEX square array, 
!         shape (:,:), size(A,1) == size(A,2) >= 0.
!         On entry, the vectors which define the elementary
!            reflectors, as returned by LA_SYTRD or LA_HETRD.
!         On exit the orthogonal or unitary matrix Q.
!
! TAU     (input) either REAL or COMPLEX array,
!         shape (:), size(TAU) == size(A,1)-1.
!         TAU(i) must contain the scalar factor of the elementary
!         reflector H(i), as returned by LA_SYTRD or LA_HETRD.
!
! UPLO    Optional, (input) CHARACTER*1
!         If UPLO is present then:
!            = 'U':  Upper triangle of A is stored
!            = 'L':  Lower triangle of A is stored
!         otherwise UPLO = 'U' is assumed.
!
! INFO    Optional, (output) INTEGER
!         If INFO is present:
!            = 0: successful exit
!            < 0: if INFO = -i, the i-th argument had an illegal value
!         If INFO is not present and an error occurs, then the program
!            is terminated with an error message.
!
! ----------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_UNGTR'
   CHARACTER(LEN=5), PARAMETER :: BSNAM  = 'ZUNGQ'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LUPLO
   CHARACTER(LEN=6) :: BSNAME
   INTEGER :: LINFO, LWORK, NB, ISTAT, ISTAT1, N, LD
!  .. LOCAL ARRAYS ..
   COMPLEX(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; N = SIZE(A,1); LD = MAX(1,N); ISTAT = 0
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE( A, 2 ) /= N .OR. N < 0 )THEN; LINFO = -1
   ELSE IF( SIZE( TAU ) /= N-1 )THEN; LINFO = -2
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
   ELSE IF( N > 0 )THEN
!     .. DETERMINE THE WORKSPACE
      IF( LSAME(LUPLO,'U') )THEN; BSNAME = BSNAM // 'L'
      ELSE; BSNAME = BSNAM // 'R'; ENDIF
      NB = ILAENV_F77( 1, BSNAME, ' ', N-1, N-1, N-1, -1 )
      IF( NB < 1 .OR. NB >= N ) NB = 1
      LWORK = MAX( 1, (N-1)*NB ); ALLOCATE(WORK(LWORK), STAT=ISTAT)
      IF( ISTAT /= 0 )THEN; DEALLOCATE(WORK, STAT=ISTAT)
         LWORK = MAX( 1, N-1 ); ALLOCATE(WORK(LWORK), STAT=ISTAT)
         IF( ISTAT == 0 ) CALL ERINFO( -200, SRNAME, LINFO )
      ENDIF
      IF( ISTAT == 0 )THEN
!     .. CALL LAPACK77 ROUTINE
         CALL UNGTR_F77( LUPLO, N, A, LD, TAU, WORK, LWORK, LINFO )
      ELSE; LINFO = -100; ENDIF
      DEALLOCATE(WORK, STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO, SRNAME, INFO, ISTAT)
END SUBROUTINE ZUNGTR_F95

PROGRAM LA_ZGGSVD_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GGSVD
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, INFO, M, P, N, K, L
!  .. LOCAL ARRAYS ..
   INTEGER :: IWORK(1:50)
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:), ALPHA(:), BETA(:)
   COMPLEX(WP), ALLOCATABLE :: A(:,:), B(:,:), U(:,:), V(:,:), Q(:,:), DUMMY(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'ZGGSVD ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) M, N, P
   PRINT *, 'M = ', M, ' N = ', N, ' P = ', P
   ALLOCATE ( A(M,N), AA(M,N), B(P,N), BB(P,N), ALPHA(N), BETA(N), &
              U(M,M), V(P,P), Q(N,N) )
!
   READ (NIN, *) AA, BB
   A=AA; B=BB
   WRITE(NOUT,*) 'The matrix A:'
   DO I = 1, M; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,:); ENDDO
   WRITE(NOUT,*) 'The matrix B:'
   DO I = 1, P; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) B(I,:); ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_ZGGSVD LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGSVD( A, B, ALPHA, BETA, K, L, U, V, Q, IWORK, INFO ) '
   A=AA; B=BB
   CALL LA_GGSVD( A, B, ALPHA, BETA, K, L, U, V, Q,IWORK, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' K = ', K, ' L = ', L
   WRITE(NOUT,*) ' Alpha'
   WRITE(NOUT,FMT) ALPHA
   WRITE(NOUT,*) ' Beta:'
   WRITE(NOUT,FMT) BETA
   WRITE(NOUT,*) 'U:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) U(:,I); END DO
   WRITE(NOUT,*) 'V:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) V(:,I); END DO
   WRITE(NOUT,*) 'Q:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Q(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGSVD( A, B, ALPHA, BETA, INFO=INFO ) '
   A=AA; B=BB
   CALL LA_GGSVD( A, B, ALPHA, BETA, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   WRITE(NOUT,*) ' Alpha'
   WRITE(NOUT,FMT) ALPHA
   WRITE(NOUT,*) ' Beta:'
   WRITE(NOUT,FMT) BETA
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGSVD( DUMMY, B, ALPHA, BETA, K, L, U, V, Q, IWORK, INFO ) '
   A=AA; B=BB
   CALL LA_GGSVD( DUMMY, B, ALPHA, BETA, K, L, U, V, Q,IWORK, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGSVD( A, B(:,1:N-1), ALPHA, BETA, K, L, U, V, Q, IWORK, INFO ) '
   A=AA; B=BB
   CALL LA_GGSVD( A, B(:,1:N-1), ALPHA, BETA, K, L, U, V, Q, IWORK,INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGSVD( A, B, ALPHA(1:N-1), BETA, K, L, U, V, Q, IWORK, INFO ) '
   A=AA; B=BB
   CALL LA_GGSVD( A, B, ALPHA(1:N-1), BETA, K, L, U, V, Q, IWORK,INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGSVD( A, B, ALPHA, BETA(1:N-1), K, L, U, V, Q,IWORK, INFO ) '
   A=AA; B=BB
   CALL LA_GGSVD( A, B, ALPHA, BETA(1:N-1), K, L, U, V, Q, IWORK,INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGSVD( A, B, ALPHA, BETA, K, L, U(1:N,:), V, Q,IWORK, INFO ) '
   A=AA; B=BB
   CALL LA_GGSVD( A, B, ALPHA, BETA, K, L, U(1:N,:), V, Q, IWORK,INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGSV(:,1:M)D( A, B, ALPHA, BETA, K, L, U, V, Q,IWORK, INFO ) '
   A=AA; B=BB
   CALL LA_GGSVD( A, B, ALPHA, BETA, K, L, U, V(:,1:M), Q, IWORK,INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGSVD( A, B, ALPHA, BETA, K, L, U, V, Q(:,1:P), IWORK,INFO ) '
   A=AA; B=BB
   CALL LA_GGSVD( A, B, ALPHA, BETA, K, L, U, V, Q(:,1:P),IWORK, INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
!
END PROGRAM LA_ZGGSVD_ET_EXAMPLE

PROGRAM LA_ZHBEVD_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_HBEVD
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, INFO, N, KD
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), W(:)
   COMPLEX(WP), ALLOCATABLE :: A(:,:), Z(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'ZHBEVD ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, KD
   PRINT *, 'N = ', N, ' KD = ', KD
   ALLOCATE ( A(KD+1,N), AA(KD+1,N), W(N), Z(N,N) )
!
   AA = HUGE(1.0_WP)
   DO I = 1, KD+1
      READ (NIN, *) (AA(I, J), J = KD-I+2, N)
   ENDDO
   A=AA
   WRITE(NOUT,*) 'The matrix A:'
   DO I = 1, KD+1
      WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,1:N)
   ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_ZHBEVD LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HBEVD( A, W, ''U'', Z, INFO )'
   A=AA
   CALL LA_HBEVD( A, W, 'U', Z, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HBEVD( A, W, ''U'', Z )'
   A=AA
   CALL LA_HBEVD( A, W, 'U', Z )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HBEVD( A, W, Z=Z )'
   A=AA
   CALL LA_HBEVD( A, W, Z=Z )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HBEVD( A, W, UPLO=''L'', Z=Z )'
   A = HUGE(1.0_WP)
   WRITE(NOUT,*) 'The transpose matrix of A:'
   DO I = 1, KD+1
      A(I,1:N-I+1) = AA(KD+2-I,I:N)
      WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,1:N)
   ENDDO
   CALL LA_HBEVD( A, W, UPLO='L', Z=Z )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HBEVD( A, W )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_HBEVD( A, W )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HBEVD( A(:,1:N-1), W, INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_HBEVD( A(:,1:N-1), W, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HBEVD( A, W(1:N-1), INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_HBEVD( A, W(1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HBEVD( A, W, UPLO=''9'', INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_HBEVD( A, W, UPLO='9', INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HBEVD( A, W, Z=Z(1:N-1,:), INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_HBEVD( A, W, Z=Z(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HBEVD( A, W, Z=Z(:,1:N-1) )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_HBEVD( A, W, Z=Z(:,1:N-1) )
!
END PROGRAM LA_ZHBEVD_ET_EXAMPLE

SUBROUTINE ZGELSD1_F95( A, B, RANK, S, RCOND, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => DP
      USE LA_AUXMOD, ONLY: ERINFO
      USE F77_LAPACK, ONLY: GELSD_F77 => LA_GELSD,  ILAENV_F77 => ILAENV
!   .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL :: RANK
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(IN), OPTIONAL :: RCOND
!   .. ARRAY ARGUMENTS ..
      COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: S(:)
!   .. PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GELSD'
!   .. LOCAL SCALARS ..
      INTEGER :: LINFO, ISTAT, LWORK, N, M, MN, LRANK, SS, &
     &  LIWORK, SMLSIZ, NLVL, LRWORK
      REAL(WP) :: LRCOND
!   .. LOCAL POINTERS ..
      COMPLEX(WP), POINTER :: WORK(:)
      REAL(WP), POINTER :: LS(:)
      INTEGER, POINTER :: IWORK(:)
      REAL(WP), POINTER :: RWORK(:)
      COMPLEX(WP) :: WORKMIN(1)
      INTEGER :: IWORKMIN(1) 
      DOUBLE PRECISION  TWO
      PARAMETER       ( TWO = 2.0D0 ) 
!   .. INTRINSIC FUNCTIONS ..
      INTRINSIC SIZE, PRESENT, MAX, MIN, EPSILON
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2)
    MN = MIN(M,N)
       SMLSIZ = ILAENV_F77( 9, 'ZGELSD', ' ', 0, 0, 0, 0 )
       NLVL = MAX(INT(LOG(DBLE(MAX(1,MN))/DBLE(SMLSIZ+1))/LOG(TWO)),0)
! NEXT LINE SHOULD BE  LIWORK = 3 * MN * NLVL + 11 * MN, WHEN THE LAPACK CODE IS FIXED
       LIWORK = 2*(3 * MN * NLVL + 11 * MN)
       LRWORK = 8  * MN + 2*MN*SMLSIZ + 8*MN*NLVL + MN
       
       LRWORK = 25000
       ALLOCATE(RWORK(LRWORK), STAT = ISTAT)
       IF (ISTAT /= 0) THEN ; LINFO=-100; GOTO 100; ENDIF
       
       IF( PRESENT(RCOND) )THEN; LRCOND = RCOND
       ELSE; LRCOND = 100*EPSILON(1.0_WP); ENDIF
       IF( PRESENT(S) )THEN; SS = SIZE(S); ELSE; SS =MN; ENDIF
!   .. TEST THE ARGUMENTS
       IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
       ELSE IF( SIZE( B, 1 ) /= MAX(1,M,N)) THEN; LINFO = -2
       ELSE IF( SS /= MN ) THEN; LINFO = -4
       ELSE IF( LRCOND <= 0.0_WP ) THEN; LINFO = -5
       ELSE 
          IF( PRESENT(S) )THEN; LS => S
          ELSE
            ALLOCATE( LS(MN), STAT = ISTAT );
            IF (ISTAT /= 0) THEN ;
             LINFO=-200; GOTO 200; ENDIF
          END IF
          LWORK=-1
       
          CALL GELSD_F77( M, N, 1, A, MAX(1,M), B, MAX(1,M,N), &
     &         LS, LRCOND, LRANK, WORKMIN, LWORK, RWORK, IWORKMIN, LINFO )
          LWORK = WORKMIN(1)
! THE NEXT LINE SHOULD BE REMOVED, WHEN THE LAPACK CODE IS FIXED.
          LWORK = 10 * LWORK
          ALLOCATE( WORK(LWORK), IWORK(LIWORK), STAT = ISTAT )
          IF (ISTAT /= 0) THEN; 
	    LINFO=-300; GOTO 300
          ENDIF
       
          CALL GELSD_F77( M, N, 1, A, MAX(1,M), B, SIZE(B,1), &
     &      LS, LRCOND, LRANK, WORK, LWORK, RWORK, IWORK, LINFO )
       
          IF( PRESENT(RANK) ) RANK = LRANK
          DEALLOCATE(WORK, IWORK, STAT = ISTAT)
300       IF (.NOT. PRESENT(S)) DEALLOCATE(LS, STAT = ISTAT)
        END IF
200     DEALLOCATE(RWORK, STAT = ISTAT)
100     CALL ERINFO( LINFO, SRNAME, INFO, ISTAT ) 
END SUBROUTINE ZGELSD1_F95

PROGRAM LA_ZGEES_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GEES
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
   INTERFACE
     LOGICAL FUNCTION SELECT(W)
        USE LA_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN) :: W
     END FUNCTION SELECT
   END INTERFACE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, INFO, N, SDIM
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:)
   COMPLEX(WP), ALLOCATABLE :: A(:,:), VS(:,:), DUMMY(:,:)
   COMPLEX(WP), ALLOCATABLE :: W(:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'GEES ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N
   PRINT *, 'N = ', N
   ALLOCATE ( A(N,N), AA(N,N), W(N), VS(N,N) )
!
      READ (NIN, *) AA
   A=AA
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,:); ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_ZGEES LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEES( A, W, VS, SELECT, SDIM, INFO )'
   A=AA
   CALL LA_GEES( A, W, VS, SELECT, SDIM, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' SDIM = ', SDIM, ' Eigenvalues:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'Schur vectors:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VS(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEES( A, W, VS )'
   A=AA; VS = HUGE(1.0_WP)
   CALL LA_GEES( A, W, VS )
   WRITE(NOUT,*) 'INFO = ', INFO, ' Eigenvalues:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'Schur vectors:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VS(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEES( A, W, SELECT=SELECT, SDIM=SDIM, INFO=INFO )'
   A=AA
   CALL LA_GEES( A, W, SELECT=SELECT, SDIM = SDIM, INFO = INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' SDIM = ', SDIM, ' Eigenvalues:'
   WRITE(NOUT,FMT) W
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEES( A, W )'
   A=AA
   CALL LA_GEES( A, W )
   WRITE(NOUT,*) 'INFO = ', INFO, ' Eigenvalues:'
   WRITE(NOUT,FMT) W
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEES( DUMMY, W, VS, SELECT, SDIM, INFO )'
   A=AA
   CALL LA_GEES( DUMMY, W, VS, SELECT, SDIM, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEES( A, WR(1:N-1), VS, SELECT, SDIM, INFO )'
   A=AA
   CALL LA_GEES( A, W(1:N-1), VS, SELECT, SDIM, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEES( A, W(1:N-1), VS, SELECT, SDIM, INFO )'
   A=AA
   CALL LA_GEES( A, W(1:N-1), VS, SELECT, SDIM, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEES( A, W, VS(1:N-1,:), SELECT, SDIM, INFO )'
   A=AA
   CALL LA_GEES( A, W, VS(1:N-1,:), SELECT, SDIM, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEES( A, W, VS(:,1:N-1), SELECT, SDIM, INFO )'
   A=AA
   CALL LA_GEES( A, W, VS(:,1:N-1), SELECT, SDIM, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEES( A, W, VS, SDIM=SDIM )'
   A=AA
   CALL LA_GEES( A, W, VS, SDIM=SDIM )
   WRITE(NOUT,*) 'INFO = ', INFO
!
END PROGRAM LA_ZGEES_ET_EXAMPLE
!  CONTAINS
   LOGICAL FUNCTION SELECT(W)
      USE LA_PRECISION, ONLY: WP => DP
      COMPLEX(WP), INTENT(IN) :: W
      INTRINSIC AIMAG
      IF( AIMAG(W) > 0.0_WP ) THEN; SELECT = .TRUE.
      ELSE; SELECT = .FALSE.; END IF 
   END FUNCTION SELECT

      SUBROUTINE CERRED( PATH, NUNIT )
*
*  -- LAPACK test routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     April 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  CERRED tests the error exits for the eigenvalue driver routines for
*  REAL matrices:
*
*  PATH  driver   description
*  ----  ------   -----------
*  CEV   CGEEV    find eigenvalues/eigenvectors for nonsymmetric A
*  CES   CGEES    find eigenvalues/Schur form for nonsymmetric A
*  CVX   CGEEVX   CGEEV + balancing and condition estimation
*  CSX   CGEESX   CGEES + balancing and condition estimation
*  CBD   CGESVD   compute SVD of an M-by-N matrix A
*        CGESDD   compute SVD of an M-by-N matrix A(by divide and
*                 conquer)
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX, LW
      PARAMETER          ( NMAX = 4, LW = 5*NMAX )
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E0, ZERO = 0.0E0 )
*     ..
*     .. Local Scalars ..
      CHARACTER*2        C2
      INTEGER            I, IHI, ILO, INFO, J, NT, SDIM
      REAL               ABNRM
*     ..
*     .. Local Arrays ..
      LOGICAL            B( NMAX )
      INTEGER            IW( 4*NMAX ), IN(100)
      REAL               R1( NMAX ), R2( NMAX ), RW( LW ), S( NMAX )
      COMPLEX            A( NMAX, NMAX ), U( NMAX, NMAX ),
     $                   VL( NMAX, NMAX ), VR( NMAX, NMAX ),
     $                   VT( NMAX, NMAX ), W( 4*NMAX ), X( NMAX )
*     ..
*     .. External Subroutines ..
      EXTERNAL           LA_TEST_CGEES, LA_TEST_CGEESX, LA_TEST_CGEEV,
     &                   LA_TEST_CGEEVX,
     &                   LA_TEST_CGESDD, LA_TEST_CGESVD, CHKXER
*     ..
*     .. External Functions ..
      LOGICAL            CSLECT, LSAMEN
      EXTERNAL           CSLECT, LSAMEN
*     ..
*     .. Arrays in Common ..
      LOGICAL            SELVAL( 20 )
      REAL               SELWI( 20 ), SELWR( 20 )
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT, SELDIM, SELOPT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
      COMMON             / SSLCT / SELOPT, SELDIM, SELVAL, SELWR, SELWI
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )
*
*     Initialize A
*
      DO 20 J = 1, NMAX
         DO 10 I = 1, NMAX
            A( I, J ) = ZERO
   10    CONTINUE
   20 CONTINUE
      DO 30 I = 1, NMAX
         A( I, I ) = ONE
   30 CONTINUE
      OK = .TRUE.
      NT = 0
*
      IF( LSAMEN( 2, C2, 'EV' ) ) THEN
*
*        Test CGEEV
*
        SRNAMT = 'CGEEV '
        DO I = 1, 4
          IN(I) = 1
        END DO
        DO I = 1, 4
          INFOT = I
          DO J = 1, 1
            INFO = J + 100*I
            CALL LA_TEST_CGEEV('N', 'N', NMAX, A, NMAX, X, VL,
     &        NMAX, VR, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGEEV ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_CGEEV('N', 'V', NMAX, A, NMAX, X, VL,
     &        NMAX, VR, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGEEV ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_CGEEV('V', 'N', NMAX, A, NMAX, X, VL,
     &        NMAX, VR, NMAX, W, NMAX, RW, INFO )

            CALL CHKXER( 'CGEEV ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_CGEEV('V', 'V', NMAX, A, NMAX, X, VL,
     &        NMAX, VR, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGEEV ', INFOT, NOUT, LERR, OK )
          END DO
        END DO
*
      ELSE IF( LSAMEN( 2, C2, 'ES' ) ) THEN
*
*        Test CGEES
*
        SRNAMT = 'CGEES '
        DO I = 1, 4
          IN(I) = 1
        END DO
        DO I = 1, 4
          INFOT = I
          DO J = 1, 1
            INFO = J + 100*I
            CALL LA_TEST_CGEES('N', 'N', CSLECT, NMAX, A, NMAX,
     &        SDIM, X, VL, NMAX, W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEES ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_CGEES('N', 'V', CSLECT, NMAX, A, NMAX,
     &        SDIM, X, VL, NMAX, W, NMAX, RW, B, INFO)
            CALL CHKXER( 'CGEES ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_CGEES('V', 'N', CSLECT, NMAX, A, NMAX,
     &        SDIM, X, VL, NMAX, W, NMAX, RW,  B, INFO )
            CALL CHKXER( 'CGEES ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_CGEES('V', 'V', CSLECT, NMAX, A, NMAX,
     &        SDIM, X, VL, NMAX, W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEES ', INFOT, NOUT, LERR, OK )
          END DO
        ENDDO
       
         NT = NT + 6
*
      ELSE IF( LSAMEN( 2, C2, 'VX' ) ) THEN
*
*        Test CGEEVX
*
        SRNAMT = 'CGEEVX'
        DO I = 1, 11
          IN(I) = 1
        END DO
        DO I = 1, 11
          IF (I/=6 .AND. I/= 7 .AND. I/=9) THEN
            INFOT = I
            DO J = 1, 1
              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'V', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'V', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'V', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'V', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'V', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'V', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'V', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'V', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'P', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 1              00*I
              CALL LA_TEST_CGEEVX( 'P', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'P', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'P', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'P', 'N', 'V', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'P', 'N', 'V', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'P', 'N', 'V', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'P', 'N', 'V', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 1              00*I
              CALL LA_TEST_CGEEVX( 'P', 'V', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'P', 'V', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'P', 'V', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'P', 'V', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'S', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'S', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'S', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 1              00*I
              CALL LA_TEST_CGEEVX( 'S', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'S', 'N', 'V', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'S', 'N', 'V', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'S', 'N', 'V', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'S', 'N', 'V', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'S', 'V', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'S', 'V', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'S', 'V', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 1              00*I
              CALL LA_TEST_CGEEVX( 'S', 'V', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 1              00*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'N', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'N', 'V', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'N', 'V', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'N', 'V', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'N', 'V', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'V', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'V', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'V', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CGEEVX( 'B', 'V', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'CGEEVX', INFOT, NOUT, LERR, OK )
            ENDDO
          ENDIF
        ENDDO
        NT = NT + 10
*
      ELSE IF( LSAMEN( 2, C2, 'SX' ) ) THEN
*
*        Test CGEESX
*
        SRNAMT = 'CGEESX'
        DO I = 1, 3
          IN(I) = 1
        END DO
        DO I = 1, 3
          INFOT = I
          DO J = 1, 1
            INFO = J + 100*I
            CALL LA_TEST_CGEESX( 'N', 'N', CSLECT, 'N', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGEESX( 'N', 'N', CSLECT, 'E', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGEESX( 'N', 'N', CSLECT, 'V', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGEESX( 'N', 'N', CSLECT, 'B', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGEESX( 'N', 'S', CSLECT, 'N', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGEESX( 'N', 'S', CSLECT, 'E', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 1            00*I
            CALL LA_TEST_CGEESX( 'N', 'S', CSLECT, 'V', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGEESX( 'N', 'S', CSLECT, 'B', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGEESX( 'V', 'N', CSLECT, 'N', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGEESX( 'V', 'N', CSLECT, 'E', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGEESX( 'V', 'N', CSLECT, 'V', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGEESX( 'V', 'N', CSLECT, 'B', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'CGEESX', INFOT, NOUT, LERR, OK )

          ENDDO
        ENDDO
        NT = NT + 7
*
      ELSE IF( LSAMEN( 2, C2, 'BD' ) ) THEN
*
*        Test CGESVD
*
        SRNAMT = 'CGESVD'
        DO I = 2, 6
          IN(I) = 1
        END DO
        DO I = 2, 6
          INFOT = I
          DO J = 1, 1
            INFO = J + 100*I
            CALL LA_TEST_CGESVD('A', 'A', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('A', 'S',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('A', 'O',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW,  INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('A', 'N', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW,  INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('S', 'A', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW,  INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('S', 'S',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_CGESVD('S', 'O',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('S', 'N', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW,  INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('O', 'A', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('O', 'S',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('O', 'O',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_CGESVD('O', 'N', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('N', 'A', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('N', 'S',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('N', 'O',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_CGESVD('N', 'N', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'CGESVD', INFOT, NOUT, LERR, OK )
          END DO
        END DO
        
        NT = NT + 8
         IF( OK ) THEN
            WRITE( NOUT, FMT = 9999 )SRNAMT, NT
         ELSE
            WRITE( NOUT, FMT = 9998 )
         END IF
*
*        Test CGESDD
*
         SRNAMT = 'CGESDD'
         DO I = 2, 6
           IN(I) = 1
         END DO
         DO I = 2, 6
           IF (I/=5) THEN
             INFOT = I
             DO J = 1, 1
               INFO = J + 100*I
               CALL LA_TEST_CGESDD( 'N', NMAX, NMAX, A, NMAX, S, U,
     &           NMAX, VT, NMAX, W, NMAX, RW, IW, INFO )
               CALL CHKXER( 'CGESDD', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CGESDD( 'A', NMAX, NMAX, A, NMAX, S, U,
     &           NMAX, VT, NMAX, W, NMAX, RW, IW, INFO )
               CALL CHKXER( 'CGESDD', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CGESDD( 'S', NMAX, NMAX, A, NMAX, S, U,
     &           NMAX, VT, NMAX, W, NMAX, RW, IW, INFO )
               CALL CHKXER( 'CGESDD', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CGESDD( 'O', NMAX, NMAX, A, NMAX, S, U,
     &           NMAX, VT, NMAX, W, NMAX, RW, IW, INFO )
               CALL CHKXER( 'CGESDD', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDIF
         ENDDO            
         
         NT = NT - 2
         IF( OK ) THEN
            WRITE( NOUT, FMT = 9999 )SRNAMT, NT
         ELSE
            WRITE( NOUT, FMT = 9998 )
         END IF
      END IF
*
*     Print a summary line.
*
      IF( .NOT.LSAMEN( 2, C2, 'BD' ) ) THEN
         IF( OK ) THEN
            WRITE( NOUT, FMT = 9999 )SRNAMT, NT
         ELSE
            WRITE( NOUT, FMT = 9998 )
         END IF
      END IF
*
 9999 FORMAT( 1X, A6, ' passed the tests of the error exits (', I3,
     $      ' tests done)' )
 9998 FORMAT( ' *** ', A6, ' failed the tests of the error exits ***' )
      RETURN
*
*     End of CERRED
*
      END

SUBROUTINE LA_TEST_DSPGV( ITYPE, JOBZ, UPLO, N, AP, BP, W, Z, LDZ, WORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 5, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_SPGV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: ITYPE, N, LDZ
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBZ, UPLO
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: AP(1:N*(N+1)/2), BP( 1:N*(N+1)/2)
   REAL(WP), INTENT(OUT)::  W(1:N), WORK(1:3*N), Z(1:LDZ, 1:N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SPGV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DSPGV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IAP, IW, IBP, IITYPE, IZ1, IZ2
   CHARACTER*1 :: IUPLO, IJOBZ   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IAP = N *(N+1)/2; IUPLO = UPLO; IW = N; IJOBZ = JOBZ
   IBP = N*(N+1)/2; IITYPE = ITYPE; IZ1 = MAX(1, N); IZ2 = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
      IAP = IAP - 1
     CASE (2)
       IBP = IAP - 1
     CASE (3)
       IW = IW - 1
     CASE (4)
       IITYPE = 22   
     CASE (5)
       IUPLO = 'T' 
     CASE (6)
       IZ2 = IZ2 - 1
       IJOBZ = 'V'
     CASE(:-1,7:)
       CALL UESTOP(SRNAMT)
   END SELECT
   IF (LSAME(IJOBZ, 'V')) THEN
     CALL LA_SPGV( AP(1:IAP), BP(1:IBP), W(1 :IW), &
&      IITYPE, IUPLO, Z(1:IZ1, 1: IZ2), INFO )
   ELSE
     CALL LA_SPGV( AP(1:IAP), BP(1:IBP), W(1 :IW), &
&      IITYPE, IUPLO, INFO = INFO )
   END IF

   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_DSPGV
      
      

SUBROUTINE CPBSVX_F95(A, B, X, UPLO, AF, FACT, EQUED, &
                           S, FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: PBSVX_F77 => LA_PBSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
   CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
   COMPLEX(WP), INTENT(OUT) :: X(:,:)
   COMPLEX(WP), INTENT(INOUT), OPTIONAL, TARGET :: AF(:,:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: S(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: FERR(:), BERR(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!     LA_PBSVX computes the solution to a linear system of equations
! A*X = B, where A has band form and is real symmetric or complex 
! Hermitian and, in either case, positive definite, and where X and B 
! are rectangular matrices or vectors.
!     LA_PBSVX can also optionally equilibrate the system if A is poorly
! scaled, estimate the condition number of (the equilibrated) A, and 
! compute error bounds.
! 
! =========
! 
!       SUBROUTINE LA_PBSVX( AB, B, X, UPLO=uplo, AFB=afb, FACT=fact, &
!                             EQUED=equed, S=s, FERR=ferr, BERR=berr, &
!                             RCOND=rcond, INFO=info )
!             <type>(<wp>), INTENT(INOUT) :: AB(:,:), <rhs>
!             <type>(<wp>), INTENT(OUT) :: <sol>
!             CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!             <type>(<wp>), INTENT(INOUT), OPTIONAL :: AFB(:,:)
!             CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
!             CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
!             REAL(<wp>), INTENT(INOUT), OPTIONAL :: S(:)
!             REAL(<wp>), INTENT(OUT), OPTIONAL :: <err>
!             REAL(<wp>), INTENT(OUT), OPTIONAL :: RCOND
!             INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!             <type> ::= REAL | COMPLEX
!             <wp>   ::= KIND(1.0) | KIND(1.0D0)
!             <rhs>  ::= B(:,:) | B(:)
!             <sol>  ::= X(:,:) | X(:)
!             <err>  ::= FERR(:), BERR(:) | FERR, BERR
! 
! Arguments
! =========
! 
! AB       (input/output) REAL or COMPLEX array, shape (:,:) with 
!          size(AB,1) = kd + 1 and size(AB,2) = n, where kd is the number
!          of superdiagonals or subdiagonals and n is the order of A.
!          On entry, the upper (if UPLO = 'U') or lower (if UPLO = 'L') 
!          triangle of matrix A, or its equilibration, in band storage. 
!          The (kd + 1) diagonals of A are stored in the rows of AB so
!          that the j-th column of A is stored in the j-th column of AB
!   	   as follows:
!          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j
!                                                   1<=j<=n
!          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd)
!                                                   1<=j<=n.
!          On exit, if FACT = 'E', then the equilibrated version of A is
!          stored in AB; otherwise, AB is unchanged.
! B        (input/output) REAL or COMPLEX array, shape (:,:) with 
!          size(B,1) = n or shape (:) with size(B) = n.
!          On entry, the matrix B.
!          On exit, the scaled version of B if the system has been 
!          equilibrated; otherwise, B is unchanged.
! X        (output) REAL or COMPLEX array, shape (:,:) with size(X,1)=n
!          and size(X,2) = size(B,2), or shape (:) with size(X) = n.
!          The solution matrix X .
! UPLO     Optional (input) CHARACTER(LEN=1).
!          = 'U': Upper triangle of A is stored;
!          = 'L': Lower triangle of A is stored.
!          Default value: 'U'.
! AFB      Optional (input or output) REAL or COMPLEX array, shape (:) 
!          with the same size as AB.
!          If FACT = 'F' then AFB is an input argument that contains the
!          factor U or L from the Cholesky factorization of (the
! 	   equilibrated) A, in the same storage format as A, returned by 
!          a previous call to LA_PBSVX.
!          If FACT /= 'F' then AFB is an output argument that contains 
! 	   the factor U or L from the Cholesky factorization of (the 
!          equilibrated) A in the same storage format as A.
! FACT     Optional (input) CHARACTER(LEN=1).
!          Specifies whether the factored form of the matrix A is supplied
!          on entry, and if not, whether A should be equilibrated before 
!          it is factored.
!            = 'N': The matrix A will be copied to AFB and factored (no 
! 	          equilibration).
!            = 'E': The matrix A will be equilibrated, then copied to 
! 	          AFB and factored.
!            = 'F': AFB contains the factored form of (the equilibrated)
! 	          A.
!          Default value: 'N'.
! EQUED    Optional (input or output) CHARACTER(LEN=1).
!          Specifies the form of equilibration that was done.
!          EQUED is an input argument if FACT = 'F', otherwise it is an
!          output argument
!            = 'N': No equilibration (always true if FACT = 'N').
!            = 'Y': Equilibration, i.e., A has been premultiplied and 
! 	          postmultiplied by diag(S).
!          Default value: 'N'.
! S        Optional (input or output) REAL array, shape (:) with size(S) 
!          = size(A,1).
!          The scaling factors for A.
!          S is an input argument if FACT = 'F' and EQUED = 'Y'.
!          S is an output argument if FACT = 'E' and EQUED = 'Y'.
! FERR     Optional (output) REAL array of shape (:), with size(FERR) =
!          size(X,2), or REAL scalar.
!          The estimated forward error bound for each solution vector 
!          X(j) (the j-th column of the solution matrix X). If XTRUE is 
! 	   the true solution corresponding to X(j) , FERR(j) is an 
! 	   estimated upper bound for the magnitude of the largest element
! 	   in (X(j)-XTRUE) divided by the magnitude of the largest 
! 	   element in X(j). The estimate is as reliable as the estimate
!          for RCOND, and is almost always a slight overestimate of the
!          true error.
! BERR     Optional (output) REAL array of shape (:), with size(BERR) = 
!          size(X,2), or REAL scalar.
!          The componentwise relative backward error of each solution 
!          vector X(j) (i.e., the smallest relative change in any element
!          of A or B that makes X(j) an exact solution).
! RCOND    Optional (output) REAL
!          The estimate of the reciprocal condition number of (the 
!          equilibrated) A. If RCOND is less than the machine precision,
!          the matrix is singular to working precision. This condition is
!          indicated by a return code of INFO > 0.
! INFO     Optional (output) INTEGER
!          = 0: successful exit.
!          < 0: if INFO = -i, the i-th argument had an illegal value.
!          > 0: if INFO = i, and i is
!             <= n: the leading minor of order i of (the equilibrated) A 
! 	         is not positive definite, so the factorization could 
! 		 not be completed and the solution and error bounds 
! 		 could not be computed. RCOND= 0 is returned.
!             = n+1: U or L is nonsingular, but RCOND is less than 
! 	         machine precision, so the matrix is singular to
! 		 working precision. Nevertheless, the solution and
! 		 error bounds are computed because the computed solution
! 		 can be more accurate than the value of RCOND would 
! 		 suggest.
!          If INFO is not present and an error occurs, then the program 
! 	   is terminated with an error message.
!----------------------------------------------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_PBSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LUPLO, LEQUED
   INTEGER :: LINFO, NRHS, N, ISTAT, ISTAT1, S1AF, S2AF, &
              SS, SFERR, SBERR, KD
   REAL(WP) :: LRCOND, MVS
!  .. LOCAL POINTERS ..
   REAL(WP),  POINTER :: RWORK(:), LS(:), LFERR(:), LBERR(:)
   COMPLEX(WP),  POINTER :: WORK(:), LAF(:, :)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE, MINVAL, TINY
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0
   KD = SIZE(A,1)-1; N = SIZE(A, 2); NRHS = SIZE(B, 2)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(EQUED) .AND. LSAME(LFACT,'F') )THEN; LEQUED = EQUED
   ELSE; LEQUED='N'; END IF
   IF( PRESENT(AF) )THEN; S1AF = SIZE(AF,1); S2AF = SIZE(AF,2)
   ELSE; S1AF = KD+1; S2AF = N; END IF
   IF( ( PRESENT(S) ) )THEN; SS = SIZE(S); ELSE; SS = N; END IF
   IF( PRESENT(S) .AND. LSAME(LFACT,'F') .AND. LSAME(LEQUED,'Y') ) THEN
       MVS = MINVAL(S); ELSE; MVS = TINY(1.0_WP); ENDIF
   IF( PRESENT(FERR) )THEN; SFERR = SIZE(FERR); ELSE; SFERR = NRHS; END IF
   IF( PRESENT(BERR) )THEN; SBERR = SIZE(BERR); ELSE; SBERR = NRHS; END IF
   IF(PRESENT(UPLO))THEN; LUPLO = UPLO; ELSE; LUPLO='U'; END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE(A,1) < 0 .OR. N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE(B, 1) /= N .OR. NRHS < 0 )THEN; LINFO = -2
   ELSE IF( SIZE(X, 1) /= N .OR. SIZE(X, 2) /= NRHS )THEN; LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
   ELSE IF( S1AF /= KD+1 .OR. S2AF /= N ) THEN; LINFO = -5
   ELSE IF( ( .NOT. ( LSAME(LFACT,'F') .OR. LSAME(LFACT,'N') .OR. &
                    LSAME(LFACT,'E') ) ) .OR. &
      ( LSAME(LFACT,'F') .AND. .NOT.PRESENT(AF) ) )THEN; LINFO = -6
   ELSE IF( .NOT.LSAME(LEQUED,'N') .AND. .NOT.LSAME(LEQUED,'Y') )THEN; LINFO = -7
   ELSE IF( SS /= N .OR. LSAME(LFACT,'F') .AND. LSAME(LEQUED,'Y') &
      .AND. MVS  <= 0.0_WP )THEN; LINFO = -8
   ELSE IF( SFERR /= NRHS )THEN; LINFO = -9
   ELSE IF( SBERR /= NRHS )THEN; LINFO = -10
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(AF) ) THEN; ALLOCATE( LAF(S1AF,N), STAT=ISTAT )
      ELSE; LAF => AF; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(S) )THEN; ALLOCATE( LS(N), STAT=ISTAT )
         ELSE; LS => S; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(FERR) )THEN; ALLOCATE( LFERR(NRHS), STAT=ISTAT )
         ELSE; LFERR => FERR; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(BERR) )THEN; ALLOCATE( LBERR(NRHS), STAT=ISTAT )
         ELSE; LBERR => BERR; END IF
      END IF
      IF( ISTAT == 0 ) ALLOCATE(WORK(2*N), RWORK(N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
         CALL PBSVX_F77( LFACT, LUPLO, N, KD, NRHS, A, KD+1, LAF, S1AF, &
                         LEQUED, LS, B, N, X, N, LRCOND, &
                         LFERR, LBERR, WORK, RWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(S) ) DEALLOCATE( LS, STAT=ISTAT1 )
      IF( .NOT.PRESENT(AF) ) DEALLOCATE( LAF, STAT=ISTAT1 )
      IF( .NOT.PRESENT(FERR) ) DEALLOCATE( LFERR, STAT=ISTAT1 )
      IF( .NOT.PRESENT(BERR) ) DEALLOCATE( LBERR, STAT=ISTAT1 )
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      IF( PRESENT(EQUED) .AND. .NOT.LSAME(LFACT,'F') ) EQUED=LEQUED
      DEALLOCATE( WORK, RWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE CPBSVX_F95

      SUBROUTINE ZGESV_F95( A, B, IPIV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!     .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => DP
      USE LA_AUXMOD, ONLY: ERINFO
      USE F77_LAPACK, ONLY: GESV_F77 => LA_GESV
!     .. "Implicit Statement" ..
      IMPLICIT NONE
!     .. "Scalar Arguments" ..
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
!     .. "Array Arguments" ..
      INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IPIV(:)
      COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_GESV computes the solution to a real or complex linear system of
! equations A*X = B, where A is a square matrix and X and B are 
! rectangular matrices or vectors. Gaussian elimination with row 
! interchanges is used to factor A as A = P*L*U , where P is a permutation
! matrix, L is unit lower triangular, and U is upper triangular. The 
! factored form of A is then used to solve the above system.
! 
! =========
! 
!       SUBROUTINE LA_GESV( A, B, IPIV=ipiv, INFO=info )
!          <type>(<wp>), INTENT(INOUT) :: A(:,:), <rhs>
!          INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
!          INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!          <type> ::= REAL | COMPLEX
!          <wp>   ::= KIND(1.0) | KIND(1.0D0)
!          <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! A      (input/output) REAL or COMPLEX square array, shape (:,:).
!        On entry, the matrix A.
!        On exit, the factors L and U from the factorization A = P*L*U; 
!        the unit diagonal elements of L are not stored.
! B      (input/output) REAL or COMPLEX array, shape (:,:) with 
!        size(B,1) = size(A,1) or shape (:) with size(B) = size(A,1).
!        On entry, the matrix B.
!        On exit, the solution matrix X .
! IPIV   Optional (output) INTEGER array, shape (:) with size(IPIV) = 
!        size(A,1).
!        The pivot indices that define the permutation matrix P; row i of
!        the matrix was interchanged with row IPIV(i).
! INFO   Optional (output) INTEGER
!        = 0 : successful exit.
!        < 0 : if INFO = -i, the i-th argument has an illegal value.
!        > 0 : if INFO = i, then U(i,i) = 0. The factorization has been 
!        completed, but the factor U is singular, so the solution could
!        not be computed.
!        If INFO is not present and an error occurs, then the program is 
!        terminated with an error message.
!----------------------------------------------------------------------
!     .. "Parameters" ..
      CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GESV'
!     .. LOCAL SCALARS ..
      INTEGER :: LINFO, ISTAT, ISTAT1, SIPIV
!     .. "Local Pointers" ..
      INTEGER, POINTER :: LPIV(:)
!     .. "Intrinsic Functions" ..
      INTRINSIC SIZE, PRESENT, MAX
!     .. "Executable Statements" ..
      LINFO = 0; ISTAT = 0
      IF( PRESENT(IPIV) )THEN
         SIPIV = SIZE(IPIV)
      ELSE
         SIPIV = SIZE(A,1)
      END IF
!     .. "Test the arguments" ..
      IF( SIZE( A, 2 ) /= SIZE(A,1) .OR. SIZE(A,1) < 0 ) THEN
         LINFO = -1
      ELSE IF( SIZE( B, 1 ) /= SIZE(A,1) .OR. SIZE(B,2) < 0 ) THEN
         LINFO = -2
      ELSE IF( SIPIV /= SIZE(A,1) )THEN
            LINFO = -3
      ELSE IF ( SIZE(A,1) > 0 ) THEN
         IF( PRESENT(IPIV) )THEN
            LPIV => IPIV
         ELSE
            ALLOCATE( LPIV(SIZE(A,1)), STAT = ISTAT )
         END IF
         IF ( ISTAT == 0 ) THEN
!        .. "Call LAPACK77 routine" ..
            CALL GESV_F77( SIZE(A,1), SIZE(B,2), A, MAX(1,SIZE(A,1)), LPIV, B, MAX(1,SIZE(A,1)), &
                           LINFO )
         ELSE
            LINFO = -100
         END IF
         IF( .NOT.PRESENT(IPIV) )THEN
            DEALLOCATE(LPIV, STAT = ISTAT1 )
         END IF
      END IF
      CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
      END SUBROUTINE ZGESV_F95

 PROGRAM EXAMPLE 
  USE LA_PRECISION, ONLY: WP => DP
  USE f77_LAPACK, ONLY: F77GESV => LA_GESV
  USE f95_LAPACK, ONLY: F95GESV => LA_GESV

  USE f77_LAPACK, ONLY: F77GESDD => LA_GESDD
  USE f95_LAPACK, ONLY: F95GESDD => LA_GESDD

  IMPLICIT NONE 

  INTEGER :: INFO, J, LDA, LDB, N, NRHS, LWORK, S, I
  INTEGER, ALLOCATABLE :: IPIV(:)
  INTEGER, ALLOCATABLE :: IWORK(:)
  REAL :: T0, T1, T2
  DOUBLE PRECISION  ::  CPU_MFLP, RTC_MFLP, FLP, p,r
  DOUBLE PRECISION :: RTC, BEFORE, AFTER, RTC_TIME, CPU1_TIME
  COMPLEX(WP), ALLOCATABLE :: A(:,:), B(:,:), AA(:,:), BB(:,:)
  REAL(WP), ALLOCATABLE :: WR(:), RWORK(:)
  COMPLEX(WP), ALLOCATABLE :: VL(:,:), VR(:,:)
  COMPLEX(WP), ALLOCATABLE :: WORK(:)
  print *, 'N = '
  read (*,*) N

  NRHS = 1; S = 10
  print * ,'=========================================================='
  print * ,'      LAPACK95 TIMING routine, Double Complex Version     '
  print * ,'=========================================================='
  
  print *,' N , NRHS = ', N, NRHS
  ALLOCATE( A(N,N), B(N,NRHS), IPIV(N), AA(N,N), BB(N,NRHS) )
  ALLOCATE(WR(N), VL(N,N), VR(N,N), RWORK(5*N*N+6*N))
  ALLOCATE(IWORK(10*N))

  do i=1,n
    do j=1,n
      call random_number(p)
      call random_number(r)
      a(i,j) = cmplx( p, r)
    enddo
  enddo
!  CALL RANDOM_NUMBER(A)
  DO J = 1, NRHS
    B(:,J) = SUM( A, DIM=2 )*J
  ENDDO
  AA = A; BB = B
  LDA = N; LDB = N 

! DGESV
  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  DO I = 1, S
    A = AA; B = BB
    CALL CPU_TIME(T0); CALL CPU_TIME(T1); T0 = T1-T0
    CALL F77GESV( N, NRHS, A, LDA, IPIV, B, LDB, INFO )
    CALL CPU_TIME(T2)
    CPU1_TIME = CPU1_TIME + (T2-T1-T0)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    A = AA; B = BB
    before = rtc()
    CALL F77GESV( N, NRHS, A, LDA, IPIV, B, LDB, INFO )
    after = rtc()
    RTC_TIME = RTC_TIME + (after - before)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
  ENDDO
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 0.67*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L77GESV ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L77GESV ', RTC_TIME, RTC_MFLP

  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  DO i = 1, s
    A = AA; B = BB
    CALL CPU_TIME(T1);
    CALL F95GESV( A, B ); CALL CPU_TIME(T2)
    CPU1_TIME = CPU1_TIME + (T2-T1-T0)
    
    A = AA; B = BB
    before = rtc()
    CALL F95GESV( A, B ); CALL CPU_TIME(T2)
    after = rtc()
    RTC_TIME = RTC_TIME+(after - before)
  ENDDO
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 0.67*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L95GESV ',  CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L95GESV ',  RTC_TIME, RTC_MFLP

! DGESDD, singular values & left and right singular vectors
   print *,'DGESDD, singular values & left and right singular vectors'
   CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  DO I = 1, S
    A = AA;  LWORK =10*N*N + 20*N
    ALLOCATE(WORK(LWORK))
    CALL CPU_TIME(T1)
    CALL F77GESDD( 'S', N, N, A, LDA, WR, VL, LDA, VR, LDA, WORK, &
&     LWORK, RWORK, IWORK, INFO )
    CALL CPU_TIME(T2)
    DEALLOCATE(WORK)
    CPU1_TIME = CPU1_TIME + ( T2-T1-T0 )
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    A = AA;  LWORK =10*N*N + 20*N
    ALLOCATE(WORK(LWORK))
    BEFORE = RTC()
    CALL F77GESDD( 'S', N, N, A, LDA, WR, VL, LDA, VR, LDA, WORK, &
&     LWORK, RWORK, IWORK, INFO )
    AFTER = RTC()
    DEALLOCATE(WORK)
    RTC_TIME=RTC_TIME + (AFTER - BEFORE)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
  ENDDO
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 6.67*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L77GESDD ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L77GESDD ', RTC_TIME, RTC_MFLP
  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  DO I=1,S
    A = AA
    CALL CPU_TIME(T1)
    CALL F95GESDD( A, WR, VL, VR, JOB='N', INFO=INFO)
    CALL CPU_TIME(T2)
    CPU1_TIME = CPU1_TIME + ( T2-T1-T0 )
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    A = AA
    BEFORE = RTC()
    CALL F95GESDD( A, WR, VL, VR, JOB='N', INFO=INFO)
    AFTER = RTC()
    RTC_TIME=RTC_TIME + (AFTER - BEFORE)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
  ENDDO
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 6.67*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L95GESDD ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L95GESDD ', RTC_TIME, RTC_MFLP
  
  DEALLOCATE( A, B, IPIV, AA, BB )
  DEALLOCATE(WR, VL, VR, RWORK)
  DEALLOCATE(IWORK)
  
END PROGRAM EXAMPLE
  

      MODULE LA_PRECISION
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  DEFINES SINGLE AND DOUBLE PRECISION PARAMETERS, SP AND DP.
!  THESE VALUES ARE COMPILER DEPENDENT.
!
      INTEGER, PARAMETER :: SP=KIND(1.0), DP=KIND(1.0D0)
!
      END MODULE LA_PRECISION

      MODULE LA_AUXMOD
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
      INTERFACE
         SUBROUTINE    ERINFO(LINFO, SRNAME, INFO, ISTAT)
            CHARACTER( LEN = * ), INTENT(IN)              :: SRNAME
            INTEGER             , INTENT(IN)              :: LINFO
            INTEGER             , INTENT(OUT), OPTIONAL   :: INFO
            INTEGER             , INTENT(IN), OPTIONAL    :: ISTAT
         END SUBROUTINE ERINFO
         INTEGER FUNCTION LA_WS_GELS( VER, M, N, NRHS, TRANS )
             CHARACTER( LEN=1 ), INTENT(IN) :: TRANS, VER
             INTEGER, INTENT(IN) :: M, N, NRHS
         END FUNCTION LA_WS_GELS
         INTEGER FUNCTION LA_WS_GELSS( VER, M, N, NRHS )
          CHARACTER(LEN=1), INTENT(IN) :: VER
          INTEGER, INTENT(IN) :: M, N, NRHS
         END FUNCTION LA_WS_GELSS
      END INTERFACE
!
      CONTAINS
!
      LOGICAL FUNCTION LSAME( CA, CB )
!
!  PURPOSE
!  =======
!
!  LSAME  TESTS IF CA IS THE SAME LETTER AS CB REGARDLESS OF CASE.
!
!  PARAMETERS
!  ==========
!
!  CA      (INPUT) CHARACTER*1
!  CB      (INPUT) CHARACTER*1
!          CHARACTERS TO BE COMPARED.
!
!  .. SCALAR ARGUMENTS ..
      CHARACTER*1, INTENT(IN) :: CA, CB
!  .. PARAMETERS ..
      INTEGER, PARAMETER      :: IOFF=32
!  .. LOCAL SCALARS ..
      INTEGER                 :: INTA, INTB, ZCODE
!  .. INTRINSIC FUNCTIONS ..
      INTRINSIC                  ICHAR
!
!  .. EXECUTABLE STATEMENTS ..
!
!  TEST IF THE CHARACTERS ARE EQUAL
!
      LSAME = CA == CB
!
!  NOW TEST FOR EQUIVALENCE
!
      IF( .NOT.LSAME )THEN
!
!     USE 'Z' RATHER THAN 'A' SO THAT ASCII CAN BE DETECTED ON PRIME
!     MACHINES, ON WHICH ICHAR RETURNS A VALUE WITH BIT 8 SET.
!     ICHAR('A') ON PRIME MACHINES RETURNS 193 WHICH IS THE SAME AS
!     ICHAR('A') ON AN EBCDIC MACHINE.
!
         ZCODE = ICHAR( 'Z' )
!
         INTA = ICHAR( CA )
         INTB = ICHAR( CB )
!
         IF( ZCODE.EQ.90 .OR. ZCODE.EQ.122 )THEN
!
!        ASCII IS ASSUMED - ZCODE IS THE ASCII CODE OF EITHER LOWER OR
!        UPPER CASE 'Z'.
!
            IF( INTA.GE.97 .AND. INTA.LE.122 ) INTA = INTA - 32
            IF( INTB.GE.97 .AND. INTB.LE.122 ) INTB = INTB - 32
!
         ELSE IF( ZCODE.EQ.233 .OR. ZCODE.EQ.169 )THEN
!
!        EBCDIC IS ASSUMED - ZCODE IS THE EBCDIC CODE OF EITHER LOWER OR
!        UPPER CASE 'Z'.
!
         IF( INTA.GE.129 .AND. INTA.LE.137 .OR.                         &
!    &       INTA.GE.145 .AND. INTA.LE.153 .OR.                         &
     &       INTA.GE.162 .AND. INTA.LE.169 ) INTA = INTA + 64
         IF( INTB.GE.129 .AND. INTB.LE.137 .OR.                         &
     &       INTB.GE.145 .AND. INTB.LE.153 .OR.                         &
     &       INTB.GE.162 .AND. INTB.LE.169 ) INTB = INTB + 64
!
         ELSE IF( ZCODE.EQ.218 .OR. ZCODE.EQ.250 )THEN
!
!        ASCII IS ASSUMED, ON PRIME MACHINES - ZCODE IS THE ASCII CODE
!        PLUS 128 OF EITHER LOWER OR UPPER CASE 'Z'.
!
            IF( INTA.GE.225 .AND. INTA.LE.250 ) INTA = INTA - 32
         IF( INTB.GE.225 .AND. INTB.LE.250 ) INTB = INTB - 32
         ENDIF
         LSAME = INTA == INTB
      ENDIF
      END FUNCTION LSAME

      END MODULE LA_AUXMOD

      SUBROUTINE SGETRF_F95( A, IPIV, RCOND, NORM, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => SP
      USE LA_AUXMOD, ONLY: LSAME, ERINFO
      USE F77_LAPACK, ONLY: GETRF_F77 => LA_GETRF, LANGE_F77 => LA_LANGE, &
                                          GECON_F77 => LA_GECON
!  .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT( OUT ), OPTIONAL :: RCOND
!  .. ARRAY ARGUMENTS ..
      INTEGER, INTENT( OUT ), OPTIONAL, TARGET :: IPIV( : )
      REAL(WP), INTENT( INOUT ) :: A( :, : )
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_GESV computes the solution to a real or complex linear system of
! equations A*X = B, where A is a square matrix and X and B are 
! rectangular matrices or vectors. Gaussian elimination with row 
! interchanges is used to factor A as A = P*L*U , where P is a permutation
! matrix, L is unit lower triangular, and U is upper triangular. The 
! factored form of A is then used to solve the above system.
! 
! =========
! 
!       SUBROUTINE LA_GESV( A, B, IPIV=ipiv, INFO=info )
!          <type>(<wp>), INTENT(INOUT) :: A(:,:), <rhs>
!          INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
!          INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!          <type> ::= REAL | COMPLEX
!          <wp>   ::= KIND(1.0) | KIND(1.0D0)
!          <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! A      (input/output) REAL or COMPLEX square array, shape (:,:).
!        On entry, the matrix A.
!        On exit, the factors L and U from the factorization A = P*L*U; 
!        the unit diagonal elements of L are not stored.
! B      (input/output) REAL or COMPLEX array, shape (:,:) with 
!        size(B,1) = size(A,1) or shape (:) with size(B) = size(A,1).
!        On entry, the matrix B.
!        On exit, the solution matrix X .
! IPIV   Optional (output) INTEGER array, shape (:) with size(IPIV) = 
!        size(A,1).
!        The pivot indices that define the permutation matrix P; row i of
!        the matrix was interchanged with row IPIV(i).
! INFO   Optional (output) INTEGER
!        = 0 : successful exit.
!        < 0 : if INFO = -i, the i-th argument has an illegal value.
!        > 0 : if INFO = i, then U(i,i) = 0. The factorization has been 
!        completed, but the factor U is singular, so the solution could
!        not be computed.
!        If INFO is not present and an error occurs, then the program is 
!        terminated with an error message.
!----------------------------------------------------------------------
!  .. PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GETRF'
!  .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: LNORM
      INTEGER :: LINFO, M, N, LD, ISTAT, ISTAT1, MINMN, LWORK, SIPIV
      REAL(WP) :: LANORM
!  .. LOCAL POINTERS ..
      INTEGER, POINTER :: LIPIV(:), IWORK(:)
      REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
      INTRINSIC PRESENT, MAX, MIN, SIZE, TINY
!  .. EXECUTABLE STATEMENTS ..
      M = SIZE(A,1); N = SIZE(A,2); LINFO = 0; ISTAT = 0; MINMN = MIN(M,N)
      LD = MAX(1,M)
      IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = MINMN; ENDIF
      IF ( PRESENT(NORM) ) THEN; LNORM = NORM; ELSE; LNORM = '1'; END IF
!  .. TEST THE ARGUMENTS
      IF( M < 0 .OR. N < 0 .OR. PRESENT(RCOND) .AND. M /= N )THEN; LINFO = -1
      ELSE IF( SIPIV /= MINMN )THEN; LINFO = -2
      ELSE IF( ( .NOT.PRESENT(RCOND) .AND. PRESENT(NORM) ) .OR. &
               ( .NOT.LSAME(LNORM,'I') .AND. .NOT.LSAME(LNORM,'O') &
                                       .AND. LNORM /= '1' ) ) THEN; LINFO = -4
      ELSE IF( M > 0 .AND. N > 0 ) THEN
         IF( PRESENT(RCOND) .AND. M == N ) THEN
!        .. COMPUTE THE NORM OF THE MATRIX A
            IF( LNORM == 'I' ) THEN; LWORK = MINMN; ELSE; LWORK = 1; END IF
            ALLOCATE( WORK(LWORK), STAT=ISTAT )
            IF( ISTAT == 0 )THEN
               LANORM = LANGE_F77( LNORM, MINMN, MINMN, A, LD, WORK )
            ELSE
               LINFO = -100
            END IF
            DEALLOCATE(WORK, STAT=ISTAT1)
         END IF
         IF( LINFO == 0 ) THEN
            IF( PRESENT(IPIV) )THEN; LIPIV => IPIV
            ELSE; ALLOCATE( LIPIV( MINMN ), STAT=ISTAT ); ENDIF
            IF( ISTAT /= 0 )LINFO = -100
         END IF
         IF( LINFO == 0 ) THEN
!           .. COMPUTE THE LU FACTORS OF THE MATRIX A
            CALL GETRF_F77( M, N, A, LD, LIPIV, LINFO )
            IF( .NOT. PRESENT(IPIV) )DEALLOCATE( LIPIV, STAT=ISTAT )
            IF( PRESENT(RCOND) ) THEN
!              .. COMPUTE THE RECIPROCAL OF THE CONDITION NUMBER OF A
               IF( LANORM <= TINY(1.0_WP) .OR. M /= N .OR. LINFO /= 0 ) THEN
                  RCOND = 0.0_WP
               ELSE 
                  ALLOCATE(WORK(4*MINMN), IWORK(MINMN), STAT=ISTAT)
                  IF( ISTAT == 0 )THEN
                     CALL GECON_F77( LNORM, MINMN, A, LD, LANORM, &
                                     RCOND, WORK, IWORK, LINFO )
                  ELSE
                     LINFO = -100
                  END IF
                  DEALLOCATE( WORK, IWORK, STAT=ISTAT1 )
               END IF
            END IF
         END IF
      ELSE IF( PRESENT(RCOND) ) THEN
         IF( M == N )THEN
            RCOND = 1.0_WP
         ELSE
            RCOND = 0.0_WP
         END IF
      END IF
      CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
      END SUBROUTINE SGETRF_F95

SUBROUTINE LA_TEST_SSPGVD( ITYPE, JOBZ, UPLO, N, AP, BP, W, Z, LDZ, WORK, LWORK, IWORK, LIWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     August 13, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SPGVD
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: ITYPE, N, LDZ, LWORK, LIWORK
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: JOBZ, UPLO
!  .. Array Arguments ..
      REAL(WP), INTENT(INOUT) :: AP(1:N*(N+1)/2), BP( 1:N*(N+1)/2)
      REAL(WP), INTENT(OUT)::  W(1:N), WORK(1:3*N), Z(1:LDZ, 1:N)
      INTEGER, INTENT(OUT) :: IWORK(1:LIWORK)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SPGVD'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SSPGVD'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IAP, IW, IBP, IITYPE, IZ1, IZ2
      CHARACTER*1 :: IUPLO, IJOBZ   
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      LOGICAL LSAME
!  .. Executable Statements ..
      IAP = N *(N+1)/2; IUPLO = UPLO; IW = N; IJOBZ = JOBZ
      IBP = N*(N+1)/2; IITYPE = ITYPE; IZ1 = MAX(1, N); IZ2 = N
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE (1)
      IAP = IAP - 1
      CASE (2)
      IBP = IAP - 1
      CASE (3)
      IW = IW - 1
      CASE (4)
      IITYPE = 22   
      CASE (5)
      IUPLO = 'T' 
      CASE (6)
      IZ2 = IZ2 - 1
      IJOBZ = 'V'
      CASE(:-1,7:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF (LSAME(IJOBZ, 'V')) THEN
        CALL LA_SPGVD( AP(1:IAP), BP(1:IBP), W(1 :IW), &
     &    IITYPE, IUPLO, Z(1:IZ1, 1: IZ2), INFO )
      ELSE
        CALL LA_SPGVD( AP(1:IAP), BP(1:IBP), W(1 :IW), &
     &    IITYPE, IUPLO, INFO = INFO )
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      END SUBROUTINE LA_TEST_SSPGVD

SUBROUTINE LA_TEST_SSBEVX( JOBZ, RANGE, UPLO, N, KD, AB, LDAB, Q, LDQ, &
     &  VL, VU, IL, IU, ABSTOL, M, W, Z, LDZ, &
     &  WORK, IWORK, IFAIL,INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 14, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SBEVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, LDAB, KD, LDQ, LDZ, IL, IU
      INTEGER, INTENT(INOUT) :: INFO
      INTEGER, INTENT(OUT) :: M
      CHARACTER*1, INTENT(IN) :: UPLO, JOBZ, RANGE
      REAL(WP), INTENT(IN) :: VL, VU, ABSTOL
!  .. Array Arguments ..
      INTEGER, INTENT(OUT) :: IFAIL(1:N)
      REAL(WP), INTENT(INOUT) :: AB(1:LDAB, 1:N)
      REAL(WP), INTENT(OUT)::  W(1:N), WORK(1 : 7*N), Z(1:LDZ, 1:N), &
     &  Q(1:LDQ,1:N)
      INTEGER, INTENT(OUT) :: IWORK(1: 5*N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SBEVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SSBEVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IAB1, IAB2, IW, IZ1, IZ2, IQ1, IQ2, &
     &  IIL, IIU, IIFAIL 
      REAL(WP) :: IVL, IVU
      CHARACTER*1 :: IUPLO, IJOBZ, IRANGE   
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      LOGICAL LSAME
!  .. Executable Statements ..
      IAB1 = KD+1 ; IAB2 = N; IUPLO = UPLO; IW = N; IJOBZ = JOBZ
      IZ1 = N; IZ2 = N; IRANGE = RANGE; IVL=VL; IVU=VU; IQ1 = N
      IQ2 = N; IIL=IL; IIU=IU; IIFAIL=N
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE (1)
      IAB1 = -2
      CASE (2)
      IW = IW - 1
      CASE (3)
      IUPLO = 'T'   
      CASE (4)
      IZ1 = IZ1 - 1; IJOBZ = 'V'
      CASE (5)
      IVL = IVU+1; IJOBZ = 'V'; IRANGE = 'V'
      CASE (6)
      IJOBZ = 'V'; IRANGE = 'V'
      CALL LA_SBEVX( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO, &
     &  Z(1:IZ1, 1: IZ2), IVL, IVU, IIL, IIU, M, IFAIL, &
     &  Q, ABSTOL, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (7)
      IJOBZ = 'V'; IRANGE = 'I'
      IIL = IIU+1
      CALL LA_SBEVX( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO, &
     &  Z(1:IZ1, 1: IZ2), IL=IIL, IU=IIU, M=M, IFAIL=IFAIL(1:IIFAIL),&
     &  Q=Q(1:IQ1,1:IQ2), ABSTOL=ABSTOL, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (8)
      IJOBZ = 'V'; IRANGE = 'I'
      IIU = IZ1+1; IIL = IIU
      CALL LA_SBEVX( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO, &
     &  Z(1:IZ1, 1: IZ2), IL=IIL, IU=IIU, M=M, IFAIL=IFAIL(1:IIFAIL),&
     &  Q=Q(1:IQ1,1:IQ2), ABSTOL=ABSTOL, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN   
      CASE (10)
      IIFAIL = IZ1 - 3
      IJOBZ = 'V'; IRANGE = 'V'
      CALL LA_SBEVX( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO,&
     &  Z(1:IZ1, 1: IZ2), IVL, IVU, M=M, IFAIL=IFAIL(1:IIFAIL),&
     &  Q=Q(1:IQ1,1:IQ2), ABSTOL=ABSTOL, INFO=INFO ) 
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN 
      CASE (11)
      IJOBZ = 'V'; IRANGE = 'V'
      IQ1 = IZ1 - 3
      CALL LA_SBEVX( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO,&
     &  Z(1:IZ1, 1: IZ2), IVL, IVU, M=M, IFAIL=IFAIL(1:IIFAIL),&
     &  Q=Q(1:IQ1,1:IQ2), ABSTOL=ABSTOL, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN  
      CASE(:-1,9,12:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF (LSAME (IJOBZ, 'V')) THEN
        IF(LSAME(IRANGE,'V')) THEN
          CALL LA_SBEVX( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO,&
     &      Z(1:IZ1, 1: IZ2), IVL, IVU, M=M, IFAIL=IFAIL(1:IIFAIL),&
     &      Q=Q(1:IQ1,1:IQ2), ABSTOL=ABSTOL, INFO=INFO )
        ELSE IF (LSAME(IRANGE,'I')) THEN
          CALL LA_SBEVX( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO, &
     &      Z(1:IZ1, 1: IZ2), IL=IIL, IU=IIU, M=M, IFAIL=IFAIL(1:IIFAIL),&
     &      Q=Q(1:IQ1,1:IQ2), ABSTOL=ABSTOL, INFO=INFO )
        ELSE IF (LSAME(IRANGE,'A')) THEN
          CALL LA_SBEVX( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO,&
     &      Z(1:IZ1, 1: IZ2), M=M, IFAIL=IFAIL(1:IIFAIL), &
     &      Q=Q(1:IQ1,1:IQ2), ABSTOL=ABSTOL, INFO=INFO )
        ENDIF
      ELSE
        IF (LSAME(IRANGE,'V')) THEN
          CALL LA_SBEVX( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO, &
     &      VL=IVL, VU=IVU, M=M, ABSTOL=ABSTOL, INFO=INFO )
        ELSE IF (LSAME(IRANGE,'I')) THEN
          CALL LA_SBEVX( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO,&
     &      IL=IIL, IU=IIU, M=M, ABSTOL=ABSTOL, INFO=INFO )
        ELSE IF (LSAME(IRANGE,'A')) THEN
          CALL LA_SBEVX( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO,&
     &      M=M, ABSTOL=ABSTOL, INFO=INFO )
        ENDIF 
      ENDIF
      
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      END SUBROUTINE LA_TEST_SSBEVX

      PROGRAM LA_SGEEVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GEEVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N, ILO, IHI
      REAL(WP) :: ABNRM
      REAL(WP), ALLOCATABLE :: WR(:), WI(:)
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), VL(:,:), VR(:,:), SCALE(:)
      REAL(WP), ALLOCATABLE :: RCONDE(:), RCONDV(:)
!  .. "Intrinsic Functions" ..
      INTRINSIC REAL, INT
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GEEVX Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), WR(N), WI(N), VL(N,N), VR(N,N), SCALE(N) )
      ALLOCATE( RCONDE(N), RCONDV(N) )
      
      OPEN(UNIT=21,FILE='geev1.ma',STATUS='UNKNOWN')
      DO I=1,N
         DO J=1,N
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=A

      WRITE(*,*)'Matrix A:'
      DO I=1,N
         WRITE(*,"(5(I3,1X))") INT(A(I,:))
      ENDDO

      WRITE(*,*) "CALL LA_GEEVX( A, WR, WI, 'B', ILO, IHI, SCALE,", &
                               " ABNRM, RCONDE, RCONDV )"  
!      CALL LA_GEEVX( A, WR, WI, VL, VR, 'B', ILO, IHI, SCALE, ABNRM, RCONDE, RCONDV )
!      CALL LA_GEEVX( A, WR, WI, BALANC='B', ILO=ILO, IHI=IHI, SCALE=SCALE, ABNRM=ABNRM,&
!&       RCONDE=RCONDE, RCONDV=RCONDV )
!        RCONDE=RCONDE, RCONDV=RCONDV )

       CALL LA_GEEVX( A, WR, WI, BALANC='B', ILO=ILO, IHI=IHI, &
            SCALE=SCALE, ABNRM=ABNRM, RCONDE=RCONDE, RCONDV=RCONDV )

      WRITE(*,*) "WR on exit : "
      DO I=1,N
         WRITE(*,"((E14.6,1X))") REAL(WR(I))
      ENDDO
   
      WRITE(*,*) "WI on exit : "
      DO I=1,N
         WRITE(*,"((E14.6,1X))") REAL(WI(I))
      ENDDO
   
      WRITE(*,*)'ILO : ',ILO
      WRITE(*,*)'IHI : ',IHI
      WRITE(*,*)'SCALE : ',SCALE
      WRITE(*,*)'ABNRM on exit :', ABNRM
      WRITE(*,*)'RCONDE on exit :', RCONDE
      WRITE(*,*)'RCONDV on exit :', RCONDV

      END PROGRAM LA_SGEEVX_EXAMPLE

      PROGRAM LA_SSYEVR_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SYEVR
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, M, N, IL, IU
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE ::  ISUPPZ(:)
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), W(:), Z(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_SYEVR Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), W(N), Z(N,N), ISUPPZ(2*N)  )

      OPEN(UNIT=21,FILE='syev.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=A

      WRITE(*,*)'Matrix A:'
      DO I=1,N; 
         WRITE(*,"(5(F9.5))") A(I,:); 
      ENDDO

      WRITE(*,*) 'CALL LA_SYEVR( A, W, Z=Z, ISUPPZ=ISUPPZ, IL=1, IU=2, M=M )'
      IL=1; IU=2

      CALL LA_SYEVR( A, W, IL=1, IU=2, M=M )

      WRITE(*,*)'Matrix A on exit :'
      DO I=1,N; 
         WRITE(*,"(5(F9.5))") A(I,:); 
      ENDDO


      WRITE(*,*)'M = ', M
      WRITE(*,*) 'W on exit :'
      DO I=1,M
         WRITE(*,"(5(F9.5))") W(I)
      ENDDO
      
      WRITE(*,*)'Z on exit :'
      DO I=1,N
         WRITE(*,"(5(E14.6))") Z(I,1:M)
      ENDDO
      WRITE(*,*)'ISUPPZ on exit:'
      WRITE(*,*) ISUPPZ(1:2*max(1,m))

      END PROGRAM LA_SSYEVR_EXAMPLE

      PROGRAM LA_SGGLSE_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GGLSE, LA_LANGE
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" .
      REAL(WP) ::  R1
      INTEGER :: I, J, INFO, M, N, P
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), C(:), D(:), X(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GGLSE Example Program Results'
      M=5; N = 3; P = 2
      ALLOCATE( A(M,N), B(P,N), C(M), D(P), X(N) )

      OPEN(UNIT=21,FILE='gglse.ma',STATUS='UNKNOWN')
      DO I=1,M 
         DO J=1,N
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)
    
      OPEN(UNIT=22,FILE='gglse.mb',STATUS='UNKNOWN')
      DO I=1,P 
         DO J=1,N
            READ(22,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(22)

      OPEN(UNIT=23,FILE='gglse.mc',STATUS='UNKNOWN')
      DO I=1,M 
         READ(23,*) C(I)
      ENDDO
      CLOSE(23)

      OPEN(UNIT=24,FILE='gglse.md',STATUS='UNKNOWN')
      DO I=1,P 
         READ(24,*) D(I)
      ENDDO
      CLOSE(24)
      
      WRITE(*,*)'Matrix A :'
      DO I=1,M;
         WRITE(*,"(3(F9.5))") A(I,:);
      ENDDO          
      
      WRITE(*,*)'Matrix B : '
      DO I=1,P; 
         WRITE(*,"(3(F9.5))") B(I,:); 
      ENDDO
      
      WRITE(*,*)'Vector C : '
      DO I=1,M; 
         WRITE(*,"(F9.5)") C(I); 
      ENDDO
      
      WRITE(*,*) 'Vector D : '
      DO I=1,P; 
         WRITE(*,"(F9.5))") D(I); 
      ENDDO
      WRITE(*,*)
      WRITE(*,*) 'CALL LA_GGLSE( A, B, C, D, X, INFO )'
      CALL LA_GGLSE( A, B, C, D, X, INFO )
   
      WRITE(*,*) 'C on exit : '
      DO I=1,M; 
         WRITE(*,"(E14.6)") C(I); 
      ENDDO
    
      WRITE(*,*) 'X on exit : '
      DO I=1,N; 
         WRITE(*,"(E14.5)") X(I); 
      ENDDO
       
      WRITE(*,*)'INFO = ',INFO
       
      R1=LA_LANGE(C(N-P+1:M),'F')
      WRITE(*,*)'The residual r = ',R1
     
      END PROGRAM LA_SGGLSE_EXAMPLE

      PROGRAM LA_SGTSV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999

!  .. "Use Statements"
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GTSV
!  .."Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, INFO, N, NRHS
      INTEGER, ALLOCATABLE :: IPIV(:)
!  .. Local Arrays ..
      REAL(WP), ALLOCATABLE :: DL(:), D(:), DU(:), B(:,:),X(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'GTSV Example Program Results.'
      N = 6; NRHS = 3

      ALLOCATE(DL(N-1),D(N),DU(N-1),B(N,NRHS), X(N,NRHS), IPIV(N) )

      OPEN(UNIT=21,FILE='gtsv.ma',STATUS='UNKNOWN')
          DO I=1,N-1
          READ(21,'(F2.0)') DL(I)
          ENDDO
          DO I=1,N
          READ(21,'(F2.0)') D(I)   
          ENDDO
          DO I=1,N-1
          READ(21,'(F2.0)') DU(I)
          ENDDO
      CLOSE(21)

      WRITE(*,*)'DU :'
      WRITE(*,"(I3,1X)") INT(DU(:));
         
      WRITE(*,*)'D :'
      WRITE(*,"(I3,1X)") INT(D(:)); 
      
      WRITE(*,*)'DL :'
      WRITE(*,"(I3,1X)") INT(DL(:)); 
    
      DO I = 2, N-1; B(I,:) = DL(I-1) + D(I) + DU(I); ENDDO
      B(1,:) = D(1) + DU(1);B(N,:) = DL(N-1) + D(N)
      DO I = 1, NRHS; B(:,I) = B(:,I)*I; ENDDO
   
      WRITE(*,*) 'The RHS matrix B:'
      DO I=1,N; WRITE(*,"(3(I3,1X))") INT(B(I,:)); ENDDO
   
      WRITE(*,*) ' CALL LA_GTSV(DL, D, DU, B, INFO)'
      CALL LA_GTSV(DL, D, DU, B, INFO )

      WRITE(*,*)'DL on exit: '
      WRITE(*,"(F8.5)") DL(:); 
      WRITE(*,*)'D on exit: '
      WRITE(*,"(F8.5)") D(:); 
      WRITE(*,*)'DU on exit: '
      WRITE(*,"(F8.5)") DU(:); 
      WRITE(*,*)'B on exit: '
      DO I=1,N; WRITE(*,"(6(F8.5))") B(I,:); ENDDO

      WRITE(*,*)'INFO = ',INFO

      DEALLOCATE(DL,D,DU,B,X)

      END PROGRAM LA_SGTSV_EXAMPLE

 SUBROUTINE SGELSX_F95( A, B, RANK, JPVT, RCOND, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => SP
    USE LA_AUXMOD, ONLY: ERINFO
    USE F77_LAPACK, ONLY: GELSX_F77 => LA_GELSX
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL :: RANK
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
    REAL(WP), INTENT(IN), OPTIONAL :: RCOND
!   .. ARRAY ARGUMENTS ..
    INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: JPVT(:)
    REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
!-----------------------------------------------------------------
!
! Purpose
! =======
!
! LA_GELSX computes the minimum-norm solution to a real linear least
! squares problem:
!     minimize || A * X - B ||
! using a complete orthogonal factorization of A.  A is an m-by-n
! matrix which may be rank-deficient.
! Several right hand side vectors b and solution vectors x can be
! handled in a single call; they are stored as the columns of the
! M-by-NRHS right hand side matrix B and the n-by-nrhs solution
! matrix X.
! The routine first computes a QR factorization with column pivoting:
!     A * P = Q * [ R11 R12 ]
!                 [  0  R22 ]
! with R11 defined as the largest leading submatrix whose estimated
! condition number is less than 1/RCOND.  The order of R11, RANK,
! is the effective rank of A.
! Then, R22 is considered to be negligible, and R12 is annihilated
! by orthogonal transformations from the right, arriving at the
! complete orthogonal factorization:
!    A * P = Q * [ T11 0 ] * Z
!                [  0  0 ]
! The minimum-norm solution is then
!    X = P * Z' [ inv(T11)*Q1'*B ]
!               [        0       ]
! where Q1 consists of the first RANK columns of Q.
!
!
! Arguments
! =========
!
!  SUBROUTINE LA_GELSX( A, B, RANK, JPVT, RCOND, INFO )
!    <type>(<wp>), INTENT( INOUT ) :: A( :, : ), <rhs>
!    INTEGER, INTENT(IN), OPTIONAL :: RANK
!    INTEGER, INTENT(OUT), OPTIONAL :: JPVT(:)
!    REAL(<wp>), INTENT(IN), OPTIONAL :: RCOND
!    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!    <type> ::= REAL | COMPLEX
!    <wp>   ::= KIND(1.0) | KIND(1.0D0)
!    <rhs>  ::= B(:,:) | B(:)
!
! =====================
!
! A    (input/output) Deither REAL or COMPLEX array, shape (:,:),
!      SIZE(A,1) == m, SIZE(A,2) == n.
!      On entry, the m-by-n matrix A.
!      On exit, A has been overwritten by details of its
!      complete orthogonal factorization.
!      INFO = -1 if SIZE(A,1) < 0 or SIZE(A,2) < 0
!
! B    Optional (input/output) either REAL or COMPLEX array, shape either
!      (:,:) or (:), size(B,1) or size(B) == size(A,1). SIZE(B,2) == nrhs.
!      On entry, the m-by-nrhs right hand side matrix B.
!      On exit, the n-by-nrhs solution matrix X.
!      If m >= n and RANK = n, the residual sum-of-squares for
!      the solution in the i-th column is given by the sum of
!      squares of elements n+1:m in that column.
!      INFO = -2 if SIZE(B,1) /= max(SIZE(A,1), SIZE(A,2)) or SIZE(B,2) < 0
!                    and if shape of B is (:,:) or
!                if SIZE(B) /= max(SIZE(A,1), SIZE(A,2)) or SIZE(B,2) < 0
!                   and if shape of B is (:)
!
! RANK Optional (output) INTEGER
!      The effective rank of A, i.e., the order of the submatrix
!      R11.  This is the same as the order of the submatrix T11
!      in the complete orthogonal factorization of A.
!
! JPVT Optional (input/output) INTEGER array, shape (:), SIZE(JPVT) == n
!      On entry, if JPVT(i) .ne. 0, the i-th column of A is an
!      initial column, otherwise it is a free column.  Before
!      the QR factorization of A, all initial columns are
!      permuted to the leading positions; only the remaining
!      free columns are moved as a result of column pivoting
!      during the factorization.
!      On exit, if JPVT(i) = k, then the i-th column of A*P
!      was the k-th column of A.
!      INFO = -4 if SIZE(S) /= SIZE(A,2)
!
! RCOND Optional (input) REAL
!      RCOND is used to determine the effective rank of A, which
!      is defined as the order of the largest leading triangular
!      submatrix R11 in the QR factorization with pivoting of A,
!      whose estimated condition number < 1/RCOND.
!
! INFO    (output) INTEGER
!      = 0:  successful exit
!      < 0:  if INFO = -i, the i-th argument had an illegal value
!      If INFO is not present and an error occurs, then the program is
!         terminated with an error message.
!--------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GELSX'
!   .. LOCAL SCALARS ..
    INTEGER :: LINFO, ISTAT, ISTAT1, LWORK, N, M, MN, NRHS, LRANK, SJPVT
    REAL(WP) :: LRCOND
!   .. LOCAL POINTERS ..
    INTEGER, POINTER :: LJPVT(:)
    REAL(WP), POINTER :: WORK(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT, MAX, MIN, EPSILON
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2); NRHS = SIZE(B,2)
    MN = MIN(M,N)
    IF( PRESENT(RCOND) )THEN; LRCOND = RCOND; ELSE
       LRCOND = 100*EPSILON(1.0_WP) ; ENDIF
    IF( PRESENT(JPVT) )THEN; SJPVT = SIZE(JPVT); ELSE; SJPVT = N; ENDIF
!   .. TEST THE ARGUMENTS
    IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B, 1 ) /= MAX(1,M,N) .OR. NRHS < 0 ) THEN; LINFO = -2
    ELSE IF( SJPVT /= N ) THEN; LINFO = -4
    ELSE IF( LRCOND <= 0.0_WP ) THEN; LINFO = -5
    ELSE
       IF( PRESENT(JPVT) )THEN; LJPVT => JPVT
       ELSE; ALLOCATE( LJPVT(N), STAT = ISTAT ); LJPVT = 0; END IF
       IF( ISTAT == 0 ) THEN
          LWORK = MAX( 1, MIN(M,N) + 3*N, 2*MIN(M,N) + NRHS )
          ALLOCATE( WORK(LWORK), STAT = ISTAT )
          IF( ISTAT /= 0 ) CALL ERINFO( -200, SRNAME, LINFO )
       END IF
       IF ( ISTAT == 0 ) THEN
          CALL GELSX_F77( M, N, NRHS, A, MAX(1,M), B, MAX(1,M,N), &
                         LJPVT, LRCOND, LRANK, WORK, LINFO )
       ELSE; LINFO = -100; END IF
       IF( PRESENT(RANK) ) RANK = LRANK
       IF( PRESENT(JPVT) ) JPVT = LJPVT
       DEALLOCATE(WORK, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE SGELSX_F95

SUBROUTINE LA_TEST_SGETRI( N, A, LDA, IPIV, WORK, LWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     October 31, 1996
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GETRI
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDA, LWORK
   INTEGER, INTENT(INOUT) :: INFO
!  .. Array Arguments ..
   INTEGER, INTENT(OUT) :: IPIV(1:N)
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), WORK(*)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GETRI'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGETRI'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IIPIV
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IIPIV = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
         CALL LA_GETRI( A(1:IA1,1:IA2), IPIV(1:IIPIV) )
         INFO = INFOTC
   CASE (1)
      IA2 = IA1-1
   CASE (2)
      IIPIV = IA1-1
   CASE(:-1,3:)
      CALL UESTOP(SRNAMT)
   END SELECT
   IF( I /= 0 ) THEN
     CALL LA_GETRI( A(1:IA1,1:IA2), IPIV(1:IIPIV), INFO )
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_SGETRI

      PROGRAM LA_CHPEVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_HPEVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N
      REAL(WP), ALLOCATABLE :: W(:)  
!  .. "Local Arrays" ..
      COMPLEX(WP), ALLOCATABLE :: A(:), AA(:), Z(:,:)
!  .. "Intrinsic Functions" ..
      INTRINSIC AIMAG, INT
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_HPEVX Example Program Results'
      N = 5
      ALLOCATE( A(N*(N+1)/2), AA(N*(N+1)/2), W(N), Z(N,N) )

      OPEN(UNIT=21,FILE='hpev.ma',STATUS='UNKNOWN')
      DO J=1,N*(N+1)/2
         READ(21,*) A(J)
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix A:'
      DO I=1,N*(N+1)/2
         WRITE(*,"((I3,1X,'+',1X,I3,'i',1X))") INT(A(I)), INT(AIMAG(A(I)))
      ENDDO
   
      WRITE(*,*) "CALL LA_HPEVX( A, W, IL=2, IU=5, ABSTOL=1.0E-5_WP ) "
      CALL LA_HPEVX( A, W, IL=2, IU=5, ABSTOL=1.0E-5_WP )
      
      WRITE(*,*) 'W on exit : '
      DO I=1,N
      WRITE(*,"(5(F9.5))") W(I)
      ENDDO

      END PROGRAM LA_CHPEVX_EXAMPLE

      PROGRAM LA_SPOSV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_POSV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N, NRHS
      CHARACTER(LEN=1) :: UPLO
!  .. "Local Arrays" ..
 !    INTEGER, DIMENSION(NP) :: IPUT
      REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), AA(:,:),BB(:,:), S(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SPOSV Example Program Results'
      N = 5; NRHS = 3

      ALLOCATE ( A(N,N), B(N,NRHS), AA(N,N), BB(N,NRHS), S(N) )
 
      OPEN(UNIT=21,FILE='posv.ma',STATUS='UNKNOWN')
      DO I=1,N
         DO J=I,N
         READ(21,'(F3.0)') A(I,J);
         ENDDO
      ENDDO;
      CLOSE(21)

      WRITE(*,*) 'The array A :'
      DO I=1,N
      WRITE(*,'(10(I3,1X,1X),I3,1X)') INT(A(I,1:N)); 
      ENDDO
     
      DO I = 1, N 
        DO J = 1, NRHS
        B(I,J) = (SUM(A(I,I:N)) + SUM(A(1:I-1,I)))*J
        ENDDO 
      ENDDO
     
      AA = TRANSPOSE(A)
      BB = B
      WRITE(*,*) 'The array B :'
      DO I=1,N
      WRITE(*,'(3(I3,1X,1X))') INT(B(I,1:NRHS));
      ENDDO
 
      WRITE(*,*) 'CALL LA_POSV( A, B )'
      CALL LA_POSV(  A, B )

      WRITE(*,*)'A on exit: '
      DO I=1,N; WRITE(*,"(5(E15.6))") A(I,1:N); 
      ENDDO
  
      WRITE(*,*)'B on exit: '
      DO I=1,N; WRITE(*,"(3(F9.5))") B(I,1:NRHS);
      ENDDO
      
      WRITE(*,*)' * Example 2 * '
    
      WRITE(*,*) 'The array A :'
      DO J=1,N
      WRITE(*,'(10(I3,1X,1X),I3,1X)') INT(AA(J,:)); 
      ENDDO

      WRITE(*,*) 'The array B(:,1) :'
      Do I=1,N
      WRITE(*,'(3(I3,1X,1X))') INT(BB(I,1));
      ENDDO

      WRITE(*,*) "CALL LA_POSV( A, B(:,1), 'L' )"
      UPLO='L'
      CALL LA_POSV(  AA, BB(:,1), 'L' )

      WRITE(*,*)'A on exit: '
      DO J=1,N; WRITE(*,"(6(E13.6))") AA(J,:); ENDDO

      WRITE(*,*)'B on exit: '
      DO I=1,N; WRITE(*,"(3(F8.5))") BB(I,1); ENDDO

      END PROGRAM LA_SPOSV_EXAMPLE

!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, INFO, N 
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:), W(:)
   COMPLEX(WP), ALLOCATABLE :: A(:,:), B(:,:)
!  .. EXECUTABLE STATEMENTS ..
   READ(NIN,*) ! SKIP HEADING IN DATA FILE
   READ(NIN,*) N
   ALLOCATE ( A(N,N), B(N,N), W(N), AA(N,N), BB(N,N) )
      DO I = 1, N
        READ(NIN,*) (AA(I, J), J = 1, N)
      ENDDO
      DO I = 1, N
        READ(NIN,*) (BB(I, J), J = 1, N)
      ENDDO
      A=AA; B=BB
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      ENDDO
      WRITE(NOUT,*) 'The matrix B:'
      DO I = 1, N
        WRITE(NOUT,FMT) B(I,:)
      ENDDO
!
   WRITE(NOUT,*) '---------------------------------------------------------'
   WRITE(NOUT,*)

      PROGRAM LA_SSYSV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SYSV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N, NRHS
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE :: IPIV(:)
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:)
!  .. "Intrinsic Functions" ..
      INTRINSIC  SUM
!  .. "Executable Statements" ..
      WRITE (*,*) 'SSYSV Example Program Results'
      N = 5; NRHS = 3
      WRITE(*,'(5H N = , I4, 9H; NRHS = , I4)') N, NRHS
      ALLOCATE ( A(N,N), AA(N,N), B(N,NRHS), BB(N,NRHS), IPIV(N) )
    
      OPEN(UNIT=21,FILE='sysv.ma',STATUS='UNKNOWN')
      DO I=1,N
         DO J=I,N
         READ(21,'(F3.0)') A(I,J);
         ENDDO
      ENDDO;
      CLOSE(21)

      WRITE(*,*) 'The array A :'
      DO I=1,N
      WRITE(*,'(10(I3,1X,1X),I3,1X)') INT(A(I,1:N)); 
      ENDDO
      AA=TRANSPOSE(A)
      DO I = 1, N 
        DO J = 1, NRHS
        B(I,J) = (SUM(A(I,I:N)) + SUM(A(1:I-1,I)))*J
        ENDDO 
      ENDDO
     
      WRITE(*,*) 'The array B :'
      DO I=1,N
            WRITE(*,'(3(I3,1X,1X))') INT(B(I,1:NRHS));
      ENDDO
      BB=B
      WRITE(*,*)' CALL LA_SYSV( A, B, IPIV=IPIV )'
      CALL LA_SYSV( A, B, IPIV=IPIV )
   
      WRITE(*,*)'A on exit: '
      DO J=1,N; WRITE(*,"(6(E13.5))") A(J,:); 
      ENDDO

      WRITE(*,*)'B on exit: '
      DO I=1,N; WRITE(*,"(3(F9.5))") B(I,:);
      ENDDO

      WRITE(*,*)'IPIV on exit : ', IPIV
    
      WRITE(*,*)' * EXAMPLE 2 * '

      WRITE(*,*) 'The array A :'
      DO I=1,N
      WRITE(*,'(10(I3,1X,1X),I3,1X)') INT(AA(I,1:N)); 
      ENDDO
      WRITE(*,*) 'The array B :'
      DO I=1,N
      WRITE(*,'(3(I3,1X,1X))') INT(BB(I,1));
      ENDDO
      
      WRITE(*,*)"CALL LA_SYSV( A, B(:,1), 'L', IPIV, INFO )"
      CALL LA_SYSV( AA, BB(:,1), 'L', IPIV, INFO )
   
      WRITE(*,*)'A on exit: '
      DO J=1,N; WRITE(*,"(6(E13.5))") AA(J,:); 
      ENDDO

      WRITE(*,*)'B(:,1) on exit: '
      DO I=1,N; WRITE(*,"(3(F9.5))") BB(I,1);
      ENDDO

      WRITE(*,*)' IPIV = ',IPIV
      WRITE(*,*)' INFO = ',INFO


!      DEALLOCATE (A, AA, B, BB, IPIV)
      print *,'after the dealloc'
      END PROGRAM LA_SSYSV_EXAMPLE

SUBROUTINE LA_TEST_SGGES(JOBVSL, JOBVSR, SORT, SELECT, N, A, LDA, B, LDB, SDIM, &
&   ALPHAR, ALPHAI, BETA, VSL, LDVSL, VSR, LDVSR, WORK, LWORK, BWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     September 25, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GGES
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDA, LDB, LDVSL, LDVSR, LWORK
   INTEGER, INTENT(INOUT) :: INFO
   INTEGER, INTENT(OUT) :: SDIM
   CHARACTER*1, INTENT(IN) :: JOBVSL, JOBVSR, SORT
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB, 1:N)
   REAL(WP), INTENT(OUT):: WORK(1:LWORK)
   LOGICAL :: BWORK(1: N)
   REAL(WP), INTENT(OUT) :: ALPHAR(1:N), ALPHAI(1:N), BETA(1:N), &
     &  VSL(1: LDVSL, 1:N), VSR(1: LDVSR, 1:N)
   INTERFACE
     LOGICAL FUNCTION SELECT(ALPHAR, ALPHAI, BETA)
     USE LA_PRECISION, ONLY: WP => SP
     REAL(WP), INTENT(IN) :: ALPHAR, ALPHAI, BETA
   END FUNCTION SELECT
 END INTERFACE
 OPTIONAL :: SELECT   
      
!  .. Parameters ..
 CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GGES '
 CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGGES '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IALPHAI, IALPHAR, IBETA, IVSL1, &
     &  IVSL2, IVSR1, IVSR2
   CHARACTER*1 :: IJOBVSL, IJOBVSR, ISORT
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IJOBVSL = JOBVSL; IJOBVSR = JOBVSR
   IB1 = N; IB2 = N; IALPHAR = N; IALPHAI = N; IBETA = N
   IVSL1 = N; IVSL2 = N; IVSR1 = N; IVSR2 = N; ISORT = SORT
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
       IA2 = IA1 - 1
     CASE (2)
       IB1 = IA1 - 1
       CASE (3)
       IALPHAR = IA1 - 1
       CASE (4)
       IALPHAI = IA1 - 1 
       CASE (5)
       IBETA  = IA1 - 1
       CASE (6)
       ISORT = 'N'; IJOBVSL = 'V'; IJOBVSR = 'N'
       IVSL1 = IA1 - 1
       CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &   ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
     &   BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2),  SDIM=SDIM, &
     &   INFO=INFO)
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN
       CASE (7)
       ISORT = 'N'; IJOBVSL = 'N'; IJOBVSR = 'V' 
       IVSR1 = IA1 - 1
       CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &   ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA),&
     &   VSR = VSR(1:IVSR1,1:IVSR2), SELECT = SELECT, SDIM=SDIM,& 
     &   INFO = INFO)
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN 
       CASE(:-1, 8:)
       CALL UESTOP(SRNAMT)
   END SELECT

   IF (LSAME(ISORT, 'N')) THEN
      IF (LSAME(IJOBVSL,'V')) THEN
        IF (LSAME (IJOBVSR, 'V')) THEN
          CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &      ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
     &      BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
     &      VSR=VSR(1:IVSR1,1:IVSR2),SDIM=SDIM,  &
     &      INFO=INFO)
        ELSE
          CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &      ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
     &      BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), SDIM=SDIM, & 
     &      INFO=INFO)    
        END IF
      ELSE 
        IF (LSAME (IJOBVSR, 'V')) THEN
          CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &      ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
     &      BETA=BETA(1: IBETA), VSR = VSR(1:IVSR1,1:IVSR2), &
     &      SDIM=SDIM, INFO = INFO)
        ELSE
          CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &      ALPHAR=ALPHAR(1: IALPHAR), ALPHAI=ALPHAI(1:IALPHAI), &
     &      BETA=BETA(1: IBETA), SDIM=SDIM, INFO = INFO)
        END IF
      END IF
      ELSE
        IF (LSAME(IJOBVSL,'V')) THEN
          IF (LSAME (IJOBVSR, 'V')) THEN
            CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &        ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA), &
     &        VSL(1:IVSL1,1:IVSL2), VSR(1:IVSR1,1:IVSR2), SELECT, SDIM, &
     &        INFO)    
          ELSE
            CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &        ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA),&
     &        VSL(1:IVSL1,1:IVSL2), SELECT = SELECT, SDIM = SDIM, INFO=INFO) 
          END IF
        ELSE 
          IF (LSAME (IJOBVSR, 'V')) THEN
            CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &        ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA),&
     &        VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, INFO = INFO)
          ELSE
            CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &        ALPHAR(1: IALPHAR), ALPHAI(1:IALPHAI), BETA(1: IBETA), &
     &        SELECT = SELECT, SDIM = SDIM, INFO = INFO)
          END IF
        END IF
      END IF
CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_SGGES

SUBROUTINE LA_TEST_ZGESVX( FACT, TRANS, N, NRHS, A, LDA, AF, LDAF, IPIV, &
                   EQUED, R, C, B, LDB, X, LDX, RCOND, FERR, BERR, &
                   WORK, RWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     October 31, 1996
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO
   USE F95_LAPACK, ONLY: LA_GESVX
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   CHARACTER(LEN=1), INTENT(INOUT) :: EQUED
   CHARACTER(LEN=1), INTENT(IN) :: FACT, TRANS
   INTEGER, INTENT(IN) :: N, NRHS, LDA, LDB, LDAF, LDX
   INTEGER, INTENT(INOUT) :: INFO
   REAL(WP), INTENT(OUT) :: RCOND
!  .. Array Arguments ..
   INTEGER, INTENT(INOUT) :: IPIV(1:N)
   COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N), AF(1:LDAF,1:N), B(1:LDB,1:N), &
                              WORK(*), X(1:LDX,1:NRHS)
   REAL(WP), INTENT(INOUT) :: BERR(1:NRHS), FERR(1:NRHS), R(1:N), C(1:N), &
                              RWORK(*)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GESVX'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZGESVX'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   CHARACTER(LEN=1) :: LFACT, LTRANS, LEQUED
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IX1, IX2, IAF1, IAF2, IIPIV, &
              IR, IC, IFERR, IBERR
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IB1 = N; IB2 = NRHS; IX1 = N; IX2 = NRHS
   IAF1 = N; IAF2 = N; IIPIV = N; LFACT = FACT; LTRANS = TRANS
   LEQUED = EQUED; IR = N; IC = N; IFERR = NRHS; IBERR = NRHS
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
      IF (NRHS == 1) THEN
        CALL LA_GESVX( A(1:IA1,1:IA2), B(1:IB1,1), X(1:IX1,1), &
        AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), LFACT, LTRANS, LEQUED, &
        R(1:IR), C(1:IC), FERR(1), BERR(1), RCOND, RWORK(1) )
        INFO = INFOTC
      ELSE
        CALL LA_GESVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
        AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), LFACT, LTRANS, LEQUED, &
        R(1:IR), C(1:IC), FERR(1:IFERR), BERR(1:IBERR), RCOND, &
        RWORK(1) )
        INFO = INFOTC
      ENDIF
   CASE (1)
      IA2 = IA1-1
   CASE (2)
      IB1 = IA1-1
   CASE (3)
I3:   SELECT CASE(J)
      CASE(1)
         IX1 = IA1-1
      CASE (2)
         IX2 = IB2-1
      CASE (3:)
         CALL UESTOP(SRNAMT)
      END SELECT I3
   CASE (4)
I4:   SELECT CASE(J)
      CASE(1)
         IAF1 = IA1-1
      CASE (2)
         IAF2 = IA1-1
      CASE (3:)
         CALL UESTOP(SRNAMT)
      END SELECT I4
   CASE (5)
      IIPIV = IA1-1
   CASE (6)
I6:   SELECT CASE(J)
      CASE(1)
         LFACT = '/'
      CASE (2)
         SELECT CASE(NRHS)
         CASE (2:)
            CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                 AF(1:IAF1,1:IAF2), FACT='F', INFO = INFO)
          CASE (1)
             CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1), X(1:IX1,1), &
                 AF(1:IAF1,1:IAF2), FACT='F', INFO=INFO)
          CASE DEFAULT
             CALL UESTOP(SRNAMT)
          END SELECT
      CASE (3)
         SELECT CASE(NRHS)
         CASE (2:)
            CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                 IPIV=IPIV(1:IIPIV), FACT='F', INFO=INFO)
          CASE (1)
             CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1), X(1:IX1,1), &
                  IPIV=IPIV(1:IIPIV), FACT='F', INFO=INFO)
          CASE DEFAULT
             CALL UESTOP(SRNAMT)
          END SELECT
      CASE (4)
         SELECT CASE(NRHS)
         CASE (2:)
            CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                 FACT='F', INFO=INFO)
          CASE (1)
             CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1), X(1:IX1,1), &
                  FACT='F', INFO=INFO)
          CASE DEFAULT
             CALL UESTOP(SRNAMT)
          END SELECT
      CASE (5:)
         CALL UESTOP(SRNAMT)
      END SELECT I6
   CASE (7)
      LTRANS = '/'; LFACT = 'N'; LEQUED = 'N'
   CASE (8)
      LFACT = 'F'; LTRANS = 'N'
I8:   SELECT CASE (J)
      CASE (1)
         LEQUED = '/'
      CASE (2)
         LEQUED = 'R'
         SELECT CASE (NRHS)
         CASE (2:)
            CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                 AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), LFACT, LTRANS, LEQUED, &
                 INFO=INFO)
         CASE (1)
            CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1), X(1:IX1,1), &
                 AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), LFACT, LTRANS, LEQUED, &
                 INFO=INFO)
          CASE DEFAULT
             CALL UESTOP(SRNAMT)
         END SELECT
      CASE (3)
         LEQUED = 'B'
         SELECT CASE (NRHS)
         CASE (2:)
            CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                 AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), LFACT, LTRANS, LEQUED, &
                 INFO=INFO)
         CASE (1)
            CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1), X(1:IX1,1), &
                 AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), LFACT, LTRANS, LEQUED, &
                 INFO=INFO)
          CASE DEFAULT
             CALL UESTOP(SRNAMT)
         END SELECT
      CASE (4)
         LEQUED = 'C'
         SELECT CASE (NRHS)
         CASE (2:)
            CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                 AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), LFACT, LTRANS, LEQUED, &
                 INFO=INFO)
         CASE (1)
            CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1), X(1:IX1,1), &
                 AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), LFACT, LTRANS, LEQUED, &
                 INFO=INFO)
          CASE DEFAULT
             CALL UESTOP(SRNAMT)
         END SELECT
      CASE (5:)
         CALL UESTOP(SRNAMT)
      END SELECT I8
   CASE (9)
      LFACT = 'F'; R(1) = -1.0_WP; C = +1.0_WP
I9:   SELECT CASE (J)
      CASE(1)
         IR = IA1-1
      CASE(2)
         LEQUED = 'R'
      CASE(3)
         LEQUED = 'B'
      CASE (4:)
         CALL UESTOP(SRNAMT)
      END SELECT I9
   CASE (10)
      LFACT = 'F'; R = +1.0_WP; C(1) = -1.0_WP
I10:  SELECT CASE (J)
      CASE(1)
         IC = IA1-1
      CASE(2)
         LEQUED = 'C'
      CASE(3)
         LEQUED = 'B'
      CASE (4:)
         CALL UESTOP(SRNAMT)
      END SELECT I10
   CASE (11)
      IFERR = IB2-1
   CASE (12)
      IBERR = IB2-1
   CASE (13:)
      CALL UESTOP(SRNAMT)
   END SELECT
   IF( .NOT. ( ( I == 6 .AND. ( J == 2 .OR. J == 3 .OR. J == 4 ) ) &
         .OR. ( I == 8 .AND. ( J == 2 .OR. J == 3 .OR. J == 4 ) )) &
         .AND. ( I /= 0 )) THEN 
      SELECT CASE (NRHS)
      CASE (2:)
         CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
              AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), LFACT, LTRANS, LEQUED, &
              R(1:IR), C(1:IC), FERR(1:IFERR), BERR(1:IBERR), RCOND, &
              RWORK(1), INFO)
      CASE (1)
         IF( INFO /= 202 .AND. INFO /= 302 .AND. I /= 11 .AND. I /= 12 )THEN
            CALL LA_GESVX(A(1:IA1,1:IA2), B(1:IB1,1), X(1:IX1,1), &
                 AF(1:IAF1,1:IAF2), IPIV(1:IIPIV), LFACT, LTRANS, LEQUED, &
                 R(1:IR), C(1:IC), FERR(1), BERR(1), RCOND, RWORK(1), INFO)
          ELSE
             CALL ERINFO( -I, SRNAME, INFO )
          END IF
      END SELECT
   END IF
   EQUED = LEQUED
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_ZGESVX

SUBROUTINE LA_TEST_ZPTSVX( FACT, N, NRHS, D, E, DF, EF, B, LDB, X, LDX,&
     &  RCOND, FERR, BERR, WORK, RWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     April 7, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => DP
      USE F95_LAPACK, ONLY: LA_PTSVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, NRHS, LDB, LDX
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER(LEN=1), INTENT(IN) :: FACT
      REAL(WP), INTENT(OUT) :: RCOND 
!  .. Array Arguments ..
      REAL(WP), INTENT(IN) :: D(1:N)
      COMPLEX(WP), INTENT(IN) :: E(1:N-1), B(1:LDB,1:NRHS)
      REAL(WP), INTENT(INOUT) :: DF(1:N)
      COMPLEX(WP), INTENT(INOUT) :: EF(1:N)
      COMPLEX(WP), INTENT(OUT) :: X(1:LDX,1:NRHS), WORK(1:N)
      REAL(WP), INTENT(OUT) :: FERR(1:NRHS), BERR(1:NRHS)
      REAL(WP), INTENT(OUT) :: RWORK(1: N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_PTSVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZPTSVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, ID, IE, IB1, IB2, IX1, IX2, IDF, IEF, &
     &  IFERR, IBERR
      CHARACTER(LEN=1) :: IFACT
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      ID = N; IE = N-1; IB1 = N; IB2 = NRHS; IX1 = N; IX2 = NRHS
      IDF = N; IEF=N-1; IFACT = FACT; IFERR = NRHS; IBERR = NRHS
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE(0)
      IF (NRHS == 1) THEN
        CALL LA_PTSVX( D(1:ID), E(1:IE), B(1:IB1,1), X(1:IX1,1),&
     &    DF(1:IDF), EF(1:IEF), IFACT, FERR(1), BERR(1),&
     &    RCOND, INFO )
        INFO = INFOTC
      ELSE
        CALL LA_PTSVX( D(1:ID), E(1:IE), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
     &    DF(1:IDF), EF(1:IEF), IFACT, FERR(1: IFERR), BERR(1:IBERR),&
     &    RCOND, INFO ) 
        INFO = INFOTC
      END IF
      CASE (2)
      IE = ID - 2
      CASE(3)
      IB1 = ID - 1
      CASE (4)
      IX1 = ID - 1
      CASE (5)
      IDF = ID - 1
      CASE (6)
      IEF = IE - 1
      CASE (7)
      IFACT = 'T'
      CASE (8)
      IFERR = IB2 - 1
      CALL LA_PTSVX( D(1:ID), E(1:IE), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
     &  DF(1:IDF), EF(1:IEF), IFACT, FERR(1: IFERR), BERR(1:IBERR),&
     &  RCOND, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (9)
      IBERR = IB2 - 1
      CALL LA_PTSVX( D(1:ID), E(1:IE), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
     &  DF(1:IDF), EF(1:IEF), IFACT, FERR(1: IFERR), BERR(1:IBERR),&
     &  RCOND, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN  
      CASE(:-1, 1, 10:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF( I /= 0 ) THEN
        SELECT CASE (NRHS)
        CASE (2:)
        CALL LA_PTSVX( D(1:ID), E(1:IE), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
     &    DF(1:IDF), EF(1:IEF), IFACT, FERR(1: IFERR), BERR(1:IBERR),&
     &    RCOND, INFO )
        CASE(1)
        CALL LA_PTSVX( D(1:ID), E(1:IE), B(1:IB1,1), X(1:IX1,1),&
     &    DF(1:IDF), EF(1:IEF), IFACT, FERR(1), BERR(1),&
     &    RCOND, INFO )
        CASE(:-1)
        CALL UESTOP(SRNAMT)
      END SELECT
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_ZPTSVX
      

      PROGRAM LA_SGESV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GESV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N, NRHS
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE :: IPIV(:)
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SGESV Example Program Results.'
      OPEN(UNIT=21,FILE='gesv.ma',STATUS='UNKNOWN')
      READ (21, * ) N
      READ (21, * ) NRHS
      ALLOCATE( A(N,N), AA(N,N), B(N,NRHS), BB(N,NRHS), IPIV(N) )
      DO J=1,N
      DO I=1,N 
         READ(21,'(F2.0)') AA(I,J)
      ENDDO  
      ENDDO
      CLOSE(21)

      DO J = 1, NRHS; BB(:,J) = SUM( AA, DIM=2)*J; ENDDO

      WRITE(*,*) 'The matrix A:'
      DO I=1,N; WRITE(*,"(4(I3,1X),I3,1X)") INT(AA(I,:)); ENDDO

      WRITE(*,*) 'The RHS matrix B:'
      DO I=1,N; WRITE(*,"(2(I3,1X),I3,1X)") INT(BB(I,:)); ENDDO

      WRITE(*,*) 'CALL LA_GESV( A, B )'
      A=AA; B=BB

      CALL LA_GESV(  A, B )
   
      WRITE(*,*) 'B - the solution vectors computed by LA_GESV'
      DO I=1,N; WRITE(*,"(2(E12.6,1X),E12.6,1X)") B(I,:); ENDDO
   
      WRITE(*,*) 'CALL LA_GESV( A, B(:,1), IPIV, INFO )'

      CALL LA_GESV(  AA, BB(:,1), IPIV, INFO )
   
      WRITE(*,*) ' A on exit:'
      DO I=1,N; WRITE(*,"(4(E12.6,1X),E12.6,1X)") AA(I,:); ENDDO
     
      WRITE(*,*) 'B on exit:'
      DO I=1,N; WRITE(*,"(4(E12.6,1X),E12.6,1X)") BB(I,1); ENDDO

      WRITE(*,*)'IPIV on exit:', IPIV

      WRITE(*,*)'INFO on exit:', INFO
   
      END PROGRAM LA_SGESV_EXAMPLE

      PROGRAM LA_SGBSV_EXAMPLE
 
!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
 
!  .. "Use Statements"
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GBSV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: K, KL, KU, I, J, N, NRHS, INFO
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE :: IPIV(:)
      REAL(WP), ALLOCATABLE :: AB(:,:), B(:,:)
!  .. "Executable Statements" ..
       WRITE (*,*) 'SGBSV Example Program Results.'
       N = 6; KL = 2; KU = 1; NRHS = 2  
       ALLOCATE ( AB(2*KL+KU+1,N), B(N,NRHS), IPIV(N))
       
       OPEN(UNIT=21,FILE='gbsv.ma',STATUS='UNKNOWN')
       DO I=KL+1,2*KL+KU+1 
       DO J=1,N
          READ(21,'(F2.0)') AB(I,J)
       ENDDO  
       ENDDO
       CLOSE(21)

       WRITE(*,*) 'The matrix AB:'
       DO I=1,N; WRITE(*,"(5(I3,1X,1X),I3,1X)") INT(AB(I,:)); 
       ENDDO
      
       DO I = 1, NRHS  
       DO J = 1, N
       DO K = MAX(1,J-KL),MIN(J+KU,N); B(J,I) = AB(KL+KU+1+J-K,K)+B(J,I); 
       ENDDO
       ENDDO; 
       B(:,I) = B(:,I)*I; 
       ENDDO
       
       WRITE(*,*) 'The RHS matrix B:'
       DO I=1,N; WRITE(*,"(1(I3,1X),I3,1X)") INT(B(I,:)); ENDDO
       WRITE(*,*) 'CALL LA_GBSV( AB, B, 2, IPIV, INFO)' 

       CALL LA_GBSV( AB, B, 2, IPIV, INFO )

       WRITE(*,*)'AB on exit: '
       DO I=1,2*KL+KU+1; WRITE(*,"(5(E12.6,1X),E12.6,1X)") AB(I,:); ENDDO
       WRITE(*,*)'B on exit: '
       DO I=1,N; WRITE(*,"(1(E12.6,1X),E12.6,1X)") B(I,:); ENDDO
       WRITE(*,*)'IPIV on exit: ', IPIV
       WRITE(*,*)'INFO on exit: ', INFO

       END PROGRAM LA_SGBSV_EXAMPLE

SUBROUTINE LA_TEST_DGELSD( M, N, NRHS, A, LDA, B, LDB, S, RCOND, RANK, WORK, LWORK, IWORK,  INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     September 10, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GELSD
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: M, N, NRHS, LDA, LDB
   INTEGER, INTENT(INOUT) :: INFO
   INTEGER, INTENT(OUT) :: RANK
   INTEGER, INTENT(IN) :: LWORK
   REAL(WP), INTENT(IN) :: RCOND
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB,1:NRHS)
   REAL(WP), INTENT(OUT) :: WORK(1:LWORK)
   INTEGER :: IWORK(1:LWORK)
   REAL(WP), INTENT(OUT) :: S(1:MIN(M,N))
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GELSD'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DGELSD'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IS
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = M; IA2 = N; IB1 = MAX(1,M,N); IB2 = NRHS; IS = MIN(M,N)
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE(0)
       IF (NRHS==1) THEN
         CALL LA_GELSD( A(1:IA1,1:IA2), B(1:IB1,1), RANK,&
&          S(1:IS), RCOND, INFO )
         INFO = INFOTC
       ELSE
         CALL LA_GELSD( A(1:IA1,1:IA2), B(1:IB1,1:IB2), RANK,&
&          S(1:IS), RCOND, INFO )
         INFO = INFOTC
       ENDIF
     CASE (2)
       IB1 = MAX(1, N, M) - 1
     CASE(4)
       IS = MIN (M, N) - 1
     CASE(:-1,1,3, 5:)
       CALL UESTOP(SRNAMT)
   END SELECT
   IF (I/=0) THEN
     SELECT CASE (NRHS) 
       CASE (2:)
         CALL LA_GELSD( A(1:IA1,1:IA2), B(1:IB1,1:IB2), RANK,&
&          S(1:IS), RCOND, INFO )
       CASE(1)
         CALL LA_GELSD( A(1:IA1,1:IA2), B(1:IB1,1), RANK,&
&          S(1:IS), RCOND, INFO )
       CASE(:-1)
         CALL UESTOP(SRNAMT)
     END SELECT
   ENDIF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_DGELSD

SUBROUTINE LA_TEST_ZHBGVX(JOBZ, RANGE, UPLO, N, KAB, KBB, AB, LDAB, BB,&
     &  LDBB, Q, LDQ, VL, VU, IL, IU, ABSTOL, M, W, Z, &
     &  LDZ, WORK, RWORK, IWORK, IFAIL, INFO )
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark
!     August 20, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => DP
      USE F95_LAPACK, ONLY: LA_HBGVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      CHARACTER(LEN=1), INTENT(INOUT) :: JOBZ, RANGE, UPLO
      INTEGER, INTENT(IN) :: N, IL, IU, KAB, KBB, LDAB, LDBB, &
     &  LDQ, LDZ
      INTEGER, INTENT(OUT) :: M
      INTEGER, INTENT(INOUT) :: INFO
      REAL(WP), INTENT(IN) ::  ABSTOL, VL, VU 
!  .. Array Arguments ..
      INTEGER, INTENT(OUT) ::  IWORK(1:5*N)
      COMPLEX(WP), INTENT(INOUT) :: AB(1:LDAB,1:N), BB(1:LDBB,1:N)
      COMPLEX(WP), INTENT(OUT) :: WORK(1:N), Q(1:LDQ,1:N), &
     &  Z(1:LDZ,1:N)
      REAL(WP), INTENT(OUT) :: W(1:N)
      REAL(WP), INTENT(OUT) :: RWORK(1:7*N)
      INTEGER, INTENT(OUT) :: IFAIL(1:N)
      LOGICAL LSAME
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_HBGVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZHBGVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      CHARACTER(LEN=1) :: IJOBZ, IRANGE, IUPLO
      INTEGER :: I, J, IAB1, IAB2, IBB1, IBB2, IQ1, IQ2, IW, IZ1, IZ2
      INTEGER :: IIL, IIU, IIFAIL
      REAL(WP) :: IVL, IVU, IABSTOL
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IAB1 = KAB+1; IAB2 = N; IBB1 = KBB+1; IBB2 = N; IQ1 = N; IQ2 = N
      IW = N; IZ1 = N; IZ2 = N; IIL = IL; IIU = IU; IIFAIL = N
      IJOBZ = JOBZ; IRANGE = RANGE; IUPLO = UPLO
      IVL = VL; IVU = VU; IABSTOL = ABSTOL
      I =  INFO / 100; J = INFO - I*100
      IF (IRANGE == 'A') THEN; M=N; ELSE; M=IIL - IIL + 1; ENDIF
      SELECT CASE(I)
      CASE(1)
      IAB1 = -1
      CASE (2)
      IBB1 = -1
      CASE (3)
      IW = IW - 1
      CASE (4)
      IUPLO = 'T'
      CASE (5)
      IZ1 = IZ1 - 1
      CASE (6)   
      IVU = IVL -1
      CASE (7)
      CALL LA_HBGVX( AB(1:IAB1,1:IAB2), BB(1:IBB1,1:IBB2), W=W, &
     &  UPLO=IUPLO, Z=Z(1:IZ1,1:IZ2), VL=IVL, VU=IVU, IL=IIL, &
     &  IU=IIU, M=M, IFAIL=IFAIL(1:IIFAIL),&
     &  Q=Q(1:IQ1,1:IQ2), ABSTOL=IABSTOL, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )  
      RETURN
      CASE (8)
      IIU = IIL - 1
      CASE (9)
      IIU = N+1
      CASE (10)
      IIFAIL = IAB1 - 1
      CASE(11)
      IQ2 = IQ2 - 1
      CASE (:-1, 12:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF (LSAME(IJOBZ, 'V')) THEN
        IF (LSAME(IRANGE,'A')) THEN
          CALL LA_HBGVX( AB(1:IAB1,1:IAB2), BB(1:IBB1,1:IBB2), W, IUPLO,&
     &      Z=Z(1:IZ1,1:IZ2), M=M, IFAIL=IFAIL(1:IIFAIL),               &
     &      Q=Q(1:IQ1,1:IQ2), ABSTOL=IABSTOL, INFO=INFO )
        ELSE IF (LSAME(IRANGE,'I')) THEN
          CALL LA_HBGVX( AB(1:IAB1,1:IAB2), BB(1:IBB1,1:IBB2), W, IUPLO, &
     &      Z=Z(1:IZ1,1:IZ2), IL=IIL, IU=IIU, M=M, IFAIL=IFAIL(1:IIFAIL),& 
     &      Q=Q(1:IQ1,1:IQ2), ABSTOL=IABSTOL, INFO=INFO ) 
        ELSE
          CALL LA_HBGVX( AB(1:IAB1,1:IAB2), BB(1:IBB1,1:IBB2), W, IUPLO, &
     &      Z=Z(1:IZ1,1:IZ2), VL=IVL, VU=IVU, M=M, IFAIL=IFAIL(1:IIFAIL),&
     &      Q=Q(1:IQ1,1:IQ2), ABSTOL=IABSTOL, INFO=INFO )
        ENDIF
      ELSE
        IF (LSAME(IRANGE,'A')) THEN 
          CALL LA_HBGVX( AB(1:IAB1,1:IAB2), BB(1:IBB1,1:IBB2), W, IUPLO, &
     &      M=M, ABSTOL=IABSTOL, INFO=INFO )
        ELSE IF (LSAME(IRANGE,'I')) THEN
          CALL LA_HBGVX( AB(1:IAB1,1:IAB2), BB(1:IBB1,1:IBB2), W, IUPLO, &
     &      IL=IIL, IU=IIU, M=M, ABSTOL=IABSTOL, INFO=INFO )  
        ELSE
          CALL LA_HBGVX( AB(1:IAB1,1:IAB2), BB(1:IBB1,1:IBB2), W, IUPLO,&
     &      VL=IVL, VU=IVU,  M=M, ABSTOL=IABSTOL, INFO=INFO )
        END IF
      ENDIF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_ZHBGVX

SUBROUTINE DGEEVX_F95( A, WR, WI, VL, VR, BALANC, ILO, IHI, &
                       SCALE, ABNRM, RCONDE, RCONDV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: GEEVX_F77 => LA_GEEVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: BALANC
   INTEGER, INTENT(OUT), OPTIONAL :: INFO, ILO, IHI
   REAL(WP), INTENT(OUT), OPTIONAL :: ABNRM
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:)
   REAL(WP), INTENT(OUT) :: WR(:), WI(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: SCALE(:), RCONDE(:), RCONDV(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!        LA_GEEVX computes for a real or complex square matrix A, the 
! eigenvalues and, optionally, the left and/or right eigenvectors. 
! Optionally, it also balances A and computes reciprocal condition
! numbers for the  eigenvalues and right eigenvectors.
! A right eigenvector v(j) of A satisfies
!                   A * v(j) = lambda(j) * v(j)
! where lambda(j) is its eigenvalue. A left eigenvector u(j) of A 
! satisffies
!                   u(j)^H * A = lambda(j) * u(j)^H
! where u(j)^H denotes the conjugate-transpose of u(j). The computed
! eigenvectors are normalized to have Euclidean norm equal to 1 and 
! largest component real.
!        Balancing A involves permuting its rows and columns to make 
! it more nearly upper triangular and then scaling rows and columns by
! a diagonal similarity transformation to reduce the condition numbers 
! of the eigenvalues and eigenvectors.
!        Computed reciprocal condition numbers pertain to the matrix 
! after balancing. Permuting does not change condition numbers (in 
! exact arithmetic), but scaling does.
!
! =========
! 
!    SUBROUTINE LA_GEEVX( A, <w>, VL=vl, VR=vr, BALANC=balanc, ILO=ilo, &
!                     IHI=ihi, SCALE=scale, ABNRM=abnrm, RCONDE=rconde, &
!                     RCONDV=rcondv, INFO=info )
!         <type>(<wp>), INTENT(INOUT) :: A(:,:)
!         <type>(<wp>), INTENT(OUT) :: <w(:)>
!         <type>(<wp>), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
!         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: BALANC
!         INTEGER, INTENT(OUT), OPTIONAL :: ILO, IHI
!         REAL(<wp>), INTENT(OUT), OPTIONAL :: SCALE(:), ABNRM, &
!               RCONDE(:), RCONDV(:)
!         INTEGER, INTENT(OUT), OPTIONAL :: INFO
!    where
!         <type> ::= REAL | COMPLEX
!         <wp>   ::= KIND(1.0) | KIND(1.0D0)
!         <w>    ::= WR, WI | W
!         <w(:)> ::= WR(:), WI(:) | W(:)
! 
! Arguments
! =========
! 
! A        (input/output) REAL or COMPLEX square array, shape (:,:).
!          On entry, the matrix A.
!          On exit, the contents of A are destroyed.
! <w>      (output) REAL or COMPLEX array, shape (:) with size(w) = 
!          size(A,1).
!          The computed eigenvalues.
!          <w(:)> ::= WR(:), WI(:) | W(:),
!          where
!          WR(:), WI(:) are of REAL type (for the real and imaginary
!          parts) and W(:) is of COMPLEX type.
!          Note: If A is real, then a complex-conjugate pair appear 
!          consecutively, with the eigenvalue having the positive 
!          imaginary part appearing first.
! VL       Optional (output) REAL or COMPLEX square array, shape (:,:)
!          with size(VL,1) = size(A,1).
!          The left eigenvectors u(j) are stored in the columns of VL in
!          the order of their eigenvalues. Each eigenvector is scaled so
!          that the Euclidean norm is 1 and the largest component is real.
!          Note: If A is real then complex eigenvectors, like their 
!          eigenvalues, occur in complex conjugate pairs. The real and 
!          imaginary parts of the first eigenvector of the pair are
!          stored in VL(:,j) and VL(:,j+1). Thus a complex conjugate pair
!          is given by 
!            u(j) = VL(:,j) + i*VL(:,j+1), u(j+1) = VL(:,j) - i*VL(:,j+1)
! VR       Optional (output) REAL or COMPLEX square array, shape (:,:) 
!          with size(VR,1) = size(A,1).
!          The right eigenvectors v(j) are stored in the columns of VR in
!          the order of their eigenvalues.
!          Each eigenvector is scaled so that the Euclidean norm is 1 and 
!          the largest component is real.
!          Note: If A is real then complex eigenvectors, like their 
!          eigenvalues, occur in complex conjugate pairs. The real and 
!          imaginary parts of the first eigenvector of the pair are stored
!          in VR(:,j) and VR(:,j+1). Thus a complex conjugate pair is 
!          given by 
! 	     v(j) = VR(:,j) + i*VR(:,j+1), v(j+1) = VR(:,j) - i*VR(:,j+1)
! BALANC   Optional (input) CHARACTER(LEN=1).
!          Indicates whether the input matrix should be permuted and/or 
!          diagonally scaled.
!             = 'N': Do not permute or scale;
!             = 'P': Permute but do not scale;
!             = 'S': Scale but do not permute;
!             = 'B': Both permute and scale.
!           Default value: 'N'.
! ILO,IHI  Optional (output) INTEGER.
!          ILO and IHI are determined when A is balanced. The balanced
!          A(i,j) = 0 if i > j and j = 1, ..., ILO-1 or 
!          i = IHI+1, ... , size(A,1).
! SCALE    Optional (output) REAL array, shape (:) with size(SCALE) = 
!          size(A,1).
!          Details of the permutations and scaling factors applied when 
!          balancing A. If P(j) is the index of the row and column 
!          interchanged with row and column j, and D(j) is the
!          scaling factor applied to row and column j, then
!          P(j) = SCALE(j), j = 1, ..., ILO-1 and j =IHI+1, ...,  n
!          D(j) = SCALE(j), j = ILO, ... , IHI.
! ABNRM    Optional (output) REAL.
!          The l1 norm of the balanced matrix (the maximum of the sum 
!          of absolute values of elements of any column).
! RCONDE   Optional (output) REAL array, shape (:) with size(RCONDE) =
!          size(A,1). RCONDE(j) is the reciprocal condition number of 
!          the j-th eigenvalue.
! RCONDV   Optional (output) REAL array, shape (:), size(RCONDV) = 
!          size(A,1). RCONDV(j) is the reciprocal condition number of 
!          the j-th right eigenvector.
! INFO     Optional (output) INTEGER.
!          = 0: successful exit.
!          < 0: if INFO = -i, the i-th argument had an illegal value.
!          > 0: if INFO = i, the QR algorithm failed to compute all the 
!          eigenvalues and no eigenvectors or condition numbers were
!          computed; elements 1:ILO-1 and i+1:n of <w> contain
!          eigenvalues which have converged.
!          If INFO is not present and an error occurs, then the program
!          is terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GEEVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LBALANC, LJOBVL, LJOBVR, LSENSE
   INTEGER, SAVE :: LWORK = 0
   INTEGER :: N, LINFO, LD, ISTAT, ISTAT1, S1VL, S2VL, S1VR, S2VR, NN, &
              LILO, LIHI, SSCALE, SRCONDE, SRCONDV
   REAL(WP) :: LABNRM
!  .. LOCAL ARRAYS ..
   INTEGER, TARGET :: LLIWORK(1)
   INTEGER, POINTER :: IWORK(:)
   REAL(WP) :: WORKMIN(1)
   REAL(WP), POINTER :: LSCALE(:), LRCONDE(:), LRCONDV(:)
   REAL(WP), POINTER :: LLVL(:,:), LLVR(:,:)
   REAL(WP), POINTER :: WORK(:)
   
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(A,1); LD = MAX(1,N)
   IF( PRESENT(BALANC) )THEN; LBALANC = BALANC; ELSE; LBALANC = 'N'; ENDIF
   IF( PRESENT(VL) )THEN; S1VL = SIZE(VL,1); S2VL = SIZE(VL,2); LJOBVL = 'V'
   ELSE; S1VL = 1; S2VL = N; LJOBVL = 'N'; END IF
   IF( PRESENT(VR) )THEN; S1VR = SIZE(VR,1); S2VR = SIZE(VR,2); LJOBVR = 'V'
   ELSE; S1VR = 1; S2VR = N; LJOBVR = 'N'; END IF
   IF( PRESENT(SCALE) )THEN; SSCALE = SIZE(SCALE); ELSE; SSCALE = N; ENDIF
   IF( PRESENT(RCONDE) )THEN; SRCONDE = SIZE(RCONDE); ELSE; SRCONDE = N; ENDIF
   IF( PRESENT(RCONDV) )THEN; SRCONDV = SIZE(RCONDV); ELSE; SRCONDV = N; ENDIF
!  .. TEST THE ARGUMENTS
   IF( N < 0 .OR. SIZE(A,2) /= N )THEN; LINFO = -1
   ELSE IF( SIZE( WR ) /= N )THEN; LINFO = -2
   ELSE IF( SIZE( WI ) /= N )THEN; LINFO = -3
   ELSE IF( PRESENT(VL) .AND. ( S1VL /= N .OR. S2VL /= N ) )THEN; LINFO = -4
   ELSE IF( PRESENT(VR) .AND. ( S1VR /= N .OR. S2VR /= N ) )THEN; LINFO = -5
   ELSE IF( .NOT.( LSAME(LBALANC,'N') .OR. LSAME(LBALANC,'P') .OR. &
                   LSAME(LBALANC,'S') .OR. LSAME(LBALANC,'B') ) )THEN; LINFO = -6
   ELSE IF( SSCALE /= N )THEN; LINFO = -9
   ELSE IF( SRCONDE /= N )THEN; LINFO = -11
   ELSE IF( SRCONDV /= N )THEN; LINFO = -12
   ELSE IF( N > 0 )THEN
      IF( PRESENT(BALANC) )THEN; LBALANC = BALANC; ELSE; LBALANC = 'N'; ENDIF
      IF( PRESENT(RCONDE).AND.PRESENT(RCONDV) )THEN; LSENSE = 'B'
      ELSE IF( PRESENT(RCONDE) )THEN; LSENSE = 'E'
      ELSE IF( PRESENT(RCONDV) )THEN; LSENSE = 'V'; ELSE; LSENSE = 'N'; ENDIF
      IF( PRESENT(SCALE) )THEN; LSCALE => SCALE
      ELSE; ALLOCATE( LSCALE(N), STAT=ISTAT ); ENDIF
      IF( ISTAT == 0 ) THEN
         IF( PRESENT(RCONDE) )THEN; LRCONDE => RCONDE
         ELSE; ALLOCATE( LRCONDE(N), STAT=ISTAT ); ENDIF
      END IF
      IF( ISTAT == 0 ) THEN
         IF( PRESENT(RCONDV) )THEN; LRCONDV => RCONDV
         ELSE; ALLOCATE( LRCONDV(N), STAT=ISTAT ); ENDIF
      END IF
      IF( ISTAT == 0 ) THEN
         IF( LSAME(LSENSE,'N') .OR. LSAME(LSENSE,'E') )THEN; IWORK => LLIWORK
         ELSE; ALLOCATE( IWORK(MAX( 1, 2*N-2 )), STAT=ISTAT ); ENDIF
      END IF

      IF (LSAME (LSENSE,'E') .OR. LSAME(LSENSE,'B') ) THEN
        LJOBVL = 'V'; LJOBVR = 'V'; S1VR=N; S1VL=N
      ENDIF
      
      IF (PRESENT (VL)) THEN; LLVL => VL
      ELSE; ALLOCATE (LLVL(N,N), STAT = ISTAT); ENDIF
      IF (PRESENT (VR)) THEN; LLVR => VR
      ELSE; ALLOCATE (LLVR(N,N), STAT = ISTAT); ENDIF
			
      IF( ISTAT == 0 ) THEN
! QUERY FOR THE SIZE OF WORK        
         LWORK = -1
	 IF (PRESENT (VL)) THEN
  	   IF (PRESENT(VR)) THEN
	     CALL GEEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, WR, WI, &
&              VL, S1VL, VR, S1VR, LILO, LIHI, LSCALE, LABNRM, &
&              LRCONDE, LRCONDV, WORKMIN, LWORK, IWORK, LINFO )
            ELSE
	     CALL GEEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, WR, WI, &
&              VL, S1VL, LLVR, S1VR, LILO, LIHI, LSCALE, LABNRM, &
&              LRCONDE, LRCONDV, WORKMIN, LWORK, IWORK, LINFO )
	    ENDIF
	  ELSE
	    IF (PRESENT(VR)) THEN
	     CALL GEEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, WR, WI, &
&              LLVL, S1VL, VR, S1VR, LILO, LIHI, LSCALE, LABNRM, &
&              LRCONDE, LRCONDV, WORKMIN, LWORK, IWORK, LINFO )
            ELSE
	     CALL GEEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, WR, WI, &
&              LLVL, S1VL, LLVR, S1VR, LILO, LIHI, LSCALE, LABNRM, &
&              LRCONDE, LRCONDV, WORKMIN, LWORK, IWORK, LINFO )
	    ENDIF
	  ENDIF  
         LWORK = WORKMIN(1)
        
         ALLOCATE(WORK(LWORK), STAT=ISTAT)
         IF( ISTAT /= 0 )THEN; DEALLOCATE(WORK, STAT=ISTAT1)
	    NN = MAX(1, 3*N, N*(N+6))
            LWORK = MAX( 1, NN); ALLOCATE(WORK(LWORK), STAT=ISTAT)
            IF( ISTAT == 0) CALL ERINFO( -200, SRNAME, LINFO )
         END IF
      END IF
      IF( ISTAT == 0 ) THEN
        IF (PRESENT (VL)) THEN
          IF (PRESENT(VR)) THEN
             CALL GEEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, WR, WI, &
&               VL, S1VL, VR, S1VR, LILO, LIHI, LSCALE, LABNRM, &
&               LRCONDE, LRCONDV, WORK, LWORK, IWORK, LINFO )
          ELSE
             CALL GEEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, WR, WI, &
&               VL, S1VL, LLVR, S1VR, LILO, LIHI, LSCALE, LABNRM, &
&               LRCONDE, LRCONDV, WORK, LWORK, IWORK, LINFO )
          ENDIF
	ELSE
          IF (PRESENT(VR)) THEN
             CALL GEEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, WR, WI, &
&               LLVL, S1VL, VR, S1VR, LILO, LIHI, LSCALE, LABNRM, &
&               LRCONDE, LRCONDV, WORK, LWORK, IWORK, LINFO )
          ELSE
             CALL GEEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, WR, WI, &
&               LLVL, S1VL, LLVR, S1VR, LILO, LIHI, LSCALE, LABNRM, &
&               LRCONDE, LRCONDV, WORK, LWORK, IWORK, LINFO )
          ENDIF
        ENDIF  
        IF( LINFO == 0 ) LWORK = INT(WORK(1)+1)
	ELSE; LINFO = -100; ENDIF
      IF( PRESENT(ILO) ) ILO = LILO; IF( PRESENT(IHI) ) IHI = LIHI
      IF( PRESENT(ABNRM) ) ABNRM = LABNRM
      IF( .NOT. PRESENT(SCALE) ) DEALLOCATE( LSCALE, STAT=ISTAT1 )
      IF( .NOT. PRESENT(RCONDE) ) DEALLOCATE( LRCONDE, STAT=ISTAT1 )
      IF( .NOT. PRESENT(RCONDV) ) DEALLOCATE( LRCONDV, STAT=ISTAT1 )
      IF( LSAME(LSENSE,'V').OR.LSAME(LSENSE,'B') ) DEALLOCATE(IWORK,STAT=ISTAT1)
      DEALLOCATE(WORK, STAT=ISTAT1)
      IF (.NOT.PRESENT (VL)) DEALLOCATE(LLVL)
      IF (.NOT.PRESENT (VR)) DEALLOCATE(LLVR)
   ENDIF
   CALL ERINFO(LINFO, SRNAME, INFO, ISTAT)

END SUBROUTINE DGEEVX_F95

SUBROUTINE LA_TEST_ZHEEVX( JOBZ, RANGE, UPLO,  N, A, LDA, VL, VU, IL, &
     &  IU, ABSTOL, M, W, Z, LDZ, WORK, LWORK, RWORK, IWORK, IFAIL, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     September 11, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => DP
      USE F95_LAPACK, ONLY: LA_HEEVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, LDA, LDZ, IL, IU, LWORK
      REAL(WP), INTENT(IN) ::  ABSTOL, VL, VU
      INTEGER, INTENT(OUT) :: M
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: UPLO, JOBZ, RANGE
!  .. Array Arguments ..
      COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N)
      REAL(WP), INTENT(OUT)::  W(1:N)
      COMPLEX(WP), INTENT(OUT) :: WORK(1:LWORK), Z(1:LDZ,1:N)
      INTEGER, INTENT(OUT) :: IWORK(1:5*N), IFAIL(1:N)
      REAL(WP), INTENT(OUT) :: RWORK (1: 7*N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_HEEVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZHEEVX'
      LOGICAL LSAME
      EXTERNAL LSAME
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, IW, IIL, IIU, IIFAIL
      REAL(WP) :: IVU, IVL
      CHARACTER*1 :: IUPLO, IJOBZ, IRANGE   
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IA1 = N; IA2 = N; IUPLO = UPLO; IW = N; IJOBZ = JOBZ
      IVU=VU; IVL = VL;IIL=IL; IIU = IU; IIFAIL = N
      I = INFO / 100; J = INFO - I*100; IRANGE=RANGE
      
      SELECT CASE(I)
      CASE (1)
      IA2 = IA1 - 1
      CASE (2)
      IW = IA1 - 1
      CASE (3)
        IJOBZ = 'T'
        CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
&         M=M, IFAIL=IFAIL(1:IIFAIL), ABSTOL=ABSTOL, INFO=INFO )
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
        RETURN
      CASE (4)
        IUPLO = 'T'
      CASE (5)
        IVL = IVU+1; IJOBZ='V'; IRANGE='V'
        CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
&         IVL, IVU,  M=M, IFAIL=IFAIL(1:IIFAIL), ABSTOL=ABSTOL,&
&         INFO=INFO )
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
        RETURN
      CASE (6)
        IRANGE='A'; IJOBZ='V'
        CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
&         IVL, IVU, IL, IU,  M, IFAIL(1:IIFAIL),&
&         ABSTOL, INFO )
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
        RETURN
      CASE(7)
        IIL = IIU + 1; IJOBZ='V'; IRANGE='I'
        CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
&         IL=IIL, IU=IIU, M=M,IFAIL=IFAIL(1 :IIFAIL), &
&         ABSTOL=ABSTOL, INFO=INFO )
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
        RETURN
      CASE (8)
        IIU = IA2 + 1;  IIL = IIU; IJOBZ='V'; IRANGE='I'     
        CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
&         IL=IIL, IU=IIU, M=M, ABSTOL=ABSTOL, INFO=INFO )
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
        RETURN
      CASE(10)
        IIFAIL = IA2 - 1; IJOBZ='V'; IRANGE='A'
        CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
&         M=M, IFAIL=IFAIL(1:IIFAIL), ABSTOL=ABSTOL, INFO=INFO )
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
        RETURN
      CASE(:-1,9,11:)
        CALL UESTOP(SRNAMT)
    END SELECT
    IF (LSAME(IRANGE,'A')) THEN
      IF (LSAME(IJOBZ, 'V')) THEN
        CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
&         M=M, IFAIL=IFAIL(1:IIFAIL), ABSTOL=ABSTOL, INFO=INFO )
      ELSE
        CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), UPLO=IUPLO, &
&         M=M, ABSTOL=ABSTOL, INFO=INFO )
      END IF
    ELSE
      IF (LSAME(IRANGE, 'V')) THEN
        IF (LSAME(IJOBZ, 'V')) THEN
          CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
&           IVL, IVU,  M=M, IFAIL=IFAIL(1:IIFAIL), ABSTOL=ABSTOL,&
&           INFO=INFO )
        ELSE
          CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), UPLO=IUPLO,  &
&           VL=IVL, VU=IVU, M=M, ABSTOL=ABSTOL, INFO=INFO )
        END IF
      ELSE
        IF (LSAME(IJOBZ, 'V')) THEN
          CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
&           IL=IIL, IU=IIU, M=M,IFAIL=IFAIL(1 :IIFAIL), &
&           ABSTOL=ABSTOL, INFO=INFO )
        ELSE
          CALL LA_HEEVX( A(1:IA1,1:IA2), W(1 :IW), UPLO=IUPLO, &
&           IL=IIL, IU=IIU, M=M, ABSTOL=ABSTOL, INFO=INFO )
        ENDIF
      END IF
    ENDIF
    IF (N/=0) Z(1:IA1, 1:M) = A(1:IA1, 1:M)
    CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_ZHEEVX

SUBROUTINE LA_TEST_SSBGVD( JOBZ, UPLO, N, KAB, KBB, AB, LDAB, BB, LDBB, W, Z, LDZ, WORK, LWORK, IWORK, LIWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     August 11, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SBGVD
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, KAB, KBB, LDAB, LDBB, LDZ, LWORK, LIWORK
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: JOBZ, UPLO
!  .. Array Arguments ..
      INTEGER, INTENT(OUT) :: IWORK(1: LIWORK)
      REAL(WP), INTENT(INOUT) :: AB(1:LDAB, 1:N), BB( 1:LDBB, 1:N)
      REAL(WP), INTENT(OUT)::  W(1:N), WORK(1: LWORK), Z(1:LDZ, 1:N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SBGVD'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SSBGVD'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IAB1, IAB2, IW, IBB1, IBB2, IZ1, IZ2
      CHARACTER*1 :: IUPLO, IJOBZ   
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      LOGICAL LSAME
!  .. Executable Statements ..
      IAB1 = KAB + 1; IAB2 = N; IUPLO = UPLO; IW = N; IJOBZ = JOBZ
      IBB1 = KBB + 1; IBB2 = N; IZ1 = N; IZ2 = N
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE (1)
      IAB1  = IAB1 - 1
      CASE (2)
      IBB2 = IBB2 - 1
      CASE (3)
      IW = IW - 1
      CASE (4)
      IUPLO = 'T'
      CASE (5)
      IZ2 = IZ2 - 1
      CALL LA_SBGVD( AB(1:IAB1, 1: IAB2), BB(1:IBB1, 1:IBB2), W(1 :IW), &
     &  IUPLO, Z(1:IZ1, 1: IZ2), INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      IJOBZ = 'V'
      CASE(:-1,6:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF (LSAME(IJOBZ, 'V')) THEN
        CALL LA_SBGVD( AB(1:IAB1, 1: IAB2), BB(1:IBB1, 1:IBB2), W(1 :IW), &
     &    IUPLO, Z(1:IZ1, 1: IZ2), INFO )
      ELSE
        CALL LA_SBGVD( AB(1:IAB1, 1: IAB2), BB(1:IBB1, 1:IBB2), W(1 :IW), &
     &    IUPLO, INFO = INFO )
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      END SUBROUTINE LA_TEST_SSBGVD

SUBROUTINE SGEEV_F95( A, WR, WI, VL, VR, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: GEEV_F77 => LA_GEEV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:)
   REAL(WP), INTENT(OUT) :: WR(:), WI(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!        LA_GEEV computes for a real or complex square matrix A, the 
! eigenvalues and, optionally, the left and/or right eigenvectors. A 
! right eigenvector v(j) of A satisfies
!                   A * v(j) = lambda(j) * v(j)
! where lambda(j) is its eigenvalue. A left eigenvector u(j) of A 
! satisffies
!                   u(j)^H * A = lambda(j) * u(j)^H
! where u(j)^H denotes the conjugate-transpose of u(j).
! 
! =========
! 
!       SUBROUTINE LA_GEEV( A, <w>, VL=vl, VR=vr, INFO=info )
!            <type>(<wp>), INTENT(INOUT) :: A(:,:)
!            <type>(<wp>), INTENT(OUT) :: <w(:)>
!            <type>(<wp>), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
!            INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!            <type> ::= REAL | COMPLEX
!            <wp>   ::= KIND(1.0) | KIND(1.0D0)
!            <w>    ::= WR, WI | W
!            <w(:)> ::= WR(:), WI(:) | W(:)
! 
! Arguments
! =========
! 
! A        (input/output) REAL or COMPLEX square array, shape (:,:).
!          On entry, the matrix A.
!          On exit, the contents of A are destroyed.
! <w>      (output) REAL or COMPLEX array, shape (:) with size(w) = 
!          size(A,1).
!          The computed eigenvalues.
!          <w(:)> ::= WR(:), WI(:) | W(:),
!          where
!          WR(:), WI(:) are of REAL type (for the real and imaginary
!          parts) and W(:) is of COMPLEX type.
!          Note: If A is real, then a complex-conjugate pair appear 
!          consecutively, with the eigenvalue having the positive 
!          imaginary part appearing first.
! VL       Optional (output) REAL or COMPLEX square array, shape (:,:)
!          with size(VL,1) = size(A,1).
!          The left eigenvectors u(j) are stored in the columns of VL in
!          the order of their eigenvalues. Each eigenvector is scaled so
!          that the Euclidean norm is 1 and the largest component is real.
!          Note: If A is real then complex eigenvectors, like their 
!          eigenvalues, occur in complex conjugate pairs. The real and 
!          imaginary parts of the first eigenvector of the pair are
!          stored in VL(:,j) and VL(:,j+1). Thus a complex conjugate pair
!          is given by 
!            u(j) = VL(:,j) + i*VL(:,j+1), u(j+1) = VL(:,j) - i*VL(:,j+1)
! VR       Optional (output) REAL or COMPLEX square array, shape (:,:) 
!          with size(VR,1) = size(A,1).
!          The right eigenvectors v(j) are stored in the columns of VR in
!          the order of their eigenvalues.
!          Each eigenvector is scaled so that the Euclidean norm is 1 and 
!          the largest component is real.
!          Note: If A is real then complex eigenvectors, like their 
!          eigenvalues, occur in complex conjugate pairs. The real and 
!          imaginary parts of the first eigenvector of the pair are stored
!          in VR(:,j) and VR(:,j+1). Thus a complex conjugate pair is 
!          given by 
! 	     v(j) = VR(:,j) + i*VR(:,j+1), v(j+1) = VR(:,j) - i*VR(:,j+1)
! INFO     Optional (output) INTEGER.
!          = 0: successful exit.
!          < 0: if INFO = -i, the i-th argument had an illegal value.
!          > 0: if INFO = i, the QR algorithm failed to compute all the 
!          eigenvalues and no eigenvectors were computed. Elements 
! 	   i+1 : n of <w> contain eigenvalues which have converged.
!          n is the order of A
!          If INFO is not present and an error occurs, then the program
!          is terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GEEV'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBVL, LJOBVR
   INTEGER, SAVE :: LWORK = 0
   INTEGER :: N, NN, LINFO, LD, ISTAT, ISTAT1, S1VL, S2VL, S1VR, S2VR
!  .. LOCAL ARRAYS ..
   REAL(WP), TARGET :: LLVL(1,1), LLVR(1,1)
   REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(A,1); LD = MAX(1,N)
   IF( PRESENT(VL) )THEN; S1VL = SIZE(VL,1); S2VL = SIZE(VL,2); LJOBVL = 'V'
   ELSE; S1VL = 1; S2VL = 1; LJOBVL = 'N'; END IF
   IF( PRESENT(VR) )THEN; S1VR = SIZE(VR,1); S2VR = SIZE(VR,2); LJOBVR = 'V'
   ELSE; S1VR = 1; S2VR = 1; LJOBVR = 'N'; END IF
!  .. TEST THE ARGUMENTS
   IF( N < 0 .OR. SIZE(A,2) /= N )THEN; LINFO = -1
   ELSE IF( SIZE( WR ) /= N )THEN; LINFO = -2
   ELSE IF( SIZE( WI ) /= N )THEN; LINFO = -3
   ELSE IF( PRESENT(VL) .AND. ( S1VL /= N .OR. S2VL /= N ) )THEN; LINFO = -4
   ELSE IF( PRESENT(VR) .AND. ( S1VR /= N .OR. S2VR /= N ) )THEN; LINFO = -5
   ELSE IF( N > 0 )THEN
      NN = 3; IF( LSAME(LJOBVL,'V').OR.LSAME(LJOBVR,'V') ) NN = NN + 1
      LWORK = MAX( 1, NN*N, LWORK); ALLOCATE(WORK(LWORK), STAT=ISTAT)
         IF( ISTAT /= 0 )THEN; DEALLOCATE(WORK,STAT=ISTAT1)
            LWORK = MAX( 1, NN*N ); ALLOCATE(WORK(LWORK), STAT=ISTAT)
            IF( ISTAT == 0) CALL ERINFO( -200, SRNAME, LINFO )
         END IF
      IF( ISTAT == 0 ) THEN
        IF( PRESENT(VL) )THEN
           IF( PRESENT(VR) )THEN
               CALL GEEV_F77( LJOBVL, LJOBVR, N, A, LD, WR, WI, &
                        VL, S1VL, VR, S1VR, WORK, LWORK, LINFO )
	   ELSE
	      CALL GEEV_F77( LJOBVL, LJOBVR, N, A, LD, WR, WI, &
                        VL, S1VL, LLVR, S1VR, WORK, LWORK, LINFO )
	   ENDIF
	 ELSE
	   IF( PRESENT(VR) )THEN
	       CALL GEEV_F77( LJOBVL, LJOBVR, N, A, LD, WR, WI, &
                        LLVL, S1VL, VR, S1VR, WORK, LWORK, LINFO )
	   ELSE
	       CALL GEEV_F77( LJOBVL, LJOBVR, N, A, LD, WR, WI, &
                        LLVL, S1VL, LLVR, S1VR, WORK, LWORK, LINFO )
	   ENDIF
	 ENDIF  
         IF( LINFO == 0 ) LWORK = INT(WORK(1)+1)
      ELSE; LINFO = -100; ENDIF
      DEALLOCATE(WORK, STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE SGEEV_F95

      PROGRAM LA_CGEEV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GEEV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N
      REAL(WP), ALLOCATABLE ::  WR(:), WI(:)
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:)
      COMPLEX(WP), ALLOCATABLE :: AA(:,:), W(:), VL(:,:), VR(:,:)
!  .. "Intrinsic Functions" ..
      INTRINSIC  REAL, AIMAG, INT
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GEEV Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), W(N), WR(N), WI(N), VL(N,N), VR(N,N) )

      OPEN(UNIT=21,FILE='geev1.ma',STATUS='UNKNOWN')
      DO I=1,N
         DO J=1,N
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix A:'
      DO I=1,N
         WRITE(*,"(5(I3,1X))") INT(A(I,:))
      ENDDO

      WRITE(*,*) "CALL LA_GEEV( A, WR, WI ) "
      CALL LA_GEEV( A, WR, WI )
     
      WRITE(*,*) 'WR on exit : '
      DO I=1,N
         WRITE(*,"((F9.6,1X))") REAL(WR(I))
      ENDDO
   
      WRITE(*,*) 'WI on exit : '
      DO I=1,N
         WRITE(*,"((F9.5,1X))") REAL(WI(I))
      ENDDO
   
      WRITE(*,*)
      WRITE(*,*) ' * EXAMPLE 2 * '

      OPEN(UNIT=21,FILE='geev.ma',STATUS='UNKNOWN')
      DO I=1,N
         DO J=1,N
            READ(21,*) AA(I,J)
         ENDDO
      ENDDO
      CLOSE(21)
  
      WRITE(*,*)'Matrix A : '
      DO J=1,N      
         WRITE(*,"(5(I3,1X,'+',I3,'i',1X,1X,1X))") INT(AA(J,1)),INT(AIMAG(AA(J,1))), &
              INT(AA(J,2)),INT(AIMAG(AA(J,2))), &  
              INT(AA(J,3)),INT(AIMAG(AA(J,3))), & 
              INT(AA(J,4)),INT(AIMAG(AA(J,4))), & 
              INT(AA(J,5)),INT(AIMAG(AA(J,5))) 
      ENDDO

      WRITE(*,*) "CALL LA_GEEV( A, W, VL, VR, INFO )"
      CALL LA_GEEV( AA, W, VL, VR, INFO )
      
      WRITE(*,*) ' W on exit : '
      DO I=1,N;
         WRITE(*,"('('E14.7,1X,',',1X,E14.7,')',1X)")  W(I) 
      ENDDO
 
      WRITE(*,*)' VL on exit : '
      DO I=1,N;
         WRITE(*,"(5('('E14.7,1X,',',1X,E14.7,')',1X))")  VL(I,:)
      ENDDO;
      
      WRITE(*,*) ' VR on exit : '
      DO I=1,N;
         WRITE(*,"(5('('E14.7,1X,',',1X,E14.7,')',1X))")  VR(I,:)
      ENDDO;

      WRITE(*,*) ' INFO = ', INFO
      DEALLOCATE( A, AA, VL, VR )

      END PROGRAM LA_CGEEV_EXAMPLE

SUBROUTINE LA_TEST_DSYEVR( JOBZ, RANGE, UPLO, N, A, LDA, VL, VU, IL, &
     &  IU, ABSTOL, M, W, Z, LDZ, ISUPPZ, WORK, LWORK, IWORK, LIWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     September 11, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_SYEVR
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDA, LDZ, IL, IU, LWORK, LIWORK
   REAL(WP), INTENT(IN) ::  ABSTOL, VL, VU
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: UPLO, JOBZ, RANGE
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N)
   REAL(WP), INTENT(OUT)::  W(1:N), WORK(1:LWORK), Z(1:LDZ, 1:MAX(1,N))
   INTEGER, INTENT(OUT) :: IWORK(LIWORK)
   INTEGER, INTENT(OUT) :: ISUPPZ(2*MAX(1,N)), M
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SYEVR'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DSYEVR'
   LOGICAL LSAME
   EXTERNAL LSAME
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IW, IIL, IIU, IZ1, IZ2
   REAL(WP) :: IVU, IVL
   CHARACTER*1 :: IUPLO, IJOBZ   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IUPLO = UPLO; IW = N; IJOBZ = JOBZ
   IVU=VU; IVL = VL;IIL=IL; IIU = IU; IZ1 = max(1,N); IZ2 = N
   I = INFO / 100; J = INFO - I*100

   SELECT CASE(I)
     CASE (1)
       IA2 = IA1 - 1
     CASE (2)
       IW = IA1 - 1
     CASE (3)
       IJOBZ='T'
       CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, & 
&        M=M, ISUPPZ=ISUPPZ, ABSTOL=ABSTOL, INFO=INFO )
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN
     CASE (4)
       IUPLO = 'T'   
     CASE (5)
       IVU = IVL - 1
       CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
     &  VL=IVL, VU=IVU, M=M, ABSTOL=ABSTOL, INFO=INFO )
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN
     CASE (6)
       CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
     &   IVL, IVU, IIL, IIU, M, ISUPPZ, ABSTOL, INFO )
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN
     CASE (7)
       IIU = IIL - 1
       CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), IJOBZ,  IUPLO, &
     &  IL=IIL, IU=IIU, M=M, ABSTOL=ABSTOL, INFO=INFO )
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN
     CASE (8)
       IIU = IA1 + 1
       CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
     &  IL=IIL, IU=IIU, M=M, ABSTOL=ABSTOL, INFO=INFO )
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN
     CASE(10)
       IJOBZ='N'
       CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
&        M=M, ISUPPZ=ISUPPZ, ABSTOL=ABSTOL, INFO=INFO )
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN
     CASE(:-1,9,11:)
       CALL UESTOP(SRNAMT)
   END SELECT

   IF (LSAME(RANGE,'A')) THEN
     IF (LSAME(JOBZ, 'V')) THEN
       CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
     &    M=M, ISUPPZ=ISUPPZ, ABSTOL=ABSTOL, INFO=INFO )
      ELSE
       CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), UPLO=IUPLO, &
     &   M=M, ABSTOL=ABSTOL, INFO=INFO )
     END IF
   ELSE
     IF (LSAME(RANGE, 'V')) THEN
       IF (LSAME(JOBZ, 'V')) THEN
         CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
     &     IVL, IVU,  M=M, ISUPPZ=ISUPPZ, ABSTOL=ABSTOL, INFO=INFO )
       ELSE
         CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), UPLO=IUPLO,  &
     &     VL=IVL, VU=IVU,  M=M, ABSTOL=ABSTOL, INFO=INFO )
       END IF
     ELSE
       IF (LSAME(JOBZ, 'V')) THEN
         CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), IJOBZ, IUPLO, &
     &     IL=IIL, IU=IIU, M=M, ISUPPZ=ISUPPZ, ABSTOL=ABSTOL, INFO=INFO )
       ELSE
         CALL LA_SYEVR( A(1:IA1,1:IA2), W(1 :IW), UPLO=IUPLO, &
     &     IL=IIL, IU=IIU, M=M, ABSTOL=ABSTOL, INFO=INFO )
       ENDIF
     END IF
   ENDIF
   IF (N/=0) Z(1:IA1, 1:M) = A(1:IA1, 1:M)
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_DSYEVR

PROGRAM LA_LAMCH_EXAMPLE
!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     August, 2000
! .. "Use Statements" ..
     USE LA_PRECISION, ONLY: SP, DP
     USE F95_LAPACK, ONLY: LA_LAMCH
! .. "Implicit Statement" ..
     IMPLICIT NONE
! .. "Parameters" ..
     CHARACTER( LEN=10 ), PARAMETER :: CHU='ESBPNRMULO', &
                                       CHL='esbpnrmulo' 
     CHARACTER( LEN=5 ), PARAMETER :: CNAME(10) = (/'eps  ', &
        'sfmin', 'base ', 'prec ', 't    ', 'rnd  ', 'emin ', &
        'rmin ', 'emax ', 'rmax '/)
! .. "Local Scalars" ..
     INTEGER :: I, INFO
     REAL(SP) :: SR
     REAL(DP) :: DR
! .. "Executable Statements" ..
     WRITE (*,*) 'LA_LAMCH Example Program Results.'
     WRITE(*,*)'Machine constants, sengle and double precision:'
     DO I=1, 10
       SR = LA_LAMCH( 1.0_SP, CHU(I:I) )
       DR = LA_LAMCH( 1.0_DP, CHL(I:I) )
       WRITE(*,*) CNAME(I), SR, '          ', DR
     ENDDO
     PRINT *, CNAME(10), LA_LAMCH( 1.0_SP, 'E', INFO), '  INFO = ', INFO
     PRINT *, CNAME(10), LA_LAMCH( 1.0_DP, 'E', INFO), '  INFO = ', INFO
     PRINT *, CNAME(10), LA_LAMCH( 1.0_DP, '1', INFO), '  INFO = ', INFO
     SR = LA_LAMCH( 1.0_SP, '1')
     PRINT *, CNAME(10), SR
END PROGRAM LA_LAMCH_EXAMPLE

PROGRAM LA_SGEGS_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GEGS
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, INFO, N
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:)
   REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), VSL(:,:), VSR(:,:), &
                ALPHAR(:), ALPHAI(:), BETA(:), DUMMY(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'SGEGS ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N
   PRINT *, 'N = ', N
   ALLOCATE ( A(N,N), AA(N,N), ALPHAR(N), ALPHAI(N), BETA(N), &
              VSL(N,N), VSR(N,N), B(N,N), BB(N,N) )
!
   READ (NIN, *) AA, BB
   A=AA; B=BB
   WRITE(NOUT,*) 'The matrix A:'
   DO I = 1, N; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,:); ENDDO
   WRITE(NOUT,*) 'The matrix B:'
   DO I = 1, N; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) B(I,:); ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_SGEGS LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEGS( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR, INFO )'
   A=AA
   CALL LA_GEGS( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   WRITE(NOUT,*) ' Alphar:'
   WRITE(NOUT,FMT) ALPHAR
   WRITE(NOUT,*) ' Alphai:'
   WRITE(NOUT,FMT) ALPHAI
   WRITE(NOUT,*) ' Beta:'
   WRITE(NOUT,FMT) BETA
   WRITE(NOUT,*) 'VSL:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VSL(:,I); END DO
   WRITE(NOUT,*) 'VSR:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VSR(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEGS( A, B, INFO=INFO )'
   A=AA
   CALL LA_GEGS( A, B, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   WRITE(NOUT,*) 'A:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(:,I); END DO
   WRITE(NOUT,*) 'B:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) B(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEGS( DUMMY, B, INFO=INFO )'
   A=AA
   CALL LA_GEGS( DUMMY, B, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEGS( A, DUMMY, INFO=INFO )'
   A=AA
   CALL LA_GEGS( A, DUMMY, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEGS( A, B, ALPHAR(1:N-1), INFO=INFO )'
   A=AA
   CALL LA_GEGS( A, B, ALPHAR(1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEGS( A, B, ALPHAI=ALPHAI(1:N-1), INFO=INFO )'
   A=AA
   CALL LA_GEGS( A, B, ALPHAI=ALPHAI(1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEGS( A, B, BETA=ALPHAI(1:N-1), INFO=INFO )'
   A=AA
   CALL LA_GEGS( A, B, BETA=ALPHAI(1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEGS( A, B, VSL=VSL(:,1:N-1), INFO=INFO )'
   A=AA
   CALL LA_GEGS( A, B, VSL=VSL(:,1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEGS( A, B, VSL=VSL(1:N-1,:), INFO=INFO )'
   A=AA
   CALL LA_GEGS( A, B, VSL=VSL(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEGS( A, B, VSR=VSR(1:N-1,:), INFO=INFO )'
   A=AA
   CALL LA_GEGS( A, B, VSR=VSR(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GEGS( A, B, VSR=VSR(:,1:N-1), INFO=INFO )'
   A=AA
   CALL LA_GEGS( A, B, VSR=VSR(:,1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
END PROGRAM LA_SGEGS_ET_EXAMPLE

 SUBROUTINE SGELSX1_F95( A, B, RANK, JPVT, RCOND, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => SP
    USE LA_AUXMOD, ONLY: ERINFO
    USE F77_LAPACK, ONLY: GELSX_F77 => LA_GELSX
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL :: RANK
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
    REAL(WP), INTENT(IN), OPTIONAL :: RCOND
!   .. ARRAY ARGUMENTS ..
    INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: JPVT(:)
    REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
!   .. PARAMETERS ..
    CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GELSX'
!   .. LOCAL SCALARS ..
    INTEGER :: LINFO, ISTAT, ISTAT1, LWORK, N, M, MN, LRANK, SJPVT
    REAL(WP) :: LRCOND
!   .. LOCAL POINTERS ..
    INTEGER, POINTER :: LJPVT(:)
    REAL(WP), POINTER :: WORK(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT, MAX, MIN, EPSILON
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2)
    MN = MIN(M,N)
    IF( PRESENT(RCOND) )THEN; LRCOND = RCOND; ELSE
        LRCOND = 100*EPSILON(1.0_WP) ; ENDIF
    IF( PRESENT(JPVT) )THEN; SJPVT = SIZE(JPVT); ELSE; SJPVT = N; ENDIF
!   .. TEST THE ARGUMENTS
    IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B, 1 ) /= MAX(1,M,N) ) THEN; LINFO = -2
    ELSE IF( SJPVT /= N ) THEN; LINFO = -4
    ELSE IF( LRCOND <= 0.0_WP ) THEN; LINFO = -5
    ELSE
       IF( PRESENT(JPVT) )THEN; LJPVT => JPVT
       ELSE; ALLOCATE( LJPVT(N), STAT = ISTAT ); LJPVT = 0; END IF
       IF( ISTAT == 0 ) THEN
          LWORK = MAX( 1, MIN(M,N) + 3*N, 2*MIN(M,N) + 1 )
          ALLOCATE( WORK(LWORK), STAT = ISTAT )
          IF( ISTAT /= 0 ) CALL ERINFO( -200, SRNAME, LINFO )
       END IF
       IF ( ISTAT == 0 ) THEN
          CALL GELSX_F77( M, N, 1, A, MAX(1,M), B, MAX(1,M,N), &
                         LJPVT, LRCOND, LRANK, WORK, LINFO )
       ELSE; LINFO = -100; END IF
       IF( PRESENT(RANK) ) RANK = LRANK
       IF( PRESENT(JPVT) ) JPVT = LJPVT
       DEALLOCATE(WORK, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE SGELSX1_F95

PROGRAM EXAMPLE 
  USE LA_PRECISION, ONLY: WP => DP
  USE f77_LAPACK, ONLY: F77GESV => LA_GESV
  USE F95_LAPACK, ONLY: f95GESV => LA_GESV

  USE f77_LAPACK, ONLY: F77GEEV => LA_GEEV
  USE F95_LAPACK, ONLY: F95GEEV => LA_GEEV

  USE f77_LAPACK, ONLY: F77GESDD => LA_GESDD
  USE F95_LAPACK, ONLY: F95GESDD => LA_GESDD

  USE f77_LAPACK, ONLY: F77GESVD => LA_GESVD
  USE F95_LAPACK, ONLY: F95GESVD => LA_GESVD

  IMPLICIT NONE 

  INTEGER :: INFO, J, LDA, LDB, N, NRHS, LWORK, S, I
  INTEGER, ALLOCATABLE :: IPIV(:)
  INTEGER, ALLOCATABLE :: IWORK(:)
  REAL :: T0, T1, T2
  REAL(WP) ::  CPU_MFLP, RTC_MFLP, FLP
  DOUBLE PRECISION RTC, BEFORE, AFTER, RTC_TIME, CPU1_TIME
  REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), AA(:,:), BB(:,:)
  REAL(WP), ALLOCATABLE :: WR(:), WI(:), VL(:,:), VR(:,:)
  REAL(WP), ALLOCATABLE :: WORK(:)
  
  print *, 'N = '
  read (*,*) N
  
  NRHS = 1; S=10
  print * ,'====================================================='
  print * ,'        LAPACK95 TIMING routine, Double Real Version '
  print * ,'====================================================='
  print *,' N , NRHS =  ', N, NRHS
  ALLOCATE( A(N,N), B(N,NRHS), IPIV(N), AA(N,N), BB(N,NRHS) )
  ALLOCATE(WR(N), WI(N), VL(N,N), VR(N,N))
  ALLOCATE(IWORK(10*N))
  
  CALL RANDOM_NUMBER(A)
  DO J = 1, NRHS
    B(:,J) = SUM( A, DIM=2 )*J
  ENDDO
  AA = A; BB = B
  LDA = N; LDB = N 
! DGESV
  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  do i =1, s
    before = rtc()
    CALL CPU_TIME(T0); CALL CPU_TIME(T1); T0 = T1-T0
    CALL F77GESV( N, NRHS, A, LDA, IPIV, B, LDB, INFO )
    CALL CPU_TIME(T2)
    CPU1_TIME = CPU1_TIME+ (T2-T1-T0)
    after = rtc()
    RTC_TIME = RTC_TIME + (after - before)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
  enddo
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  Flp = 0.67*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L77GESV ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L77GESV ', RTC_TIME, RTC_MFLP
  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  do i =1, s
    A = AA; B = BB
    CALL CPU_TIME(T1);
    CALL F95GESV( A, B ); CALL CPU_TIME(T2)
    CPU1_TIME = CPU1_TIME + (T2-T1-T0)
    
    A = AA; B = BB
    before = rtc()
    CALL F95GESV( A, B ); CALL CPU_TIME(T2)
    after = rtc()
    RTC_TIME = RTC_TIME + (after - before)
  enddo
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  
  FLP = 0.67*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L95GESV ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L95GESV ', RTC_TIME, RTC_MFLP
  
! DGEEV, eigenvalues only
  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  PRINT *,' DGEEV, eigenvalues only'
  DO I=1,S
    A = AA; LWORK = 5*N
    ALLOCATE(WORK(LWORK))
    CALL CPU_TIME(T1);
    CALL F77GEEV( 'N', 'N', N, A, LDA, WR, WI, VL, LDA, VR, &
&     LDA, WORK, LWORK, INFO )
    CALL CPU_TIME(T2)
    CPU1_TIME = CPU1_TIME + (T2-T1-T0)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    A = AA; LWORK = 5*N
    BEFORE = RTC()
    CALL F77GEEV( 'N', 'N', N, A, LDA, WR, WI, VL, LDA, VR, &
&     LDA, WORK, LWORK, INFO )
    AFTER = RTC()
    RTC_TIME = RTC_TIME + (AFTER - BEFORE)
    DEALLOCATE(WORK)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
  ENDDO
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 10.00*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L77GEEV ',  CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L77GEEV ',  RTC_TIME, RTC_MFLP
  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  DO I=1,S
    A = AA
    CALL CPU_TIME(T1);
    CALL F95GEEV(A, WR, WI, INFO = INFO)
    CALL CPU_TIME(T2)
    CPU1_TIME = CPU1_TIME + (T2-T1-T0)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    A = AA
    BEFORE = RTC()
    CALL F95GEEV(A, WR, WI, INFO = INFO)
    AFTER = RTC()
    RTC_TIME = RTC_TIME + (AFTER - BEFORE)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
  ENDDO
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 10.00*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L95GEEV ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L95GEEV ', RTC_TIME, RTC_MFLP
! DGEEV, eigenvalues and right eigenvectors
  print *,' DGEEV, eigenvalues and right eigenvectors'
  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  do i=1,s
    A = AA; LWORK = 5*N
    ALLOCATE(WORK(LWORK))
    CALL CPU_TIME(T1);
    CALL F77GEEV( 'N', 'V', N, A, LDA, WR, WI, VL, LDA, VR, &
&     LDA, WORK, LWORK, INFO )
    CALL CPU_TIME(T2)
    DEALLOCATE(WORK)
    CPU1_TIME = CPU1_TIME + (T2-T1-T0)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    A = AA; LWORK = 5*N
    ALLOCATE(WORK(LWORK))
    BEFORE = RTC()
    CALL F77GEEV( 'N', 'V', N, A, LDA, WR, WI, VL, LDA, VR, &
&     LDA, WORK, LWORK, INFO )
    AFTER =  RTC()
    DEALLOCATE(WORK)
    RTC_TIME = RTC_TIME + (AFTER - BEFORE)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
  enddo
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 26.33*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L77GEEV(2) ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L77GEEV(2) ', RTC_TIME, RTC_MFLP
  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  DO I=1,S
    A= AA
    CALL CPU_TIME(T1);
    CALL F95GEEV(A, WR, WI, VL, INFO = INFO)
    CALL CPU_TIME(T2)
    CPU1_TIME = CPU1_TIME + (T2-T1-T0)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    A= AA
    BEFORE = rtc()
    CALL F95GEEV(A, WR, WI, VL, INFO = INFO)
    AFTER = RTC()
    RTC_TIME = RTC_TIME + (AFTER - BEFORE)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
  ENDDO
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 26.33*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L95GEEV(2) ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L95GEEV(2) ', RTC_TIME, RTC_MFLP
! DGESDD, singular values only
   print *, ' DGESDD, singular values only'
   CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
   do i = 1, s
     A = AA;  LWORK =10*N*N + 20*N
     ALLOCATE(WORK(LWORK))
     CALL CPU_TIME(T1)
     CALL F77GESDD( 'N', N, N, A, LDA, WR, VL, LDA, VR, LDA, WORK, &
&      LWORK, IWORK, INFO )
     CALL CPU_TIME(T2)
     DEALLOCATE(WORK)
     CPU1_TIME = CPU1_TIME + ( T2-T1-T0 )
     IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
     A = AA;  LWORK =10*N*N + 20*N
     ALLOCATE(WORK(LWORK))
     BEFORE = RTC()
     CALL F77GESDD( 'N', N, N, A, LDA, WR, VL, LDA, VR, LDA, WORK, &
&      LWORK, IWORK, INFO )
     AFTER = RTC()
     DEALLOCATE(WORK)
     RTC_TIME=RTC_TIME + (AFTER - BEFORE)
     IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
   enddo
   CPU1_TIME = CPU1_TIME/S
   RTC_TIME = RTC_TIME/S
   FLP = 2.67*(DBLE(N)*(N*DBLE(N)))
   IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
   ENDIF
   IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
   ENDIF
   WRITE(*,*) 'CPUTIME and MFLOPS of L77GESDD ', CPU1_TIME, CPU_MFLP
   WRITE(*,*) 'RTCTIME and MFLOPS of L77GESDD ', RTC_TIME, RTC_MFLP
   CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
   do i=1,s
     A = AA
     CALL CPU_TIME(T1)
     CALL F95GESDD( A, WR, JOB='N', INFO=INFO)
     CALL CPU_TIME(T2)
     CPU1_TIME = CPU1_TIME + ( T2-T1-T0 )
     IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
     A = AA
     BEFORE = RTC()
     CALL F95GESDD( A, WR, JOB='N', INFO=INFO)
     AFTER = RTC()
     RTC_TIME=RTC_TIME + (AFTER - BEFORE)
     IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
   enddo
   CPU1_TIME = CPU1_TIME/S
   RTC_TIME = RTC_TIME/S
   FLP = 2.67*(DBLE(N)*(N*DBLE(N)))
   IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
   ENDIF
   IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
   ENDIF
   WRITE(*,*) 'CPUTIME and MFLOPS of L95GESDD ', CPU1_TIME, CPU_MFLP
   WRITE(*,*) 'RTCTIME and MFLOPS of L95GESDD ', RTC_TIME, RTC_MFLP
! DGESDD, singular values & left and right singular vectors
   print *,' DGESDD, singular values & left and right singular vectors'
   CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  do i = 1, s
    A = AA;  LWORK =10*N*N + 20*N
    ALLOCATE(WORK(LWORK))
    CALL CPU_TIME(T1)
    CALL F77GESDD( 'S', N, N, A, LDA, WR, VL, LDA, VR, LDA, WORK, &
&     LWORK, IWORK, INFO )
    CALL CPU_TIME(T2)
    DEALLOCATE(WORK)
    CPU1_TIME = CPU1_TIME + ( T2-T1-T0 )
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    A = AA;  LWORK =10*N*N + 20*N
    ALLOCATE(WORK(LWORK))
    BEFORE = RTC()
    CALL F77GESDD( 'S', N, N, A, LDA, WR, VL, LDA, VR, LDA, WORK, &
&     LWORK, IWORK, INFO )
    AFTER = RTC()
    DEALLOCATE(WORK)
    RTC_TIME=RTC_TIME + (AFTER - BEFORE)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
  enddo
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 6.67*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L77GESDD(2) ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L77GESDD(2) ', RTC_TIME, RTC_MFLP
  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  do i=1,s
    A = AA
    CALL CPU_TIME(T1)
    CALL F95GESDD( A, WR, VL, VR, JOB='N', INFO=INFO)
    CALL CPU_TIME(T2)
    CPU1_TIME = CPU1_TIME + ( T2-T1-T0 )
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    A = AA
    BEFORE = RTC()
    CALL F95GESDD( A, WR, VL, VR, JOB='N', INFO=INFO)
    AFTER = RTC()
    RTC_TIME=RTC_TIME + (AFTER - BEFORE)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
  enddo
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 6.67*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L95GESDD(2) ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L95GESDD(2) ', RTC_TIME, RTC_MFLP
! DGESVD, singular values & left and right singular vectors
  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  print *,' DGESVD, singular values & left and right singular vectors'
  do i=1,s
    A = AA; LWORK = 3*N*N+1
    ALLOCATE(WORK(LWORK))
    CALL CPU_TIME(T1)
    CALL F77GESVD( 'A', 'A', N, N, A, LDA, WI, VL, LDA, VR, LDA, &
&     WORK, LWORK, INFO )
    CALL CPU_TIME(T2)
    DEALLOCATE(WORK)
    CPU1_TIME = CPU1_TIME + (T2-T1-T0)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    A = AA; LWORK = 3*N*N+1
    ALLOCATE(WORK(LWORK))
    BEFORE = RTC()
    CALL F77GESVD( 'A', 'A', N, N, A, LDA, WI, VL, LDA, VR, LDA, &
&     WORK, LWORK, INFO )
    AFTER = RTC()
    DEALLOCATE(WORK)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    RTC_TIME=RTC_TIME + (AFTER - BEFORE)
  enddo
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 6.67*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L77GESVD ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L77GESVD ', RTC_TIME, RTC_MFLP
  CPU1_TIME = 0; RTC_TIME = 0; CPU_MFLP = 0; RTC_MFLP = 0;
  do i = 1, s
    A = AA
    CALL CPU_TIME(T1)
    CALL F95GESVD( A, WI, VL, VR, JOB='N', INFO=INFO)
    CALL CPU_TIME(T2)
    CPU1_TIME = CPU1_TIME + (T2-T1-T0)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
    A = AA
    BEFORE = RTC()
    CALL F95GESVD( A, WI, VL, VR, JOB='N', INFO=INFO)
    AFTER = RTC()
    RTC_TIME=RTC_TIME + (AFTER - BEFORE)
    IF (INFO .NE. 0) THEN
      PRINT *,'INFO = ', INFO
      EXIT
    ENDIF
  enddo
  CPU1_TIME = CPU1_TIME/S
  RTC_TIME = RTC_TIME/S
  FLP = 6.67*(DBLE(N)*(N*DBLE(N)))
  IF (CPU1_TIME .NE.0)THEN; CPU_MFLP = (FLP /CPU1_TIME)/1E6; ELSE; CPU_MFLP = 0
  ENDIF
  IF (RTC_TIME .NE.0)THEN; RTC_MFLP = (FLP /RTC_TIME)/1E6; ELSE; RTC_MFLP = 0
  ENDIF
  WRITE(*,*) 'CPUTIME and MFLOPS of L95GESVD ', CPU1_TIME, CPU_MFLP
  WRITE(*,*) 'RTCTIME and MFLOPS of L95GESVD ', RTC_TIME, RTC_MFLP
  
  DEALLOCATE( A, B, IPIV, AA, BB )
  DEALLOCATE( WR, WI, VL, VR )
  DEALLOCATE( IWORK )
  
END PROGRAM EXAMPLE
  

SUBROUTINE LA_TEST_SGEES( JOBVS, SORT, SELECT, N, A, LDA, SDIM, WR, WI, VS, LDVS, WORK, LWORK, BWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     May 21, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GEES
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDA, LDVS, LWORK
   INTEGER, INTENT(OUT) :: SDIM
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBVS, SORT
!   LOGICAL SELECT
   INTERFACE
      LOGICAL FUNCTION SELECT(WR, WI)
      USE LA_PRECISION, ONLY: WP => SP
      REAL(WP), INTENT(IN) :: WR, WI
  END FUNCTION SELECT
 END INTERFACE
   
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N)
   REAL(WP), INTENT(OUT) :: WR(1: N), WI(1: N), VS(1: LDVS, 1: N), &
     &  WORK (1: LWORK)
   LOGICAL :: BWORK(1: N)
   LOGICAL LSAME
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GEES '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGEES '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IWI, IWR, IVS1, IVS2
   CHARACTER*1 :: IJOBVS
!  .. Local Arrays ..
   INTEGER, SAVE, POINTER :: IWORK(:)
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IWI = N; IWR = N;
   IVS1 = N; IVS2 = N; IJOBVS = JOBVS
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
       IA2 = IA2-1
     CASE (2)
       IWR = IWR-1
     CASE(3)
       IWI = IWI - 1
     CASE (4)
       IVS1 = IVS1 - 1
       IJOBVS = 'V'
     CASE (5)
       CALL LA_GEES( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &   VS(1: IVS1, 1: IVS2), SDIM=SDIM, INFO=INFO)
       RETURN
     CASE(:-1,6:)
       CALL UESTOP(SRNAMT)
   END SELECT 
   IF (LSAME (IJOBVS,'V')) THEN
     IF (LSAME(SORT, 'S')) THEN 
       CALL LA_GEES( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &   VS(1: IVS1, 1: IVS2), SELECT, SDIM, INFO)
     ELSE 
       CALL LA_GEES( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &   VS(1: IVS1, 1: IVS2), INFO=INFO)
     END IF
   ELSE
     IF (LSAME(SORT, 'S')) THEN 
       CALL LA_GEES( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &   SELECT=SELECT, SDIM=SDIM, INFO=INFO)
     ELSE
       CALL LA_GEES( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &   INFO=INFO)
     END IF
   END IF
   
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_SGEES

PROGRAM LA_SSBGVX_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_SBGVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
   CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: UPLO
   INTEGER :: I, J, INFO, N, KA, KB, M, IL, IU
   REAL(WP) ::  VL, VU 
!  .. LOCAL ARRAYS ..
   INTEGER, ALLOCATABLE :: IFAIL(:) 
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:), W(:)
   REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), Z(:,:), DUMMY(:,:), Q(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'SSBGVX ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, KA, KB
   PRINT *, 'N = ', N, ' KA = ', KA, ' KB = ', KB
   ALLOCATE ( A(KA+1,N), AA(KA+1,N), B(KB+1,N), BB(KB+1,N), W(N), Z(N,N) )
   ALLOCATE (IFAIL(N), Q(N,N))
!
   VL = -10.0; VU=10.0; IL=1; IU=N; UPLO = 'U'
   AA = HUGE(1.0_WP); BB = HUGE(1.0_WP)
   DO I = 1, KA+1; READ (NIN, *) (AA(I, J), J = KA-I+2, N); ENDDO
   DO I = 1, KB+1; READ (NIN, *) (BB(I, J), J = KB-I+2, N); ENDDO
   A=AA; B=BB
   WRITE(NOUT,*) 'The matrix A:'
   DO I = 1, KA+1; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) AA(I,:); ENDDO
   WRITE(NOUT,*) 'The matrix B:'
   DO I = 1, KB+1; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) BB(I,:); ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_SSBGVX LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, ''U'', Z, INFO )'
   A=AA; B=BB
   CALL LA_SBGVX( A, B, W, UPLO, Z, INFO = INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
     UPLO = 'U'
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, ''U'', Z )'
   A=AA; B=BB
   CALL LA_SBGVX( A, B, W, UPLO, Z )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, Z=Z )'
   A=AA; B=BB
   CALL LA_SBGVX( A, B, W, Z=Z )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, ''L'', Z, INFO=INFO )'
   A=AA; B=BB; W = HUGE(1.0_WP); Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, Z, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
! STARTING THE ERROR TESTS: 
! ERROR 1
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( DUMMY, B, W, INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( DUMMY, B, W, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 2
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, DUMMY, W, INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, DUMMY, W, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 3
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W(1:N-1), INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W(1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 4
   UPLO = '9'
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, UPLO=''9'', INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 5
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, UPLO, Z(:, 1:N-1), INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, Z(:, 1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 5
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, UPLO, Z(1:N-1,:), INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, Z(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 6
   VL = 10.0; VU = -10.0
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, UPLO, Z, VL, VU, M, IFAIL, Q, INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, Z,  VL, VU, M=M, IFAIL=IFAIL, Q=Q, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 7
   IL = 1; IU = N; VL=-10.0; VU=10.0
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, UPLO, Z, VL, VU, IL, IU, M, IFAIL, Q, INFO=INFO )' 
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, Z, VL, VU, IL, IU, M, IFAIL, Q, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   IU=N; IL=1
! ERROR 8
   IL = -1; IU = N+1
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, UPLO, Z, IL=IL, IU=IU, M=M, IFAIL=IFAIL, Q=Q, INFO=INFO )' 
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, Z, IL=IL, IU=IU, M=M, IFAIL=IFAIL, Q=Q, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   IU=N; IL=1
! ERROR 9
   IU = N+1
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, UPLO, Z, IL=IL, IU=IU, M=M, IFAIL=IFAIL, Q=Q, INFO=INFO )' 
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, Z, IL=IL, IU=IU, M=M, IFAIL=IFAIL, Q=Q, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   IU=N
! ERROR 10
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W,  UPLO, Z, VL, VU, M=M, IFAIL=IFAIL(1:N-1), Q=Q, INFO=INFO )' 
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, Z, VL, VU, M=M, IFAIL=IFAIL(1:N-1), Q=Q, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 10
   UPLO= 'L'
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W,  UPLO, VL=VL, VU=VU, M=M, IFAIL=IFAIL, Q=Q, INFO=INFO )' 
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, VL=VL, VU=VU, M=M, IFAIL=IFAIL, Q=Q, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 11
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, UPLO, Z, VL, VU, M=M, IFAIL=IFAIL, Q=Q(1:N-1,:), INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, Z,  VL, VU, M=M, IFAIL=IFAIL, Q=Q(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO 
! ERROR 11
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, UPLO, Z, VL, VU, M=M, IFAIL=IFAIL, Q=Q(:,1:N-1), INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, Z,  VL, VU, M=M, IFAIL=IFAIL, Q=Q(:,1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 11
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SBGVX( A, B, W, UPLO, VL=VL, VU=VU, M=M, IFAIL=IFAIL, Q=Q, INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_SBGVX( A, B, W, UPLO, VL=VL, VU=VU, M=M, IFAIL=IFAIL, Q=Q, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO   
!
END PROGRAM LA_SSBGVX_ET_EXAMPLE

PROGRAM LA_ZHPSV_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_HPSV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
   CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, K, FAIL, N, NRHS, NS
!  .. LOCAL ARRAYS ..
   INTEGER, ALLOCATABLE :: PIV(:)
   COMPLEX(WP), ALLOCATABLE :: A(:), B(:,:)
   REAL(WP), ALLOCATABLE :: AA(:), BB(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'ZSPSV ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, NRHS
   PRINT *, 'N = ', N, ' NRHS = ', NRHS
   NS = N*(N+1)/2
   ALLOCATE ( A(NS), AA(NS), B(N,NRHS), BB(N,NRHS), PIV(N) )
!
        READ (NIN, *) AA
      BB = 0.0_WP
      DO K = 1, NRHS
         DO I = 1, N
            DO J = 1, I
               BB(J,K) = BB(J,K) + AA(J+(I-1)*I/2)
               IF ( J /= I ) BB(I,K) = BB(I,K) + AA(J+(I-1)*I/2)
            ENDDO
         ENDDO
         BB(:,K) = BB(:,K)*K
      ENDDO
   A=AA; B=BB
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N
        WRITE (NOUT,*) 'J = ', I; WRITE (NOUT,FMT) (A(J+(I-1)*I/2),J=1,I)
      ENDDO
      WRITE(NOUT,*) 'The RHS matrix B:'
      DO J = 1, NRHS
        WRITE (NOUT,*) 'RHS', J; WRITE (NOUT,FMT) B(:,J)
      ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_ZHPSV LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HPSV(A, B )'
   A=AA; B=BB
   IF (NRHS .GT. 1) THEN
      CALL LA_HPSV( A, B )
   ELSE
      CALL LA_HPSV( A, B(1:N,1) )
   END IF
   WRITE(NOUT,*)'   B - the solution vectors computed by LA_HPSV:'
   DO J = 1, NRHS
      WRITE (NOUT,FMT) B(:,J)
   END DO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HPSV( A, B, ''L'' )'
   DO I = 1,N
      DO J = I, N
         A(J+(I-1)*(2*N-I)/2) = AA(I+J*(J-1)/2)
      ENDDO
   ENDDO
   B = BB
   CALL LA_HPSV( A, B, 'L' )
   WRITE(NOUT,*)'   B - the solution vectors computed by LA_HPSV:'
   DO J = 1, NRHS
      WRITE (NOUT,FMT) B(:,J)
   END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HPSV( A, B(1:N,1), IPIV=PIV, INFO=FAIL )'
   A=AA; B=BB
   CALL LA_HPSV( A, B(1:N,1), IPIV=PIV, INFO=FAIL )
   WRITE(NOUT,*)'B - the solution vectors computed by LA_HPSV, INFO = ', FAIL
   WRITE (NOUT,FMT) B(1:N,1)
   WRITE (NOUT,*) 'Pivots: ', PIV
!
END PROGRAM LA_ZHPSV_ET_EXAMPLE

SUBROUTINE LA_TEST_ZHPGVD( ITYPE, JOBZ, UPLO, N, AP, BP, W, Z, LDZ,&
     &  WORK,LWORK, RWORK, LRWORK, IWORK, LIWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     August 13, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_HPGVD
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: ITYPE, N, LDZ, LWORK, LRWORK, LIWORK
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBZ, UPLO
!  .. Array Arguments ..
   COMPLEX(WP), INTENT(INOUT) :: AP(1:N*(N+1)/2), BP( 1:N*(N+1)/2)
   REAL(WP), INTENT(OUT)::  W(1:N)
   COMPLEX(WP), INTENT(OUT) ::   WORK(1:LWORK), Z(1:LDZ, 1:N)
      INTEGER, INTENT(OUT) :: IWORK(1:LIWORK)
      REAL(WP), INTENT(OUT) :: RWORK(1: LRWORK)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_HPGVD'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZHPGVD'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IAP, IW, IBP, IITYPE, IZ1, IZ2
   CHARACTER*1 :: IUPLO, IJOBZ   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..

   IAP = N *(N+1)/2; IUPLO = UPLO; IW = N; IJOBZ = JOBZ
   IBP = N*(N+1)/2; IITYPE = ITYPE; IZ1 = MAX(1, N); IZ2 = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
      IAP = IAP - 1
     CASE (2)
       IBP = IAP - 1
     CASE (3)
       IW = IW - 1
     CASE (4)
       IITYPE = 22   
     CASE (5)
       IUPLO = 'T' 
     CASE (6)
       IZ2 = IZ2 - 1
       IJOBZ = 'V'
     CASE(:-1,7:)
       CALL UESTOP(SRNAMT)
   END SELECT
   IF (LSAME(IJOBZ, 'V')) THEN
     CALL LA_HPGVD( AP(1:IAP), BP(1:IBP), W(1 :IW), &
     &  IITYPE, IUPLO, Z(1:IZ1, 1: IZ2), INFO )
      ELSE
        CALL LA_HPGVD( AP(1:IAP), BP(1:IBP), W(1 :IW), &
     &    IITYPE, IUPLO, INFO = INFO )
      END IF
      
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_ZHPGVD
      
      

PROGRAM LA_DSPSVX_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_SPSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, K, INFO, N, NN, NRHS
!  .. LOCAL ARRAYS ..
   REAL(WP) :: RCOND
   INTEGER, ALLOCATABLE :: IPIV(:)
   REAL(WP), ALLOCATABLE :: A(:), B(:,:), X(:,:), AF(:)
   REAL(WP), ALLOCATABLE :: AA(:), BB(:,:), FERR(:), BERR(:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'DSPSVX ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, NRHS
   PRINT *, 'N = ', N, ' NRHS = ', NRHS
   NN = N*(N+1)/2
   ALLOCATE ( A(NN), AA(NN), B(N,NRHS), BB(N,NRHS), IPIV(N), X(N,NRHS), AF(NN), &
             FERR(NRHS), BERR(NRHS) )
!
   READ (NIN, *) AA
   BB = 0.0_WP
   DO K = 1, NRHS
      DO I = 1, N
         DO J = 1, I
            BB(J,K) = BB(J,K) + AA(J+(I-1)*I/2)
            IF ( J /= I ) BB(I,K) = BB(I,K) + AA(J+(I-1)*I/2)
         ENDDO
      ENDDO
      BB(:,K) = BB(:,K)*K
   ENDDO
   A=AA; B=BB
   WRITE(NOUT,*) 'The matrix A:'
   DO I = 1, N
     WRITE (NOUT,*) 'J = ', I; WRITE (NOUT,FMT) (A(J+(I-1)*I/2),J=1,I)
   ENDDO
   WRITE(NOUT,*) 'The RHS matrix B:'
   DO J = 1, NRHS
     WRITE (NOUT,*) 'RHS', J; WRITE (NOUT,FMT) B(:,J)
   ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_DSPSVX LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX( A, B, X, afp=AF, IPIV=IPIV, INFO=INFO )'
   A=AA; B=BB
   CALL LA_SPSVX( A, B, X, AFP=AF, IPIV=IPIV, INFO=INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX, INFO = ', INFO
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*) 'Pivots: ', IPIV
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX( A, B(1:N,1), X(1:N,1), afp=AF, IPIV=IPIV, INFO=INFO )'
   A=AA; B=BB
   CALL LA_SPSVX( A, B(1:N,1), X(1:N,1), AFP=AF, IPIV=IPIV, INFO=INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX, INFO = ', INFO
   WRITE (NOUT,FMT) X(:,1)
   WRITE(NOUT,*) 'Pivots: ', IPIV
! 
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX:'
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX( A, B, X )'
   A=AA; B=BB
   CALL LA_SPSVX( A, B, X )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX:'
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX(A, B(1:N,1), X(1:N,1) )'
   A=AA; B=BB
   CALL LA_SPSVX(A, B(1:N,1), X(1:N,1) )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX:'
   WRITE (NOUT,FMT) X(:,1)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX(A, B, X, IPIV=IPIV)'
   A=AA; B=BB
   CALL LA_SPSVX( A, B, X, IPIV=IPIV)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX:'
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*) 'Pivots: ', IPIV
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX( A, B(1:N,1), X(1:N,1), IPIV=IPIV )'
   A=AA; B=BB
   CALL LA_SPSVX( A, B(1:N,1), X(1:N,1), IPIV=IPIV )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX:'
   WRITE (NOUT,FMT) X(1:N,1)
   WRITE(NOUT,*) 'Pivots: ', IPIV
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX(A(4:4), B, X, INFO =INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_SPSVX( A(4:4), B, X, INFO=INFO)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX, INFO = ', INFO
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX( A, B(1:N,1), X(1:N-1,1), INFO=INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_SPSVX( A, B(1:N,1), X(1:N-1,1), INFO=INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX, INFO = ', INFO
   WRITE (NOUT,FMT) X(1:N,1)
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX(A, B, X, ''L'', INFO =INFO )'
   DO I = 1,N; DO J = I, N
         A(J+(I-1)*(2*N-I)/2) = AA(I+J*(J-1)/2)
      ENDDO; ENDDO
   B=BB; X=HUGE(1.0_WP)
   CALL LA_SPSVX( A, B, X, 'L', INFO=INFO)
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX, INFO = ', INFO
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX( A, B(1:N,1), X(1:N,1), FACT=''F'', INFO=INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_SPSVX( A, B(1:N,1), X(1:N,1), FACT='F', INFO=INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX, INFO = ', INFO
   WRITE (NOUT,FMT) X(1:N,1)
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX(A, B, X, ''U'', AF, IPIV, ''N'', ', &
                      'FERR, BERR, RCOND, INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_SPSVX(A, B, X, 'U', AF, IPIV, 'N', FERR, BERR, RCOND, INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX, INFO = ', INFO
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*) 'RCOND = ', RCOND
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPSVX(A, B(1:N,1), X(1:N,1), ''U'', AF, IPIV, ''F'', ', &
                      'FERR, BERR, &'
   WRITE(NOUT,*) '              RCOND, INFO )'
   A=AA; B=BB; X=HUGE(1.0_WP)
   CALL LA_SPSVX(A, B(1:N,1), X(1:N,1), 'U', AF, IPIV, 'F', &
                 FERR(1), BERR(1), RCOND, INFO )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_SPSVX, INFO = ', INFO
   WRITE (NOUT,FMT) X(1:N,1)
   WRITE(NOUT,*) 'RCOND = ', RCOND
!
END PROGRAM LA_DSPSVX_ET_EXAMPLE

      SUBROUTINE ZERRVX( PATH, NUNIT )
*
*  -- LAPACK90 test routine (version 1.1) --
*     UNI-C, Denmark
*     April 13, 1999
*
      IMPLICIT NONE
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  ZERRVX tests the error exits for the COMPLEX*16 driver routines
*  for solving linear systems of equations.
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*     .. Local Scalar ..
      CHARACTER*3 PATH1
      SAVE PATH1
      DATA PATH1/'   '/
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX
      PARAMETER          ( NMAX = 4 )
*     ..
*     .. Local Scalars ..
      CHARACTER          EQ
      CHARACTER*2        C2
      CHARACTER*1        CHAR, IEQUED 
      INTEGER            I, INFO, J, NRHS, IW
      INTEGER            KL, KU
      DOUBLE PRECISION   RCOND
*     ..
*     .. Local Arrays ..
      INTEGER            IP( NMAX ), IN( 100 )
      DOUBLE PRECISION   C( NMAX ), R( NMAX ), R1( NMAX ), R2( NMAX ),
     $                   RW( NMAX )
      COMPLEX*16         A( NMAX, NMAX ), AF( NMAX, NMAX ), B( NMAX ),
     $                   W( 2*NMAX ), X( NMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAMEN
      EXTERNAL           LSAMEN
*     ..
*     .. External Subroutines ..
      EXTERNAL CHKXER, LA_TEST_ZGBSV, LA_TEST_ZGBSVX, LA_TEST_ZGESV,
     $         LA_TEST_ZGESVX, LA_TEST_ZGTSV, LA_TEST_ZGTSVX,
     $         LA_TEST_ZHESV,
     $         LA_TEST_ZHESVX, LA_TEST_ZHPSV, LA_TEST_ZHPSVX,
     &         LA_TEST_ZPBSV,
     $         LA_TEST_ZPBSVX, LA_TEST_ZPOSV, LA_TEST_ZPOSVX,
     $         LA_TEST_ZPPSV, LA_TEST_ZPPSVX,
     $         LA_TEST_ZPTSV, LA_TEST_ZPTSVX, LA_TEST_ZSPSV,
     &         LA_TEST_ZSPSVX, LA_TEST_ZSYSV, LA_TEST_ZSYSVX
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, DCMPLX
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )
*
*     Set the variables to innocuous values.
*
      DO 20 J = 1, NMAX
         DO 10 I = 1, NMAX
            A( I, J ) = DCMPLX( 1.D0 / DBLE( I+J ),
     $                  -1.D0 / DBLE( I+J ) )
            AF( I, J ) = DCMPLX( 1.D0 / DBLE( I+J ),
     $                   -1.D0 / DBLE( I+J ) )
   10    CONTINUE
         B( J ) = 0.D0
         R1( J ) = 0.D0
         R2( J ) = 0.D0
         W( J ) = 0.D0
         X( J ) = 0.D0
         C( J ) = 0.D0
         R( J ) = 0.D0
         IP( J ) = J
   20 CONTINUE
      OK = .TRUE.
*
      IF( LSAMEN( 2, C2, 'GE' ) ) THEN
*
*        ZGESV
*
         SRNAMT = 'ZGESV '
         DO I = 1, 3
            IN(I) = 1
         END DO
         DO I = 1, 3
            INFOT = I
            DO J = 1, IN(I)
               DO NRHS = 1, 2
                  INFO = J + 100*I
                CALL LA_TEST_ZGESV( NMAX, NRHS, A, NMAX, IP, B, NMAX,
     $                 INFO )
                  CALL CHKXER( 'ZGESV ', INFOT, NOUT, LERR, OK )
               END DO
            END DO
         END DO
*
*        ZGESVX
*
         SRNAMT = 'ZGESVX'
         DO I = 1, 12
            IN(I) = 1
         END DO
         IN(3) = 2
         IN(4) = 2
         IN(6) = 4
         IN(8) = 4
         IN(9) = 3
         IN(10) = 3
         DO I = 1, 12
            INFOT = I
            DO J = 1, IN(I)
               DO NRHS = 1, 2
                  INFO = J + 100*I
                  CALL LA_TEST_ZGESVX( CHAR, CHAR, NMAX, NRHS, A, NMAX,
     $               AF, NMAX, IP, EQ, R, C, B, NMAX, X, NMAX, RCOND,
     $               R1, R2, W, IW, INFO)
                  CALL CHKXER( 'ZGESVX', INFOT, NOUT, LERR, OK )
               END DO
            END DO
         END DO
*
      ELSE IF( LSAMEN( 2, C2, 'GB' ) ) THEN
*
*        ZGBSV
*
         SRNAMT = 'ZGBSV '
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               KL = (NMAX-1)/3
               KU = NMAX-2*KL-1
               CALL LA_TEST_ZGBSV( NMAX, KL, KU, NRHS, A, NMAX, IP, B,
     $                              NMAX, INFO )
               CALL CHKXER( 'ZGBSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO  
*
*        ZGBSVX
*
         SRNAMT = 'ZGBSVX'
         DO I = 1, 13
           IN(I) = 1
         END DO
         IN(3) = 2
         IN(4) = 2
         IN(5) = 2
         IN(7) = 4
         IN(9) = 4
         IN(10) = 3
         IN(11) = 3
         DO I = 1, 13
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               IF (I /= 1) THEN
                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_ZGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_ZGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_ZGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )
                 
                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_ZGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_ZGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_ZGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_ZGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_ZGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_ZGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )
                 
                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_ZGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_ZGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_ZGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_ZGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_ZGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_ZGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )
                 
                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_ZGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_ZGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_ZGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_ZGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_ZGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_ZGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )
                 
                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_ZGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_ZGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_ZGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_ZGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_ZGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_ZGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )
                 INFO = J + 1                 00*I
                 IEQUED = 'B'
                 CALL LA_TEST_ZGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_ZGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_ZGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_ZGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_ZGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_ZGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_ZGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_ZGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_ZGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGBSVX', INFOT, NOUT, LERR, OK )
               ENDIF
             ENDDO
           ENDDO
         ENDDO
         
*
      ELSE IF( LSAMEN( 2, C2, 'GT' ) ) THEN
*
*        ZGTSV
*
         SRNAMT = 'ZGTSV '
         DO I = 1, 4
           IF (I/=2)  THEN
             INFOT = I
             DO J = 1, 1
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_ZGTSV( NMAX, NRHS, A(1,1), A(1,2),A(1, 3),
     $                               B, NMAX, INFO )
                 CALL CHKXER( 'XGTSV ', INFOT, NOUT, LERR, OK )
               END DO
             END DO
           END IF
         END DO 
*
*        ZGTSVX
*
         SRNAMT = 'ZGTSVX'
         DO I = 1, 14
           IF (I/=2)  THEN
             INFOT = I
             DO J = 1, 1
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_ZGTSVX( 'N', 'N', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGTSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 CALL LA_TEST_ZGTSVX( 'F', 'N', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGTSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 CALL LA_TEST_ZGTSVX( 'N', 'T', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGTSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 CALL LA_TEST_ZGTSVX( 'F', 'T', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGTSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 CALL LA_TEST_ZGTSVX( 'N', 'C', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGTSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 CALL LA_TEST_ZGTSVX( 'F', 'C', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'ZGTSVX', INFOT, NOUT, LERR, OK )
               ENDDO
             ENDDO
           ENDIF
         ENDDO
         
*
      ELSE IF( LSAMEN( 2, C2, 'PO' ) ) THEN
*
*        ZPOSV
*
         SRNAMT = 'ZPOSV '
         DO I = 1, 3
           IN(I) = 1
         END DO
         DO I = 1, 3
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_ZPOSV( 'U', NMAX, NRHS, A, NMAX, B, NMAX,
     $                                INFO )
               CALL CHKXER( 'ZPOSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_ZPOSV( 'L', NMAX, NRHS, A, NMAX, B, NMAX,
     $                                INFO )
               CALL CHKXER( 'ZPOSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO  
*
*        ZPOSVX
*
         SRNAMT = 'ZPOSVX'
         DO I = 1, 10
           IN(I) = 1
         END DO
         DO I = 1, 10
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'F', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'F', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'F', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'F', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'N', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'N', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'N', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'N', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'E', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'E', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'E', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPOSVX( 'E', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'ZPOSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'PP' ) ) THEN
*
*        ZPPSV
*
         SRNAMT = 'ZPPSV '
         DO I = 1, 3
           IN(I) = 1
         END DO
         DO I = 1, 3
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_ZPPSV( 'U', NMAX, NRHS, A(1,1), B,
     $                              NMAX, INFO)

               CALL CHKXER( 'ZPPSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_ZPPSV( 'L', NMAX, NRHS, A(1,1), B,
     $                             NMAX, INFO)
               CALL CHKXER( 'ZPPSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO 
*
*        ZPPSVX
*
         SRNAMT = 'ZPPSVX'
         DO I = 1, 10
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_ZPPSVX( 'F', 'U', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPPSVX( 'F', 'U', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPPSVX( 'F', 'L', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPPSVX( 'F', 'L', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPPSVX( 'N', 'U', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPPSVX( 'N', 'U', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPPSVX( 'N', 'L', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 1               00*I
               CALL LA_TEST_ZPPSVX( 'N', 'L', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPPSVX( 'E', 'U', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPPSVX( 'E', 'U', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPPSVX( 'E', 'L', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZPPSVX( 'E', 'L', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZPPSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'PB' ) ) THEN
*
*        ZPBSV
*
        SRNAMT = 'ZPBSV '
        DO I = 1, 3
          IN(I) = 1
        END DO
        DO I = 1, 3
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_ZPBSV( 'U', NMAX, 1, NRHS, A, NMAX,
     $                               B, NMAX, INFO)
              CALL CHKXER( 'ZPBSV ', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_ZPBSV( 'L', NMAX, 1, NRHS, A, NMAX,
     $                              B, NMAX, INFO)
              CALL CHKXER( 'ZPBSV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO    
*
*        ZPBSVX
*
        SRNAMT = 'ZPBSVX'
        DO I = 1, 10
          IN(I) = 1
        END DO
        DO I = 2, 10
          INFOT = I
          DO J = 1, 1
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'F', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'F', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'F', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'F', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'N', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'N', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'N', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'N', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'E', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'E', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'E', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZPBSVX( 'E', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
            ENDDO
          ENDDO
        ENDDO
        


        
         INFOT = 1
         CALL ZPBSVX( '/', 'U', 0, 0, 0, A, 1, AF, 1, EQ, C, B, 1, X, 1,
     $                RCOND, R1, R2, W, RW, INFO )
         CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL ZPBSVX( 'N', '/', 0, 0, 0, A, 1, AF, 1, EQ, C, B, 1, X, 1,
     $                RCOND, R1, R2, W, RW, INFO )
         CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL ZPBSVX( 'N', 'U', -1, 0, 0, A, 1, AF, 1, EQ, C, B, 1, X,
     $                1, RCOND, R1, R2, W, RW, INFO )
         CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL ZPBSVX( 'N', 'U', 1, -1, 0, A, 1, AF, 1, EQ, C, B, 1, X,
     $                1, RCOND, R1, R2, W, RW, INFO )
         CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL ZPBSVX( 'N', 'U', 0, 0, -1, A, 1, AF, 1, EQ, C, B, 1, X,
     $                1, RCOND, R1, R2, W, RW, INFO )
         CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL ZPBSVX( 'N', 'U', 1, 1, 0, A, 1, AF, 2, EQ, C, B, 2, X, 2,
     $                RCOND, R1, R2, W, RW, INFO )
         CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL ZPBSVX( 'N', 'U', 1, 1, 0, A, 2, AF, 1, EQ, C, B, 2, X, 2,
     $                RCOND, R1, R2, W, RW, INFO )
         CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
         INFOT = 10
         EQ = '/'
         CALL ZPBSVX( 'F', 'U', 0, 0, 0, A, 1, AF, 1, EQ, C, B, 1, X, 1,
     $                RCOND, R1, R2, W, RW, INFO )
         CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
         INFOT = 11
         EQ = 'Y'
         CALL ZPBSVX( 'F', 'U', 1, 0, 0, A, 1, AF, 1, EQ, C, B, 1, X, 1,
     $                RCOND, R1, R2, W, RW, INFO )
         CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
         INFOT = 13
         CALL ZPBSVX( 'N', 'U', 2, 0, 0, A, 1, AF, 1, EQ, C, B, 1, X, 2,
     $                RCOND, R1, R2, W, RW, INFO )
         CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
         INFOT = 15
         CALL ZPBSVX( 'N', 'U', 2, 0, 0, A, 1, AF, 1, EQ, C, B, 2, X, 1,
     $                RCOND, R1, R2, W, RW, INFO )
         CALL CHKXER( 'ZPBSVX', INFOT, NOUT, LERR, OK )
*
      ELSE IF( LSAMEN( 2, C2, 'PT' ) ) THEN
*
*        ZPTSV
*
        SRNAMT = 'ZPTSV '
        DO I = 1, 3
          IN(I) = 1
        END DO
        DO I = 2, 3
          INFOT = I
          DO J = 1, 1
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_ZPTSV( NMAX, NRHS, A(1,1), A(1,2),
     $                            B, NMAX, INFO )
              CALL CHKXER( 'ZPTSV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO  
*
*        ZPTSVX
*
        SRNAMT = 'ZPTSVX'
        DO I = 2, 9
          IN(I) = 1
        END DO
        DO I = 2, 9
          INFOT = I
          DO J = 1, 1
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_ZPTSVX( 'F', NMAX, NMAX, A( 1, 1 ),
     &          A( 1, 2 ), AF( 1, 1 ), AF( 1, 2 ), B, NMAX, X,
     &          NMAX, RCOND, R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPTSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZPTSVX( 'N', NMAX, NMAX, A( 1, 1 ),
     &          A( 1, 2 ), AF( 1, 1 ), AF( 1, 2 ), B, NMAX, X,
     &          NMAX, RCOND, R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZPTSVX', INFOT, NOUT, LERR, OK )
            ENDDO
          ENDDO
        ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'HE' ) ) THEN
*
*        ZHESV
*
        SRNAMT = 'ZHESV '
        DO I = 1, 4
          IN(I) = 1
        END DO
        DO I = 1, 4
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_ZHESV( 'U', NMAX, NRHS,  A, NMAX, A(1,2),
     $                               B, NMAX, W, 1, INFO)
              CALL CHKXER( 'ZHESV ', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_ZHESV( 'L', NMAX, NRHS, A, NMAX, A(1,2),
     $                              B, NMAX, W, 1,INFO)
              CALL CHKXER( 'ZHESV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO  
*
*        ZHESVX
*
        SRNAMT = 'ZHESVX'
         DO I = 1, 9
           IN(I) = 1
         END DO
         DO I = 1, 9
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_ZHESVX( 'N', 'L', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'ZHESVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHESVX( 'N', 'U', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'ZHESVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHESVX( 'F', 'L', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'ZHESVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHESVX( 'F', 'U', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'ZHESVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'HP' ) ) THEN
*
*        ZHPSV
*
         SRNAMT = 'ZHPSV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_ZHPSV( 'U', NMAX, NRHS, A(1,1), A(1,2),
     $                              B, NMAX, INFO)
               CALL CHKXER( 'ZHPSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_ZHPSV( 'L', NMAX, NRHS, A(1,1), A(1 ,2),
     $                              B, NMAX, INFO)
               CALL CHKXER( 'ZHPSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO  
*
*        ZHPSVX
*
         SRNAMT = 'ZHPSVX'
         DO I = 1, 9
           IN(I) = 1
         END DO
         DO I = 1, 9
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_ZHPSVX( 'N', 'U', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZHPSVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_ZHPSVX( 'N', 'L', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZHPSVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_ZHPSVX( 'F', 'U', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZHPSVX', INFOT, NOUT, LERR, OK )
               
               INFO = J + 100*I
               CALL LA_TEST_ZHPSVX( 'F', 'L', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
               CALL CHKXER( 'ZHPSVX', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO
*
      ELSE IF( LSAMEN( 2, C2, 'SY' ) ) THEN
*
*        ZSYSV
*
         SRNAMT = 'ZSYSV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_ZSYSV('U', NMAX, NRHS, A, NMAX,
     $                               A(1,2), B, NMAX, W, 1 ,INFO )
               CALL CHKXER( 'ZSYSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_ZSYSV('L', NMAX, NRHS, A, NMAX,
     $                               A(1,2), B, NMAX, W, 1 ,INFO )
               CALL CHKXER( 'ZSYSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO  
*
*        ZSYSVX
*
         SRNAMT = 'ZSYSVX'
         DO I = 1, 9
           IN(I) = 1
         END DO
         DO I = 1, 9
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_ZSYSVX( 'N', 'L', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'ZSYSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZSYSVX( 'N', 'U', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'ZSYSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZSYSVX( 'F', 'L', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'ZSYSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZSYSVX( 'F', 'U', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'ZSYSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'SP' ) ) THEN
*
*        ZSPSV
*
        SRNAMT = 'ZSPSV '
        DO I = 1, 4
          IN(I) = 1
        END DO
        DO I = 1, 4
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_ZSPSV( 'U', NMAX, NRHS, A(1,1), A(1,2),
     $                              B, NMAX, INFO)
              CALL CHKXER( 'ZSPSV ', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_ZSPSV( 'L', NMAX, NRHS, A(1,1), A(1 ,2),
     $                              B, NMAX, INFO)
              CALL CHKXER( 'ZSPSV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO  
*
*        ZSPSVX
*
        SRNAMT = 'ZSPSVX'
        DO I = 1, 9
          IN(I) = 1
        END DO
        DO I = 1, 9
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_ZSPSVX( 'N', 'U', NMAX, NRHS, A, AF, IP, B,
     &          NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZSPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZSPSVX( 'N', 'L', NMAX, NRHS, A, AF, IP, B,
     &          NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZSPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZSPSVX( 'F', 'U', NMAX, NRHS, A, AF, IP, B,
     &          NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZSPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_ZSPSVX( 'F', 'L', NMAX, NRHS, A, AF, IP, B,
     &          NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
              CALL CHKXER( 'ZSPSVX', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO
        
      END IF
*
*     Print a summary line.
*
      IF( PATH1 /= PATH ) THEN
         PATH1 = PATH
         IF( OK ) THEN
            WRITE( NOUT, FMT = 9999 )PATH
         ELSE
            WRITE( NOUT, FMT = 9998 )PATH
         END IF
      END IF
*
 9999 FORMAT( 1X, A3, ' drivers passed the tests of the error exits' )
 9998 FORMAT( ' *** ', A3, ' drivers failed the tests of the error ',
     $      'exits ***' )
*
      RETURN
*
*     End of ZERRVX
*
      END

SUBROUTINE LA_TEST_DGETRS( TRANS, N, NRHS, A, LDA, IPIV, B, LDB, INFO )
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     October 31, 1996
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO
   USE F95_LAPACK, ONLY: LA_GETRS
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   CHARACTER*1 TRANS
   INTEGER, INTENT(IN) :: N, NRHS, LDA, LDB
   INTEGER, INTENT(INOUT) :: INFO
!  .. Array Arguments ..
   INTEGER, INTENT(OUT) :: IPIV(1:N)
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB,1:N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GETRS'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DGETRS'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   CHARACTER*1 LTRANS
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IIPIV
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IB1 = N; IB2 = NRHS; IIPIV = N; LTRANS = TRANS
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
      IF ( NRHS ==1 ) THEN
        IF( LTRANS == 'N' )THEN
          CALL LA_GETRS( A(1:IA1,1:IA2), IPIV(1:IIPIV), B(1:IB1,1) )
        ELSE
          CALL LA_GETRS( A(1:IA1,1:IA2), IPIV(1:IIPIV), B(1:IB1,1), & 
     &                               LTRANS)
        END IF
        INFO = INFOTC 
      ELSE
        IF( LTRANS == 'N' )THEN
          CALL LA_GETRS( A(1:IA1,1:IA2), IPIV(1:IIPIV), B(1:IB1,1:IB2))
        ELSE
          CALL LA_GETRS( A(1:IA1,1:IA2), IPIV(1:IIPIV), B(1:IB1,1:IB2), & 
     &                                LTRANS)
        END IF
        INFO = INFOTC
      END IF
   CASE (1)
      IA2 = IA1-1
   CASE (2)
      IIPIV = IA1-1
   CASE(3)
      IB1 = IA1-1
   CASE(4)
      LTRANS = '/'
   CASE(:-1,5:)
      CALL UESTOP(SRNAMT)
   END SELECT
   IF( I /= 0 ) THEN
      SELECT CASE (NRHS)
      CASE (2:)
         CALL LA_GETRS( A(1:IA1,1:IA2),IPIV(1:IIPIV), B(1:IB1,1:IB2), &
              LTRANS, INFO )
      CASE(1)
         IF( I /= 4 )THEN
            CALL LA_GETRS( A(1:IA1,1:IA2),IPIV(1:IIPIV), B(1:IB1,1), &
                 LTRANS, INFO )
         ELSE
            CALL ERINFO( -I, SRNAME, INFO )
         END IF
      CASE(:-1)
         CALL UESTOP(SRNAMT)
      END SELECT
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_DGETRS

      FUNCTION ZLANGE_F95( A, NORM, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!     .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => DP
      USE LA_AUXMOD, ONLY: ERINFO, LSAME
      USE F77_LAPACK, ONLY: LANGE_F77 => LA_LANGE
!     .. "Implicit Statement" ..
      IMPLICIT NONE
!     .. "Function Type" ..
      REAL(WP) :: ZLANGE_F95
!     .. "Scalar Arguments" ..
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
!     .. "Array Arguments" ..
      COMPLEX(WP), INTENT(IN) :: A(:,:)
!-----------------------------------------------------------------
!
!  Purpose
!  =======
!
!  LA_LANGE  returns the value of the one norm,  or the Frobenius norm,
!  or the  infinity norm,  or the  element of  largest absolute value
!  of a complex matrix A.
!
!  Description
!  ===========
!
!  LA_LANGE returns the value
!
!     LA_LANGE = ( max(abs(A(i,j))), NORM = 'M' or 'm'
!              (
!              ( norm1(A),         NORM = '1', 'O' or 'o'
!              (
!              ( normI(A),         NORM = 'I' or 'i'
!              (
!              ( normF(A),         NORM = 'F', 'f', 'E' or 'e'
!
!  where  norm1  denotes the  one norm of a matrix (maximum column sum),
!  normI  denotes the  infinity norm  of a matrix  (maximum row sum) and
!  normF  denotes the  Frobenius norm of a matrix (square root of sum of
!  squares).  Note that  max(abs(A(i,j)))  is not a  matrix norm.
!
!  =========
!
!  FUNCTION LA_ANGE( A, NORM, INFO )
!     REAL(<wp>) :: LA_ANGE
!     <type>(<wp>), INTENT(IN) :: <a>
!     CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
!     INTEGER, INTENT(OUT), OPTIONAL :: INFO
!     <type> ::= REAL | COMPLEX
!     <wp>   ::= KIND(1.0) | KIND(1.0D0)
!     <a>    ::= A(:,:) | A(:)
!
!  Arguments
!  =========
!
!  A       (input) COMPLEX array, shape either (:,:) or (:).
!          If shape is (:,:) then SIZE(A,1) == m, SIZE(A,2) == n.
!          If shape is (:) then SIZE(A) == n.
!          If either m or n == 0 LA_LANGE is set to zero.
!          The m by n matrix A.
!
!  NORM    (input) CHARACTER*1
!          Specifies the value to be returned in LA_LANGE as described
!          above.
!
!  INFO    (output) INTEGER
!          = 0: successful exit
!          < 0: if INFO = -i, the i-th argument had an illegal value
!      If INFO is not present and an error occurs, then the program is
!         terminated with an error message.
!
!  ---------------------------------------------------------------------
!     .. "Parameters" ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_LANGE'
!     .. "Local Scalars" ..
      CHARACTER(LEN=1) :: LNORM
      INTEGER :: ISTAT, ISTAT1, LDA, LINFO, M, N
      REAL(WP), TARGET ::LLWORK(1)
!     .. "Local Pointers" ..
      REAL(WP), POINTER :: WORK(:)
!     .. "Intrinsic Functions" ..
      INTRINSIC SIZE, PRESENT, MAX
!     .. "Executable Statements" ..
      LINFO = 0; M = SIZE(A,1); N = SIZE(A,2); LDA = MAX(1,M)
      ISTAT = 0
      IF( PRESENT(NORM) )THEN; LNORM = NORM; ELSE; LNORM = '1'; ENDIF
!     .. "Testing The Arguments" ..
      IF( M < 0 .OR. N < 0 )THEN; LINFO = -1
      ELSE IF( .NOT. ( LSAME(LNORM,'M') .OR. LSAME(LNORM,'1') .OR. &
         LSAME(LNORM,'I') .OR. LSAME(LNORM,'F') .OR. &
         LSAME(LNORM,'E') ) )THEN; LINFO = -2
      ELSE
         IF( LSAME(LNORM,'I') )THEN; ALLOCATE( WORK( M), STAT=ISTAT )
         ELSE; WORK => LLWORK; ENDIF
         IF( ISTAT == 0 ) &
           ZLANGE_F95 = LANGE_F77( LNORM, M, N, A, LDA, WORK )
         IF( LSAME(LNORM,'I') )DEALLOCATE( WORK, STAT=ISTAT1 )
      ENDIF
      CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
      END FUNCTION ZLANGE_F95

 SUBROUTINE DSPSV1_F95( AP, B, UPLO, IPIV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO, LSAME
    USE F77_LAPACK, ONLY: SPSV_F77 => LA_SPSV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IPIV(:)
    REAL(WP), INTENT(INOUT) :: AP(:), B(:)
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_SPSV'
!   .. LOCAL SCALARS ..
    CHARACTER(LEN=1) :: LUPLO
    INTEGER :: LINFO, N, NN, SIPIV, ISTAT, ISTAT1
    COMPLEX(WP) :: WW
!   .. LOCAL POINTERS ..
    INTEGER, POINTER :: LPIV(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT, REAL, INT, AIMAG
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; NN = SIZE(AP)
    WW = (-1+SQRT(1+8*REAL(NN,WP)))*0.5; N = INT(WW)
    IF( PRESENT(UPLO) )THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
    IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; END IF
!   .. TEST THE ARGUMENTS
    IF( NN < 0 .OR. AIMAG(WW) /= 0 .OR. REAL(N,WP) /= REAL(WW) ) THEN; LINFO = -1
    ELSE IF( SIZE( B ) /= N ) THEN; LINFO = -2
    ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
    ELSE IF( SIPIV /= N )THEN; LINFO = -4
    ELSE IF ( N > 0 ) THEN
      IF( PRESENT(IPIV) )THEN; LPIV => IPIV
      ELSE; ALLOCATE( LPIV(N), STAT = ISTAT ); END IF
      IF( ISTAT == 0 ) THEN
         CALL SPSV_F77( LUPLO, N, 1, AP, LPIV, B, N, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(IPIV) )DEALLOCATE(LPIV, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE DSPSV1_F95

      SUBROUTINE SERRLS( PATH, NUNIT )
*
*  -- LAPACK test routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     April 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  SERRLS tests the error exits for the REAL least squares
*  driver routines (SGELS, SGELSS, SGELSX, SGELSY, SGELSD).
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX
      PARAMETER          ( NMAX = 2 )
*     ..
*     .. Local Scalars ..
      CHARACTER*2        C2
      INTEGER            INFO, IRNK, I, J, NRHS
      REAL               RCOND
*     ..
*     .. Local Arrays ..
      INTEGER            IP( NMAX ), IN(100)
      REAL               A( NMAX, NMAX ), B( NMAX, NMAX ), S( NMAX ),
     $                   W( NMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAMEN
      EXTERNAL           LSAMEN
*     ..
*     .. External Subroutines ..
      EXTERNAL           ALAESM, CHKXER, LA_TEST_SGELS, SGELSD,
     $                   LA_TEST_SGELSS,
     $                   LA_TEST_SGELSX,
     $                   SGELSY
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )
      A( 1, 1 ) = 1.0E+0
      A( 1, 2 ) = 2.0E+0
      A( 2, 2 ) = 3.0E+0
      A( 2, 1 ) = 4.0E+0
      OK = .TRUE.
*
      IF( LSAMEN( 2, C2, 'LS' ) ) THEN
*
*        Test error exits for the least squares driver routines.
*
*        SGELS
*
         SRNAMT = 'SGELS '
         DO I = 2, 3
           IN(I) = 1
         END DO
         DO I = 2, 3
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_SGELS('N', NMAX, NMAX, NRHS, A,
     &           NMAX, B, NMAX, A(1,1), NMAX, INFO )
               CALL CHKXER( 'SGELS ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_SGELS('T', NMAX, NMAX, NRHS, A, NMAX, B,
     &           NMAX, A(1,1), NMAX, INFO )
               CALL CHKXER( 'SGELS ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO 

*
*        SGELSS
*
         SRNAMT = 'SGELSS'
         DO I = 2, 4
           IN(I) = 1
         END DO
         DO I = 2, 4
           IF (I /= 3) THEN
             INFOT = I
             DO J = 1, IN(I)
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_SGELSS( NMAX, NMAX, NRHS, A,
     &             NMAX, B, NMAX, A(1,1), RCOND,
     &             IRNK, W, 1 , INFO )
                 CALL CHKXER( 'SGELSS ', INFOT, NOUT, LERR, OK )
               END DO
             END DO
           END IF
         END DO 

*
*        SGELSX
*
         SRNAMT = 'SGELSX'
         DO I = 2, 4
           IN(I) = 1
         END DO
         DO I = 2, 4
           IF (I /= 3) THEN
             INFOT = I
             DO J = 1, IN(I)
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_SGELSX( NMAX, NMAX, NRHS, A,
     &             NMAX, B, NMAX, A(1,1), RCOND,
     &             IRNK, W, INFO )
                 CALL CHKXER( 'SGELSX ', INFOT, NOUT, LERR, OK )
               END DO
             END DO
          END IF
         END DO 

*        SGELSY
*
         SRNAMT = 'SGELSY'
         DO I = 2, 4
           IN(I) = 1
         END DO
         DO I = 2, 4
           IF (I /= 3) THEN
             INFOT = I
             DO J = 1, IN(I)
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_SGELSY( NMAX, NMAX, NRHS, A, NMAX, B,
     &             NMAX, IP, RCOND, IRNK, W, 10, INFO )
                 CALL CHKXER( 'SGELSY', INFOT, NOUT, LERR, OK )
               ENDDO
             ENDDO
           ENDIF
         ENDDO     
*
*        SGELSD
*
         SRNAMT = 'SGELSD'
         DO I = 2, 4
           IN(I) = 1
         END DO
         DO I = 2, 4
           IF (I /= 3) THEN
             INFOT = I
             DO J = 1, IN(I)
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_SGELSD( NMAX, NMAX, NRHS, A, NMAX, B,
     &             NMAX, S, RCOND, IRNK, W, 50*NMAX, IP, INFO )
                 CALL CHKXER( 'SGELSD', INFOT, NOUT, LERR, OK )
               ENDDO
             ENDDO
           ENDIF
         ENDDO        
     
      END IF
*
*     Print a summary line.
*
      CALL ALAESM( PATH, OK, NOUT )
*
      RETURN
*
*     End of SERRLS
*
      END

      PROGRAM LA_SSYEV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SYEV, LA_SYEVD
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), W(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_SYEV Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), W(N) )

      OPEN(UNIT=21,FILE='syev.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO    
      CLOSE(21)
    
      AA=TRANSPOSE(A)

      WRITE(*,*)'Matrix A:'
      DO I=1,N; 
         WRITE(*,"(5(F9.5))") A(I,:); 
      ENDDO
    
      WRITE(*,*) 'CALL LA_SYEV( A, W )'
      CALL LA_SYEV(  A, W)
      WRITE(*,*) 'W on exit : '
      DO I=1,N
      WRITE(*,"(5(F10.5))") W(I)
      ENDDO

      WRITE(*,*)
      WRITE(*,*)' * EXAMPLE 2 * '

      WRITE(*,*)'Matrix A:'
      DO I=1,N; 
         WRITE(*,"(5(F9.5))") AA(I,:); 
      ENDDO

      WRITE(*,*) "CALL LA_SYEVD( A, W, 'V', 'L', INFO )"
      CALL LA_SYEVD( AA, W, 'V', 'L', INFO )

      WRITE(*,*) 'A on exit : '
      DO I=1,N; 
         WRITE(*,"(5(E14.6))") AA(I,:); 
      ENDDO

      WRITE(*,*) 'W on exit : '
      DO I=1,N
      WRITE(*,"(5(F10.5))") W(I)
      ENDDO

      WRITE(*,*) ' INFO = ', INFO

      END PROGRAM LA_SSYEV_EXAMPLE

SUBROUTINE ZHEEVR_F95( A, W, JOBZ, UPLO, VL, VU, IL, IU, M, ISUPPZ,  ABSTOL, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => DP
      USE LA_AUXMOD, ONLY: ERINFO, LSAME
      USE F77_LAPACK, ONLY: HEEVR_F77 => LA_HEEVR
!  .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!  .. CHARACTER ARGUMENTS ..
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
!  .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(IN), OPTIONAL :: IL, IU
      INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
      REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
!  .. ARRAY ARGUMENTS ..
      COMPLEX(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: W(:)
      INTEGER, INTENT(OUT), OPTIONAL, TARGET :: ISUPPZ(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!       LA_SYEVR / LA_HEEVR compute selected eigenvalues and, optionally,
! the corresponding eigenvectors of a real symmetric/complex Hermitian 
! matrix A. Eigenvalues and eigenvectors can be selected by specifying
! either a range of values or a range of indices for the desired 
! eigenvalues.
!       LA_SYEVR and LA_HEEVR use a relatively robust representation 
! (RRR) algorithm. It is usually the fastest algorithm of all and uses 
! the least workspace.
! 
! ========
! 
!        SUBROUTINE LA SYEVR / LA HEEVR( A, W, JOBZ=jobz, &
!                 UPLO=uplo, VL=vl, VU=vu, IL=il, IU=iu, M=m, &
!                 ISUPPZ= isuppz, ABSTOL=abstol, INFO=info )
!           <type>(<wp>), INTENT(INOUT) :: A(:,:)
!           REAL(<wp>), INTENT(OUT) :: W(:)
!           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
!           REAL(<wp>), INTENT(IN), OPTIONAL :: VL, VU
!           INTEGER, INTENT(IN), OPTIONAL :: IL, IU
!           INTEGER, INTENT(OUT), OPTIONAL :: M
!           INTEGER, INTENT(OUT), OPTIONAL :: ISUPPZ(:)
!           REAL(<wp>), INTENT(IN), OPTIONAL :: ABSTOL
!           INTEGER, INTENT(OUT), OPTIONAL :: INFO
!        where
!           <type> ::= REAL | COMPLEX
!           <wp>   ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! A       (input/output) REAL or COMPLEX square array, shape (:,:).
!         On entry, the matrix A.
!         If UPLO = 'U', the upper triangular part of A contains the 
!         upper triangular part of the matrix A. If UPLO = 'L', the 
!         lower triangular part of A contains the lower triangular part
!         of the matrix A.
!         On exit:
!         If JOBZ = 'V', then the first M columns of A contain the 
!         orthonormal eigenvectors of the matrix A corresponding to the
!         selected eigenvalues, with the i-th column of A containing the
!         eigenvector associated with the eigenvalue in W(i).
!         If JOBZ = 'N', the upper triangle (if UPLO = 'U') or the lower 
!         triangle (if UPLO = 'L') of A, including the diagonal, is 
! 	  destroyed.
! W       (output) REAL array, shape (:) with size(W) = size(A,1).
!         The first M elements contain the selected eigenvalues in 
!         ascending order.
! JOBZ    Optional (input) CHARACTER(LEN=1).
!         = 'N': Computes eigenvalues only;
!         = 'V': Computes eigenvalues and eigenvectors.
!         Default value: 'N'.
! UPLO    Optional (input) CHARACTER(LEN=1).
!         = 'U': Upper triangle of A is stored;
!         = 'L': Lower triangle of A is stored.
!         Default value: 'U'.
! VL,VU   Optional (input) REAL.
!         The lower and upper bounds of the interval to be searched for
!         eigenvalues. VL < VU.
!         Default values: VL = -HUGE(<wp>) and VU = HUGE(<wp>), where 
!         <wp> ::= KIND(1.0) | KIND(1.0D0).
!         Note: Neither VL nor VU may be present if IL and/or IU is 
!         present.
! IL,IU   Optional (input) INTEGER.
!         The indices of the smallest and largest eigenvalues to be
!         returned. The IL-th through IU-th eigenvalues will be found.
! 	     1 <= IL <= IU <= size(A,1).
!         Default values: IL = 1 and IU = size(A,1).
!         Note: Neither IL nor IU may be present if VL and/or VU is 
!         present.
!         Note: All eigenvalues are calculated if none of the arguments
!         VL, VU, IL and IU are present.
! M       Optional (output) INTEGER.
!         The total number of eigenvalues found. 0 <= M <= size(A,1).
!         Note: If IL and IU are present then M = IU-IL+1.
! ISUPPZ  Optional (output) INTEGER array, shape (:) with 
!         size(ISUPPZ) = 2*max(1,M).
!         The support of the eigenvectors in A, i.e., the indices 
!         indicating the nonzero elements. The i-th eigenvector is
!         nonzero only in elements ISUPPZ(2i-1) through ISUPPZ(2i) .
!         Note: ISUPPZ must be absent if JOBZ = 'N'.
! ABSTOL  Optional (input) REAL.
!         The absolute error tolerance for the eigenvalues. An 
!         approximate eigenvalue is accepted as converged when it is 
!         determined to lie in an interval [a, b] of width less than or
!         equal to ABSTOL + EPSILON(1.0_<wp>) * max(|a|,|b|),
!         where <wp> is the working precision. If ABSTOL <= 0, then 
! 	  EPSILON(1.0_<wp>)* ||T||1 will be used in its place, where 
! 	  ||T||1 is the l1 norm of the tridiagonal matrix obtained by 
!         reducing A to tridiagonal form.
!         Default value: 0.0_<wp>.
!         Note: Eigenvalues are computed most accurately if ABSTOL is set
!         to LA_LAMCH(1.0_<wp>,'Safe minimum'), not zero.
! INFO    Optional (output) INTEGER
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         If INFO is not present and an error occurs, then the program
!         is terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_HEEVR'
!  .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: LJOBZ, LUPLO, LRANGE
      INTEGER :: N, LINFO, LD, LDZ, LZ, LIL, LIU, LM, LWORK, ISTAT, &
     &  LIWORK, SISUPPZ, NN, LRWORK
      INTEGER:: IWORKMIN(1)
      COMPLEX(WP) :: WORKMIN(1)
      REAL(WP), POINTER :: RWORK(:)
      REAL(WP) :: RWORKMIN(1) 
      REAL(WP) :: LABSTOL, LVL, LVU
!  .. LOCAL ARRAYS ..
      INTEGER, POINTER :: IWORK(:), LISUPPZ(:)
      COMPLEX(WP), POINTER :: WORK(:), Z(:,:)
!  .. INTRINSIC FUNCTIONS ..
      INTRINSIC HUGE, PRESENT, SIZE
      INTEGER ILAENV
      EXTERNAL ILAENV
!  .. EXECUTABLE STATEMENTS ..
      N = SIZE(A,1); LD = MAX(1,N); LINFO = 0; ISTAT = 0
      NN=2*MAX(1,N)
      IF( PRESENT(JOBZ) )THEN; LJOBZ = JOBZ; ELSE; LJOBZ = 'N'; ENDIF
      IF( PRESENT(ISUPPZ) )THEN; SISUPPZ = SIZE(ISUPPZ); ELSE; SISUPPZ = NN; END IF 
      IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U';  END IF
      IF( PRESENT(VL) )THEN; LVL = VL; ELSE; LVL = -HUGE(LVL);  ENDIF
      IF( PRESENT(VU) )THEN; LVU = VU; ELSE; LVU = HUGE(LVU); ENDIF
      IF( PRESENT(IL) )THEN; LIL = IL; ELSE; LIL = 1; ENDIF
      IF( PRESENT(IU) )THEN; LIU = IU; ELSE; LIU = N; ENDIF
!  .. TEST THE ARGUMENTS ..
        IF( SIZE( A, 2 ) /= N .OR. N < 0 )THEN; LINFO = -1
        ELSE IF( SIZE( W ) /= N )THEN; LINFO = -2
	ELSE IF( .NOT.LSAME(LJOBZ,'N') .AND. .NOT.LSAME(LJOBZ,'V') )THEN; LINFO = -3
        ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
        ELSE IF( LVU < LVL )THEN; LINFO = -5
        ELSE IF( (PRESENT(VL) .OR. PRESENT(VU)) .AND. (PRESENT(IL) .OR. PRESENT(IU)) )THEN
          LINFO = -6
        ELSE IF(( LIU < LIL .OR. LIL < 1) .AND. N>0)THEN; LINFO = -7
        ELSE IF( N < LIU )THEN; LINFO = -8
        ELSE IF( SISUPPZ /= NN .OR. PRESENT(ISUPPZ).AND.LSAME(LJOBZ,'N'))THEN; LINFO = -10
        ELSE IF( N > 0 )THEN
          IF( PRESENT(VL) .OR. PRESENT(VU) )THEN
            LRANGE = 'V'; LM = N
          ELSE IF( PRESENT(IL) .OR. PRESENT(IU) )THEN
            LRANGE = 'I'; LM = LIU-LIL+1
          ELSE
            LRANGE = 'A'; LM = N
          END IF
	  IF ( LSAME(LJOBZ,'V') ) THEN
	      LDZ=N; LZ=LM
	  ELSE
	      LDZ=1; LZ=1
	  ENDIF
	  ALLOCATE (Z(LDZ,LZ), STAT=ISTAT)							
!  .. QUERING THE SIZE OF WORKSPACE ..
             LWORK = -1
	     LRWORK = -1
	     LIWORK = -1
	        CALL HEEVR_F77( LJOBZ, LRANGE, LUPLO, N, A, LD, LVL, LVU, &
     &             LIL, LIU, LABSTOL, LM, W, Z, LDZ, IWORKMIN, &
     &             WORKMIN, LWORK, RWORKMIN, LRWORK, IWORKMIN, LIWORK, LINFO )
! THE NEXT  LINE SHOULD BE
!           LWORK = WORKMIN(1) WHEN  THE LAPACK IS FIXED
            LWORK = 10*WORKMIN(1)+10000
	    LRWORK = RWORKMIN(1)
	    LIWORK = IWORKMIN(1)
	    DEALLOCATE(Z)
	    
	    ALLOCATE(IWORK(LIWORK), RWORK(LRWORK), STAT=ISTAT)
            IF (ISTAT /=0) THEN ; LINFO = -100; GOTO 100; ENDIF
            ALLOCATE(WORK(LWORK), STAT=ISTAT)
            IF (ISTAT /=0) THEN ; LINFO = -100; GOTO 200; ENDIF
                
            ALLOCATE(LISUPPZ(NN), STAT=ISTAT)
            IF (ISTAT /= 0) THEN ; LINFO = -100; GOTO 300; ENDIF
	    
	    ALLOCATE(Z(LDZ, LZ), STAT = ISTAT)
	    IF(ISTAT /= 0) THEN; LINFO = -100; GOTO 400; ENDIF
                  
            IF( PRESENT(ABSTOL) )THEN; LABSTOL = ABSTOL; ELSE
!              LABSTOL = 2*LAMCH_F77('Safe minimum');  ENDIF
              LABSTOL = 0.0_WP;  ENDIF
! .. CALL LAPACK77 ROUTINE ..
              CALL HEEVR_F77( LJOBZ, LRANGE, LUPLO, N, A, LD, LVL, LVU, &
     &          LIL, LIU, LABSTOL, LM, W, Z, LDZ, LISUPPZ, &
     &          WORK, LWORK, RWORK, LRWORK, IWORK, LIWORK, LINFO )
              IF( LSAME(LJOBZ,'V') ) A(1:LDZ,1:LM) = Z(1:LDZ,1:LM)
              IF( PRESENT(M) ) M = LM
	      IF(PRESENT(ISUPPZ)) ISUPPZ = LISUPPZ

              DEALLOCATE(Z)
400           DEALLOCATE(LISUPPZ)
300           DEALLOCATE(WORK)
200           DEALLOCATE(IWORK, RWORK)
         ENDIF
100         CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE ZHEEVR_F95

!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_STEVX computes selected eigenvalues and, optionally, the 
! corresponding eigenvectors of a real symmetric tridiagonal matrix A.
! Eigenvalues and eigenvectors can be selected by specifying either a 
! range of values or a range of indices for the desired eigenvalues.
! 
! =========
! 
!        SUBROUTINE LA_STEVX( D, E, W, Z=z, VL=vl, VU=vu, &
!                         IL=il, IU=iu, M=m, IFAIL=ifail, &
!                         ABSTOL=abstol, INFO=info )
!             REAL(<wp>), INTENT(INOUT) :: D(:), E(:)
!             REAL(<wp>), INTENT(OUT) :: W(:)
!             REAL(<wp>), INTENT(OUT), OPTIONAL :: Z(:,:)
!             REAL(<wp>), INTENT(IN), OPTIONAL :: VL, VU
!             INTEGER, INTENT(IN), OPTIONAL :: IL, IU
!             INTEGER, INTENT(OUT), OPTIONAL :: M
!             INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
!             REAL(<wp>), INTENT(IN), OPTIONAL :: ABSTOL
!             INTEGER, INTENT(OUT), OPTIONAL :: INFO
!        where
!              <wp> ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! D        (input/output) REAL array, shape (:) with size(D) = n, where n
!          is the order of A.
!          On entry, the diagonal elements of the matrix A.
!          On exit, the original contents of D possibly multiplied by a 
!          constant factor to avoid over/underflow in computing the
! 	   eigenvalues.
! E        (input/output) REAL array, shape (:) with size(E) = n.
!          On entry, the n-1 subdiagonal elements of A in E(1) to E(n-1).
! 	   E(n) need not be set.
!          On exit, the original contents of E possibly multiplied by a 
! 	   constant factor to avoid over/underflow in computing the 
! 	   eigenvalues.
! W        (output) REAL array with size(W) = n.
!          The first M elements contain the selected eigenvalues in 
! 	   ascending order.
! Z        Optional (output) REAL or COMPLEX array, shape (:,:) with 
!          size(Z,1) = n and size(Z,2) = M.
!          The first M columns of Z contain the orthonormal eigenvectors
! 	   of A corresponding to the selected eigenvalues, with the i-th
! 	   column of Z containing the eigenvector associated with the
!          eigenvalue in W(i) . If an eigenvector fails to converge, then
!          that column of Z contains the latest approximation to the 
!          eigenvector, and the index of the eigenvector is returned in 
! 	   IFAIL.
!          Note: The user must ensure that at least M columns are 
! 	   supplied in the array Z. When the exact value of M is not 
! 	   known in advance, an upper bound must be used. In all cases
! 	   M <= n.
! VL,VU    Optional (input) REAL.
!          The lower and upper bounds of the interval to be searched for 
! 	   eigenvalues. VL < VU.
!          Default values: VL = -HUGE(<wp>) and VU = HUGE(<wp>), where 
! 	   <wp> ::= KIND(1.0) | KIND(1.0D0).
!          Note: Neither VL nor VU may be present if IL and/or IU is 
! 	   present.
! IL,IU    Optional (input) INTEGER.
!          The indices of the smallest and largest eigenvalues to be
! 	   returned. The IL-th through IU-th eigenvalues will be found.
! 	   1 <= IL <= IU <= n.
!          Default values: IL = 1 and IU = n.
!          Note: Neither IL nor IU may be present if VL and/or VU is 
! 	   present.
!          Note: All eigenvalues are calculated if none of the arguments
! 	   VL, VU, IL and IU are present.
! M        Optional (output) INTEGER.
!          The total number of eigenvalues found. 0 <= M <= n.
!          Note: If IL and IU are present then M = IU - IL + 1.
! IFAIL    Optional (output) INTEGER array, shape (:) with 
!          size(IFAIL) = n.
!          If INFO = 0, the first M elements of IFAIL are zero.
!          If INFO > 0, then IFAIL contains the indices of the 
! 	   eigenvectors that failed to converge.
!          Note: If Z is present then IFAIL should also be present.
! ABSTOL   Optional (input) REAL.
!          The absolute error tolerance for the eigenvalues. An 
!          approximate eigenvalue is accepted as converged when it is
!          determined to lie in an interval [a,b] of width less than or
!          equal to ABSTOL + EPSILON(1.0_<wp>) * max(|a|,|b|),
!          where <wp> is the working precision. If ABSTOL <= 0, then
! 	   EPSILON(1.0_<wp>) * ||A||1 will be used in its place. 
! 	   Eigenvalues will be computed most accurately when ABSTOL is
! 	   set to twice the underflow threshold 
! 	   2 * LA_LAMCH(1.0_<wp>, 'Safe minimum'), not zero.
!          Default value: 0.0_<wp>.
!          Note: If this routine returns with INFO > 0, then some 
! 	   eigenvectors did not converge. Try setting ABSTOL to 
! 	   2 * LA_LAMCH(1.0_<wp>, 'Safe minimum').
! INFO     Optional (output) INTEGER
!          = 0: successful exit.
!          < 0: if INFO = -i, the i-th argument had an illegal value.
!          > 0: if INFO = i, then i eigenvectors failed to converge.
! 	      Their indices are stored in array IFAIL.
!          If INFO is not present and an error occurs, then the program
! 	   is terminated with an error message.
!----------------------------------------------------------------------
SUBROUTINE SSTEVX_F95( D, E, W, Z, VL, VU, IL, IU, M, &
                            IFAIL, ABSTOL, INFO )
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO
   USE F77_LAPACK, ONLY: STEVX_F77 => LA_STEVX, LAMCH_F77 => SLAMCH
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(IN), OPTIONAL :: IL, IU
   INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
   REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
!  .. ARRAY ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
   REAL(WP), INTENT(INOUT) :: D(:), E(:)
   REAL(WP), INTENT(OUT) :: W(:)
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_STEVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBZ, LRANGE
   INTEGER :: N, LD, LIL, LIU, LM, SIFAIL, S1Z, S2Z
   INTEGER :: LINFO, ISTAT
   INTEGER, TARGET :: ISTAT1(1)
   REAL(WP), TARGET :: LLZ(1,1)
   REAL(WP) :: LABSTOL, LVL, LVU
!  .. LOCAL ARRAYS ..
   INTEGER, POINTER :: IWORK(:), LIFAIL(:)
   REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC HUGE, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(D); LD = MAX(1,N)
   IF( PRESENT(M)) M = 0 
   IF( PRESENT(IFAIL) )THEN; SIFAIL = SIZE(IFAIL); ELSE; SIFAIL = N; END IF
   IF( PRESENT(VL) )THEN; LVL = VL; ELSE; LVL = -HUGE(LVL); ENDIF
   IF( PRESENT(VU) )THEN; LVU = VU; ELSE; LVU = HUGE(LVU); ENDIF
   IF( PRESENT(IL) )THEN; LIL = IL; ELSE; LIL = 1; ENDIF
   IF( PRESENT(IU) )THEN; LIU = IU; ELSE; LIU = N; ENDIF
   IF( PRESENT(Z) )THEN; S1Z = SIZE(Z,1); S2Z = SIZE(Z,2)
   ELSE; S1Z = 1; S2Z = 1; ENDIF
!  .. TEST THE ARGUMENTS
   IF( N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE( E ) /= N .AND. N > 0 )THEN; LINFO = -2
   ELSE IF( SIZE( W ) /= N )THEN; LINFO = -3
   ELSE IF( PRESENT(Z) .AND. ( S1Z /= LD .OR. S2Z /= N ) )THEN; LINFO = -4
   ELSE IF( LVU < LVL )THEN; LINFO = -5
   ELSE IF( (PRESENT(VL) .OR. PRESENT(VU)) .AND. &
     &         (PRESENT(IL) .OR. PRESENT(IU)) )THEN; LINFO = -6
   ELSE IF(( LIU < LIL .OR. LIL < 1) .AND. N>0 )THEN; LINFO = -7
   ELSE IF( N < LIU )THEN; LINFO = -8
   ELSE IF( SIFAIL /= N .OR. PRESENT(IFAIL).AND..NOT.PRESENT(Z) )THEN; LINFO = -10
   ELSE IF( N > 0 )THEN
      IF( PRESENT(VL) .OR. PRESENT(VU) )THEN; LRANGE = 'V'; LM = N
      ELSE IF( PRESENT(IL) .OR. PRESENT(IU) )THEN; LRANGE = 'I'; LM = LIU-LIL+1
      ELSE; LRANGE = 'A'; LM = N; END IF
      IF( PRESENT(Z) ) THEN; LJOBZ = 'V'
         IF( PRESENT(IFAIL) )THEN; LIFAIL => IFAIL
         ELSE; ALLOCATE( LIFAIL(N), STAT=ISTAT ); END IF
      ELSE; LJOBZ = 'N'
      LIFAIL => ISTAT1; ENDIF
!     .. DETERMINE THE WORKSPACE
      IF( ISTAT == 0 ) THEN
         ALLOCATE(IWORK(5*N), WORK(5*N), STAT=ISTAT)
         IF( ISTAT == 0 )THEN
            IF( PRESENT(ABSTOL) )THEN; LABSTOL = ABSTOL
            ELSE; LABSTOL = 2*LAMCH_F77('Safe minimum'); ENDIF
	    IF (PRESENT(Z)) THEN
               CALL STEVX_F77( LJOBZ, LRANGE, N, D, E, LVL, LVU, LIL, LIU, &
                            LABSTOL, LM, W, Z, S1Z, WORK, IWORK, LIFAIL, LINFO )
	    ELSE
	       CALL STEVX_F77( LJOBZ, LRANGE, N, D, E, LVL, LVU, LIL, LIU, &
                            LABSTOL, LM, W, LLZ, S1Z, WORK, IWORK, LIFAIL, LINFO )
	    ENDIF		    
            IF( PRESENT(M) ) M = LM
            W(LM+1:N) = 0.0_WP
         ELSE; LINFO = -100; END IF
      END IF
      IF( PRESENT(Z) .AND. .NOT.PRESENT(IFAIL) ) DEALLOCATE( LIFAIL, STAT=ISTAT1(1) )
      DEALLOCATE(IWORK, WORK, STAT=ISTAT1(1))
   END IF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE SSTEVX_F95

      SUBROUTINE ERINFO(LINFO, SRNAME, INFO, ISTAT)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. IMPLICIT STATEMENT ..
         IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
         CHARACTER( LEN = * ), INTENT(IN)              :: SRNAME
         INTEGER             , INTENT(IN)              :: LINFO
         INTEGER             , INTENT(OUT), OPTIONAL   :: INFO
         INTEGER             , INTENT(IN), OPTIONAL    :: ISTAT
!  .. EXECUTABLE STATEMENTS ..
!         IF( ( LINFO < 0 .AND. LINFO > -200 ) .OR.                     &
!    &       ( LINFO > 0 .AND. .NOT.PRESENT(INFO) ) )THEN
      IF( ( ( LINFO < 0 .AND. LINFO > -200 ) .OR. LINFO > 0 )           &
     &           .AND. .NOT.PRESENT(INFO) )THEN
        WRITE (*,*) 'Program terminated in LAPACK95 subroutine ',SRNAME
        WRITE (*,*) 'Error indicator, INFO = ',LINFO
        IF( PRESENT(ISTAT) )THEN
          IF( ISTAT /= 0 ) THEN
            IF( LINFO == -100 )THEN
              WRITE (*,*) 'The statement ALLOCATE causes STATUS = ',    &
     &                    ISTAT
            ELSE
              WRITE (*,*) 'LINFO = ', LINFO, ' not expected'
            END IF
          END IF   
        END IF
        STOP
         ELSE IF( LINFO <= -200 ) THEN
           WRITE(*,*) '++++++++++++++++++++++++++++++++++++++++++++++++'
           WRITE(*,*) '*** WARNING, INFO = ', LINFO, ' WARNING ***'
           IF( LINFO == -200 )THEN
             WRITE(*,*)                                                 &
     &        'Could not allocate sufficient workspace for the optimum'
             WRITE(*,*)                                                 &
     &        'blocksize, hence the routine may not have performed as'
             WRITE(*,*) 'efficiently as possible'
         ELSE
           WRITE(*,*) 'Unexpected warning'
         END IF
           WRITE(*,*) '++++++++++++++++++++++++++++++++++++++++++++++++'
        END IF
        IF( PRESENT(INFO) ) THEN
          INFO = LINFO
        END IF
      END SUBROUTINE ERINFO

      SUBROUTINE CERRGE( PATH, NUNIT )
*
*  -- LAPACK test routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  CERRGE tests the error exits for the COMPLEX routines
*  for general matrices.
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX
      PARAMETER          ( NMAX = 4 )
*     ..
*     .. Local Scalars ..
      CHARACTER*2        C2
      INTEGER            I, INFO, J, NRHS, LW
      REAL               ANRM, CCOND, RCOND
*     ..
*     .. Local Arrays ..
      INTEGER            IP( NMAX ), IN(100)
      REAL               R( NMAX ), R1( NMAX ), R2( NMAX ), IW(NMAX)
      COMPLEX            A( NMAX, NMAX ), AF( NMAX, NMAX ), B( NMAX ),
     $                   W( 2*NMAX ), X( NMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAMEN
      EXTERNAL           LSAMEN
*     ..
*     .. External Subroutines ..
      EXTERNAL ALAESM, CGBCON, CGBEQU, CGBRFS, CGBTF2, CGBTRF, CGBTRS,
     $         LA_TEST_CGECON, LA_TEST_CGEEQU, LA_TEST_CGERFS, CGETF2,
     $         LA_TEST_CGETRF, LA_TEST_CGETRI, LA_TEST_CGETRS, CHKXER
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CMPLX, REAL
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )
*
*     Set the variables to innocuous values.
*
      DO 20 J = 1, NMAX
         DO 10 I = 1, NMAX
            A( I, J ) = CMPLX( 1. / REAL( I+J ), -1. / REAL( I+J ) )
            AF( I, J ) = CMPLX( 1. / REAL( I+J ), -1. / REAL( I+J ) )
   10    CONTINUE
         B( J ) = 0.
         R1( J ) = 0.
         R2( J ) = 0.
         W( J ) = 0.
         X( J ) = 0.
         IP( J ) = J
   20 CONTINUE
      OK = .TRUE.
*
*     Test error exits of the routines that use the LU decomposition
*     of a general matrix.
*
      IF( LSAMEN( 2, C2, 'GE' ) ) THEN
*
*        CGETRF
*
         SRNAMT = 'CGETRF'
         INFOT = 2
         INFO = 201
         CALL LA_TEST_CGETRF( NMAX, NMAX, A, NMAX, IP, INFO )
         CALL CHKXER( 'SGETRF', INFOT, NOUT, LERR, OK )
*
*        CGETF2
*
         SRNAMT = 'CGETF2'
         INFOT = 1
         CALL CGETF2( -1, 0, A, 1, IP, INFO )
         CALL CHKXER( 'CGETF2', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CGETF2( 0, -1, A, 1, IP, INFO )
         CALL CHKXER( 'CGETF2', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CGETF2( 2, 1, A, 1, IP, INFO )
         CALL CHKXER( 'CGETF2', INFOT, NOUT, LERR, OK )
*
*        CGETRI
*
         SRNAMT = 'CGETRI'
         DO I = 1, 2
            IN(I) = 1
         END DO
         DO I = 1, 2
            INFOT = I
            DO J = 1, IN(I)
               INFO = J + 100*I
               CALL LA_TEST_CGETRI( NMAX, A, NMAX, IP, W, LW, INFO )
               CALL CHKXER( 'CGETRI', INFOT, NOUT, LERR, OK )
            END DO
         END DO
*
*        CGETRS
*
         SRNAMT = 'CGETRS'
         DO I = 1, 4
            IN(I) = 1
         END DO
         DO I = 1, 4
            INFOT = I
            DO J = 1, IN(I)
               DO NRHS = 1, 2
                  INFO = J + 100*I
                  CALL LA_TEST_CGETRS( 'N', NMAX, NRHS, A, NMAX,
     $                 IP, B, NMAX, INFO )
                  CALL CHKXER( 'CGETRS', INFOT, NOUT, LERR, OK )
               END DO
            END DO
         END DO
*
*        CGERFS
*
         SRNAMT = 'CGERFS'
         DO I = 1, 8
            IN(I) = 1
         END DO
         IN(2) = 2
         IN(5) = 2
         DO I = 1, 8
            INFOT = I
            DO J = 1, IN(I)
               DO NRHS = 1, 2
                  INFO = J + 100*I
                  CALL LA_TEST_CGERFS( 'N', NMAX, NRHS, A, NMAX, AF,
     $                 NMAX, IP, B, NMAX, X, NMAX, R1, R2, W, IW, INFO )
                  CALL CHKXER( 'CGERFS', INFOT, NOUT, LERR, OK )
               END DO
            END DO
         END DO
*
*        CGECON
*
         SRNAMT = 'CGECON'
         DO I = 1, 4
            IN(I) = 1
         END DO
         IN(4) = 2
         DO I = 1, 4
            IF( I.NE.3 ) THEN
               INFOT = I
               DO J = 1, IN(I)
                  INFO = J + 100*I
                  CALL LA_TEST_CGECON( 'I', NMAX, A, NMAX, ANRM, RCOND,
     $                 W, IW, INFO )
                  CALL CHKXER( 'CGECON ', INFOT, NOUT, LERR, OK )
               END DO
            END IF
         END DO
*
*        CGEEQU
*
         SRNAMT = 'CGEEQU'
         DO I = 2, 3
            IN(I) = 1
         END DO
         DO I = 2, 3
            INFOT = I
            DO J = 1, IN(I)
               INFO = J + 100*I
               CALL LA_TEST_CGEEQU( NMAX, NMAX+1, A, NMAX, R1, R2,
     $              RCOND, CCOND, ANRM, INFO )
               CALL CHKXER( 'CGEEQU', INFOT, NOUT, LERR, OK )
            END DO
         END DO
*
*     Test error exits of the routines that use the LU decomposition
*     of a general band matrix.
*
      ELSE IF( LSAMEN( 2, C2, 'GB' ) ) THEN
*
*        CGBTRF
*
         SRNAMT = 'CGBTRF'
         INFOT = 1
         CALL CGBTRF( -1, 0, 0, 0, A, 1, IP, INFO )
         CALL CHKXER( 'CGBTRF', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CGBTRF( 0, -1, 0, 0, A, 1, IP, INFO )
         CALL CHKXER( 'CGBTRF', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CGBTRF( 1, 1, -1, 0, A, 1, IP, INFO )
         CALL CHKXER( 'CGBTRF', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CGBTRF( 1, 1, 0, -1, A, 1, IP, INFO )
         CALL CHKXER( 'CGBTRF', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CGBTRF( 2, 2, 1, 1, A, 3, IP, INFO )
         CALL CHKXER( 'CGBTRF', INFOT, NOUT, LERR, OK )
*
*        CGBTF2
*
         SRNAMT = 'CGBTF2'
         INFOT = 1
         CALL CGBTF2( -1, 0, 0, 0, A, 1, IP, INFO )
         CALL CHKXER( 'CGBTF2', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CGBTF2( 0, -1, 0, 0, A, 1, IP, INFO )
         CALL CHKXER( 'CGBTF2', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CGBTF2( 1, 1, -1, 0, A, 1, IP, INFO )
         CALL CHKXER( 'CGBTF2', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CGBTF2( 1, 1, 0, -1, A, 1, IP, INFO )
         CALL CHKXER( 'CGBTF2', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CGBTF2( 2, 2, 1, 1, A, 3, IP, INFO )
         CALL CHKXER( 'CGBTF2', INFOT, NOUT, LERR, OK )
*
*        CGBTRS
*
         SRNAMT = 'CGBTRS'
         INFOT = 1
         CALL CGBTRS( '/', 0, 0, 0, 1, A, 1, IP, B, 1, INFO )
         CALL CHKXER( 'CGBTRS', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CGBTRS( 'N', -1, 0, 0, 1, A, 1, IP, B, 1, INFO )
         CALL CHKXER( 'CGBTRS', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CGBTRS( 'N', 1, -1, 0, 1, A, 1, IP, B, 1, INFO )
         CALL CHKXER( 'CGBTRS', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CGBTRS( 'N', 1, 0, -1, 1, A, 1, IP, B, 1, INFO )
         CALL CHKXER( 'CGBTRS', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CGBTRS( 'N', 1, 0, 0, -1, A, 1, IP, B, 1, INFO )
         CALL CHKXER( 'CGBTRS', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL CGBTRS( 'N', 2, 1, 1, 1, A, 3, IP, B, 2, INFO )
         CALL CHKXER( 'CGBTRS', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL CGBTRS( 'N', 2, 0, 0, 1, A, 1, IP, B, 1, INFO )
         CALL CHKXER( 'CGBTRS', INFOT, NOUT, LERR, OK )
*
*        CGBRFS
*
         SRNAMT = 'CGBRFS'
         INFOT = 1
         CALL CGBRFS( '/', 0, 0, 0, 0, A, 1, AF, 1, IP, B, 1, X, 1, R1,
     $                R2, W, R, INFO )
         CALL CHKXER( 'CGBRFS', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CGBRFS( 'N', -1, 0, 0, 0, A, 1, AF, 1, IP, B, 1, X, 1, R1,
     $                R2, W, R, INFO )
         CALL CHKXER( 'CGBRFS', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CGBRFS( 'N', 1, -1, 0, 0, A, 1, AF, 1, IP, B, 1, X, 1, R1,
     $                R2, W, R, INFO )
         CALL CHKXER( 'CGBRFS', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CGBRFS( 'N', 1, 0, -1, 0, A, 1, AF, 1, IP, B, 1, X, 1, R1,
     $                R2, W, R, INFO )
         CALL CHKXER( 'CGBRFS', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL CGBRFS( 'N', 1, 0, 0, -1, A, 1, AF, 1, IP, B, 1, X, 1, R1,
     $                R2, W, R, INFO )
         CALL CHKXER( 'CGBRFS', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL CGBRFS( 'N', 2, 1, 1, 1, A, 2, AF, 4, IP, B, 2, X, 2, R1,
     $                R2, W, R, INFO )
         CALL CHKXER( 'CGBRFS', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL CGBRFS( 'N', 2, 1, 1, 1, A, 3, AF, 3, IP, B, 2, X, 2, R1,
     $                R2, W, R, INFO )
         CALL CHKXER( 'CGBRFS', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL CGBRFS( 'N', 2, 0, 0, 1, A, 1, AF, 1, IP, B, 1, X, 2, R1,
     $                R2, W, R, INFO )
         CALL CHKXER( 'CGBRFS', INFOT, NOUT, LERR, OK )
         INFOT = 14
         CALL CGBRFS( 'N', 2, 0, 0, 1, A, 1, AF, 1, IP, B, 2, X, 1, R1,
     $                R2, W, R, INFO )
         CALL CHKXER( 'CGBRFS', INFOT, NOUT, LERR, OK )
*
*        CGBCON
*
         SRNAMT = 'CGBCON'
         INFOT = 1
         CALL CGBCON( '/', 0, 0, 0, A, 1, IP, ANRM, RCOND, W, R, INFO )
         CALL CHKXER( 'CGBCON', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CGBCON( '1', -1, 0, 0, A, 1, IP, ANRM, RCOND, W, R, INFO )
         CALL CHKXER( 'CGBCON', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CGBCON( '1', 1, -1, 0, A, 1, IP, ANRM, RCOND, W, R, INFO )
         CALL CHKXER( 'CGBCON', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CGBCON( '1', 1, 0, -1, A, 1, IP, ANRM, RCOND, W, R, INFO )
         CALL CHKXER( 'CGBCON', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CGBCON( '1', 2, 1, 1, A, 3, IP, ANRM, RCOND, W, R, INFO )
         CALL CHKXER( 'CGBCON', INFOT, NOUT, LERR, OK )
*
*        CGBEQU
*
         SRNAMT = 'CGBEQU'
         INFOT = 1
         CALL CGBEQU( -1, 0, 0, 0, A, 1, R1, R2, RCOND, CCOND, ANRM,
     $                INFO )
         CALL CHKXER( 'CGBEQU', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL CGBEQU( 0, -1, 0, 0, A, 1, R1, R2, RCOND, CCOND, ANRM,
     $                INFO )
         CALL CHKXER( 'CGBEQU', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL CGBEQU( 1, 1, -1, 0, A, 1, R1, R2, RCOND, CCOND, ANRM,
     $                INFO )
         CALL CHKXER( 'CGBEQU', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL CGBEQU( 1, 1, 0, -1, A, 1, R1, R2, RCOND, CCOND, ANRM,
     $                INFO )
         CALL CHKXER( 'CGBEQU', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL CGBEQU( 2, 2, 1, 1, A, 2, R1, R2, RCOND, CCOND, ANRM,
     $                INFO )
         CALL CHKXER( 'CGBEQU', INFOT, NOUT, LERR, OK )
      END IF
*
*     Print a summary line.
*
      CALL ALAESM( PATH, OK, NOUT )
*
      RETURN
*
*     End of CERRGE
*
      END

SUBROUTINE LA_TEST_ZSPSV( UPLO, N, NRHS, AP, IPIV, B, LDB, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     April 13, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_SPSV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, NRHS, LDB
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: UPLO  
!  .. Array Arguments ..
   INTEGER, INTENT(OUT) :: IPIV(1:N)
   COMPLEX(WP), INTENT(INOUT) :: AP(1:N*(N+1)/2), B(1:LDB,1:NRHS)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SPSV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZSPSV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IAP, IB1, IB2, IIPIV
   CHARACTER*1 :: IUPLO   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IAP= N*(N+1)/2; IB1 = N; IB2 = NRHS; IUPLO= UPLO; IIPIV=N
   I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
   CASE(0)
      IF ( NRHS == 1 ) THEN
        CALL LA_SPSV( AP(1:IAP), B(1:IB1,1), IUPLO, &
     &    IPIV(1:IIPIV), INFO )
        INFO = INFOTC
      ELSE
        CALL LA_SPSV( AP(1:IAP), B(1:IB1,1:IB2), IUPLO, &
     &    IPIV(1:IIPIV), INFO)
        INFO = INFOTC
      END IF
   CASE (1)
      IAP = IAP - 1
   CASE (2)
      IB1 = IB1 - 1
   CASE (3)
      IUPLO = 'T'
   CASE (4)
      IIPIV = IB1 - 1
   CASE(:-1,5:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF( I /= 0 ) THEN
        SELECT CASE (NRHS)
          CASE (2:)
            CALL LA_SPSV( AP(1:IAP), B(1:IB1,1:IB2), IUPLO, &
     &                    IPIV(1:IIPIV), INFO )
          CASE(1)
            CALL LA_SPSV( AP(1:IAP), B(1:IB1,1), IUPLO, &
     &                 IPIV(1: IIPIV), INFO )
          CASE(:-1)
            CALL UESTOP(SRNAMT)
        END SELECT
     END IF
    CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_ZSPSV
      

PROGRAM LA_DGGGLM_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GGGLM
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.2))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER  :: I, INFO, M, N, P
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:), DD(:)
   REAL(WP), ALLOCATABLE :: A(:, :), B(:,:), D(:), X(:), Y(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MATMUL
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'DGGGLM Example Program Results'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) M, N, P
   PRINT *, 'M = ', M, ' N = ', N, ' P = ', P
   ALLOCATE ( A(N,M), AA(N,M), B(N,P), BB(N,P), D(N), DD(N), X(M), Y(P) )
   READ (NIN,*) AA, BB, DD
   A = AA; B=BB; D = DD
   WRITE(NOUT,*) 'The matrix A'
   DO I = 1, N; WRITE (NOUT,FMT) A(I,:); ENDDO
   WRITE(NOUT,*) 'The RHS matrix B:'
   DO I = 1, N; WRITE (NOUT,FMT) B(I,:); ENDDO
   WRITE(NOUT,*) 'The vector D:'; WRITE (NOUT,FMT) D
!
   WRITE ( NOUT, * )'--------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_DGGGLM LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGGLM (A, B, D, X, Y)'
   A = AA; B=BB; D = DD
   CALL LA_GGGLM (A, B, D, X, Y)
   WRITE(NOUT,*)' MATMUL(AA, X) + MATMUL(BB, Y), X, Y'
   WRITE (NOUT,FMT) MATMUL( AA, X ) + MATMUL( BB, Y )
   WRITE(NOUT,FMT) X; WRITE(NOUT,FMT) Y
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGGLM (A, B, D, X, Y, INFO)'
   A = AA; B=BB; D = DD
   CALL LA_GGGLM (A, B, D, X, Y, INFO)
   WRITE(NOUT,*)'INFO = ', INFO, ' MATMUL(AA, X) + MATMUL(BB, Y), X, Y'
   WRITE (NOUT,FMT) MATMUL( AA, X ) + MATMUL( BB, Y )
   WRITE(NOUT,FMT) X; WRITE(NOUT,FMT) Y
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGGLM (A(:,1:M-1), B, D, X, Y, INFO)'
   A = AA; B=BB; D = DD
   CALL LA_GGGLM (A(:,1:M-1), B, D, X, Y, INFO)
   WRITE(NOUT,*)'INFO = ', INFO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGGLM (A, B(1:1,:), D, X, Y, INFO)'
   A = AA; B=BB; D = DD
   CALL LA_GGGLM (A, B(1:1,:), D, X, Y, INFO)
   WRITE(NOUT,*)'INFO = ', INFO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGGLM (A, B, D(1:1), X, Y, INFO)'
   A = AA; B=BB; D = DD
   CALL LA_GGGLM (A, B, D(1:1), X, Y, INFO)
   WRITE(NOUT,*)'INFO = ', INFO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGGLM (A, B, D, X(1:1), Y, INFO)'
   A = AA; B=BB; D = DD
   CALL LA_GGGLM (A, B, D, X(1:1), Y, INFO)
   WRITE(NOUT,*)'INFO = ', INFO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGGLM (A, B, D, X, Y(1:1))'
   A = AA; B=BB; D = DD
   CALL LA_GGGLM (A, B, D, X, Y(1:1))
   WRITE(NOUT,*)'INFO = ', INFO
!
END!PROGRAM LA_DGGGLM_EXAMPLE

SUBROUTINE DGERFS_F95(A, AF, IPIV, B, X, TRANS, FERR, BERR, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: GERFS_F77 => LA_GERFS
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   INTEGER, INTENT(IN), TARGET :: IPIV(:)
   REAL(WP), INTENT(IN) :: A(:,:), AF(:,:), B(:,:)
   REAL(WP), INTENT(INOUT) :: X(:,:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: FERR(:), BERR(:)
!-----------------------------------------------------------------
!
! Purpose
! =======
!
! LA_GERFS improves the computed solution X of a system of linear 
! equations   A X = B  or  A^T X = B
! and provides error bounds and backward error estimates for
! the solution. LA_GERFS uses the LU factors computed by LA_GETRF.
!
! Arguments
! =========
! SUBROUTINE LA_GERFS (A, AF, IPIV, B, X, TRANS, FERR, BERR, INFO)
!    <type>(<wp>), INTENT(IN)  :: A(:,:), AF(:,:), <rhs>
!    INTEGER, INTENT(IN) :: IPIV(:)
!    <type>(<wp>), INTENT(INOUT) :: <sol>
!    REAL(<wp>), INTENT(OUT), OPTIONAL :: <err>
!    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
!    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!    where
!    <type> ::= REAL | COMPLEX
!    <wp>   ::= KIND(1.0) | KIND(1.0D0)
!    <rhs>  ::= B(:,:) | B(:)
!    <sol>  ::= X(:,:) | X(:)
!    <err>  ::= FERR(:), BERR(:) | FERR, BERR
!
! =====================
!
! A     (input) either REAL or COMPLEX square array,
!       shape (:,:), size(A,1) == size(A,2).
!       The original matrix A.
!
! AF    (input) either REAL or COMPLEX square array,
!       shape (:,:), size(AF,1) == size(AF,2) == size(A,1).
!       The factors L and U from the factorization A = PLU
!       as computed by LA_GETRF.
!
! IPIV  (input) INTEGER array, shape (:), size(IPIV) == size(A,1).
!       The pivot indices from LA_GETRF; for 1<=i<=size(A,1), row i
!       of the matrix was interchanged with row IPIV(i).
!
! B     (input) either REAL or COMPLEX rectangular array,
!       shape either (:,:) or (:), size(B,1) or size(B) == size(A,1).
!       The right hand side vector(s) of matrix B for
!       the system of equations AX = B.
!
! X     (input/output) either REAL or COMPLEX rectangular array,
!       shape either (:,:) or (:), size(X,1) or size(X) == size(A,1).
!       On entry, the solution matrix X, as computed by LA_GETRS.
!       On exit, the improved solution matrix X.
!
! TRANS Optional (input) CHARACTER*1
!       If TRANS is present, it specifies the form of the system 
!       of equations:
!          = 'N':  A X = B    (No transpose)
!          = 'T':  A^T X = B  (Transpose)
!          = 'C':  A^H X = B  (Conjugate transpose = Transpose)
!       otherwise TRANS = 'N' is assumed.
!
! FERR  Optional (output) either REAL array of shape (:) or REAL
!       scalar. If it is an array, size(FERR) == size(X,2).
!       The estimated forward error bound for each solution vector
!       X(j) (the j-th column of the solution matrix X).
!       If XTRUE is the true solution corresponding to X(j), FERR(j)
!       is an estimated upper bound for the magnitude of the largest
!       element in (X(j) - XTRUE) divided by the magnitude of the
!       largest element in X(j).  The estimate is as reliable as
!       the estimate for RCOND, and is almost always a slight
!       overestimate of the true error.
!
! BERR  Optional (output) either REAL array of shape (:) or REAL
!       scalar. If it is an array, size(BERR) == size(X,2).
!       The componentwise relative backward error of each solution
!       vector X(j) (i.e., the smallest relative change in
!       any element of A or B that makes X(j) an exact solution).
!
! INFO  Optional (output) INTEGER.
!       If INFO is present
!          = 0: successful exit
!          < 0: if INFO = -k, the k-th argument had an illegal value
!       If INFO is not present and an error occurs, then the program is
!          terminated with an error message.
!
! Internal Parameters
! ===================
!
! ITMAX is the maximum number of steps of iterative refinement.
! It is set to 5 in the LAPACK77 subroutines
! -----------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GERFS'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LTRANS
   INTEGER :: LINFO, NRHS, N, ISTAT, ISTAT1, SFERR, SBERR
!  .. LOCAL ARRAYS, POINTERS ..
   INTEGER, POINTER :: IWORK(:)
   REAL(WP), POINTER :: LFERR(:), LBERR(:)
   REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE, MAX
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(A, 1); NRHS = SIZE(B, 2)
   IF( PRESENT(FERR) )THEN; SFERR = SIZE(FERR); ELSE; SFERR = NRHS; END IF
   IF( PRESENT(BERR) )THEN; SBERR = SIZE(BERR); ELSE; SBERR = NRHS; END IF
   IF(PRESENT(TRANS))THEN; LTRANS = TRANS; ELSE; LTRANS='N'
   END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE(A, 2) /= N .OR. N < 0 )THEN; LINFO = -1
   ELSE IF( SIZE(AF, 1) /= N .OR. SIZE(AF, 2) /= N )THEN; LINFO = -2
   ELSE IF ( SIZE( IPIV ) /= N ) THEN; LINFO = -3
   ELSE IF ( SIZE(B, 1) /= N ) THEN; LINFO = -4
   ELSE IF ( SIZE(X, 1) /= N .OR. SIZE(X, 2) /= NRHS ) THEN; LINFO = -5
   ELSE IF( .NOT.( LSAME(LTRANS,'N') .OR.  LSAME(LTRANS,'T') .OR. &
                  LSAME(LTRANS,'C') ) )THEN; LINFO = -6
   ELSE IF( SFERR /= NRHS )THEN; LINFO = -7
   ELSE IF( SBERR /= NRHS )THEN; LINFO = -8
   ELSE IF ( N > 0 ) THEN
      IF( .NOT.PRESENT(FERR) ) THEN
         ALLOCATE( LFERR(NRHS), STAT=ISTAT )
      ELSE; LFERR => FERR; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(BERR) ) THEN
            ALLOCATE( LBERR(NRHS), STAT=ISTAT )
         ELSE; LBERR => BERR; END IF
      END IF
      IF( ISTAT == 0 )THEN; ALLOCATE( WORK(3*N), IWORK(N), STAT=ISTAT ); END IF
      IF( ISTAT == 0 )THEN
!        .. CALL LAPACK77 ROUTINE
         CALL GERFS_F77( LTRANS, N, NRHS, A, MAX(1,N), AF, MAX(1,N), &
                         IPIV, B, MAX(1,N), X, MAX(1,N), LFERR, &
                         LBERR, WORK, IWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(FERR) ) DEALLOCATE( LFERR, STAT=ISTAT1 )
      IF( .NOT.PRESENT(BERR) ) DEALLOCATE( LBERR, STAT=ISTAT1 )
      DEALLOCATE(WORK, IWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE DGERFS_F95

      PROGRAM LA_SPBSV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_PBSV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Parameters" ..
      REAL(WP), PARAMETER :: ZERO = 0.0_WP, ONE = 1.0_WP
!  .. "Local Scalars" ..
      INTEGER :: KD, I, J, INFO, N, NRHS
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: AB(:,:), B(:,:)
      REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SPBSV Example Program Results.'
      N = 7; KD = 3; NRHS = 3
      WRITE(*,'(5H N = , I4, 9H; NRHS = , I4)') N, NRHS
      ALLOCATE ( AB(KD+1,N), AA(KD+1,N), B(N,NRHS), BB(N,NRHS) )
    
      OPEN(UNIT=21,FILE='pbsv.ma',STATUS='UNKNOWN')
      DO I=1,KD+1
         DO J=1,N
         READ(21,'(F3.0)') AB(I,J);
         ENDDO
      ENDDO
      CLOSE(21)

      B(:,1) = ZERO
      DO I = 1, N
         DO J = MAX(1,-N+I+KD+1), KD
         B(I,1) = AB(J,I-J+KD+1) + B(I,1)
         ENDDO
         DO J = MAX(1,KD+2-I), KD+1
         B(I,1) = AB(J,I) + B(I,1)
         ENDDO
      ENDDO
      
      DO J = 2, NRHS; B(:,J) = B(:,1)*J; ENDDO
      AA = AB; BB = B
       
      WRITE(*,*) 'AB on entry:'
      DO I = 1,KD+1;         
         WRITE (*,'(7(F8.5))') AB(I,:);
      ENDDO
       
      WRITE(*,*) 'The RHS matrix B:'
      DO J = 1, N; WRITE (*,*) B(J,:); 
      ENDDO

      CALL LA_PBSV(AB, B, INFO=INFO)
  
      WRITE(*,*)'AB on exit :'
      DO I=1,KD+1; WRITE(*,"(10(E12.6))") AB(I,:); 
      ENDDO     

      WRITE(*,*)'B on exit :'
      DO J=1,N; WRITE(*,"(10(F8.5))") B(J,:); 
      ENDDO

      WRITE(*,*)'INFO = ' ,INFO

      END PROGRAM LA_SPBSV_EXAMPLE

PROGRAM LA_ZPBSV_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_PBSV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: KD, I, J, K, INFO, N, NRHS
!  .. LOCAL ARRAYS ..
   COMPLEX(WP), ALLOCATABLE :: A(:,:), B(:,:)
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'ZPBSV ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, KD, NRHS
   PRINT *, 'N = ', N, ' KD = ', KD, ' NRHS = ', NRHS
   ALLOCATE ( A(KD+1,N), AA(KD+1,N), B(N,NRHS), BB(N,NRHS) )
!
      AA = HUGE(1.0_WP)
      DO I = 1, KD+1
        READ (NIN, *) (AA(I, J), J = KD-I+2, N)
      ENDDO
!     DO J = 1, NRHS
!        BB(:,J) = SUM( AA, DIM=2)*J
!     ENDDO
      B = 0.0_WP
      DO K = 1, NRHS
         DO I = 1, N
            DO J = MAX(1,-N+I+KD+1), KD
!              PRINT *, K, I, J, I-J+KD+1, AA(J,I-J+KD+1)
               BB(I,K) = AA(J,I-J+KD+1) + BB(I,K)
            ENDDO
            DO J = MAX(1,KD+2-I), KD+1
               BB(I,K) = AA(J,I) + BB(I,K)
!              PRINT *, K, I, J, AA(J,I)
            ENDDO
         ENDDO
         BB(:,K) = BB(:,K)*K
      ENDDO
   A=AA; B=BB
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, KD+1
        WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,1:N)
      ENDDO
      WRITE(NOUT,*) 'The RHS matrix B:'
      DO J = 1, NRHS
        WRITE (NOUT,*) 'RHS', J; WRITE (NOUT,FMT) B(:,J)
      ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_ZPBSV LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSV( A, B )'
   A=AA; B=BB
   IF (NRHS .GT. 1) THEN
      CALL LA_PBSV( A, B )
   ELSE
      CALL LA_PBSV( A, B(1:N,1) )
   END IF
   WRITE(NOUT,*)'   B - the solution vectors computed by LA_PBSV:'
   DO J = 1, NRHS
      WRITE (NOUT,FMT) B(:,J)
   END DO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PBSV( A, B, UPLO=''L'')'
   B=BB; A = HUGE(1.0_WP)
   DO I = 1, KD+1
      A(I,1:N-I+1) = AA(KD+2-I,I:N)
      WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,1:N)
   ENDDO
   CALL LA_PBSV( A, B, UPLO='L')
   WRITE(NOUT,*)'   B - the solution vectors computed by LA_PBSV:'
   DO J = 1, NRHS
      WRITE (NOUT,FMT) B(:,J)
   END DO
   A=AA; B=BB
   CALL LA_PBSV( A, B(1:N,1), INFO=INFO )
   WRITE(NOUT,*)'   B - the solution vectors computed by LA_PBSV, INFO = ', INFO
   WRITE (NOUT,FMT) B(1:N,1)
!
END PROGRAM LA_ZPBSV_ET_EXAMPLE

      PROGRAM LA_SPBSVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_PBSVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Parameters" ..
      CHARACTER(LEN=1) :: EQUED
!  .. "Local Scalars" ..
      INTEGER :: KD, I, J, INFO, N, NRHS
      REAL(WP) :: RCOND
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), X(:,:), S(:)
      REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:), FERR(:), BERR(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SPBSVX Example Program Results.'
      N = 7; KD = 3; NRHS = 3
      WRITE(*,'(5H N = , I4, 9H; NRHS = , I4)') N, NRHS
      ALLOCATE ( A(KD+1,N), AA(KD+1,N), B(N,NRHS), BB(N,NRHS) )
      ALLOCATE ( X(N,NRHS), S(N), FERR(NRHS), BERR(NRHS) )         
      
      OPEN(UNIT=21,FILE='pbsv.ma',STATUS='UNKNOWN')
      DO I=1,KD+1
         DO J=1,N
            READ(21,'(F3.0)') A(I,J);
         ENDDO
      ENDDO
      CLOSE(21)


      B(:,1) = 0.0
      DO I = 1, N
         DO J = MAX(1,-N+I+KD+1), KD
            B(I,1) = A(J,I-J+KD+1) + B(I,1)
         ENDDO
         DO J = MAX(1,KD+2-I), KD+1
            B(I,1) = A(J,I) + B(I,1)
         ENDDO
      ENDDO
      DO J = 2, NRHS; B(:,J) = B(:,1)*J; ENDDO
         AA = A; BB = B
   
      WRITE(*,*) 'AB on entry:'
      DO I = 1, KD+1; WRITE (*,'(7(F9.5))') A(I,:); ENDDO
          
      WRITE(*,*) 'The RHS matrix B:'
      DO J = 1, N; WRITE (*,'(3(F10.5))') B(J,:); ENDDO
      
      CALL LA_PBSVX(A, B, X, FACT='E', EQUED=EQUED, S=S, FERR=FERR, BERR=BERR, RCOND=RCOND, INFO=INFO)
  
      WRITE(*,*)'EQUED = ',EQUED
      WRITE(*,*)'S on exit :'
      DO I=1,N; WRITE(*,"(5(F8.5))") S(I); 
      ENDDO
      WRITE(*,*)'X on exit :'
      DO I=1,N; WRITE(*,"(5(F8.5))") X(I,:); 
      ENDDO
      WRITE(*,*)'FERR on exit :'
      DO I=1,NRHS; WRITE(*,"(5(E13.6))") FERR(I); 
      ENDDO
      WRITE(*,*)'BERR = '
      DO I=1,NRHS; WRITE(*,"(5(E13.6))") BERR(I); 
      ENDDO
      WRITE(*,*)'RCOND = ',RCOND
      
      WRITE(*,*)'INFO = ' ,INFO

      WRITE(*,*) '\noindent'
      WRITE(*,*) 'The solution of the system $ A\,X = B $ is:'
      WRITE(*,*) '$$ X = \left( \begin{array}{rrr}'
      DO I=1,N; WRITE(*,"(2(F9.5,' & '),F9.5,' \\')") X(I,:); ENDDO
      WRITE(*,*) '\end{array} \right). $$'

      END PROGRAM LA_SPBSVX_EXAMPLE

PROGRAM LA_SGGESX_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GGESX
!  .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
      INTERFACE
      LOGICAL FUNCTION SELECT(ALPHAR, ALPHAI, BETA)
      USE LA_PRECISION, ONLY: WP => SP
      REAL(WP), INTENT(IN) :: ALPHAR, ALPHAI, BETA
      END FUNCTION SELECT
      END INTERFACE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
      INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
      INTEGER :: I, INFO, N, SDIM
!  .. LOCAL ARRAYS ..
      REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:)
      REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), VSL(:,:), VSR(:,:), DUMMY(:,:)
      REAL(WP), ALLOCATABLE ::  ALPHAR(:), ALPHAI(:), BETA(:)
      REAL(WP) RCONDE(2), RCONDV(2)
!  .. EXECUTABLE STATEMENTS ..
      WRITE (NOUT,*) 'GGESX ET_Example Program Results.'
      READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
      READ ( NIN, * ) N
      PRINT *, 'N = ', N
      ALLOCATE ( A(N,N), B(N,N), AA(N,N), BB(N,N), VSL(N,N), VSR(N,N) )
      ALLOCATE (ALPHAI(N), ALPHAR(N), BETA(N))
!
      READ (NIN, *) AA
      A=AA
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,:); ENDDO
!
        WRITE ( NOUT, * )'---------------------------------------------------------'
        WRITE ( NOUT, * )
        WRITE ( NOUT, * )'Details of LA_SGGESX LAPACK Subroutine Results.'
        WRITE ( NOUT, * )
!
        WRITE(NOUT,*)
        WRITE(NOUT,*) 'CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR, SELECT, SDIM, RCONDE, RCONDV, INFO )'
        A=AA
        CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR, SELECT, SDIM, RCONDE, RCONDV, INFO )
        WRITE(NOUT,*) 'INFO = ', INFO, ' SDIM = ', SDIM, ' Eigenvalues:'
        WRITE(NOUT,FMT) ALPHAR
        WRITE(NOUT,FMT) ALPHAI
        WRITE(NOUT,*) 'Left Schur vectors:'
        DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VSL(:,I); END DO
          WRITE(NOUT,*) 'Right Schur vectors:'
          DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VSR(:,I); END DO
          WRITE(NOUT,*) 'RCONDE = :'; WRITE(NOUT,FMT) RCONDE
          WRITE(NOUT,*) 'RCONDV = :'; WRITE(NOUT,FMT) RCONDV
!
            WRITE(NOUT,*)
            WRITE(NOUT,*) 'CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR )'
            A=AA; VSL = HUGE(1.0_WP); VSR = HUGE(1.0_WP)
            CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR)
            WRITE(NOUT,*) 'INFO = ', INFO, ' Eigenvalues:'
            WRITE(NOUT,FMT)  ALPHAR 
            WRITE(NOUT,FMT)  ALPHAI
            WRITE(NOUT,*) 'Left Schur vectors:'
            DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VSL(:,I); END DO
              WRITE(NOUT,*) 'Right Schur vectors:'
              DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VSR(:,I); END DO        
!
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, SELECT=SELECT, SDIM=SDIM, INFO=INFO )'
                A=AA
                CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, SELECT=SELECT, SDIM=SDIM, INFO=INFO )
                WRITE(NOUT,*) 'INFO = ', INFO, ' SDIM = ', SDIM, ' Eigenvalues:'
                WRITE(NOUT,FMT) ALPHAR
                WRITE(NOUT,FMT) ALPHAI
!
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( A, B,  ALPHAR, ALPHAI, BETA )'
                A=AA
                CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA)
                WRITE(NOUT,*) 'INFO = ', INFO, ' Eigenvalues:'
                WRITE(NOUT,FMT) ALPHAR
                WRITE(NOUT,FMT) ALPHAI
! START THE ERROR TESTS 
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( DUMMY, B, ALPHAR, ALPHAI, BETA, SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, RCONDV=RCONDV,  INFO=INFO )'
                A=AA
                CALL LA_GGESX( DUMMY, B, ALPHAR, ALPHAI, BETA, SELECT=SELECT, SDIM=SDIM,  RCONDE=RCONDE, &
&                 RCONDV=RCONDV, INFO=INFO )
                WRITE(NOUT,*) 'INFO = ', INFO
!
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( A,B(1:N-1,:), ALPHAR, ALPHAI, BETA, SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO )'
                A=AA
                CALL LA_GGESX( A, B(1:N-1,:), ALPHAR, ALPHAI, BETA, SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO )
                WRITE(NOUT,*) 'INFO = ', INFO
!
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( A,B(:,1:N-1), ALPHAR, ALPHAI, BETA, SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO )'
                A=AA
                CALL LA_GGESX( A, B(:,1:N-1), ALPHAR, ALPHAI, BETA, SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO )
                WRITE(NOUT,*) 'INFO = ', INFO                
!
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( A, B, ALPHAR(1:N-1), ALPHAI, BETA, SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO )'
                A=AA
                CALL LA_GGESX( A, B, ALPHAR(1 :N-1), ALPHAI, BETA, SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO)
                WRITE(NOUT,*) 'INFO = ', INFO
!
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( A, B, ALPHAR, ALPHAI(1:N-1), BETA, SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, RCONDV=RCONDV,INFO=INFO )'
                A=AA
                CALL LA_GGESX( A, B, ALPHAR, ALPHAI(1:N-1), BETA, SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO)
                WRITE(NOUT,*) 'INFO = ', INFO
!
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA(1:N-1), SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO )'
                A=AA
                CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA(1:N-1), SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO)
                WRITE(NOUT,*) 'INFO = ', INFO                
!
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL(1:N-1,:), VSR, SELECT, &
&                 SDIM, RCONDE, RCONDV, INFO )'
                A=AA
                CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL(1:N-1,:), VSR, SELECT, &
&                 SDIM, RCONDE, RCONDV, INFO)
                WRITE(NOUT,*) 'INFO = ', INFO
!
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL(:,1:N-1), VSR, SELECT, SDIM, &
&                 RCONDE, RCONDV,  INFO )'
                A=AA
                CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL(:,1:N-1), VSR, SELECT, SDIM, &
&                 RCONDE, RCONDV, INFO)
                WRITE(NOUT,*) 'INFO = ', INFO                
!
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR(1:N-1,:), SELECT, SDIM, &
&                 RCONDE, RCONDV, INFO )'
                A=AA
                CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR(1:N-1,:), SELECT, SDIM, &
&                 RCONDE, RCONDV,  INFO)
                WRITE(NOUT,*) 'INFO = ', INFO
!
                WRITE(NOUT,*)
                WRITE(NOUT,*) 'CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR(:,1:N-1), SELECT, SDIM, &
&                 RCONDE, RCONDV,  INFO )'
                A=AA
                CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR(:,1:N-1), SELECT, SDIM, &
&                 RCONDE, RCONDV, INFO)
                WRITE(NOUT,*) 'INFO = ', INFO                
END PROGRAM LA_SGGESX_ET_EXAMPLE
                LOGICAL FUNCTION SELECT(ALPHAR, ALPHAI, BETA)
                USE LA_PRECISION, ONLY: WP => SP
                REAL(WP), INTENT(IN) :: ALPHAR, ALPHAI, BETA
                SELECT = .TRUE.     
              END FUNCTION SELECT
            

            

SUBROUTINE LA_TEST_DPOSV( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     April 5, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_POSV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, NRHS, LDA, LDB
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: UPLO  
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB,1:NRHS)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_POSV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DPOSV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, IB1, IB2
      CHARACTER*1 :: IUPLO   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IB1 = N; IB2 = NRHS; IUPLO= UPLO
   I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
   CASE(0)
      IF (NRHS == 1) THEN
        CALL LA_POSV( A(1:IA1,1:IA2), B(1:IB1,1), UPLO, INFO )
        INFO = INFOTC
      ELSE
        CALL LA_POSV( A(1:IA1,1:IA2), B(1:IB1,1:IB2), UPLO, INFO )
        INFO = INFOTC
      END IF
   CASE (1)
      IA2 = IA1 - 1
   CASE (2)
      IB1 = IA1 - 1
   CASE(3)
      IUPLO = 'T'
   CASE(:-1,4:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF( I /= 0 ) THEN
        SELECT CASE (NRHS)
          CASE (2:)
           CALL LA_POSV( A(1:IA1,1:IA2), B(1:IB1,1:IB2), IUPLO, INFO )
          CASE(1)
           CALL LA_POSV( A(1:IA1,1:IA2), B(1:IB1,1), IUPLO, INFO )
          CASE(:-1)
           CALL UESTOP(SRNAMT)
        END SELECT
     END IF
    CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_DPOSV
      

      SUBROUTINE CGESVX1_F95( A, B, X, AF, IPIV, FACT, TRANS, EQUED, R, C, FERR, BERR, RCOND,    &
                              RPVGRW, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!     .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => SP
      USE LA_AUXMOD, ONLY: LSAME, ERINFO
      USE F77_LAPACK, ONLY: GESVX_F77 => LA_GESVX
!     .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!     .. SCALAR ARGUMENTS ..
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
      CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
!     .. ARRAY ARGUMENTS ..
      COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
      COMPLEX(WP), INTENT(OUT) :: X(:)
      INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: IPIV(:)
      REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: C(:), R(:)
      COMPLEX(WP), INTENT(INOUT), OPTIONAL, TARGET :: AF(:,:)
      REAL(WP), INTENT(OUT), OPTIONAL :: FERR, BERR
!     .. PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GESVX'
!     .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: LFACT, LTRANS, LEQUED
      INTEGER :: ISTAT, ISTAT1, LD, LINFO, N, NRHS, S1AF, S2AF, SC, SIPIV, SR
      REAL(WP) :: LRCOND, MVR, MVC, LFERR, LBERR
!     .. LOCAL POINTERS ..
      INTEGER, POINTER :: LPIV(:)
      REAL(WP),  POINTER :: LC(:), LR(:), RWORK(:)
      COMPLEX(WP),  POINTER :: WORK(:), LAF(:, :)
!     .. INTRINSIC FUNCTIONS ..
      INTRINSIC MAX, PRESENT, SIZE, MINVAL, TINY
!     .. EXECUTABLE STATEMENTS ..
      LINFO = 0; ISTAT = 0; N = SIZE(A, 1); NRHS = 1; LD = MAX(1,N)
      IF( PRESENT(RCOND) ) RCOND = 1.0_WP
      IF( PRESENT(RPVGRW) ) RPVGRW = 1.0_WP
      IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
      IF( PRESENT(EQUED) .AND. LSAME(LFACT,'F') )THEN; LEQUED = EQUED
      ELSE; LEQUED='N'; END IF
      IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; END IF
      IF( PRESENT(AF) )THEN; S1AF = SIZE(AF,1); S2AF = SIZE(AF,2)
      ELSE; S1AF = N; S2AF = N; END IF
      IF( ( PRESENT(C) ) )THEN; SC = SIZE(C); ELSE; SC = N; END IF
      IF( ( PRESENT(C) .AND. LSAME(LFACT,'F') ) .AND.                   &
     &    ( LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') ) )THEN; MVC = MINVAL(C)
      ELSE; MVC = TINY(1.0_WP); END IF
      IF( PRESENT(R) )THEN
         SR = SIZE(R)
      ELSE
         SR = N
      END IF
      IF( ( PRESENT(R) .AND. LSAME(LFACT,'F') ) .AND.                   &
     &    ( LSAME(LEQUED,'R') .OR. LSAME(LEQUED,'B') ) )THEN
         MVR = MINVAL(R)
      ELSE
         MVR = TINY(1.0_WP)
      END IF
      IF(PRESENT(TRANS))THEN
         LTRANS = TRANS
      ELSE
         LTRANS='N'
      END IF
!     .. TEST THE ARGUMENTS
      IF( SIZE(A, 2) /= N .OR. N < 0 )THEN
         LINFO = -1
      ELSE IF( SIZE(B) /= N )THEN
         LINFO = -2
      ELSE IF( SIZE(X) /= N )THEN
         LINFO = -3
      ELSE IF( S1AF /= N .OR. S2AF /= N ) THEN
         LINFO = -4
      ELSE IF( SIPIV /= N )THEN
         LINFO = -5
      ELSE IF( SR /= N .OR. MVR <= 0.0_WP )THEN
         LINFO = -9
      ELSE IF( SC /= N .OR. MVC <= 0.0_WP )THEN
         LINFO = -10
      ELSE IF( ( .NOT. ( LSAME(LFACT,'F') .OR. LSAME(LFACT,'N') .OR.    &
     &                 LSAME(LFACT,'E') ) ) .OR.                        &
     &    ( LSAME(LFACT,'F') .AND. .NOT.( PRESENT(AF) .AND.             &
     &      PRESENT(IPIV) ) ) )THEN
         LINFO = -6
      ELSE IF( .NOT.( LSAME(LTRANS,'N') .OR.  LSAME(LTRANS,'T') .OR.    &
     &               LSAME(LTRANS,'C') ) )THEN
         LINFO = -7
      ELSE IF( ( .NOT.( LSAME(LEQUED,'N') .OR. LSAME(LEQUED,'R') .OR.   &
     &       LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') )                 &
     &           .AND. LSAME(LFACT,'F') ) .OR.                          &
     &      ( ( LSAME(LEQUED,'R') .OR. LSAME(LEQUED,'B') ) .AND.        &
     &           .NOT.PRESENT(R) ) .OR.                                 &
     &      ( ( LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') ) .AND.        &
     &           .NOT.PRESENT(C) ) )THEN
         LINFO = -8
      ELSE IF ( N > 0 )THEN
         IF( .NOT.PRESENT(AF) ) THEN
            ALLOCATE( LAF(LD,N), STAT=ISTAT )
         ELSE
            LAF => AF
         END IF
         IF( .NOT.PRESENT(IPIV) )THEN
            ALLOCATE( LPIV(N), STAT=ISTAT )
         ELSE
            LPIV => IPIV
         END IF
         IF( .NOT.PRESENT(R) )THEN
            ALLOCATE( LR(N), STAT=ISTAT )
         ELSE
            LR => R
         END IF
         IF( .NOT.PRESENT(C) )THEN
            ALLOCATE( LC(N), STAT=ISTAT )
         ELSE
            LC => C
         END IF
            ALLOCATE(WORK(2*N), RWORK(2*N), STAT=ISTAT )
         IF( ISTAT == 0 )THEN
!           .. CALL LAPACK77 ROUTINE
            CALL GESVX_F77( LFACT, LTRANS, N, NRHS, A, LD, LAF, LD, LPIV, LEQUED, LR, LC, B, LD, &
                            X, LD, LRCOND, LFERR, LBERR, WORK, RWORK, LINFO )
         ELSE
            LINFO = -100
         END IF
         IF( .NOT.PRESENT(R) ) DEALLOCATE( LR, STAT=ISTAT1 )
         IF( .NOT.PRESENT(C) ) DEALLOCATE( LC, STAT=ISTAT1 )
         IF( .NOT.PRESENT(AF) ) DEALLOCATE( LAF, STAT=ISTAT1 )
         IF( .NOT.PRESENT(IPIV) ) DEALLOCATE( LPIV, STAT=ISTAT1 )
         IF( PRESENT(FERR) ) FERR = LFERR
         IF( PRESENT(BERR) ) BERR = LBERR
         IF( PRESENT(EQUED) .AND. .NOT.LSAME(LFACT,'F') ) EQUED=LEQUED
         IF( PRESENT(RCOND) ) RCOND=LRCOND
         IF( PRESENT(RPVGRW) ) RPVGRW=RWORK(1)
         DEALLOCATE( WORK, RWORK, STAT=ISTAT1 )
      END IF
      CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
      END SUBROUTINE CGESVX1_F95

      PROGRAM LA_CGGEVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GGEVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N
      REAL :: ABNRM, BBNRM
!  .. "Local Arrays" ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
      CHARACTER(LEN=1) :: BALANC
      COMPLEX(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:), ALPHA(:)
      COMPLEX(WP), ALLOCATABLE :: BETA(:), LAMBDA(:)
      REAL(WP), ALLOCATABLE :: LSCALE(:), RSCALE(:), RCONDE(:), RCONDV(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GGEVX Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), B(N,N), BB(N,N), ALPHA(N), BETA(N), LSCALE(N), &
&       RSCALE(N), RCONDE(N), RCONDV(N), LAMBDA(N) )

      OPEN(UNIT=21,FILE='ggev.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=A
    
      WRITE(*,*)'Matrix A : '
      DO I=1,N 
         WRITE(*,"(5('('(I3,1X,',',I3)')',1X,1X))") INT(A(I,:)), INT(AIMAG(A(I,:)))
      ENDDO
    
      OPEN(UNIT=21,FILE='ggev.mb',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      BB=B
      WRITE(*,*)'Matrix B : '
      DO I=1,N 
         WRITE(*,"(5('('(I3,1X,',',I3)')',1X,1X))") INT(B(I,:)), INT(AIMAG(B(I,:)))
      ENDDO
      
      WRITE(*,*)
      WRITE(*,*) "CALL LA_GGEVX( A, B, BALANC='B', LSCALE=LSCALE, RSCALE=RSCALE,"
      WRITE(*,*)"ABNRM=ABNRM, BBNRM=BBNRM, RCONDE=RCONDE, RCONDV=RCONDV )"
      BALANC = 'B'
      CALL LA_GGEVX( A, B, ALPHA, BETA, BALANC=BALANC, LSCALE=LSCALE, RSCALE=RSCALE, ABNRM=ABNRM, &
           BBNRM=BBNRM, RCONDE=RCONDE, RCONDV=RCONDV )
   
      WRITE(*,*)
      WRITE(*,*)'LSCALE : '
      DO I=1,N
         WRITE(*,'(F9.5)') LSCALE(I)
      ENDDO
      WRITE(*,*)
      WRITE(*,*)'RSCALE : '
      DO I=1,N
         WRITE(*,'(F9.5)') RSCALE(I)
      ENDDO
      WRITE(*,*)
      WRITE(*,*)'ABNRM = ', ABNRM
      WRITE(*,*)
      WRITE(*,*)'BBNRM = ', BBNRM
      WRITE(*,*)
      WRITE(*,*)'RCONDE : '
      DO I=1,N
         WRITE(*,'(F9.5)') RCONDE(I)
      ENDDO
      WRITE(*,*)
      WRITE(*,*)'RCONDV : '
      DO I=1,N
         WRITE(*,'(F9.5)') RCONDV(I)
      ENDDO

      WRITE(*,*)'Matrix ALPHA : '
      WRITE(*,FMT) ALPHA
      
      WRITE(*,*)'Matrix BETA : '
      WRITE(*,FMT) BETA
      lambda = alpha/beta
      print *,'lambda = ', LAMBDA
      WRITE(*,FMT) LAMBDA
      END PROGRAM LA_CGGEVX_EXAMPLE

      PROGRAM LA_SSBGVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SBGVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, M, N, KD
      REAL(WP) :: VL, VU
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), W(:), Z(:,:), Q(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_SBGVX Example Program Results'
      N = 5; KD = 2;
      ALLOCATE( A(KD+1,N), B(KD+1,N), W(N), Z(N,N), Q(N,N) )

      OPEN(UNIT=21,FILE='sbgvu.ma',STATUS='UNKNOWN')
      DO I=1,KD+1 
         DO J=1,N
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix A : '
      DO I=1,KD+1; 
         WRITE(*,"(5(I3,1X))") INT(A(I,:)); 
      ENDDO
  
      OPEN(UNIT=21,FILE='sbgvu.mb',STATUS='UNKNOWN')
      DO I=1,KD+1 
         DO J=1,N
            READ(21,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix B : '
      DO I=1,KD+1; 
         WRITE(*,"(5(I3,1X))") INT(B(I,:)); 
      ENDDO
  
      WRITE(*,*)
      WRITE(*,*) 'CALL LA_SBGVX( A, B, W, Z=Z, VL=0.0_WP, VU=100.0_WP, M=M, Q=Q )'
      VL=0; VU=100
      CALL LA_SBGVX(  A, B, W, Z=Z, VL=0.0_WP, VU=100.0_WP, M=M, Q=Q )
  
      WRITE(*,*) ' W on exit : '
      DO I=1,N
      WRITE(*,"(5(E14.6,1X))") W(I)
      ENDDO

      WRITE(*,*) ' M = ',M
    
      WRITE(*,*) ' Matrix Q on exit : '
      DO I=1,N 
         WRITE(*,'(5(E14.6,1X))') Q(I,:)
      ENDDO


      END PROGRAM LA_SSBGVX_EXAMPLE

PROGRAM LA_CGGLSE_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GGLSE
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.2,1H,,F7.2,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER  :: I, INFO, M, N, P
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:), CC(:), DD(:)
   COMPLEX(WP), ALLOCATABLE :: A(:, :), B(:,:), C(:), D(:), X(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MATMUL
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'CGGLSE Example Program Results'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) M, N, P
   PRINT *, 'M = ', M, ' N = ', N, ' P = ', P
   ALLOCATE ( A(M,N), AA(M,N), B(P,N), BB(P,N), C(M), CC(M), D(P), DD(P), X(N) )
   READ (NIN,*) AA, BB, CC, DD
   A = AA; B=BB; C = CC; D = DD
   WRITE(NOUT,*) 'The matrix A'
   DO I = 1, M; WRITE (NOUT,FMT) A(I,:); ENDDO
   WRITE(NOUT,*) 'The RHS matrix B:'
   DO I = 1, P; WRITE (NOUT,FMT) B(I,:); ENDDO
   WRITE(NOUT,*) 'The vector C:'; WRITE (NOUT,FMT) C
   WRITE(NOUT,*) 'The vector D:'; WRITE (NOUT,FMT) D
!
   WRITE ( NOUT, * )'--------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_CGELSE LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGLSE (A, B, C, D, X)'
   A = AA; B=BB; C = CC; D = DD
   CALL LA_GGLSE (A, B, C, D, X)
   WRITE(NOUT,*)' C - MATMUL(AA, X), MATMUL(BB, X), X'
   WRITE (NOUT,FMT) C - MATMUL( AA, X )
   WRITE (NOUT,FMT) MATMUL( BB, X )
   WRITE(NOUT,FMT) X
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGLSE (A, B, C, D, X, INFO)'
   A = AA; B=BB; C = CC; D = DD
   CALL LA_GGLSE (A, B, C, D, X, INFO)
   WRITE(NOUT,*)'INFO = ', INFO, ' C - MATMUL(AA, X), MATMUL(BB, X), X'
   WRITE (NOUT,FMT) C - MATMUL( AA, X )
   WRITE (NOUT,FMT) MATMUL( BB, X )
   WRITE(NOUT,FMT) X
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGLSE (A(:,1:N-1), B, C, D, X, INFO)'
   A = AA; B=BB; C = CC; D = DD
   CALL LA_GGLSE (A(:,1:N-1), B, C, D, X, INFO)
   WRITE(NOUT,*)'INFO = ', INFO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGLSE (A, B(1:1,:), C, D, X, INFO)'
   A = AA; B=BB; C = CC; D = DD
   CALL LA_GGLSE (A, B(1:1,:), C, D, X, INFO)
   WRITE(NOUT,*)'INFO = ', INFO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGLSE (A, B, C(1:1), D, X, INFO)'
   A = AA; B=BB; C = CC; D = DD
   CALL LA_GGLSE (A, B, C(1:1), D, X, INFO)
   WRITE(NOUT,*)'INFO = ', INFO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGLSE (A, B, C, D(1:1), X, INFO)'
   A = AA; B=BB; C = CC; D = DD
   CALL LA_GGLSE (A, B, C, D(1:1), X, INFO)
   WRITE(NOUT,*)'INFO = ', INFO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GGLSE (A, B, C, D, X(1:1))'
   A = AA; B=BB; C = CC; D = DD
   CALL LA_GGLSE (A, B, C, D, X(1:1))
   WRITE(NOUT,*)'INFO = ', INFO
!
END!PROGRAM LA_CGGLSE_EXAMPLE

SUBROUTINE DGGSVD_F95( A, B, ALPHA, BETA, K, L, U, V, Q, IWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO
   USE F77_LAPACK, ONLY: GGSVD_F77 => LA_GGSVD
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO, K, L
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
   REAL(WP), INTENT(OUT) :: ALPHA(:), BETA(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: U(:,:), V(:,:), Q(:,:)
   INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IWORK(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!      LA_GGSVD computes the generalized singular values and, optionally,
! the transformation matrices from the generalized singular value
! decomposition (GSVD) of a real or complex matrix pair (A,B), where A 
! is m by n and B is p by n. The GSVD of (A,B) is written 
!       A = U * SIGMA1(0, R)*Q^H , B = V * SIGMA2(0, R)*Q^H
! where U , V and Q are orthogonal (unitary) matrices of dimensions m by m,
! p by p and n by n, respectively. Let l be the rank of B and r the rank of
! the (m + p) * n matrix ( A )
!                        ( B )
! , and let k = r-l. Then SIGMA1 and SIGMA2 are m*(k + l) and p * (k + l) 
! "diagonal" matrices, respectively, and R is a (k + l) * (k + l)
! nonsingular triangular matrix. The detailed structure of SIGMA1 ,SIGMA2
! and R depends on the sign of (m - k - l) as follows:
!       The case m-k-l>=0:
! 
!                               k   l
!                      k      ( I   0 )
!        SIGMA1 =      l      ( 0   C )
!                    m-k-l    ( 0   0 )
! 
! 
!                           k   l
! 	SIGMA2 =    l   ( 0   S )
! 	          p - l ( 0   S )
! 
! 
!                          n-k-l   k     l
!          (0, R) =   k   (  0    R11   R12  )
!  	              l   (  0     0    R22  )
! 			
! where C^2 + S^2 = I . We define
! alpha(1)=alpha(2)=...=alpha(k) = 1, alpha(k+i)=c(i i), i=1,2,...,l
! beta(1) = beta(2) = ... = beta(k) = 0, beta(k+i) = s(i i), i=1,2,...,l
!  
! The case m-k-l < 0:
! 
!                                k    m-k    k+l-m
!            SIGMA1 =    k    (  I     0       0   )
!   	                m-k   (  0     C       0   )
! 		      
! 		      
! 		               k    m-k     k+l-m
!                        m-k   ( 0     S        0  )
!            SIGMA2 =   k+l-m  ( 0     0        I  )
!  	                 p-l   ( 0     0        0  )
! 
! 
!                                  n-k-l    k     m-k   k+l-m
! 		  	  k      (   0     R11    R12    R13  )
!              (0,R) =   m-k     (   0      0     R22    R23  )
! 	                k+l-m    (   0      0      0     R33  )
! 			
! where C^2 + S^2 = I . We define
!  alpha(1)=alpha(2)=...=alpha(k) = 1, alpha(k+i)=c(i i), i =1,2,...,m-k,
!  alpha(m+1) = alpha(m+2)=...= alpha(k+l) = 0
!  beta(1)=beta(2)= ... =beta(k)=0, beta(k+i)=s(i i), i=1,2,...,m-k,
!  beta(m+1) = beta(m+2) = ... = beta(k+l) = 1
! 
! In both cases the generalized singular values of the pair (A,B) are the
! ratios
!  sigma(i) = alpha(i)/beta(i), i = 1,2, ... ,k+l
!  
! The first k singular values are infinite. The finite singular values 
! are real and nonnegative.
!     LA_GGSVD computes the real (nonnegative) scalars alpha(i), beta(i),
! i=1,2,..., k+l , the matrix R, and, optionally, the transformation 
! matrices U , V and Q.
! 
! =========
! 
!      SUBROUTINE LA_GGSVD( A, B, ALPHA, BETA, K=k, L=l, &
!                       U=u, V=v, Q=q, IWORK=iwork, INFO=info )
!          <type>(<wp>), INTENT(INOUT) :: A(:,:), B(:,:)
!          REAL(<wp>), INTENT(OUT) :: ALPHA(:), BETA(:)
!          INTEGER, INTENT(OUT), OPTIONAL :: K, L
!          <type>(<wp>), INTENT(OUT), OPTIONAL :: U(:,:), V(:,:), Q(:,:)
!          INTEGER, INTENT(IN), OPTIONAL :: IWORK(:)
!          INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!          <type> ::= REAL | COMPLEX
!          <wp>   ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! A      (input/output) REAL or COMPLEX array, shape (:,:) with 
!        size(A,1) = m and size(A,2) = n.
!        On entry, the matrix A.
!        On exit, A contains the triangular matrix R, or part of R, as
!        follows:
!        If m-k-l >= 0, then R is stored in A(1:k+l,n-k-l+1:n).
!        If m-k-l < 0, then the matrix
!                  ( R11     R12    R13 )
! 		 (  0      R22    R23 )
!        is stored in A(1:m,n-k-l+1:n).
! B      (input/output) REAL or COMPLEX array, shape (:,:) with 
!        size(B,1) = p and size(B,2) = n.
!        On entry, the matrix B.
!        On exit, if m-k-l < 0, then R33 is stored in
!        B(m-k+1:l,n+m-k-l+1:n).
! ALPHA  (output) REAL array, shape (:) with size(ALPHA) = n
!        The real scalars alpha(i) , i = 1, 2,..., k+l.
! BETA   (output) REAL array, shape (:) with size(BETA) = n.
!        The real scalars beta(i) , i = 1, 2, ..., k+l.
!        Note: The generalized singular values of the pair (A,B) are
!        sigma(i) = ALPHA(i)/BETA(i), i = 1, 2, ...,  k+l.
!        If k + l < n, then ALPHA(k+l+1:n) = BETA(k+l+1:n) = 0.
! K, L   Optional (output) INTEGER.
!        The dimension parameters k and l.
! U      Optional (output) REAL or COMPLEX square array, shape (:,:) with
!        size(U,1) = m.
!        The matrix U .
! V      Optional (output) REAL or COMPLEX square array, shape (:,:) with
!        size(V,1) = p.
!        The matrix V .
! Q      Optional (output) REAL or COMPLEX square array, shape (:,:) with
!        size(Q,1) = n.
!        The matrix Q.
! IWORK  Optional (output) INTEGER array, shape(:) with size(IWORK) = n.
!        IWORK contains sorting information. More precisely, the loop
!             for i = k + 1, min(m, k + l)
!                   swap ALPHA(i) and ALPHA(IWORK(i))
!             end
!        will sort ALPHA so that ALPHA(1) >= ALPHA(2) >= ... >= ALPHA(n).
! INFO   Optional (output) INTEGER.
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value.
!        > 0: if INFO = 1, the algorithm failed to converge.
!        If INFO is not present and an error occurs, then the program is 
!        terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GGSVD'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBU, LJOBV, LJOBQ
   INTEGER :: M, N, P, LINFO, ISTAT, ISTAT1, S1U, S2U, S1V, S2V, &
              S1Q, S2Q, LK, LL
!  .. LOCAL ARRAYS ..
   REAL(WP), TARGET :: LLU(1,1), LLV(1,1), LLQ(1,1)
   INTEGER, POINTER :: LIWORK(:)
   REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2); P = SIZE(B,1)
   IF( PRESENT(U) )THEN; S1U = SIZE(U,1); S2U = SIZE(U,2); LJOBU = 'U'
   ELSE; S1U = 1; S2U = 1; LJOBU = 'N'; END IF
   IF( PRESENT(V) )THEN; S1V = SIZE(V,1); S2V = SIZE(V,2); LJOBV = 'V'
   ELSE; S1V = 1; S2V = 1; LJOBV = 'N'; END IF
   IF( PRESENT(Q) )THEN; S1Q = SIZE(Q,1); S2Q = SIZE(Q,2); LJOBQ = 'Q'
   ELSE; S1Q = 1; S2Q = 1; LJOBQ = 'N'; END IF
!  .. TEST THE ARGUMENTS
   IF( M < 0 .OR. N < N )THEN; LINFO = -1
   ELSE IF( SIZE(B,2) /= N .OR. P < 0 ) THEN; LINFO = -2
   ELSE IF( SIZE( ALPHA ) /= N )THEN; LINFO = -3
   ELSE IF( SIZE( BETA ) /= N )THEN; LINFO = -4
   ELSE IF( PRESENT(U) .AND. ( S1U /= MAX(1,M) .OR.  S2U /= M ) )THEN; LINFO = -7
   ELSE IF( PRESENT(V) .AND. ( S1V /= MAX(1,P) .OR.  S2V /= P ) )THEN; LINFO = -8
   ELSE IF( PRESENT(Q) .AND. ( S1Q /= MAX(1,N) .OR.  S2Q /= N ) )THEN; LINFO = -9
   ELSE
    IF (PRESENT(IWORK)) THEN
      LIWORK => IWORK
    ELSE 
      ALLOCATE( LIWORK(MAX(1,N)), STAT=ISTAT )
    ENDIF
      IF( ISTAT == 0 ) THEN
         ALLOCATE( WORK( MAX(1,MAX(3*N,M,P)+N) ), STAT=ISTAT)
      END IF
      IF( ISTAT == 0 ) THEN
         IF( PRESENT(U) )THEN
           IF( PRESENT(V) )THEN
             IF( PRESENT(Q) )THEN
                CALL GGSVD_F77( LJOBU, LJOBV, LJOBQ, M, N, P, LK, LL, A, MAX(1,M), &
                         B, MAX(1,P), ALPHA, BETA, U, MAX(1,S1U), &
                        V, MAX(1,S1V), Q, MAX(1,S1Q), WORK, LIWORK, LINFO )
	      ELSE
	        CALL GGSVD_F77( LJOBU, LJOBV, LJOBQ, M, N, P, LK, LL, A, MAX(1,M), &
                         B, MAX(1,P), ALPHA, BETA, U, MAX(1,S1U), &
                        V, MAX(1,S1V), LLQ, MAX(1,S1Q), WORK, LIWORK, LINFO )
	      ENDIF
	     ELSE
	      IF( PRESENT(Q) )THEN
	        CALL GGSVD_F77( LJOBU, LJOBV, LJOBQ, M, N, P, LK, LL, A, MAX(1,M), &
                         B, MAX(1,P), ALPHA, BETA, U, MAX(1,S1U), &
                        LLV, MAX(1,S1V), Q, MAX(1,S1Q), WORK, LIWORK, LINFO )
	      ELSE
	        CALL GGSVD_F77( LJOBU, LJOBV, LJOBQ, M, N, P, LK, LL, A, MAX(1,M), &
                         B, MAX(1,P), ALPHA, BETA, U, MAX(1,S1U), &
                        LLV, MAX(1,S1V), LLQ, MAX(1,S1Q), WORK, LIWORK, LINFO )
	      ENDIF
	    ENDIF
	   ELSE
	     IF( PRESENT(V) )THEN
	       IF( PRESENT(Q) )THEN
	         CALL GGSVD_F77( LJOBU, LJOBV, LJOBQ, M, N, P, LK, LL, A, MAX(1,M), &
                         B, MAX(1,P), ALPHA, BETA, LLU, MAX(1,S1U), &
                        V, MAX(1,S1V), Q, MAX(1,S1Q), WORK, LIWORK, LINFO )
	       ELSE
	         CALL GGSVD_F77( LJOBU, LJOBV, LJOBQ, M, N, P, LK, LL, A, MAX(1,M), &
                         B, MAX(1,P), ALPHA, BETA, LLU, MAX(1,S1U), &
                        V, MAX(1,S1V), LLQ, MAX(1,S1Q), WORK, LIWORK, LINFO )
		ENDIF
	      ELSE
	       IF( PRESENT(Q) )THEN 
	         CALL GGSVD_F77( LJOBU, LJOBV, LJOBQ, M, N, P, LK, LL, A, MAX(1,M), &
                         B, MAX(1,P), ALPHA, BETA, LLU, MAX(1,S1U), &
                        LLV, MAX(1,S1V), Q, MAX(1,S1Q), WORK, LIWORK, LINFO )
		ELSE
		 CALL GGSVD_F77( LJOBU, LJOBV, LJOBQ, M, N, P, LK, LL, A, MAX(1,M), &
                         B, MAX(1,P), ALPHA, BETA, LLU, MAX(1,S1U), &
                        LLV, MAX(1,S1V), LLQ, MAX(1,S1Q), WORK, LIWORK, LINFO )
		ENDIF
	       ENDIF
	      ENDIF 
         IF( PRESENT(K) ) K = LK
         IF( PRESENT(L) ) L = LL
      ELSE; LINFO = -100; ENDIF
      DEALLOCATE(WORK, STAT=ISTAT1)
      IF (.NOT. PRESENT(IWORK)) DEALLOCATE(LIWORK, STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE DGGSVD_F95

PROGRAM LA_CGGEV_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GGEV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
   CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, INFO, N
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:)
   COMPLEX(WP), ALLOCATABLE :: A(:,:), B(:,:), VL(:,:), &
                            VR(:,:), ALPHA(:), BETA(:), DUMMY(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'CGGEV ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N
   PRINT *, 'N = ', N
   ALLOCATE ( A(N,N), AA(N,N), ALPHA(N), BETA(N), &
              VL(N,N), VR(N,N), B(N,N), BB(N,N) )
!
   READ (NIN, *) AA, BB
   A=AA; B=BB
   WRITE(NOUT,*) 'The matrix A:'
   DO I = 1, N; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,:); ENDDO
   WRITE(NOUT,*) 'The matrix B:'
   DO I = 1, N; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) B(I,:); ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_CGGEV LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEV( A, B, ALPHA, BETA, VL, VR, INFO )'
   A=AA
   CALL LA_GGEV( A, B, ALPHA, BETA, VL, VR, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   WRITE(NOUT,*) ' Alpha:'
   WRITE(NOUT,FMT) ALPHA
   WRITE(NOUT,*) ' Beta:'
   WRITE(NOUT,FMT) BETA
   WRITE(NOUT,*) 'VL:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VL(:,I); END DO
   WRITE(NOUT,*) 'VR:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VR(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEV( A, B, ALPHA, BETA, INFO=INFO )'
   A=AA
   CALL LA_GGEV( A, B, ALPHA, BETA, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   WRITE(NOUT,*) 'A:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(:,I); END DO
   WRITE(NOUT,*) 'B:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) B(:,I); END DO
   WRITE(NOUT,*) ' Alpha:'
   WRITE(NOUT,FMT) ALPHA
   WRITE(NOUT,*) ' Beta:'
   WRITE(NOUT,FMT) BETA
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEV( DUMMY, B, ALPHA, BETA, INFO=INFO )'
   A=AA
   CALL LA_GGEV( DUMMY, B, ALPHA, BETA, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEV( A, DUMMY, ALPHA, BETA, INFO=INFO )'
   A=AA
   CALL LA_GGEV( A, DUMMY, ALPHA, BETA, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEV( A, B, ALPHA(1:N-1), BETA, INFO=INFO )'
   A=AA
   CALL LA_GGEV( A, B, ALPHA(1:N-1), BETA, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEV( A, B, ALPHA=ALPHA(1:N-1), BETA, INFO=INFO )'
   A=AA
   CALL LA_GGEV( A, B, ALPHA(1:N-1), BETA, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEV( A, B, ALPHA, BETA(1:N-1), INFO=INFO )'
   A=AA
   CALL LA_GGEV( A, B, ALPHA, BETA(1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEV( A, B, ALPHA, BETA, VL(:,1:N-1), INFO=INFO )'
   A=AA
   CALL LA_GGEV( A, B, ALPHA, BETA, VL(:,1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEV( A, B, ALPHA, BETA, VL(1:N-1,:), INFO=INFO )'
   A=AA
   CALL LA_GGEV( A, B, ALPHA, BETA, VL(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEV( A, B, ALPHA, BETA, VR=VR(1:N-1,:), INFO=INFO )'
   A=AA
   CALL LA_GGEV( A, B, ALPHA, BETA, VR=VR(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEV( A, B, ALPHA, BETA, VR=VR(:,1:N-1), INFO=INFO )'
   A=AA
   CALL LA_GGEV( A, B, ALPHA, BETA, VR=VR(:,1:N-1), INFO = INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
END PROGRAM LA_CGGEV_ET_EXAMPLE

     SUBROUTINE LA_TEST_SGEESX( JOBVS, SORT, SELECT, SENSE, N, A, LDA, SDIM, &
     &  WR, WI, VS, LDVS, RCONDE, RCONDV, WORK, LWORK, IWORK, LIWORK, BWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     May 21, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GEESX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, LDA, LDVS, LWORK, LIWORK
      INTEGER, INTENT(OUT) :: SDIM
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: JOBVS, SORT, SENSE
      REAL(WP), INTENT(OUT) :: RCONDV, RCONDE 
!   LOGICAL SELECT
      INTERFACE
      LOGICAL FUNCTION SELECT(WR, WI)
      USE LA_PRECISION, ONLY: WP => SP
      REAL(WP), INTENT(IN) :: WR, WI
      END FUNCTION SELECT
      END INTERFACE
!  .. Array Arguments ..
      REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N)
      REAL(WP), INTENT(OUT) :: WR(1: N), WI(1: N), VS(1: LDVS, 1: N), &
     &  WORK (1: LWORK)
      LOGICAL :: BWORK(1: N)
      INTEGER, INTENT(OUT) :: IWORK(1: LIWORK)
      LOGICAL LSAME
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GEESX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGEESX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, ISDIM, IWI, IWR, IVS1, IVS2
      CHARACTER*1 :: IJOBVS
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IA1 = N; IA2 = N; IWI = N; IWR = N;
      IVS1 = N; IVS2 = N; ISDIM = SDIM; IJOBVS = JOBVS
      
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE (1)
      IA2 = IA2-1
      CASE (2)
      IWR = IWR-1
      CASE(3)
      IWI = IWI - 1
      CASE (4)
      IVS1 = IVS1 - 1
      IJOBVS = 'V'
      CASE(:-1,5:)
      CALL UESTOP(SRNAMT)
      END SELECT
      SDIM = 0
      if (lsame(sense,'E')) then
        IF (LSAME (IJOBVS,'V')) THEN
          IF (LSAME(SORT, 'S')) THEN 
            CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &        VS(1: IVS1, 1: IVS2), SELECT, SDIM, RCONDE, INFO=INFO)
          ELSE 
            CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &        VS(1: IVS1, 1: IVS2), RCONDE=RCONDE, INFO=INFO)
          END IF
        ELSE
          IF (LSAME(SORT, 'S')) THEN 
            CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &        SELECT=SELECT, SDIM=SDIM, RCONDE=RCONDE, INFO=INFO)
          ELSE
            CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &        RCONDE=RCONDE, INFO=INFO)
          END IF
        END IF
      else if (lsame (sense,'V')) then
        IF (LSAME (IJOBVS,'V')) THEN
          IF (LSAME(SORT, 'S')) THEN
            CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &        VS(1: IVS1, 1: IVS2), SELECT, SDIM, RCONDV=RCONDV, &
     &        INFO=INFO)
          ELSE
            CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &        VS(1: IVS1, 1: IVS2), RCONDV=RCONDV, INFO=INFO)
          END IF
        ELSE
          IF (LSAME(SORT, 'S')) THEN
            CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &        SELECT=SELECT, SDIM=SDIM, RCONDV=RCONDV, INFO=INFO)
          ELSE
            CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
     &        RCONDV=RCONDV, INFO=INFO)
          END IF
        END IF
      else
        if (lsame (sense,'B')) then
          IF (LSAME (IJOBVS,'V')) THEN
            IF (LSAME(SORT, 'S')) THEN
              CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
&               VS(1: IVS1, 1: IVS2), SELECT, SDIM, RCONDE, RCONDV, &
&               INFO=INFO)
            ELSE
              CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
&               VS(1: IVS1, 1: IVS2), RCONDE=RCONDE, RCONDV=RCONDV, &
&               INFO=INFO)
            END IF
          ELSE
            IF (LSAME(SORT, 'S')) THEN
              CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
&               SELECT=SELECT, SDIM=SDIM, RCONDE=RCONDE, RCONDV=RCONDV, &
&               INFO=INFO)
            ELSE
              CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
&               RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO)
            END IF
          END IF
        else
          IF (LSAME (IJOBVS,'V')) THEN
            IF (LSAME(SORT, 'S')) THEN
              CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
&               VS(1: IVS1, 1: IVS2), SELECT, SDIM, INFO=INFO)
            ELSE
              CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
&               VS(1: IVS1, 1: IVS2), INFO=INFO)
            END IF
          ELSE
            IF (LSAME(SORT, 'S')) THEN
              CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
&               SELECT=SELECT, SDIM=SDIM, INFO=INFO)
            ELSE
              CALL LA_GEESX( A(1:IA1, 1: IA2), WR(1:IWR), WI(1:IWI), &
&               INFO=INFO)
            END IF
          END IF 
        end if
      endif
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_SGEESX

SUBROUTINE DPPSVX1_F95(A, B, X, UPLO, AF, FACT, EQUED, S, FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: PPSVX_F77 => LA_PPSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
   CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:), B(:)
   REAL(WP), INTENT(OUT) :: X(:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: AF(:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: S(:)
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_PPSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LUPLO, LEQUED
   INTEGER :: LINFO, N, NN, ISTAT, ISTAT1, SAF, SS
   REAL(WP) :: LRCOND, MVS, LFERR, LBERR
   COMPLEX(WP) :: WW
!  .. LOCAL POINTERS ..
   INTEGER, POINTER :: IWORK(:)
   REAL(WP),  POINTER :: LS(:)
   REAL(WP),  POINTER :: WORK(:), LAF( :)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE, MINVAL, TINY, REAL, INT, AIMAG
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; NN = SIZE(A, 1)
   WW = (-1+SQRT(1+8*REAL(NN,WP)))*0.5; N = INT(WW)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(EQUED) .AND. LSAME(LFACT,'F') )THEN; LEQUED = EQUED
   ELSE; LEQUED='N'; END IF
   IF( PRESENT(AF) )THEN; SAF = SIZE(AF); ELSE; SAF = N*(N+1)/2; END IF
   IF( ( PRESENT(S) ) )THEN; SS = SIZE(S); ELSE; SS = N; END IF
   IF( PRESENT(S) .AND. LSAME(LFACT,'F') .AND. LSAME(LEQUED,'Y') ) THEN
       MVS = MINVAL(S); ELSE; MVS = TINY(1.0_WP); ENDIF
   IF(PRESENT(UPLO))THEN; LUPLO = UPLO; ELSE; LUPLO='U'; END IF
!  .. TEST THE ARGUMENTS
   IF( NN < 0 .OR. AIMAG(WW) /= 0 .OR. REAL(N,WP) /= REAL(WW) ) THEN; LINFO = -1
   ELSE IF( SIZE(B) /= N )THEN; LINFO = -2
   ELSE IF( SIZE(X) /= N )THEN; LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
   ELSE IF( SAF /= N*(N+1)/2 ) THEN; LINFO = -5
   ELSE IF( ( .NOT. ( LSAME(LFACT,'F') .OR. LSAME(LFACT,'N') .OR. &
                    LSAME(LFACT,'E') ) ) .OR. &
      ( LSAME(LFACT,'F') .AND. .NOT.PRESENT(AF) ) )THEN; LINFO = -6
   ELSE IF( .NOT.LSAME(LEQUED,'N') .AND. .NOT.LSAME(LEQUED,'Y') )THEN; LINFO = -7
   ELSE IF( SS /= N .OR. LSAME(LFACT,'F') .AND. LSAME(LEQUED,'Y') &
      .AND. MVS  <= 0.0_WP )THEN; LINFO = -8
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(AF) ) THEN; ALLOCATE( LAF(N*(N+1)/2), STAT=ISTAT )
      ELSE; LAF => AF; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(S) )THEN; ALLOCATE( LS(N), STAT=ISTAT )
         ELSE; LS => S; END IF
      END IF
      IF( ISTAT == 0 ) ALLOCATE(WORK(3*N), IWORK(N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
         CALL PPSVX_F77( LFACT, LUPLO, N, 1, A, LAF, LEQUED, LS, &
                  B, N, X, N, LRCOND, LFERR, LBERR, WORK, IWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(S) ) DEALLOCATE( LS, STAT=ISTAT1 )
      IF( .NOT.PRESENT(AF) ) DEALLOCATE( LAF, STAT=ISTAT1 )
      IF( PRESENT(FERR) ) FERR = LFERR
      IF( PRESENT(BERR) ) BERR = LBERR
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      IF( PRESENT(EQUED) .AND. .NOT.LSAME(LFACT,'F') ) EQUED=LEQUED
      DEALLOCATE( WORK, IWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE DPPSVX1_F95

    SUBROUTINE DGEES_F95( A, WR, WI, VS, SELECT, SDIM, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: GEES_F77 => LA_GEES
!  USE LA_EXTERNAL, ONLY: SELECT
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
   INTERFACE
      LOGICAL FUNCTION SELECT(WR, WI)
         USE LA_PRECISION, ONLY: WP => DP
         REAL(WP), INTENT(IN) :: WR, WI
      END FUNCTION SELECT
   END INTERFACE
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO, SDIM
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:)
   REAL(WP), INTENT(OUT) :: WR(:), WI(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VS(:,:)
!  .. EXTERNAL ARGUMENTS ..
   OPTIONAL :: SELECT
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!      LA_GEES computes for a real/complex square matrix A, the 
! eigenvalues, the real-Schur/complex-Schur form T , and, optionally, the
! matrix of Schur vectors Z, where Z is orthogonal/unitary. This gives the
! Schur factorization
!                        A = Z*T*Z^H.
! Optionally, it also orders the eigenvalues on the diagonal of the Schur 
! form so that selected eigenvalues are at the top left. The leading 
! columns of Z then form an orthonormal basis for the invariant subspace
! corresponding to the selected eigenvalues.
!      A real matrix is in real-Schur form if it is block upper triangular
! with 1 by 1 and 2 by 2 blocks along the main diagonal. 2 by 2 blocks are
! standardized in the form
!                       [ a  b ]
! 		        [ c  a ]
! where b*c < 0. The eigenvalues of such a block are a +/- Sqrt(b*c).
! A complex matrix is in complex-Schur form if it is upper triangular.
! 
! =========
! 
!        SUBROUTINE LA_GEES( A, <w>, VS=vs, SELECT=select, &
!                                   SDIM=sdim, INFO=info )
!           <type>(<wp>), INTENT(INOUT) :: A(:,:)
!           <type>(<wp>), INTENT(OUT) :: <w(:)>
!           <type>(<wp>), INTENT(OUT), OPTIONAL :: VS(:,:)
!           INTERFACE
!               LOGICAL FUNCTION SELECT(<w(j)>)
!                  <type>(<wp>), INTENT(IN) :: <w(j)>
!               END FUNCTION SELECT
!           END INTERFACE
!           OPTIONAL :: SELECT
!           INTEGER, INTENT(OUT), OPTIONAL :: SDIM, INFO
!        where
!           <type> ::= REAL | COMPLEX
!           <wp>   ::= KIND(1.0) | KIND(1.0D0)
!           <w>    ::= WR, WI | W
!           <w(:)> ::= WR(:), WI(:) | W(:)
!           <w(j)> ::= WR(j) , WI(j) |  W(j)
! 
! Arguments
! =========
! 
! A        (input/output) REAL or COMPLEX square array, shape (:,:).
!          On entry, the matrix A.
!          On exit, the Schur form T.
! <w>      (output) REAL or COMPLEX array, shape (:) with size(w) = 
!          size(A,1).
!          The computed eigenvalues in the order in which they appear on 
!          the diagonal of the Schur form T.
!          <w(:)> ::= WR(:), WI(:) | W(:),
!          where
!          WR(:), WI(:) are of REAL type (for the real and imaginary 
! 	   parts) and W(:) is of COMPLEX type.
!          Note: If A is real, then a complex-conjugate pair appear 
!          consecutively, with the eigenvalue having the positive
! 	   imaginary part appearing first.
! VS       Optional (output) REAL or COMPLEX square array, shape (:,:) 
!          with size(VS,1) = size(A,1).
!          The matrix Z of Schur vectors.
! SELECT   Optional (input) LOGICAL FUNCTION.
!          LOGICAL FUNCTION SELECT( <w(j)> )
!            <type>(<wp>), INTENT(IN) :: <w(j)>
!          where
!            <type> ::= REAL | COMPLEX
!            <wp>   ::= KIND(1.0) | KIND(1.0D0)
!            <w(j)> ::= WR(j) , WI(j) | W(j)
!          1. SELECT must be declared as EXTERNAL or as an explicit 
!             interface in the calling (sub)program.
!          2. SELECT is called by LA_GEES for every computed eigenvalue
! 	    w(j) (but only once for a complex conjugate pair when A is
! 	    real). It is used to select the eigenvalues that will be
!             ordered to the top left of the Schur form. The eigenvalue
! 	    w(j) is selected if SELECT(w(j)) has the value .TRUE.
!          3. A selected complex eigenvalue may no longer satisfy 
! 	    SELECT(w(j)) = .TRUE. after ordering, since ordering may 
! 	    change the value of complex eigenvalues (especially if the
! 	    eigenvalue is ill-conditioned). In this case INFO is set to
! 	    size(A,1) + 2 (see INFO below).
!          Note: Select must be present if SDIM is desired.
! SDIM     Optional (output) INTEGER.
!          The number of eigenvalues (after sorting) for which 
! 	   SELECT=.TRUE. (If A is real, complex conjugate pairs for which 
! 	   SELECT=.TRUE. for either eigenvalue count as 2).
! INFO     Optional (output) INTEGER.
!          = 0: successful exit.
!          < 0: if INFO = -i, the i-th argument had an illegal value.
!          > 0: if INFO = i, and i is 
!              <= n: the QR algorithm failed to compute all the 
!                    eigenvalues; elements 1:ilo-1 and i+1:n of w contain
!                    those eigenvalues which have converged. VS contains 
!                    the matrix which reduces A to its partially converged
!                    Schur form.
!              = n+1: the eigenvalues could not be reordered because some 
!                    eigenvalues were not sufficiently separated (the 
! 		   problem is very ill-conditioned).
!              = n+2: after reordering, some leading complex eigenvalues 
! 	           in the Schur form no longer satisfy SELECT = .TRUE. 
!                    This can be caused by ordinary roundoff or underflow
!                    due to scaling.
!              n is the order of A.
!          If INFO is not present and an error occurs, then the program is
!          terminated with an error message.
!-------------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GEES'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBVS, LSORT
   INTEGER, SAVE :: LWORK = 0
   INTEGER :: N, LINFO, LD, ISTAT, ISTAT1, S1VS, S2VS, LSDIM
!  .. LOCAL ARRAYS ..
   LOGICAL, TARGET :: LLBWORK(1)
   LOGICAL, POINTER :: BWORK(:)
   REAL(WP), TARGET :: LLVS(1,1)
   REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LSDIM = 0
   LINFO = 0; ISTAT = 0; N = SIZE(A,1); LD = MAX(1,N)
   IF( PRESENT(VS) )THEN; S1VS = SIZE(VS,1); S2VS = SIZE(VS,2); LJOBVS = 'V'
   ELSE; S1VS = 1; S2VS = 1; LJOBVS = 'N'; END IF
   IF( PRESENT(SDIM) .OR. PRESENT(SELECT) )THEN; LSORT = 'S'; ELSE; LSORT = 'N'; END IF
!  .. TEST THE ARGUMENTS
   IF( N < 0 .OR. SIZE(A,2) /= N )THEN; LINFO = -1
   ELSE IF( SIZE( WR ) /= N )THEN; LINFO = -2
   ELSE IF( SIZE( WI ) /= N )THEN; LINFO = -3
   ELSE IF( PRESENT(VS) .AND. ( S1VS /= N .OR. S2VS /= N ) )THEN; LINFO = -4
   ELSE IF( PRESENT(SDIM) .AND. .NOT.PRESENT(SELECT) )THEN; LINFO = -5
   ELSE IF( N > 0 )THEN
      IF( ISTAT == 0 ) THEN
         LWORK = MAX( 1, 3*N, LWORK); ALLOCATE(WORK(LWORK), STAT=ISTAT)
         IF( ISTAT /= 0 )THEN; DEALLOCATE(WORK,STAT=ISTAT1)
            LWORK = MAX( 1, 3*N ); ALLOCATE(WORK(LWORK), STAT=ISTAT)
            IF( ISTAT == 0) CALL ERINFO( -200, SRNAME, LINFO )
         END IF
      END IF
      IF( ISTAT == 0 ) THEN
        IF( PRESENT(VS) )THEN  
          IF( PRESENT(SDIM) )THEN 
	     ALLOCATE(BWORK(N),STAT=ISTAT)
             CALL GEES_F77( LJOBVS, LSORT, SELECT, N, A, LD, LSDIM, WR, WI, &
                        VS, S1VS, WORK, LWORK, BWORK, LINFO )
	    ELSE
	     CALL GEES_F77( LJOBVS, LSORT, SELECT, N, A, LD, LSDIM, WR, WI, &
                        VS, S1VS, WORK, LWORK, LLBWORK, LINFO )
	    ENDIF		
	  ELSE
	   IF( PRESENT(SDIM) )THEN
	      ALLOCATE(BWORK(N),STAT=ISTAT)
	      CALL GEES_F77( LJOBVS, LSORT, SELECT, N, A, LD, LSDIM, WR, WI, &
                        LLVS, S1VS, WORK, LWORK, BWORK, LINFO )
	   ELSE
	      CALL GEES_F77( LJOBVS, LSORT, SELECT, N, A, LD, LSDIM, WR, WI, &
                        LLVS, S1VS, WORK, LWORK, LLBWORK, LINFO )
	  ENDIF
	 ENDIF 
         IF( LINFO == 0 ) LWORK = INT(WORK(1)+1)
      ELSE; LINFO = -100; ENDIF
!      IF( PRESENT(SDIM) ) SDIM = LSDIM
      IF( LSAME(LSORT,'S') ) DEALLOCATE(BWORK, STAT=ISTAT1)
      DEALLOCATE(WORK, STAT=ISTAT1)
   ENDIF
   IF( PRESENT(SDIM) ) SDIM = LSDIM
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE DGEES_F95

SUBROUTINE LA_TEST_SSBEV( JOBS, UPLO, N, KD, AB, LDAB, W, Z, LDZ, WORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 14, 1999
!
!  .. Use Statements ..
  USE LA_PRECISION, ONLY: WP => SP
  USE F95_LAPACK, ONLY: LA_SBEV
!  .. Implicit Statement ..
  IMPLICIT NONE
!  .. Scalar Arguments ..
  INTEGER, INTENT(IN) :: N, LDAB, KD, LDZ
  INTEGER, INTENT(INOUT) :: INFO
  CHARACTER*1, INTENT(IN) :: UPLO, JOBS
!  .. Array Arguments ..
  REAL(WP), INTENT(INOUT) :: AB(1:LDAB, 1:N)
  REAL(WP), INTENT(OUT)::  W(1:N), WORK(1 : 3*N-2), Z(1:LDZ, 1:N)
!  .. Parameters ..
  CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SBEV '
  CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SSBEV '
!  .. Common blocks ..
  INTEGER :: INFOTC
  COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
  INTEGER :: I, J, IAB1, IAB2, IW, IZ1, IZ2, IWORK
  CHARACTER*1 :: IUPLO, IJOBS   
!  .. Local Arrays ..
  LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
  LOGICAL LSAME
!  .. Executable Statements ..
  IAB1 = KD+1 ; IAB2 = N; IUPLO = UPLO; IW = N; IJOBS = JOBS; IWORK=3*N-2
  IZ1 = N; IZ2 = N
  I = INFO / 100; J = INFO - I*100
  SELECT CASE(I)
    CASE (1)
      IAB1 = -2
    CASE (2)
      IW = IW - 1
    CASE (3)
      IUPLO = 'T'   
    CASE (4)
      IZ1 = IZ1 - 1
      IJOBS = 'V'
    CASE(:-1,5:)
      CALL UESTOP(SRNAMT)
  END SELECT
  IF  (LSAME(IJOBS, 'V')) THEN 
    CALL LA_SBEV( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO, Z(1:IZ1, 1: IZ2), &
&     INFO )
  ELSE
    CALL LA_SBEV( AB(1:IAB1,1:IAB2), W(1 :IW), IUPLO, INFO=INFO )
  END IF
  
    CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_SSBEV
      
      

PROGRAM LA_ZPTSV_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_PTSV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMTR = '(8(1X,F10.3))'
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, IFAIL, N, NRHS
!  .. LOCAL ARRAYS ..
   COMPLEX(WP), ALLOCATABLE :: E(:), B(:,:)
   REAL(WP), ALLOCATABLE :: D(:), DD(:), EE(:), BB(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'ZPTSV ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, NRHS
   PRINT *, 'N = ', N, ' NRHS = ', NRHS
   ALLOCATE ( D(N), DD(N), E(N-1), EE(N-1), B(N,NRHS), BB(N,NRHS) )
!
        READ (NIN, *) DD(:), EE(:)
        
      BB(1,:) = DD(1) + EE(1)
!     BB(2:N-1,:) = EE(1:N-2) + DD(2:N-1) + EE(2:N-1)
      DO I = 2, N-1
         BB(I,:) = EE(I-1) + DD(I) + EE(I)
      ENDDO
      BB(N,:) = EE(N-1) + DD(N)
      DO I = 1, NRHS
         BB(:,I) = BB(:,I)*I
      ENDDO
   D = DD; E = EE; B = BB
      WRITE(NOUT,*) 'The matrix A:'
      WRITE (NOUT,*) 'D  '; WRITE (NOUT,FMTR) D
      WRITE (NOUT,*) 'EE '; WRITE (NOUT,FMT) E
      WRITE(NOUT,*) 'The RHS matrix B:'
      DO J = 1, NRHS
        WRITE (NOUT,*) 'RHS', J; WRITE (NOUT,FMT) B(:,J)
      ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_ZPTSV LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSV( D, E, B )'
   D = DD; E = EE; B = BB
   IF (NRHS .GT. 1) THEN
      CALL LA_PTSV( D, E, B )
   ELSE
      CALL LA_PTSV( D, E, B(1:N,1) )
   END IF
   WRITE(NOUT,*)'   B - the solution vectors computed by LA_PTSV:'
   DO J = 1, NRHS
      WRITE (NOUT,FMT) B(:,J)
   END DO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_PTSV( D, E, B, INFO=IFAIL)'
   D = DD; E = EE; B = BB
   CALL LA_PTSV( D, E, B, INFO=IFAIL )
   WRITE(NOUT,*)'   B - the solution vectors computed by LA_PTSV, INFO = ', IFAIL
   DO J = 1, NRHS
      WRITE (NOUT,FMT) B(:,J)
   END DO
   D = DD; E = EE; B = BB
   CALL LA_PTSV( D, E, B(1:N,1), IFAIL )
   WRITE(NOUT,*)'   B - the solution vectors computed by LA_PTSV, INFO = ', IFAIL
   WRITE (NOUT,FMT) B(1:N,1)
!
END PROGRAM LA_ZPTSV_ET_EXAMPLE

 SUBROUTINE DPPSV_F95( A, B, UPLO, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO, LSAME
    USE F77_LAPACK, ONLY: PPSV_F77 => LA_PPSV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    REAL(WP), INTENT(INOUT) :: A(:), B(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_PPSV computes the solution to a linear system of equations 
! A*X = B, where A is real symmetric or complex Hermitian and, in either
! case, positive definite, and where X and B are rectangular matrices or
! vectors. A is stored in packed format. The Cholesky decomposition is 
! used to factor A as
!      A = U^H*U if UPLO = 'U', or A = L*L^H if UPLO = 'L'
! where U is an upper triangular matrix and L is a lower triangular 
! matrix (L = U^H ). The factored form of A is then used to solve the 
! above system.
! 
! =========
! 
!       SUBROUTINE LA_PPSV( AP, B, UPLO=uplo, INFO=info )
!           <type>(<wp>), INTENT(INOUT) :: AP(:), <rhs>
!           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!           INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!           <type> ::= REAL | COMPLEX
!           <wp>   ::= KIND(1.0) | KIND(1.0D0)
!           <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! AP      (input/output) REAL or COMPLEX array, shape (:) with size(AP) 
!         = n*(n+1)/2, where n is the order of A.
!         On entry, the upper or lower triangle of matrix A in packed
!         storage. The elements are stored columnwise as follows:
!          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j<=n;
!          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for 1<=j<=i<=n.
!         On exit, the factor U or L from the Cholesky factorization 
! 	  A = U^H*U or A = L*L^H , in the same storage format as A.
! B       (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(B,1) = n or shape (:) with size(B) = n.
!         On entry, the matrix B.
!         On exit, the solution matrix X.
! UPLO    Optional, (input) CHARACTER(LEN=1)
!         = 'U': Upper triangle of A is stored;
!         = 'L': Lower triangle of A is stored.
!         Default value: 'U'.
! INFO    Optional (output) INTEGER.
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: if INFO = i, the leading minor of order i of A is not 
! 	     positive definite, so the factorization could not be 
! 	     completed and the solution could not be computed.
!         If INFO is not present and an error occurs, then the program is
! 	  terminated with an error message.
!------------------------------------------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_PPSV'
!   .. LOCAL SCALARS ..
    CHARACTER(LEN=1) :: LUPLO
    INTEGER :: LINFO, N, NN, NRHS
    COMPLEX(WP) :: WW
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT, REAL, INT, AIMAG
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; NN = SIZE(A); NRHS = SIZE(B,2)
    WW = (-1+SQRT(1+8*REAL(NN,WP)))*0.5; N = INT(WW)
    IF( PRESENT(UPLO) )THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
!   .. TEST THE ARGUMENTS
    IF( NN < 0 .OR. AIMAG(WW) /= 0 .OR. REAL(N,WP) /= REAL(WW) ) THEN; LINFO = -1
    ELSE IF( SIZE( B, 1 ) /= N .OR. NRHS < 0 ) THEN; LINFO = -2
    ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
    ELSE IF ( N > 0 ) THEN
       CALL PPSV_F77( LUPLO, N, NRHS, A, B, N, LINFO )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO )
 END SUBROUTINE DPPSV_F95

      SUBROUTINE CERRVX( PATH, NUNIT )
      IMPLICIT NONE
*
*  -- LAPACK90 test routine (version 1.1) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*     UNI-C, Denmark       
*     April 9, 1999
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  CERRVX tests the error exits for the COMPLEX driver routines
*  for solving linear systems of equations.
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*     .. Local Scalar ..
      CHARACTER*3 PATH1
      SAVE PATH1
      DATA PATH1/'   '/
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX
      PARAMETER          ( NMAX = 4 )
*     ..
*     .. Local Scalars ..
      CHARACTER          EQ
      CHARACTER*2        C2
      CHARACTER*1        CHAR, IEQUED 
      INTEGER            I, INFO, J, NRHS
      INTEGER            KL, KU
      REAL               RCOND
*     ..
*     .. Local Arrays ..
      INTEGER            IP( NMAX ), IN( 100 )
      REAL               C( NMAX ), R( NMAX ), R1( NMAX ), R2( NMAX ),
     $                   RW( NMAX )
      COMPLEX            A( NMAX, NMAX ), AF( NMAX, NMAX ), B( NMAX ),
     $                   W( 2*NMAX ), X( NMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAMEN
      EXTERNAL           LSAMEN
*     ..
*     .. External Subroutines ..
      EXTERNAL LA_TEST_CGBSV, LA_TEST_CGBSVX, LA_TEST_CGESV,
     &         LA_TEST_CGESVX, LA_TEST_CGTSV, LA_TEST_CGTSVX,
     &         LA_TEST_CHESV, LA_TEST_CHESVX, CHKXER,
     &         LA_TEST_CHPSV, LA_TEST_CHPSVX, LA_TEST_CPBSV,
     $         LA_TEST_CPBSVX, LA_TEST_CPOSV, LA_TEST_CPOSVX,
     &         LA_TEST_CPPSV, LA_TEST_CPPSVX, LA_TEST_CPTSV,
     $         LA_TEST_CPTSVX, LA_TEST_CSPSV, LA_TEST_CSPSVX,
     &         LA_TEST_CSYSV, LA_TEST_CSYSVX
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CMPLX, REAL
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )
*
*     Set the variables to innocuous values.
*
      DO 20 J = 1, NMAX
         DO 10 I = 1, NMAX
            A( I, J ) = CMPLX( 1. / REAL( I+J ), -1. / REAL( I+J ) )
            AF( I, J ) = CMPLX( 1. / REAL( I+J ), -1. / REAL( I+J ) )
   10    CONTINUE
         B( J ) = 0.
         R1( J ) = 0.
         R2( J ) = 0.
         W( J ) = 0.
         X( J ) = 0.
         C( J ) = 0.
         R( J ) = 0.
         IP( J ) = J
   20 CONTINUE
      OK = .TRUE.
*
      IF( LSAMEN( 2, C2, 'GE' ) ) THEN
*
*        CGESV
*
         SRNAMT = 'CGESV '
         DO I = 1, 3
            IN(I) = 1
         END DO
         DO I = 1, 3
            INFOT = I
            DO J = 1, IN(I)
               DO NRHS = 1, 2
                  INFO = J + 100*I
                  CALL LA_TEST_CGESV( NMAX, NRHS, A, NMAX, IP, B, NMAX,
     $                 INFO )
                  CALL CHKXER( 'CGESV ', INFOT, NOUT, LERR, OK )
               END DO
             END DO
           END DO
*
*        CGESVX
*
         SRNAMT = 'CGESVX'
         DO I = 1, 12
            IN(I) = 1
         END DO
         IN(3) = 2
         IN(4) = 2
         IN(6) = 4
         IN(8) = 4
         IN(9) = 3
         IN(10) = 3
         DO I = 1, 12
            INFOT = I
            DO J = 1, IN(I)
               DO NRHS = 1, 2
                  INFO = J + 100*I
                  CALL LA_TEST_CGESVX( CHAR, CHAR, NMAX, NRHS, A, NMAX,
     $               AF, NMAX, IP, EQ, R, C, B, NMAX, X, NMAX, RCOND,
     $               R1, R2, W, 2*NMAX, INFO)
                  CALL CHKXER( 'CGESVX', INFOT, NOUT, LERR, OK )
               END DO
            END DO
         END DO

*
      ELSE IF( LSAMEN( 2, C2, 'GB' ) ) THEN
*
*        CGBSV
*
         SRNAMT = 'CGBSV '
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               KL = (NMAX-1)/3
               KU = NMAX-2*KL-1
               CALL LA_TEST_CGBSV( NMAX, KL, KU, NRHS, A, NMAX, IP, B,
     $             NMAX, INFO )
               CALL CHKXER( 'CGBSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO 
*
*        CGBSVX
*
         SRNAMT = 'CGBSVX'
         DO I = 1, 13
           IN(I) = 1
         END DO
         IN(3) = 2
         IN(4) = 2
         IN(5) = 2
         IN(7) = 4
         IN(9) = 4
         IN(10) = 3
         IN(11) = 3
         DO I = 1, 13
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               IF (I /= 1) THEN
                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_CGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_CGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_CGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_CGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )
                 
                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_CGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_CGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_CGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_CGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_CGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_CGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_CGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_CGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_CGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_CGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_CGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_CGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_CGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_CGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_CGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_CGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_CGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_CGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_CGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_CGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_CGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_CGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_CGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )
                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_CGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 1                 00*I
                 IEQUED = 'N'
                 CALL LA_TEST_CGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_CGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_CGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_CGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'N'
                 CALL LA_TEST_CGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'R'
                 CALL LA_TEST_CGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'C'
                 CALL LA_TEST_CGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 IEQUED = 'B'
                 CALL LA_TEST_CGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &             A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &             B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGBSVX', INFOT, NOUT, LERR, OK )
               ENDIF
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'GT' ) ) THEN
*
*        CGTSV
*
         SRNAMT = 'CGTSV '
         DO I = 1, 4
           IF (I/=2)  THEN
             INFOT = I
             DO J = 1, 1
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_CGTSV( NMAX, NRHS, A(1,1), A(1,2),A(1, 3),
     $            B, NMAX, INFO )
                 CALL CHKXER( 'CGTSV ', INFOT, NOUT, LERR, OK )
               END DO
             END DO
           END IF
         END DO 
*
*        CGTSVX
*
         SRNAMT = 'CGTSVX'
         DO I = 1, 14
           IF (I/=2)  THEN
             INFOT = I
             DO J = 1, 1
               DO NRHS = 1, 2
                 INFO = J + 100*I
                 CALL LA_TEST_CGTSVX( 'N', 'N', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGTSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 CALL LA_TEST_CGTSVX( 'F', 'N', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGTSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 CALL LA_TEST_CGTSVX( 'N', 'T', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGTSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 CALL LA_TEST_CGTSVX( 'F', 'T', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGTSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 CALL LA_TEST_CGTSVX( 'N', 'C', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGTSVX', INFOT, NOUT, LERR, OK )

                 INFO = J + 100*I
                 CALL LA_TEST_CGTSVX( 'F', 'C', NMAX, NMAX, A( 1, 1 ),
     &             A( 1, 2 ), A( 1, 3 ),
     &             AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &             IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
                 CALL CHKXER( 'CGTSVX', INFOT, NOUT, LERR, OK )
               ENDDO
             ENDDO
           ENDIF
         ENDDO    
*
      ELSE IF( LSAMEN( 2, C2, 'PO' ) ) THEN
*
*        CPOSV
*
         SRNAMT = 'CPOSV '
         DO I = 1, 3
           IN(I) = 1
         END DO
         DO I = 1, 3
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CPOSV( 'U', NMAX, NRHS, A, NMAX, B, NMAX,
     $                 INFO )
               CALL CHKXER( 'CPOSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_CPOSV( 'L', NMAX, NRHS, A, NMAX, B, NMAX,
     $                 INFO )
               CALL CHKXER( 'CPOSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO 
*
*        CPOSVX
*
         SRNAMT = 'CPOSVX'
         DO I = 1, 10
           IN(I) = 1
         END DO
         DO I = 1, 10
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'F', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'F', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'F', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'F', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'N', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'N', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'N', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'N', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'E', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'E', 'U', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'E', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPOSVX( 'E', 'L', NMAX, NMAX, A, NMAX,
     &           AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &           W, RW, INFO )
               CALL CHKXER( 'CPOSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'PP' ) ) THEN
*
*        CPPSV
*
         SRNAMT = 'CPPSV '
         DO I = 1, 3
           IN(I) = 1
         END DO
         DO I = 1, 3
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CPPSV( 'U', NMAX, NRHS, A(1,1), B,
     $                             NMAX, INFO)

               CALL CHKXER( 'CPPSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_CPPSV( 'L', NMAX, NRHS, A(1,1), B,
     $                             NMAX, INFO)
               CALL CHKXER( 'CPPSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO
*
*        CPPSVX
*
         SRNAMT = 'CPPSVX'
         DO I = 1, 10
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'F', 'U', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'F', 'U', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'F', 'L', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'F', 'L', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'N', 'U', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'N', 'U', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'N', 'L', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'N', 'L', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'E', 'U', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'E', 'U', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'E', 'L', NMAX, NMAX, A, AF, 'N',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPPSVX( 'E', 'L', NMAX, NMAX, A, AF, 'Y',
     &           C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPPSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'PB' ) ) THEN
*
*        CPBSV
*
         SRNAMT = 'CPBSV '
         DO I = 1, 3
           IN(I) = 1
         END DO
         DO I = 1, 3
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CPBSV( 'U', NMAX, 1, NRHS, A, NMAX,
     $                               B, NMAX, INFO)
               CALL CHKXER( 'CPBSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_CPBSV( 'L', NMAX, 1, NRHS, A, NMAX,
     $                              B, NMAX, INFO)
               CALL CHKXER( 'CPBSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO    

*
*        CPBSVX
*
         SRNAMT = 'CPBSVX'
         DO I = 1, 10
           IN(I) = 1
         END DO
         DO I = 2, 10
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'F', 'U', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'F', 'U', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'F', 'L', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'F', 'L', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'N', 'U', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'N', 'U', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'N', 'L', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'N', 'L', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'E', 'U', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'E', 'U', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'E', 'L', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPBSVX( 'E', 'L', NMAX, NMAX-1, NMAX, A,
     &           NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &           R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPBSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'PT' ) ) THEN
*
*        CPTSV
*
         SRNAMT = 'CPTSV '
         DO I = 1, 3
           IN(I) = 1
         END DO
         DO I = 2, 3
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CPTSV( NMAX, NRHS, A(1,1), A(1,2),
     $                            B, NMAX, INFO )
               CALL CHKXER( 'CPTSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO 
*
*        CPTSVX
*
         SRNAMT = 'CPTSVX'
         DO I = 2, 9
           IN(I) = 1
         END DO
         DO I = 2, 9
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CPTSVX( 'F', NMAX, NMAX, A( 1, 1 ),
     &           A( 1, 2 ), AF( 1, 1 ), AF( 1, 2 ), B, NMAX, X,
     &           NMAX, RCOND, R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPTSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CPTSVX( 'N', NMAX, NMAX, A( 1, 1 ),
     &           A( 1, 2 ), AF( 1, 1 ), AF( 1, 2 ), B, NMAX, X,
     &           NMAX, RCOND, R1, R2, W, RW, INFO )
               CALL CHKXER( 'CPTSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'HE' ) ) THEN
*
*        CHESV
*
        SRNAMT = 'CHESV '
        DO I = 1, 4
          IN(I) = 1
        END DO
        DO I = 1, 4
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_CHESV( 'U', NMAX, NRHS,  A, NMAX, A(1,2),
     $                               B, NMAX, W, 1, INFO)
              CALL CHKXER( 'CHESV ', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_CHESV( 'L', NMAX, NRHS, A, NMAX, A(1,2),
     $                              B, NMAX, W, 1,INFO)
              CALL CHKXER( 'CHESV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO 
        
*
*        CHESVX
*
        SRNAMT = 'CHESVX'
        DO I = 1, 9
          IN(I) = 1
        END DO
        DO I = 1, 9
          INFOT = I
          DO J = 1, 1
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_CHESVX( 'N', 'L', NMAX, NRHS, A, NMAX, AF,
     &          NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &          RW, INFO )
              CALL CHKXER( 'CHESVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CHESVX( 'N', 'U', NMAX, NRHS, A, NMAX, AF,
     &          NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &          RW, INFO )
              CALL CHKXER( 'CHESVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CHESVX( 'F', 'L', NMAX, NRHS, A, NMAX, AF,
     &          NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &          RW, INFO )
              CALL CHKXER( 'CHESVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CHESVX( 'F', 'U', NMAX, NRHS, A, NMAX, AF,
     &          NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &          RW, INFO )
              CALL CHKXER( 'CHESVX', INFOT, NOUT, LERR, OK )
            ENDDO
          ENDDO
        ENDDO                                     
*
      ELSE IF( LSAMEN( 2, C2, 'HP' ) ) THEN
*
*        CHPSV
*
         SRNAMT = 'CHPSV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CHPSV( 'U', NMAX, NRHS, A(1,1), A(1,2),
     $                              B, NMAX, INFO)
               CALL CHKXER( 'CHPSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_CHPSV( 'L', NMAX, NRHS, A(1,1), A(1 ,2),
     $                              B, NMAX, INFO)
               CALL CHKXER( 'CHPSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO
*
*        CHPSVX
*
         SRNAMT = 'CHPSVX'
         DO I = 1, 9
           IN(I) = 1
         END DO
         DO I = 1, 9
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CHPSVX( 'N', 'U', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
               CALL CHKXER( 'CHPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPSVX( 'N', 'L', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
               CALL CHKXER( 'CHPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPSVX( 'F', 'U', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
               CALL CHKXER( 'CHPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CHPSVX( 'F', 'L', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
               CALL CHKXER( 'CHPSVX', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO                      
*
      ELSE IF( LSAMEN( 2, C2, 'SY' ) ) THEN
*
*        CSYSV
*
         SRNAMT = 'CSYSV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CSYSV('U', NMAX, NRHS, A, NMAX,
     $                               A(1,2), B, NMAX, W, 1 ,INFO )
               CALL CHKXER( 'CSYSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_CSYSV('L', NMAX, NRHS, A, NMAX,
     $                               A(1,2), B, NMAX, W, 1 ,INFO )
               CALL CHKXER( 'CSYSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO      
*
*        CSYSVX
*
         SRNAMT = 'CSYSVX'
         DO I = 1, 9
           IN(I) = 1
         END DO
         DO I = 1, 9
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_CSYSVX( 'N', 'L', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'CSYSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CSYSVX( 'N', 'U', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'CSYSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CSYSVX( 'F', 'L', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'CSYSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_CSYSVX( 'F', 'U', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           RW, INFO )
               CALL CHKXER( 'CSYSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO                                                     
*
      ELSE IF( LSAMEN( 2, C2, 'SP' ) ) THEN
*
*        CSPSV
*
        SRNAMT = 'CSPSV '
        DO I = 1, 4
          IN(I) = 1
        END DO
        DO I = 1, 4
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_CSPSV( 'U', NMAX, NRHS, A(1,1), A(1,2),
     $                              B, NMAX, INFO)
              CALL CHKXER( 'CSPSV ', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_CSPSV( 'L', NMAX, NRHS, A(1,1), A(1 ,2),
     $                              B, NMAX, INFO)
              CALL CHKXER( 'CSPSV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO  
*
*        CSPSVX
*
        SRNAMT = 'CSPSVX'
        DO I = 1, 9
          IN(I) = 1
        END DO
        DO I = 1, 9
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_CSPSVX( 'N', 'U', NMAX, NRHS, A, AF, IP, B,
     &          NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
              CALL CHKXER( 'CSPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CSPSVX( 'N', 'L', NMAX, NRHS, A, AF, IP, B,
     &          NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
              CALL CHKXER( 'CSPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CSPSVX( 'F', 'U', NMAX, NRHS, A, AF, IP, B,
     &          NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
              CALL CHKXER( 'CSPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_CSPSVX( 'F', 'L', NMAX, NRHS, A, AF, IP, B,
     &          NMAX, X, NMAX, RCOND, R1, R2, W, RW, INFO )
              CALL CHKXER( 'CSPSVX', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO                
      END IF
*
*     Print a summary line.
*
      IF( PATH1 /= PATH )THEN
         PATH1 = PATH
         IF( OK ) THEN
            WRITE( NOUT, FMT = 9999 )PATH
         ELSE
            WRITE( NOUT, FMT = 9998 )PATH
         END IF
      END IF
*
 9999 FORMAT( 1X, A3, ' drivers passed the tests of the error exits' )
 9998 FORMAT( ' *** ', A3, ' drivers failed the tests of the error ',
     $      'exits ***' )
*
      RETURN
*
*     End of CERRVX
*
      END

PROGRAM LA_CHEGV_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_HEGV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, INFO, N 
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:), W(:)
   COMPLEX(WP), ALLOCATABLE :: A(:,:), B(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE(NOUT,*) 'CHEGV ET_Example Program Results.'
   READ(NIN,*) ! SKIP HEADING IN DATA FILE
   READ(NIN,*) N
   ALLOCATE ( A(N,N), B(N,N), W(N), AA(N,N), BB(N,N) )
      DO I = 1, N
        READ(NIN,*) (AA(I, J), J = 1, N)
      ENDDO
      DO I = 1, N
        READ(NIN,*) (BB(I, J), J = 1, N)
      ENDDO
      A=AA; B=BB
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      ENDDO
      WRITE(NOUT,*) 'The matrix B:'
      DO I = 1, N
        WRITE(NOUT,FMT) B(I,:)
      ENDDO
!
   WRITE(NOUT,*) '---------------------------------------------------------'
   WRITE(NOUT,*)
   WRITE ( NOUT, * )'Details of LA_CHEGV LAPACK Subroutine Results.'
   WRITE(NOUT,*)
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HEGV(A, B, W, INFO=INFO)'
   WRITE(NOUT,*) 'LA_HEGV computes all the eigenvalues of a real'
   WRITE(NOUT,*) 'symmetric-definite generalized eigenproblem'
   WRITE(NOUT,*) 'A*x = lambda*B*x'
   WRITE(NOUT,*) 'ON ENTRY: A, B'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   B - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, B, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   B - the triangular factor U from the Cholesky'
   WRITE(NOUT,*) '       factorization'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   B=BB
   CALL LA_HEGV(A,B,W,INFO=INFO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_HEGV:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'INFO = ',INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_HEGV(A, B, W, JOBZ='V', INFO=INFO)"
   WRITE(NOUT,*) 'LA_HEGV computes all the eigenvalues and eigenvectors'
   WRITE(NOUT,*) 'of a real symmetric-definite generalized eigenproblem'
   WRITE(NOUT,*) 'A*x = lambda*B*x'
   WRITE(NOUT,*) 'ON ENTRY: A, B'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   B - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, B, W'
   WRITE(NOUT,*) '   A - the eigenvectors normalized as follows:'
   WRITE(NOUT,*) '       Z**T*B*Z = I'
   WRITE(NOUT,*) '   B - the triangular factor U from the Cholesky'
   WRITE(NOUT,*) '       factorization'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   B=BB
   CALL LA_HEGV(A,B,W,JOBZ='V',INFO=INFO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_HEGV:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The normalized eigenvectors computed by LA_HEGV:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
   WRITE(NOUT,*) 'INFO = ',INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_HEGV(A, B, W, JOBZ='V', UPLO='L', INFO=INFO)"
   WRITE(NOUT,*) 'LA_HEGV computes all the eigenvalues and eigenvectors'
   WRITE(NOUT,*) 'of a real symmetric-definite generalized eigenproblem'
   WRITE(NOUT,*) 'A*x = lambda*B*x'
   WRITE(NOUT,*) 'ON ENTRY: A, B'
   WRITE(NOUT,*) '   A - the original matrix (lower triangular)'
   WRITE(NOUT,*) '   B - the original matrix (lower triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, B, W'
   WRITE(NOUT,*) '   A - the eigenvectors normalized as follows:'
   WRITE(NOUT,*) '       Z**T*B*Z = I'
   WRITE(NOUT,*) '   B - the triangular factor L from the Cholesky'
   WRITE(NOUT,*) '       factorization'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   B=BB
   CALL LA_HEGV(A,B,W,JOBZ='V',UPLO='L',INFO=INFO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_HEGV:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The normalized eigenvectors computed by LA_HEGV:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
   WRITE(NOUT,*) 'INFO = ',INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_HEGV(A, B, W, 2, 'V', 'L', INFO)"
   WRITE(NOUT,*) 'LA_HEGV computes all the eigenvalues and eigenvectors'
   WRITE(NOUT,*) 'of a real symmetric-definite generalized eigenproblem'
   WRITE(NOUT,*) 'A*B*x = lambda*x'
   WRITE(NOUT,*) 'ON ENTRY: A, B'
   WRITE(NOUT,*) '   A - the original matrix (lower triangular)'
   WRITE(NOUT,*) '   B - the original matrix (lower triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, B, W'
   WRITE(NOUT,*) '   A - the eigenvectors normalized as follows:'
   WRITE(NOUT,*) '       Z**T*B*Z = I'
   WRITE(NOUT,*) '   B - the triangular factor L from the Cholesky'
   WRITE(NOUT,*) '       factorization'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   B=BB
   CALL LA_HEGV(A,B,W,2,'V','L',INFO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_HEGV:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The normalized eigenvectors computed by LA_HEGV:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
   WRITE(NOUT,*) 'INFO = ',INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_HEGV(A, B, W, 3, 'V', INFO=INFO)"
   WRITE(NOUT,*) 'LA_HEGV computes all the eigenvalues and eigenvectors'
   WRITE(NOUT,*) 'of a real symmetric-definite generalized eigenproblem'
   WRITE(NOUT,*) 'B*A*x = lambda*x'
   WRITE(NOUT,*) 'ON ENTRY: A, B'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   B - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, B, W'
   WRITE(NOUT,*) '   A - the eigenvectors normalized as follows:'
   WRITE(NOUT,*) '       Z**T*inv(B)*Z = I'
   WRITE(NOUT,*) '   B - the triangular factor U from the Cholesky'
   WRITE(NOUT,*) '       factorization'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   B=BB
   CALL LA_HEGV(A,B,W,3,'V',INFO=INFO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_HEGV:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The normalized eigenvectors computed by LA_HEGV:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
   WRITE(NOUT,*) 'INFO = ',INFO
!
END PROGRAM LA_CHEGV_ET_EXAMPLE

      PROGRAM LA_CGESV_ET_EXAMPLE
!
!  -- LAPACK95 INTERFACE DRIVER ROUTINE (VERSION 3.0) --
!     UNI-C, DENMARK; UNIV. OF TENNESSEE, USA; NAG LTD., UK
!     SEPTEMBER, 2000
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GESV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Parameters" ..
      CHARACTER(LEN=*), PARAMETER :: FMT =                              &
     &                   '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
      INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N, NRHS
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE :: IPIV(:)
      COMPLEX(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:), DUMMY(:,:)
      REAL(WP), ALLOCATABLE :: RR(:,:)
!  .. "Executable Statements" ..
      WRITE (NOUT,*) 'CGESV ET_Example Program Results.'
      READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
      READ ( NIN, * ) N, NRHS
      ALLOCATE( A(N,N), AA(N,N), B(N,NRHS), BB(N,NRHS), IPIV(N), RR(N,N) )
!
      DO I = 1, N; READ (NIN, *) (RR(I, J), J = 1, N); ENDDO
      AA=RR
      DO J = 1, NRHS; BB(:,J) = SUM( AA, DIM=2)*J; ENDDO
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N; WRITE (NOUT,FMT) AA(I,:); ENDDO
      WRITE(NOUT,*) 'The RHS matrix B:'
      DO J = 1, NRHS; WRITE (NOUT,FMT) BB(:,J);
      ENDDO
!
      WRITE ( NOUT, * )'-----------------------------------------------'
      WRITE ( NOUT, * )
      WRITE ( NOUT, * )'Details of LA_CGESV LAPACK Subroutine Results.'
      WRITE ( NOUT, * )
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GESV( A, B, IPIV, INFO )'
      A=AA; B=BB
      CALL LA_GESV(  A, B, IPIV, INFO )
      WRITE(NOUT,*) 'B - the solution vectors computed by LA_GESV,',    &
     &              ' INFO = ', INFO
      DO J = 1, NRHS; WRITE (NOUT,FMT) B(:,J); END DO
      WRITE(NOUT,*) 'Pivot vector'
      WRITE(NOUT,*) IPIV
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GESV( A, B(:,1), IPIV, INFO )'
      A=AA; B=BB
      CALL LA_GESV(  A, B(:,1), IPIV, INFO )
      WRITE(NOUT,*) 'B - the solution vector computed by LA_GESV,',     &
     &              ' INFO = ', INFO
      WRITE (NOUT,FMT) B(:,1)
      WRITE(NOUT,*) 'Pivot vector'
      WRITE(NOUT,*) IPIV
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GESV( A, B, INFO=INFO )'
      A=AA; B=BB
      CALL LA_GESV(  A, B, INFO=INFO )
      WRITE(NOUT,*) 'B - the solution vector computed by LA_GESV,',     &
     &              ' INFO = ', INFO
      DO J = 1, NRHS; WRITE (NOUT,FMT) B(:,J); END DO
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GESV( A, B(:,1), INFO=INFO )'
      A=AA; B=BB
      CALL LA_GESV(  A, B(:,1), INFO=INFO )
      WRITE(NOUT,*) 'B - the solution vector computed by LA_GESV,',     &
     &              ' INFO = ', INFO
      WRITE (NOUT,FMT) B(:,1)
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GESV( DUMMY, B, INFO=INFO )'
      A=AA; B=BB
      CALL LA_GESV(  DUMMY, B, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GESV( DUMMY, B(:,1), INFO=INFO )'
      A=AA; B=BB
      CALL LA_GESV(  DUMMY, B(:,1), INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GESV( A, B(1:N-1,:), INFO=INFO )'
      A=AA; B=BB
      CALL LA_GESV(  A, B(1:N-1,:), INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GESV( A, B(1:N-1,1), INFO=INFO )'
      A=AA; B=BB
      CALL LA_GESV(  A, B(1:N-1,1), INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GESV( A, B, IPIV(1:N-1), INFO=INFO )'
      A=AA; B=BB
      CALL LA_GESV(  A, B, IPIV(1:N-1), INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
!
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GESV( A, B(:,1), IPIV(1:N-1) )'
      A=AA; B=BB
      CALL LA_GESV(  A, B(:,1), IPIV(1:N-1) )
      WRITE(NOUT,*) 'INFO = ', INFO
!
      END PROGRAM LA_CGESV_ET_EXAMPLE

      SUBROUTINE CGESV1_F95( A, B, IPIV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!     .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => SP
      USE LA_AUXMOD, ONLY: ERINFO
      USE F77_LAPACK, ONLY: GESV_F77 => LA_GESV
!     .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!     .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
!     .. ARRAY ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IPIV(:)
      COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
!     .. PARAMETERS ..
      CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GESV'
!     .. LOCAL SCALARS ..
      INTEGER :: LINFO, ISTAT, ISTAT1, SIPIV
!     .. LOCAL POINTERS ..
      INTEGER, POINTER :: LPIV(:)
!     .. INTRINSIC FUNCTIONS ..
      INTRINSIC SIZE, PRESENT, MAX
!     .. EXECUTABLE STATEMENTS ..
      LINFO = 0; ISTAT = 0
      IF( PRESENT(IPIV) )THEN
         SIPIV = SIZE(IPIV)
      ELSE
         SIPIV = SIZE(A,1)
      END IF
!     .. TEST THE ARGUMENTS
      IF( SIZE( A, 2 ) /= SIZE(A,1) .OR. SIZE(A,1) < 0 ) THEN; LINFO = -1
      ELSE IF( SIZE( B ) /= SIZE(A,1) ) THEN; LINFO = -2
      ELSE IF( SIPIV /= SIZE(A,1) )THEN; LINFO = -3
      ELSE IF ( SIZE(A,1) > 0 ) THEN
         IF( PRESENT(IPIV) )THEN; LPIV => IPIV
         ELSE; ALLOCATE( LPIV(SIZE(A,1)), STAT = ISTAT ); END IF
         IF ( ISTAT == 0 ) THEN
!        .. CALL LAPACK77 ROUTINE ..
            CALL GESV_F77( SIZE(A,1), 1, A, MAX(1,SIZE(A,1)), LPIV, B, MAX(1,SIZE(A,1)),         &
                           LINFO )
         ELSE; LINFO = -100; END IF
         IF( .NOT.PRESENT(IPIV) ) DEALLOCATE(LPIV, STAT = ISTAT1 )
      END IF
      CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
      END SUBROUTINE CGESV1_F95

      SUBROUTINE WPRINT(SRNAME, PAR, MSG)
      CHARACTER*6 SRNAME
      CHARACTER*(*) MSG
      LOGICAL PAR
      IF (PAR) THEN
        PRINT *, 'The test of ', SRNAME, ' started. ', MSG
      ELSE
        PRINT *, 'The test of ', SRNAME, ' ended. ', MSG
      END IF
      RETURN
      END

PROGRAM LA_CHEEV_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_HEEV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
   INTEGER, PARAMETER :: NIN = 5, NOUT = 6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, INFO, N 
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), W(:)
   COMPLEX(WP), ALLOCATABLE :: A(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE(NOUT,*) 'CHEEV ET_Example Program Results.'
   READ(NIN,*) ! SKIP HEADING IN DATA FILE
   READ(NIN,*) N
   ALLOCATE ( A(N,N), AA(N,N), W(N) )
      DO I = 1, N
        READ(NIN,*) (AA(I, J), J = 1, N)
      ENDDO
   A=AA
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      ENDDO
!
   WRITE(NOUT,*) '---------------------------------------------------------'
   WRITE(NOUT,*)
   WRITE ( NOUT, * )'Details of LA_CHEEV LAPACK Subroutine Results.'
   WRITE(NOUT,*)
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HEEV(A, W, INFO=INFO)'
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   CALL LA_HEEV(A,W,INFO=INFO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_HEEV:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'INFO = ',INFO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_HEEV(A, W, 'V')"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   CALL LA_HEEV(A,W,'V')
   WRITE(NOUT,*) 'The eigenvalues computed by LA_HEEV:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_HEEV:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_HEEV(A, W, 'V', 'L')"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (lower triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   CALL LA_HEEV(A,W,'V','L')
   WRITE(NOUT,*) 'The eigenvalues computed by LA_HEEV:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_HEEV:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_HEEV(A, W, UPLO='L')"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (lower triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   CALL LA_HEEV(A,W,UPLO='L')
   WRITE(NOUT,*) 'The eigenvalues computed by LA_HEEV:'
   WRITE(NOUT,FMT) W(:)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HEEV(A, W, INFO=INFO)'
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   CALL LA_HEEV(A,W,INFO=INFO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_HEEV:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'INFO = ',INFO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_HEEV(A, W, 'V' )"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   CALL LA_HEEV(A,W,'V')
   WRITE(NOUT,*) 'The eigenvalues computed by LA_HEEV:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_HEEV:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
! 
END PROGRAM LA_CHEEV_ET_EXAMPLE

      PROGRAM LA_SSTEVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_STEVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N, IL, IU
      REAL(WP) :: ABSTOL
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: D(:), E(:), Z(:,:), W(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_STEV Example Program Results'
      N = 5; 
      ALLOCATE( D(N), E(N), Z(N,N), W(N) )

      OPEN(UNIT=21,FILE='stevd.ma',STATUS='UNKNOWN')
      DO J=1,N
         READ(21,*) D(J) 
      ENDDO
      CLOSE(21)

      OPEN(UNIT=21,FILE='steve.ma',STATUS='UNKNOWN')
      DO J=1,N
         READ(21,*) E(J) 
      ENDDO
      CLOSE(21)

      WRITE(*,*)' Vector D : '
      DO I=1,N
      WRITE(*,"(5(I5,1X))") INT(D(I))
      ENDDO

      WRITE(*,*)' Vector E : '
      DO I=1,N
      WRITE(*,"(5(I5,1X))") INT(E(I))
      ENDDO

      WRITE(*,*) 'CALL LA_STEVX( D, E, W, IL=1, IU=3, ABSTOL=1E-2 )'
      IL=1; IU=3; ABSTOL=1E-2
      CALL LA_STEVX( D, E, W, IL=IL, IU=IU, ABSTOL=ABSTOL )
  
      WRITE(*,*) ' W on exit : '
      DO I=1,N
      WRITE(*,"(5(F12.5,1X))") W(I)
      ENDDO

      END PROGRAM LA_SSTEVX_EXAMPLE

SUBROUTINE SSYGST_F95( A, B, ITYPE, UPLO, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: SYGST_F77 => LA_SYGST
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
   INTEGER, INTENT(IN), OPTIONAL :: ITYPE
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:)
   REAL(WP), INTENT(IN) :: B(:,:)
!-----------------------------------------------------------------
!
! Purpose
! =======
!
! LA_SYGST / LA_HEGST reduces a real symmetric-definite or complex
! Hermitian-definite generalized eigenproblem to standard form.
!
! If ITYPE = 1, the problem is A*x = lambda*B*x,
! and A is overwritten by inv(U**H)*A*inv(U) or inv(L)*A*inv(L**H)
!
! If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
! B*A*x = lambda*x, and A is overwritten by U*A*U**H or L**H*A*L.
!
! B must have been previously factorized as U**H*U or L*L**H 
! by LA_POTRF.
!
! =======
!
!    SUBROUTINE LA_SYGST / LA_HEGST( A, B, ITYPE, UPLO, INFO )
!       CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!       INTEGER, INTENT(IN), OPTIONAL :: ITYPE
!       INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       <type(<wp>), INTENT(IN) :: B(:,:)
!       <type(<wp>), INTENT(INOUT) :: A(:,:)
!    where
!       <wp>   ::= KIND(1.0) | KIND(1.0D0)
!       <type> ::= REAL | COMPLEX
!
! Defaults
! ========
!
! 1. If ITYPE is not present then ITYPE = 1 is assumed.
!       
! 2. If UPLO is not present then UPLO = 'U' is assumed.
!
! Arguments
! =========
!
! A       (input/output) either REAL or COMPLEX square array, 
!         shape (:,:), size(A,1) == size(A,2) >= 0.
!         On entry, the symmetric (Hermitian) matrix A.  
!            If UPLO = 'U', the upper triangular part of A contains
!               the upper triangular part of the matrix A, and the 
!               strictly lower triangular part of A is not referenced.
!            If UPLO = 'L', the lower triangular part of A contains
!               the lower triangular part of the matrix A, and the 
!               strictly upper triangular part of A is not referenced.
!         On exit, if INFO = 0, the transformed matrix, stored in the
!            same format as A.
!
! B       (input) either REAL or COMPLEX square array,
!         shape (:,:), size(B,1) == size(A,1).
!         The triangular factor from the Cholesky factorization of B,
!         as returned by LA_POTRF.
!
! ITYPE   Optional, (input) INTEGER
!         If ITYPE is present then:
!            = 1: compute inv(U**H)*A*inv(U) or inv(L)*A*inv(L**H);
!            = 2 or 3: compute U*A*U**H or L**H*A*L.
!         otherwise ITYPE = 1 is assumed.
!
! UPLO    Optional, (input) CHARACTER*1
!         If UPLO is present then:
!            = 'U':  Upper triangle of A is stored and B is factored as
!                    U**H*U;
!            = 'L':  Lower triangle of A is stored and B is factored as
!                    L*L**H.
!         otherwise UPLO = 'U' is assumed.
!
! INFO    Optional, (output) INTEGER
!         If INFO is present:
!            = 0: successful exit
!            < 0: if INFO = -i, the i-th argument had an illegal value
!         If INFO is not present and an error occurs, then the program
!            is terminated with an error message.
!
!------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_SYGST'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LUPLO
   INTEGER :: LINFO, N, LD, LITYPE
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE, MAX
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; N = SIZE(A,1); LD = MAX(1,N)
   IF( PRESENT(ITYPE) )THEN; LITYPE = ITYPE; ELSE; LITYPE = 1; END IF
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE( A, 2 ) /= N .OR. N < 0 )THEN; LINFO = -1
   ELSE IF( SIZE( B, 1 ) /= N .OR. SIZE( B, 2 ) /= N )THEN; LINFO = -2
   ELSE IF( LITYPE < 1 .OR. LITYPE > 3 )THEN; LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
   ELSE IF( N > 0 )THEN
!  .. CALL LAPACK77 ROUTINE
      CALL SYGST_F77( LITYPE, LUPLO, N, A, LD, B, LD, LINFO )
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO)
END SUBROUTINE SSYGST_F95

PROGRAM LA_SSYEVR_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_SYEVR
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
   CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, INFO, M, N
   CHARACTER(LEN = 1) :: UPLO
   REAL(WP) :: VL, VU
   INTEGER :: IL, IU
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), W(:)
   REAL(WP), ALLOCATABLE :: Z(:,:)
   REAL(WP), ALLOCATABLE :: A(:,:)
   INTEGER, ALLOCATABLE :: ISUPPZ(:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE(NOUT,*) 'SSYEVR ET_Example Program Results.'
   READ(NIN,*) ! SKIP HEADING IN DATA FILE
   READ(NIN,*) N
   ALLOCATE ( A(N,N), AA(N,N), W(N) )
   ALLOCATE (Z(N,N), ISUPPZ(N))
      DO I = 1, N
        READ(NIN,*) (AA(I, J), J = 1, N)
      ENDDO
   A=AA
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      ENDDO
!
   WRITE(NOUT,*) '---------------------------------------------------------'
   WRITE(NOUT,*)
   WRITE ( NOUT, * )'Details of LA_SSYEVR LAPACK Subroutine Results.'
   WRITE(NOUT,*)
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SYEVR(A, W, INFO=INFO)'
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVR(A,W,INFO=INFO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVR:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'INFO = ',INFO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVR(A,W)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVR:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVR:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, ABSTOL=0.01_WP)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   ABSTOL - the absolute error tolerance for the eigenvalues'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVR(A,W,  ABSTOL=0.01_WP)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVR:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVR:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, UPLO='L')"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (lower triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   UPLO = 'L'
   CALL LA_SYEVR(A, W, UPLO='L')
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVR:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVR:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, UPLO='L')"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (lower triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   UPLO = 'L'
   CALL LA_SYEVR(A,W,UPLO=UPLO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVR:'
   WRITE(NOUT,FMT) W(:)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, INFO=INFO)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A   - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W   - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVR(A,W,INFO=INFO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVR:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVR:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
   WRITE(NOUT,*) 'INFO = ',INFO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, IL=2, IU=3)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A     - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   IL,IU - the indices of the smallest and largest'
   WRITE(NOUT,*) '           eigenvalues to be returned'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVR(A,W,IL=2,IU=3)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVR:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVR:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, IL=2)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A     - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   IL,IU - the indices of the smallest and largest'
   WRITE(NOUT,*) '           eigenvalues to be returned (IU = N is assumed).'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVR(A,W,IL=2)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVR:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVR:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, VL=0.1_WP, VU=4.0_WP, M=M)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A     - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   VL,VU - the lower and upper bounds of the interval'
   WRITE(NOUT,*) '           to be searched for eigenvalues'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   WRITE(NOUT,*) '   M - the total number of eigenvalues found'
   A=AA
   W=0
   CALL LA_SYEVR(A,W,VL=0.1_WP,VU=4.0_WP,M=M)
   WRITE(NOUT,*) 'The total number of eigenvalues found = ',M
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVR:'
   WRITE(NOUT,FMT) W(:M)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, VU=4.0_WP, M=M)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A     - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   VL,VU - the lower and upper bounds of the interval'
   WRITE(NOUT,*) '           to be searched for eigenvalues (VL = -infinity'
   WRITE(NOUT,*) '           is assumed)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   WRITE(NOUT,*) '   M - the total number of eigenvalues found'
   A=AA
   W=0
   CALL LA_SYEVR(A,W,VU=4.0_WP,M=M)
   WRITE(NOUT,*) 'The total number of eigenvalues found = ',M
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVR:'
   WRITE(NOUT,FMT) W(:M)
! STARTING THE ERROR TESTS:
! ERROR 1
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A(:,1:N-1), W, VL=0.1_WP, VU=4.0_WP, M=M, INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A(:,1:N-1),W,VL=0.1_WP,VU=4.0_WP,M=M, INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 2
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W(1:N-1), VL=0.1_WP, VU=4.0_WP, M=M, INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A,W(1:N-1),VL=0.1_WP,VU=4.0_WP,M=M, INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 3
   UPLO = 'T'; VL = 1; VU = 10
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, 'T', VL=VL, VU=VU, M=M, INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A, W, JOBZ='T', VL=VL, VU=VU, M=M, INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 4
   UPLO = 'U'; VL = 1; VU = 10
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, 'V', UPLO='U', VL=VL, VU=VU, M=M, INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A, W, 'V', UPLO='U', VL=VL, VU=VU, M=M, INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 4
   UPLO = 'U'; VL = 1; VU = 10
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, 'U', VL=VL, VU=VU, M=M, INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A, W, 'U', VL=VL, VU=VU, M=M, INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 5
   UPLO = 'U'; VL = 1; VU = 10
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, JOBZ='V', UPLO='U', VL=VL, VU=VU, M=M, ISUPPZ=ISUPPZ(1:N-1), INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A, W, JOBZ='V', UPLO='U', VL=VL, VU=VU, M=M, ISUPPZ=ISUPPZ(1:N-1), INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 5
   UPLO = 'U'; VL = 1; VU = 10
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, 'U', VL=VL, VU=VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A, W, 'U', VL=VL, VU=VU, M=M, ISUPPZ=ISUPPZ, INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO   
! ERROR 6
   UPLO = 'U'; VL = 10; VU = 1
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, 'U', VL=VL, VU=VU, M=M, INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A, W, 'N', VL=VL, VU=VU, M=M, INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO   
! ERROR 7
   UPLO = 'U'; VL = 1; VU = 10; IL=1; IU=N
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, 'V', VL=VL, VU=VU, IL=IL, IU=IU, M=M, INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A, W, 'V', VL=VL, VU=VU, IL=IL, IU=IU, M=M, INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO   
! ERROR 8
   UPLO = 'U'; IL=-1; IU=N
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, 'N', IL=-1, IU=IU, M=M, INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A, W, 'N', IL=IL, IU=IU, M=M, INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 8
   UPLO = 'U'; IL=N; IU=N-1
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, '0', IL=N, IU=N-1, M=M, INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A, W, '0', IL=IL, IU=IU, M=M, INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO   
! ERROR 9
   UPLO = 'U'; IL=1; IU=N+1
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVR(A, W, UPLO='N', IL=1, IU=N+1, M=M, INFO=INFO)"
   A=AA; W=0
   CALL LA_SYEVR(A, W, UPLO='N', IL=IL, IU=IU, M=M, INFO=INFO)
   WRITE(NOUT,*) 'INFO = ', INFO   
   
END PROGRAM LA_SSYEVR_ET_EXAMPLE

SUBROUTINE ZPOSVX_F95(A, B, X, UPLO, AF, FACT, EQUED, S, FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: POSVX_F77 => LA_POSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
   CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
   COMPLEX(WP), INTENT(OUT) :: X(:,:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: S(:)
   COMPLEX(WP), INTENT(INOUT), OPTIONAL, TARGET :: AF(:,:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: FERR(:), BERR(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!   LA_POSVX computes the solution to a linear system of equations 
! A*X = B, where A is real symmetric or complex Hermitian and, in either
! case, positive definite, and where X and B are rectangular matrices or 
! vectors.
!   LA_POSVX can also optionally equilibrate the system if A is poorly 
! scaled, estimate the condition number of (the equilibrated) A, and
! compute error bounds.
! 
! =========
! 
!       SUBROUTINE LA_POSVX( A, B, X, UPLO=uplo, AF=af, FACT=fact, &
!                          EQUED=equed, S=s, FERR=ferr, BERR=berr, &
!                          RCOND=rcond, INFO=info )
!            <type>(<wp>), INTENT(INOUT) :: A(:,:), <rhs>
!            <type>(<wp>), INTENT(OUT) :: <sol>
!            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!            <type>(<wp>), INTENT(INOUT), OPTIONAL :: AF(:,:)
!            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
!            CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
!            REAL(<wp>), INTENT(INOUT), OPTIONAL :: S(:)
!            REAL(<wp>), INTENT(OUT), OPTIONAL :: <err>
!            REAL(<wp>), INTENT(OUT), OPTIONAL :: RCOND
!            INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!            <type> ::= REAL | COMPLEX
!            <wp>   ::= KIND(1.0) | KIND(1.0D0)
!            <rhs>  ::= B(:,:) | B(:)
!            <sol>  ::= X(:,:) | X(:)
!            <err>  ::= FERR(:), BERR(:) | FERR, BERR
! 
! Arguments
! =========
! 
! A        (input/output) REAL or COMPLEX square array, shape (:,:).
!          On entry, the matrix A or its equilibration:
!          If UPLO = 'U', then the upper triangular part of A contains 
! 	   the upper triangular part of (the equilibrated) A, and the 
! 	   strictly lower triangular part of A is not referenced.
!          If UPLO = 'L', then the lower triangular part of A contains 
! 	   the lower triangular part of (the equilibrated) A, and the 
! 	   strictly upper triangular part of A is not referenced.
!          If FACT = 'F' and EQUED = 'Y', then A has been equilibrated 
! 	   by the scaling factors in S during a previous call to 
! 	   LA_POSVX.
!          On exit, if FACT = 'E', then the equilibrated version of A is
! 	   stored in A; otherwise, A is unchanged.
! B        (input/output) REAL or COMPLEX array, shape (:,:) with 
!          size(B,1) = size(A,1) or shape (:) with size(B) = 
! 	   size(A,1).
!          On entry, the matrix B.
!          On exit, the scaled version of B if the system has been 
! 	   equilibrated; otherwise, B is unchanged.
! X        (output) REAL or COMPLEX array, shape (:,:) with size(X,1) = 
!          size(A,1) and size(X,2) = size(B,2), or shape (:) with size(X)
! 	   = size(A,1).
!          The solution matrix X .
! UPLO     Optional (input) CHARACTER(LEN=1).
!            = 'U': Upper triangle of A is stored;
!            = 'L': Lower triangle of A is stored.
!          Default value: 'U'.
! AF       Optional (input or output) REAL or COMPLEX array, shape (:,:)
!          with the same size as A.
!          If FACT = 'F' then AF is an input argument that contains the 
! 	   factor U or L from the Cholesky factorization of (the 
! 	   equilibrated) A, in the same storage format as A, returned by
! 	   a previous call to LA_POSVX
!          If FACT /= 'F' then AF is an output argument that contains the
! 	   factor U or L from the Cholesky factorization of (the 
! 	   equilibrated) A in the same storage format as A.
! FACT     Optional (input) CHARACTER(LEN=1).
!          Specifies whether the factored form of the matrix A is
! 	   supplied on entry, and, if not, whether A should be 
! 	   equilibrated before it is factored.
!            = 'N': The matrix A will be copied to AF and factored 
! 	          (no equilibration).
!            = 'E': The matrix A will be equilibrated, then copied to AF
! 	          and factored.
!            = 'F': AF contains the factored form of (the equilibrated)
! 	          A.
!          Default value: 'N'.
! EQUED    Optional (input or output) CHARACTER(LEN=1).
!          Specifies the form of equilibration that was done.
!          EQUED is an input argument if FACT = 'F', otherwise it is an
!          output argument:
!            = 'N': No equilibration (always true if FACT = 'N').
!            = 'Y': Equilibration, i.e., A has been premultiplied and 
! 	          postmultiplied by diag(S).
!          Default value: 'N'.
! S        Optional (input or output) REAL array, shape (:) with size(S)=
!          size(A,1). 
! 	   The scaling factors for A.
!          S is an input argument if FACT = 'F' and EQUED = 'Y'.
!          S is an output argument if FACT = 'E' and EQUED = 'Y'.
! FERR     Optional (output) REAL array of shape (:), with size(FERR) =
!          size(X,2), or REAL scalar.
!          The estimated forward error bound for each solution vector 
! 	   X(j) (the j-th column of the solution matrix X). If XTRUE is 
! 	   the true solution corresponding to X(j), FERR(j) is an 
! 	   estimated upper bound for the magnitude of the largest element
! 	   in (X(j)-XTRUE) divided by the magnitude of the largest 
! 	   element in X(j). The estimate is as reliable as the estimate
!          for RCOND, and is almost always a slight overestimate of the 
! 	   true error.
! BERR     Optional (output) REAL array of shape (:), with size(BERR) = 
!          size(X,2), or REAL scalar.
!          The componentwise relative backward error of each solution 
! 	   vector X(j) (i.e., the smallest relative change in any element 
! 	   of A or B that makes X(j) an exact solution).
! RCOND    Optional (output) REAL
!          The estimate of the reciprocal condition number of (the
! 	   equilibrated) A. If RCOND is less than the machine precision,
! 	   the matrix is singular to working precision. This condition is
!          indicated by a return code of INFO > 0.
! INFO     Optional (output) INTEGER
!          = 0: successful exit.
!          < 0: if INFO = -i, the i-th argument had an illegal value.
!          > 0: if INFO = i, and i is
!              <= n: the leading minor of order i of (the equilibrated)
! 	           A is not positive definite, so the factorization 
! 		   could not be completed and the solution and error 
! 		   bounds could not be computed. RCOND= 0 is returned.
!              = n+1: U or L is nonsingular, but RCOND is less than 
! 	           machine precision, so the matrix is singular to 
! 		   working precision. Nevertheless, the solution and 
! 		   error bounds are computed because the computed 
! 		   solution can be more accurate than the value of
!                    RCOND would suggest.
!          If INFO is not present and an error occurs, then the program
! 	   is terminated with an error message.
!----------------------------------------------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_POSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LUPLO, LEQUED
   INTEGER :: LINFO, NRHS, N, ISTAT, ISTAT1, S1AF, S2AF, SS, SFERR, SBERR
   REAL(WP) :: LRCOND, MVS
!  .. LOCAL POINTERS ..
   REAL(WP),  POINTER :: RWORK(:), LFERR(:), LBERR(:), LS(:)
   COMPLEX(WP),  POINTER :: WORK(:), LAF(:, :)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE, MINVAL, TINY
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(A, 1); NRHS = SIZE(B, 2)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(EQUED) .AND. LSAME(LFACT,'F') )THEN; LEQUED = EQUED
   ELSE; LEQUED='N'; END IF
   IF( PRESENT(AF) )THEN; S1AF = SIZE(AF,1); S2AF = SIZE(AF,2)
   ELSE; S1AF = N; S2AF = N; END IF
   IF( ( PRESENT(S) ) )THEN; SS = SIZE(S); ELSE; SS = N; END IF
   IF( PRESENT(S) .AND. LSAME(LFACT,'F') .AND. LSAME(LEQUED,'Y') ) THEN
       MVS = MINVAL(S); ELSE; MVS = TINY(1.0_WP); ENDIF
   IF( PRESENT(FERR) )THEN; SFERR = SIZE(FERR); ELSE; SFERR = NRHS; END IF
   IF( PRESENT(BERR) )THEN; SBERR = SIZE(BERR); ELSE; SBERR = NRHS; END IF
   IF(PRESENT(UPLO))THEN; LUPLO = UPLO; ELSE; LUPLO='U'; END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE(A, 2) /= N .OR. N < 0 )THEN; LINFO = -1
   ELSE IF( SIZE(B, 1) /= N .OR. NRHS < 0 )THEN; LINFO = -2
   ELSE IF( SIZE(X, 1) /= N .OR. SIZE(X, 2) /= NRHS )THEN; LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
   ELSE IF( S1AF /= N .OR. S2AF /= N ) THEN; LINFO = -5
   ELSE IF( ( .NOT. ( LSAME(LFACT,'F') .OR. LSAME(LFACT,'N') .OR. &
                    LSAME(LFACT,'E') ) ) .OR. &
      ( LSAME(LFACT,'F') .AND. .NOT.PRESENT(AF) ) )THEN; LINFO = -6
   ELSE IF( .NOT.LSAME(LEQUED,'N') .AND. .NOT.LSAME(LEQUED,'Y') )THEN; LINFO = -7
   ELSE IF( SS /= N .OR. LSAME(LFACT,'F') .AND. LSAME(LEQUED,'Y') &
      .AND. MVS  <= 0.0_WP )THEN; LINFO = -8
   ELSE IF( SFERR /= NRHS )THEN; LINFO = -9
   ELSE IF( SBERR /= NRHS )THEN; LINFO = -10
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(AF) ) THEN; ALLOCATE( LAF(N,N), STAT=ISTAT )
      ELSE; LAF => AF; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(S) )THEN; ALLOCATE( LS(N), STAT=ISTAT )
         ELSE; LS => S; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(FERR) )THEN; ALLOCATE( LFERR(NRHS), STAT=ISTAT )
         ELSE; LFERR => FERR; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(BERR) )THEN; ALLOCATE( LBERR(NRHS), STAT=ISTAT )
         ELSE; LBERR => BERR; END IF
      END IF
      IF( ISTAT == 0 ) ALLOCATE(WORK(2*N), RWORK(N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
         CALL POSVX_F77( LFACT, LUPLO, N, NRHS, A, N, LAF, N, LEQUED, LS, &
                  B, N, X, N, LRCOND, LFERR, LBERR, WORK, RWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(S) ) DEALLOCATE( LS, STAT=ISTAT1 )
      IF( .NOT.PRESENT(AF) ) DEALLOCATE( LAF, STAT=ISTAT1 )
      IF( .NOT.PRESENT(FERR) ) DEALLOCATE( LFERR, STAT=ISTAT1 )
      IF( .NOT.PRESENT(BERR) ) DEALLOCATE( LBERR, STAT=ISTAT1 )
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      IF( PRESENT(EQUED) .AND. .NOT.LSAME(LFACT,'F') ) EQUED=LEQUED
      DEALLOCATE( WORK, RWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE ZPOSVX_F95

      SUBROUTINE ZERRED( PATH, NUNIT )
*
*  -- LAPACK test routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     April 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  ZERRED tests the error exits for the eigenvalue driver routines for
*  DOUBLE PRECISION matrices:
*
*  PATH  driver   description
*  ----  ------   -----------
*  ZEV   ZGEEV    find eigenvalues/eigenvectors for nonsymmetric A
*  ZES   ZGEES    find eigenvalues/Schur form for nonsymmetric A
*  ZVX   ZGEEVX   ZGEEV + balancing and condition estimation
*  ZSX   ZGEESX   ZGEES + balancing and condition estimation
*  ZBD   ZGESVD   compute SVD of an M-by-N matrix A
*        ZGESDD   compute SVD of an M-by-N matrix A(by divide and
*                 conquer)
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX, LW
      PARAMETER          ( NMAX = 4, LW = 5*NMAX)
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D0, ZERO = 0.0D0 )
*     ..
*     .. Local Scalars ..
      CHARACTER*2        C2
      INTEGER            I, IHI, ILO, INFO, J, NT, SDIM
      DOUBLE PRECISION   ABNRM
*     ..
*     .. Local Arrays ..
      LOGICAL            B( NMAX )
      INTEGER            IW( 4*NMAX ), IN(100)
      DOUBLE PRECISION   R1( NMAX ), R2( NMAX ), RW( LW), S( NMAX )
      COMPLEX*16         A( NMAX, NMAX ), U( NMAX, NMAX ),
     $                   VL( NMAX, NMAX ), VR( NMAX, NMAX ),
     $                   VT( NMAX, NMAX ), W( 4*NMAX ), X( NMAX )
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHKXER, LA_TEST_ZGEES, LA_TEST_ZGEESX,
     &                   LA_TEST_ZGEEV,
     &                   LA_TEST_ZGEEVX, LA_TEST_ZGESDD, LA_TEST_ZGESVD
*     ..
*     .. External Functions ..
      LOGICAL            LSAMEN, ZSLECT
      EXTERNAL           LSAMEN, ZSLECT
*     ..
*     .. Arrays in Common ..
      LOGICAL            SELVAL( 20 )
      DOUBLE PRECISION   SELWI( 20 ), SELWR( 20 )
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT, SELDIM, SELOPT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
      COMMON             / SSLCT / SELOPT, SELDIM, SELVAL, SELWR, SELWI
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )
*
*     Initialize A
*
      DO 20 J = 1, NMAX
         DO 10 I = 1, NMAX
            A( I, J ) = ZERO
   10    CONTINUE
   20 CONTINUE
      DO 30 I = 1, NMAX
         A( I, I ) = ONE
   30 CONTINUE
      OK = .TRUE.
      NT = 0
*
      IF( LSAMEN( 2, C2, 'EV' ) ) THEN
*
*        Test ZGEEV
*
        SRNAMT = 'ZGEEV '
        DO I = 1, 4
          IN(I) = 1
        END DO
        DO I = 1, 4
          INFOT = I
          DO J = 1, 1
            INFO = J + 100*I
            CALL LA_TEST_ZGEEV('N', 'N', NMAX, A, NMAX, X, VL,
     &        NMAX, VR, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGEEV ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_ZGEEV('N', 'V', NMAX, A, NMAX, X, VL,
     &        NMAX, VR, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGEEV ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_ZGEEV('V', 'N', NMAX, A, NMAX, X, VL,
     &        NMAX, VR, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGEEV ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_ZGEEV('V', 'V', NMAX, A, NMAX, X, VL,
     &        NMAX, VR, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGEEV ', INFOT, NOUT, LERR, OK )
          END DO
        END DO 
*
      ELSE IF( LSAMEN( 2, C2, 'ES' ) ) THEN
*
*        Test ZGEES
*
        SRNAMT = 'ZGEES '
        DO I = 1, 4
          IN(I) = 1
        END DO
        DO I = 1, 4
          INFOT = I
          DO J = 1, 1
            INFO = J + 100*I
            CALL LA_TEST_ZGEES('N', 'N', ZSLECT, NMAX, A, NMAX,
     &        SDIM, X, VL, NMAX, W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEES ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_ZGEES('N', 'V', ZSLECT, NMAX, A, NMAX,
     &        SDIM, X, VL, NMAX, W, NMAX, RW, B, INFO)
            CALL CHKXER( 'ZGEES ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_ZGEES('V', 'N', ZSLECT, NMAX, A, NMAX,
     &        SDIM, X, VL, NMAX, W, NMAX, RW,  B, INFO )
            CALL CHKXER( 'ZGEES ', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_ZGEES('V', 'V', ZSLECT, NMAX, A, NMAX,
     &        SDIM, X, VL, NMAX, W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEES ', INFOT, NOUT, LERR, OK )
          END DO
        END DO
        NT = NT + 6
*
      ELSE IF( LSAMEN( 2, C2, 'VX' ) ) THEN
*
*        Test ZGEEVX
*
        SRNAMT = 'ZGEEVX'
        DO I = 1, 11
          IN(I) = 1
        END DO
        DO I = 1, 11
          IF (I/=6 .AND. I/= 7 .AND. I/=9) THEN
            INFOT = I
            DO J = 1, 1
              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'V', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'V', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'V', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'V', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'V', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'V', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'V', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'V', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )
!!!

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'N', 'V', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'N', 'V', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'N', 'V', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'N', 'V', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'V', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'V', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'V', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'P', 'V', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'N', 'V', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'N', 'V', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'N', 'V', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'N', 'V', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'V', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'V', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'V', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'S', 'V', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'N', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'N', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'N', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'N', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'N', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'N', 'V', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'N', 'V', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'N', 'V', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'N', 'V', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'V', 'N', 'N', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'V', 'N', 'E', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'V', 'N', 'V', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I  
              CALL LA_TEST_ZGEEVX( 'B', 'V', 'N', 'B', NMAX, A, NMAX,
     &          X, VL, NMAX, VR, NMAX, ILO,
     &          IHI, S, ABNRM, R1, R2, W, NMAX, RW, INFO )
              CALL CHKXER( 'ZGEEVX', INFOT, NOUT, LERR, OK )
            ENDDO
          ENDIF
        ENDDO
        
         NT = NT + 10
*
      ELSE IF( LSAMEN( 2, C2, 'SX' ) ) THEN
*
*        Test ZGEESX
*
        SRNAMT = 'ZGEESX'
        DO I = 1, 3
          IN(I) = 1
        END DO
        DO I = 1, 3
          INFOT = I
          DO J = 1, 1
            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'N', 'N', ZSLECT, 'N', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'N', 'N', ZSLECT, 'E', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'N', 'N', ZSLECT, 'V', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'N', 'N', ZSLECT, 'B', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'N', 'S', ZSLECT, 'N', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'N', 'S', ZSLECT, 'E', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'N', 'S', ZSLECT, 'V', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'N', 'S', ZSLECT, 'B', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'V', 'N', ZSLECT, 'N', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'V', 'N', ZSLECT, 'E', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'V', 'N', ZSLECT, 'V', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGEESX( 'V', 'N', ZSLECT, 'B', NMAX, A,
     &        NMAX, SDIM, X, VL, NMAX,
     &        R1( 1 ), R2( 1 ), W, NMAX, RW, B, INFO )
            CALL CHKXER( 'ZGEESX', INFOT, NOUT, LERR, OK )

          ENDDO
        ENDDO
        NT = NT + 7
*
      ELSE IF( LSAMEN( 2, C2, 'BD' ) ) THEN
*
*        Test ZGESVD
*
        SRNAMT = 'ZGESVD'
        DO I = 2, 6
          IN(I) = 1
        END DO
        DO I = 2, 6
          INFOT = I
          DO J = 1, 1
            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('A', 'A', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('A', 'S',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('A', 'O',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW,  INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('A', 'N', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW,  INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('S', 'A', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW,  INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('S', 'S',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('S', 'O',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('S', 'N', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW,  INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('O', 'A', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('O', 'S',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('O', 'O',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )
            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('O', 'N', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('N', 'A', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('N', 'S',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('N', 'O',NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )

            INFO = J + 100*I
            CALL LA_TEST_ZGESVD('N', 'N', NMAX, NMAX, A, NMAX, S, U,
     &        NMAX, VT, NMAX, W, NMAX, RW, INFO )
            CALL CHKXER( 'ZGESVD', INFOT, NOUT, LERR, OK )
          END DO
        END DO                                               
        NT = NT + 8
        IF( OK ) THEN
          WRITE( NOUT, FMT = 9999 )SRNAMT, NT
        ELSE
          WRITE( NOUT, FMT = 9998 )
        END IF
*
*        Test ZGESDD
*
        SRNAMT = 'ZGESDD'
        DO I = 2, 6
          IN(I) = 1
        END DO
        DO I = 2, 6
          IF (I/=5) THEN
            INFOT = I
            DO J = 1, 1
              INFO = J + 100*I
              CALL LA_TEST_ZGESDD( 'N', NMAX, NMAX, A, NMAX, S, U,
     &          NMAX, VT, NMAX, W, NMAX, RW, IW, INFO )
              CALL CHKXER( 'ZGESDD', INFOT, NOUT, LERR, OK ) 

              INFO = J + 100*I
              CALL LA_TEST_ZGESDD( 'A', NMAX, NMAX, A, NMAX, S, U,
     &          NMAX, VT, NMAX, W, NMAX, RW, IW, INFO )
              CALL CHKXER( 'ZGESDD', INFOT, NOUT, LERR, OK ) 

              INFO = J + 100*I
              CALL LA_TEST_ZGESDD( 'S', NMAX, NMAX, A, NMAX, S, U,
     &          NMAX, VT, NMAX, W, NMAX, RW, IW, INFO )
              CALL CHKXER( 'ZGESDD', INFOT, NOUT, LERR, OK ) 

              INFO = J + 100*I
              CALL LA_TEST_ZGESDD( 'O', NMAX, NMAX, A, NMAX, S, U,
     &          NMAX, VT, NMAX, W, NMAX, RW, IW, INFO )
              CALL CHKXER( 'ZGESDD', INFOT, NOUT, LERR, OK ) 
            ENDDO
          ENDIF
        ENDDO
        
        NT = NT - 2
         IF( OK ) THEN
            WRITE( NOUT, FMT = 9999 )SRNAMT, NT
         ELSE
            WRITE( NOUT, FMT = 9998 )
         END IF
      END IF
*
*     Print a summary line.
*
      IF( .NOT.LSAMEN( 2, C2, 'BD' ) ) THEN
         IF( OK ) THEN
            WRITE( NOUT, FMT = 9999 )SRNAMT, NT
         ELSE
            WRITE( NOUT, FMT = 9998 )
         END IF
      END IF
*
 9999 FORMAT( 1X, A6, ' passed the tests of the error exits (', I3,
     $      ' tests done)' )
 9998 FORMAT( ' *** ', A6, ' failed the tests of the error exits ***' )
      RETURN
*
*     End of ZERRED
*
      END

      PROGRAM LA_SGTSVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements"
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GTSVX
!  .."Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, N, NRHS
      INTEGER, ALLOCATABLE :: IPIV(:)
      CHARACTER(LEN=1) :: TRANS
!  .. Local Arrays ..
      REAL(WP), ALLOCATABLE :: DL(:), D(:), DU(:), DLF(:), &
                DF(:), DUF(:), DU2(:), B(:,:),X(:,:)

!  .. "Executable Statements" ..
       WRITE (*,*) 'SGTSVX Example Program Results.'
       N = 6; NRHS = 3

       ALLOCATE(DL(N-1), DLF(N-1), D(N), DF(N), DU(N-1), DUF(N-1), &
                DU2(N-2), B(N,NRHS), X(N,NRHS), IPIV(N) )

      
       OPEN(UNIT=21,FILE='gtsv.ma',STATUS='UNKNOWN')
          DO I=1,N-1
          READ(21,'(F2.0)') DL(I)
          ENDDO
          DO I=1,N
          READ(21,'(F2.0)') D(I)   
          ENDDO
          DO I=1,N-1
          READ(21,'(F2.0)') DU(I)
          ENDDO
       CLOSE(21)

       WRITE(*,*)'DU :'
       WRITE(*,"(8(I3,1X))") INT(DU(:));
       WRITE(*,*)'D :'
       WRITE(*,"(8(I3,1X))") INT(D(:)); 
       WRITE(*,*)'DL :'
       WRITE(*,"(8(I3,1X))") INT(DL(:))

       B = 0.0_WP
       DO I = 2, N-1; B(I,:) = DU(I-1) + D(I) + DL(I); ENDDO
       B(1,:) = D(1) + DL(1);B(N,:) = DU(N-1) + D(N)
       DO I = 1, NRHS; B(:,I) = B(:,I)*I; ENDDO
       WRITE(*,*)'B = '
       DO I=1,N; WRITE(*,"(8(F8.5,1X))") B(I,:)
       ENDDO

       WRITE(*,*) "CALL LA_GTSVX(DL, D, DU, B, X, DLF, DF, DUF, DU2, TRANS='T' )"
       TRANS='T'
       CALL LA_GTSVX(DL, D, DU, B, X, DLF, DF, DUF, DU2, IPIV, TRANS='T' )

       WRITE(*,*)'X = '
       DO I=1,N;WRITE(*,"(6(F8.5,1X))") X(I,:)
       ENDDO

       WRITE(*,*)'DLF on exit:'; WRITE(*,"(8(F8.5,1X))") DLF(:);
       WRITE(*,*)'DF on exit:';  WRITE(*,"(8(F8.5,1X))") DF(:);
       WRITE(*,*)'DUF on exit:'; WRITE(*,"(8(F8.5,1X))") DUF(:); 
       WRITE(*,*)'DU2 on exit:'; WRITE(*,"(8(F8.5,1X))") DU2(:);
       WRITE(*,*)'IPIV on exit:';WRITE(*,"(8(I6,1X))") IPIV(:);

       DEALLOCATE(DL,DLF,D,DF,DU,DUF,DU2,B,X)

       END PROGRAM LA_SGTSVX_EXAMPLE

SUBROUTINE ZSYSVX_F95(A, B, X, UPLO, AF, IPIV, FACT, &
                      FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: SYSVX_F77 => LA_SYSVX, ILAENV_F77 => ILAENV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(IN) :: A(:,:), B(:,:)
   COMPLEX(WP), INTENT(OUT) :: X(:,:)
   INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: IPIV(:)
   COMPLEX(WP), INTENT(INOUT), OPTIONAL, TARGET :: AF(:,:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: FERR(:), BERR(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!      LA_SYSVX computes the solution to a linear system of equations 
! A*X = B, where A is a real or complex symmetric matrix and X and B are
! rectangular matrices or vectors.
!      LA_HESVX computes the solution to a linear system of equations 
! A*X = B, where A is a complex Hermitian matrix and X and B are
! rectangular matrices or vectors.
!      LA_SYSVX and LA_HESVX can also optionally estimate the condition 
! number of A and compute error bounds.
! 
! =========
! 
!         SUBROUTINE LA_SYSVX / LA HESVX( A, B, X, UPLO=uplo, AF=af, &
!                        IPIV=ipiv, FACT=fact, FERR=ferr, BERR=berr, &
!                        RCOND=rcond, INFO=info )
!              <type>(<wp>), INTENT(IN) :: A(:,:), <rhs>
!              <type>(<wp>), INTENT(OUT) :: <sol>
!              CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!              <type>(<wp>), INTENT(INOUT), OPTIONAL :: AF(:,:)
!              INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
!              CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
!              REAL(<wp>), INTENT(OUT), OPTIONAL :: <err>, RCOND
!              INTEGER, INTENT(OUT), OPTIONAL :: INFO
!         where
!              <type> ::= REAL | COMPLEX
!              <wp>   ::= KIND(1.0) | KIND(1.0D0)
!              <rhs>  ::= B(:,:) | B(:)
!              <sol>  ::= X(:,:) | X(:)
!              <err>  ::= FERR(:), BERR(:) | FERR, BERR
! 
! Arguments
! =========
! 
! A       (input) REAL or COMPLEX square array, shape (:,:).
!         The symmetric or Hermitian matrix A.
!         If UPLO = 'U', the upper triangular part of A contains the 
! 	  upper triangular part of the matrix A, and the strictly lower
! 	  triangular part of A is not referenced. If UPLO = 'L', the 
! 	  lower triangular part of A contains the lower triangular part
! 	  of the matrix A, and the strictly upper triangular part of A is
! 	  not referenced.
! B       (input) REAL or COMPLEX array, shape (:,:) with size(B,1) = 
!         size(A,1) or shape (:) with size(B) = size(A,1).
!         The matrix B.
! X       (output) REAL or COMPLEX array, shape (:,:) with size(X,1) = 
!         size(A,1) and size(X,2) = size(B,2), or shape (:) with size(X)
! 	  = size(A,1).
!         The solution matrix X.
! UPLO    Optional (input) CHARACTER(LEN=1).
!            = 'U': Upper triangle of A is stored;
!            = 'L': Lower triangle of A is stored.
!         Default value: 'U'.
! AF      Optional (input or output) REAL or COMPLEX array, shape (:,:)
!         with the same size as A.
!         If FACT = 'F', then AF is an input argument that contains the 
! 	  block diagonal matrix D and the multipliers used to obtain the
! 	  factor L or U from the factorization of A, returned by a
!         previous call to LA_SYSVX or LA_HESVX.
!         If FACT = 'N', then AF is an output argument that contains the
! 	  block diagonal matrix D and the multipliers used to obtain the
! 	  factor L or U from the factorization of A.
! IPIV    Optional (input or output) INTEGER array, shape (:) with 
!         size(IPIV) = size(A,1).
!         If FACT = 'F', then IPIV is an input argument that contains 
! 	  details of the row and column interchanges and the block 
! 	  structure of D.
!         If IPIV(k) > 0 , then rows and columns k and IPIV(k) were 
! 	  interchanged and D(k,k) is a 1 by 1 diagonal block.
!         If IPIV(k) < 0 , then there are two cases:
!           1. If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0, then rows and
! 	     columns k-1 and -IPIV(k) were interchanged and 
! 	     D(k-1:k,k-1:k) is a 2 by 2 diagonal block.
!           2. If UPLO = 'L' and IPIV(k) = IPIV(k+1) < 0, then rows and
! 	     columns k+1 and -IPIV(k) were interchanged and 
! 	     D(k:k+1,k:k+1) is a 2 by 2 diagonal block.
!         If FACT = 'N', then IPIV is an output argument that contains 
! 	  details of the row and column interchanges and the block 
! 	  structure of D; as described above.
! FACT    Optional (input) CHARACTER(LEN=1).
!         Specifies whether the factored form of the matrix A has been 
! 	  supplied on entry.
!           = 'N': The matrix A will be copied to AF and factored.
!           = 'F': AF and IPIV contain the factored form of A.
!         Default value: 'N'.
! FERR    Optional (output) REAL array of shape (:), with 
!         size(FERR) = size(X,2), or REAL scalar.
!         The estimated forward error bound for each solution vector 
! 	  X(j) (the j-th column of the solution matrix X). If XTRUE is
! 	  the true solution corresponding to X(j), FERR(j) is an
!         estimated upper bound for the magnitude of the largest element
! 	  in (X(j)-XTRUE) divided by the magnitude of the largest element
! 	  in X(j). The estimate is as reliable as the estimate for RCOND, 
! 	  and is almost always a slight overestimate of the true error.
! BERR    Optional (output) REAL array of shape (:), with size(BERR) = 
!         size(X,2), or REAL scalar.
!         The componentwise relative backward error of each solution 
! 	  vector X(j) (i.e., the smallest relative change in any element
! 	  of A or B that makes X(j) an exact solution).
! RCOND   Optional (output) REAL
!         The estimate of the reciprocal condition number of A. If RCOND 
! 	  is less than the machine
!         precision, the matrix is singular to working precision. This 
! 	  condition is indicated by a return code of INFO > 0.
! INFO    (output) INTEGER
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: if INFO = i, and i is
!             <= n: D(i,i) = 0. The factorization has been completed, but
! 	         the block diagonal matrix D is singular, so the 
! 		 solution could not be computed.
!             = n+1: D is nonsingular, but RCOND is less than machine 
! 	         precision, so the matrix is singular to working 
! 		 precision. Nevertheless, the solution and error bounds
! 		 are computed because the computed solution can be more
! 		 accurate than the value of RCOND would suggest.
!             n is the order of A.
!         If INFO is not present and an error occurs, then the program is
! 	  terminated with an error message.
!------------------------------------------------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_SYSVX'
   CHARACTER(LEN=6), PARAMETER :: BSNAME = 'ZSYTRF'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LUPLO
   INTEGER :: LINFO, NRHS, N, NB, LWORK, ISTAT, ISTAT1, SIPIV, S1AF, S2AF, SFERR, SBERR
   REAL(WP) :: LRCOND
!  .. LOCAL POINTERS ..
   INTEGER, POINTER :: LPIV(:)
   REAL(WP),  POINTER :: RWORK(:), LFERR(:), LBERR(:)
   COMPLEX(WP),  POINTER :: WORK(:), LAF(:, :)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE, MAX
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(A, 1); NRHS = SIZE(B, 2)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
   IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; END IF
   IF( PRESENT(AF) )THEN; S1AF = SIZE(AF,1); S2AF = SIZE(AF,2)
   ELSE; S1AF = N; S2AF = N; END IF
   IF( PRESENT(FERR) )THEN; SFERR = SIZE(FERR); ELSE; SFERR = NRHS; END IF
   IF( PRESENT(BERR) )THEN; SBERR = SIZE(BERR); ELSE; SBERR = NRHS; END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE(A, 2) /= N .OR. N < 0 )THEN; LINFO = -1
   ELSE IF( SIZE(B, 1) /= N .OR. NRHS < 0 )THEN; LINFO = -2
   ELSE IF( SIZE(X, 1) /= N .OR. SIZE(X, 2) /= NRHS )THEN; LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
   ELSE IF( S1AF /= N .OR. S2AF /= N ) THEN; LINFO = -5
   ELSE IF( SIPIV /= N )THEN; LINFO = -6
   ELSE IF( ( .NOT. LSAME(LFACT,'F') .AND. .NOT. LSAME(LFACT,'N') ) .OR. &
     ( LSAME(LFACT,'F') .AND. .NOT.( PRESENT(AF) .AND. PRESENT(IPIV) ) ) )THEN; LINFO = -7
   ELSE IF( SFERR /= NRHS )THEN; LINFO = -8
   ELSE IF( SBERR /= NRHS )THEN; LINFO = -9
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(AF) ) THEN; ALLOCATE( LAF(N,N), STAT=ISTAT )
      ELSE; LAF => AF; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(IPIV) )THEN; ALLOCATE( LPIV(N), STAT=ISTAT )
         ELSE; LPIV => IPIV; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(FERR) )THEN; ALLOCATE( LFERR(NRHS), STAT=ISTAT )
         ELSE; LFERR => FERR; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(BERR) )THEN; ALLOCATE( LBERR(NRHS), STAT=ISTAT )
         ELSE; LBERR => BERR; END IF
      END IF
      IF( ISTAT == 0 )THEN
         NB = ILAENV_F77( 1, BSNAME, LUPLO, N, -1, -1, -1 )
         IF( NB <= 1 .OR. NB >= N ) NB = 1; LWORK = MAX(1,2*N,N*NB)
         ALLOCATE(WORK(LWORK), RWORK(N), STAT=ISTAT)
         IF( ISTAT /= 0 )THEN
            DEALLOCATE(WORK, RWORK, STAT=ISTAT1); LWORK = MAX(1,3*N)
            ALLOCATE(WORK(LWORK), RWORK(N), STAT=ISTAT)
            IF( ISTAT /= 0 ) THEN; LINFO = - 100
            ELSE; CALL ERINFO( -200, SRNAME, LINFO ); ENDIF
         ENDIF
      END IF
      IF( ISTAT == 0 )THEN
!        .. CALL LAPACK77 ROUTINE
         CALL SYSVX_F77( LFACT, LUPLO, N, NRHS, A, N, LAF, N, LPIV, B, N, X, N, &
                         LRCOND, LFERR, LBERR, WORK, LWORK, RWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(AF) ) DEALLOCATE( LAF, STAT=ISTAT1 )
      IF( .NOT.PRESENT(IPIV) ) DEALLOCATE( LPIV, STAT=ISTAT1 )
      IF( .NOT.PRESENT(FERR) ) DEALLOCATE( LFERR, STAT=ISTAT1 )
      IF( .NOT.PRESENT(BERR) ) DEALLOCATE( LBERR, STAT=ISTAT1 )
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      DEALLOCATE( WORK, RWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE ZSYSVX_F95

      SUBROUTINE SERRVX( PATH, NUNIT )
*
*  -- LAPACK90 test routine (version 1.1) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*     UNI-C, Denmark
*     April 8, 1999
*      
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  SERRVX tests the error exits for the REAL driver routines
*  for solving linear systems of equations.
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*     .. Local Scalar ..
      CHARACTER*3 PATH1
      SAVE PATH1
      DATA PATH1/'   '/
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX, ARGMAX
      PARAMETER          ( NMAX = 4, ARGMAX = 100 )
*     ..
*     .. Local Scalars ..
      CHARACTER          EQ
      CHARACTER*1        CHAR, IEQUED 
      CHARACTER*2        C2
      INTEGER            I, INFO, J, NRHS
      INTEGER            KL, KU
      REAL               RCOND
*     ..
*     .. Local Arrays ..
      INTEGER            IP( NMAX ), IW( NMAX ), IN(ARGMAX)
      REAL               A( NMAX, NMAX ), AF( NMAX, NMAX ), B( NMAX ),
     $                   C( NMAX ), R( NMAX ), R1( NMAX ), R2( NMAX ),
     $                   W( 2*NMAX ), X( NMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAMEN
      EXTERNAL           LSAMEN
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHKXER, LA_TEST_SGBSV, LA_TEST_SGBSVX,
     &                   LA_TEST_SGESV,
     $                   LA_TEST_SGESVX, LA_TEST_SGTSV, LA_TEST_SGTSVX,
     $                   LA_TEST_SPBSV, LA_TEST_SPBSVX, LA_TEST_SPOSV,
     &                   LA_TEST_SPOSVX, LA_TEST_SPPSV, LA_TEST_SPPSVX,
     &                   LA_TEST_SPTSV, LA_TEST_SPTSVX, LA_TEST_SSPSV,
     &                   LA_TEST_SSPSVX, LA_TEST_SSYSV, LA_TEST_SSYSVX
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          REAL
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )
*
*     Set the variables to innocuous values.
*
      DO 20 J = 1, NMAX
         DO 10 I = 1, NMAX
            A( I, J ) = 1. / REAL( I+J )
            AF( I, J ) = 1. / REAL( I+J )
   10    CONTINUE
         B( J ) = 0.
         R1( J ) = 0.
         R2( J ) = 0.
         W( J ) = 0.
         X( J ) = 0.
         C( J ) = 0.
         R( J ) = 0.
         IP( J ) = J
   20 CONTINUE
      OK = .TRUE.
*
      IF( LSAMEN( 2, C2, 'GE' ) ) THEN
*
*        SGESV
*
         SRNAMT = 'SGESV '
         DO I = 1, 3
            IN(I) = 1
         END DO
         DO I = 1, 3
            INFOT = I
            DO J = 1, IN(I)
               DO NRHS = 1, 2
                  INFO = J + 100*I
                  CALL LA_TEST_SGESV( NMAX, NRHS, A, NMAX, IP, B, NMAX,
     $                 INFO )
                  CALL CHKXER( 'SGESV ', INFOT, NOUT, LERR, OK )
               END DO
            END DO
         END DO
*
*        SGESVX
*
         SRNAMT = 'SGESVX'
         DO I = 1, 12
            IN(I) = 1
         END DO
         IN(3) = 2
         IN(4) = 2
         IN(6) = 4
         IN(8) = 4
         IN(9) = 3
         IN(10) = 3
         DO I = 1, 12
            INFOT = I
            DO J = 1, IN(I)
               DO NRHS = 1, 2
                  INFO = J + 100*I
                  CALL LA_TEST_SGESVX( CHAR, CHAR, NMAX, NRHS, A, NMAX,
     $               AF, NMAX, IP, EQ, R, C, B, NMAX, X, NMAX, RCOND,
     $               R1, R2, W, IW, INFO)
                  CALL CHKXER( 'SGESVX', INFOT, NOUT, LERR, OK )
               END DO
            END DO
         END DO
*
      ELSE IF( LSAMEN( 2, C2, 'GB' ) ) THEN
*
*        SGBSV
*
        SRNAMT = 'SGBSV '
        DO I = 1, 4
          INFOT = I
          DO J = 1, 1
            DO NRHS = 1, 2
              INFO = J + 100*I
              KL = (NMAX-1)/3
              KU = NMAX-2*KL-1
              CALL LA_TEST_SGBSV( NMAX, KL, KU, NRHS, A, NMAX, IP, B,
     $                            NMAX, INFO )
              CALL CHKXER( 'SGBSV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO

*
*        SGBSVX
*
        SRNAMT = 'SGBSVX'
        DO I = 1, 13
          IN(I) = 1
        END DO
        IN(3) = 2
        IN(4) = 2
        IN(5) = 2
        IN(7) = 4
        IN(9) = 4
        IN(10) = 3
        IN(11) = 3
        DO I = 1, 13
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              IF (I /= 1) THEN
                INFO = J + 100*I
                IEQUED = 'N'
                CALL LA_TEST_SGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'R'
                CALL LA_TEST_SGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'C'
                CALL LA_TEST_SGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                CALL LA_TEST_SGBSVX( 'F', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )           

                INFO = J + 100*I
                IEQUED = 'N'
                CALL LA_TEST_SGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'R'
                CALL LA_TEST_SGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'C'
                CALL LA_TEST_SGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                CALL LA_TEST_SGBSVX( 'F', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'N'
                CALL LA_TEST_SGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'R'
                CALL LA_TEST_SGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )


                INFO = J + 100*I
                IEQUED = 'C'
                CALL LA_TEST_SGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                CALL LA_TEST_SGBSVX( 'F', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'N'
                CALL LA_TEST_SGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'R'
                CALL LA_TEST_SGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'C'
                CALL LA_TEST_SGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                CALL LA_TEST_SGBSVX( 'N', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'N'
                CALL LA_TEST_SGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'R'
                CALL LA_TEST_SGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'C'
                CALL LA_TEST_SGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                CALL LA_TEST_SGBSVX( 'N', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'N'
                CALL LA_TEST_SGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'R'
                CALL LA_TEST_SGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'C'
                CALL LA_TEST_SGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                CALL LA_TEST_SGBSVX( 'N', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'N'
                CALL LA_TEST_SGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'R'
                CALL LA_TEST_SGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'C'
                CALL LA_TEST_SGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                CALL LA_TEST_SGBSVX( 'E', 'T', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'N'
                CALL LA_TEST_SGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'R'
                CALL LA_TEST_SGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'C'
                CALL LA_TEST_SGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                CALL LA_TEST_SGBSVX( 'E', 'N', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'N'
                CALL LA_TEST_SGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'R'
                CALL LA_TEST_SGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'C'
                CALL LA_TEST_SGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                IEQUED = 'B'
                CALL LA_TEST_SGBSVX( 'E', 'C', NMAX, NMAX, NMAX, NRHS,
     &            A, NMAX, AF, NMAX, IP, IEQUED, R, C,
     &            B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGBSVX', INFOT, NOUT, LERR, OK )

              END IF
            ENDDO
          ENDDO
        ENDDO                          
*
      ELSE IF( LSAMEN( 2, C2, 'GT' ) ) THEN
*
*        SGTSV
*
        SRNAMT = 'SGTSV '
        DO I = 1, 4
          IF (I/=2)  THEN
            INFOT = I
            DO J = 1, 1
              DO NRHS = 1, 2
                INFO = J + 100*I
                CALL LA_TEST_SGTSV( NMAX, NRHS, A(1,1), A(1,2),A(1, 3),
     $                              B, NMAX, INFO )
                CALL CHKXER( 'SGTSV ', INFOT, NOUT, LERR, OK )
              END DO
            END DO
          END IF
        END DO 
*
*        SGTSVX
*
        SRNAMT = 'SGTSVX'
        DO I = 1, 14
          IF (I/=2)  THEN
            INFOT = I
            DO J = 1, 1
              DO NRHS = 1, 2
                INFO = J + 100*I
                CALL LA_TEST_SGTSVX( 'N', 'N', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGTSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                CALL LA_TEST_SGTSVX( 'F', 'N', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGTSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                CALL LA_TEST_SGTSVX( 'N', 'T', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGTSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                CALL LA_TEST_SGTSVX( 'F', 'T', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGTSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                CALL LA_TEST_SGTSVX( 'N', 'C', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGTSVX', INFOT, NOUT, LERR, OK )

                INFO = J + 100*I
                CALL LA_TEST_SGTSVX( 'F', 'C', NMAX, NMAX, A( 1, 1 ),
     &            A( 1, 2 ), A( 1, 3 ),
     &            AF( 1, 1 ), AF( 1, 2 ), AF( 1, 3 ), AF( 1, 4 ),
     &            IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
                CALL CHKXER( 'SGTSVX', INFOT, NOUT, LERR, OK )

              ENDDO
            ENDDO
          ENDIF
        ENDDO                                            
*
      ELSE IF( LSAMEN( 2, C2, 'PO' ) ) THEN
*
*        SPOSV
*
        SRNAMT = 'SPOSV '
        DO I = 1, 3
          IN(I) = 1
        END DO
        DO I = 1, 3
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_SPOSV( 'U', NMAX, NRHS, A, NMAX, B, NMAX,
     $                              INFO )
              CALL CHKXER( 'SPOSV ', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_SPOSV( 'L', NMAX, NRHS, A, NMAX, B, NMAX,
     $                              INFO )
              CALL CHKXER( 'SPOSV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO 
*
*        SPOSVX
*
        SRNAMT = 'SPOSVX'
        DO I = 1, 10
          IN(I) = 1
        END DO
        DO I = 1, 10
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'F', 'U', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'F', 'U', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'F', 'L', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'F', 'L', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'N', 'U', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'N', 'U', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'N', 'L', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'N', 'L', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'E', 'U', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'E', 'U', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'E', 'L', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
              
              INFO = J + 100*I
              CALL LA_TEST_SPOSVX( 'E', 'L', NMAX, NMAX, A, NMAX,
     &          AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND, R1, R2,
     &          W, IW, INFO )
              CALL CHKXER( 'SPOSVX', INFOT, NOUT, LERR, OK )
            ENDDO
          ENDDO
        ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'PP' ) ) THEN
*
*        SPPSV
*
        SRNAMT = 'SPPSV '
        DO I = 1, 3
          IN(I) = 1
        END DO
        DO I = 1, 3
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_SPPSV( 'U', NMAX, NRHS, A(1,1), B,
     $                             NMAX, INFO)
              CALL CHKXER( 'SPPSV ', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_SPPSV( 'L', NMAX, NRHS, A(1,1), B,
     $                             NMAX, INFO)
              CALL CHKXER( 'SPPSV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO

*
*        SPPSVX
*
        SRNAMT = 'SPPSVX'
        DO I = 1, 10
          INFOT = I
          DO J = 1, 1
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_SPPSVX( 'F', 'U', NMAX, NMAX, A, AF, 'N',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPPSVX( 'F', 'U', NMAX, NMAX, A, AF, 'Y',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPPSVX( 'F', 'L', NMAX, NMAX, A, AF, 'N',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPPSVX( 'F', 'L', NMAX, NMAX, A, AF, 'Y',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPPSVX( 'N', 'U', NMAX, NMAX, A, AF, 'N',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPPSVX( 'N', 'U', NMAX, NMAX, A, AF, 'Y',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 1              00*I
              CALL LA_TEST_SPPSVX( 'N', 'L', NMAX, NMAX, A, AF, 'N',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPPSVX( 'N', 'L', NMAX, NMAX, A, AF, 'Y',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPPSVX( 'E', 'U', NMAX, NMAX, A, AF, 'N',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPPSVX( 'E', 'U', NMAX, NMAX, A, AF, 'Y',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPPSVX( 'E', 'L', NMAX, NMAX, A, AF, 'N',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPPSVX( 'E', 'L', NMAX, NMAX, A, AF, 'Y',
     &          C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPPSVX', INFOT, NOUT, LERR, OK )
            ENDDO
          ENDDO
        ENDDO                                                                   
*
      ELSE IF( LSAMEN( 2, C2, 'PB' ) ) THEN
*
*        SPBSV
*
        SRNAMT = 'SPBSV '
        DO I = 1, 3
          IN(I) = 1
        END DO
        DO I = 1, 3
          INFOT = I
          DO J = 1, IN(I)
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_SPBSV( 'U', NMAX, 1, NRHS, A, NMAX,
     $                               B, NMAX, INFO)
              CALL CHKXER( 'SPBSV ', INFOT, NOUT, LERR, OK )
              INFO = J + 100*I
              CALL LA_TEST_SPBSV( 'L', NMAX, 1, NRHS, A, NMAX,
     $                              B, NMAX, INFO)
              CALL CHKXER( 'SPBSV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO  
*
*        SPBSVX
*
        SRNAMT = 'SPBSVX'
        DO I = 1, 10
          IN(I) = 1
        END DO
        DO I = 2, 10
          INFOT = I
          DO J = 1, 1
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'F', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'F', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'F', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'F', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'N', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'N', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'N', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'N', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'E', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'E', 'U', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'E', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'N', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPBSVX( 'E', 'L', NMAX, NMAX-1, NMAX, A,
     &          NMAX, AF, NMAX, 'Y', C, B, NMAX, X, NMAX, RCOND,
     &          R1, R2, W, IW, INFO )
              CALL CHKXER( 'SPBSVX', INFOT, NOUT, LERR, OK )
            ENDDO
          ENDDO
        ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'PT' ) ) THEN
*
*        SPTSV
*
        SRNAMT = 'SPTSV '
        DO I = 1, 3
          IN(I) = 1
        END DO
        DO I = 2, 3
          INFOT = I
          DO J = 1, 1
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_SPTSV( NMAX, NRHS, A(1,1), A(1,2),
     $                            B, NMAX, INFO )
              CALL CHKXER( 'SPTSV ', INFOT, NOUT, LERR, OK )
            END DO
          END DO
        END DO

*
*        SPTSVX
*
        SRNAMT = 'SPTSVX'
        DO I = 1, 3
          IN(I) = 1
        END DO
        DO I = 2, 3
          INFOT = I
          DO J = 1, 1
            DO NRHS = 1, 2
              INFO = J + 100*I
              CALL LA_TEST_SPTSVX( 'F', NMAX, NMAX, A( 1, 1 ),
     &          A( 1, 2 ), AF( 1, 1 ), AF( 1, 2 ), B, NMAX, X,
     &          NMAX, RCOND, R1, R2, W, INFO )
              CALL CHKXER( 'SPTSVX', INFOT, NOUT, LERR, OK )

              INFO = J + 100*I
              CALL LA_TEST_SPTSVX( 'N', NMAX, NMAX, A( 1, 1 ),
     &          A( 1, 2 ), AF( 1, 1 ), AF( 1, 2 ), B, NMAX, X,
     &          NMAX, RCOND, R1, R2, W, INFO )
              CALL CHKXER( 'SPTSVX', INFOT, NOUT, LERR, OK )
            ENDDO
          ENDDO
        ENDDO
*
      ELSE IF( LSAMEN( 2, C2, 'SY' ) ) THEN
*
*        SSYSV
*
         SRNAMT = 'SSYSV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_SSYSV('U', NMAX, NRHS, A, NMAX,
     $                               A(1,2), B, NMAX, W, 1 ,INFO )
               CALL CHKXER( 'SSYSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_SSYSV('L', NMAX, NRHS, A, NMAX,
     $                              A(1,2), B, NMAX, W, 1 ,INFO )
               CALL CHKXER( 'SSYSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO  
*
*        SSYSVX
*
         SRNAMT = 'SSYSVX'
         DO I = 1, 9
           IN(I) = 1
         END DO
         DO I = 1, 9
           INFOT = I
           DO J = 1, 1
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_SSYSVX( 'N', 'L', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           IW, INFO )
               CALL CHKXER( 'SSYSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_SSYSVX( 'N', 'U', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           IW, INFO )
               CALL CHKXER( 'SSYSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_SSYSVX( 'F', 'L', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           IW, INFO )
               CALL CHKXER( 'SSYSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_SSYSVX( 'F', 'U', NMAX, NRHS, A, NMAX, AF,
     &           NMAX, IP, B, NMAX, X, NMAX, RCOND, R1, R2, W, NMAX,
     &           IW, INFO )
               CALL CHKXER( 'SSYSVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDDO
         ENDDO                                           
*
      ELSE IF( LSAMEN( 2, C2, 'SP' ) ) THEN
*
*        SSPSV
*
         SRNAMT = 'SSPSV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_SSPSV( 'U', NMAX, NRHS, A(1,1), A(1,2),
     $                              B, NMAX, INFO)
               CALL CHKXER( 'SSPSV ', INFOT, NOUT, LERR, OK )
               INFO = J + 100*I
               CALL LA_TEST_SSPSV( 'L', NMAX, NRHS, A(1,1), A(1 ,2),
     $                              B, NMAX, INFO)
               CALL CHKXER( 'SSPSV ', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO  
*
*        SSPSVX
*
         SRNAMT = 'SSPSVX'
         DO I = 1, 9
           IN(I) = 1
         END DO
         DO I = 1, 9
           INFOT = I
           DO J = 1, IN(I)
             DO NRHS = 1, 2
               INFO = J + 100*I
               CALL LA_TEST_SSPSVX( 'N', 'U', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'SSPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_SSPSVX( 'N', 'L', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'SSPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_SSPSVX( 'F', 'U', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'SSPSVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_SSPSVX( 'F', 'L', NMAX, NRHS, A, AF, IP, B,
     &           NMAX, X, NMAX, RCOND, R1, R2, W, IW, INFO )
               CALL CHKXER( 'SSPSVX', INFOT, NOUT, LERR, OK )
             END DO
           END DO
         END DO

       END IF
*
*     Print a summary line.
*
      IF( PATH1 .NE. PATH ) THEN
         PATH1 = PATH
         IF( OK ) THEN
            WRITE( NOUT, FMT = 9999 )PATH
         ELSE
            WRITE( NOUT, FMT = 9998 )PATH
         END IF
      END IF
*
 9999 FORMAT( 1X, A3, ' drivers passed the tests of the error exits' )
 9998 FORMAT( ' *** ', A3, ' drivers failed the tests of the error ',
     $      'exits ***' )
*
      RETURN
*
*     End of SERRVX
*
      END

SUBROUTINE DSBEVX_F95( A, W, UPLO, Z, VL, VU, IL, IU, &
                       M, IFAIL, Q,  ABSTOL, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: LAMCH_F77 => DLAMCH
   USE F77_LAPACK, ONLY: SBEVX_F77 => LA_SBEVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
   INTEGER, INTENT(IN), OPTIONAL :: IL, IU
   INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
   REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
!  .. ARRAY ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:), Q(:,:)
   REAL(WP), INTENT(INOUT) :: A(:,:)
   REAL(WP), INTENT(OUT) :: W(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_SBEVX / LA_HBEVX compute selected eigenvalues and, optionally, 
! the corresponding eigenvectors of a real symmetric/complex Hermitian 
! band matrix A. Eigenvalues and eigenvectors can be selected by 
! specifying either a range of values or a range of indices for the
! desired eigenvalues.
! 
! =========
! 
!        SUBROUTINE LA_SBEVX / LA_HBEVX( AB, W, UPLO=uplo, Z=z, &
!                 VL=vl, VU=vu, IL=il, IU=iu, M=m, IFAIL=ifail, &
!                 Q=q, ABSTOL=abstol, INFO=info )
!            <type>(<wp>), INTENT(INOUT) :: AB(:,:)
!            REAL(<wp>), INTENT(OUT) :: W(:)
!            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!            <type>(<wp>), INTENT(OUT), OPTIONAL :: Z(:,:)
!            REAL(<wp>), INTENT(IN), OPTIONAL :: VL, VU
!            INTEGER, INTENT(IN), OPTIONAL :: IL, IU
!            INTEGER, INTENT(OUT), OPTIONAL :: M
!            INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
!            <type>(<wp>), INTENT(OUT), OPTIONAL :: Q(:,:)
!            REAL(<wp>), INTENT(IN), OPTIONAL :: ABSTOL
!            INTEGER, INTENT(OUT), OPTIONAL :: INFO
!         where
!            <type> ::= REAL j COMPLEX
!            <wp> ::= KIND(1.0) j KIND(1.0D0)
! 
! Arguments
! =========
! 
! AB     (input/output) REAL or COMPLEX array, shape (:,:) with 
!        size(AB,1) = kd + 1 and size(AB,2) = n, where kd is the number
!        of subdiagonals or superdiagonals in the band and n is the order
!        of A.
!        On entry, the upper (if UPLO = 'U') or lower (if UPLO = 'L') 
!        triangle of matrix A in band storage. The kd + 1 diagonals of A 
!        are stored in the rows of AB so that the j-th column of A is 
!        stored in the j-th column of AB as follows:
!        if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j
!                                                   1<=j<=n
!        if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd)
!                                                   1<=j<=n.
!        On exit, AB is overwritten by values generated during the 
!        reduction of A to a tridiagonal matrix T . If UPLO = 'U' the 
!        first superdiagonal and the diagonal of T are returned in rows
!        kd and kd + 1 of AB. If UPLO = 'L', the diagonal and first 
!        subdiagonal of T are returned in the first two rows of AB.
! W      (output) REAL array, shape (:) with size(W) = n.
!        The first M elements contain the selected eigenvalues in 
!        ascending order.
! UPLO   Optional (input) CHARACTER(LEN=1).
!        = 'U' : Upper triangle of A is stored;
!        = 'L' : Lower triangle of A is stored.
!        Default value: 'U'.
! Z      Optional (output) REAL or COMPLEX array, shape (:,:) with 
!        size(Z,1) = n and size(Z,2) = M.
!        The first M columns of Z contain the orthonormal eigenvectors of
!        the matrix A corresponding to the selected eigenvalues, with the
!        i-th column of Z containing the eigenvector associated with the 
!        eigenvalue in W(i). If an eigenvector fails to converge, then 
!        that column of Z contains the latest approximation to the 
!        eigenvector, and the index of the eigenvector is returned in 
!        IFAIL.
!        Note: The user must ensure that at least M columns are supplied 
!        in the array Z. When the exact value of M is not known in 
!        advance, an upper bound must be used. In all cases M<=n.
! VL,VU  Optional (input) REAL.
!        The lower and upper bounds of the interval to be searched for
!        eigenvalues. VL < VU.
!        Default values: VL = -HUGE(<wp>) and VU = HUGE(<wp>), where 
!        <wp> ::= KIND(1.0) | KIND(1.0D0).
!        Note: Neither VL nor VU may be present if IL and/or IU is 
!        present.
! IL,IU  Optional (input) INTEGER.
!        The indices of the smallest and largest eigenvalues to be
!        returned. The IL-th through IU-th eigenvalues will be found.
!        1<=IL<=IU<=size(A,1).
!        Default values: IL = 1 and IU = size(A,1).
!        Note: Neither IL nor IU may be present if VL and/or VU is 
!        present.
!        Note: All eigenvalues are calculated if none of the arguments 
!        VL, VU, IL and IU are present.
! M      Optional (output) INTEGER.
!        The total number of eigenvalues found. 0<=M<=size(A,1).
!        Note: If IL and IU are present then M = IU - IL + 1.
! IFAIL  Optional (output) INTEGER array, shape (:) with size(IFAIL) = n.
!        If INFO = 0, the first M elements of IFAIL are zero.
!        If INFO > 0, then IFAIL contains the indices of the eigenvectors
!        that failed to converge.
!        Note: If Z is present then IFAIL should also be present.
! Q      Optional (output) REAL or COMPLEX square array, shape(:,:) with
!        size(Q,1) = n.
!        The n by n unitary matrix used in the reduction to tridiagonal 
!        form. This is computed only if Z is present.
! ABSTOL Optional (input) REAL.
!        The absolute error tolerance for the eigenvalues. An approximate
!        eigenvalue is accepted as converged when it is determined to lie
!        in an interval [a,b] of width less than or equal to
!        ABSTOL + EPSILON(1.0_<wp>) * max(|a|, |b|),
!        where <wp> is the working precision. If ABSTOL<=0, then 
!        EPSILON(1.0_<wp>)* ||T||1 will be used in its place, where
!        ||T||1 is the l1 norm of the tridiagonal matrix obtained by 
!        reducing A to tridiagonal form. Eigenvalues will be computed most
!        accurately when ABSTOL is set to twice the underflow threshold 
!        2 * LA_LAMCH(1.0_<wp>, 'Safe minimum'), not zero.
!        Default value: 0.0_<wp>.
!        Note: If this routine returns with INFO > 0, then some 
!        eigenvectors did not converge. Try setting ABSTOL to 
!        2 * LA_LAMCH(1.0_<wp>, 'Safe minimum').
! INFO   Optional (output) INTEGER
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value.
!        > 0: if INFO = i, then i eigenvectors failed to converge. Their
!        indices are stored in array IFAIL.
!        If INFO is not present and an error occurs, then the program is
!        terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_SBEVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBZ, LUPLO, LRANGE
   INTEGER :: N, LINFO, LD, LIL, LIU, LM, ISTAT, &
              SIFAIL, S1Z, S2Z, S1Q, S2Q, KD
   INTEGER, TARGET :: ISTAT1(1)
   REAL(WP), TARGET :: LLZ(1,1), LLQ(1,1)
   REAL(WP) :: LABSTOL, LVL, LVU
!  .. LOCAL ARRAYS ..
   INTEGER, POINTER :: IWORK(:), LIFAIL(:)
   REAL(WP), POINTER :: WORK(:), LQ(:,:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC HUGE, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0
   KD = SIZE(A,1)-1; N = SIZE(A,2); LD = MAX(1,SIZE(A,1))
   IF( PRESENT(IFAIL) )THEN; SIFAIL = SIZE(IFAIL); ELSE; SIFAIL = N; END IF
   IF( PRESENT(Q) )THEN; S1Q = SIZE(Q,1); S2Q = SIZE(Q,2)
   ELSE; S1Q = N; S2Q = N; END IF
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
   IF( PRESENT(VL) )THEN; LVL = VL; ELSE; LVL = -HUGE(LVL); ENDIF
   IF( PRESENT(VU) )THEN; LVU = VU; ELSE; LVU = HUGE(LVU); ENDIF
   IF( PRESENT(IL) )THEN; LIL = IL; ELSE; LIL = 1; ENDIF
   IF( PRESENT(IU) )THEN; LIU = IU; ELSE; LIU = N; ENDIF
   IF( PRESENT(Z) )THEN; S1Z = SIZE(Z,1); S2Z = SIZE(Z,2)
   ELSE; S1Z = 1; S2Z = 1; ENDIF
!  .. TEST THE ARGUMENTS
   IF( KD < 0 .OR. N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE( W ) /= N )THEN; LINFO = -2
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
   ELSE IF( PRESENT(Z) .AND. ( S1Z /= N .OR. S2Z /= N ) )THEN; LINFO = -4
   ELSE IF( LVU < LVL )THEN; LINFO = -5
   ELSE IF( (PRESENT(VL) .OR. PRESENT(VU)) .AND. &
            (PRESENT(IL) .OR. PRESENT(IU)) )THEN; LINFO = -6
   ELSE IF(( LIU < LIL .OR. LIL < 1 ) .AND. N>0 )THEN; LINFO = -7
   ELSE IF( N < LIU )THEN; LINFO = -8
   ELSE IF( SIFAIL /= N .OR. PRESENT(IFAIL).AND..NOT.PRESENT(Z) )THEN; LINFO = -10
   ELSE IF( S1Q /= N .OR. S2Q /= N .OR. PRESENT(Q).AND..NOT.PRESENT(Z) )THEN; LINFO = -11
   ELSE IF( N > 0 )THEN
      IF( PRESENT(VL) .OR. PRESENT(VU) )THEN; LRANGE = 'V'; LM = N
      ELSE IF( PRESENT(IL) .OR. PRESENT(IU) )THEN; LRANGE = 'I'; LM = LIU-LIL+1
      ELSE; LRANGE = 'A'; LM = N; END IF
      IF( PRESENT(Z) ) THEN; LJOBZ = 'V'
         IF( PRESENT(IFAIL) )THEN; LIFAIL => IFAIL
         ELSE; ALLOCATE( LIFAIL(N), STAT=ISTAT ); END IF
         IF( ISTAT == 0 )THEN
            IF( PRESENT(Q) )THEN; LQ => Q
            ELSE; ALLOCATE( LQ(N,N), STAT=ISTAT ); END IF
         END IF
      ELSE; LJOBZ = 'N'; LIFAIL => ISTAT1; LQ => LLQ; S1Q =1; ENDIF
!     .. DETERMINE THE WORKSPACE
      IF( ISTAT == 0 ) THEN
         ALLOCATE(IWORK(MAX(1,5*N)), WORK(MAX(1,7*N)), STAT=ISTAT)
         IF( ISTAT == 0 )THEN
            IF( PRESENT(ABSTOL) )THEN; LABSTOL = ABSTOL
            ELSE; LABSTOL = 2*LAMCH_F77('Safe minimum'); ENDIF
	    IF (PRESENT (Z)) THEN
               CALL SBEVX_F77( LJOBZ, LRANGE, LUPLO, N, KD, A, LD, LQ, S1Q, LVL, LVU, &
     &                LIL, LIU, LABSTOL, LM, W, Z, S1Z, WORK, &
     &                IWORK, LIFAIL, LINFO )
            ELSE
	       CALL SBEVX_F77( LJOBZ, LRANGE, LUPLO, N, KD, A, LD, LQ, S1Q, LVL, LVU, &
     &                LIL, LIU, LABSTOL, LM, W, LLZ, S1Z, WORK, &
     &                IWORK, LIFAIL, LINFO )
            ENDIF
            IF( PRESENT(M) ) M = LM
            W(LM+1:N) = 0.0_WP
         ELSE; LINFO = -100; END IF
      END IF
      IF( PRESENT(Z) .AND. .NOT.PRESENT(IFAIL) ) DEALLOCATE( LIFAIL, STAT=ISTAT1(1) )
      IF( PRESENT(Z) .AND. .NOT.PRESENT(Q) ) DEALLOCATE( LQ, STAT=ISTAT1(1) )
      DEALLOCATE(IWORK, WORK, STAT=ISTAT1(1))
   END IF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE DSBEVX_F95

 SUBROUTINE DGELS_F95( A, B, TRANS, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO, LSAME, LA_WS_GELS
    USE F77_LAPACK, ONLY: GELS_F77 => LA_GELS
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!       LA_GELS computes the minimum-norm least squares solution to one 
! or more real or complex linear systems of the form A*x = b, A^T*x = b
! or A^H*x = b using a QR or LQ factorization of A. Matrix A is 
! rectangular assumed to be of full rank. The vectors b and correspon-
! ding solution vectors x are the columns of matrices denoted B and X,
! respectively.
! 
! ==========
! 
!       SUBROUTINE LA_GELS( A, B, TRANS=trans, INFO=info )
!          <type>(<wp>), INTENT( INOUT ) :: A( :, : ), <rhs>
! 	   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
! 	   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!          <type> ::= REAL | COMPLEX
! 	   <wp>   ::= KIND(1.0) | KIND(1.0D0)
!          <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! A        (input/output) REAL or COMPLEX rectangular array, shape (:,:).
!          On entry, the matrix A.
! 	   On exit, if size(A,1) >= size(A,2), A is overwritten by
! 	   details of its QR factorization. If size(A,1) < size(A,2), A 
! 	   is overwritten by details of its LQ factorization.
! B        (input/output) REAL or COMPLEX array, shape (:,:) with 
!          size(B,1) = max(size(A,1), size(A,2)) or shape (:) with 
! 	   size(B) = max(size(A,1); size(A,2)).
! 	   On entry, the matrix B.
! 	   On exit, the solution matrix X. There are four cases:
! 	   1. If TRANS = 'N' and size(A,1) >= size(A,2), then rows 1 
! 	      to size(A,2) of B contain, columnwise, the least squares
! 	      solution vector(s); the residual sum of squares for the 
! 	      solution vector in a column of B is given by the sum of
! 	      squares of elements in rows size(A,2)+1 to size(A,1) of
! 	      that column.
! 	   2. If TRANS = 'N' and size(A,1) < size(A,2), then rows 1 
! 	      to size(A,2) of B contain, columnwise, the minimum norm 
! 	      solution vector(s).
! 	   3. If TRANS = 'T' or TRANS = 'C', and size(A,1)>=size(A,2),
! 	      then rows 1 to size(A,1) of B contain, columnwise, the 
! 	      minimum norm solution vector(s).
! 	   4. If TRANS = 'T' or TRANS = 'C', and size(A,1) < size(A,2),
! 	      then rows 1 to size(A,1) of B contain, columnwise, the 
! 	      least squares solution vector(s); the residual sum of 
! 	      squares for the solution vector in a column of B is given
! 	      by the sum of squares of elements in rows size(A,1)+1 to 
! 	      size(A,2) of that column.
! TRANS    Optional (input) CHARACTER(LEN=1).
!          Specifies the form of the system of equations:
! 	   = 'N': Ax = b (No transpose)
!          = 'T': A^T*x = b (Transpose)
! 	   = 'C': A^H*x = b (Conjugate transpose)
! 	   Default value: 'N'.
! INFO     Optional (output) INTEGER
!          = 0: successful exit.
! 	   < 0: if INFO = -i, the i-th argument had an illegal value.
! 	   If INFO is not present and an error occurs, then the program
! 	   is terminated with an error message.
!---------------------------------------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GELS'
    CHARACTER(LEN=1), PARAMETER :: VER = 'D'
!   .. LOCAL SCALARS ..
    CHARACTER(LEN=1) :: LTRANS
    INTEGER :: LINFO, ISTAT, ISTAT1, LWORK, N, M, NRHS
!   .. LOCAL POINTERS ..
    REAL(WP), POINTER :: WORK(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT, MAX, MIN
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2); NRHS = SIZE(B,2)
    IF( PRESENT(TRANS) )THEN; LTRANS = TRANS; ELSE; LTRANS = 'N'; ENDIF
!   .. TEST THE ARGUMENTS
    IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B, 1 ) /= MAX(1,M,N) .OR. NRHS < 0 ) THEN; LINFO = -2
    ELSE IF( .NOT.( LSAME(LTRANS,'N') .OR. LSAME(LTRANS,'T') ) )THEN; LINFO = -3
    ELSE
!   .. CALCULATE THE OPTIMAL WORKSPACE ..
       LWORK = LA_WS_GELS( VER, M, N, NRHS, LTRANS )
       ALLOCATE( WORK(LWORK), STAT = ISTAT )
       IF( ISTAT /= 0 ) THEN
          DEALLOCATE( WORK, STAT=ISTAT1 ); LWORK = MIN(M,N) + MAX(1,M,N,NRHS)
          ALLOCATE( WORK(LWORK), STAT = ISTAT )
          IF( ISTAT /= 0 ) CALL ERINFO( -200, SRNAME, LINFO )
       END IF
       IF ( ISTAT == 0 ) THEN
!      .. CALL LAPACK77 ROUTINE
          CALL GELS_F77( LTRANS, M, N, NRHS, A, MAX(1,M), B, MAX(1,M,N), &
                         WORK, LWORK, LINFO )
       ELSE; LINFO = -100; END IF
       DEALLOCATE(WORK, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE DGELS_F95

SUBROUTINE LA_TEST_CHEGVX(ITYPE, JOBZ, RANGE, UPLO, N, A, LDA, B,&
     &  LDB, VL, VU, IL, IU, ABSTOL, M, W, Z, LDZ, WORK, LWORK, RWORK, &
     &  IWORK, IFAIL, INFO )
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark
!     August 20, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_HEGVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      CHARACTER(LEN=1), INTENT(INOUT) :: JOBZ, RANGE, UPLO
      INTEGER, INTENT(IN) :: N, IL, IU, LDZ, LDA, LDB, LWORK
      INTEGER, INTENT(OUT) :: M
      INTEGER, INTENT(IN) :: ITYPE
      INTEGER, INTENT(INOUT) :: INFO
      REAL(WP), INTENT(IN) ::  ABSTOL, VL, VU
      INTRINSIC SIZE 
!  .. Array Arguments ..
      INTEGER, INTENT(OUT) ::  IWORK(1:5*N)
      COMPLEX(WP), INTENT(INOUT) :: A(1:LDA, 1:N), B(1:LDB, 1:N)
      COMPLEX(WP), INTENT(OUT) :: WORK(1:LWORK), Z(1:LDZ,1:MAX(1,N))
      REAL(WP), INTENT(OUT) :: W(1:N)
      REAL(WP), INTENT(OUT) :: RWORK(1: 7*N)
      INTEGER, INTENT(OUT) :: IFAIL(1:N)
      LOGICAL LSAME
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_HEGVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_CHEGVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      CHARACTER(LEN=1) :: IJOBZ, IRANGE, IUPLO
      INTEGER :: I, J, IA1, IA2, IB1, IB2, IW, IZ1, IZ2, IITYPE
      INTEGER :: IIL, IIU, IIFAIL
      REAL(WP) :: IVL, IVU, IABSTOL
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IA1 =  N; IA2 = N; IB1 = N; IB2=N; IITYPE= ITYPE
      IW = N;  IZ1 = N; IZ2 = N; IIL = IL; IIU = IU; IIFAIL = N
      IJOBZ = JOBZ; IRANGE = RANGE; IUPLO = UPLO
      IVL = VL; IVU = VU; IABSTOL = ABSTOL; M=0
      I =  INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE(1)
      IA2 = IA2 - 1
      CASE (2)
      IB2 = IB2 - 1 
      CASE (3)
      IW = IW - 1
      CASE (4)
      IITYPE = 5
      CASE (5)
      IUPLO = 'T'
      CASE (6)   
      IVU = IVL -1
      CASE (7)
        CALL LA_HEGVX(A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W, &
&         IITYPE, IJOBZ, IUPLO, IVL, IVU, IIL, &
&         IIU, M, IFAIL(1:IIFAIL), IABSTOL, INFO )
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )  
        RETURN
      CASE (8)
      IIU = IIL - 1
      CASE (9)
      IIU = N+1
      CASE (11)
      IIFAIL = IA2 - 1
      CASE (:-1, 10, 12:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF (LSAME(IJOBZ, 'V')) THEN
        IF (LSAME(IRANGE,'A')) THEN
          CALL LA_HEGVX( A(1:IA1, 1:IA2), B(1:IB1,1:IB2), W,  &
     &      IITYPE, IJOBZ, IUPLO, M=M, IFAIL=IFAIL(1:IIFAIL), &
     &      ABSTOL=IABSTOL, INFO=INFO )
        ELSE IF (LSAME(IRANGE,'I')) THEN
          CALL LA_HEGVX(A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W,  &
     &      IITYPE, IJOBZ, IUPLO, IL=IIL, IU=IIU, M=M, &
     &      IFAIL=IFAIL(1:IIFAIL), ABSTOL=IABSTOL, INFO=INFO ) 
        ELSE
          CALL LA_HEGVX( A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W, &
     &      IITYPE, IJOBZ, IUPLO, IVL, IVU, M=M, &
     &      IFAIL=IFAIL(1:IIFAIL), ABSTOL=IABSTOL, INFO=INFO )
        ENDIF
      ELSE
        IF (LSAME(IRANGE,'A')) THEN 
          CALL LA_HEGVX( A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W, IITYPE, &
     &      UPLO=IUPLO, M=M, ABSTOL=IABSTOL, INFO=INFO )
        ELSE IF (LSAME(IRANGE,'I')) THEN
          CALL LA_HEGVX( A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W, IITYPE, &
     &      UPLO=IUPLO,  IL=IIL, IU=IIU, M=M, &
     &      ABSTOL=IABSTOL, INFO=INFO )  
         ELSE
           CALL LA_HEGVX( A(1:IA1, 1:IA2), B(1:IB1, 1:IB2), W, IITYPE, &
     &       UPLO=IUPLO, VL=IVL, VU=IVU,  M=M, &
     &       ABSTOL=IABSTOL,  INFO=INFO )
         END IF
       ENDIF
       IF (N/=0) Z(1:IA1, 1:M) = A(1:IA1, 1:M)
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_CHEGVX
       

 SUBROUTINE CPOSV_F95( A, B, UPLO, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => SP
    USE LA_AUXMOD, ONLY: ERINFO, LSAME
    USE F77_LAPACK, ONLY: POSV_F77 => LA_POSV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_POSV computes the solution to a linear system of equations 
! A*X=B, where A is real symmetric or complex Hermitian and, in either
! case, positive definite, and where X and B are rectangular matrices 
! or vectors. The Cholesky decomposition is used to factor A as
! A = U^H*U if UPLO = 'U', or A = L*L^H if UPLO = 'L'
! where U is an upper triangular matrix and L is a lower triangular 
! matrix (L = U^H ). The factored form of A is then used to solve the
! above system.
! 
! =========
! 
!         SUBROUTINE LA_POSV( A, B, UPLO=uplo, INFO=info )
!            <type>(<wp>), INTENT(INOUT) :: A(:,:), <rhs>
!            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!            INTEGER, INTENT(OUT), OPTIONAL :: INFO
!         where
!            <type> ::= REAL | COMPLEX
!            <wp>   ::= KIND(1.0) | KIND(1.0D0)
!            <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! A     (input/output) REAL or COMPLEX square array, shape (:,:).
!       On entry, the matrix A.
!       If UPLO = 'U', the upper triangular part of A contains the upper 
!       triangular part of the matrix A, and the strictly lower triangular
!       part of A is not referenced. If UPLO = 'L', the lower triangular 
!       part of A contains the lower triangular part of the matrix A, and
!       the strictly upper triangular part of A is not referenced.
!       On exit, the factor U or L from the Cholesky factorization 
!       A = U^H*U = L*L^H.
! B     (input/output) REAL or COMPLEX array, shape (:,:) with 
!       size(B,1) = size(A,1) or shape (:) with size(B) = size(A,1).
!       On entry, the matrix B.
!       On exit, the solution matrix X.
! UPLO  Optional (input) CHARACTER(LEN=1)
!        = 'U': Upper triangle of A is stored;
!        = 'L': Lower triangle of A is stored.
!       Default value: 'U'.
! INFO  Optional (output) INTEGER
!       = 0: sauccessful exit.
!       < 0: if INFO = -i, the i-th argument had an illegal value.
!       > 0: if INFO = i, the leading minor of order i of A is not
!            positive definite, so the factorization could not be 
! 	   completed and the solution could not be computed.
!       If INFO is not present and an error occurs, then the program is
!       terminated with an error message.
!----------------------------------------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_POSV'
!   .. LOCAL SCALARS ..
    CHARACTER(LEN=1) :: LUPLO
    INTEGER :: LINFO, N, NRHS
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; N = SIZE(A,1); NRHS = SIZE(B,2)
    IF( PRESENT(UPLO) )THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
!   .. TEST THE ARGUMENTS
    IF( SIZE( A, 2 ) /= N .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B, 1 ) /= N .OR. NRHS < 0 ) THEN; LINFO = -2
    ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
    ELSE IF ( N > 0 ) THEN
       CALL POSV_F77( LUPLO, N, NRHS, A, N, B, N, LINFO )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO )
 END SUBROUTINE CPOSV_F95

 SUBROUTINE ZPTSV1_F95( D, E, B, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO
    USE F77_LAPACK, ONLY: PTSV_F77 => LA_PTSV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    REAL(WP), INTENT(INOUT) :: D(:)
    COMPLEX(WP), INTENT(INOUT) :: E(:), B(:)
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_PTSV'
!   .. LOCAL SCALARS ..
    INTEGER :: LINFO, N
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0
    N = SIZE(D)
!   .. TEST THE ARGUMENTS
    IF( N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( E ) /= N-1 .AND. N /= 0 ) THEN; LINFO = -2
    ELSE IF( SIZE( B ) /= N ) THEN; LINFO = -3
    ELSE IF ( N > 0 ) THEN
       CALL PTSV_F77( N, 1, D, E, B, N, LINFO )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO )
 END SUBROUTINE ZPTSV1_F95

SUBROUTINE ZHPSVX1_F95(A, B, X, UPLO, AF, IPIV, FACT, &
                      FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: HPSVX_F77 => LA_HPSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(IN) :: A(:), B(:)
   COMPLEX(WP), INTENT(OUT) :: X(:)
   INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: IPIV(:)
   COMPLEX(WP), INTENT(INOUT), OPTIONAL, TARGET :: AF(:)
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_HPSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LUPLO
   INTEGER :: LINFO, N, NN, ISTAT, ISTAT1, SIPIV, SAF
   REAL(WP) :: LRCOND, LFERR, LBERR
   COMPLEX(WP) :: WW
!  .. LOCAL POINTERS ..
   INTEGER, POINTER :: LPIV(:)
   REAL(WP),  POINTER :: RWORK(:)
   COMPLEX(WP),  POINTER :: WORK(:), LAF(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; NN = SIZE(A)
   WW = (-1+SQRT(1+8*REAL(NN,WP)))*0.5; N = INT(WW)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
   IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; END IF
   IF( PRESENT(AF) )THEN; SAF = SIZE(AF); ELSE; SAF = NN; END IF
!  .. TEST THE ARGUMENTS
    IF( NN < 0 .OR. AIMAG(WW) /= 0 .OR. REAL(N,WP) /= REAL(WW) ) THEN; LINFO = -1
   ELSE IF( SIZE(B) /= N )THEN; LINFO = -2
   ELSE IF( SIZE(X) /= N )THEN; LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
   ELSE IF( SAF /= NN ) THEN; LINFO = -5
   ELSE IF( SIPIV /= N )THEN; LINFO = -6
   ELSE IF( ( .NOT. LSAME(LFACT,'F') .AND. .NOT. LSAME(LFACT,'N') ) .OR. &
     ( LSAME(LFACT,'F') .AND. .NOT.( PRESENT(AF) .AND. PRESENT(IPIV) ) ) )THEN; LINFO = -7
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(AF) ) THEN; ALLOCATE( LAF(NN), STAT=ISTAT )
      ELSE; LAF => AF; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(IPIV) )THEN; ALLOCATE( LPIV(N), STAT=ISTAT )
         ELSE; LPIV => IPIV; END IF
      END IF
      IF( ISTAT == 0 )THEN
         ALLOCATE(WORK(MAX(1,3*N)), RWORK(N), STAT=ISTAT)
      END IF
      IF( ISTAT == 0 )THEN
!        .. CALL LAPACK77 ROUTINE
         CALL HPSVX_F77( LFACT, LUPLO, N, 1, A, LAF, LPIV, B, N, X, N, &
                         LRCOND, LFERR, LBERR, WORK, RWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(AF) ) DEALLOCATE( LAF, STAT=ISTAT1 )
      IF( .NOT.PRESENT(IPIV) ) DEALLOCATE( LPIV, STAT=ISTAT1 )
      IF( PRESENT(FERR) ) FERR = LFERR
      IF( PRESENT(BERR) ) BERR = LBERR
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      DEALLOCATE( WORK, RWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE ZHPSVX1_F95

SUBROUTINE ZHEEVX_F95( A, W, JOBZ, UPLO, VL, VU, IL, IU, &
                       M, IFAIL, ABSTOL, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: HEEVX_F77 => LA_HEEVX, ILAENV_F77 => ILAENV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. CHARACTER ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(IN), OPTIONAL :: IL, IU
   INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
   REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
!  .. ARRAY ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
   COMPLEX(WP), INTENT(INOUT) :: A(:,:)
   REAL(WP), INTENT(OUT) :: W(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!      LA_SYEVX / LA_HEEVX compute selected eigenvalues and, optionally,
! the corresponding eigenvectors of a real symmetric/complex Hermitian 
! matrix A. Eigenvalues and eigenvectors can be selected by specifying
! either a range of values or a range of indices for the desired 
! eigenvalues.
! 
! =========
! 
!         SUBROUTINE LA_SYEVX / LA_HEEVX ( A, W, JOBZ=jobz, UPLO=uplo, &
!                        VL=vl, VU=vu, IL=il, IU=iu, M=m, IFAIL=ifail, &
!                        ABSTOL=abstol, INFO=info )
!              <type>(<wp>), INTENT(INOUT) :: A(:,:)
!              REAL(<wp>), INTENT(OUT) :: W(:)
!              CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
!              REAL(<wp>), INTENT(IN), OPTIONAL :: VL, VU
!              INTEGER, INTENT(IN), OPTIONAL :: IL, IU
!              INTEGER, INTENT(OUT), OPTIONAL :: M
!              INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
!              REAL(<wp>), INTENT(IN), OPTIONAL :: ABSTOL
!              INTEGER, INTENT(OUT), OPTIONAL :: INFO
!         where
!              <type> ::= REAL | COMPLEX
!              <wp> ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! A      (input/output) REAL or COMPLEX square array, shape (:,:).
!        On entry, the matrix A.
!        If UPLO = 'U', the upper triangular part of A contains the upper
!        triangular part of the matrix A. If UPLO = 'L', the lower 
!        triangular part of A contains the lower triangular part of the
!        matrix A.
!        On exit:
!        If JOBZ = 'V', then the first M columns of A contain the 
!        orthonormal eigenvectors of the matrix A corresponding to the 
!        selected eigenvalues, with the i-th column of A containing the
!        eigenvector associated with the eigenvalue in W(i) . If an 
!        eigenvector fails to converge, then that column of A contains the
!        latest approximation to the eigenvector and the index of the 
!        eigenvector is returned in IFAIL.
!        If JOBZ = 'N', then the upper triangle (if UPLO = 'U') or the 
!        lower triangle (if UPLO = 'L') of A, including the diagonal, is 
!        destroyed.
! W      (output) REAL array, shape (:) with size(W) = size(A,1).
!        The first M elements contain the selected eigenvalues in 
!        ascending order.
! JOBZ   Optional (input) CHARACTER(LEN=1).
!        = 'N': Computes eigenvalues only;
!        = 'V': Computes eigenvalues and eigenvectors.
!        Default value: 'N'.
! UPLO   Optional (input) CHARACTER(LEN=1).
!        = 'U': Upper triangle of A is stored;
!        = 'L': Lower triangle of A is stored.
!        Default value: 'U'.
! VL,VU  Optional (input) REAL.
!        The lower and upper bounds of the interval to be searched for
!        eigenvalues. VL < VU.
!        Default values: VL = -HUGE(<wp>) and VU = HUGE(<wp>), where
!        <wp> ::= KIND(1.0) | KIND(1.0D0).
!        Note: Neither VL nor VU may be present if IL and/or IU is 
!        present.
! IL,IU  Optional (input) INTEGER.
!        The indices of the smallest and largest eigenvalues to be 
!        returned. The IL-th through IU-th eigenvalues will be found. 
!        1 <= IL <= IU <= size(A,1).
!        Default values: IL = 1 and IU = size(A,1).
!        Note: Neither IL nor IU may be present if VL and/or VU is 
!        present.
!        Note: All eigenvalues are calculated if none of the arguments
!        VL, VU, IL and IU are present.
! M      Optional (output) INTEGER.
!        The total number of eigenvalues found. 0 <= M <= size(A,1).
!        Note: If IL and IU are present then M = IU-IL+1.
! IFAIL  Optional (output) INTEGER array, shape (:) with size(IFAIL) =
!        size(A,1).
!        If INFO = 0, the first M elements of IFAIL are zero.
!        If INFO > 0, then IFAIL contains the indices of the eigenvectors
!        that failed to converge.
!        Note: IFAIL must be absent if JOBZ = 'N'.
! ABSTOL Optional (input) REAL.
!        The absolute error tolerance for the eigenvalues. An approximate
!        eigenvalue is accepted as converged when it is determined to lie 
!        in an interval [a,b] of width less than or equal to 
!        ABSTOL + EPSILON(1.0_<wp>) * max(|a|,|b|),
!        where <wp> is the working precision. If ABSTOL<= 0, then 
!        EPSILON(1.0_<wp>)*||T||1 will be used in its place, where ||T||1
!        is the l1 norm of the tridiagonal matrix obtained by reducing A
!        to tridiagonal form. Eigenvalues will be computed most accurately 
!        when ABSTOL is set to twice the underflow threshold
!        2 * LA_LAMCH(1.0_<wp>, 'Safe minimum'), not zero.
!        Default value: 0.0_<wp>.
!        Note: If this routine returns with INFO > 0, then some 
!        eigenvectors did not converge. Try setting ABSTOL to 
!        2 * LA_LAMCH(1.0_<wp>, 'Safe minimum').
! INFO   Optional (output) INTEGER.
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value.
!        > 0: if INFO = i, then i eigenvectors failed to converge. Their
!        indices are stored in array IFAIL.
!        If INFO is not present and an error occurs, then the program is 
!        terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_HEEVX'
   CHARACTER(LEN=6), PARAMETER :: BSNAME = 'ZHETRD'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBZ, LUPLO, LRANGE
   INTEGER :: N, LINFO, LD, LDZ, LZ, LIL, LIU, LM, LWORK, NB, ISTAT, &
              SIFAIL
   INTEGER, TARGET :: ISTAT1(1)
   REAL(WP) :: LABSTOL, LVL, LVU
!  .. LOCAL ARRAYS ..
   INTEGER, POINTER :: IWORK(:), LIFAIL(:)
   COMPLEX(WP), POINTER :: WORK(:), Z(:,:)
   REAL(WP), POINTER :: RWORK(:)
   COMPLEX(WP) :: WORKMIN(1)  
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC HUGE, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   N = SIZE(A,1); LD = MAX(1,N); LINFO = 0; ISTAT = 0
   IF( PRESENT(JOBZ) )THEN; LJOBZ = JOBZ; ELSE; LJOBZ = 'N'; ENDIF
   IF( PRESENT(M)) M=0 
   IF( PRESENT(IFAIL) )THEN
      SIFAIL = SIZE(IFAIL)
   ELSE
      SIFAIL = N
   END IF
   IF( PRESENT(UPLO) ) THEN
      LUPLO = UPLO
   ELSE
      LUPLO = 'U'
   END IF
   IF( PRESENT(VL) )THEN
      LVL = VL
   ELSE
      LVL = -HUGE(LVL)
   ENDIF
   IF( PRESENT(VU) )THEN
      LVU = VU
   ELSE
      LVU = HUGE(LVU)
   ENDIF
   IF( PRESENT(IL) )THEN
      LIL = IL
   ELSE
      LIL = 1
   ENDIF
   IF( PRESENT(IU) )THEN
      LIU = IU
   ELSE
      LIU = N
   ENDIF
!  .. TEST THE ARGUMENTS
   IF( SIZE( A, 2 ) /= N .OR. N < 0 )THEN
      LINFO = -1
   ELSE IF( SIZE( W ) /= N )THEN
      LINFO = -2
   ELSE IF( .NOT.LSAME(LJOBZ,'N') .AND. .NOT.LSAME(LJOBZ,'V') )THEN
      LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN
      LINFO = -4
   ELSE IF( LVU < LVL )THEN
      LINFO = -5
   ELSE IF( (PRESENT(VL) .OR. PRESENT(VU)) .AND. &
            (PRESENT(IL) .OR. PRESENT(IU)) )THEN
      LINFO = -6
   ELSE IF(( LIU < LIL .OR. LIL < 1) .AND. N>0  )THEN
      LINFO = -7
   ELSE IF( N < LIU )THEN
      LINFO = -8
   ELSE IF( SIFAIL /= N .OR. PRESENT(IFAIL).AND.LSAME(LJOBZ,'N') )THEN
          LINFO = -10
   ELSE IF( N > 0 )THEN
      IF( PRESENT(VL) .OR. PRESENT(VU) )THEN
         LRANGE = 'V'
         LM = N
      ELSE IF( PRESENT(IL) .OR. PRESENT(IU) )THEN
         LRANGE = 'I'
         LM = LIU-LIL+1
      ELSE
         LRANGE = 'A'
         LM = N
      END IF
      IF ( LSAME(LJOBZ,'V') ) THEN
         LDZ = N
         LZ = LM
      ELSE
         LDZ = 1
         LZ = 1
      ENDIF
      IF( PRESENT(IFAIL) )THEN;
         LIFAIL => IFAIL
      ELSE
         LIFAIL => ISTAT1
      ENDIF
!     .. DETERMINE THE WORKSPACE
      NB = ILAENV_F77( 1, BSNAME, LUPLO, N, -1, -1, -1 )
      IF( NB < 5 .OR. NB >= N )THEN
         NB = 5
      END IF
      LWORK = N*(3+NB)
      ALLOCATE(IWORK(5*N),RWORK(7*N),Z(LDZ,LM), STAT=ISTAT)
      IF( ISTAT /= 0 )THEN
         DEALLOCATE(IWORK, RWORK, Z, STAT=ISTAT1(1))
         ALLOCATE(IWORK(5*N), RWORK(7*N), Z(LDZ,LM), STAT=ISTAT)
         IF( ISTAT /= 0 ) THEN
            LINFO = - 100
         ELSE
            CALL ERINFO( -200, SRNAME, LINFO )
         ENDIF
      END IF
      IF( LINFO == 0 )THEN 
       LWORK = -1
       CALL HEEVX_F77( LJOBZ, LRANGE, LUPLO, N, A, LD, LVL, LVU, &
     &         LIL, LIU, LABSTOL, LM, W, Z, LDZ, WORKMIN, &
     &         LWORK, RWORK, IWORK, LIFAIL, LINFO )
       LWORK = WORKMIN(1)
       ALLOCATE (WORK(LWORK), STAT = ISTAT)
       IF  (ISTAT == 0) THEN                
         IF( PRESENT(ABSTOL) )THEN
            LABSTOL = ABSTOL
         ELSE
            LABSTOL = 0.0_WP
         ENDIF
!     .. CALL LAPACK77 ROUTINE
         CALL HEEVX_F77( LJOBZ, LRANGE, LUPLO, N, A, LD, LVL, LVU, &
                         LIL, LIU, LABSTOL, LM, W, Z, LDZ, WORK, &
                         LWORK, RWORK, IWORK, LIFAIL, LINFO )
         IF( LSAME(LJOBZ,'V') ) A(1:LDZ,1:LM) = Z(1:LDZ,1:LM)
         IF( PRESENT(M) ) M = LM
         W(LM+1:N) = 0.0_WP
      END IF
      ENDIF
      DEALLOCATE(IWORK, Z, RWORK, STAT=ISTAT1(1))
      DEALLOCATE (WORK)
   END IF
   CALL ERINFO(LINFO, SRNAME, INFO, ISTAT)
END SUBROUTINE ZHEEVX_F95

      MODULE F95_LAPACK
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!

      INTERFACE LA_LAMCH

       FUNCTION SLAMCH_F95( PRECISION, CMACH, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN) :: CMACH
           REAL(WP), INTENT(IN) :: PRECISION
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP) :: SLAMCH_F95
        END FUNCTION SLAMCH_F95

       FUNCTION DLAMCH_F95( PRECISION, CMACH, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN) :: CMACH
           REAL(WP), INTENT(IN) :: PRECISION
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP) :: DLAMCH_F95
        END FUNCTION DLAMCH_F95

      END INTERFACE

      INTERFACE LA_GGSVD

       SUBROUTINE SGGSVD_F95( A, B, ALPHA, BETA, K, L, U, V, Q, IWORK,  &
     &                        INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, K, L
          REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          REAL(WP), INTENT(OUT) :: ALPHA(:), BETA(:)
          REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: U(:,:), V(:,:),    &
     &                                               Q(:,:)
          INTEGER, INTENT(OUT), OPTIONAL :: IWORK(:)
        END SUBROUTINE SGGSVD_F95

       SUBROUTINE DGGSVD_F95( A, B, ALPHA, BETA, K, L, U, V, Q, IWORK,  &
     &                        INFO )
          USE LA_PRECISION, ONLY: WP => DP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, K, L
          REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          REAL(WP), INTENT(OUT) :: ALPHA(:), BETA(:)
          REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: U(:,:), V(:,:),    &
     &                                               Q(:,:)
          INTEGER, INTENT(OUT), OPTIONAL :: IWORK(:)
        END SUBROUTINE DGGSVD_F95

       SUBROUTINE CGGSVD_F95( A, B, ALPHA, BETA, K, L, U, V, Q, IWORK,  &
     &                        INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, K, L
          COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          REAL(WP), INTENT(OUT) :: ALPHA(:), BETA(:)
          COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: U(:,:), V(:,:), &
     &                                                  Q(:,:)
          INTEGER, INTENT(OUT), OPTIONAL :: IWORK(:)
        END SUBROUTINE CGGSVD_F95

      END INTERFACE

      INTERFACE LA_GEGV

       SUBROUTINE SGEGV_F95( A, B, ALPHAR, ALPHAI, BETA, VL, VR, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          REAL(WP), INTENT(OUT), OPTIONAL :: ALPHAR(:), ALPHAI(:),      &
     &                                       BETA(:)
          REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
        END SUBROUTINE SGEGV_F95

       SUBROUTINE DGEGV_F95( A, B, ALPHAR, ALPHAI, BETA, VL, VR, INFO )
          USE LA_PRECISION, ONLY: WP => DP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          REAL(WP), INTENT(OUT), OPTIONAL :: ALPHAR(:), ALPHAI(:),      &
     &                                       BETA(:)
          REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
        END SUBROUTINE DGEGV_F95


       SUBROUTINE CGEGV_F95( A, B, ALPHA, BETA, VL, VR, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          COMPLEX(WP), INTENT(OUT), OPTIONAL :: ALPHA(:), BETA(:)
          COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
        END SUBROUTINE CGEGV_F95

      END INTERFACE

      INTERFACE LA_GEGS

       SUBROUTINE SGEGS_F95( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR,      &
     &                       INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          REAL(WP), INTENT(OUT), OPTIONAL :: ALPHAR(:), ALPHAI(:),      &
     &                                       BETA(:)
          REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VSL(:,:), VSR(:,:)
        END SUBROUTINE SGEGS_F95

       SUBROUTINE DGEGS_F95( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR,      &
     &                       INFO )
          USE LA_PRECISION, ONLY: WP => DP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          REAL(WP), INTENT(OUT), OPTIONAL :: ALPHAR(:), ALPHAI(:),      &
     &                                       BETA(:)
          REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VSL(:,:), VSR(:,:)
        END SUBROUTINE DGEGS_F95


       SUBROUTINE CGEGS_F95( A, B, ALPHA, BETA, VSL, VSR, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          COMPLEX(WP), INTENT(OUT), OPTIONAL :: ALPHA(:), BETA(:)
          COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: VSL(:,:),       &
     &                                                  VSR(:,:)
        END SUBROUTINE CGEGS_F95

      END INTERFACE

        INTERFACE LA_SBGVX

        SUBROUTINE SSBGVX_F95( AB, BB, W, UPLO, Z, VL, VU, IL, IU, M,   &
     &                         IFAIL, Q, ABSTOL, INFO )
       USE LA_PRECISION, ONLY: WP => SP
       REAL(WP), INTENT(INOUT) :: AB(:,:), BB(:,:)
       REAL(WP), INTENT(OUT) :: W(:)
       CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  UPLO
       INTEGER, INTENT(OUT), OPTIONAL :: INFO
       REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:), Q(:,:)
       REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
       INTEGER, INTENT(IN), OPTIONAL :: IL, IU
       INTEGER, INTENT(OUT), OPTIONAL :: M
       INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
      END SUBROUTINE SSBGVX_F95

        SUBROUTINE DSBGVX_F95( AB, BB, W, UPLO, Z, VL, VU, IL, IU, M,   &
     &                         IFAIL, Q, ABSTOL, INFO )
       USE LA_PRECISION, ONLY: WP => DP
       REAL(WP), INTENT(INOUT) :: AB(:,:), BB(:,:)
       REAL(WP), INTENT(OUT) :: W(:)
       CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  UPLO
       INTEGER, INTENT(OUT), OPTIONAL :: INFO
       REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:), Q(:,:)
       REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
       INTEGER, INTENT(IN), OPTIONAL :: IL, IU
       INTEGER, INTENT(OUT), OPTIONAL :: M
       INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
      END SUBROUTINE DSBGVX_F95

       END INTERFACE
	     
       INTERFACE LA_HBGVX
       
       SUBROUTINE CHBGVX_F95( AB, BB, W, UPLO, Z, VL, VU, IL, IU, M,    &
     &                        IFAIL, Q, ABSTOL, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         COMPLEX(WP), INTENT(INOUT) :: AB(:,:), BB(:,:)
         REAL(WP), INTENT(OUT) :: W(:)
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  UPLO
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:),  Q(:,:)
         REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
         INTEGER, INTENT(IN), OPTIONAL :: IL, IU
         INTEGER, INTENT(OUT), OPTIONAL :: M
         INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
        END SUBROUTINE CHBGVX_F95
	
        END INTERFACE

        INTERFACE LA_SBGVD
	

        SUBROUTINE SSBGVD_F95( AB, BB, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT(INOUT) :: AB(:,:), BB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
         END SUBROUTINE SSBGVD_F95
	  

        SUBROUTINE DSBGVD_F95( AB, BB, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           REAL(WP), INTENT(INOUT) :: AB(:,:), BB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
         END SUBROUTINE DSBGVD_F95
	  
         END INTERFACE
		
         INTERFACE LA_HBGVD
	 
       SUBROUTINE CHBGVD_F95( AB, BB, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           COMPLEX(WP), INTENT(INOUT) :: AB(:,:), BB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(OUT), OPTIONAL,TARGET :: Z(:,:)
          END SUBROUTINE CHBGVD_F95
	  
        
         END INTERFACE

      INTERFACE LA_SBGV

       SUBROUTINE SSBGV_F95( A, B, W, UPLO, Z, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          REAL(WP), INTENT(OUT) :: W(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE SSBGV_F95

       SUBROUTINE DSBGV_F95( A, B, W, UPLO, Z, INFO )
          USE LA_PRECISION, ONLY: WP => DP
          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          REAL(WP), INTENT(OUT) :: W(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE DSBGV_F95

      END INTERFACE

      INTERFACE LA_HBGV

       SUBROUTINE CHBGV_F95( A, B, W, UPLO, Z, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          REAL(WP), INTENT(OUT) :: W(:)
          COMPLEX(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE CHBGV_F95

      END INTERFACE

        INTERFACE LA_SPGVX
 
        SUBROUTINE SSPGVX_F95( AP, BP, W, ITYPE, UPLO, Z, VL, VU, IL,   &
     &                         IU, M, IFAIL, ABSTOL, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         REAL(WP), INTENT(INOUT) :: AP(:), BP(:)
         REAL(WP), INTENT(OUT) :: W(:)
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  UPLO
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
         REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
         INTEGER, INTENT(IN), OPTIONAL :: IL, IU, ITYPE
         INTEGER, INTENT(OUT), OPTIONAL :: M
         INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
       END SUBROUTINE SSPGVX_F95

        SUBROUTINE DSPGVX_F95( AP, BP, W, ITYPE, UPLO, Z, VL, VU, IL,   &
     &                         IU, M, IFAIL, ABSTOL, INFO )
         USE LA_PRECISION, ONLY: WP => DP
         REAL(WP), INTENT(INOUT) :: AP(:), BP(:)
         REAL(WP), INTENT(OUT) :: W(:)
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  UPLO
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
         REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
         INTEGER, INTENT(IN), OPTIONAL :: IL, IU, ITYPE
         INTEGER, INTENT(OUT), OPTIONAL :: M
         INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
       END SUBROUTINE DSPGVX_F95

       END INTERFACE
	     
       INTERFACE LA_HPGVX
		    
       SUBROUTINE CHPGVX_F95( AP, BP, W, ITYPE, UPLO, Z, VL, VU, IL, IU,&
     &                        M, IFAIL, ABSTOL, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         COMPLEX(WP), INTENT(INOUT) :: AP(:), BP(:)
         REAL(WP), INTENT(OUT) :: W(:)
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  UPLO
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
         REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
         INTEGER, INTENT(IN), OPTIONAL :: IL, IU, ITYPE
         INTEGER, INTENT(OUT), OPTIONAL :: M
         INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
       END SUBROUTINE CHPGVX_F95

        END INTERFACE

      INTERFACE LA_SPGVD

       SUBROUTINE SSPGVD_F95( AP, BP, W, ITYPE, UPLO, Z, INFO )
        USE LA_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(INOUT) :: AP(:), BP(:)
        REAL(WP), INTENT(OUT) :: W(:)
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        INTEGER, INTENT(IN), OPTIONAL :: ITYPE
        INTEGER, INTENT(OUT), OPTIONAL :: INFO
        REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
       END SUBROUTINE SSPGVD_F95
     
       SUBROUTINE DSPGVD_F95( AP, BP, W, ITYPE, UPLO, Z, INFO )
        USE LA_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(INOUT) :: AP(:), BP(:)
        REAL(WP), INTENT(OUT) :: W(:)
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        INTEGER, INTENT(IN), OPTIONAL :: ITYPE
        INTEGER, INTENT(OUT), OPTIONAL :: INFO
        REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
       END SUBROUTINE DSPGVD_F95
     
        END INTERFACE
	    
        INTERFACE LA_HPGVD

       SUBROUTINE CHPGVD_F95( AP, BP, W, ITYPE, UPLO, Z, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         COMPLEX(WP), INTENT(INOUT) :: AP(:), BP(:)
         REAL(WP), INTENT(OUT) :: W(:)
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
         INTEGER, INTENT(IN), OPTIONAL :: ITYPE 
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
        END SUBROUTINE CHPGVD_F95

       END INTERFACE

      INTERFACE LA_SPGV

       SUBROUTINE SSPGV_F95( A, B, W, ITYPE, UPLO, Z, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
          INTEGER, INTENT(IN), OPTIONAL :: ITYPE
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:), B(:)
          REAL(WP), INTENT(OUT) :: W(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE SSPGV_F95

       SUBROUTINE DSPGV_F95( A, B, W, ITYPE, UPLO, Z, INFO )
          USE LA_PRECISION, ONLY: WP => DP
          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
          INTEGER, INTENT(IN), OPTIONAL :: ITYPE
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:), B(:)
          REAL(WP), INTENT(OUT) :: W(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE DSPGV_F95

      END INTERFACE

      INTERFACE LA_HPGV

       SUBROUTINE CHPGV_F95( A, B, W, ITYPE, UPLO, Z, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
          INTEGER, INTENT(IN), OPTIONAL :: ITYPE
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          COMPLEX(WP), INTENT(INOUT) :: A(:), B(:)
          REAL(WP), INTENT(OUT) :: W(:)
          COMPLEX(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE CHPGV_F95

      END INTERFACE

      INTERFACE LA_GESVD

       SUBROUTINE SGESVD_F95( A, S, U, VT, WW, JOB, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          CHARACTER(LEN=1), OPTIONAL, INTENT(IN) :: JOB
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT) :: S(:)
          REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: WW(:)
         REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: U(:,:), VT(:,:)
        END SUBROUTINE SGESVD_F95

       SUBROUTINE DGESVD_F95( A, S, U, VT, WW, JOB, INFO )
          USE LA_PRECISION, ONLY: WP => DP
          CHARACTER(LEN=1), OPTIONAL, INTENT(IN) :: JOB
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT) :: S(:)
          REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: WW(:)
         REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: U(:,:), VT(:,:)
        END SUBROUTINE DGESVD_F95

       SUBROUTINE CGESVD_F95( A, S, U, VT, WW, JOB, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          CHARACTER(LEN=1), OPTIONAL, INTENT(IN) :: JOB
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          COMPLEX(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT) :: S(:)
          REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: WW(:)
         COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: U(:,:), VT(:,:)
        END SUBROUTINE CGESVD_F95

      END INTERFACE

      INTERFACE LA_GEEVX

       SUBROUTINE SGEEVX_F95( A, WR, WI, VL, VR, BALANC, ILO, IHI,      &
     &                        SCALE, ABNRM, RCONDE, RCONDV, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: BALANC
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, ILO, IHI
          REAL(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT), OPTIONAL :: ABNRM
         REAL(WP), INTENT(OUT), OPTIONAL :: SCALE(:), RCONDE(:),        &
     &                                      RCONDV(:)
          REAL(WP), INTENT(OUT) :: WR(:), WI(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
       END SUBROUTINE SGEEVX_F95

       SUBROUTINE DGEEVX_F95( A, WR, WI, VL, VR, BALANC, ILO, IHI,      &
     &                        SCALE, ABNRM, RCONDE, RCONDV, INFO )
          USE LA_PRECISION, ONLY: WP => DP
          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: BALANC
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, ILO, IHI
          REAL(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT), OPTIONAL :: ABNRM
         REAL(WP), INTENT(OUT), OPTIONAL :: SCALE(:), RCONDE(:),        &
     &                                      RCONDV(:)
          REAL(WP), INTENT(OUT) :: WR(:), WI(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
       END SUBROUTINE DGEEVX_F95

       SUBROUTINE CGEEVX_F95( A, W, VL, VR, BALANC, ILO, IHI, SCALE,    &
     &                        ABNRM, RCONDE, RCONDV, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: BALANC
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, ILO, IHI
          COMPLEX(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT), OPTIONAL :: ABNRM
         REAL(WP), INTENT(OUT), OPTIONAL :: SCALE(:), RCONDE(:),        &
     &                                      RCONDV(:)
          COMPLEX(WP), INTENT(OUT) :: W(:)
          COMPLEX(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
       END SUBROUTINE CGEEVX_F95

      END INTERFACE

         INTERFACE LA_GGEVX
      
       SUBROUTINE SGGEVX_F95( A, B, ALPHAR, ALPHAI, BETA, VL, VR,       &
     &                        BALANC, ILO, IHI, LSCALE, RSCALE, ABNRM,  &
     &                        BBNRM, RCONDE, RCONDV, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: BALANC
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         INTEGER, INTENT(OUT), OPTIONAL :: ILO,IHI
         REAL(WP), INTENT(OUT), OPTIONAL :: ABNRM, BBNRM
         REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
         REAL(WP), INTENT(OUT) :: ALPHAR(:), ALPHAI(:)
         REAL(WP), INTENT(OUT) :: BETA(:)
         REAL(WP), INTENT(OUT), OPTIONAL ::LSCALE(:), RSCALE(:),        &
     &                                     RCONDE(:), RCONDV(:)
         REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
        END SUBROUTINE SGGEVX_F95

       SUBROUTINE DGGEVX_F95( A, B, ALPHAR, ALPHAI, BETA, VL, VR,       &
     &                        BALANC, ILO, IHI, LSCALE, RSCALE, ABNRM,  &
     &                        BBNRM, RCONDE, RCONDV, INFO )
         USE LA_PRECISION, ONLY: WP => DP
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: BALANC
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         INTEGER, INTENT(OUT), OPTIONAL :: ILO,IHI
         REAL(WP), INTENT(OUT), OPTIONAL :: ABNRM, BBNRM
         REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
         REAL(WP), INTENT(OUT) :: ALPHAR(:), ALPHAI(:)
         REAL(WP), INTENT(OUT) :: BETA(:)
         REAL(WP), INTENT(OUT), OPTIONAL ::LSCALE(:), RSCALE(:),        &
     &                                     RCONDE(:), RCONDV(:)
         REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
        END SUBROUTINE DGGEVX_F95

       SUBROUTINE CGGEVX_F95( A, B, ALPHA, BETA, VL, VR, BALANC, ILO,   &
     &                        IHI, LSCALE, RSCALE, ABNRM, BBNRM, RCONDE,&
     &                        RCONDV, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: BALANC
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         INTEGER, INTENT(OUT), OPTIONAL :: ILO,IHI
         REAL(WP), INTENT(OUT), OPTIONAL :: ABNRM, BBNRM
         COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
         COMPLEX(WP), INTENT(OUT) :: ALPHA(:)
         COMPLEX(WP), INTENT(OUT) :: BETA(:)
         REAL(WP), INTENT(OUT), OPTIONAL :: LSCALE(:), RSCALE(:),       &
     &                                      RCONDE(:), RCONDV(:)
         COMPLEX(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
       END SUBROUTINE CGGEVX_F95

       END INTERFACE

       INTERFACE LA_GGEV
      
       SUBROUTINE SGGEV_F95( A, B, ALPHAR, ALPHAI, BETA, VL, VR, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
         REAL(WP), INTENT(OUT) :: ALPHAR(:), ALPHAI(:), BETA(:)
         REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
       END SUBROUTINE SGGEV_F95

       SUBROUTINE DGGEV_F95( A, B, ALPHAR, ALPHAI, BETA, VL, VR, INFO )
         USE LA_PRECISION, ONLY: WP => DP
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
         REAL(WP), INTENT(OUT) :: ALPHAR(:), ALPHAI(:), BETA(:)
         REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
       END SUBROUTINE DGGEV_F95

       SUBROUTINE CGGEV_F95( A, B, ALPHA, BETA, VL, VR, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
         COMPLEX(WP), INTENT(OUT) ::  ALPHA(:), BETA(:)
         COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
        END SUBROUTINE CGGEV_F95

       END INTERFACE

      INTERFACE LA_GEEV

       SUBROUTINE SGEEV_F95( A, WR, WI, VL, VR, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT) :: WR(:), WI(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
       END SUBROUTINE SGEEV_F95

       SUBROUTINE DGEEV_F95( A, WR, WI, VL, VR, INFO )
          USE LA_PRECISION, ONLY: WP => DP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT) :: WR(:), WI(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
       END SUBROUTINE DGEEV_F95

       SUBROUTINE CGEEV_F95( A, W, VL, VR, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          COMPLEX(WP), INTENT(INOUT) :: A(:,:)
          COMPLEX(WP), INTENT(OUT) :: W(:)
          COMPLEX(WP), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
       END SUBROUTINE CGEEV_F95

      END INTERFACE

      INTERFACE LA_GEESX

       SUBROUTINE SGEESX_F95( A, WR, WI, VS, SELECT, SDIM, RCONDE,      &
     &                        RCONDV, INFO )
          USE LA_PRECISION, ONLY: WP => SP
!         USE LA_EXTERNAL
          INTERFACE
             LOGICAL FUNCTION SELECT(WR, WI)
                USE LA_PRECISION, ONLY: WP => SP
                REAL(WP), INTENT(IN) :: WR, WI
             END FUNCTION SELECT
          END INTERFACE
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, SDIM
          REAL(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT) :: WR(:), WI(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: RCONDE, RCONDV
          REAL(WP), INTENT(OUT), OPTIONAL :: VS(:,:)
          OPTIONAL :: SELECT
       END SUBROUTINE SGEESX_F95

       SUBROUTINE DGEESX_F95( A, WR, WI, VS, SELECT, SDIM, RCONDE,      &
     &                        RCONDV, INFO )
          USE LA_PRECISION, ONLY: WP => DP
!         USE LA_EXTERNAL
          INTERFACE
             LOGICAL FUNCTION SELECT(WR, WI)
                USE LA_PRECISION, ONLY: WP => DP
                REAL(WP), INTENT(IN) :: WR, WI
             END FUNCTION SELECT
          END INTERFACE
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, SDIM
          REAL(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT) :: WR(:), WI(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: RCONDE, RCONDV
          REAL(WP), INTENT(OUT), OPTIONAL :: VS(:,:)
          OPTIONAL :: SELECT
       END SUBROUTINE DGEESX_F95

       SUBROUTINE CGEESX_F95( A, W, VS, SELECT, SDIM, RCONDE, RCONDV,   &
     &                        INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTERFACE
             LOGICAL FUNCTION SELECT(W)
                USE LA_PRECISION, ONLY: WP => SP
                COMPLEX(WP), INTENT(IN) :: W
             END FUNCTION SELECT
          END INTERFACE
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, SDIM
          COMPLEX(WP), INTENT(INOUT) :: A(:,:)
          COMPLEX(WP), INTENT(OUT) :: W(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: RCONDE, RCONDV
          COMPLEX(WP), INTENT(OUT), OPTIONAL :: VS(:,:)
          OPTIONAL :: SELECT
       END SUBROUTINE CGEESX_F95

      END INTERFACE

        INTERFACE LA_GGESX

       SUBROUTINE SGGESX_F95( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR,     &
     &                        SELECT, SDIM, RCONDE, RCONDV, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          INTEGER, INTENT(OUT), OPTIONAL :: SDIM
          REAL(WP), INTENT(OUT) :: ALPHAR(:), ALPHAI(:),  BETA(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: VSL(:,:), VSR(:,:)
          INTERFACE
           LOGICAL FUNCTION SELECT(ALPHAR, ALPHAI, BETA)
            USE LA_PRECISION, ONLY: WP => SP
            REAL(WP), INTENT(IN) :: ALPHAR, ALPHAI, BETA
           END FUNCTION SELECT
          END INTERFACE
          OPTIONAL :: SELECT
          REAL(WP), INTENT(OUT), OPTIONAL :: RCONDE(2), RCONDV(2)
        END SUBROUTINE SGGESX_F95

       SUBROUTINE DGGESX_F95( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR,     &
     &                        SELECT, SDIM, RCONDE, RCONDV, INFO )
          USE LA_PRECISION, ONLY: WP => DP
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          INTEGER, INTENT(OUT), OPTIONAL :: SDIM
          REAL(WP), INTENT(OUT) :: ALPHAR(:), ALPHAI(:),  BETA(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: VSL(:,:), VSR(:,:)
          INTERFACE
           LOGICAL FUNCTION SELECT(ALPHAR, ALPHAI, BETA)
            USE LA_PRECISION, ONLY: WP => DP
            REAL(WP), INTENT(IN) :: ALPHAR, ALPHAI, BETA
           END FUNCTION SELECT
          END INTERFACE
          OPTIONAL :: SELECT
          REAL(WP), INTENT(OUT), OPTIONAL :: RCONDE(2), RCONDV(2)
        END SUBROUTINE DGGESX_F95

       SUBROUTINE CGGESX_F95( A, B, ALPHA, BETA, VSL, VSR, SELECT, SDIM,&
     &                        RCONDE, RCONDV, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           INTEGER, INTENT(OUT), OPTIONAL :: SDIM
           COMPLEX(WP), INTENT(OUT) :: ALPHA(:), BETA(:)
           COMPLEX(WP), INTENT(OUT), OPTIONAL :: VSL(:,:), VSR(:,:)
           INTERFACE
            LOGICAL FUNCTION SELECT(ALPHA, BETA)
              USE LA_PRECISION, ONLY: WP => SP
              COMPLEX(WP), INTENT(IN) :: ALPHA, BETA
           END FUNCTION SELECT
          END INTERFACE
          OPTIONAL :: SELECT
          REAL(WP), INTENT(OUT), OPTIONAL :: RCONDE(2), RCONDV(2)
         END SUBROUTINE  CGGESX_F95
	 
        END INTERFACE 


       INTERFACE LA_GGES
      
       SUBROUTINE SGGES_F95( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR,      &
     &                       SELECT, SDIM, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           INTEGER, INTENT(OUT), OPTIONAL :: SDIM
           REAL(WP), INTENT(OUT) :: ALPHAR(:), ALPHAI(:), BETA(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: VSL(:,:), VSR(:,:)
           INTERFACE
             LOGICAL FUNCTION SELECT(ALPHAR, ALPHAI, BETA)
               USE LA_PRECISION, ONLY: WP => SP
               REAL(WP), INTENT(IN) :: ALPHAR, ALPHAI, BETA
             END FUNCTION SELECT
           END INTERFACE
           OPTIONAL :: SELECT
          END SUBROUTINE SGGES_F95

       SUBROUTINE DGGES_F95( A, B, ALPHAR, ALPHAI, BETA, VSL, VSR,      &
     &                       SELECT, SDIM, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           INTEGER, INTENT(OUT), OPTIONAL :: SDIM
           REAL(WP), INTENT(OUT) :: ALPHAR(:), ALPHAI(:), BETA(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: VSL(:,:), VSR(:,:)
           INTERFACE
             LOGICAL FUNCTION SELECT(ALPHAR, ALPHAI, BETA)
               USE LA_PRECISION, ONLY: WP => DP
               REAL(WP), INTENT(IN) :: ALPHAR, ALPHAI, BETA
             END FUNCTION SELECT
           END INTERFACE
           OPTIONAL :: SELECT
          END SUBROUTINE DGGES_F95

       SUBROUTINE CGGES_F95( A, B, ALPHA, BETA, VSL, VSR, SELECT, SDIM, &
     &                       INFO )
         USE LA_PRECISION, ONLY: WP => SP
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
         INTEGER, INTENT(OUT), OPTIONAL :: SDIM
         COMPLEX(WP), INTENT(OUT) :: ALPHA(:),  BETA(:)
         COMPLEX(WP), INTENT(OUT), OPTIONAL :: VSL(:,:), VSR(:,:)
         INTERFACE
           LOGICAL FUNCTION SELECT(ALPHA, BETA)
             USE LA_PRECISION, ONLY: WP => SP
             COMPLEX(WP), INTENT(IN) :: ALPHA, BETA
           END FUNCTION SELECT
         END INTERFACE
         OPTIONAL :: SELECT
       END SUBROUTINE CGGES_F95

       END INTERFACE

      INTERFACE LA_GEES

       SUBROUTINE SGEES_F95( A, WR, WI, VS, SELECT, SDIM, INFO )
          USE LA_PRECISION, ONLY: WP => SP
!         USE LA_EXTERNAL, ONLY: SELECT
          INTERFACE
             LOGICAL FUNCTION SELECT(WR, WI)
                USE LA_PRECISION, ONLY: WP => SP
                REAL(WP), INTENT(IN) :: WR, WI
             END FUNCTION SELECT
          END INTERFACE

          INTEGER, INTENT(OUT), OPTIONAL :: INFO, SDIM
          REAL(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT) :: WR(:), WI(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: VS(:,:)
          OPTIONAL :: SELECT
       END SUBROUTINE SGEES_F95

       SUBROUTINE DGEES_F95( A, WR, WI, VS, SELECT, SDIM, INFO )
          USE LA_PRECISION, ONLY: WP => DP
!         USE LA_EXTERNAL, ONLY: SELECT
          INTERFACE
             LOGICAL FUNCTION SELECT(WR, WI)
                USE LA_PRECISION, ONLY: WP => DP
                REAL(WP), INTENT(IN) :: WR, WI
             END FUNCTION SELECT
          END INTERFACE

          INTEGER, INTENT(OUT), OPTIONAL :: INFO, SDIM
          REAL(WP), INTENT(INOUT) :: A(:,:)
          REAL(WP), INTENT(OUT) :: WR(:), WI(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: VS(:,:)
          OPTIONAL :: SELECT
       END SUBROUTINE DGEES_F95

       SUBROUTINE CGEES_F95( A, W, VS, SELECT, SDIM, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTERFACE
             LOGICAL FUNCTION SELECT(W)
                USE LA_PRECISION, ONLY: WP => SP
                COMPLEX(WP), INTENT(IN) :: W
             END FUNCTION SELECT
          END INTERFACE
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, SDIM
          COMPLEX(WP), INTENT(INOUT) :: A(:,:)
          COMPLEX(WP), INTENT(OUT) :: W(:)
          COMPLEX(WP), INTENT(OUT), OPTIONAL :: VS(:,:)
          OPTIONAL :: SELECT
       END SUBROUTINE CGEES_F95

      END INTERFACE

        INTERFACE LA_STEVR
 
       SUBROUTINE SSTEVR_F95( D, E, W, Z, VL, VU, IL, IU, M, ISUPPZ,    &
     &                        ABSTOL, INFO )
         USE LA_PRECISION, ONLY: WP =>  SP
          REAL(WP), INTENT(INOUT) :: D(:), E(:)
          REAL(WP), INTENT(OUT) :: W(:)
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(IN), OPTIONAL:: ABSTOL, VL, VU
          INTEGER, INTENT(IN), OPTIONAL :: IL, IU
          INTEGER, INTENT(OUT), OPTIONAL :: M
          REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
          INTEGER, INTENT(OUT), OPTIONAL, TARGET :: ISUPPZ(:)
         END SUBROUTINE SSTEVR_F95
 
       SUBROUTINE DSTEVR_F95( D, E, W, Z, VL, VU, IL, IU, M, ISUPPZ,    &
     &                        ABSTOL, INFO )
         USE LA_PRECISION, ONLY: WP =>  DP
          REAL(WP), INTENT(INOUT) :: D(:), E(:)
          REAL(WP), INTENT(OUT) :: W(:)
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          REAL(WP), INTENT(IN), OPTIONAL:: ABSTOL, VL, VU
          INTEGER, INTENT(IN), OPTIONAL :: IL, IU
          INTEGER, INTENT(OUT), OPTIONAL :: M
          REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
          INTEGER, INTENT(OUT), OPTIONAL, TARGET :: ISUPPZ(:)
         END SUBROUTINE DSTEVR_F95
 
        END INTERFACE
						
      INTERFACE LA_STEVX

       SUBROUTINE SSTEVX_F95( D, E, W, Z, VL, VU, IL, IU, M, IFAIL,     &
     &                        ABSTOL, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          INTEGER, INTENT(IN), OPTIONAL :: IL, IU
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
          REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
          INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
          REAL(WP), INTENT(INOUT) :: D(:), E(:)
          REAL(WP), INTENT(OUT) :: W(:)
       END SUBROUTINE SSTEVX_F95

       SUBROUTINE DSTEVX_F95( D, E, W, Z, VL, VU, IL, IU, M, IFAIL,     &
     &                        ABSTOL, INFO )
          USE LA_PRECISION, ONLY: WP => DP
          INTEGER, INTENT(IN), OPTIONAL :: IL, IU
          INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
          REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
          INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
          REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
          REAL(WP), INTENT(INOUT) :: D(:), E(:)
          REAL(WP), INTENT(OUT) :: W(:)
       END SUBROUTINE DSTEVX_F95

      END INTERFACE

      INTERFACE LA_STEVD

       SUBROUTINE SSTEVD_F95( D, E, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT(INOUT) :: D(:), E(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
      END SUBROUTINE SSTEVD_F95

       SUBROUTINE DSTEVD_F95( D, E, Z, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           REAL(WP), INTENT(INOUT) :: D(:), E(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
      END SUBROUTINE DSTEVD_F95

      END INTERFACE

      INTERFACE LA_STEV

       SUBROUTINE SSTEV_F95( D, E, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT(INOUT) :: D(:), E(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE SSTEV_F95

       SUBROUTINE DSTEV_F95( D, E, Z, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           REAL(WP), INTENT(INOUT) :: D(:), E(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE DSTEV_F95

      END INTERFACE

      INTERFACE LA_SBEVX

       SUBROUTINE SSBEVX_F95( AB, W, UPLO, Z, VL, VU, IL, IU, M, IFAIL, &
     &                        Q, ABSTOL, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(IN), OPTIONAL :: IL, IU
           INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
           REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
           INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:), Q(:,:)
           REAL(WP), INTENT(INOUT) :: AB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE SSBEVX_F95

       SUBROUTINE DSBEVX_F95( AB, W, UPLO, Z, VL, VU, IL, IU, M, IFAIL, &
     &                        Q, ABSTOL, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(IN), OPTIONAL :: IL, IU
           INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
           REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
           INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:), Q(:,:)
           REAL(WP), INTENT(INOUT) :: AB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE DSBEVX_F95

      END INTERFACE

      INTERFACE LA_HBEVX

       SUBROUTINE CHBEVX_F95( AB, W, UPLO, Z, VL, VU, IL, IU, M, IFAIL, &
     &                        Q, ABSTOL, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(IN), OPTIONAL :: IL, IU
           INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
           REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
           INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
           COMPLEX(WP), INTENT(OUT), OPTIONAL :: Z(:,:), Q(:,:)
           COMPLEX(WP), INTENT(INOUT) :: AB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE CHBEVX_F95

      END INTERFACE

      INTERFACE LA_SBEVD

       SUBROUTINE SSBEVD_F95( AB, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: AB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE SSBEVD_F95

       SUBROUTINE DSBEVD_F95( AB, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: AB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE DSBEVD_F95

      END INTERFACE

      INTERFACE LA_HBEVD

       SUBROUTINE CHBEVD_F95( AB, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(INOUT) :: AB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
           COMPLEX(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE CHBEVD_F95

      END INTERFACE

      INTERFACE LA_SBEV

       SUBROUTINE SSBEV_F95( AB, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: AB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE SSBEV_F95

       SUBROUTINE DSBEV_F95( AB, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: AB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE DSBEV_F95

      END INTERFACE

      INTERFACE LA_HBEV

       SUBROUTINE CHBEV_F95( AB, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(INOUT) :: AB(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
           COMPLEX(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE CHBEV_F95

      END INTERFACE

      INTERFACE LA_SPEVX

       SUBROUTINE SSPEVX_F95( AP, W, UPLO, Z, VL, VU, IL, IU, M, IFAIL, &
     &                        ABSTOL, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(IN), OPTIONAL :: IL, IU
           INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
           REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
           INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
           REAL(WP), INTENT(INOUT) :: AP(:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE SSPEVX_F95

       SUBROUTINE DSPEVX_F95( AP, W, UPLO, Z, VL, VU, IL, IU, M, IFAIL, &
     &                        ABSTOL, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(IN), OPTIONAL :: IL, IU
           INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
           REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
           INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
           REAL(WP), INTENT(INOUT) :: AP(:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE DSPEVX_F95

      END INTERFACE

      INTERFACE LA_HPEVX

       SUBROUTINE CHPEVX_F95( AP, W, UPLO, Z, VL, VU, IL, IU, M, IFAIL, &
     &                        ABSTOL, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(IN), OPTIONAL :: IL, IU
           INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
           REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
           INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
           COMPLEX(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
           COMPLEX(WP), INTENT(INOUT) :: AP(:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE CHPEVX_F95

      END INTERFACE

      INTERFACE LA_SPEVD

       SUBROUTINE SSPEVD_F95( AP, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: AP(:)
           REAL(WP), INTENT(OUT) :: W(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE SSPEVD_F95

       SUBROUTINE DSPEVD_F95( AP, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: AP(:)
           REAL(WP), INTENT(OUT) :: W(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE DSPEVD_F95

      END INTERFACE

      INTERFACE LA_HPEVD

       SUBROUTINE CHPEVD_F95( AP, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(INOUT) :: AP(:)
           REAL(WP), INTENT(OUT) :: W(:)
           COMPLEX(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE CHPEVD_F95

      END INTERFACE

      INTERFACE LA_SPEV

       SUBROUTINE SSPEV_F95( AP, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: AP(:)
           REAL(WP), INTENT(OUT) :: W(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE SSPEV_F95

       SUBROUTINE DSPEV_F95( AP, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: AP(:)
           REAL(WP), INTENT(OUT) :: W(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE DSPEV_F95

      END INTERFACE

      INTERFACE LA_HPEV

       SUBROUTINE CHPEV_F95( AP, W, UPLO, Z, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(INOUT) :: AP(:)
           REAL(WP), INTENT(OUT) :: W(:)
           COMPLEX(WP), INTENT(OUT), OPTIONAL :: Z(:,:)
        END SUBROUTINE CHPEV_F95

      END INTERFACE

      INTERFACE LA_GGGLM

       SUBROUTINE SGGGLM_F95( A, B, D, X, Y, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:), D(:)
           REAL(WP), INTENT( OUT ) :: X(:), Y(:)
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE SGGGLM_F95

       SUBROUTINE DGGGLM_F95( A, B, D, X, Y, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:), D(:)
           REAL(WP), INTENT( OUT ) :: X(:), Y(:)
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE DGGGLM_F95

       SUBROUTINE CGGGLM_F95( A, B, D, X, Y, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           COMPLEX(WP), INTENT( INOUT ) :: A( :, : ), B(:,:), D(:)
           COMPLEX(WP), INTENT( OUT ) :: X(:), Y(:)
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE CGGGLM_F95

      END INTERFACE

      INTERFACE LA_GGLSE

       SUBROUTINE SGGLSE_F95( A, B, C, D, X, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:), C(:), D(:)
           REAL(WP), INTENT( OUT ) :: X(:)
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE SGGLSE_F95

       SUBROUTINE DGGLSE_F95( A, B, C, D, X, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:), C(:), D(:)
           REAL(WP), INTENT( OUT ) :: X(:)
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE DGGLSE_F95

       SUBROUTINE CGGLSE_F95( A, B, C, D, X, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           COMPLEX(WP), INTENT( INOUT ) :: A( :, : ), B(:,:), C(:), D(:)
           COMPLEX(WP), INTENT( OUT ) :: X(:)
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE CGGLSE_F95

      END INTERFACE

         INTERFACE LA_GELSY

       SUBROUTINE SGELSY_F95( A, B, RANK, JPVT, RCOND, INFO )
       USE LA_PRECISION, ONLY: WP => SP
       REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
       INTEGER, INTENT(OUT), OPTIONAL :: RANK
       INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: JPVT(:)
       REAL(WP), INTENT(IN), OPTIONAL :: RCOND
       INTEGER, INTENT(OUT), OPTIONAL :: INFO
      END SUBROUTINE SGELSY_F95   

       SUBROUTINE SGELSY1_F95( A, B, RANK, JPVT, RCOND, INFO )
        USE LA_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
        INTEGER, INTENT(OUT), OPTIONAL :: RANK
        INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: JPVT(:)
        REAL(WP), INTENT(IN), OPTIONAL :: RCOND
        INTEGER, INTENT(OUT), OPTIONAL :: INFO
       END SUBROUTINE SGELSY1_F95
       
       SUBROUTINE DGELSY_F95( A, B, RANK, JPVT, RCOND, INFO )
       USE LA_PRECISION, ONLY: WP => DP
       REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
       INTEGER, INTENT(OUT), OPTIONAL :: RANK
       INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: JPVT(:)
       REAL(WP), INTENT(IN), OPTIONAL :: RCOND
       INTEGER, INTENT(OUT), OPTIONAL :: INFO
      END SUBROUTINE DGELSY_F95   

       SUBROUTINE DGELSY1_F95( A, B, RANK, JPVT, RCOND, INFO )
        USE LA_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
        INTEGER, INTENT(OUT), OPTIONAL :: RANK
        INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: JPVT(:)
        REAL(WP), INTENT(IN), OPTIONAL :: RCOND
        INTEGER, INTENT(OUT), OPTIONAL :: INFO
       END SUBROUTINE DGELSY1_F95
       
       SUBROUTINE CGELSY_F95( A, B, RANK, JPVT, RCOND, INFO )
       USE LA_PRECISION, ONLY: WP => SP
       COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
       INTEGER, INTENT(OUT), OPTIONAL :: RANK
       INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: JPVT(:)
       REAL(WP), INTENT(IN), OPTIONAL :: RCOND
       INTEGER, INTENT(OUT), OPTIONAL :: INFO
      END SUBROUTINE CGELSY_F95   

       SUBROUTINE CGELSY1_F95( A, B, RANK, JPVT, RCOND, INFO )
        USE LA_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
        INTEGER, INTENT(OUT), OPTIONAL :: RANK
        INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: JPVT(:)
        REAL(WP), INTENT(IN), OPTIONAL :: RCOND
        INTEGER, INTENT(OUT), OPTIONAL :: INFO
       END SUBROUTINE CGELSY1_F95
       
      END INTERFACE 

        INTERFACE LA_GELSD

       SUBROUTINE SGELSD_F95( A, B, RANK, S, RCOND, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
         INTEGER, INTENT(IN), OPTIONAL :: RANK
         REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
         REAL(WP), INTENT(IN), OPTIONAL :: RCOND
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
       END SUBROUTINE SGELSD_F95
       
       SUBROUTINE SGELSD1_F95( A, B, RANK, S, RCOND, INFO )
        USE LA_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:)
        INTEGER, INTENT(IN), OPTIONAL :: RANK
        REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
        REAL(WP), INTENT(IN), OPTIONAL :: RCOND
        INTEGER, INTENT(OUT), OPTIONAL :: INFO
       END SUBROUTINE SGELSD1_F95

       SUBROUTINE DGELSD_F95( A, B, RANK, S, RCOND, INFO )
         USE LA_PRECISION, ONLY: WP => DP
         REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
         INTEGER, INTENT(IN), OPTIONAL :: RANK
         REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
         REAL(WP), INTENT(IN), OPTIONAL :: RCOND
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
       END SUBROUTINE DGELSD_F95
       
       SUBROUTINE DGELSD1_F95( A, B, RANK, S, RCOND, INFO )
        USE LA_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:)
        INTEGER, INTENT(IN), OPTIONAL :: RANK
        REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
        REAL(WP), INTENT(IN), OPTIONAL :: RCOND
        INTEGER, INTENT(OUT), OPTIONAL :: INFO
       END SUBROUTINE DGELSD1_F95

       SUBROUTINE CGELSD_F95( A, B, RANK, S, RCOND, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         COMPLEX(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
         INTEGER, INTENT(IN), OPTIONAL :: RANK
         REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
         REAL(WP), INTENT(IN), OPTIONAL :: RCOND
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
       END SUBROUTINE CGELSD_F95
       
       SUBROUTINE CGELSD1_F95( A, B, RANK, S, RCOND, INFO )
        USE LA_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT( INOUT ) :: A( :, : ), B(:)
        INTEGER, INTENT(IN), OPTIONAL :: RANK
        REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
        REAL(WP), INTENT(IN), OPTIONAL :: RCOND
        INTEGER, INTENT(OUT), OPTIONAL :: INFO
       END SUBROUTINE CGELSD1_F95

      END INTERFACE

      INTERFACE LA_GELSX

       SUBROUTINE SGELSX_F95( A, B, RANK, JPVT, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           INTEGER, INTENT(OUT), OPTIONAL :: JPVT(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE SGELSX_F95

       SUBROUTINE SGELSX1_F95( A, B, RANK, JPVT, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           INTEGER, INTENT(OUT), OPTIONAL :: JPVT(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE SGELSX1_F95

       SUBROUTINE DGELSX_F95( A, B, RANK, JPVT, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           INTEGER, INTENT(OUT), OPTIONAL :: JPVT(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE DGELSX_F95

       SUBROUTINE DGELSX1_F95( A, B, RANK, JPVT, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           INTEGER, INTENT(OUT), OPTIONAL :: JPVT(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE DGELSX1_F95

       SUBROUTINE CGELSX_F95( A, B, RANK, JPVT, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           COMPLEX(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           INTEGER, INTENT(OUT), OPTIONAL :: JPVT(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE CGELSX_F95

       SUBROUTINE CGELSX1_F95( A, B, RANK, JPVT, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           COMPLEX(WP), INTENT( INOUT ) :: A( :, : ), B(:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           INTEGER, INTENT(OUT), OPTIONAL :: JPVT(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE CGELSX1_F95

      END INTERFACE

      INTERFACE LA_GELSS

       SUBROUTINE SGELSS_F95( A, B, RANK, S, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE SGELSS_F95

       SUBROUTINE SGELSS1_F95( A, B, RANK, S, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE SGELSS1_F95

       SUBROUTINE DGELSS_F95( A, B, RANK, S, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE DGELSS_F95

       SUBROUTINE DGELSS1_F95( A, B, RANK, S, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE DGELSS1_F95

       SUBROUTINE CGELSS_F95( A, B, RANK, S, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           COMPLEX(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE CGELSS_F95

       SUBROUTINE CGELSS1_F95( A, B, RANK, S, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           COMPLEX(WP), INTENT( INOUT ) :: A( :, : ), B(:)
           INTEGER, INTENT(IN), OPTIONAL :: RANK
           REAL(WP), INTENT(OUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(IN), OPTIONAL :: RCOND
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
        END SUBROUTINE CGELSS1_F95

      END INTERFACE

      INTERFACE LA_GELS

       SUBROUTINE SGELS_F95( A, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
        END SUBROUTINE SGELS_F95

       SUBROUTINE SGELS1_F95( A, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:)
        END SUBROUTINE SGELS1_F95

       SUBROUTINE DGELS_F95( A, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
        END SUBROUTINE DGELS_F95

       SUBROUTINE DGELS1_F95( A, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT( INOUT ) :: A( :, : ), B(:)
        END SUBROUTINE DGELS1_F95

       SUBROUTINE CGELS_F95( A, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT( INOUT ) :: A( :, : ), B(:,:)
        END SUBROUTINE CGELS_F95

       SUBROUTINE CGELS1_F95( A, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT( INOUT ) :: A( :, : ), B(:)
        END SUBROUTINE CGELS1_F95

      END INTERFACE

      INTERFACE LA_SPSVX

       SUBROUTINE SSPSVX_F95( AP, B, X, UPLO, AFP, IPIV, FACT, FERR,    &
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(IN) :: AP(:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE SSPSVX_F95

       SUBROUTINE SSPSVX1_F95( AP, B, X, UPLO, AFP, IPIV, FACT, FERR,   &
     &                         BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(IN) :: AP(:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
        END SUBROUTINE SSPSVX1_F95

       SUBROUTINE DSPSVX_F95( AP, B, X, UPLO, AFP, IPIV, FACT, FERR,    &
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(IN) :: AP(:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE DSPSVX_F95

       SUBROUTINE DSPSVX1_F95( AP, B, X, UPLO, AFP, IPIV, FACT, FERR,   &
     &                         BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(IN) :: AP(:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
        END SUBROUTINE DSPSVX1_F95

       SUBROUTINE CSPSVX_F95( AP, B, X, UPLO, AFP, IPIV, FACT, FERR,    &
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           COMPLEX(WP), INTENT(IN) :: AP(:), B(:,:)
           COMPLEX(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE CSPSVX_F95

       SUBROUTINE CSPSVX1_F95( AP, B, X, UPLO, AFP, IPIV, FACT, FERR,   &
     &                         BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           COMPLEX(WP), INTENT(IN) :: AP(:), B(:)
           COMPLEX(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
        END SUBROUTINE CSPSVX1_F95

      END INTERFACE

      INTERFACE LA_HPSVX

       SUBROUTINE CHPSVX_F95( A, B, X, UPLO, AFP, IPIV, FACT, FERR,     &
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           COMPLEX(WP), INTENT(IN) :: A(:), B(:,:)
           COMPLEX(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE CHPSVX_F95

       SUBROUTINE CHPSVX1_F95( A, B, X, UPLO, AFP, IPIV, FACT, FERR,    &
     &                         BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           COMPLEX(WP), INTENT(IN) :: A(:), B(:)
           COMPLEX(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
        END SUBROUTINE CHPSVX1_F95

      END INTERFACE

      INTERFACE LA_SYSVX

       SUBROUTINE SSYSVX_F95( A, B, X, UPLO, AF, IPIV, FACT, FERR, BERR,&
     &                        RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(IN) :: A(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE SSYSVX_F95

       SUBROUTINE SSYSVX1_F95( A, B, X, UPLO, AF, IPIV, FACT, FERR,     &
     &                         BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(IN) :: A(:,:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
        END SUBROUTINE SSYSVX1_F95

       SUBROUTINE DSYSVX_F95( A, B, X, UPLO, AF, IPIV, FACT, FERR, BERR,&
     &                        RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(IN) :: A(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE DSYSVX_F95

       SUBROUTINE DSYSVX1_F95( A, B, X, UPLO, AF, IPIV, FACT, FERR,     &
     &                         BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(IN) :: A(:,:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
        END SUBROUTINE DSYSVX1_F95

       SUBROUTINE CSYSVX_F95( A, B, X, UPLO, AF, IPIV, FACT, FERR, BERR,&
     &                        RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           COMPLEX(WP), INTENT(IN) :: A(:,:), B(:,:)
           COMPLEX(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE CSYSVX_F95

       SUBROUTINE CSYSVX1_F95( A, B, X, UPLO, AF, IPIV, FACT, FERR,     &
     &                         BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           COMPLEX(WP), INTENT(IN) :: A(:,:), B(:)
           COMPLEX(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
        END SUBROUTINE CSYSVX1_F95

      END INTERFACE

      INTERFACE LA_HESVX

       SUBROUTINE CHESVX_F95( A, B, X, UPLO, AF, IPIV, FACT, FERR, BERR,&
     &                        RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           COMPLEX(WP), INTENT(IN) :: A(:,:), B(:,:)
           COMPLEX(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE CHESVX_F95

       SUBROUTINE CHESVX1_F95( A, B, X, UPLO, AF, IPIV, FACT, FERR,     &
     &                         BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           COMPLEX(WP), INTENT(IN) :: A(:,:), B(:)
           COMPLEX(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
        END SUBROUTINE CHESVX1_F95

      END INTERFACE

      INTERFACE LA_PTSVX

       SUBROUTINE SPTSVX_F95( D, E, B, X, DF, EF, FACT, FERR, BERR,     &
     &                        RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(IN) :: D(:)
           REAL(WP), INTENT(IN) :: E(:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: DF(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: EF(:)
        END SUBROUTINE SPTSVX_F95

       SUBROUTINE SPTSVX1_F95( D, E, B, X, DF, EF, FACT, FERR, BERR,    &
     &                         RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(IN) :: D(:)
           REAL(WP), INTENT(IN) :: E(:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: DF(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: EF(:)
        END SUBROUTINE SPTSVX1_F95

       SUBROUTINE DPTSVX_F95( D, E, B, X, DF, EF, FACT, FERR, BERR,     &
     &                        RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(IN) :: D(:)
           REAL(WP), INTENT(IN) :: E(:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: DF(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: EF(:)
        END SUBROUTINE DPTSVX_F95

       SUBROUTINE DPTSVX1_F95( D, E, B, X, DF, EF, FACT, FERR, BERR,    &
     &                         RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(IN) :: D(:)
           REAL(WP), INTENT(IN) :: E(:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: DF(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: EF(:)
        END SUBROUTINE DPTSVX1_F95

       SUBROUTINE CPTSVX_F95( D, E, B, X, DF, EF, FACT, FERR, BERR,     &
     &                        RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(IN) :: D(:)
           COMPLEX(WP), INTENT(IN) :: E(:), B(:,:)
           COMPLEX(WP), INTENT(OUT) :: X(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: DF(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: EF(:)
        END SUBROUTINE CPTSVX_F95

       SUBROUTINE CPTSVX1_F95( D, E, B, X, DF, EF, FACT, FERR, BERR,    &
     &                         RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(IN) :: D(:)
           COMPLEX(WP), INTENT(IN) :: E(:), B(:)
           COMPLEX(WP), INTENT(OUT) :: X(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: DF(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: EF(:)
        END SUBROUTINE CPTSVX1_F95

      END INTERFACE

      INTERFACE LA_PBSVX

       SUBROUTINE SPBSVX_F95( AB, B, X, UPLO, AFB, FACT, EQUED, S, FERR,&
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(INOUT) :: AB(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
        END SUBROUTINE SPBSVX_F95

       SUBROUTINE SPBSVX1_F95( AB, B, X, UPLO, AFB, FACT, EQUED, S,     &
     &                         FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(INOUT) :: AB(:,:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
        END SUBROUTINE SPBSVX1_F95

       SUBROUTINE DPBSVX_F95( AB, B, X, UPLO, AFB, FACT, EQUED, S, FERR,&
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(INOUT) :: AB(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
        END SUBROUTINE DPBSVX_F95

       SUBROUTINE DPBSVX1_F95( AB, B, X, UPLO, AFB, FACT, EQUED, S,     &
     &                         FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(INOUT) :: AB(:,:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
        END SUBROUTINE DPBSVX1_F95

       SUBROUTINE CPBSVX_F95( AB, B, X, UPLO, AFB, FACT, EQUED, S, FERR,&
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           COMPLEX(WP), INTENT(INOUT) :: AB(:,:), B(:,:)
           COMPLEX(WP), INTENT(OUT) :: X(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
        END SUBROUTINE CPBSVX_F95

       SUBROUTINE CPBSVX1_F95( AB, B, X, UPLO, AFB, FACT, EQUED, S,     &
     &                         FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           COMPLEX(WP), INTENT(INOUT) :: AB(:,:), B(:)
           COMPLEX(WP), INTENT(OUT) :: X(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
        END SUBROUTINE CPBSVX1_F95

      END INTERFACE

      INTERFACE LA_PPSVX

       SUBROUTINE SPPSVX_F95( AP, B, X, UPLO, AFP, FACT, EQUED, S, FERR,&
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(INOUT) :: AP(:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE SPPSVX_F95

       SUBROUTINE SPPSVX1_F95( AP, B, X, UPLO, AFP, FACT, EQUED, S,     &
     &                         FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(INOUT) :: AP(:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
        END SUBROUTINE SPPSVX1_F95

       SUBROUTINE DPPSVX_F95( AP, B, X, UPLO, AFP, FACT, EQUED, S, FERR,&
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(INOUT) :: AP(:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE DPPSVX_F95

       SUBROUTINE DPPSVX1_F95( AP, B, X, UPLO, AFP, FACT, EQUED, S,     &
     &                         FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(INOUT) :: AP(:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
        END SUBROUTINE DPPSVX1_F95

       SUBROUTINE CPPSVX_F95( AP, B, X, UPLO, AFP, FACT, EQUED, S, FERR,&
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           COMPLEX(WP), INTENT(INOUT) :: AP(:), B(:,:)
           COMPLEX(WP), INTENT(OUT) :: X(:,:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE CPPSVX_F95

       SUBROUTINE CPPSVX1_F95( AP, B, X, UPLO, AFP, FACT, EQUED, S,     &
     &                         FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           COMPLEX(WP), INTENT(INOUT) :: AP(:), B(:)
           COMPLEX(WP), INTENT(OUT) :: X(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AFP(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
        END SUBROUTINE CPPSVX1_F95

      END INTERFACE

      INTERFACE LA_POSVX

       SUBROUTINE SPOSVX_F95( A, B, X, UPLO, AF, FACT, EQUED, S, FERR,  &
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE SPOSVX_F95

       SUBROUTINE SPOSVX1_F95( A, B, X, UPLO, AF, FACT, EQUED, S, FERR, &
     &                         BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
        END SUBROUTINE SPOSVX1_F95

       SUBROUTINE DPOSVX_F95( A, B, X, UPLO, AF, FACT, EQUED, S, FERR,  &
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE DPOSVX_F95

       SUBROUTINE DPOSVX1_F95( A, B, X, UPLO, AF, FACT, EQUED, S, FERR, &
     &                         BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
        END SUBROUTINE DPOSVX1_F95

       SUBROUTINE CPOSVX_F95( A, B, X, UPLO, AF, FACT, EQUED, S, FERR,  &
     &                        BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           COMPLEX(WP), INTENT(OUT) :: X(:,:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE CPOSVX_F95

       SUBROUTINE CPOSVX1_F95( A, B, X, UPLO, AF, FACT, EQUED, S, FERR, &
     &                         BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
           COMPLEX(WP), INTENT(OUT) :: X(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: S(:)
        END SUBROUTINE CPOSVX1_F95

      END INTERFACE

      INTERFACE LA_GTSVX

       SUBROUTINE SGTSVX_F95( DL, D, DU, B, X, DLF, DF, DUF, DU2, IPIV, &
     &                        FACT, TRANS, FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(IN) :: DL(:), D(:), DU(:), B(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: DLF(:), DF(:), DUF(:),  &
     &                                          DU2(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
           REAL(WP), INTENT(OUT) :: X(:,:)
        END SUBROUTINE SGTSVX_F95

       SUBROUTINE SGTSVX1_F95( DL, D, DU, B, X, DLF, DF, DUF, DU2, IPIV,&
     &                         FACT, TRANS, FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(IN) :: DL(:), D(:), DU(:), B(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: DLF(:), DF(:), DUF(:),  &
     &                                          DU2(:)
           REAL(WP), INTENT(OUT) :: X(:)
        END SUBROUTINE SGTSVX1_F95

       SUBROUTINE DGTSVX_F95( DL, D, DU, B, X, DLF, DF, DUF, DU2, IPIV, &
     &                        FACT, TRANS, FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(IN) :: DL(:), D(:), DU(:), B(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: DLF(:), DF(:), DUF(:),  &
     &                                          DU2(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
           REAL(WP), INTENT(OUT) :: X(:,:)
        END SUBROUTINE DGTSVX_F95

       SUBROUTINE DGTSVX1_F95( DL, D, DU, B, X, DLF, DF, DUF, DU2, IPIV,&
     &                         FACT, TRANS, FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           REAL(WP), INTENT(IN) :: DL(:), D(:), DU(:), B(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: DLF(:), DF(:), DUF(:),  &
     &                                          DU2(:)
           REAL(WP), INTENT(OUT) :: X(:)
        END SUBROUTINE DGTSVX1_F95

       SUBROUTINE CGTSVX_F95( DL, D, DU, B, X, DLF, DF, DUF, DU2, IPIV, &
     &                        FACT, TRANS, FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           COMPLEX(WP), INTENT(IN) :: DL(:), D(:), DU(:), B(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: DLF(:), DF(:),       &
     &                                             DUF(:), DU2(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
           COMPLEX(WP), INTENT(OUT) :: X(:,:)
        END SUBROUTINE CGTSVX_F95

       SUBROUTINE CGTSVX1_F95( DL, D, DU, B, X, DLF, DF, DUF, DU2, IPIV,&
     &                         FACT, TRANS, FERR, BERR, RCOND, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
           COMPLEX(WP), INTENT(IN) :: DL(:), D(:), DU(:), B(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: DLF(:), DF(:),       &
     &                                             DUF(:), DU2(:)
           COMPLEX(WP), INTENT(OUT) :: X(:)
        END SUBROUTINE CGTSVX1_F95

      END INTERFACE

      INTERFACE LA_GBSVX

       SUBROUTINE SGBSVX_F95( A, B, X, KL, AFB, IPIV, FACT, TRANS,      &
     &                        EQUED, R, C, FERR, BERR, RCOND, RPVGRW,   &
     &                        INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(IN), OPTIONAL :: KL
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE SGBSVX_F95

       SUBROUTINE SGBSVX1_F95( A, B, X, KL, AFB, IPIV, FACT, TRANS,     &
     &                         EQUED, R, C, FERR, BERR, RCOND, RPVGRW,  &
     &                         INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(IN), OPTIONAL :: KL
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW, FERR, BERR
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
        END SUBROUTINE SGBSVX1_F95

       SUBROUTINE DGBSVX_F95( A, B, X, KL, AFB, IPIV, FACT, TRANS,      &
     &                        EQUED, R, C, FERR, BERR, RCOND, RPVGRW,   &
     &                        INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(IN), OPTIONAL :: KL
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE DGBSVX_F95

       SUBROUTINE DGBSVX1_F95( A, B, X, KL, AFB, IPIV, FACT, TRANS,     &
     &                         EQUED, R, C, FERR, BERR, RCOND, RPVGRW,  &
     &                         INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(IN), OPTIONAL :: KL
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW, FERR, BERR
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
        END SUBROUTINE DGBSVX1_F95

       SUBROUTINE CGBSVX_F95( A, B, X, KL, AFB, IPIV, FACT, TRANS,      &
     &                        EQUED, R, C, FERR, BERR, RCOND, RPVGRW,   &
     &                        INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(IN), OPTIONAL :: KL
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
           COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           COMPLEX(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE CGBSVX_F95

       SUBROUTINE CGBSVX1_F95( A, B, X, KL, AFB, IPIV, FACT, TRANS,     &
     &                         EQUED, R, C, FERR, BERR, RCOND, RPVGRW,  &
     &                         INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(IN), OPTIONAL :: KL
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW, FERR, BERR
           COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
           COMPLEX(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AFB(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
        END SUBROUTINE CGBSVX1_F95

      END INTERFACE

      INTERFACE LA_SPSV

       SUBROUTINE SSPSV_F95( AP, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: AP(:), B(:,:)
        END SUBROUTINE SSPSV_F95

       SUBROUTINE SSPSV1_F95( AP, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: AP(:), B(:)
        END SUBROUTINE SSPSV1_F95

       SUBROUTINE DSPSV_F95( AP, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: AP(:), B(:,:)
        END SUBROUTINE DSPSV_F95

       SUBROUTINE DSPSV1_F95( AP, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: AP(:), B(:)
        END SUBROUTINE DSPSV1_F95

       SUBROUTINE CSPSV_F95( AP, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: AP(:), B(:,:)
        END SUBROUTINE CSPSV_F95

       SUBROUTINE CSPSV1_F95( AP, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: AP(:), B(:)
        END SUBROUTINE CSPSV1_F95

      END INTERFACE

      INTERFACE LA_HPSV

       SUBROUTINE CHPSV_F95( AP, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: AP(:), B(:,:)
        END SUBROUTINE CHPSV_F95

       SUBROUTINE CHPSV1_F95( AP, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: AP(:), B(:)
        END SUBROUTINE CHPSV1_F95

      END INTERFACE

      INTERFACE LA_SYSV

       SUBROUTINE SSYSV_F95( A, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE SSYSV_F95

       SUBROUTINE SSYSV1_F95( A, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE SSYSV1_F95

       SUBROUTINE DSYSV_F95( A, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE DSYSV_F95

       SUBROUTINE DSYSV1_F95( A, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE DSYSV1_F95

       SUBROUTINE CSYSV_F95( A, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE CSYSV_F95

       SUBROUTINE CSYSV1_F95( A, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE CSYSV1_F95

      END INTERFACE

      INTERFACE LA_HESV

       SUBROUTINE CHESV_F95( A, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE CHESV_F95

       SUBROUTINE CHESV1_F95( A, B, UPLO, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE CHESV1_F95

      END INTERFACE

      INTERFACE LA_PTSV

       SUBROUTINE SPTSV_F95( D, E, B, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: D(:)
            REAL(WP), INTENT(INOUT) :: E(:), B(:,:)
        END SUBROUTINE SPTSV_F95

       SUBROUTINE SPTSV1_F95( D, E, B, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: D(:)
            REAL(WP), INTENT(INOUT) :: E(:), B(:)
        END SUBROUTINE SPTSV1_F95

       SUBROUTINE DPTSV_F95( D, E, B, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: D(:)
            REAL(WP), INTENT(INOUT) :: E(:), B(:,:)
        END SUBROUTINE DPTSV_F95

       SUBROUTINE DPTSV1_F95( D, E, B, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: D(:)
            REAL(WP), INTENT(INOUT) :: E(:), B(:)
        END SUBROUTINE DPTSV1_F95

       SUBROUTINE CPTSV_F95( D, E, B, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: D(:)
            COMPLEX(WP), INTENT(INOUT) :: E(:), B(:,:)
        END SUBROUTINE CPTSV_F95

       SUBROUTINE CPTSV1_F95( D, E, B, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: D(:)
            COMPLEX(WP), INTENT(INOUT) :: E(:), B(:)
        END SUBROUTINE CPTSV1_F95

      END INTERFACE

      INTERFACE LA_PBSV

       SUBROUTINE SPBSV_F95( AB, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: AB(:,:), B(:,:)
        END SUBROUTINE SPBSV_F95

       SUBROUTINE SPBSV1_F95( AB, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: AB(:,:), B(:)
        END SUBROUTINE SPBSV1_F95

       SUBROUTINE DPBSV_F95( AB, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: AB(:,:), B(:,:)
        END SUBROUTINE DPBSV_F95

       SUBROUTINE DPBSV1_F95( AB, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: AB(:,:), B(:)
        END SUBROUTINE DPBSV1_F95

       SUBROUTINE CPBSV_F95( AB, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            COMPLEX(WP), INTENT(INOUT) :: AB(:,:), B(:,:)
        END SUBROUTINE CPBSV_F95

       SUBROUTINE CPBSV1_F95( AB, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            COMPLEX(WP), INTENT(INOUT) :: AB(:,:), B(:)
        END SUBROUTINE CPBSV1_F95

      END INTERFACE

      INTERFACE LA_PPSV

       SUBROUTINE SPPSV_F95( AP, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: AP(:), B(:,:)
        END SUBROUTINE SPPSV_F95

       SUBROUTINE SPPSV1_F95( AP, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: AP(:), B(:)
        END SUBROUTINE SPPSV1_F95

       SUBROUTINE DPPSV_F95( AP, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: AP(:), B(:,:)
        END SUBROUTINE DPPSV_F95

       SUBROUTINE DPPSV1_F95( AP, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: AP(:), B(:)
        END SUBROUTINE DPPSV1_F95

       SUBROUTINE CPPSV_F95( AP, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            COMPLEX(WP), INTENT(INOUT) :: AP(:), B(:,:)
        END SUBROUTINE CPPSV_F95

       SUBROUTINE CPPSV1_F95( AP, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            COMPLEX(WP), INTENT(INOUT) :: AP(:), B(:)
        END SUBROUTINE CPPSV1_F95

      END INTERFACE

      INTERFACE LA_POSV

       SUBROUTINE SPOSV_F95( A, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE SPOSV_F95

       SUBROUTINE SPOSV1_F95( A, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE SPOSV1_F95

       SUBROUTINE DPOSV_F95( A, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE DPOSV_F95

       SUBROUTINE DPOSV1_F95( A, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE DPOSV1_F95

       SUBROUTINE CPOSV_F95( A, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE CPOSV_F95

       SUBROUTINE CPOSV1_F95( A, B, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE CPOSV1_F95

      END INTERFACE

      INTERFACE LA_GTSV

       SUBROUTINE SGTSV_F95( DL, D, DU, B, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: DL(:), D(:), DU(:), B(:,:)
        END SUBROUTINE SGTSV_F95

       SUBROUTINE SGTSV1_F95( DL, D, DU, B, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: DL(:), D(:), DU(:), B(:)
        END SUBROUTINE SGTSV1_F95

       SUBROUTINE DGTSV_F95( DL, D, DU, B, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: DL(:), D(:), DU(:), B(:,:)
        END SUBROUTINE DGTSV_F95

       SUBROUTINE DGTSV1_F95( DL, D, DU, B, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            REAL(WP), INTENT(INOUT) :: DL(:), D(:), DU(:), B(:)
        END SUBROUTINE DGTSV1_F95

       SUBROUTINE CGTSV_F95( DL, D, DU, B, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            COMPLEX(WP), INTENT(INOUT) :: DL(:), D(:), DU(:), B(:,:)
        END SUBROUTINE CGTSV_F95

       SUBROUTINE CGTSV1_F95( DL, D, DU, B, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            COMPLEX(WP), INTENT(INOUT) :: DL(:), D(:), DU(:), B(:)
        END SUBROUTINE CGTSV1_F95

      END INTERFACE

      INTERFACE LA_GBSV

       SUBROUTINE SGBSV_F95( AB, B, KL, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(IN), OPTIONAL :: KL
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: AB(:,:), B(:,:)
        END SUBROUTINE SGBSV_F95

       SUBROUTINE SGBSV1_F95( AB, B, KL, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(IN), OPTIONAL :: KL
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: AB(:,:), B(:)
        END SUBROUTINE SGBSV1_F95

       SUBROUTINE DGBSV_F95( AB, B, KL, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            INTEGER, INTENT(IN), OPTIONAL :: KL
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: AB(:,:), B(:,:)
        END SUBROUTINE DGBSV_F95

       SUBROUTINE DGBSV1_F95( AB, B, KL, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            INTEGER, INTENT(IN), OPTIONAL :: KL
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: AB(:,:), B(:)
        END SUBROUTINE DGBSV1_F95

       SUBROUTINE CGBSV_F95( AB, B, KL, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(IN), OPTIONAL :: KL
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: AB(:,:), B(:,:)
        END SUBROUTINE CGBSV_F95

       SUBROUTINE CGBSV1_F95( AB, B, KL, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(IN), OPTIONAL :: KL
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: AB(:,:), B(:)
        END SUBROUTINE CGBSV1_F95

      END INTERFACE

      INTERFACE LA_GESV

       SUBROUTINE SGESV_F95( A, B, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE SGESV_F95

       SUBROUTINE SGESV1_F95( A, B, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE SGESV1_F95

       SUBROUTINE DGESV_F95( A, B, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE DGESV_F95

       SUBROUTINE DGESV1_F95( A, B, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE DGESV1_F95

       SUBROUTINE CGESV_F95( A, B, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE CGESV_F95

       SUBROUTINE CGESV1_F95( A, B, IPIV, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
            INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
            COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE CGESV1_F95

      END INTERFACE

      INTERFACE LA_GESVX

       SUBROUTINE SGESVX_F95( A, B, X, AF, IPIV, FACT, TRANS, EQUED, R, &
     &                        C, FERR, BERR, RCOND, RPVGRW, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE SGESVX_F95

       SUBROUTINE SGESVX1_F95( A, B, X, AF, IPIV, FACT, TRANS, EQUED, R,&
     &                         C, FERR, BERR, RCOND, RPVGRW, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR, BERR
        END SUBROUTINE SGESVX1_F95

       SUBROUTINE DGESVX_F95( A, B, X, AF, IPIV, FACT, TRANS, EQUED, R, &
     &                        C, FERR, BERR, RCOND, RPVGRW, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE DGESVX_F95

       SUBROUTINE DGESVX1_F95( A, B, X, AF, IPIV, FACT, TRANS, EQUED, R,&
     &                         C, FERR, BERR, RCOND, RPVGRW, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
           REAL(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR, BERR
        END SUBROUTINE DGESVX1_F95

       SUBROUTINE CGESVX_F95( A, B, X, AF, IPIV, FACT, TRANS, EQUED, R, &
     &                        C, FERR, BERR, RCOND, RPVGRW, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
           COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           COMPLEX(WP), INTENT(OUT) :: X(:,:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE CGESVX_F95

       SUBROUTINE CGESVX1_F95( A, B, X, AF, IPIV, FACT, TRANS, EQUED, R,&
     &                         C, FERR, BERR, RCOND, RPVGRW, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
           CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
           COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
           COMPLEX(WP), INTENT(OUT) :: X(:)
           INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT), OPTIONAL :: AF(:,:)
           REAL(WP), INTENT(INOUT), OPTIONAL :: C(:), R(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR, BERR
        END SUBROUTINE CGESVX1_F95

      END INTERFACE

      INTERFACE LA_GETRF

       SUBROUTINE SGETRF_F95( A, IPIV, RCOND, NORM, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT( OUT ), OPTIONAL :: RCOND
           INTEGER, INTENT( OUT ), OPTIONAL :: IPIV( : )
           REAL(WP), INTENT( INOUT ) :: A( :, : )
        END SUBROUTINE SGETRF_F95

       SUBROUTINE DGETRF_F95( A, IPIV, RCOND, NORM, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT( OUT ), OPTIONAL :: RCOND
           INTEGER, INTENT( OUT ), OPTIONAL :: IPIV( : )
           REAL(WP), INTENT( INOUT ) :: A( :, : )
        END SUBROUTINE DGETRF_F95

       SUBROUTINE CGETRF_F95( A, IPIV, RCOND, NORM, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT( OUT ), OPTIONAL :: RCOND
           INTEGER, INTENT( OUT ), OPTIONAL :: IPIV( : )
           COMPLEX(WP), INTENT( INOUT ) :: A( :, : )
        END SUBROUTINE CGETRF_F95

      END INTERFACE

      INTERFACE LA_GETRS

       SUBROUTINE SGETRS_F95( A, IPIV, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE SGETRS_F95

       SUBROUTINE SGETRS1_F95( A, IPIV, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE SGETRS1_F95

       SUBROUTINE DGETRS_F95( A, IPIV, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE DGETRS_F95

       SUBROUTINE DGETRS1_F95( A, IPIV, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE DGETRS1_F95

       SUBROUTINE CGETRS_F95( A, IPIV, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
        END SUBROUTINE CGETRS_F95

       SUBROUTINE CGETRS1_F95( A, IPIV, B, TRANS, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
        END SUBROUTINE CGETRS1_F95

      END INTERFACE

      INTERFACE LA_GETRI

       SUBROUTINE SGETRI_F95( A, IPIV, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           REAL(WP), INTENT(INOUT) :: A(:,:)
        END SUBROUTINE SGETRI_F95

       SUBROUTINE DGETRI_F95( A, IPIV, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           REAL(WP), INTENT(INOUT) :: A(:,:)
        END SUBROUTINE DGETRI_F95

       SUBROUTINE CGETRI_F95( A, IPIV, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        END SUBROUTINE CGETRI_F95

      END INTERFACE

      INTERFACE LA_GERFS

       SUBROUTINE SGERFS_F95( A, AF, IPIV, B, X, TRANS, FERR, BERR,     &
     &                        INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           REAL(WP), INTENT(IN) :: A(:,:), AF(:,:), B(:,:)
           REAL(WP), INTENT(INOUT) :: X(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE SGERFS_F95

       SUBROUTINE SGERFS1_F95( A, AF, IPIV, B, X, TRANS, FERR, BERR,    &
     &                         INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           REAL(WP), INTENT(IN) :: A(:,:), AF(:,:)
           REAL(WP), INTENT(IN) :: B(:)
           REAL(WP), INTENT(INOUT) :: X(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR, BERR
        END SUBROUTINE SGERFS1_F95

       SUBROUTINE DGERFS_F95( A, AF, IPIV, B, X, TRANS, FERR, BERR,     &
     &                        INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           REAL(WP), INTENT(IN) :: A(:,:), AF(:,:), B(:,:)
           REAL(WP), INTENT(INOUT) :: X(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE DGERFS_F95

       SUBROUTINE DGERFS1_F95( A, AF, IPIV, B, X, TRANS, FERR, BERR,    &
     &                         INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           REAL(WP), INTENT(IN) :: A(:,:), AF(:,:)
           REAL(WP), INTENT(IN) :: B(:)
           REAL(WP), INTENT(INOUT) :: X(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR, BERR
        END SUBROUTINE DGERFS1_F95

       SUBROUTINE CGERFS_F95( A, AF, IPIV, B, X, TRANS, FERR, BERR,     &
     &                        INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           COMPLEX(WP), INTENT(IN) :: A(:,:), AF(:,:), B(:,:)
           COMPLEX(WP), INTENT(INOUT) :: X(:,:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR(:), BERR(:)
        END SUBROUTINE CGERFS_F95

       SUBROUTINE CGERFS1_F95( A, AF, IPIV, B, X, TRANS, FERR, BERR,    &
     &                         INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           INTEGER, INTENT(IN) :: IPIV(:)
           COMPLEX(WP), INTENT(IN) :: A(:,:), AF(:,:)
           COMPLEX(WP), INTENT(IN) :: B(:)
           COMPLEX(WP), INTENT(INOUT) :: X(:)
           REAL(WP), INTENT(OUT), OPTIONAL :: FERR, BERR
        END SUBROUTINE CGERFS1_F95

      END INTERFACE

      INTERFACE LA_GEEQU

       SUBROUTINE SGEEQU_F95( A, R, C, ROWCND, COLCND, AMAX, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT( OUT ), OPTIONAL :: AMAX, COLCND, ROWCND
           REAL(WP), INTENT( IN ) :: A( :, : )
           REAL(WP), INTENT( OUT ) :: C( : ), R( : )
        END SUBROUTINE SGEEQU_F95

       SUBROUTINE DGEEQU_F95( A, R, C, ROWCND, COLCND, AMAX, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT( OUT ), OPTIONAL :: AMAX, COLCND, ROWCND
           REAL(WP), INTENT( IN ) :: A( :, : )
           REAL(WP), INTENT( OUT ) :: C( : ), R( : )
        END SUBROUTINE DGEEQU_F95

       SUBROUTINE CGEEQU_F95( A, R, C, ROWCND, COLCND, AMAX, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT( OUT ), OPTIONAL :: AMAX, COLCND, ROWCND
           COMPLEX(WP), INTENT( IN ) :: A( :, : )
           REAL(WP), INTENT( OUT ) :: C( : ), R( : )
        END SUBROUTINE CGEEQU_F95

      END INTERFACE

      INTERFACE LA_SYEV

       SUBROUTINE SSYEV_F95( A, W, JOBZ, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE SSYEV_F95

       SUBROUTINE DSYEV_F95( A, W, JOBZ, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE DSYEV_F95

      END INTERFACE

      INTERFACE LA_HEEV

       SUBROUTINE CHEEV_F95( A, W, JOBZ, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE CHEEV_F95

      END INTERFACE

      INTERFACE LA_SYEVD

       SUBROUTINE SSYEVD_F95( A, W, JOBZ, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE SSYEVD_F95

       SUBROUTINE DSYEVD_F95( A, W, JOBZ, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE DSYEVD_F95

      END INTERFACE

      INTERFACE LA_HEEVD

       SUBROUTINE CHEEVD_F95( A, W, JOBZ, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE CHEEVD_F95

      END INTERFACE

        INTERFACE LA_SYEVR

       SUBROUTINE SSYEVR_F95( A, W, JOBZ, UPLO, VL, VU, IL, IU, M,      &
     &                        ISUPPZ, ABSTOL, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         REAL(WP), INTENT(INOUT) :: A(:,:)
         REAL(WP), INTENT(OUT) :: W(:)
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  JOBZ, UPLO
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
         INTEGER, INTENT(IN), OPTIONAL :: IL, IU
         INTEGER, INTENT(OUT), OPTIONAL :: M
         INTEGER, INTENT(OUT), OPTIONAL, TARGET :: ISUPPZ(:)
       END SUBROUTINE SSYEVR_F95   

       SUBROUTINE DSYEVR_F95( A, W, JOBZ, UPLO, VL, VU, IL, IU, M,      &
     &                        ISUPPZ, ABSTOL, INFO )
         USE LA_PRECISION, ONLY: WP => DP
         REAL(WP), INTENT(INOUT) :: A(:,:)
         REAL(WP), INTENT(OUT) :: W(:)
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  JOBZ, UPLO
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
         INTEGER, INTENT(IN), OPTIONAL :: IL, IU
         INTEGER, INTENT(OUT), OPTIONAL :: M
         INTEGER, INTENT(OUT), OPTIONAL, TARGET :: ISUPPZ(:)
       END SUBROUTINE DSYEVR_F95   

       END INTERFACE
	   
       INTERFACE LA_HEEVR
		 
       SUBROUTINE CHEEVR_F95( A, W, JOBZ, UPLO, VL, VU, IL, IU, M,      &
     &                        ISUPPZ, ABSTOL, INFO )
        USE LA_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        REAL(WP), INTENT(OUT) :: W(:)
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL ::  JOBZ, UPLO
        INTEGER, INTENT(OUT), OPTIONAL :: INFO
        REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
        INTEGER, INTENT(IN), OPTIONAL :: IL, IU
        INTEGER, INTENT(OUT), OPTIONAL :: M
        INTEGER, INTENT(OUT), OPTIONAL, TARGET :: ISUPPZ(:) 
       END SUBROUTINE CHEEVR_F95
       
      END INTERFACE

      INTERFACE LA_SYEVX

       SUBROUTINE SSYEVX_F95( A, W, JOBZ, UPLO, VL, VU, IL, IU, M,      &
     &                        IFAIL, ABSTOL, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(IN), OPTIONAL :: IL, IU
           INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
           REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
           INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
           REAL(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE SSYEVX_F95

       SUBROUTINE DSYEVX_F95( A, W, JOBZ, UPLO, VL, VU, IL, IU, M,      &
     &                        IFAIL, ABSTOL, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(IN), OPTIONAL :: IL, IU
           INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
           REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
           INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
           REAL(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE DSYEVX_F95

      END INTERFACE

      INTERFACE LA_HEEVX

       SUBROUTINE CHEEVX_F95( A, W, JOBZ, UPLO, VL, VU, IL, IU, M,      &
     &                        IFAIL, ABSTOL, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(IN), OPTIONAL :: IL, IU
           INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
           REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
           INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
           COMPLEX(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE CHEEVX_F95

      END INTERFACE

      INTERFACE LA_SYGST

       SUBROUTINE SSYGST_F95( A, B, ITYPE, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(IN), OPTIONAL :: ITYPE
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(IN) :: B(:,:)
        END SUBROUTINE SSYGST_F95

       SUBROUTINE DSYGST_F95( A, B, ITYPE, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(IN), OPTIONAL :: ITYPE
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(IN) :: B(:,:)
        END SUBROUTINE DSYGST_F95

      END INTERFACE

      INTERFACE LA_HEGST

       SUBROUTINE CHEGST_F95( A, B, ITYPE, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(IN), OPTIONAL :: ITYPE
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(INOUT) :: A(:,:)
           COMPLEX(WP), INTENT(IN) :: B(:,:)
        END SUBROUTINE CHEGST_F95

      END INTERFACE

      INTERFACE LA_SYGV

       SUBROUTINE SSYGV_F95( A, B, W, ITYPE, JOBZ, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(IN), OPTIONAL :: ITYPE
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE SSYGV_F95

       SUBROUTINE DSYGV_F95( A, B, W, ITYPE, JOBZ, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(IN), OPTIONAL :: ITYPE
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE DSYGV_F95

      END INTERFACE

      INTERFACE LA_HEGV

       SUBROUTINE CHEGV_F95( A, B, W, ITYPE, JOBZ, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
           INTEGER, INTENT(IN), OPTIONAL :: ITYPE
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
           REAL(WP), INTENT(OUT) :: W(:)
        END SUBROUTINE CHEGV_F95

      END INTERFACE

         INTERFACE LA_SYGVX

        SUBROUTINE SSYGVX_F95( A, B, W, ITYPE, JOBZ, UPLO, VL, VU, IL,  &
     &                         IU, M, IFAIL, ABSTOL, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
         REAL(WP), INTENT(OUT) :: W(:)
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
         INTEGER, INTENT(IN), OPTIONAL :: IL, IU, ITYPE
         INTEGER, INTENT(OUT), OPTIONAL :: M
         INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
        END SUBROUTINE SSYGVX_F95
	
        SUBROUTINE DSYGVX_F95( A, B, W, ITYPE, JOBZ, UPLO, VL, VU, IL,  &
     &                         IU, M, IFAIL, ABSTOL, INFO )
         USE LA_PRECISION, ONLY: WP => DP
         REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
         REAL(WP), INTENT(OUT) :: W(:)
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
         INTEGER, INTENT(IN), OPTIONAL :: IL, IU, ITYPE
         INTEGER, INTENT(OUT), OPTIONAL :: M
         INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
        END SUBROUTINE DSYGVX_F95
	
       END INTERFACE
		  
       INTERFACE LA_HEGVX

       SUBROUTINE CHEGVX_F95( A, B, W, ITYPE, JOBZ, UPLO, VL, VU, IL,   &
     &                        IU, M, IFAIL, ABSTOL, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
         REAL(WP), INTENT(OUT) :: W(:)
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
         INTEGER, INTENT(IN), OPTIONAL :: IL, IU, ITYPE
         INTEGER, INTENT(OUT), OPTIONAL :: M
         INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
        END SUBROUTINE  CHEGVX_F95

        END INTERFACE

         INTERFACE LA_SYGVD

        SUBROUTINE SSYGVD_F95( A, B, W, ITYPE, JOBZ, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => SP
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
            REAL(WP), INTENT(OUT) :: W(:)
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
            INTEGER, INTENT(IN), OPTIONAL :: ITYPE 
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
           END SUBROUTINE SSYGVD_F95

        SUBROUTINE DSYGVD_F95( A, B, W, ITYPE, JOBZ, UPLO, INFO )
            USE LA_PRECISION, ONLY: WP => DP
            REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
            REAL(WP), INTENT(OUT) :: W(:)
            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
            INTEGER, INTENT(IN), OPTIONAL :: ITYPE 
            INTEGER, INTENT(OUT), OPTIONAL :: INFO
           END SUBROUTINE DSYGVD_F95

            END INTERFACE
	    
          INTERFACE LA_HEGVD
	  
       SUBROUTINE CHEGVD_F95( A, B, W, ITYPE, JOBZ, UPLO, INFO )
          USE LA_PRECISION, ONLY: WP => SP
          COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
          REAL(WP), INTENT(OUT) :: W(:)
          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOBZ, UPLO
          INTEGER, INTENT(OUT), OPTIONAL :: INFO
          INTEGER, INTENT(IN), OPTIONAL :: ITYPE
         END SUBROUTINE CHEGVD_F95   


        END INTERFACE
      
      INTERFACE LA_SYTRD

       SUBROUTINE SSYTRD_F95( A, TAU, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(OUT) :: TAU(:)
        END SUBROUTINE SSYTRD_F95

       SUBROUTINE DSYTRD_F95( A, TAU, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(INOUT) :: A(:,:)
           REAL(WP), INTENT(OUT) :: TAU(:)
        END SUBROUTINE DSYTRD_F95

      END INTERFACE

      INTERFACE LA_HETRD

       SUBROUTINE CHETRD_F95( A, TAU, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(INOUT) :: A(:,:)
           COMPLEX(WP), INTENT(OUT) :: TAU(:)
        END SUBROUTINE CHETRD_F95

      END INTERFACE

      INTERFACE LA_ORGTR

       SUBROUTINE SORGTR_F95( A, TAU, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(IN) :: TAU(:)
           REAL(WP), INTENT(INOUT) :: A(:,:)
        END SUBROUTINE SORGTR_F95

       SUBROUTINE DORGTR_F95( A, TAU, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           REAL(WP), INTENT(IN) :: TAU(:)
           REAL(WP), INTENT(INOUT) :: A(:,:)
        END SUBROUTINE DORGTR_F95

      END INTERFACE

      INTERFACE LA_UNGTR

       SUBROUTINE CUNGTR_F95( A, TAU, UPLO, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
           INTEGER, INTENT(OUT), OPTIONAL :: INFO
           COMPLEX(WP), INTENT(IN) :: TAU(:)
           COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        END SUBROUTINE CUNGTR_F95

      END INTERFACE

      INTERFACE LA_POTRF

       SUBROUTINE SPOTRF_F95( A, UPLO, RCOND, NORM, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM, UPLO
           INTEGER, INTENT(OUT), OPTIONAL  :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(INOUT) :: A(:,:)
        END SUBROUTINE SPOTRF_F95

       SUBROUTINE DPOTRF_F95( A, UPLO, RCOND, NORM, INFO )
           USE LA_PRECISION, ONLY: WP => DP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM, UPLO
           INTEGER, INTENT(OUT), OPTIONAL  :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           REAL(WP), INTENT(INOUT) :: A(:,:)
        END SUBROUTINE DPOTRF_F95

       SUBROUTINE CPOTRF_F95( A, UPLO, RCOND, NORM, INFO )
           USE LA_PRECISION, ONLY: WP => SP
           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM, UPLO
           INTEGER, INTENT(OUT), OPTIONAL  :: INFO
           REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
           COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        END SUBROUTINE CPOTRF_F95

      END INTERFACE

      INTERFACE LA_LAGGE

      SUBROUTINE SLAGGE_F95( A, KL, KU, D, ISEED, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         INTEGER, INTENT(IN), OPTIONAL :: KL, KU
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: ISEED(4)
         REAL(WP), INTENT(IN), OPTIONAL, TARGET :: D(:)
         REAL(WP), INTENT(OUT) :: A(:,:)
      END SUBROUTINE SLAGGE_F95

      SUBROUTINE DLAGGE_F95( A, KL, KU, D, ISEED, INFO )
         USE LA_PRECISION, ONLY: WP => DP
         INTEGER, INTENT(IN), OPTIONAL :: KL, KU
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: ISEED(4)
         REAL(WP), INTENT(IN), OPTIONAL, TARGET :: D(:)
         REAL(WP), INTENT(OUT) :: A(:,:)
      END SUBROUTINE DLAGGE_F95

      SUBROUTINE CLAGGE_F95( A, KL, KU, D, ISEED, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         INTEGER, INTENT(IN), OPTIONAL :: KL, KU
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: ISEED(4)
         REAL(WP), INTENT(IN), OPTIONAL, TARGET :: D(:)
         COMPLEX(WP), INTENT(OUT) :: A(:,:)
      END SUBROUTINE CLAGGE_F95

      END INTERFACE

      INTERFACE LA_LANGE

      FUNCTION SLANGE_F95( A, NORM, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         REAL(WP) :: SLANGE_F95
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(IN) :: A(:,:)
      END FUNCTION SLANGE_F95

      FUNCTION SLANGE1_F95( A, NORM, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         REAL(WP) :: SLANGE1_F95
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(IN) :: A(:)
      END FUNCTION SLANGE1_F95

      FUNCTION DLANGE_F95( A, NORM, INFO )
         USE LA_PRECISION, ONLY: WP => DP
         REAL(WP) :: DLANGE_F95
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(IN) :: A(:,:)
      END FUNCTION DLANGE_F95

      FUNCTION DLANGE1_F95( A, NORM, INFO )
         USE LA_PRECISION, ONLY: WP => DP
         REAL(WP) :: DLANGE1_F95
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         REAL(WP), INTENT(IN) :: A(:)
      END FUNCTION DLANGE1_F95

      FUNCTION CLANGE_F95( A, NORM, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         REAL(WP) :: CLANGE_F95
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         COMPLEX(WP), INTENT(IN) :: A(:,:)
      END FUNCTION CLANGE_F95

      FUNCTION CLANGE1_F95( A, NORM, INFO )
         USE LA_PRECISION, ONLY: WP => SP
         REAL(WP) :: CLANGE1_F95
         CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
         INTEGER, INTENT(OUT), OPTIONAL :: INFO
         COMPLEX(WP), INTENT(IN) :: A(:)
      END FUNCTION CLANGE1_F95

      END INTERFACE

      INTERFACE LA_GESDD
      
       SUBROUTINE SGESDD_F95(A, S, U, VT, WW, JOB, INFO )
      USE LA_PRECISION, ONLY: WP => SP
      CHARACTER(LEN=1), OPTIONAL, INTENT(IN) :: JOB
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: S(:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: WW(:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: U(:,:), VT(:,:)
      END SUBROUTINE SGESDD_F95
      
       SUBROUTINE DGESDD_F95(A, S, U, VT, WW, JOB, INFO )
      USE LA_PRECISION, ONLY: WP => DP
      CHARACTER(LEN=1), OPTIONAL, INTENT(IN) :: JOB
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: S(:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: WW(:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: U(:,:), VT(:,:)
      END SUBROUTINE DGESDD_F95
      
       SUBROUTINE CGESDD_F95(A, S, U, VT, WW, JOB, INFO )
      USE LA_PRECISION, ONLY: WP => SP
      CHARACTER(LEN=1), OPTIONAL, INTENT(IN) :: JOB
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      COMPLEX(WP), INTENT(INOUT) :: A(:,:)
      REAL(WP), INTENT(OUT) :: S(:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: WW(:)
      COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: U(:,:), VT(:,:)
      END SUBROUTINE CGESDD_F95
      
        END INTERFACE                         

      END MODULE F95_LAPACK

SUBROUTINE LA_TEST_SGEGS(JOBVSL, JOBVSR, N, A, LDA, B, LDB, ALPHAR, ALPHAI, BETA, VSL, LDVSL, VSR, LDVSR, WORK, LWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 5, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GEGS
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDA, LDB, LDVSL, LDVSR, LWORK
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBVSL, JOBVSR
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB, 1:N)
   REAL(WP), INTENT(OUT):: WORK(1:LWORK)
   REAL(WP), INTENT(OUT) :: ALPHAR(1:N), ALPHAI(1:N), BETA(1:N), &
&                           VSL(1: LDVSL, 1:N), VSR(1: LDVSR, 1:N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GEGS '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGEGS '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IALPHAI, IALPHAR, IBETA, IVSL1, &
&    IVSL2, IVSR1, IVSR2
   CHARACTER*1 :: IJOBVSL, IJOBVSR
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IJOBVSL = JOBVSL; IJOBVSR = JOBVSR
   IB1 = N; IB2 = N; IALPHAR = N; IALPHAI = N; IBETA = N
   IVSL1 = N; IVSL2 = N; IVSR1 = N; IVSR2 = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
       IA2 = IA1 - 1
     CASE (2)
       IB1 = IA1 - 1
     CASE (3)
       IALPHAR = IA1 - 1
     CASE (4)
       IALPHAI = IA1 - 1
     CASE (5)
       IBETA  = IA1 - 1
     CASE (6)
       IVSL1 = IA1 - 1
     CASE (7)
       IVSR1 = IA1 - 1
     CASE(:-1,8:)
       CALL UESTOP(SRNAMT)
   END SELECT

   IF (LSAME(IJOBVSL,'V')) THEN
     IF (LSAME (IJOBVSR, 'V')) THEN
       CALL LA_GEGS( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
&        ALPHAI(1:IALPHAI), BETA(1: IBETA), VSL(1:IVSL1,1:IVSL2), &
&        VSR(1:IVSR1,1:IVSR2), INFO)    
     ELSE
       CALL LA_GEGS( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
&        ALPHAI(1:IALPHAI), BETA(1: IBETA), VSL(1:IVSL1,1:IVSL2), &
&        INFO = INFO)
     END IF
   ELSE 
     IF (LSAME (IJOBVSR, 'V')) THEN
       CALL LA_GEGS( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
&        ALPHAI(1:IALPHAI), BETA(1: IBETA),&
&        VSR = VSR(1:IVSR1,1:IVSR2), INFO = INFO)
     ELSE
       CALL LA_GEGS( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
&        ALPHAI(1:IALPHAI), BETA(1: IBETA), &
&        INFO = INFO)
     END IF
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_SGEGS
      
      

      PROGRAM LA_CHPGV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_HPGV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N
      REAL(WP), ALLOCATABLE :: W(:)
!  .. "Local Arrays" ..
      COMPLEX(WP), ALLOCATABLE :: A(:), AA(:), B(:), BB(:), Z(:,:)
!  .. "Intrinsic Functions" ..
      INTRINSIC REAL, AIMAG, INT
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_HPGV Example Program Results'
      N = 5
      ALLOCATE( A(N*(N+1)/2), AA(N*(N+1)/2), B(N*(N+1)/2), BB(N*(N+1)/2), W(N), Z(N,N) )

      OPEN(UNIT=21,FILE='hpgvu.ma',STATUS='UNKNOWN')
      DO J=1,N*(N+1)/2
         READ(21,*) A(J)
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix AP : '
      DO I=1,N*(N+1)/2
         WRITE(*,"('('(I3,',',I3)')')") INT(A(I)), INT(AIMAG(A(I)))
      ENDDO

      OPEN(UNIT=21,FILE='hpgvu.mb',STATUS='UNKNOWN')
      DO J=1,N*(N+1)/2
         READ(21,*) B(J)
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix B : '
      DO I=1,N*(N+1)/2
         WRITE(*,"('('(I3,',',I3)')')") INT(B(I)), INT(AIMAG(B(I)))
      ENDDO
    
      WRITE(*,*) "CALL LA_HPGV( AP, BP, W) "
      CALL LA_HPGV( A, B, W )
   
      WRITE(*,*)'BP on exit : '
      DO I=1,N*(N+1)/2
         WRITE(*,"('('(E14.6,1X,','E14.6)')')") REAL(B(I)), AIMAG(B(I))
      ENDDO
  
      WRITE(*,*) 'W on exit : '
      DO I=1,N
         WRITE(*,"(5(E14.6))") W(I)
      ENDDO   

      WRITE(*,*)
      WRITE(*,*)' * EXAMPLE 2 * '

      OPEN(UNIT=21,FILE='hpgvl.ma',STATUS='UNKNOWN')
      DO J=1,N*(N+1)/2
         READ(21,*) AA(J)
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix AP : '
      DO I=1,N*(N+1)/2
         WRITE(*,"('('(I3,',',I3)')')") INT(AA(I)), INT(AIMAG(AA(I)))
      ENDDO
    
      OPEN(UNIT=21,FILE='hpgvl.mb',STATUS='UNKNOWN')
      DO J=1,N*(N+1)/2
         READ(21,*) BB(J)
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix BP : '
      DO I=1,N*(N+1)/2
         WRITE(*,"('('(I3,',',I3)')')") INT(BB(I)), INT(AIMAG(BB(I)))
      ENDDO
   
      WRITE(*,*)
!      WRITE(*,*) "CALL LA_HPGV( A, B, W, JOBZ, UPLO, INFO )"
!      CALL LA_HPGV( AA, BB, W, 3, 'L', Z, INFO )
       WRITE(*,*) "CALL LA_HPGV( A, B, W, 3, 'L', Z, INFO)"
       CALL LA_HPGV( AA, BB, W, 3, 'L', Z, INFO )
      
      WRITE(*,*)'Z on exit : '
      DO I=1,N
         DO J=1,N-1
            WRITE(*,"('('(E14.6,1X,',',1X,E14.6)')')") REAL(Z(I,J)), AIMAG(Z(I,J))
         ENDDO
         WRITE(*,"('('(E14.6,1X,',',1X,E14.6)')')") REAL(Z(I,N)), AIMAG(Z(I,N))
      ENDDO
      WRITE(*,*)'BP on exit : '
      DO I=1,N*(N+1)/2
         WRITE(*,"('('(E14.6,1X,',',1X,E14.6)')')") REAL(BB(I)), AIMAG(BB(I))
      ENDDO

      WRITE(*,*) 'W on exit : '
      DO I=1,N
      WRITE(*,"(5(E14.6,1X))") W(I)
      ENDDO
      WRITE(*,*) ' INFO = ', INFO

      END PROGRAM LA_CHPGV_EXAMPLE

SUBROUTINE SGEEQU_F95( A, R, C, ROWCND, COLCND, AMAX, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO
   USE F77_LAPACK, ONLY: GEEQU_F77 => LA_GEEQU
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT( OUT ), OPTIONAL :: AMAX, COLCND, ROWCND
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT( IN ) :: A( :, : )
   REAL(WP), INTENT( OUT ) :: C( : ), R( : )
!---------------------------------------------------------------------
!
! Purpose
! =======
!
! LA_GEEQU computes row and column scalings intended to equilibrate a
! rectangle matrix A and reduce its condition number.  R returns the
! row scale factors and C the column scale factors, chosen to try to
! make the largest entry in each row and column of the matrix B with
! elements B(i,j) = R(i) A(i,j) C(j) have absolute value 1.
!
! R(i) and C(j) are restricted to be between SMLNUM = smallest safe
! number and BIGNUM = largest safe number. Use of these scaling
! factors is not guaranteed to reduce the condition number of A but
! works well in practice.
!
! Arguments
! =========
!
! SUBROUTINE LA_GEEQU ( A, R, C, ROWCND, COLCND, AMAX, INFO )
!    <type>(<wp>), INTENT(IN) :: A(:,:)
!    REAL(<wp>), INTENT( OUT ) :: R(:), C(:)
!    REAL(<wp>), INTENT( OUT ), OPTIONAL :: ROWCND, COLCND, AMAX
!    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!    where
!    <type> ::= REAL | COMPLEX
!    <wp>   ::= KIND(1.0) | KIND(1.0D0)
!
! ====================
!
! A       (input) either REAL or COMPLEX array, shape (:,:).
!         The matrix A, whose equilibration factors are to be computed.
!
! R       (output) REAL array, shape (:), size(R) == size(A,1).
!         If INFO = 0 or INFO > size(A,1), R contains the row
!         scale factors for A.
!
! C       (output) REAL array, shape (:), size(C) == size(A,2).
!         If INFO = 0, C contains the column scale factors for A.
!
! ROWCND  Optional (output) REAL.
!         If INFO = 0 or INFO > size(A,1), ROWCND contains the ratio
!         of the smallest R(i) to the largest R(i).  If ROWCND >= 0.1
!         and AMAX is neither too large nor too small, it is not worth
!         scaling by R.
!
! COLCND  Optional (output) REAL.
!         If INFO = 0, COLCND contains the ratio of the smallest
!         C(i) to the largest C(i).  If COLCND >= 0.1, it is not
!         worth scaling by C.
!
! AMAX    Optional (output) REAL.
!         Absolute value of largest matrix element.  If AMAX is very
!         close to overflow or very close to underflow, the matrix
!         should be scaled.
!
! INFO    Optional (output) INTEGER
!         If INFO is present
!            = 0:  successful exit
!            < 0:  if INFO = -k, the k-th argument had an illegal value
!            > 0:  if INFO = k,  and k is
!                  <= M:  the k-th row of A is exactly zero
!                  >  M:  the (k-M)-th column of A is exactly zero
!                         where M = size(A,1)
!         If INFO is not present and an error occurs, then the program is
!            terminated with an error message.
!
!-------------------------------------------------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GEEQU'
!  .. LOCAL SCALARS ..
   INTEGER :: LINFO, M, N
   REAL(WP) :: LAMAX, LCOLCND, LROWCND
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC SIZE, MAX
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; M = SIZE(A, 1); N = SIZE(A, 2)
!  .. TEST THE ARGUMENTS
   IF ( SIZE(R) /= M ) THEN; LINFO = -2
   ELSE IF ( SIZE(C) /= N ) THEN; LINFO = -3
   ELSE
!     .. CALL LAPACK77 ROUTINE
      CALL GEEQU_F77( M, N, A, MAX(1,M), R, C, LROWCND, LCOLCND, LAMAX, LINFO )
      IF( PRESENT( ROWCND ) ) ROWCND = LROWCND
      IF( PRESENT( COLCND ) ) COLCND = LCOLCND
      IF( PRESENT( AMAX ) ) AMAX = LAMAX
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO )
END SUBROUTINE SGEEQU_F95

 SUBROUTINE CPTSV_F95( D, E, B, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => SP
    USE LA_AUXMOD, ONLY: ERINFO
    USE F77_LAPACK, ONLY: PTSV_F77 => LA_PTSV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    REAL(WP), INTENT(INOUT) :: D(:)
    COMPLEX(WP), INTENT(INOUT) :: E(:), B(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_PTSV computes the solution to a linear system of equations 
! A*X = B, where A has tridiagonal form and is real symmetric or complex
! Hermitian and, in either case, positive definite, and where X and B are
! rectangular matrices or vectors. A is factored as A = L*D*L^H, where L 
! is a unit lower bidiagonal matrix and D is a diagonal matrix. The 
! factored form of A is then used to solve the above system.
! 
! =========
! 
!        SUBROUTINE LA_PTSV( D, E, B, INFO=info )
!            REAL(<wp>), INTENT(INOUT) :: D(:)
!            <type>(<wp>), INTENT(INOUT) :: E(:), <rhs>
!            INTEGER, INTENT(OUT), OPTIONAL :: INFO
!        where
!            <type> ::= REAL | COMPLEX
!            <wp>   ::= KIND(1.0) | KIND(1.0D0)
!            <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! D      (input/output) REAL array, shape (:) with size(D) = n, where n 
!        is the order of A.
!        On entry, the diagonal of A.
!        On exit, the diagonal of D.
! E      (input/output) REAL or COMPLEX array, shape (:), with 
!        size(E) = n-1.
!        On entry, the subdiagonal of A.
!        On exit, the subdiagonal of L.
! B      (input/output) REAL or COMPLEX array, shape (:,:) with 
!        size(B,1) = n or shape (:) with size(B) = n.
!        On entry, the matrix B.
!        On exit, the solution matrix X.
! INFO   Optional (output) INTEGER.
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value.
!        > 0: if INFO = i, the leading minor of order i of A is not 
!             positive definite, and the solution has not been computed.
! 	    The factorization has not been completed unless i = n.
!        If INFO is not present and an error occurs, then the program is
!        terminated with an error message.
!----------------------------------------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_PTSV'
!   .. LOCAL SCALARS ..
    INTEGER :: LINFO, N, NRHS
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0
    N = SIZE(D); NRHS = SIZE(B,2)
!   .. TEST THE ARGUMENTS
    IF( N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( E ) /= N-1 .AND. N /= 0 ) THEN; LINFO = -2
    ELSE IF( SIZE( B, 1 ) /= N .OR. NRHS < 0 ) THEN; LINFO = -3
    ELSE IF ( N > 0 ) THEN
       CALL PTSV_F77( N, NRHS, D, E, B, N, LINFO )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO )
 END SUBROUTINE CPTSV_F95

PROGRAM LA_SSTEVD_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_STEVD
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, INFO, N
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: D(:), DD(:), E(:), EE(:), Z(:,:), DUMMY(:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'SSTEVD ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N
   PRINT *, 'N = ', N
   ALLOCATE ( D(N), DD(N), E(N-1), EE(N-1), Z(N,N) )
!
   READ (NIN, *) DD, EE
   WRITE(NOUT,*) 'The matrix A:'
   WRITE (NOUT,*) 'D  '; WRITE (NOUT,FMT) DD
   WRITE (NOUT,*) 'EE '; WRITE (NOUT,FMT) EE
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_SSTEVX LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_STEVD( D, E, Z, INFO )'
   D = DD; E = EE
   CALL LA_STEVD( D, E, Z, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
   WRITE(NOUT,FMT) D
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_STEVD( D, E, Z )'
   D = DD; E = EE
   CALL LA_STEVD( D, E, Z )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) D
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_STEVD( D, E )'
   D = DD; E = EE
   CALL LA_STEVD( D, E )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) D
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_STEVD( DUMMY, E, INFO=INFO )'
   D = DD; E = EE
   CALL LA_STEVD( DUMMY, E, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_STEVD( D, E(1:N), INFO=INFO )'
   D = DD; E = EE
   CALL LA_STEVD( D, E(1:N), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_STEVD( D, E, Z=Z(1:N-1,:), INFO=INFO )'
   D = DD; E = EE
   CALL LA_STEVD( D, E, Z=Z(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_STEVD( D, E, Z=Z(:,1:N-1) )'
   D = DD; E = EE
   CALL LA_STEVD( D, E, Z=Z(:,1:N-1) )
!
END PROGRAM LA_SSTEVD_ET_EXAMPLE

SUBROUTINE LA_TEST_ZGETRF( M, N, A, LDA, IPIV, INFO )
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     October 31, 1996
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GETRF
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: M, N, LDA
   INTEGER, INTENT(INOUT) :: INFO
!  .. Array Arguments ..
   INTEGER, INTENT(OUT) :: IPIV(1:N)
   COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GETRF'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZGETRF'
   INTEGER :: INFOTC
!  .. Common blocks ..
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, Ia2, IIPIV
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Intrinsic Functions ..
   INTRINSIC MIN
!  .. Executable Statements ..
   IA1 = M; IA2 = N; IIPIV = MIN(M,N);
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
         CALL LA_GETRF( A(1:IA1,1:IA2), IPIV(1:IIPIV) )
         INFO = INFOTC
   CASE (2)
      IIPIV = MIN(M,N)-1
   CASE(:-1,1,3:)
      CALL UESTOP(SRNAMT)
   END SELECT
   IF( I /= 0 ) THEN
     CALL LA_GETRF( A(1:IA1,1:IA2), IPIV(1:IIPIV), INFO = INFO )
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_ZGETRF

    SUBROUTINE CGEGS_F95( A, B, ALPHA, BETA, VSL, VSR, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO
   USE F77_LAPACK, ONLY: GEGS_F77 => LA_GEGS
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
   COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: ALPHA(:), BETA(:)
   COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: VSL(:,:), VSR(:,:)
!-----------------------------------------------------------------
!
! Purpose
! =======
!
!  LA_GEGS computes for a pair of n-by-n real nonsymmetric matrices
!  A, B: the generalized eigenvalues (alphar alpha, beta),
!  the Schur form (A, B), and optionally left and/or right
!  Schur vectors (VSL and VSR).
!
!  (If only the generalized eigenvalues are needed, use the driver SGEGV
!  instead.)
!
!  A generalized eigenvalue for a pair of matrices (A,B) is, roughly
!  speaking, a scalar w or a ratio  alpha/beta = w, such that  A - w*B
!  is singular.  It is usually represented as the pair (alpha,beta),
!  as there is a reasonable interpretation for beta=0, and even for
!  both being zero.  A good beginning reference is the book, "Matrix
!  Computations", by G. Golub & C. van Loan (Johns Hopkins U. Press)
!
!  The (generalized) Schur form of a pair of matrices is the result of
!  multiplying both matrices on the left by one orthogonal matrix and
!  both on the right by another orthogonal matrix, these two orthogonal
!  matrices being chosen so as to bring the pair of matrices into
!  (real) Schur form.
!
!  A pair of matrices A, B is in generalized real Schur form if B is
!  upper triangular with non-negative diagonal and A is block upper
!  triangular with 1-by-1 and 2-by-2 blocks.  1-by-1 blocks correspond
!  to real generalized eigenvalues, while 2-by-2 blocks of A will be
!  "standardized" by making the corresponding elements of B have the
!  form:
!          [  a  0  ]
!          [  0  b  ]
!
!  and the pair of corresponding 2-by-2 blocks in A and B will
!  have a complex conjugate pair of generalized eigenvalues.
!
!  The left and right Schur vectors are the columns of VSL and VSR,
!  respectively, where VSL and VSR are the orthogonal matrices
!  which reduce A and B to Schur form:
!
!  Schur form of (A,B) = ( (VSL)**T A (VSR), (VSL)**T B (VSR) )
!
! =========
!
!   SUBROUTINE LA_GEGS( A, B, <alpha>, BETA, VSL, VSR, INFO )
!      <type>(<wp>), INTENT(INOUT) :: A(:,:), B(:,:)
!      <type>(<wp>), INTENT(OUT), OPTIONAL :: <alpha'>, BETA(:)
!      <type>(<wp>), INTENT(OUT), OPTIONAL :: VSL(:,:), VSR(:,:)
!      INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   where
!      <type>   ::= REAL | COMPLEX
!      <wp>     ::= KIND(1.0) | KIND(1.0D0)
!      <alpha>  ::= ALPHAR, ALPHAI | ALPHA
!      <alpha'> ::= ALPHAR(:), ALPHAI(:) | ALPHA(:)
!
! Arguments
! =========
!
! A    (input/output) REAL / COMPLEX array, shape (:,:),
!      SIZE(A,1) == SIZE(A,2) == n.
!      On entry, the first of the pair of matrices whose generalized
!      eigenvalues and (optionally) Schur vectors are to be
!      computed.
!      On exit, the generalized Schur form of A.
!      Note: to avoid overflow, the Frobenius norm of the matrix
!      A should be less than the overflow threshold.
!
! B    (input/output) REAL / COMPLEX array, shape (:,:),
!      SIZE(rBA,1) == SIZE(rBA,2) == n.
!      On entry, the second of the pair of matrices whose
!      generalized eigenvalues and (optionally) Schur vectors are
!      to be computed.
!      On exit, the generalized Schur form of B.
!      Note: to avoid overflow, the Frobenius norm of the matrix
!      B should be less than the overflow threshold.
!
! ALPHAR  Only for the real case. Optional (output) REAL array,
! ALPHAI  shape (:), SIZE(ALPHA') == n. ALPHA ::= ALPHAR | ALPHAI
! ALPHA   Only for the complex case. Optional (output) COMPLEX
!         array, shape (:), SIZE(ALPHAI) == n.
! BETA Optional (output) REAL / COMPLEX array, shape (:),
!      SIZE(BETA) == n.
!      On exit, (ALPHAR(j) + ALPHAI(j)*i)/BETA(j), j=1,...,n, will
!      be the generalized eigenvalues.  ALPHAR(j) + ALPHAI(j)*i,
!      j=1,...,n  and  BETA(j),j=1,...,n  are the diagonals of the
!      complex Schur form (A,B) that would result if the 2-by-2
!      diagonal blocks of the real Schur form of (A,B) were further
!      reduced to triangular form using 2-by-2 complex unitary
!      transformations.  If ALPHAI(j) is zero, then the j-th
!      eigenvalue is real; if positive, then the j-th and (j+1)-st
!      eigenvalues are a complex conjugate pair, with ALPHAI(j+1)
!      negative.
!      Note: the quotients ALPHAR(j)/BETA(j) and ALPHAI(j)/BETA(j)
!      may easily over- or underflow, and BETA(j) may even be zero.
!      Thus, the user should avoid naively computing the ratio
!      alpha/beta.  However, ALPHAR and ALPHAI will be always less
!      than and usually comparable with norm(A) in magnitude, and
!      BETA always less than and usually comparable with norm(B).
!
! VSL  Optional (output) REAL / COMPLEX array, shape (:,:),
!      SIZE(VSL,1) == SIZE(VSL,2) == n.
!      VSL will contain the left Schur vectors. (See "Purpose", above.)
!
! VSR  Optional (output) REAL / COMPLEX array, shape (:,:),
!      SIZE(VSL,1) == SIZE(VSL,2) == n.
!      VSR will contain the right Schur vectors. (See "Purpose", above.)
!
! INFO (output) INTEGER
!      = 0:  successful exit
!      < 0:  if INFO = -i, the i-th argument had an illegal value.
!      = 1,...,n:
!            The QZ iteration failed.  (A,B) are not in Schur
!            form, but ALPHAR(j), ALPHAI(j), and BETA(j) should
!            be correct for j=INFO+1,...,n.
!      > n:  errors that usually indicate LAPACK problems:
!            =n+1: error return from LA_GGBAL
!            =n+2: error return from LA_GEQRF
!            =n+3: error return from LA_ORMQR
!            =n+4: error return from LA_ORGQR
!            =n+5: error return from LA_GGHRD
!            =n+6: error return from LA_HGEQZ (other than failed
!                                            iteration)
!            =n+7: error return from LA_GGBAK (computing VSL)
!            =n+8: error return from LA_GGBAK (computing VSR)
!            =n+9: error return from LA_LASCL (various places)
!      If INFO is not present and an error occurs, then the program is
!         terminated with an error message.
!-------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GEGS'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBVSL, LJOBVSR
   INTEGER, SAVE :: LWORK = 0
   INTEGER :: N, LINFO, LD, ISTAT, ISTAT1, S1VSL, S2VSL, S1VSR, S2VSR, &
              SALPHA, SBETA
!  .. LOCAL ARRAYS ..
   COMPLEX(WP), TARGET :: LLVSL(1,1), LLVSR(1,1)
   COMPLEX(WP), POINTER :: WORK(:), &
     &                    LALPHA(:), LBETA(:)
   REAL(WP), POINTER :: RWORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(A,1); LD = MAX(1,N)
   IF( PRESENT(ALPHA) )THEN; SALPHA = SIZE(ALPHA); ELSE; SALPHA = N; ENDIF
   IF( PRESENT(BETA) )THEN; SBETA = SIZE(BETA); ELSE; SBETA = N; ENDIF
   IF( PRESENT(VSL) )THEN; S1VSL = SIZE(VSL,1); S2VSL = SIZE(VSL,2); LJOBVSL = 'V'
   ELSE; S1VSL = 1; S2VSL = 1; LJOBVSL = 'N'; END IF
   IF( PRESENT(VSR) )THEN; S1VSR = SIZE(VSR,1); S2VSR = SIZE(VSR,2); LJOBVSR = 'V'
   ELSE; S1VSR = 1; S2VSR = 1; LJOBVSR = 'N'; END IF
!  .. TEST THE ARGUMENTS
   IF( N < 0 .OR. SIZE(A,2) /= N )THEN; LINFO = -1
   ELSE IF( SIZE(B,1) /= N .OR. SIZE(B,2) /= N )THEN; LINFO = -2
   ELSE IF( SALPHA /= N )THEN; LINFO = -3
   ELSE IF( SBETA /= N )THEN; LINFO = -4
   ELSE IF( PRESENT(VSL) .AND. ( S1VSL /= N .OR. S2VSL /= N ) )THEN; LINFO = -5
   ELSE IF( PRESENT(VSR) .AND. ( S1VSR /= N .OR. S2VSR /= N ) )THEN; LINFO = -6
   ELSE IF( N > 0 )THEN
      IF( PRESENT(ALPHA) )THEN; LALPHA => ALPHA
      ELSE; ALLOCATE(LALPHA(N),STAT=ISTAT); ENDIF
      IF( ISTAT == 0 )THEN
         IF( PRESENT(BETA) )THEN; LBETA => BETA
         ELSE; ALLOCATE(LBETA(N),STAT=ISTAT); ENDIF
      END IF
      IF( ISTAT == 0 )THEN
         ALLOCATE( RWORK(MAX(1,3*N)), STAT=ISTAT )
      END IF
      IF( ISTAT == 0 )THEN
         LWORK = MAX( 1, 2*N, LWORK); ALLOCATE(WORK(LWORK), STAT=ISTAT)
         IF( ISTAT /= 0 )THEN; DEALLOCATE(WORK,STAT=ISTAT1)
            LWORK = MAX( 1, 2*N ); ALLOCATE(WORK(LWORK), STAT=ISTAT)
            IF( ISTAT == 0) CALL ERINFO( -200, SRNAME, LINFO )
         END IF
      END IF
      IF( ISTAT == 0 ) THEN
         IF( PRESENT(VSL) )THEN
           IF( PRESENT(VSR) )THEN
              CALL GEGS_F77( LJOBVSL, LJOBVSR, N, A, LD, B, LD, LALPHA, &
                        LBETA, VSL, S1VSL, VSR, S1VSR, WORK, LWORK, RWORK, LINFO )
	    ELSE
	      CALL GEGS_F77( LJOBVSL, LJOBVSR, N, A, LD, B, LD, LALPHA, &
                        LBETA, VSL, S1VSL, LLVSR, S1VSR, WORK, LWORK, RWORK, LINFO )
	    ENDIF
	  ELSE
	    IF( PRESENT(VSR) )THEN
	       CALL GEGS_F77( LJOBVSL, LJOBVSR, N, A, LD, B, LD, LALPHA, &
                        LBETA, LLVSL, S1VSL, VSR, S1VSR, WORK, LWORK, RWORK, LINFO )
	    ELSE
	       CALL GEGS_F77( LJOBVSL, LJOBVSR, N, A, LD, B, LD, LALPHA, &
                        LBETA, LLVSL, S1VSL, LLVSR, S1VSR, WORK, LWORK, RWORK, LINFO )
	    ENDIF
	  ENDIF
         IF( LINFO == 0 ) LWORK = INT(WORK(1)+1)
      ELSE; LINFO = -100; ENDIF
      DEALLOCATE(WORK, RWORK, STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE CGEGS_F95

SUBROUTINE LA_TEST_ZGESVD(JOBU, JOBVT, M, N, A, LDA, S, U, LDU, VT, LDVT, WORK, LWORK, RWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 31, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GESVD
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: M, N, LDA, LDU, LDVT, LWORK
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBU, JOBVT
!  .. Array Arguments ..
   COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N)
   COMPLEX(WP), INTENT(OUT):: WORK(1:LWORK)
   REAL(WP), INTENT(OUT) :: S(1: MIN(M,N))
   COMPLEX(WP), INTENT(OUT) :: U(1: LDU, 1:N), VT(1: LDVT, 1:N)
   REAL(WP) :: RWORK(1: 5*MIN(M,N))
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GESVD'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZGESVD'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IS, IU1, IU2, IVT1, IVT2, IRWORK
   CHARACTER*1 :: IJOBU, IJOBVT, IJOB
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IA1 = M; IA2 = N; IJOBVT = JOBVT; IJOBU = JOBU
   IS = MIN(M,N); IU1 = M; IU2 = M; IVT1 = N; IVT2 = N;
   IJOB = 'N'; IRWORK = IS - 1
   I = INFO / 100; J = INFO - I*100
   IF (LSAME(IJOBVT, 'O')) THEN
     IJOB = 'V'
   ELSE
     IF (LSAME(IJOBU, 'O')) THEN
       IJOB = 'U'
     END IF
   END IF

   SELECT CASE(I)
     CASE (2)
       IS = IS - 1
     CASE (3)
       IU1 = IU1 - 1
       IJOBVT = 'A'
       IJOBU = 'A'
     CASE (4)
       IVT2 = IVT2 - 1
       IJOBVT = 'A'
       IJOBU = 'A'
     CASE (5)
       IRWORK = IRWORK - 2
     CASE (6)
       IJOB = 'T'
     CASE(:-1,1,7:)
       CALL UESTOP(SRNAMT)
   END SELECT

   IF ( LSAME(IJOBVT,'A') .OR. LSAME(IJOBVT,'S')) THEN
     IF (LSAME (IJOBU, 'A') .OR. LSAME(IJOBU,'S')) THEN
       CALL LA_GESVD( A(1:IA1,1:IA2), S(1:IS), U(1:IU1, 1:IU2), &
&        VT(1: IVT1, 1: IVT2), WW = RWORK(1: IRWORK), &
&        JOB=IJOB, INFO=INFO)
     ELSE
       CALL LA_GESVD( A(1:IA1,1:IA2), S(1:IS), &
&        VT=VT(1: IVT1, 1: IVT2), WW = RWORK(1: IRWORK), &
&        JOB=IJOB, INFO=INFO)
     END IF
   ELSE 
     IF (LSAME (IJOBU, 'A') .OR. LSAME(IJOBU,'S')) THEN
       CALL LA_GESVD(A(1:IA1,1:IA2), S(1:IS), U(1:IU1, 1:IU2), &
        WW = RWORK(1: IRWORK), JOB=IJOB, INFO=INFO)
     ELSE
       CALL LA_GESVD( A(1:IA1,1:IA2), S(1:IS), WW = RWORK(1: IRWORK), &
&        JOB=IJOB, INFO=INFO)
     END IF
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_ZGESVD
      
      

      PROGRAM LA_SGEESX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GEESX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N, SDIM
      REAL(WP) :: RCONDE, RCONDV
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), WR(:), WI(:), VS(:,:)
      INTERFACE
         FUNCTION SELECT(WR, WI)
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT(IN) :: WR, WI
            LOGICAL :: SELECT
         END FUNCTION SELECT
      END INTERFACE
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GEESX Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), VS(N,N), WR(N), WI(N) )

      OPEN(UNIT=21,FILE='gees.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=A

      WRITE(*,*)'Matrix A:'
      DO I=1,N; 
         WRITE(*,"(5(I3,1X))") INT(A(I,:));
      ENDDO 

      WRITE(*,*) 'CALL LA_GEESX( A, WR, WI, SELECT=SELECT, SDIM=SDIM,', &
                 ' RCONDE=RCONDE, RCONDV=RCONDV )'
      CALL LA_GEESX(  A, WR, WI, SELECT=SELECT, SDIM=SDIM, RCONDE=RCONDE, RCONDV=RCONDV  )
     
      WRITE(*,*) 'A on exit : '
      DO I=1,N; 
         WRITE(*,"(5(F12.5,1X))") A(I,:); 
      ENDDO
   
      WRITE(*,*) 'WR on exit : '
      DO I=1,N; 
         WRITE(*,"(5(F12.5,1X))") WR(I); 
      ENDDO

      WRITE(*,*) 'WI on exit : '
      DO I=1,N;    
      WRITE(*,"(5(F12.5,1X))") WI(I)
      ENDDO
   
      WRITE(*,*)'SDIM = ',SDIM
      WRITE(*,*)'RCONDE = ',RCONDE
   
      WRITE(*,*)'RCONDV = ',RCONDV

      END PROGRAM LA_SGEESX_EXAMPLE
      LOGICAL FUNCTION SELECT( WR, WI)
         USE LA_PRECISION, ONLY: WP => SP
         REAL(WP), INTENT(IN) :: WR, WI
         INTRINSIC EPSILON, ABS
         IF( ( ABS(WR) + ABS(WI) ) < 20.0_WP )THEN
            SELECT = .TRUE.
         ELSE
            SELECT = .FALSE.
         END IF
      END FUNCTION SELECT

SUBROUTINE LA_TEST_SGECON( NORM, N, A, LDA, ANORM, RCOND, WORK, &
                           IWORK, INFO )
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     October 31, 1996
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GETRF
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   CHARACTER(LEN=1), INTENT(IN) :: NORM
   INTEGER, INTENT(IN) :: N, LDA
   INTEGER, INTENT(INOUT) :: INFO
   REAL(WP), INTENT(IN) :: ANORM
   REAL(WP), INTENT(OUT) :: RCOND
!  .. Array Arguments ..
   INTEGER, INTENT(INOUT) :: IWORK(1:N)
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), WORK(*)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GETRF'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGECON'
!  .. Local Scalars ..
   CHARACTER(LEN=1) LNORM
   INTEGER :: I, J, IA1, IA2, IIWORK
   REAL(WP) :: W1
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   W1 = ANORM; RCOND = WORK(1)
   IA1 = N; IA2 = N; IIWORK = N; LNORM = NORM
      I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
         IF( LNORM == 'N' )THEN
            CALL LA_GETRF( A(1:IA1,1:IA2), IWORK(1:IIWORK), RCOND )
         ELSE
            CALL LA_GETRF( A(1:IA1,1:IA2), IWORK(1:IIWORK), RCOND, LNORM )
         END IF
         INFO = 0
   CASE (1)
      IA2 = IA1-1
   CASE (2)
      IIWORK = IA1-1
   CASE(4)
      SELECT CASE(J)
      CASE(1)
         CALL LA_GETRF( A(1:IA1,1:IA2), IWORK(1:IIWORK), NORM = LNORM, &
              INFO = INFO )
      CASE(2)
         LNORM = '/'
      CASE(:0,3,5:)
         CALL UESTOP(SRNAMT)
      END SELECT
      CASE(:-1,5:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF ( I /= 0 ) THEN 
      CALL LA_GETRF( A(1:IA1,1:IA2),IWORK(1:IIWORK), RCOND, LNORM, INFO )
   END IF
   IF( RCOND == 0.0_WP .AND. I == 0 ) INFO = 0
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_SGECON

SUBROUTINE LA_TEST_DGGSVD(JOBU, JOBV, JOBQ, M, N, P, K, L, A, LDA, B, LDB, ALPHA, BETA, U, LDU, V, LDV, Q, LDQ, WORK, IWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     Jun 2, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => DP
      USE F95_LAPACK, ONLY: LA_GGSVD
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: M, N, P, LDA, LDB,  LDU, LDV, LDQ
      INTEGER, INTENT(OUT) :: K, L
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: JOBU, JOBV, JOBQ
!  .. Array Arguments ..
      REAL(WP), INTENT(INOUT) :: A(1:LDA,1: N), B(1: LDB, 1: N)
      REAL(WP), INTENT(OUT):: WORK(1: MAX(3*N, M, P)+N)
      REAL(WP), INTENT(OUT) :: U(1: LDU, 1:M), ALPHA(1: N), BETA(1: N), &
     &  V(1: LDV, 1:P), Q(1: LDQ, 1: N)
      INTEGER, INTENT(OUT) :: IWORK(1: N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GGSVD'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DGGSVD'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, IB1, IB2, IU1, IU2, IV1, IV2, IQ1, &
     &  IQ2, IALPHA, IBETA
      CHARACTER*1 :: IJOBU, IJOBV, IJOBQ
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      LOGICAL LSAME
!  .. Executable Statements ..
      IA1 = M; IA2 = N; IB1 = P; IB2 = N
      IJOBV = JOBV; IJOBU = JOBU; IJOBQ = JOBQ
      IU1 = MAX(1,M); IU2 = M
      IALPHA = N; IBETA = N; IV1 = MAX(1,P); IV2 = P
      IQ1 = MAX(1,N); IQ2 = N
      
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE (2)
      IB2 = IB2 - 1
      CASE (3)
      IALPHA = IALPHA - 1
      CASE (4)
      IBETA = IBETA- 1
      CASE (7)
      IU1 = IU1 - 1
      IJOBU = 'U'
      CASE (8)
      IV1 = IV1 - 1
      IJOBV = 'V'
      CASE (9)
      IQ1 = IQ1 - 1
      IJOBQ = 'Q'
      CASE(:-1,1,5,6,10:)
      CALL UESTOP(SRNAMT)
      END SELECT
      
      IF (LSAME(IJOBV,'V')) THEN
        IF (LSAME (IJOBU, 'U')) THEN
          IF (LSAME (IJOBQ, 'Q')) THEN
            CALL LA_GGSVD( A(1:IA1,1:IA2), B(1: IB1, 1:IB2), &
     &        ALPHA(1: IALPHA), BETA(1: IBETA), K, L, U(1: IU1, 1: IU2), &
     &        V(1: IV1, 1: IV2), Q(1: IQ1, 1: IQ2), IWORK, INFO)
       ELSE
         CALL LA_GGSVD( A(1:IA1,1:IA2), B(1: IB1, 1:IB2), &
     &     ALPHA(1: IALPHA), BETA(1: IBETA), K, L, U(1: IU1, 1: IU2), &
     &     V(1: IV1, 1: IV2), IWORK=IWORK, INFO=INFO)
       END IF
      ELSE
        IF (LSAME (IJOBQ, 'Q')) THEN
          CALL LA_GGSVD( A(1:IA1,1:IA2), B(1: IB1, 1:IB2), &
     &      ALPHA(1: IALPHA), BETA(1: IBETA), K, L, &
     &      V=V(1: IV1, 1: IV2), Q=Q(1: IQ1, 1: IQ2), IWORK=IWORK, INFO=INFO)
        ELSE
          CALL LA_GGSVD( A(1:IA1,1:IA2), B(1: IB1, 1:IB2), &
     &      ALPHA(1: IALPHA), BETA(1: IBETA), K, L, &
     &      V=V(1: IV1, 1: IV2), IWORK=IWORK, INFO=INFO)
        END IF
      ENDIF
      ELSE
        IF (LSAME (IJOBU, 'U')) THEN
          IF (LSAME (IJOBQ, 'Q')) THEN
            CALL LA_GGSVD( A(1:IA1,1:IA2), B(1: IB1, 1:IB2), &
     &        ALPHA(1: IALPHA), BETA(1: IBETA), K, L, U(1: IU1, 1: IU2), &
     &        Q=Q(1: IQ1, 1: IQ2), IWORK=IWORK, INFO=INFO)
          ELSE
            CALL LA_GGSVD( A(1:IA1,1:IA2), B(1: IB1, 1:IB2), &
     &        ALPHA(1: IALPHA), BETA(1: IBETA), K, L, U(1: IU1, 1: IU2), &
     &        IWORK=IWORK, INFO=INFO)
          END IF
        ELSE
          IF (LSAME (IJOBQ, 'Q')) THEN
            CALL LA_GGSVD( A(1:IA1,1:IA2), B(1: IB1, 1:IB2), &
     &        ALPHA(1: IALPHA), BETA(1: IBETA), K, L, &
     &        Q=Q(1: IQ1, 1: IQ2), IWORK=IWORK, INFO=INFO)
          ELSE
            CALL LA_GGSVD( A(1:IA1,1:IA2), B(1: IB1, 1:IB2), &
     &        ALPHA(1: IALPHA), BETA(1: IBETA), K, L, IWORK=IWORK, &
     &        INFO=INFO)
          END IF
        ENDIF
      ENDIF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_DGGSVD

      

SUBROUTINE ERINFO(LINFO, SRNAME, INFO, ISTAT)
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     October 31, 1996
!
!  .. Scalar Arguments ..
   CHARACTER( LEN = * ), INTENT(IN) :: SRNAME
   INTEGER             , INTENT(IN) :: LINFO
   INTEGER             , INTENT(INOUT), OPTIONAL :: INFO, ISTAT
!  .. Scalars in Common ..
   LOGICAL            LERR, OK
   CHARACTER*6        SRNAMT
   INTEGER            INFOT, NOUT
   INTEGER :: INFOTC
!  .. Common blocks ..
   COMMON             / INFOC / INFOT, NOUT, OK, LERR
   COMMON             / SRNAMC / SRNAMT
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: L1, L2
!  .. Intrinsic Functions
!  INTEGER :: LENTRIM
!  INTRINSIC LENTRIM
!  .. Executable Statements ..
!  L1 = LENTRIM(SRNAME)
!  L2 = LENTRIM(SRNAMT)

   L1 = LEN(SRNAME)
   L2 = L1 - 2
   IF( PRESENT(INFO) ) INFO = LINFO
   INFOTC = LINFO
   IF( LINFO .GE. 0 ) RETURN

!
   LERR = .TRUE.
   IF(- LINFO.NE.INFOT .AND. LINFO.LT.0 ) THEN
      IF( INFOT.NE.0 ) THEN
         WRITE( NOUT, FMT = 9999 )SRNAMT, INFO, INFOT
      ELSE
         WRITE( NOUT, FMT = 9997 )SRNAME, -LINFO
      END IF
      OK = .FALSE.
   END IF
   IF( SRNAME(4:L1).NE.SRNAMT(2:L2) .AND. &
       SRNAME(4:L1) /= 'GETRF' .AND. SRNAMT(2:L2) /= 'GECON' ) THEN
      WRITE( NOUT, FMT = 9998 )SRNAME(4:L1), SRNAMT(2:L2)
      OK = .FALSE.
   END IF
!
 9999 FORMAT( ' +++ ERINFO was called from ', A6, ' with INFO = ', I6, &
              ' instead of ', I2, ' +++' )
 9998 FORMAT( ' +++ ERINFO was called with SRNAME = ', A6, &
              ' instead of ', A6, ' +++' )
 9997 FORMAT( ' +++ On entry to ', A6, ' parameter number ', I6, &
              ' had an illegal value +++' )
!
!  IF( LINFO < 0 .OR. LINFO>0 .AND. .NOT.PRESENT(INFO) )THEN
!  Temporary
   IF( .NOT.PRESENT(INFO) ) THEN
      WRITE (*,*) 'Program terminated in LAPACK_95 subroutine ', SRNAME
      WRITE (*,*) 'Error indicator, INFO = ', LINFO
      STOP
   END IF 
END SUBROUTINE ERINFO

SUBROUTINE LA_TEST_DSTEVR( JOBZ, RANGE, N, D, E, VL, VU, IL, &
     &  IU, ABSTOL, M, W, Z, LDZ, ISUPPZ, WORK, LWORK, IWORK, LIWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     September 11, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => DP
      USE F95_LAPACK, ONLY: LA_STEVR
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, LDZ, IL, IU, LWORK, LIWORK
      REAL(WP), INTENT(IN) ::  ABSTOL, VL, VU
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: JOBZ, RANGE
!  .. Array Arguments ..
      REAL(WP), INTENT(INOUT) :: D(1:N), E(1: N)
      REAL(WP), INTENT(OUT)::  W(1:N), WORK(1:LWORK), Z(1:LDZ,1:MAX(1,N))
      INTEGER, INTENT(OUT) :: IWORK(LIWORK)
      INTEGER, INTENT(OUT) :: ISUPPZ(1: 2*MAX(1,N)), M
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_STEVR'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DSTEVR'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, ID, IE, IISUPPZ, IW, IIL, IIU, IZ1, IZ2
      REAL(WP) :: IVL, IVU
      CHARACTER*1 :: IRANGE
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      LOGICAL LSAME
      EXTERNAL LSAME
!  .. Executable Statements ..
      ID = N; IE = N; IW = N; IISUPPZ = 2* MAX(1,N)
      IRANGE = RANGE
      IVL = VL; IVU = VU; M=0
      IIL = IL; IIU = IU; IZ1 = MAX(1,N); IZ2 = MAX(1,N)	
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE (2)
      IE = IE - 1
      CASE (3)
      IW = IW - 1
      CASE (4)
      IZ2 = IZ2 - 1
      CALL LA_STEVR( D(1: ID), E(1:IE), W(1 :IW), Z(1: IZ1, 1:IZ2), &
     &   M=M, ISUPPZ=ISUPPZ(1: IISUPPZ), ABSTOL=ABSTOL, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (5)
      IISUPPZ = IISUPPZ - 1
      CALL LA_STEVR( D(1: ID), E(1:IE), W(1 :IW), Z(1: IZ1, 1:IZ2), &
&       M=M, ISUPPZ=ISUPPZ(1: IISUPPZ), ABSTOL=ABSTOL, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN     
      CASE (6)
      IRANGE = 'V'
      IVL = IVU+1.0
      CALL LA_STEVR( D(1: ID), E(1:IE), W(1 :IW),&
     &  VL=IVL, VU=IVU, M=M, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (7)
      CALL LA_STEVR( D(1: ID), E(1:IE), W(1 :IW), Z(1: IZ1, 1:IZ2), &
     &  IVL, IVU, IIL, IIU, M, ISUPPZ(1: IISUPPZ), ABSTOL, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (8)
      IRANGE = 'I'
      IIU = IW + 1
      CALL LA_STEVR( D(1: ID), E(1:IE), W(1 :IW), Z(1: IZ1, 1:IZ2), &
     &  IL=IIL, IU=IIU, M=M, ISUPPZ=ISUPPZ(1: IISUPPZ), ABSTOL=ABSTOL, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN 
      CASE(:-1,1,9:)
      CALL UESTOP(SRNAMT)
      END SELECT
      
      IF (LSAME(IRANGE, 'A')) THEN
        IF (LSAME(JOBZ,'V')) THEN
          CALL LA_STEVR( D(1: ID), E(1:IE), W(1 :IW), Z(1: IZ1, 1:IZ2), &
     &        M=M, ISUPPZ=ISUPPZ(1: IISUPPZ), ABSTOL=ABSTOL, INFO=INFO )
        ELSE
          CALL LA_STEVR( D(1: ID), E(1:IE), W(1 :IW), &
     &      M=M, ABSTOL=ABSTOL, INFO=INFO )
        END IF
      ELSE IF (LSAME(IRANGE, 'V')) THEN
        IF (LSAME(JOBZ,'V')) THEN
          CALL LA_STEVR( D(1: ID), E(1:IE), W(1 :IW), Z(1: IZ1, 1:IZ2), &
     &       VL=IVL, VU=IVU, M=M, ISUPPZ=ISUPPZ(1: IISUPPZ), ABSTOL=ABSTOL, INFO=INFO )
        ELSE
          CALL LA_STEVR( D(1: ID), E(1:IE), W(1 :IW), &
     &      VL=IVL, VU=IVU, M=M, ABSTOL=ABSTOL, INFO=INFO )
        END IF
      ELSE
        IF (LSAME(JOBZ, 'V')) THEN
          CALL LA_STEVR( D(1: ID), E(1:IE), W(1 :IW), Z(1: IZ1, 1:IZ2), &
     &       IL=IIL, IU=IIU, M=M, ISUPPZ=ISUPPZ(1: IISUPPZ), ABSTOL=ABSTOL, INFO=INFO )
        ELSE
          CALL LA_STEVR( D(1: ID), E(1:IE), W(1 :IW), &
     &      IL=IIL, IU=IIU, M=M, ABSTOL=ABSTOL, INFO=INFO )
        END IF
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      END SUBROUTINE LA_TEST_DSTEVR

      PROGRAM LA_SSPSV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements"
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SPSV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, N, NN, NRHS
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE :: IPIV(:)
      REAL(WP), ALLOCATABLE :: B(:,:), AP(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SSPSV Example Program Results.'
      N = 5; NRHS = 3
      WRITE(*,'(5H N = , I4, 9H; NRHS = , I4)') N, NRHS
      NN = N*(N+1)/2
      ALLOCATE ( AP(NN), B(N,NRHS), IPIV(N) )
   
      OPEN(UNIT=21,FILE='spsv.ma',STATUS='UNKNOWN')
      DO I=1,NN 
            READ(21,'(F3.0)') AP(I)
         ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix AP :'
      DO I=1,NN; WRITE(*,"(15(I3,1X,1X),I3,1X))") INT(AP(I));
      ENDDO
   
      OPEN(UNIT=21,FILE='spsv.mb',STATUS='UNKNOWN')
      DO I=1,N 
         READ(21,'(F3.0)') B(I,1)
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix B :'
      DO I=1,N; WRITE(*,"(10(I3,1X,1X),I3,1X)')") INT(B(I,1));
      ENDDO

      WRITE(*,*)" CALL LA_SPSV( AP, B, 'L', IPIV )"

      CALL LA_SPSV( AP, B, 'L', IPIV )

      WRITE(*,*)'AP on exit: '
      DO I=1,NN; WRITE(*,"(15(E13.5))") AP(I); 
      ENDDO
      
      WRITE(*,*)'Matrix B on exit :'
      DO I=1,N; WRITE(*,"(F9.5)") B(I,1);
      ENDDO
      WRITE(*,*)'IPIV = ', IPIV
          
      END PROGRAM LA_SSPSV_EXAMPLE

SUBROUTINE LA_TEST_DGELSS( M, N, NRHS, A, LDA, B, LDB, S, RCOND, RANK, WORK, LWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     April 19, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GELSS
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: M, N, NRHS, LDA, LDB
   INTEGER, INTENT(INOUT) :: INFO
   INTEGER, INTENT(IN) :: RANK
   INTEGER, INTENT(IN) :: LWORK
   REAL(WP), INTENT(IN) :: RCOND
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB,1:NRHS)
   REAL(WP), INTENT(OUT) :: WORK(LWORK)
   REAL(WP), INTENT(OUT) :: S(1:MIN(M,N))
      
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GELSS'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DGELSS'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IS
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = M; IA2 = N; IB1 = MAX(1,M,N); IB2 = NRHS; IS = MIN(M,N)
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
      IF (NRHS==1) THEN
        CALL LA_GELSS( A(1:IA1,1:IA2), B(1:IB1,1), RANK,  &
     &                      S(1:IS), RCOND, INFO )
        INFO = INFOTC
      ELSE
        CALL LA_GELSS( A(1:IA1,1:IA2), B(1:IB1,1:IB2), RANK, & 
     &                     S(1:IS), RCOND, INFO )
        INFO = INFOTC
      ENDIF 
   CASE (2)
      IB1 = MAX(1, N, M) - 1
   CASE(4)
      IS = MIN (M, N) - 1
   CASE(:-1,1,3, 5:)
      CALL UESTOP(SRNAMT)
   END SELECT
      IF( I /= 0) THEN
      SELECT CASE (NRHS)
      CASE (2:)
         CALL LA_GELSS( A(1:IA1,1:IA2), B(1:IB1,1:IB2), RANK,&
     &     S(1:IS), RCOND, INFO )
      CASE(1)
         CALL LA_GELSS( A(1:IA1,1:IA2), B(1:IB1,1), RANK, &
     &     S(1:IS), RCOND, INFO)
      CASE(:-1)
         CALL UESTOP(SRNAMT)
      END SELECT
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_DGELSS

SUBROUTINE ZGESDD_F95( A, S, U, VT, WW, JOB, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: GESDD_F77 => LA_GESDD
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), OPTIONAL, INTENT(IN) :: JOB
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(INOUT) :: A(:,:)
   REAL(WP), INTENT(OUT) :: S(:)
   REAL(WP), INTENT(OUT), OPTIONAL :: WW(:)
   COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: U(:,:), VT(:,:)
!----------------------------------------------------------------------
! 
!  Purpose
!  =======
!  
!       LA_GESVD and LA_GESDD compute the singular values and, 
! optionally, the left and/or right singular vectors from the singular
! value decomposition  (SVD) of a real or complex m by n matrix A. The
! SVD of A is written
!                    A = U * SIGMA * V^H
! where SIGMA is an  m by n matrix which is zero except for its 
! min(m, n) diagonal elements, U is an m by m orthogonal (unitary) 
! matrix, and V is an n by n orthogonal (unitary) matrix. The diagonal
! elements of SIGMA , i.e., the values 
! 
!      sigma(i)= SIGMA(i,i), i = 1, 2,..., min(m, n)
! are the singular values of A; they are real and non-negative, and are
! returned in descending order. The first min(m, n) columns of U and V 
! are the left and right singular vectors of A, respectively.
! LA_GESDD solves the same problem as LA_GESVD but uses a divide and 
! conquer method if singular vectors are desired. For large matrices it
! is usually much faster than LA_GESVD when singular vectors are 
! desired, but uses more workspace.
! 
! Note: The routine returns V^H , not V .
! 
! ========
! 
!    SUBROUTINE LA_GESVD / LA_GESDD( A, S, U=u, VT=vt, &
!              WW=ww, JOB=job, INFO=info )  
!      <type>(<wp>), INTENT(INOUT) :: A(:,:)
!      REAL(<wp>), INTENT(OUT) :: S(:)
!      <type>(<wp>), INTENT(OUT), OPTIONAL :: U(:,:), VT(:,:)
!      REAL(<wp>), INTENT(OUT), OPTIONAL :: WW(:)
!      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: JOB
!      INTEGER, INTENT(OUT), OPTIONAL :: INFO
!      where
!      <type> ::= REAL | COMPLEX
!      <wp>   ::= KIND(1.0) | KIND(1.0D0)
!  
! Arguments
! =========
! 
! A      (input/output) REAL or COMPLEX array, shape (:, :) with 
!        size(A, 1) = m and size(A, 2) = n.
!        On entry, the matrix A.
!        On exit, if JOB = 'U' and U is not present, then A is 
!        overwritten with the first min(m, n) columns of U (the left
!        singular vectors, stored columnwise).
!        If JOB = 'V' and VT is not present, then A is overwritten with
!        the first min(m, n) rows of V^H (the right singular vectors, 
!        stored rowwise).
!        In all cases the original contents of A are destroyed.
! S      (output) REAL array, shape (:) with size(S) = min(m, n).
!        The singular values of A, sorted so that S(i) >= S(i+1).
! U      Optional (output) REAL or COMPLEX array, shape (:, :) with 
!        size(U, 1) = m  and size(U, 2) = m or min(m, n).
!        If size(U, 2) = m, U contains the m by m matrix U .
!        If size(U; 2) = min(m, n), U contains the first min(m, n) 
!        columns of U (the left singular vectors, stored columnwise).
! VT     Optional (output) REAL or COMPLEX array, shape (:, :) with 
!        size(VT, 1) = n or min(m, n) and size(VT, 2) = n.
!        If size(VT, 1) = n , VT contains the n by n matrix V^H .
!        If size(VT, 1) = min(m, n), VT contains the first min(m, n)
!        rows of V^H (the right singular vectors, stored rowwise).
! WW     Optional (output) REAL array, shape (:) with size(WW) = 
!        min(m, n) - 1
!        If INFO > 0, WW contains the unconverged superdiagonal elements
!        of an upper bidiagonal matrix B whose diagonal is in SIGMA (not
!        necessarily sorted). B has the same singular values as A.
!        Note: WW is a dummy argument for LA_GESDD.
! JOB    Optional (input) CHARACTER(LEN=1).
!        = 'N': neither columns of U nor rows of V^H are returned in 
!          array A.
!        = 'U': if U is not present, the first min(m, n) columns of U 
!          (the left singular vectors) are returned in array A;
!        = 'V': if VT is not present, the first min(m, n) rows of V^H 
!          (the right singular vectors) are returned in array A;
!        Default value: 'N'.
! INFO   Optional (output) INTEGER.
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value.
!        > 0: The algorithm did not converge.
!        If INFO is not present and an error occurs, then the program is
!        terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GESDD'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBZ, JOBZ
   INTEGER, SAVE :: LWORK = 0
   INTEGER :: N, M, LINFO, LD, ISTAT, S1U, S2U, S1VT, S2VT, &
&             MN, LRWORK
!  .. LOCAL ARRAYS ..
   COMPLEX(WP), TARGET :: LLU(1,1), LLVT(1,1)
   COMPLEX(WP), POINTER :: WORK(:)
   COMPLEX(WP), ALLOCATABLE :: W1(:,:), W2(:,:)
   REAL(WP), POINTER :: RWORK(:)
   INTEGER, POINTER :: IWORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MIN, MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2)
   LD = MAX(1,M); MN = MIN(M,N)

   IF( PRESENT(JOB) )THEN; LJOBZ = JOB; ELSE; LJOBZ = 'N'; ENDIF
   IF( PRESENT(U) )THEN; S1U = SIZE(U,1); S2U = SIZE(U,2)
   ELSE; S1U = 1; S2U = 1; END IF
   IF( PRESENT(VT) )THEN; S1VT = SIZE(VT,1); S2VT = SIZE(VT,2)
   ELSE; S1VT = 1; S2VT = 1; END IF
!  .. TEST THE ARGUMENTS
   IF( M < 0 .OR. N < 0 )THEN; LINFO = -1
   ELSE IF( SIZE( S ) /= MN )THEN; LINFO = -2
   ELSE IF( PRESENT(U) .AND. ( S1U /= M .OR. &
            ( S2U /= M .AND. S2U /= MN ) ) )THEN; LINFO = -3
   ELSE IF( PRESENT(VT) .AND. ( ( S1VT /= N .AND. S1VT /= MN ) &
            .OR. S2VT /= N ) )THEN; LINFO = -4
   ELSE IF(.NOT. (LSAME(LJOBZ, 'N') .OR. LSAME(LJOBZ,'U') .OR. LSAME(LJOBZ, 'V'))) THEN ; LINFO = -6
   ELSE
        LWORK = MAX(1, 2*MN*MN+2*MN+MAX(M,N))
        LWORK = 5*LWORK
        
        ALLOCATE(WORK(LWORK), STAT=ISTAT)
        IF( ISTAT == 0 ) THEN
          ALLOCATE(IWORK(5*(8*MIN(M,N))), STAT=ISTAT)
          IF (ISTAT == 0 ) THEN
         LRWORK = (5*MIN(M,N)*MIN(M,N) + 7*MIN(M,N))
! NEXT LINE SHOULD BE REMOVED WHEN LAPACK IS FIXED
         LRWORK = 5*LRWORK
         ALLOCATE(RWORK(LRWORK), STAT = ISTAT)
         IF( ISTAT == 0 ) THEN
           IF (.NOT.PRESENT(U) .AND. .NOT. PRESENT(VT)) THEN
             ALLOCATE(W1(M,M), W2(N,N), STAT=ISTAT)
             IF (ISTAT == 0) THEN
               IF (.NOT. LSAME(LJOBZ, 'N')) THEN
                 JOBZ = 'S'
               ELSE
                 JOBZ = 'N'
               ENDIF
               CALL GESDD_F77(JOBZ, M, N, A, LD, S, W1, MAX(1,M), &
&                W2, MAX(1,N), WORK, LWORK, RWORK, IWORK, LINFO )
               SELECT CASE(LJOBZ)
                 CASE ('U')
                   A(1:MN, 1:MN) = W1(1:MN, 1:MN)
                 CASE ('V')
                   A(1:MN, 1:MN) = W2(1:MN, 1:MN)
               END SELECT
               DEALLOCATE(W1, W2)
             ELSE
               LINFO = -100
             END IF
           ELSE IF (.NOT. PRESENT(U) .AND. PRESENT(VT)) THEN
             JOBZ = 'A'
             ALLOCATE(W1(M,M), STAT=ISTAT)
             IF (ISTAT == 0) THEN
	      IF (PRESENT (VT)) THEN
               CALL GESDD_F77(JOBZ, M, N, A, LD, S, W1, MAX(1,M), &
&                VT, MAX(1, S1VT), WORK, LWORK, RWORK, IWORK, LINFO )
              ELSE
	       CALL GESDD_F77(JOBZ, M, N, A, LD, S, W1, MAX(1,M), &
&                LLVT, MAX(1, S1VT), WORK, LWORK, RWORK, IWORK, LINFO )
             ENDIF
               IF (LSAME(LJOBZ, 'U')) THEN
                 A(1:M, 1:MN) = W1(1:M, 1:MN)
               END IF
               DEALLOCATE(W1)
             ELSE
               LINFO = -100
             END IF
           ELSE IF (PRESENT(U) .AND. .NOT. PRESENT(VT)) THEN
             JOBZ = 'A'
             ALLOCATE(W2(N,N), STAT=ISTAT)
             IF (ISTAT == 0) THEN
	      IF (PRESENT (U)) THEN
               CALL GESDD_F77(JOBZ, M, N, A, LD, S, U, MAX(1,S1U), &
&                W2, MAX(1,N), WORK, LWORK, RWORK, IWORK, LINFO )
              ELSE
               CALL GESDD_F77(JOBZ, M, N, A, LD, S, LLU, MAX(1,S1U), &
&                W2, MAX(1,N), WORK, LWORK, RWORK, IWORK, LINFO )
              ENDIF 
               IF (LSAME(LJOBZ, 'V')) A(1:MN, 1:N) = W2(1:MN, 1:N)
               DEALLOCATE(W2)
             ELSE
               LINFO = -100
             END IF
           ELSE
             JOBZ = 'A'
	     IF (PRESENT (VT)) THEN
	       IF (PRESENT (U)) THEN
                  CALL GESDD_F77(JOBZ, M, N, A, LD, S, U, MAX(1,S1U), &
&                    VT, MAX(1,S1VT), WORK, LWORK, RWORK, IWORK, LINFO )
               ELSE
	          CALL GESDD_F77(JOBZ, M, N, A, LD, S, LLU, MAX(1,S1U), &
&                    VT, MAX(1,S1VT), WORK, LWORK, RWORK, IWORK, LINFO )
               ENDIF
	     ELSE
	       IF (PRESENT (U)) THEN
                  CALL GESDD_F77(JOBZ, M, N, A, LD, S, U, MAX(1,S1U), &
&                    LLVT, MAX(1,S1VT), WORK, LWORK, RWORK, IWORK, LINFO )
               ELSE
	          CALL GESDD_F77(JOBZ, M, N, A, LD, S, LLU, MAX(1,S1U), &
&                    LLVT, MAX(1,S1VT), WORK, LWORK, RWORK, IWORK, LINFO )
               ENDIF
	     ENDIF  
             IF (PRESENT(WW)) WW = WORK(1)
           ENDIF
           DEALLOCATE(RWORK, STAT=ISTAT)
         ELSE
           LINFO = -100
         END IF
         DEALLOCATE(IWORK, STAT=ISTAT)
       ELSE
         LINFO = -100
       END IF
       DEALLOCATE(WORK, STAT=ISTAT)
     ENDIF
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
    END SUBROUTINE ZGESDD_F95

      PROGRAM LA_SGGGLM_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GGGLM
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" .
      INTEGER :: I, J, INFO, M, N, P
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), D(:), X(:), Y(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GGGLM Example Program Results'
      M=5; N = 4; P = 2
      ALLOCATE( A(M,N), B(M,P), D(M), X(N), Y(P) )

      OPEN(UNIT=21,FILE='ggglm.ma',STATUS='UNKNOWN')
      DO I=1,M 
         DO J=1,N
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)
    
      OPEN(UNIT=22,FILE='ggglm.mb',STATUS='UNKNOWN')
      DO I=1,M 
         DO J=1,P
            READ(22,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(22)

      OPEN(UNIT=24,FILE='ggglm.d',STATUS='UNKNOWN')
      DO I=1,M 
         READ(24,*) D(I)
      ENDDO
      CLOSE(24)
     
      WRITE(*,*)'Matrix A :'
      DO I=1,M;
         WRITE(*,"(4(F9.5))") A(I,:);
      ENDDO   
      WRITE(*,*)'Matrix B :'
      DO I=1,M; 
         WRITE(*,"(2(F9.5))") B(I,:); 
      ENDDO
      WRITE(*,*)'Vector D :'
      DO I=1,M; 
         WRITE(*,"(F9.5))") D(I); 
      ENDDO
    
      WRITE(*,*) 'CALL LA_GGGLM( A, B, D, X, Y, INFO )'
      CALL LA_GGGLM( A, B, D, X, Y, INFO )
      WRITE(*,*) 'X on exit:'
      DO I=1,N; WRITE(*,"(E14.6)") X(I); ENDDO
   
      WRITE(*,*) 'Y on exit:'
      DO I=1,P; WRITE(*,"(E14.6)") Y(I); ENDDO
    
      WRITE(*,*)'INFO = ',INFO
      
      END PROGRAM LA_SGGGLM_EXAMPLE

SUBROUTINE LA_TEST_SSTEVX( JOBZ, RANGE, N, D, E, VL, VU, IL, IU, &
     &  ABSTOL, M, W, Z, LDZ, WORK, IWORK, IFAIL, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     November 2, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_STEVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, LDZ, IL, IU
      INTEGER, INTENT(OUT) ::  M
      INTEGER, INTENT(INOUT) :: INFO
      REAL(WP), INTENT(IN) :: VL, VU, ABSTOL
      CHARACTER*1, INTENT(IN) :: JOBZ, RANGE
!  .. Array Arguments ..
      REAL(WP), INTENT(INOUT) :: D(1:N), E(1:N)
      REAL(WP), INTENT(OUT)::  W(1:N), Z(1:LDZ, 1:N), WORK(1: 5*N)
      INTEGER, INTENT(OUT):: IWORK(1: 5*N), IFAIL(1:N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_STEVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SSTEVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IE, IZ1, IZ2, ID, IW, IIL, IIU, IIFAIL
      REAL(WP) :: IVL, IVU, IABSTOL
      CHARACTER*1 :: IJOBZ, IRANGE
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      LOGICAL LSAME
!  .. Executable Statements ..
      IJOBZ = JOBZ; ID = N; IE = N; IZ1 = MAX (1,N); IZ2 = N
      IW=N; IVL=VL; IVU=VU; IIL=IL; IIU=IU; IIFAIL=N; M=0
      IABSTOL=ABSTOL; IRANGE=RANGE
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE (2)
        IE = IE - 1
      CASE (3)
        IW=ID-1
      CASE (4)
        IZ1 = IZ1 - 1; IJOBZ='V'; IRANGE='V'
      CASE (5)
        IVL = IVU+1; IJOBZ='V'; IRANGE='V'
      CASE (6)
        IJOBZ='V'; IRANGE='V'
        CALL LA_STEVX( D(1:ID), E(1:IE), W(1:IW), Z(1:IZ1, 1:IZ2), &
&         IVL, IVU, IIL, IIU, M, IFAIL(1:IIFAIL), IABSTOL, INFO)
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
        RETURN
      CASE (7)
        IIL = IIU+1; IJOBZ='V'; IRANGE='I'
      CASE (8)
        IIU = ID+1;  IJOBZ='V'; IRANGE='I'; IIL = IIU 
      CASE (10)
        IJOBZ='V'; IRANGE='V'
        CALL LA_STEVX( D(1:ID), E(1:IE), W(1:IW), VL=IVL, VU=IVU, &
&         M=M, IFAIL=IFAIL(1:IIFAIL), ABSTOL=IABSTOL, INFO=INFO)
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
        RETURN   
      CASE(:-1, 1, 9, 11:)
        CALL UESTOP(SRNAMT)
    END SELECT

      IF (LSAME(IJOBZ,'V')) THEN
        IF (LSAME (IRANGE, 'V')) THEN
          CALL LA_STEVX( D(1:ID), E(1:IE), W(1:IW), Z(1:IZ1, 1:IZ2), &
     &      IVL, IVU, M=M, IFAIL=IFAIL(1:IIFAIL), ABSTOL=IABSTOL, INFO=INFO)
        ELSE IF (LSAME (IRANGE, 'I')) THEN
          CALL LA_STEVX( D(1:ID), E(1:IE), W(1:IW), Z(1:IZ1, 1:IZ2), &
     &      IL=IIL, IU=IIU, M=M, IFAIL=IFAIL(1:IIFAIL), ABSTOL=IABSTOL,&
     &      INFO=INFO)
        ELSE
          CALL LA_STEVX( D(1:ID), E(1:IE), W(1:IW), Z(1:IZ1, 1:IZ2), &
     &      M=M, IFAIL=IFAIL(1:IIFAIL), ABSTOL=IABSTOL, INFO=INFO)
        ENDIF
      ELSE
        IF (LSAME (IRANGE, 'V')) THEN
          CALL LA_STEVX( D(1:ID), E(1:IE), W(1 :IW), VL=IVL, VU=IVU, &
     &      M=M, ABSTOL=IABSTOL, INFO=INFO)
        ELSE IF (LSAME (IRANGE, 'I')) THEN
          CALL LA_STEVX( D(1:ID), E(1:IE), W(1 :IW), IL=IIL, IU=IIU, &
     &      M=M, ABSTOL=IABSTOL, INFO=INFO)
        ELSE
          CALL LA_STEVX( D(1:ID), E(1:IE), W(1 :IW),M=M,ABSTOL=IABSTOL,&
     &      INFO=INFO)
        ENDIF
      END IF
      
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_SSTEVX

SUBROUTINE LA_TEST_CHESV( UPLO, N, NRHS, A, LDA, IPIV, B, LDB, WORK, LWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark; 
!     April 11, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_HESV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, NRHS, LDA, LDB, LWORK
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: UPLO
!  .. Array Arguments ..
   INTEGER, INTENT(OUT) :: IPIV(1:N)
   COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB,1:NRHS)
   COMPLEX(WP), INTENT(OUT) ::  WORK(1:LWORK)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_HESV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_CHESV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IIPIV, ISTAT
   CHARACTER*1 :: IUPLO
!  .. Local Arrays ..
   INTEGER, SAVE, POINTER :: IWORK(:)
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IB1 = N; IB2 = NRHS; IIPIV = N; IUPLO = UPLO
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
      IF ( NRHS == 1 ) THEN
        CALL LA_HESV( A(1:IA1,1:IA2), B(1:IB1,1), IUPLO, &
     &    IPIV(1:IIPIV) )
        INFO = INFOTC
      ELSE
        CALL LA_HESV( A(1:IA1,1:IA2), B(1:IB1,1:IB2), IUPLO, &
     &    IPIV(1:IIPIV) )
        INFO = INFOTC
      END IF
   CASE (1)
      IA2 = IA1-1
   CASE (2)
      IB1 = IA1-1
   CASE(3)
      IUPLO = 'T'   
   CASE(4)
      IIPIV = IA1-1
   CASE(:-1,5:)
      CALL UESTOP(SRNAMT)
   END SELECT
   IF( I /= 0  ) THEN
      SELECT CASE (NRHS)
      CASE (2:)
        CALL LA_HESV( A(1:IA1,1:IA2), B(1:IB1,1:IB2), IUPLO, &
     &                     IPIV(1:IIPIV), INFO )
      CASE(1)
      CALL LA_HESV( A(1:IA1,1:IA2), B(1:IB1,1), IUPLO, &
     &                               IPIV(1:IIPIV), INFO )
      CASE(:-1)
         CALL UESTOP(SRNAMT)
      END SELECT
   END IF
   IF( I == 0 .AND. J == 1 )THEN
      ALLOCATE( IWORK(N), STAT=ISTAT )
      IF(ISTAT == 0 )THEN
         IWORK(1:N) = IPIV(1:N)
      ELSE
         WRITE(*,*)'STOP in ', SRNAMT, 'Memory allocation failed.'
      END IF
   ELSE IF( I == 0 .AND. J == 4 )THEN
      DEALLOCATE( IWORK, STAT=ISTAT )
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_CHESV

SUBROUTINE CGBSVX1_F95(A, B, X, KL, AF, IPIV, FACT, TRANS, &
                      EQUED, R, C, FERR, BERR, RCOND, RPVGRW, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: GBSVX_F77 => LA_GBSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
   CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
   INTEGER, INTENT(IN), OPTIONAL :: KL
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW, FERR, BERR
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
   COMPLEX(WP), INTENT(OUT) :: X(:)
   INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: IPIV(:)
   COMPLEX(WP), INTENT(INOUT), OPTIONAL, TARGET :: AF(:,:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: C(:), R(:)
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GBSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LTRANS, LEQUED
   INTEGER :: LINFO, N, ISTAT, ISTAT1, SIPIV, S1AF, S2AF, &
              SC, SR, LD, LKL, LKU, LDA
   REAL(WP) :: LRCOND, MVR, MVC, LFERR, LBERR
!  .. LOCAL POINTERS ..
   INTEGER, POINTER :: LPIV(:)
   REAL(WP),  POINTER :: RWORK(:), LC(:), LR(:)
   COMPLEX(WP),  POINTER :: WORK(:), LAF(:, :)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE, MINVAL, TINY
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0
   LDA = SIZE(A,1); N = SIZE(A, 2); LD = MAX(1,N)
   IF( PRESENT(KL) ) THEN; LKL = KL; ELSE; LKL = (LDA-1)/2; ENDIF
   LKU = LDA -LKL -1
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(RPVGRW) ) RPVGRW = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(EQUED) .AND. LSAME(LFACT,'F') )THEN; LEQUED = EQUED
   ELSE; LEQUED='N'; END IF
   IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; END IF
   IF( PRESENT(AF) )THEN; S1AF = SIZE(AF,1); S2AF = SIZE(AF,2)
   ELSE; S1AF = 2*LKL+LKU+1; S2AF = N; END IF
   IF( ( PRESENT(C) ) )THEN; SC = SIZE(C); ELSE; SC = N; END IF
   IF( ( PRESENT(C) .AND. LSAME(LFACT,'F') ) .AND. &
       ( LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') ) )THEN; MVC = MINVAL(C)
   ELSE; MVC = TINY(1.0_WP); END IF
   IF( PRESENT(R) )THEN; SR = SIZE(R); ELSE; SR = N; END IF
   IF( ( PRESENT(R) .AND. LSAME(LFACT,'F') ) .AND. &
       ( LSAME(LEQUED,'R') .OR. LSAME(LEQUED,'B') ) )THEN; MVR = MINVAL(R)
   ELSE; MVR = TINY(1.0_WP); END IF
   IF(PRESENT(TRANS))THEN; LTRANS = TRANS; ELSE; LTRANS='N'; END IF
!  .. TEST THE ARGUMENTS
   IF( LDA - LKL -LKU -1 < 0 .OR. LDA < 0 .OR. N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE(B) /= N )THEN; LINFO = -2
   ELSE IF( SIZE(X) /= N )THEN; LINFO = -3
   ELSE IF( LKL < 0 .OR. LKU < 0 ) THEN; LINFO = -4
   ELSE IF( S1AF /= 2*LKL+LKU+1 .OR. S2AF /= N ) THEN; LINFO = -5
   ELSE IF( SIPIV /= N )THEN; LINFO = -6
   ELSE IF( SR /= N .OR. MVR <= 0.0_WP )THEN; LINFO = -10
   ELSE IF( SC /= N .OR. MVC <= 0.0_WP )THEN; LINFO = -11
   ELSE IF( ( .NOT. ( LSAME(LFACT,'F') .OR. LSAME(LFACT,'N') .OR. &
                    LSAME(LFACT,'E') ) ) .OR. &
       ( LSAME(LFACT,'F') .AND. .NOT.( PRESENT(AF) .AND. PRESENT(IPIV) ) ) )THEN
      LINFO = -7
   ELSE IF( .NOT.( LSAME(LTRANS,'N') .OR.  LSAME(LTRANS,'T') .OR. &
                  LSAME(LTRANS,'C') ) )THEN; LINFO = -8
   ELSE IF( ( .NOT.( LSAME(LEQUED,'N') .OR. LSAME(LEQUED,'R') .OR. &
          LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') ) &
              .AND. LSAME(LFACT,'F') ) .OR. &
         ( ( LSAME(LEQUED,'R') .OR. LSAME(LEQUED,'B') ) .AND. &
              .NOT.PRESENT(R) ) .OR. &
         ( ( LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') ) .AND. &
              .NOT.PRESENT(C) ) )THEN; LINFO = -9
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(AF) ) THEN; ALLOCATE( LAF(S1AF,N), STAT=ISTAT )
      ELSE; LAF => AF; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(IPIV) )THEN; ALLOCATE( LPIV(N), STAT=ISTAT )
         ELSE; LPIV => IPIV; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(R) )THEN; ALLOCATE( LR(N), STAT=ISTAT )
         ELSE; LR => R; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(C) )THEN; ALLOCATE( LC(N), STAT=ISTAT )
         ELSE; LC => C; END IF
      END IF
      IF( ISTAT == 0 ) ALLOCATE(WORK(2*N), RWORK(N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
         CALL GBSVX_F77( LFACT, LTRANS, N, LKL, LKU, 1, A, LDA, LAF, S1AF, &
                         LPIV, LEQUED, LR, LC, B, LD, X, LD, LRCOND, &
                         LFERR, LBERR, WORK, RWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(R) ) DEALLOCATE( LR, STAT=ISTAT1 )
      IF( .NOT.PRESENT(C) ) DEALLOCATE( LC, STAT=ISTAT1 )
      IF( .NOT.PRESENT(AF) ) DEALLOCATE( LAF, STAT=ISTAT1 )
      IF( .NOT.PRESENT(IPIV) ) DEALLOCATE( LPIV, STAT=ISTAT1 )
      IF( PRESENT(FERR) ) FERR = LFERR
      IF( PRESENT(BERR) ) BERR = LBERR
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      IF( PRESENT(EQUED) .AND. .NOT.LSAME(LFACT,'F') ) EQUED=LEQUED
      IF( PRESENT(RPVGRW) ) RPVGRW=RWORK(1)
      DEALLOCATE( WORK, RWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE CGBSVX1_F95

 SUBROUTINE ZPBSV1_F95( A, B, UPLO, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO, LSAME
    USE F77_LAPACK, ONLY: PBSV_F77 => LA_PBSV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_PBSV'
!   .. LOCAL SCALARS ..
    CHARACTER(LEN=1) :: LUPLO
    INTEGER :: LINFO, KD, N
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; KD = SIZE(A,1)-1; N = SIZE(A,2)
    IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; ENDIF
!   .. TEST THE ARGUMENTS
    IF( KD < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B ) /= N ) THEN; LINFO = -2
    ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
    ELSE IF ( N > 0 ) THEN
       CALL PBSV_F77( LUPLO, N, KD, 1, A, KD+1, B, N, LINFO )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO )
 END SUBROUTINE ZPBSV1_F95

      SUBROUTINE SGGEV_F95( A, B, ALPHAR, ALPHAI, BETA, VL, VR, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => SP
      USE LA_AUXMOD, ONLY: ERINFO
      USE F77_LAPACK, ONLY: GGEV_F77 => LA_GGEV
!  .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
       REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
      REAL(WP), INTENT(OUT) :: ALPHAR(:), ALPHAI(:), BETA(:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
! LA_GGEV computes for a pair of n by n real or complex matrices (A,B) 
! the generalized eigenvalues in the form of scalar pairs (alpha, beta)
! and, optionally, the left and/or right generalized eigenvectors.
!       A generalized eigenvalue of the pair (A,B) is, roughly 
! speaking, a scalar of the form  lambda=alpha/beta such that the matrix
! A-lambda*B is singular. It is usually represented as the pair
! (alpha; beta), as there is a reasonable interpretation of the case 
! beta = 0 (even if alpha = 0).
!       A right generalized eigenvector corresponding to a generalized 
! eigenvalue lambda is a vector v such that (A-lambda*B)*v=0. A left 
! generalized eigenvector is a vector u such that u^H*(A-lambda*B)=0,
! where u^H is the conjugate-transpose of u.
!       The computation is based on the (generalized) real or complex 
! Schur form of (A,B). (See LA_GGES for details of this form.)
! 
! =========
! 
!     SUBROUTINE LA_GGEV( A, B, <alpha>, BETA, VL=vl, &
!                 VR=vr, INFO=info )
!         <type>(<wp>), INTENT(INOUT) :: A(:,:), B(:,:)
! 	  <type>(<wp>), INTENT(OUT) :: <alpha(:)>, BETA(:)
! 	  <type>(<wp>), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
! 	  INTEGER, INTENT(OUT), OPTIONAL :: INFO
!     where
! 	  <type>     ::= REAL | COMPLEX
! 	  <wp>       ::= KIND(1.0) | KIND(1.0D0)
! 	  <alpha>    ::= ALPHAR, ALPHAI | ALPHA
! 	  <alpha(:)> ::= ALPHAR(:), ALPHAI(:) | ALPHA(:)
! 
! Arguments
! =========
! 
! A       (input/output) REAL or COMPLEX square array, shape (:,:).
!         On entry, the matrix A.
! 	  On exit, A has been destroyed.
! B       (input/output) REAL or COMPLEX square array, shape (:,:) with 
!         size(B,1) = size(A,1).
!   	  On entry, the matrix B.
! 	  On exit, B has been destroyed.
! <alpha> (output) REAL or COMPLEX array, shape (:) with size(alpha) = 
!         size(A,1).
! 	  The values of alpha.
!         alpha(:) ::= ALPHAR(:), ALPHAI(:) | ALPHA(:),
! 	  where
! 	  ALPHAR(:), ALPHAI(:) are of REAL type (for the real and 
! 	  imaginary parts) and ALPHA(:) is of COMPLEX type.
! BETA    (output) REAL or COMPLEX array, shape (:) with size(BETA) =
!         size(A,1).
! 	  The values of beta.
! 	  Note: The generalized eigenvalues of the pair (A,B) are the 
! 	  scalars lambda(j)=alpha(j)/beta(j). These quotients may easily
! 	  over- or underflow, and beta(j) may even be zero. Thus, the 
! 	  user should avoid computing them naively.
!         Note: If A and B are real then complex eigenvalues occur in 
! 	  complex conjugate pairs. Each pair is stored consecutively. 
! 	  Thus a complex conjugate pair is given by
!             lambda(j) = (ALPHAR(j) + i*ALPHAI(j))/BETA(j)
!    	      lambda(j+1) = (ALPHAR(j+1) + i*ALPHAI(j+1))/BETA(j+1)
!   	  where
!     	      ALPHAI(j)/BETA(j) = -(ALPHAI(j+1)/BETA(j+1))
! VL      Optional (output) REAL or COMPLEX square array, shape (:,:) 
!         with size(VL,1) = size(A,1).
! 	  The left generalized eigenvectors u(j) are stored in the 
! 	  columns of VL in the order of their eigenvalues. Each 
! 	  eigenvector is scaled so the largest component has 
! 	      |realpart| + |imag.part| = 1,
! 	  except that for eigenvalues with alpha = beta = 0, a zero 
!     	  vector is returned as the corresponding eigenvector.
! 	  Note: If A and B are real then complex eigenvectors, like 
! 	  their eigenvalues, occur in complex conjugate pairs. The real
! 	  and imaginary parts of the first eigenvector of the pair are 
! 	  stored in VL(:,j) and VL(:,j+1) . Thus a complex conjugate 
! 	  pair is given by
! 	  u(j) = VL(:,j) + i*VL(:,j+1), u(j+1) = VL(:,j) - i*VL(:,j+1)
! VR      Optional (output) REAL or COMPLEX square array, shape (:,:) 
!         with size(VR,1) = size(A,1).
! 	  The right generalized eigenvectors v(j) are stored in the 
! 	  columns of VR in the order of their eigenvalues. Each 
! 	  eigenvector is scaled so the largest component has 
! 	      |realpart| + |imag:part| = 1,
! 	  except that for eigenvalues with alpha = beta = 0, a zero 
!  	  vector is returned as the corresponding eigenvector.
! 	  Note: If A and B are real then complex eigenvectors, like 
! 	  their eigenvalues, occur in complex conjugate pairs. The real
! 	  and imaginary parts of the first eigenvector of the pair are
! 	  stored in VR(:,j) and VR(:,j+1) . Thus a complex conjugate 
!    	  pair is given by
! 	  v(j) = VR(:,j) + i*VR(:,j+1), v(j+1) = VR(:,j) - i*VR(:,j+1)
! INFO    Optional (output) INTEGER.
!         = 0: successful exit.
! 	  < 0: if INFO = -i, the i-th argument had an illegal value.
! 	  > 0: if INFO = i, and i is
! 	     <= n: The QZ iteration failed. No eigenvectors have been
! 	           calculated, but (alpha(j), BETA(j)) should be 
! 		   correct for j = INFO+1, ..., n.
! 	     = n+1: another part of the algorithm failed.
! 	     = n+2: a failure occurred during the computation of the
! 	           generalized eigenvectors.
! 	   If INFO is not present and an error occurs, then the program
! 	   is terminated with an error message.
!-----------------------------------------------------------------------
 
!  .. LOCAL PARAMETERS ..
      CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GGEV'
!  .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: LJOBVL, LJOBVR
      INTEGER, SAVE :: LWORK = 0
      INTEGER :: N, LINFO, LD, ISTAT, S1VL, S2VL, S1VR, S2VR, &
     &  SALPHAR, SALPHAI, SBETA
!  .. LOCAL ARRAYS ..
      REAL(WP), TARGET :: LLVL(1,1), LLVR(1,1), WORKMIN(1)
      REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
      INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(A,1); LD = MAX(1,N)
   SALPHAR = SIZE(ALPHAR); SALPHAI = SIZE(ALPHAI)
   SBETA = SIZE(BETA)
   IF( PRESENT(VL) )THEN; S1VL = SIZE(VL,1); S2VL = SIZE(VL,2); LJOBVL = 'V'
   ELSE; S1VL = 1; S2VL = 1; LJOBVL = 'N'; END IF
   IF( PRESENT(VR) )THEN; S1VR = SIZE(VR,1); S2VR = SIZE(VR,2); LJOBVR = 'V'
   ELSE; S1VR = 1; S2VR = 1; LJOBVR = 'N'; END IF
!  .. TEST THE ARGUMENTS
   IF( N < 0 .OR. SIZE(A,2) /= N )THEN; LINFO = -1
   ELSE IF( SIZE(B,1) /= N .OR. SIZE(B,2) /= N )THEN; LINFO = -2
   ELSE IF( SALPHAR /= N )THEN; LINFO = -3
   ELSE IF( SALPHAI /= N )THEN; LINFO = -4
   ELSE IF( SBETA /= N )THEN; LINFO = -5
   ELSE IF( PRESENT(VL) .AND. ( S1VL /= N .OR. S2VL /= N ) )THEN; LINFO = -6
   ELSE IF( PRESENT(VR) .AND. ( S1VR /= N .OR. S2VR /= N ) )THEN; LINFO = -7
   ELSE IF( N > 0 )THEN

    
! .. DETERMINE THE WORKSPACE ..
! .. QUERING THE SIZE OF WORKSPACE ..
      LWORK = -1
      IF (PRESENT (VL)) THEN
        IF (PRESENT (VR)) THEN
           CALL GGEV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&	       BETA, VL, S1VL, VR, S1VR, WORKMIN, LWORK, LINFO )
        ELSE
	   CALL GGEV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&	       BETA, VL, S1VL, LLVR, S1VR, WORKMIN, LWORK, LINFO )
        ENDIF
      ELSE
        IF (PRESENT (VR)) THEN
           CALL GGEV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&	       BETA, LLVL, S1VL, VR, S1VR, WORKMIN, LWORK, LINFO )
        ELSE
	   CALL GGEV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&	       BETA, LLVL, S1VL, LLVR, S1VR, WORKMIN, LWORK, LINFO )
        ENDIF
       ENDIF	
      LWORK = WORKMIN(1)
      ALLOCATE(WORK(LWORK), STAT=ISTAT)
      IF (ISTAT /= 0) THEN; LINFO=-100; GOTO 100; ENDIF
      IF (PRESENT (VL)) THEN
        IF (PRESENT (VR)) THEN
           CALL GGEV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&                        BETA, VL, S1VL, VR, S1VR, WORK, LWORK, LINFO )
        ELSE
	   CALL GGEV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&                        BETA, VL, S1VL, LLVR, S1VR, WORK, LWORK, LINFO )
        ENDIF
       ELSE
        IF (PRESENT (VR)) THEN
           CALL GGEV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&                        BETA, LLVL, S1VL, VR, S1VR, WORK, LWORK, LINFO )
        ELSE
	   CALL GGEV_F77( LJOBVL, LJOBVR, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&                        BETA, LLVL, S1VL, LLVR, S1VR, WORK, LWORK, LINFO )
        ENDIF
       ENDIF 	
      IF( LINFO == 0 ) LWORK = INT(WORK(1)+1)

      DEALLOCATE(WORK)
     ENDIF
100  CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE SGGEV_F95

SUBROUTINE SSTEVR_F95( D, E, W, Z, VL, VU, IL, IU, M, ISUPPZ, &
     &    ABSTOL, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => SP
      USE LA_AUXMOD, ONLY: ERINFO
      USE F77_LAPACK, ONLY: STEVR_F77 => LA_STEVR, LAMCH_F77 => SLAMCH
!  .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(IN), OPTIONAL :: IL, IU
      INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
      REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
!  .. ARRAY ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL, TARGET :: ISUPPZ(:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
      REAL(WP), INTENT(INOUT) :: D(:), E(:)
      REAL(WP), INTENT(OUT) :: W(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
!       LA_STEVR computes selected eigenvalues and, optionally, the 
! corresponding eigenvectors of a real symmetric tridiagonal matrix A.
! Eigenvalues and eigenvectors can be selected by specifying either a 
! range of values or a range of indices for the desired eigenvalues.
!       LA_STEVR uses a relatively robust representation (RRR) algorithm.
! It is usually the fastest algorithm of all and uses the least
! workspace.
! 
! =========
! 
!         SUBROUTINE LA_STEVR ( D, E, W, Z=z, VL=vl, VU=vu, &
!                         IL=il, IU=iu, M=m, ISUPPZ=isuppz, &
!                         ABSTOL=abstol, INFO=info )
!                 REAL(<wp>), INTENT(INOUT) :: D(:), E(:)
!                 REAL(<wp>), INTENT(OUT) :: W(:)
!                 REAL(<wp>), INTENT(OUT), OPTIONAL :: Z(:,:)
!                 INTEGER, INTENT(OUT), OPTIONAL :: ISUPPZ(:)
!                 REAL(<wp>), INTENT(IN), OPTIONAL :: VL, VU
!                 INTEGER, INTENT(IN), OPTIONAL :: IL, IU
!                 INTEGER, INTENT(OUT), OPTIONAL :: M
!                 REAL(<wp>), INTENT(IN), OPTIONAL :: ABSTOL
!                 INTEGER, INTENT(OUT), OPTIONAL :: INFO
!         where
!                 <wp> ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! D      (input/output) REAL array, shape (:) with size(D) = n, where n 
!        is the order of A.
!        On entry, the diagonal elements of the matrix A.
!        On exit, the original contents of D possibly multiplied by a 
!        constant factor to avoid over/underflow in computing the 
!        eigenvalues.
! E      (input/output) REAL array, shape (:) with size(E) = n.
!        On entry, the n-1 subdiagonal elements of A in E(1) to E(n-1) .
!        E(n) need not be set.
!        On exit, the original contents of E possibly multiplied by a 
!        constant factor to avoid over/underflow in computing the 
!        eigenvalues.
! W      (output) REAL array with size(W) = n.
!        The first M elements contain the selected eigenvalues in 
!        ascending order.
! Z      Optional (output) REAL or COMPLEX array, shape (:,:) with 
!        size(Z,1) = n and size(Z,2) = M.
!        The first M columns of Z contain the orthonormal eigenvectors of
!        A corresponding to the selected eigenvalues, with the i-th column 
!        of Z containing the eigenvector associated with the eigenvalue in
!        W(i).
!        Note: The user must ensure that at least M columns are supplied 
!        in the array Z. When the exact value of M is not known in advance,
!        an upper bound must be used. In all cases M <= n.
! VL,VU  Optional (input) REAL.
!        The lower and upper bounds of the interval to be searched for 
!        eigenvalues. VL < VU.
!        Default values: VL = -HUGE(<wp>) and VU = HUGE(<wp>), where 
!        <wp> ::= KIND(1.0) | KIND(1.0D0).
!        Note: Neither VL nor VU may be present if IL and/or IU is 
!        present.
! IL,IU  Optional (input) INTEGER.
!        The indices of the smallest and largest eigenvalues to be 
!        returned. The IL-th through IU-th eigenvalues will be found. 
!        1 <= IL <= IU <= n.
!        Default values: IL = 1 and IU = n.
!        Note: Neither IL nor IU may be present if VL and/or VU is 
!        present.
!        Note: All eigenvalues are calculated if none of the arguments 
!        VL, VU, IL and IU are present.
! M      Optional (output) INTEGER.
!        The total number of eigenvalues found. 0 <= M <=  n.
!        Note: If IL and IU are present then M = IU - IL + 1.
! ISUPPZ Optional (output) INTEGER array, shape (:) with 
!        size(ISUPPZ) = 2*max(1,M).
!        The support of the eigenvectors in A, i.e., the indices 
!        indicating the nonzero elements. The i-th eigenvector is nonzero
!        only in elements ISUPPZ(2*i-1) through ISUPPZ(2*i).
! ABSTOL Optional (input) REAL.
!        The absolute error tolerance for the eigenvalues. An approximate
!        eigenvalue is accepted as converged when it is determined to lie
!        in an interval [a, b] of width less than or equal to 
!        ABSTOL + EPSILON(1.0_<wp>) * max(| a |, | b |),
!        where <wp> is the working precision. If ABSTOL <= 0, then 
!        EPSILON(1.0_<wp>)*||A||1 will be used in its place. Eigenvalues
!        will be computed most accurately if ABSTOL is set to 
!        LA_LAMCH( 1.0_<wp>, 'Safe minimum'), not zero.
!        Default value: 0.0_<wp>.
! INFO   Optional (output) INTEGER
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value.
!        > 0: an internal error occurred.
!        If INFO is not present and an error occurs, then the program is
!        terminated with an error message.
!-----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_STEVR'
!  .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: LJOBZ, LRANGE
      INTEGER :: N, LD, LIL, LIU, LM, SISUPPZ, S1Z, S2Z, NN
      INTEGER :: LINFO, ISTAT, LWORK, LIWORK
      REAL(WP), TARGET :: LLZ(1,1)
      REAL(WP) :: LABSTOL, LVL, LVU
!  .. LOCAL ARRAYS ..
      INTEGER:: IWORKMIN(1), DUMMY(1)
      REAL(WP), TARGET :: WORKMIN(1)
      INTEGER, POINTER :: IWORK(:), LISUPPZ(:)
      REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
      INTRINSIC HUGE, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(D); LD = MAX(1,N)
   NN=2*MAX(1,N)
   IF( PRESENT(ISUPPZ) )THEN; SISUPPZ = SIZE(ISUPPZ); ELSE; SISUPPZ = NN; END IF
   IF( PRESENT(VL) )THEN; LVL = VL; ELSE; LVL = -HUGE(LVL); ENDIF
   IF( PRESENT(VU) )THEN; LVU = VU; ELSE; LVU = HUGE(LVU); ENDIF
   IF( PRESENT(IL) )THEN; LIL = IL; ELSE; LIL = 1; ENDIF
   IF( PRESENT(IU) )THEN; LIU = IU; ELSE; LIU = N; ENDIF
   IF( PRESENT(Z) )THEN; S1Z = SIZE(Z,1); S2Z = SIZE(Z,2)
   ELSE; S1Z = 1; S2Z = 1; ENDIF
!  .. TEST THE ARGUMENTS
   IF( N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE( E ) /= N .AND. N/=0)THEN; LINFO = -2
   ELSE IF( SIZE( W ) /= N )THEN; LINFO = -3
   ELSE IF( PRESENT(Z) .AND. ( S1Z /= LD .OR. S2Z /= MAX(1,N) ) )THEN; LINFO = -4
   ELSE IF( SISUPPZ /= NN .OR. PRESENT(ISUPPZ).AND..NOT.PRESENT(Z) )THEN; LINFO = -5
   ELSE IF( LVU < LVL .AND. N>0)THEN; LINFO = -6
   ELSE IF( (PRESENT(VL) .OR. PRESENT(VU)) .AND. &
            (PRESENT(IL) .OR. PRESENT(IU)) )THEN; LINFO = -7
   ELSE IF (((LIU<LIL) .OR. (LIL<1)) .AND. (N>0))THEN; LINFO = -7
   ELSE IF( N < LIU )THEN; LINFO = -8
   ELSE IF( N > 0 )THEN
     IF( PRESENT(VL) .OR. PRESENT(VU) )THEN; LRANGE = 'V'; LM = N
     ELSE IF( PRESENT(IL) .OR. PRESENT(IU) )THEN; LRANGE = 'I'; LM = LIU-LIL+1
     ELSE; LRANGE = 'A'; LM = N; END IF
       IF( PRESENT(Z) ) THEN; LJOBZ = 'V'
       ELSE; LJOBZ = 'N'
       ENDIF
! .. DETERMINE THE WORKSPACE ..
! .. QUERING THE SIZE OF WORKSPACE ..
       LWORK = -1
       LIWORK = -1
       IF (PRESENT(Z)) THEN
         CALL STEVR_F77( LJOBZ, LRANGE, N, D, E,  LVL, LVU, &
     &       LIL, LIU, LABSTOL, LM, W, Z, S1Z, DUMMY, &
     &       WORKMIN, LWORK, IWORKMIN, LIWORK, LINFO )
       ELSE
         CALL STEVR_F77( LJOBZ, LRANGE, N, D, E,  LVL, LVU, &
     &       LIL, LIU, LABSTOL, LM, W, LLZ, S1Z, DUMMY, &
     &       WORKMIN, LWORK, IWORKMIN, LIWORK, LINFO )
       ENDIF
       LWORK = WORKMIN(1)
       LIWORK = IWORKMIN(1)
       
       ALLOCATE(IWORK(LIWORK), STAT=ISTAT)
       IF (ISTAT /= 0) THEN ; LINFO = -100; GOTO 100; ENDIF

       ALLOCATE(LISUPPZ(NN), STAT=ISTAT)
       IF (ISTAT /= 0) THEN ; LINFO = -100; GOTO 200; ENDIF

       ALLOCATE(WORK(LWORK), STAT=ISTAT)
       IF (ISTAT /= 0) THEN ; LINFO = -100; GOTO 300; ENDIF

       IF( PRESENT(ABSTOL) )THEN; LABSTOL = ABSTOL
       ELSE; LABSTOL = 2*LAMCH_F77('Safe minimum'); ENDIF

       IF (PRESENT (Z)) THEN
         CALL STEVR_F77( LJOBZ, LRANGE, N, D, E, LVL, LVU, LIL, LIU, &
     &     LABSTOL, LM, W, Z, S1Z, LISUPPZ, WORK, LWORK, &
     &     IWORK, LIWORK, LINFO )
       ELSE
         CALL STEVR_F77( LJOBZ, LRANGE, N, D, E, LVL, LVU, LIL, LIU, &
     &     LABSTOL, LM, W, LLZ, S1Z, LISUPPZ, WORK, LWORK, &
     &     IWORK, LIWORK, LINFO )
       ENDIF

       IF( PRESENT(M) ) M = LM

       DEALLOCATE(WORK)
300    DEALLOCATE(LISUPPZ)
200    DEALLOCATE(IWORK)
     ENDIF
100  CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE SSTEVR_F95

      SUBROUTINE DGELSY1_F95( A, B, RANK, JPVT, RCOND, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => DP
      USE LA_AUXMOD, ONLY: ERINFO
      USE F77_LAPACK, ONLY: GELSY_F77 => LA_GELSY
!   .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL :: RANK
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(IN), OPTIONAL :: RCOND
!   .. ARRAY ARGUMENTS ..
      INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: JPVT(:)
      REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
!   .. PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GELSY'
!   .. LOCAL SCALARS ..
      INTEGER :: LINFO, ISTAT, ISTAT1, LWORK, N, M, MN, LRANK, SJPVT
      REAL(WP) :: LRCOND
!   .. LOCAL POINTERS ..
      INTEGER, POINTER :: LJPVT(:)
      REAL(WP), POINTER :: WORK(:)
      REAL(WP) :: WORKMIN(1)
!   .. INTRINSIC FUNCTIONS ..
      INTRINSIC SIZE, PRESENT, MAX, MIN, EPSILON
!   .. EXECUTABLE STATEMENTS ..
      LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2)
      MN = MIN(M,N)
      IF( PRESENT(RCOND) )THEN; LRCOND = RCOND; ELSE
         LRCOND = 100*EPSILON(1.0_WP) ; ENDIF
      IF( PRESENT(JPVT) )THEN; SJPVT = SIZE(JPVT); ELSE; SJPVT = N; ENDIF
!   .. TEST THE ARGUMENTS
      IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
      ELSE IF( SIZE( B ) /= MAX(1,M,N)) THEN; LINFO = -2
      ELSE IF( SJPVT /= N ) THEN; LINFO = -4
      ELSE IF( LRCOND <= 0.0_WP ) THEN; LINFO = -5
      ELSE
        IF( PRESENT(JPVT) )THEN; LJPVT => JPVT
        ELSE; ALLOCATE( LJPVT(N), STAT = ISTAT ); LJPVT = 0; END IF
	
	
! .. DETERMINE THE WORKSPACE ..
! .. QUERING THE SIZE OF WORKSPACE ..
          LWORK = -1
          CALL GELSY_F77( M, N, 1, A, MAX(1,M), B, MAX(1,M,N), &
     &      LJPVT, LRCOND, LRANK, WORKMIN, LWORK, LINFO )  
          LWORK = WORKMIN(1)
          IF( ISTAT == 0 ) THEN
            ALLOCATE( WORK(LWORK), STAT = ISTAT )
            IF( ISTAT /= 0 ) CALL ERINFO( -200, SRNAME, LINFO )
          END IF

          IF ( ISTAT == 0 ) THEN
            CALL GELSY_F77( M, N, 1, A, MAX(1,M), B, MAX(1,M,N), &
     &      LJPVT, LRCOND, LRANK, WORK, LWORK, LINFO )
          ELSE; LINFO = -100; END IF
            IF( PRESENT(RANK) ) RANK = LRANK
            IF( PRESENT(JPVT) ) JPVT = LJPVT
            DEALLOCATE(WORK, STAT = ISTAT1 )
          END IF
          CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
        END SUBROUTINE DGELSY1_F95

      PROGRAM LA_SHESV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_HESV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N, NRHS
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE :: IPIV(:)
      COMPLEX(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SHESV Example Program Results'
      N = 5; NRHS = 3
      WRITE(*,'(5H N = , I4, 9H; NRHS = , I4)') N, NRHS
      ALLOCATE ( A(N,N), AA(N,N), B(N,NRHS), BB(N,NRHS), IPIV(N) )
    
      OPEN(UNIT=21,FILE='hesv.ma',STATUS='UNKNOWN')
      DO I=1,N
         DO J=I,N
         READ(21,*) A(I,J);
         ENDDO
      ENDDO;
      CLOSE(21)
 
      WRITE(*,*) 'The matrix A :'
      DO I=1,N
      WRITE(*,"(5(I3,1X,'+',1X,I3,'i',1X))") INT(A(I,1)),INT(AIMAG(A(I,1))), & 
                                             INT(A(I,2)),INT(AIMAG(A(I,2))), &  
                                             INT(A(I,3)),INT(AIMAG(A(I,3))), & 
                                             INT(A(I,4)),INT(AIMAG(A(I,4))), & 
                                             INT(A(I,5)),INT(AIMAG(A(I,5))) 
      ENDDO
  
      OPEN(UNIT=21,FILE='hesv.mb',STATUS='UNKNOWN')
      DO I=1,N
         READ(21,*) B(I,1);
      ENDDO;
      CLOSE(21)
     
      WRITE(*,*) 'The array B :'
      DO I=1,N
      WRITE(*,"((I3,1X,'+',1X,I3,'i',1X))") INT(B(I,1)),INT(AIMAG(B(I,1))) 
      ENDDO
      
      BB=B
      WRITE(*,*)' CALL LA_HESV( A, B, IPIV=IPIV )'
      CALL LA_HESV( A, B, IPIV=IPIV )
   
      WRITE(*,*)'A on exit: '
      DO I=1,N; WRITE(*,*) A(I,:); 
      ENDDO

      WRITE(*,*)'B on exit: '
      DO I=1,N; WRITE(*,*) (B(I,1));
      ENDDO

      WRITE(*,*)'IPIV on exit : ', IPIV
    
      
      END PROGRAM LA_SHESV_EXAMPLE

      PROGRAM LA_SSYGV_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SYGV
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:), W(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_SYEV Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), B(N,N), BB(N,N), W(N) )

      OPEN(UNIT=21,FILE='sygv.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=TRANSPOSE(A)

      WRITE(*,*)'Matrix A : '
      DO I=1,N; 
         WRITE(*,"(5(I3,1X))") INT(A(I,:)); 
      ENDDO
    
      OPEN(UNIT=21,FILE='sygv.mb',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(21)
      
      BB=TRANSPOSE(B)
      
      WRITE(*,*)'Matrix B : '
      DO I=1,N; 
         WRITE(*,"(5(I3,1X))") INT(B(I,:)); 
      ENDDO
    
      WRITE(*,*) 'CALL LA_SYGV( A, B, W )'
      CALL LA_SYGV( A, B, W )
      
      WRITE(*,*)'Matrix B on exit:'
      DO I=1,N; 
         WRITE(*,"(5(E14.6,1X))") B(I,:); 
      ENDDO
      
      WRITE(*,*) 'W on exit : '
      DO I=1,N
         WRITE(*,"(5(E14.6,1X))") W(I)
      ENDDO
       
      WRITE(*,*)
      WRITE(*,*) ' * EXAMPLE 2 * ' 
      
      WRITE(*,*)'Matrix A : '
      DO I=1,N; 
         WRITE(*,"(5(I3,1X))") INT(AA(I,:)); 
      ENDDO
          
      WRITE(*,*)'Matrix B : '
      DO I=1,N; 
         WRITE(*,"(5(I3,1X))") INT(BB(I,:)); 
      ENDDO

      WRITE(*,*) "CALL LA_SYGV( A, B, W, '2', 'V', 'L', INFO )"
      CALL LA_SYGV( AA, BB, W, 2, 'V', 'L', INFO )
      
      WRITE(*,*)'Matrix A on exit:'
      DO I=1,N; 
         WRITE(*,"(5(E14.6,1X))") AA(I,:); 
      ENDDO
    
      WRITE(*,*)'Matrix B on exit:'
      DO I=1,N; 
         WRITE(*,"(5(E14.6,1X))") BB(I,:); 
      ENDDO
    
      WRITE(*,*) 'W on exit : '
      DO I=1,N
         WRITE(*,"(5(F11.5,1X))") W(I)
      ENDDO
      
      WRITE(*,*) ' INFO = ', INFO

      END PROGRAM LA_SSYGV_EXAMPLE

SUBROUTINE LA_TEST_ZHPGVX(ITYPE, JOBZ, RANGE, UPLO, N, AP, BP,&
     &  VL, VU, IL, IU, ABSTOL, M, W, Z, LDZ, WORK, RWORK, IWORK, IFAIL, &
     &  INFO )
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark
!     August 20, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => DP
!      USE LA_AUXMOD, ONLY: ERINFO
      USE F95_LAPACK, ONLY: LA_HPGVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      CHARACTER(LEN=1), INTENT(IN) :: JOBZ, RANGE, UPLO
      INTEGER, INTENT(IN) :: N, IL, IU, LDZ
      INTEGER, INTENT(OUT) :: M
      INTEGER, INTENT(IN) :: ITYPE
      INTEGER, INTENT(INOUT) :: INFO
      REAL(WP), INTENT(IN) ::  ABSTOL, VL, VU 
!  .. Array Arguments ..
      INTEGER, INTENT(INOUT) ::  IWORK(1:5*N)
      COMPLEX(WP), INTENT(INOUT) :: WORK(1:8*N), AP(1:N*(N+1)/2), BP(1:N*(N+1)/2)
      REAL(WP), INTENT(OUT) :: W(1:N)
      COMPLEX(WP), INTENT(OUT) :: Z(1:LDZ,1:MAX(1,N))
      INTEGER, INTENT(OUT) :: IFAIL(1:N)
      REAL(WP), INTENT(OUT) :: RWORK(1: 7*N)
      LOGICAL LSAME
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_HPGVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZHPGVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      CHARACTER(LEN=1) :: IJOBZ, IRANGE, IUPLO
      INTEGER :: I, J, IAP, IBP, IW, IZ1, IZ2, IITYPE
      INTEGER :: IIL, IIU, IIFAIL
      REAL(WP) :: IVL, IVU, IABSTOL
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IAP =  N *(N+1)/2; IBP =  N *(N+1)/2; IITYPE= ITYPE
      IW = N;  IZ1 = N; IZ2 = N; IIL = IL; IIU = IU; IIFAIL = N
      IJOBZ = JOBZ; IRANGE = RANGE; IUPLO = UPLO
      IVL = VL; IVU = VU; IABSTOL = ABSTOL
      I =  INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE(1)
      IAP = IAP - 1
      CASE (2)
      IBP = IAP - 1 
      CASE (3)
      IW = IW - 1
    CASE (4)
      IITYPE = 4
      CASE (5)
      IUPLO = 'T'
      CASE (6)
      IZ1 = IZ1 - 1
      CASE (7)   
      IVU = IVL -1
      CASE (8)
      CALL LA_HPGVX( AP(1:IAP), BP(1:IBP), W=W, ITYPE=IITYPE, &
     &  UPLO=IUPLO, Z=Z(1:IZ1,1:IZ2), VL=IVL, VU=IVU, IL=IIL, &
     &  IU=IIU, M=M, IFAIL=IFAIL(1:IIFAIL),&
     &  ABSTOL=IABSTOL, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )  
      RETURN
      CASE(9)
      IRANGE = 'I'
      IIU = IIL - 1
      CASE (10)
      IIU = N+1
      CASE (12)
      IIFAIL = IAP - 1
      CASE (:-1, 11, 13:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF (LSAME(IJOBZ, 'V')) THEN
        IF (LSAME(IRANGE,'A')) THEN
          CALL LA_HPGVX( AP(1:IAP), BP(1:IBP), W, IITYPE,  IUPLO,&
     &      Z=Z(1:IZ1,1:IZ2), M=M, IFAIL=IFAIL(1:IIFAIL),               &
     &      ABSTOL=IABSTOL, INFO=INFO )
        ELSE IF (LSAME(IRANGE,'I')) THEN
          CALL LA_HPGVX( AP(1:IAP), BP(1:IBP), W, IITYPE,  IUPLO, &
     &      Z=Z(1:IZ1,1:IZ2), IL=IIL, IU=IIU, M=M, IFAIL=IFAIL(1:IIFAIL),& 
     &      ABSTOL=IABSTOL, INFO=INFO ) 
        ELSE
          CALL LA_HPGVX( AP(1:IAP), BP(1:IBP), W, IITYPE, IUPLO, &
     &      Z=Z(1:IZ1,1:IZ2), VL=IVL, VU=IVU, M=M, IFAIL=IFAIL(1:IIFAIL),&
     &      ABSTOL=IABSTOL, INFO=INFO )
        ENDIF
      ELSE
        IF (LSAME(IRANGE,'A')) THEN 
          CALL LA_HPGVX(  AP(1:IAP), BP(1:IBP), W, IITYPE,  IUPLO, &
     &      M=M, ABSTOL=IABSTOL, INFO=INFO )
        ELSE IF (LSAME(IRANGE,'I')) THEN
          CALL LA_HPGVX(  AP(1:IAP), BP(1:IBP), W, IITYPE, IUPLO, &
     &      IL=IIL, IU=IIU, M=M, ABSTOL=IABSTOL, INFO=INFO )  
         ELSE
           CALL LA_HPGVX(  AP(1:IAP), BP(1:IBP), W, IITYPE, IUPLO,&
     &       VL=IVL, VU=IVU,  M=M, ABSTOL=IABSTOL,  INFO=INFO )
         END IF
       ENDIF
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_ZHPGVX
       

SUBROUTINE ZPBSVX1_F95(A, B, X, UPLO, AF, FACT, EQUED, &
                            S, FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: PBSVX_F77 => LA_PBSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
   CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, FERR, BERR
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:)
   COMPLEX(WP), INTENT(OUT) :: X(:)
   COMPLEX(WP), INTENT(INOUT), OPTIONAL, TARGET :: AF(:,:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: S(:)
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_PBSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LUPLO, LEQUED
   INTEGER :: LINFO, N, ISTAT, ISTAT1, S1AF, S2AF, &
              SS, KD
   REAL(WP) :: LRCOND, MVS, LFERR, LBERR
!  .. LOCAL POINTERS ..
   REAL(WP),  POINTER :: RWORK(:), LS(:)
   COMPLEX(WP),  POINTER :: WORK(:), LAF(:, :)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE, MINVAL, TINY
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0
   KD = SIZE(A,1)-1; N = SIZE(A, 2)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(EQUED) .AND. LSAME(LFACT,'F') )THEN; LEQUED = EQUED
   ELSE; LEQUED='N'; END IF
   IF( PRESENT(AF) )THEN; S1AF = SIZE(AF,1); S2AF = SIZE(AF,2)
   ELSE; S1AF = KD+1; S2AF = N; END IF
   IF( ( PRESENT(S) ) )THEN; SS = SIZE(S); ELSE; SS = N; END IF
   IF( PRESENT(S) .AND. LSAME(LFACT,'F') .AND. LSAME(LEQUED,'Y') ) THEN
       MVS = MINVAL(S); ELSE; MVS = TINY(1.0_WP); ENDIF
   IF(PRESENT(UPLO))THEN; LUPLO = UPLO; ELSE; LUPLO='U'; END IF
!  .. TEST THE ARGUMENTS
   IF( KD < 0 .OR. N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE(B) /= N )THEN; LINFO = -2
   ELSE IF( SIZE(X) /= N )THEN; LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
   ELSE IF( S1AF /= KD+1 .OR. S2AF /= N ) THEN; LINFO = -5
   ELSE IF( ( .NOT. ( LSAME(LFACT,'F') .OR. LSAME(LFACT,'N') .OR. &
                    LSAME(LFACT,'E') ) ) .OR. &
      ( LSAME(LFACT,'F') .AND. .NOT.PRESENT(AF) ) )THEN; LINFO = -6
   ELSE IF( .NOT.LSAME(LEQUED,'N') .AND. .NOT.LSAME(LEQUED,'Y') )THEN; LINFO = -7
   ELSE IF( SS /= N .OR. LSAME(LFACT,'F') .AND. LSAME(LEQUED,'Y') &
      .AND. MVS  <= 0.0_WP )THEN; LINFO = -8
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(AF) ) THEN; ALLOCATE( LAF(S1AF,N), STAT=ISTAT )
      ELSE; LAF => AF; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(S) )THEN; ALLOCATE( LS(N), STAT=ISTAT )
         ELSE; LS => S; END IF
      END IF
      IF( ISTAT == 0 ) ALLOCATE(WORK(2*N), RWORK(N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
         CALL PBSVX_F77( LFACT, LUPLO, N, KD, 1, A, KD+1, LAF, S1AF, &
                         LEQUED, LS, B, N, X, N, LRCOND, &
                         LFERR, LBERR, WORK, RWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(S) ) DEALLOCATE( LS, STAT=ISTAT1 )
      IF( .NOT.PRESENT(AF) ) DEALLOCATE( LAF, STAT=ISTAT1 )
      IF( PRESENT(FERR) ) FERR = LFERR
      IF( PRESENT(BERR) ) BERR = LBERR
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      IF( PRESENT(EQUED) .AND. .NOT.LSAME(LFACT,'F') ) EQUED=LEQUED
      DEALLOCATE( WORK, RWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE ZPBSVX1_F95

 SUBROUTINE SGELSS1_F95( A, B, RANK, S, RCOND, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => SP
    USE LA_AUXMOD, ONLY: ERINFO, LA_WS_GELSS
    USE F77_LAPACK, ONLY: GELSS_F77 => LA_GELSS
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL :: RANK
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
    REAL(WP), INTENT(IN), OPTIONAL :: RCOND
!   .. ARRAY ARGUMENTS ..
    REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
    REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: S(:)
!   .. PARAMETERS ..
    CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GELSS'
    CHARACTER(LEN=1), PARAMETER :: VER = 'S'
!   .. LOCAL SCALARS ..
    INTEGER :: LINFO, ISTAT, ISTAT1, LWORK, N, M, MN, NRHS, LRANK, SS
    REAL(WP) :: LRCOND
!   .. LOCAL POINTERS ..
    REAL(WP), POINTER :: WORK(:), LS(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT, MAX, MIN, EPSILON
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2); NRHS = 1; MN = MIN(M,N)
    IF( PRESENT(RCOND) )THEN; LRCOND = RCOND; ELSE
        LRCOND = 100*EPSILON(1.0_WP) ; ENDIF
    IF( PRESENT(S) )THEN; SS = SIZE(S); ELSE; SS =MN; ENDIF
!   .. TEST THE ARGUMENTS
    IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B ) /= MAX(1,M,N) ) THEN; LINFO = -2
    ELSE IF( SS /= MN ) THEN; LINFO = -4
    ELSE IF( LRCOND <= 0.0_WP ) THEN; LINFO = -5
    ELSE
       IF( PRESENT(S) )THEN; LS => S
       ELSE; ALLOCATE( LS(MN), STAT = ISTAT ); END IF
       IF( ISTAT == 0 ) THEN
          LWORK = LA_WS_GELSS( VER, M, N, NRHS )
          ALLOCATE( WORK(LWORK), STAT = ISTAT )
          IF( ISTAT /= 0 ) THEN
             DEALLOCATE( WORK, STAT=ISTAT1 )
             LWORK = MAX( 1, 3*MIN(M,N) + MAX( 2*MIN(M,N), MAX(M,N), NRHS ) )
             ALLOCATE( WORK(LWORK), STAT = ISTAT )
             IF( ISTAT /= 0 ) CALL ERINFO( -200, SRNAME, LINFO )
          END IF
       END IF
       IF ( ISTAT == 0 ) THEN
!      .. CALL LAPACK77 ROUTINE
          CALL GELSS_F77( M, N, NRHS, A, MAX(1,M), B, MAX(1,M,N), &
                         LS, LRCOND, LRANK, WORK, LWORK, LINFO )
       ELSE; LINFO = -100; END IF
       IF( PRESENT(RANK) ) RANK = LRANK
       DEALLOCATE(WORK, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE SGELSS1_F95

 SUBROUTINE SGTSV_F95( DL, D, DU, B, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => SP
    USE LA_AUXMOD, ONLY: ERINFO
    USE F77_LAPACK, ONLY: GTSV_F77 => LA_GTSV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    REAL(WP), INTENT(INOUT) :: DL(:), D(:), DU(:), B(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_GTSV computes the solution to a real or complex linear system of
! equations A*X = B, where A is a square tridiagonal matrix and X and B 
! are rectangular matrices or vectors. The LU decomposition is used to
! factor the matrix A as A = L*U , where L is a product of permutation
! and unit lower bidiagonal matrices and U is upper triangular with 
! nonzeros in only the main diagonal and first two superdiagonals.
! The factored form of A is then used to solve the above system.
! 
! Note: The system A^T*X = B may be solved by interchanging the order of
! the arguments DU and DL.
! 
! =========
! 
!       SUBROUTINE LA_GTSV( DL, D, DU, B, INFO=info ) 
!           <type>(<wp>), INTENT(INOUT) :: DL(:), D(:), DU(:), <rhs>
!           INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!           <type> ::= REAL | COMPLEX
!           <wp> ::= KIND(1.0) | KIND(1.0D0)
!           <rhs> ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! DL    (input/output) REAL or COMPLEX array, shape (:) with 
!       size(DL) = n-1, where n is the order of A.
!       On entry, the subdiagonal of A.
!       On exit, the n-2 elements of the second superdiagonal of U in
!       DL(1),..., DL(n-2).
! D     (input/output) REAL or COMPLEX array, shape (:) with size(D) = n.
!       On entry, the diagonal of A.
!       On exit, the diagonal of U .
! DU    (input/output) REAL or COMPLEX array, shape (:) with 
!       size(DL) = n-1.
!       On entry, the superdiagonal of A.
!       On exit, the first superdiagonal of U .
! B     (input/output) REAL or COMPLEX array, shape (:,:) with 
!       size(B,1) = n or shape (:) with size(B) = n.
!       On entry, the matrix B.
!       On exit, the solution matrix X .
! INFO  Optional (output) INTEGER
!       = 0: successful exit.
!       < 0: if INFO = -i, the i-th argument had an illegal value.
!       > 0: if INFO = i, then U(i,i) = 0. The factorization has not been
!       completed unless i = n. The factor U is singular, so the solution
!       could not be computed.
!       If INFO is not present and an error occurs, then the program is 
!       terminated with an error message.
!----------------------------------------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GTSV'
!   .. LOCAL SCALARS ..
    INTEGER :: LINFO, N, NRHS
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0
    N = SIZE(D); NRHS = SIZE(B,2)
!   .. TEST THE ARGUMENTS
    IF( SIZE( DL ) /= N-1 .AND. N /= 0 ) THEN; LINFO = -1
    ELSE IF( N < 0 ) THEN; LINFO = -2
    ELSE IF( SIZE( DU ) /= N-1 .AND. N/=0 ) THEN; LINFO = -3
    ELSE IF( SIZE( B, 1 ) /= N .OR. NRHS < 0 ) THEN; LINFO = -4
    ELSE IF ( N > 0 ) THEN
       CALL GTSV_F77( N, NRHS, DL, D, DU, B, N, LINFO )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO )
 END SUBROUTINE SGTSV_F95

SUBROUTINE SSYTRD_F95( A, TAU, UPLO, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: SYTRD_F77 => LA_SYTRD, ILAENV_F77 => LA_ILAENV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:)
   REAL(WP), INTENT(OUT) :: TAU(:)
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_SYTRD'
   CHARACTER(LEN=6), PARAMETER :: BSNAME = 'SSYTRD'
!-----------------------------------------------------------------
!
! Purpose
! =======
!
! LA_SYTRD / LA_HETRD reduces a real symmetric or complex Hermitian 
! matrix A to real symmetric tridiagonal form T by an orthogonal 
! or unitary similarity transformation:
! Q**H * A * Q = T.
!
! =======
!
!    SUBROUTINE LA_HETRD / LA_SYTRD|( A, TAU, UPLO, INFO )
!    .. Scalar Arguments ..
!       CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!       INTEGER, INTENT(OUT), OPTIONAL :: INFO
!    .. Array Arguments ..
!       <type>(<wp>), INTENT(INOUT) :: A(:,:)
!       <type>(<wp>), INTENT(OUT) :: TAU(:)
!    where
!       <type> ::= REAL | COMPLEX
!       <wp>   ::= KIND(1.0) | KIND(1.0D0)
!
! Defaults
! ========
!
! 1. If UPLO is not present then UPLO = 'U' is assumed.
!
! Arguments
! =========
!
! A       (input/output) either REAL or COMPLEX square array, 
!         shape (:,:), size(A,1) == size(A,2) >= 0.
!         On entry, the symmetric (Hermitian) matrix A.  
!            If UPLO = 'U', the upper triangular part of A contains
!               the upper triangular part of the matrix A.
!            If UPLO = 'L', the lower triangular part of A contains
!               the lower triangular part of the matrix A.
!         On exit:
!            If UPLO = 'U', the diagonal and first superdiagonal
!               of A are overwritten by the corresponding elements of the
!               tridiagonal matrix T, and the elements above the first
!               superdiagonal, with the array TAU, represent the unitary
!               matrix Q as a product of elementary reflectors.
!            If UPLO = 'L', the diagonal and first subdiagonal of A are 
!               overwritten by the corresponding elements of the tridiagonal
!               matrix T, and the elements below the first subdiagonal, with
!               the array TAU, represent the unitary matrix Q as a product
!               of elementary reflectors.
!            See Further Details.
!
! TAU     (output) either REAL or COMPLEX array,
!         shape (:), size(TAU) == size(A,1)-1.
!         The scalar factors of the elementary reflectors.
!         See Further Details.
!
! UPLO    Optional, (input) CHARACTER*1
!         If UPLO is present then:
!            = 'U':  Upper triangle of A is stored
!            = 'L':  Lower triangle of A is stored
!         otherwise UPLO = 'U' is assumed.
!
! INFO    Optional, (output) INTEGER
!         If INFO is present:
!            = 0: successful exit
!            < 0: if INFO = -i, the i-th argument had an illegal value
!         If INFO is not present and an error occurs, then the program
!            is terminated with an error message.
!
! Further Details
! ===============
!
! If UPLO = 'U', the matrix Q is represented as a product of elementary
! reflectors
!
!    Q = H(n-1) . . . H(2) H(1).
!
! Each H(i) has the form
!
!    H(i) = I - tau * v * v'
!
! where tau is a complex scalar, and v is a complex vector with
! v(i+1:n) = 0 and v(i) = 1; v(1:i-1) is stored on exit in
! A(1:i-1,i+1), and tau in TAU(i).
!
! If UPLO = 'L', the matrix Q is represented as a product of elementary
! reflectors
!
!    Q = H(1) H(2) . . . H(n-1).
!
! Each H(i) has the form
!
!    H(i) = I - tau * v * v'
!
! where tau is a complex scalar, and v is a complex vector with
! v(1:i) = 0 and v(i+1) = 1; v(i+2:n) is stored on exit in A(i+2:n,i),
! and tau in TAU(i).
!
! The contents of A on exit are illustrated by the following examples
! with n = 5:
!
! if UPLO = 'U':                       if UPLO = 'L':
!
!   (  d   e   v2  v3  v4 )              (  d                  )
!   (      d   e   v3  v4 )              (  e   d              )
!   (          d   e   v4 )              (  v1  e   d          )
!   (              d   e  )              (  v1  v2  e   d      )
!   (                  d  )              (  v1  v2  v3  e   d  )
!
! where d and e denote diagonal and off-diagonal elements of T, and vi
! denotes an element of the vector defining H(i).
!
! --------------------------------------
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LUPLO
   INTEGER :: LINFO, N, LD, LWORK, NB, ISTAT, ISTAT1
!  .. LOCAL ARRAYS ..
   REAL(WP), POINTER :: WORK(:)
   REAL(WP), POINTER :: D(:), E(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC SIZE, MAX, PRESENT
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; N = SIZE(A,1); LD = MAX(1,N); ISTAT = 0
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE( A, 2 ) /= N .OR. N < 0 )THEN; LINFO = -1
   ELSE IF( SIZE( TAU ) /= N-1 )THEN; LINFO = -2
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
   ELSE IF( N > 0 )THEN
!  .. DETERMINE THE WORKSPACE
      NB = ILAENV_F77( 1, BSNAME, LUPLO, N, -1, -1, -1 )
      IF( NB > 1 .AND. NB < N )THEN; LWORK = N*NB; ELSE; LWORK = 1; ENDIF
      ALLOCATE(D(N), E(N-1), WORK(LWORK), STAT=ISTAT)
      IF( ISTAT /= 0 )THEN; DEALLOCATE(D, E, WORK, STAT=ISTAT1)
         LWORK = 1; ALLOCATE(D(N), E(N-1), WORK(LWORK), STAT=ISTAT)
         IF( ISTAT == 0 ) CALL ERINFO( -200, SRNAME, LINFO )
      ENDIF
      IF( ISTAT == 0 )THEN
!        .. CALL LAPACK77 ROUTINE
         CALL SYTRD_F77( LUPLO, N, A, LD, D, E, TAU, WORK, LWORK, LINFO )
      ELSE; LINFO = -100; ENDIF
      DEALLOCATE(D, E, WORK, STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE SSYTRD_F95

      PROGRAM LA_SGEES_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GEES
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N, SDIM
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), WR(:), WI(:), VS(:,:)
!  .. "Intrinsic Functions" ..
      INTERFACE
         LOGICAL FUNCTION SELECT( X, Y )
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT(IN) :: X, Y
         END FUNCTION SELECT
      END INTERFACE
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GEES Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), VS(N,N), WR(N), WI(N) )

      OPEN(UNIT=21,FILE='gees.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=A

      WRITE(*,*)'Matrix A:'
      DO I=1,N;
         WRITE(*,"(5(I3,1X))") INT(A(I,:)); 
      ENDDO
         
      WRITE(*,*) 'CALL LA_GEES( A, WR, WI )'
      CALL LA_GEES( A, WR, WI )

      WRITE(*,*)'Matrix A on exit :' 
      DO I=1,N; 
         WRITE(*,"(5(F12.5,1X))") A(I,:); 
      ENDDO
    
      WRITE(*,*) 'WR on exit :'
      DO I=1,N; 
         WRITE(*,"(5(F12.5,1X))") WR(I)
      ENDDO
    
      WRITE(*,*) 'WI on exit :'
      DO I=1,N; 
      WRITE(*,"(5(F12.5,1X))") WI(I)
      ENDDO

      WRITE(*,*)
      WRITE(*,*)' * EXAMPLE 2 * '

      WRITE(*,*) "CALL LA_GEES( A, WR, WI, VS, SELECT, SDIM, INFO )"
      CALL LA_GEES( AA, WR, WI, VS, SELECT, SDIM, INFO )
       
      WRITE(*,*)'Matrix A on exit :' 
      DO I=1,N; 
         WRITE(*,"(5(F12.5,1X))") AA(I,:); 
      ENDDO
   
      WRITE(*,*) 'WR on exit :'
      DO I=1,N; 
         WRITE(*,"(5(F12.5,1X))") WR(I)
      ENDDO
    
      WRITE(*,*) 'WI on exit :'
      DO I=1,N; 
      WRITE(*,"(5(F12.5,1X))") WI(I)
      ENDDO

      WRITE(*,*) 'VS on exit :'
      DO I=1,N; 
         WRITE(*,"(5(F12.7,1X))") VS(I,:); 
      ENDDO
    
      WRITE(*,*) ' SDIM = ', SDIM
      WRITE(*,*) ' INFO = ', INFO

    END PROGRAM LA_SGEES_EXAMPLE

! CONTAINS
    LOGICAL FUNCTION SELECT(X, Y )
    USE LA_PRECISION, ONLY: WP => SP
    INTRINSIC  EPSILON
      REAL(WP), INTENT(IN) :: X,Y
!      IF (ABS(Y) <= 1.1921E-7) THEN
       IF (ABS(Y) <= EPSILON(1.0_WP)) THEN
          SELECT = .TRUE.
      ELSE
         SELECT = .FALSE.
      ENDIF
   
    END FUNCTION SELECT

      PROGRAM LA_SSPSVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements"
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SPSVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, INFO, N, NN, NRHS
!  .. Local Arrays ..
      INTEGER, ALLOCATABLE :: IPIV(:)
      REAL(WP), ALLOCATABLE :: B(:,:), AP(:), X(:,:), AFP(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SSPSVX Example Program Results.'
      N = 5; NRHS = 3
      WRITE(*,'(5H N = , I4, 9H; NRHS = , I4)') N, NRHS
      NN = N*(N+1)/2
      ALLOCATE ( AP(NN), B(N,NRHS), X(N,NRHS), AFP(NN), IPIV(N) )
   
      OPEN(UNIT=21,FILE='spsv.ma',STATUS='UNKNOWN')
      DO I=1,NN 
            READ(21,'(F3.0)') AP(I)
         ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix AP :'
      DO I=1,NN; WRITE(*,"(15(I3,1X,1X),I3,1X))") INT(AP(I));
      ENDDO

      OPEN(UNIT=21,FILE='spsv.mb',STATUS='UNKNOWN')
      DO I=1,N 
         READ(21,'(F3.0)') B(I,1)
      ENDDO
      CLOSE(21)

      WRITE(*,*)"CALL LA_SPSVX( AP, B, X, 'L', AFP, IPIV, INFO=INFO)"
      CALL LA_SPSVX( AP, B, X, 'L', AFP, IPIV, INFO=INFO)

      WRITE(*,*)'AFP = '
      DO I=1,NN; WRITE(*,"(F8.5)") AFP(I);
      ENDDO
      WRITE(*,*)'IPIV = ', IPIV


      END PROGRAM LA_SSPSVX_EXAMPLE

PROGRAM LA_SGELSX_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GELSX, LA_GETRF
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.2))'
   CHARACTER(LEN=*), PARAMETER :: FMTI = '(10(1X,I4))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER  :: I, INFO, M, N, J, NRHS, RANK
   REAL(WP) :: RCOND
!  .. LOCAL ARRAYS ..
   INTEGER, ALLOCATABLE :: IPIV(:), JPVT(:)
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:)
   REAL(WP), ALLOCATABLE :: A(:, :), B(:,:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MIN, MAX
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'SGELSX Example Program Results'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) M, N, NRHS
   PRINT *, 'M = ', M, ' N = ', N, ' NRHS = ', NRHS
   ALLOCATE ( A(M,N), AA(M,N), B(MAX(1,M,N),NRHS), BB(MAX(1,M,N),NRHS), &
              IPIV(MIN(M,N)), JPVT(N) )
   DO I = 1, M; READ (NIN,*) AA(I,:); ENDDO
   DO J = 1, NRHS; BB(:,J) = SUM( AA, DIM=2)*J; ENDDO
   A = AA; B=BB
   WRITE(NOUT,*) 'The matrix A'
   DO I = 1, M; WRITE (NOUT,FMT) AA(I,:); ENDDO
   WRITE(NOUT,*) 'The RHS matrix B:'
   DO J = 1, NRHS; WRITE (NOUT,FMT) BB(:,J); ENDDO
!
   WRITE ( NOUT, * )'--------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_SGELSX LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GELSX (A, B, RANK, JPVT, RCOND, INFO)'
   A = AA; CALL LA_GETRF( A(1:MIN(M,N),1:MIN(M,N)), IPIV, RCOND )
   A = AA; B=BB; JPVT = 0
   CALL LA_GELSX (A, B, RANK, JPVT, RCOND, INFO)
   WRITE(NOUT,*)'RANK, RCOND, INFO ', RANK, RCOND, INFO
   WRITE(NOUT,*) 'B & JPVT'
   DO J = 1, NRHS; WRITE (NOUT,FMT) B(:,J); END DO
   WRITE(NOUT,FMTI) JPVT(:)
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GELSX (A, B(:,1), RANK, JPVT, RCOND, INFO)'
   A = AA; B=BB; RCOND = 0.0_WP; JPVT = 0; JPVT(4) = 1
   CALL LA_GELSX (A, B(:,1), RANK, JPVT, RCOND, INFO)
   WRITE(NOUT,*)'RANK, RCOND, INFO ', RANK, RCOND, INFO
   WRITE(NOUT,*) 'B & JPVT'
   WRITE (NOUT,FMT) B(:,1)
   WRITE(NOUT,FMTI) JPVT(:)
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GELSX (A, B, INFO=INFO)'
   A = AA; B=BB;
   CALL LA_GELSX (A, B, INFO=INFO)
   WRITE(NOUT,*)'INFO = ', INFO, ', B'
   DO J = 1, NRHS; WRITE (NOUT,FMT) B(:,J); END DO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GELSX (A, B(:,1), INFO=INFO)'
   A = AA; B=BB;
   CALL LA_GELSX (A, B(:,1), INFO=INFO)
   WRITE(NOUT,*)'INFO = ', INFO, ', B(:,1)'
   WRITE(NOUT,FMT) B(:,1)
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GELSX (A, B, RANK, INFO=INFO)'
   A = AA; B=BB;
   CALL LA_GELSX (A, B, RANK, INFO=INFO)
   WRITE(NOUT,*)'INFO = ', INFO, ' RANK = ', RANK, ', B'
   DO J = 1, NRHS; WRITE(NOUT,FMT) B(:,J); ENDDO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GELSX (A, B(:,1), RANK, JPVT, INFO=INFO)'
   A = AA; B=BB; JPVT = 0; JPVT(1) = 1
   CALL LA_GELSX (A, B(:,1), RANK, JPVT, INFO=INFO)
   WRITE(NOUT,*)'INFO = ', INFO, ' RANK = ', RANK, ', B(:,1) & JPVT'
   WRITE(NOUT,FMT) B(:,1)
   WRITE(NOUT,FMTI) JPVT(:)
!
   WRITE (NOUT,*)
   A = AA; CALL LA_GETRF( A(1:MIN(M,N),1:MIN(M,N)), IPIV, RCOND )
   WRITE (NOUT,*) 'CALL LA_GELSX (A, B, RCOND = RCOND, INFO=INFO)'
   A = AA; B=BB;
   CALL LA_GELSX (A, B, RCOND=RCOND, INFO=INFO)
   WRITE(NOUT,*)'INFO = ', INFO, ' RCOND = ', RCOND, ', B'
   DO J = 1, NRHS; WRITE(NOUT,FMT) B(:,J); ENDDO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GELSX (A, B(:,1), JPVT=JPVT(1:MAX(M,N)+1), INFO=INFO)'
   A = AA; B=BB; JPVT = 0
   CALL LA_GELSX (A, B(:,1), JPVT=JPVT(1:MAX(M,N)+1), INFO=INFO)
   WRITE(NOUT,*)'INFO = ', INFO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GELSX (A, B)'
   A = AA; B=BB;
   CALL LA_GELSX (A, B)
   WRITE(NOUT,*)'B'
   DO J = 1, NRHS; WRITE(NOUT,FMT) B(:,J); ENDDO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GELSX (A, B(:,1))'
   A = AA; B=BB;
   CALL LA_GELSX (A, B(:,1))
   WRITE(NOUT,*)'B(:,1)'
   WRITE(NOUT,FMT) B(:,1)
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GELSX (A, B(MIN(M,N),:), INFO=INFO)'
   A = AA; B=BB;
   CALL LA_GELSX (A, B(MIN(M,N),:), INFO=INFO)
   WRITE(NOUT,*)'INFO = ', INFO
!
   WRITE (NOUT,*)
   WRITE (NOUT,*) 'CALL LA_GELSX (A(1:N-1,:), B(:,1))'
   A = AA; B=BB;
   CALL LA_GELSX (A(1:N-1,:), B(:,1))
   WRITE(NOUT,*)'INFO = ', INFO
!
END!PROGRAM LA_SGELSX_EXAMPLE

PROGRAM LA_SSYEVX_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_SYEVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, INFO, M, N 
!  .. LOCAL ARRAYS ..
   INTEGER, ALLOCATABLE :: IFAIL(:) 
   REAL(WP), ALLOCATABLE :: AA(:,:), W(:)
   REAL(WP), ALLOCATABLE :: A(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE(NOUT,*) 'SSYEVX ET_Example Program Results.'
   READ(NIN,*) ! SKIP HEADING IN DATA FILE
   READ(NIN,*) N
   ALLOCATE ( A(N,N), AA(N,N), W(N), IFAIL(N) )
      DO I = 1, N
        READ(NIN,*) (AA(I, J), J = 1, N)
      ENDDO
   A=AA
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N
        WRITE(NOUT,FMT) A(I,:)
      ENDDO
!
   WRITE(NOUT,*) '---------------------------------------------------------'
   WRITE(NOUT,*)
   WRITE ( NOUT, * )'Details of LA_SSYEVX LAPACK Subroutine Results.'
   WRITE(NOUT,*)
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SYEVX(A, W, INFO=INFO)'
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVX(A,W,INFO=INFO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVX:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'INFO = ',INFO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVX(A, W, 'V', IFAIL=IFAIL)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVX(A,W,'V',IFAIL=IFAIL)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVX:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVX:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
   WRITE(NOUT,*) 'The values of the vector "IFAIL":'
   WRITE(NOUT,*) IFAIL(:)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVX(A, W, 'V', IFAIL=IFAIL, ABSTOL=0.01_WP)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   ABSTOL - the absolute error tolerance for the eigenvalues'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVX(A,W,'V',IFAIL=IFAIL, ABSTOL=0.01_WP)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVX:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVX:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
   WRITE(NOUT,*) 'The values of the vector "IFAIL":'
   WRITE(NOUT,*) IFAIL(:)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVX(A, W, 'V', 'L', IFAIL=IFAIL)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (lower triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVX(A,W, 'V', 'L', IFAIL=IFAIL)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVX:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVX:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
   WRITE(NOUT,*) 'The values of the vector "IFAIL":'
   WRITE(NOUT,*) IFAIL(:)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVX(A, W, UPLO='L')"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (lower triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVX(A,W,UPLO='L')
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVX:'
   WRITE(NOUT,FMT) W(:)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVX(A, W, JOBZ='V', IFAIL=IFAIL, INFO=INFO)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A - the original matrix (upper triangular)'
   WRITE(NOUT,*) 'ON EXIT: A, W, IFAIL'
   WRITE(NOUT,*) '   A   - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W   - the eigenvalues in ascending order'
   WRITE(NOUT,*) ' IFAIL - the indices of the failed eigenvectors'
   A=AA
   W=0
   IFAIL=0
   CALL LA_SYEVX(A, W, JOBZ='V', IFAIL=IFAIL, INFO=INFO)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVX:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVX:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
   WRITE(NOUT,*) 'The indices of the eigenvectors that failed to converge:'
   WRITE(NOUT,*) IFAIL(:)
   WRITE(NOUT,*) 'INFO = ',INFO
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVX(A, W, 'V', IL=2, IU=3, IFAIL=IFAIL)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A     - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   IL,IU - the indices of the smallest and largest'
   WRITE(NOUT,*) '           eigenvalues to be returned'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVX(A,W, 'V', IFAIL=IFAIL,IL=2,IU=3)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVX:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVX:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
   WRITE(NOUT,*) 'The values of the vector "IFAIL":'
   WRITE(NOUT,*) IFAIL(:)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVX(A, W, 'V', IFAIL=IFAIL, IL=2)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A     - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   IL,IU - the indices of the smallest and largest'
   WRITE(NOUT,*) '           eigenvalues to be returned (IU = N is assumed).'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - orthonormal eigenvectors of the matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   A=AA
   W=0
   CALL LA_SYEVX(A,W,'V', IFAIL=IFAIL,IL=2)
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVX:'
   WRITE(NOUT,FMT) W(:)
   WRITE(NOUT,*) 'The orthonormal eigenvectors computed by LA_SYEVX:'
   DO I = 1, N
      WRITE(NOUT,FMT) A(I,:)
   END DO
   WRITE(NOUT,*) 'The values of the vector "IFAIL":'
   WRITE(NOUT,*) IFAIL(:)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVX(A, W, VL=0.1_WP, VU=4.0_WP, M=M)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A     - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   VL,VU - the lower and upper bounds of the interval'
   WRITE(NOUT,*) '           to be searched for eigenvalues'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   WRITE(NOUT,*) '   M - the total number of eigenvalues found'
   A=AA
   W=0
   CALL LA_SYEVX(A,W,VL=0.1_WP,VU=4.0_WP,M=M)
   WRITE(NOUT,*) 'The total number of eigenvalues found = ',M
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVX:'
   WRITE(NOUT,FMT) W(:M)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_SYEVX(A, W, VU=4.0_WP, M=M)"
   WRITE(NOUT,*) 'ON ENTRY: A'
   WRITE(NOUT,*) '   A     - the original matrix (upper triangular)'
   WRITE(NOUT,*) '   VL,VU - the lower and upper bounds of the interval'
   WRITE(NOUT,*) '           to be searched for eigenvalues (VL = -infinity'
   WRITE(NOUT,*) '           is assumed)'
   WRITE(NOUT,*) 'ON EXIT: A, W'
   WRITE(NOUT,*) '   A - destroyed matrix A'
   WRITE(NOUT,*) '   W - the eigenvalues in ascending order'
   WRITE(NOUT,*) '   M - the total number of eigenvalues found'
   A=AA
   W=0
   CALL LA_SYEVX(A,W,VU=4.0_WP,M=M)
   WRITE(NOUT,*) 'The total number of eigenvalues found = ',M
   WRITE(NOUT,*) 'The eigenvalues computed by LA_SYEVX:'
   WRITE(NOUT,FMT) W(:M)
! 
END PROGRAM LA_SSYEVX_ET_EXAMPLE

SUBROUTINE LA_TEST_ZHPEV( JOBZ, UPLO, N, AP, W, Z, LDZ, WORK, RWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark; 
!     May 25, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_HPEV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDZ
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBZ, UPLO
!  .. Array Arguments ..
   COMPLEX(WP), INTENT(INOUT) :: AP(1:N*(N+1)/2)
   COMPLEX(WP), INTENT(OUT) :: WORK(1:MAX(1, 2*N-1)), Z(1:LDZ, 1:N)
   REAL(WP), INTENT(OUT) ::  W(1:N)
   REAL(WP) :: RWORK(1: MAX(1, 3*N-2))
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_HPEV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZHPEV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IAP, IW, IZ1, IZ2
   CHARACTER*1 :: IUPLO, IJOBZ
!  .. Local Arrays ..
   INTEGER, SAVE, POINTER :: IWORK(:)
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IAP = N*(N+1)/2; IUPLO = UPLO; IJOBZ = JOBZ; IW = N
   IZ1 = MAX(1,N); IZ2 = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE (1)
     IAP = IAP - 1
   CASE (2)
     IW = IW - 1
   CASE (3)
     IUPLO = 'T'
   CASE(4)
     IJOBZ = 'V'
     IZ2 = IZ2 - 1
   CASE(:-1,5:)
     CALL UESTOP(SRNAMT)
 END SELECT
 IF ( LSAME (IJOBZ,'V')) THEN
   CALL LA_HPEV( AP(1: IAP), W(1:IW), IUPLO, Z(1:IZ1, 1: IZ2), INFO)
 ELSE
   CALL LA_HPEV( AP(1: IAP), W(1:IW), IUPLO, INFO = INFO)
 ENDIF
 
 CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_ZHPEV

SUBROUTINE LA_TEST_DGESDD(JOBZ, M, N, A, LDA, S, U, LDU, VT, LDVT, WORK, LWORK, &
&   IWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 31, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GESDD
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: M, N, LDA, LDU, LDVT, LWORK
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBZ
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N)
   REAL(WP), INTENT(OUT):: WORK(1:LWORK), S(1: MIN(M,N))
   REAL(WP), INTENT(OUT) :: U(1: LDU, 1:N), VT(1: LDVT, 1:N)
   INTEGER :: IWORK(1: 8*MIN(M,N))
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GESDD'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DGESDD'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IS, IU1, IU2, IVT1, IVT2, ISTAT
   CHARACTER*1 IJOBZ, JOB
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
   REAL(WP), POINTER :: W1(:,:), W2(:,:)
!  .. Executable Statements ..
      IA1 = M; IA2 = N; IS = MIN(M,N); IU1 = M; IU2 = M
      IVT1 = N; IVT2 = N; IJOBZ=JOBZ
      I = INFO / 100; J = INFO - I*100
      IF (LSAME(JOBZ, 'S')) THEN
        IU2 = min(M,N)
        IVT2 = min(M,N)
      END IF
      SELECT CASE(I)
      CASE (2)
      IS = IS - 1
      JOB = 'N'
      CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), U(1:IU1, 1:IU2), &
     &  VT(1:IVT1, 1:IVT2), JOB=JOB, INFO=INFO)
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (3)
      IU1 = IU1 - 1
      JOB = 'N'
      CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), U(1:IU1, 1:IU2), &
     &  VT(1:IVT1, 1:IVT2), JOB=JOB, INFO=INFO)
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN 
      CASE (4)
      IVT2 = IVT2 - 1
      JOB = 'N'
      CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), U(1:IU1, 1:IU2), &
     &  VT(1:IVT1, 1:IVT2), JOB=JOB, INFO=INFO)
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (6)
      JOB = 'T'
      CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), U(1:IU1, 1:IU2), &
     &  VT(1:IVT1, 1:IVT2), JOB=JOB, INFO=INFO)
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN 
      CASE(:-1,1, 5, 7:)
      CALL UESTOP(SRNAMT)
      END SELECT


   SELECT CASE (JOBZ)
     CASE ('A')
       JOB = 'N'
       CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), U(1:IU1, 1:IU2), &
     &   VT(1:IVT1, 1:IVT2), JOB=JOB, INFO=INFO)
     CASE ('S')
       JOB = 'N'
       ALLOCATE (W1(M,M), W2(N,N), STAT=ISTAT)
       IF (ISTAT == 0) THEN
         CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), W1, &
     &     W2, JOB=JOB, INFO=INFO)
         U(1:M, 1:M) = W1(1:M, 1:M)
         VT(1:N, 1:N) = W2(1:N, 1:N)
         DEALLOCATE (W2, W1)
       ELSE
         INFO = -111
       ENDIF
       
     CASE ('O')
       IF (M .GE. N) THEN
         JOB = 'U'
         CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS),  &
     &     VT=VT(1:IVT1, 1:IVT2), JOB=JOB, INFO=INFO)
       ELSE
         JOB = 'V'
         CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), U(1:IU1, 1:IU2), &
     &     JOB=JOB, INFO=INFO)
       ENDIF
     CASE ('N')
       JOB = 'N'
       CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS),  &
&        JOB=JOB, INFO=INFO)
   END SELECT
   
!      IF (LSAME(IJOBZ, 'N')) THEN
!        CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), &
!     &    INFO=INFO)
!      ELSE
!        if (lsame (ijobz, 'a')) then
!         job = 'u'
!          CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), &
!     &      VT=VT(1: IVT1, 1: IVT2), INFO=INFO)
!        else
!         job = v
!          CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), u=U(1:IU1, 1:IU2), &
!     &      INFO=INFO)
!        endif
!      else if (lsame(ijobx,'s')) then
!          job = 'u'
!        CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), &
!     &    VT=VT(1: IVT1, 1: IVT2), INFO=INFO)
!      else
!          job = v
!        CALL LA_GESDD( A(1:IA1,1:IA2), S(1:IS), u=U(1:IU1, 1:IU2), &
!     &      INFO=INFO)
!      endif
!      ENDIF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_DGESDD
      

SUBROUTINE LA_TEST_CGGES(JOBVSL, JOBVSR, SORT, SELECT, N, A, LDA, B, LDB, SDIM, &
&   ALPHA, BETA, VSL, LDVSL, VSR, LDVSR, WORK, LWORK, RWORK, BWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     September 25, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GGES
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDA, LDB, LDVSL, LDVSR, LWORK
      INTEGER, INTENT(INOUT) :: INFO
      INTEGER, INTENT(OUT) :: SDIM
   CHARACTER*1, INTENT(IN) :: JOBVSL, JOBVSR, SORT
!  .. Array Arguments ..
   COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB, 1:N)
   COMPLEX(WP), INTENT(OUT):: WORK(1:LWORK)
      LOGICAL :: BWORK(1: N)
      REAL(WP) :: RWORK(1: 8*N)
   COMPLEX(WP), INTENT(OUT) :: ALPHA(1:N), BETA(1:N), &
&    VSL(1: LDVSL, 1:N), VSR(1: LDVSR, 1:N)

   INTERFACE
     LOGICAL FUNCTION SELECT(ALPHA, BETA)
     USE LA_PRECISION, ONLY: WP => SP
     COMPLEX(WP), INTENT(IN) :: ALPHA, BETA
   END FUNCTION SELECT
 END INTERFACE
 OPTIONAL :: SELECT 
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GGES '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_CGGES '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IALPHA, IBETA, IVSL1, &
     &  IVSL2, IVSR1, IVSR2
   CHARACTER*1 :: IJOBVSL, IJOBVSR
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IJOBVSL = JOBVSL; IJOBVSR = JOBVSR
   IB1 = N; IB2 = N; IALPHA = N; IBETA = N
   IVSL1 = N; IVSL2 = N; IVSR1 = N; IVSR2 = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
       IA2 = IA1 - 1
     CASE (2)
       IB1 = IA1 - 1
     CASE (3)
       IALPHA = IA1 - 1
     CASE (4)
       IBETA  = IA1 - 1
     CASE (5)
       IVSL1 = IA1 - 1; IJOBVSL = 'V';IJOBVSR = 'V'
         CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&          ALPHA=ALPHA(1: IALPHA),  &
&          BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&          VSR=VSR(1:IVSR1,1:IVSR2), SDIM=SDIM,& 
&          INFO=INFO)
         CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
         RETURN
       CASE (6)
         IVSR1 = IA1 - 1; IJOBVSL = 'V';IJOBVSR = 'V'
         CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&          ALPHA=ALPHA(1: IALPHA),  &
&          BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&          VSR=VSR(1:IVSR1,1:IVSR2),  SDIM=SDIM,&
&          INFO=INFO)
         CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
         RETURN         
       CASE(:-1,7:)
       CALL UESTOP(SRNAMT)
   END SELECT

   IF (LSAME(SORT, 'N')) THEN

     IF (LSAME(IJOBVSL,'V')) THEN
       IF (LSAME (IJOBVSR, 'V')) THEN
         CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &     ALPHA=ALPHA(1: IALPHA),  &
     &     BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
     &     VSR=VSR(1:IVSR1,1:IVSR2), SDIM=SDIM, &
     &     INFO=INFO)
       ELSE
         CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &     ALPHA=ALPHA(1: IALPHA), &
     &     BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2),& 
     &     SDIM=SDIM, INFO=INFO)    
       END IF
      ELSE 
        IF (LSAME (IJOBVSR, 'V')) THEN
          CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &      ALPHA=ALPHA(1: IALPHA),&
     &      BETA=BETA(1: IBETA), VSR = VSR(1:IVSR1,1:IVSR2), &
     &      SDIM=SDIM, INFO = INFO)
        ELSE
          CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &      ALPHA=ALPHA(1: IALPHA), &
     &      BETA=BETA(1: IBETA), SDIM=SDIM, INFO = INFO)
        END IF
      END IF
      ELSE
        IF (LSAME(IJOBVSL,'V')) THEN
          IF (LSAME (IJOBVSR, 'V')) THEN
            CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&             ALPHA(1: IALPHA), BETA(1: IBETA), &
&             VSL(1:IVSL1,1:IVSL2), VSR(1:IVSR1,1:IVSR2), &
&             SELECT, SDIM, INFO)    
          ELSE
            CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
     &        ALPHA(1:IALPHA), BETA(1: IBETA),&
&             VSL=VSL(1:IVSL1,1:IVSL2), SELECT=SELECT, &
&             SDIM=SDIM, INFO=INFO) 
          END IF
        ELSE 
          IF (LSAME (IJOBVSR, 'V')) THEN
            CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &         ALPHA(1:IALPHA), BETA(1: IBETA),&
&             VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&             INFO = INFO)
          ELSE
         CALL LA_GGES( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &     ALPHA(1:IALPHA), BETA(1: IBETA), SELECT=SELECT, SDIM=SDIM,&
     &     INFO = INFO)
       END IF
      END IF
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_CGGES

SUBROUTINE ZHPSVX_F95(A, B, X, UPLO, AFP, IPIV, FACT, &
                      FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: HPSVX_F77 => LA_HPSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO, FACT
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(IN) :: A(:), B(:,:)
   COMPLEX(WP), INTENT(OUT) :: X(:,:)
   INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: IPIV(:)
   COMPLEX(WP), INTENT(INOUT), OPTIONAL, TARGET :: AFP(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: FERR(:), BERR(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_SPSVX computes the solution to a linear system of equations
! A*X = B, where A is a real or complex symmetric matrix stored in packed
! format and X and B are rectangular matrices or vectors.
!    LA_HPSVX computes the solution to a linear system of equations 
! A*X = B, where A is a complex Hermitian matrix stored in packed format 
! and X and B are rectangular matrices or vectors.
!    LA_SPSVX and LA_HPSVX can also optionally estimate the condition 
! number of A and compute error bounds.
! 
! =========
! 
!       SUBROUTINE LA_SPSVX / LA_HPSVX( AP, B, X, UPLO=uplo, AFP=afp, &
!                         IPIV=ipiv, FACT=fact, FERR=ferr, BERR=berr, &
!                         RCOND=rcond, INFO=info )
!            <type>(<wp>), INTENT(IN) :: AP(:), <rhs>
!            <type>(<wp>), INTENT(OUT) :: <sol>
!            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!            <type>(<wp>), INTENT(INOUT), OPTIONAL :: AFP(:)
!            INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
!            CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
!            REAL(<wp>), INTENT(OUT), OPTIONAL :: <err>, RCOND
!            INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!            <type> ::= REAL | COMPLEX
!            <wp>   ::= KIND(1.0) | KIND(1.0D0)
!            <rhs>  ::= B(:,:) | B(:)
!            <sol>  ::= X(:,:) | X(:)
!            <err>  ::= FERR(:), BERR(:) | FERR, BERR
! 
! Arguments
! =========
! 
! AP       (input) REAL or COMPLEX array, shape (:) with size(AP ) = 
!          n*(n + 1)/2, where n is the order of A.
!          On entry, the upper or lower triangle of matrix A in packed 
! 	   storage. The elements are stored columnwise as follows:
!          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j<=n;
! 	   if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for 1<=j<=i<=n.
! B        (input) REAL or COMPLEX array, shape (:,:) with 
!          size(B,1) = n or shape (:) with size(B) = n.
!          The matrix B.
! X        (output) REAL or COMPLEX array, shape (:,:) with 
!          size(X,1) = n and size(X,2) = size(B,2), or shape (:) with 
! 	   size(X) = n.
!          The solution matrix X .
! UPLO     Optional (input) CHARACTER(LEN=1).
!            = 'U': Upper triangle of A is stored;
!            = 'L': Lower triangle of A is stored.
!          Default value: 'U'.
! AFP      Optional (input or output) REAL or COMPLEX array, shape (:,:)
!          with the same size as AP.
!          If FACT = 'F', then AFP is an input argument that contains 
! 	   the block diagonal matrix D and the multipliers used to 
! 	   obtain the factor L or U from the factorization of A, returned
! 	   by a previous call to LA_SPSVX or LA_HPSVX and stored as a 
! 	   packed triangular matrix in the same storage format as A.
!          If FACT = 'N', then AFP is an output argument that contains 
! 	   the block diagonal matrix D and the multipliers used to obtain
! 	   the factor L or U from the factorization of A, stored as a
!          packed triangular matrix in the same storage format as A.
! IPIV     Optional (input or output) INTEGER array, shape (:) with 
!          size(IPIV) = size(A,1).
!          If FACT = 'F', then IPIV is an input argument that contains 
! 	   details of the row and column interchanges and the block 
! 	   structure of D.
!          If IPIV(k) > 0 , then rows and columns k and IPIV(k) were 
! 	   interchanged and D(k,k) is a 1 by 1 diagonal block.
!          If IPIV(k) < 0 , then there are two cases:
!           1. If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0, then rows and
! 	     columns (k-1) and -IPIV(k) were interchanged and 
! 	     D(k-1:k,k-1:k) is a 2 by 2 diagonal block.
!           2. If UPLO = 'L' and IPIV(k) = IPIV(k+1) < 0, then rows and
! 	     columns (k+1) and -IPIV(k) were interchanged and 
! 	     D(k:k+1,k:k+1) is a 2 by 2 diagonal block.
!          If FACT = 'N', then IPIV is an output argument and on exit 
! 	   contains details of the interchanges and the block structure
! 	   of D (as described above).
! FACT     Optional (input) CHARACTER(LEN=1).
!          Specifies whether the factored form of A has been supplied 
! 	   on entry.
!            = 'N': The matrix A will be copied to AFP and factored.
!            = 'F': AFP and IPIV contain the factored form of A.
!          Default value: 'N'.
! FERR     Optional (output) REAL array of shape (:), with size(FERR)=
!          size(X,2), or REAL scalar.
!          The estimated forward error bound for each solution vector 
! 	   X(j) (the j-th column of the solution matrix X). If XTRUE is
! 	   the true solution corresponding to X(j) , FERR(j) is an
!          estimated upper bound for the magnitude of the largest element
! 	   in (X(j)-XTRUE) divided by the magnitude of the largest 
! 	   element in X(j). The estimate is as reliable as the estimate
!          for RCOND, and is almost always a slight overestimate of the 
! 	   true error.
! BERR     Optional (output) REAL array of shape (:), with size(BERR) =
!          size(X,2), or REAL scalar.
!          The componentwise relative backward error of each solution 
! 	   vector X(j) (i.e., the smallest relative change in any element
! 	   of A or B that makes X(j) an exact solution).
! RCOND    Optional (output) REAL
!          The estimate of the reciprocal condition number of A. If RCOND
! 	   is less than the machine precision, the matrix is singular to
! 	   working precision. This condition is indicated by a return
!          code of INFO > 0.
! INFO     (output) INTEGER
!          = 0: successful exit.
!          < 0: if INFO = -i, the i-th argument had an illegal value.
!          > 0: if INFO = i, and i is
!             <= n: D(i,i) = 0. The factorization has been completed, but
! 	         the block diagonal matrix D is singular, so the 
! 		 solution could not be computed.
!             = n+1: D is nonsingular, but RCOND is less than machine 
! 	         precision, so the matrix is singular to working 
! 		 precision. Nevertheless, the solution and error bounds
! 		 are computed because the computed solution can be more
! 		 accurate than the value of RCOND would suggest.
!            n is the order of A.
!          If INFO is not present and an error occurs, then the program
! 	   is terminated with an error message.
!----------------------------------------------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_HPSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LUPLO
   INTEGER :: LINFO, NRHS, N, NN, ISTAT, ISTAT1, SIPIV, SAF, SFERR, SBERR
   REAL(WP) :: LRCOND
   COMPLEX(WP) :: WW
!  .. LOCAL POINTERS ..
   INTEGER, POINTER :: LPIV(:)
   REAL(WP),  POINTER :: RWORK(:), LFERR(:), LBERR(:)
   COMPLEX(WP),  POINTER :: WORK(:), LAF(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; NN = SIZE(A); NRHS = SIZE(B, 2)
   WW = (-1+SQRT(1+8*REAL(NN,WP)))*0.5; N = INT(WW)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
   IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; END IF
   IF( PRESENT(AFP) )THEN; SAF = SIZE(AFP); ELSE; SAF = NN; END IF
   IF( PRESENT(FERR) )THEN; SFERR = SIZE(FERR); ELSE; SFERR = NRHS; END IF
   IF( PRESENT(BERR) )THEN; SBERR = SIZE(BERR); ELSE; SBERR = NRHS; END IF
!  .. TEST THE ARGUMENTS
    IF( NN < 0 .OR. AIMAG(WW) /= 0 .OR. REAL(N,WP) /= REAL(WW) ) THEN; LINFO = -1
   ELSE IF( SIZE(B, 1) /= N .OR. NRHS < 0 )THEN; LINFO = -2
   ELSE IF( SIZE(X, 1) /= N .OR. SIZE(X, 2) /= NRHS )THEN; LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
   ELSE IF( SAF /= NN ) THEN; LINFO = -5
   ELSE IF( SIPIV /= N )THEN; LINFO = -6
   ELSE IF( ( .NOT. LSAME(LFACT,'F') .AND. .NOT. LSAME(LFACT,'N') ) .OR. &
     ( LSAME(LFACT,'F') .AND. .NOT.( PRESENT(AFP) .AND. PRESENT(IPIV) ) ) )THEN; LINFO = -7
   ELSE IF( SFERR /= NRHS )THEN; LINFO = -8
   ELSE IF( SBERR /= NRHS )THEN; LINFO = -9
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(AFP) ) THEN; ALLOCATE( LAF(NN), STAT=ISTAT )
      ELSE; LAF => AFP; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(IPIV) )THEN; ALLOCATE( LPIV(N), STAT=ISTAT )
         ELSE; LPIV => IPIV; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(FERR) )THEN; ALLOCATE( LFERR(NRHS), STAT=ISTAT )
         ELSE; LFERR => FERR; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(BERR) )THEN; ALLOCATE( LBERR(NRHS), STAT=ISTAT )
         ELSE; LBERR => BERR; END IF
      END IF
      IF( ISTAT == 0 )THEN
         ALLOCATE(WORK(MAX(1,2*N)), RWORK(N), STAT=ISTAT)
      END IF
      IF( ISTAT == 0 )THEN
!        .. CALL LAPACK77 ROUTINE
         CALL HPSVX_F77( LFACT, LUPLO, N, NRHS, A, LAF, LPIV, B, N, X, N, &
                         LRCOND, LFERR, LBERR, WORK, RWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(AFP) ) DEALLOCATE( LAF, STAT=ISTAT1 )
      IF( .NOT.PRESENT(IPIV) ) DEALLOCATE( LPIV, STAT=ISTAT1 )
      IF( .NOT.PRESENT(FERR) ) DEALLOCATE( LFERR, STAT=ISTAT1 )
      IF( .NOT.PRESENT(BERR) ) DEALLOCATE( LBERR, STAT=ISTAT1 )
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      DEALLOCATE( WORK, RWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE ZHPSVX_F95

SUBROUTINE LA_TEST_ZGGESX(JOBVSL, JOBVSR, SORT, SELECT, SENSE, N, A, LDA, B, LDB, SDIM, &
     &  ALPHA, BETA, VSL, LDVSL, VSR, LDVSR, RCONDE, RCONDV, WORK, LWORK, RWORK, IWORK, &
     &  LIWORK,  BWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     September 25, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => DP
      USE F95_LAPACK, ONLY: LA_GGESX
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, LDA, LDB, LDVSL, LDVSR, LWORK, LIWORK
      INTEGER, INTENT(INOUT) :: INFO
      INTEGER, INTENT(OUT) :: SDIM
      CHARACTER*1, INTENT(IN) :: JOBVSL, JOBVSR, SORT, SENSE
      REAL(WP), INTENT(OUT) :: RCONDE(1:2), RCONDV(1:2) 
!  .. Array Arguments ..
      COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB, 1:N)
      COMPLEX(WP), INTENT(OUT):: WORK(1:LWORK)
      LOGICAL :: BWORK(1: N)
      REAL(WP), INTENT(OUT) :: RWORK(1: 8*N)
      INTEGER :: IWORK (1: LIWORK)
      COMPLEX(WP), INTENT(OUT) :: ALPHA(1:N), BETA(1:N), &
     &  VSL(1: LDVSL, 1:N), VSR(1: LDVSR, 1:N)
      INTERFACE
      LOGICAL FUNCTION SELECT(ALPHA, BETA)
      USE LA_PRECISION, ONLY: WP => DP
      COMPLEX(WP), INTENT(IN) :: ALPHA, BETA
      END FUNCTION SELECT
      END INTERFACE
      OPTIONAL :: SELECT
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GGESX'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZGGESX'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IALPHA, IBETA, IVSL1, &
     &  IVSL2, IVSR1, IVSR2
   CHARACTER*1 :: IJOBVSL, IJOBVSR
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IJOBVSL = JOBVSL; IJOBVSR = JOBVSR
   IB1 = N; IB2 = N; IALPHA = N; IBETA = N
   IVSL1 = N; IVSL2 = N; IVSR1 = N; IVSR2 = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
       IA2 = IA1 - 1
     CASE (2)
       IB1 = IA1 - 1
      CASE (3)
       IALPHA = IA1 - 1
       CASE (4)
       IBETA  = IA1 - 1
       CASE (5)
       IVSL1 = IA1 - 1
       CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &   ALPHA=ALPHA(1: IALPHA),  &
     &   BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
     &   VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
     &   RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO)
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN
       CASE (6)
       IVSR1 = IA1 - 1 
       CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
     &   ALPHA=ALPHA(1: IALPHA),  &
     &   BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
     &   VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
     &   RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO) 
       CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
       RETURN
       CASE(:-1, 7:)
       CALL UESTOP(SRNAMT)
      END SELECT
      
      IF (LSAME(SENSE,'B')) THEN
        IF (LSAME(SORT, 'N')) THEN
          IF (LSAME(IJOBVSL,'V')) THEN
            IF (LSAME (IJOBVSR, 'V')) THEN
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&               ALPHA=ALPHA(1: IALPHA),  &
&               BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&               VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&               RCONDE=RCONDE, RCONDV=RCONDV, INFO=INFO)
            ELSE
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&               ALPHA=ALPHA(1: IALPHA),  &
&               BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2),  SELECT=SELECT, & 
&               SDIM=SDIM, RCONDE=RCONDE, RCONDV=RCONDV,INFO=INFO)    
            END IF
          ELSE 
            IF (LSAME (IJOBVSR, 'V')) THEN
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&               ALPHA=ALPHA(1: IALPHA),  &
&               BETA=BETA(1: IBETA), VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, &
&               SDIM=SDIM, RCONDE=RCONDE, RCONDV=RCONDV,INFO = INFO)
            ELSE
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&               ALPHA=ALPHA(1: IALPHA),  &
&               BETA=BETA(1: IBETA), SELECT=SELECT, SDIM=SDIM, RCONDE=RCONDE, &
&               RCONDV=RCONDV,INFO = INFO)
            END IF
          END IF
        ELSE
          IF (LSAME(IJOBVSL,'V')) THEN
            IF (LSAME (IJOBVSR, 'V')) THEN
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&               ALPHA(1: IALPHA),  BETA(1: IBETA), &
&               VSL(1:IVSL1,1:IVSL2), VSR(1:IVSR1,1:IVSR2),  SELECT, SDIM,&
&               RCONDE, RCONDV,INFO)    
            ELSE
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&               ALPHA(1: IALPHA),  BETA(1: IBETA),&
&               VSL(1:IVSL1,1:IVSL2), SELECT=SELECT,  SDIM=SDIM, &
&               RCONDE=RCONDE, RCONDV=RCONDV,INFO=INFO) 
            END IF
          ELSE 
            IF (LSAME (IJOBVSR, 'V')) THEN
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&               ALPHA(1: IALPHA),  BETA(1: IBETA),&
&               VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&               RCONDE=RCONDE, RCONDV=RCONDV, &
&               INFO = INFO)
            ELSE
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&               ALPHA(1: IALPHA),  BETA(1: IBETA), &
&               SELECT=SELECT,  SDIM=SDIM, RCONDE=RCONDE, &
&               RCONDV=RCONDV,INFO = INFO)
            END IF
          END IF
        END IF
      ELSE IF (LSAME (SENSE,'V')) THEN
        IF (LSAME(SORT, 'N')) THEN
          IF (LSAME(IJOBVSL,'V')) THEN
            IF (LSAME (IJOBVSR, 'V')) THEN
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&               ALPHA=ALPHA(1: IALPHA),  &
&               BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&               VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&               RCONDV=RCONDV, INFO=INFO)
            ELSE
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&               ALPHA=ALPHA(1: IALPHA),  &
&               BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2),  SELECT=SELECT, & 
&               SDIM=SDIM,  RCONDV=RCONDV,INFO=INFO)    
            END IF
          ELSE 
            IF (LSAME (IJOBVSR, 'V')) THEN
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&               ALPHA=ALPHA(1: IALPHA),  &
&               BETA=BETA(1: IBETA), VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, &
&               SDIM=SDIM, RCONDV=RCONDV,INFO = INFO)
            ELSE
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&               ALPHA=ALPHA(1: IALPHA),  &
&               BETA=BETA(1: IBETA), SELECT=SELECT, SDIM=SDIM, &
&               RCONDV=RCONDV,INFO = INFO)
            END IF
          END IF
        ELSE
          IF (LSAME(IJOBVSL,'V')) THEN
            IF (LSAME (IJOBVSR, 'V')) THEN
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&               ALPHA(1: IALPHA),  BETA(1: IBETA), &
&               VSL(1:IVSL1,1:IVSL2), VSR(1:IVSR1,1:IVSR2),  SELECT, SDIM,&
&               RCONDV=RCONDV, INFO=INFO)    
            ELSE
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&               ALPHA(1: IALPHA),  BETA(1: IBETA),&
&               VSL(1:IVSL1,1:IVSL2), SELECT=SELECT,  SDIM=SDIM, &
&               RCONDV=RCONDV,INFO=INFO) 
            END IF
          ELSE 
            IF (LSAME (IJOBVSR, 'V')) THEN
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&               ALPHA(1: IALPHA),  BETA(1: IBETA),&
&               VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&               RCONDV=RCONDV, &
&               INFO = INFO)
            ELSE
              CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&               ALPHA(1: IALPHA),  BETA(1: IBETA), &
&               SELECT=SELECT,  SDIM=SDIM, &
&               RCONDV=RCONDV,INFO = INFO)
            END IF
          END IF
        END IF
      ELSE
        IF (LSAME (SENSE, 'E')) THEN
          IF (LSAME(SORT, 'N')) THEN
            IF (LSAME(IJOBVSL,'V')) THEN
              IF (LSAME (IJOBVSR, 'V')) THEN
                CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&                 ALPHA=ALPHA(1: IALPHA),  &
&                 BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&                 VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, INFO=INFO)
              ELSE
                CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&                 ALPHA=ALPHA(1: IALPHA),  &
&                 BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2),  SELECT=SELECT, & 
&                 SDIM=SDIM, RCONDE=RCONDE, INFO=INFO)    
              END IF
            ELSE 
              IF (LSAME (IJOBVSR, 'V')) THEN
                CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&                 ALPHA=ALPHA(1: IALPHA),  &
&                 BETA=BETA(1: IBETA), VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, &
&                 SDIM=SDIM, RCONDE=RCONDE, INFO = INFO)
              ELSE
                CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&                 ALPHA=ALPHA(1: IALPHA),  &
&                 BETA=BETA(1: IBETA), SELECT=SELECT, SDIM=SDIM, RCONDE=RCONDE, &
&                 INFO = INFO)
              END IF
            END IF
          ELSE
            IF (LSAME(IJOBVSL,'V')) THEN
              IF (LSAME (IJOBVSR, 'V')) THEN
                CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&                 ALPHA(1: IALPHA),  BETA(1: IBETA), &
&                 VSL(1:IVSL1,1:IVSL2), VSR(1:IVSR1,1:IVSR2),  SELECT, SDIM,&
&                 RCONDE, INFO = INFO)    
              ELSE
                CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&                 ALPHA(1: IALPHA),  BETA(1: IBETA),&
&                 VSL(1:IVSL1,1:IVSL2), SELECT=SELECT,  SDIM=SDIM, &
&                 RCONDE=RCONDE, INFO=INFO) 
              END IF
            ELSE 
              IF (LSAME (IJOBVSR, 'V')) THEN
                CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&                 ALPHA(1: IALPHA),  BETA(1: IBETA),&
&                 VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&                 RCONDE=RCONDE, &
&                 INFO = INFO)
              ELSE
                CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&                 ALPHA(1: IALPHA),  BETA(1: IBETA), &
&                 SELECT=SELECT,  SDIM=SDIM, RCONDE=RCONDE, &
&                 INFO = INFO)
              END IF
            END IF
          END IF
        ELSE
            IF (LSAME(SORT, 'N')) THEN
              IF (LSAME(IJOBVSL,'V')) THEN
                IF (LSAME (IJOBVSR, 'V')) THEN
                  CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&                   ALPHA=ALPHA(1: IALPHA),  &
&                   BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2), &
&                   VSR=VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&                   INFO=INFO)
                ELSE
                  CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&                   ALPHA=ALPHA(1: IALPHA),  &
&                   BETA=BETA(1: IBETA), VSL=VSL(1:IVSL1,1:IVSL2),  SELECT=SELECT, & 
&                   SDIM=SDIM, INFO=INFO)    
                END IF
              ELSE 
                IF (LSAME (IJOBVSR, 'V')) THEN
                  CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&                   ALPHA=ALPHA(1: IALPHA),  &
&                   BETA=BETA(1: IBETA), VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, &
&                   SDIM=SDIM, INFO = INFO)
                ELSE
                  CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&                   ALPHA=ALPHA(1: IALPHA),  &
&                   BETA=BETA(1: IBETA), SELECT=SELECT, SDIM=SDIM, INFO = INFO)
                END IF
              END IF
            ELSE
              IF (LSAME(IJOBVSL,'V')) THEN
                IF (LSAME (IJOBVSR, 'V')) THEN
                  CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&                   ALPHA(1: IALPHA),  BETA(1: IBETA), &
&                   VSL(1:IVSL1,1:IVSL2), VSR(1:IVSR1,1:IVSR2),  SELECT, SDIM,&
&                   INFO = INFO)    
                ELSE
                  CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&                   ALPHA(1: IALPHA),  BETA(1: IBETA),&
&                   VSL(1:IVSL1,1:IVSL2), SELECT=SELECT,  SDIM=SDIM, &
&                   INFO=INFO) 
                END IF
              ELSE 
                IF (LSAME (IJOBVSR, 'V')) THEN
                  CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), &
&                   ALPHA(1: IALPHA),  BETA(1: IBETA),&
&                   VSR = VSR(1:IVSR1,1:IVSR2), SELECT=SELECT, SDIM=SDIM, &
&                   INFO = INFO)
                ELSE
                  CALL LA_GGESX( A(1:IA1,1:IA2), B(1:IB1, 1:IB2),&
&                   ALPHA(1: IALPHA),  BETA(1: IBETA), &
&                   SELECT=SELECT,  SDIM=SDIM, INFO = INFO)
                END IF
              END IF
            END IF
          ENDIF
        ENDIF
        CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_ZGGESX

      

 SUBROUTINE SSYSV_F95( A, B, UPLO, IPIV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => SP
    USE LA_AUXMOD, ONLY: ERINFO, LSAME
    USE F77_LAPACK, ONLY: SYSV_F77 => LA_SYSV, ILAENV_F77 => ILAENV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IPIV(:)
    REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_SYSV computes the solution to a linear system of equations
! A*X = B, where A is a real or complex symmetric matrix and X and B are
! rectangular matrices or vectors. A diagonal pivoting method is used to
! factor A as
!      A = U*D*U^T if UPLO = 'U', or A = L*D*L^T if UPLO = 'L'
! where U (or L) is a product of permutation and unit upper (or lower)
! triangular matrices, and D is a symmetric block diagonal matrix with 
! 1 by 1 and 2 by 2 diagonal blocks. The factored form of A is then used
! to solve the above system.
!    LA_HESV computes the solution to a linear system of equations 
! A*X = B, where A is a complex Hermitian matrix and X and B are 
! rectangular matrices or vectors. A diagonal pivoting method is used to
! factor A as
!      A = U*D*U^H if UPLO = 'U', or A = L*D*L^H if UPLO = 'L'
! where U (or L) is a product of permutation and unit upper (or lower)
! triangular matrices, and D is a complex Hermitian block diagonal
! matrix with 1 by 1 and 2 by 2 diagonal blocks. The factored form of A
! is then used to solve the above system.
! 
! =========
! 
!          SUBROUTINE LA_SYSV / LA_HESV( A, B, UPLO=uplo, &
! 	                            IPIV=ipiv, INFO=info )
!                <type>(<wp>), INTENT(INOUT) :: A(:,:), <rhs>
!                CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!                INTEGER, INTENT(OUT), OPTIONAL :: IPIV(:)
!                INTEGER, INTENT(OUT), OPTIONAL :: INFO
!          where
!                <type> ::= REAL | COMPLEX
!                <wp>   ::= KIND(1.0) | KIND(1.0D0)
!                <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! A      (input/output) REAL or COMPLEX square array, shape (:,:).
!        On entry, the matrix A.
!        If UPLO = 'U', the upper triangular part of A contains the upper
!        triangular part of the matrix A, and the strictly lower 
!        triangular part of A is not referenced.
!        If UPLO = 'L', the lower triangular part of A contains the lower 
!        triangular part of the matrix A, and the strictly upper 
!        triangular part of A is not referenced.
!        On exit, the block diagonal matrix D and the multipliers used to
!        obtain the factor U or L from the factorization of A.
! B      (input/output) REAL or COMPLEX array, shape (:,:) with 
!        size(B,1) = size(A,1) or shape (:) with size(B) = size(A,1).
!        On entry, the matrix B.
!        On exit, the solution matrix X.
! UPLO   Optional (input) CHARACTER(LEN=1)
!          = 'U': Upper triangle of A is stored;
!          = 'L': Lower triangle of A is stored.
!        Default value: 'U'.
! IPIV   Optional (output) INTEGER array, shape (:) with size(IPIV) = 
!        size(A,1).
!        Details of the row and column interchanges and the block 
!        structure of D.
!        If IPIV(k) > 0, then rows and columns k and IPIV(k) were
!        interchanged, and D(k,k) is a 1 by 1 diagonal block.
!        If IPIV k < 0, then there are two cases:
!         1. If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0, then rows and 
! 	   columns (k-1) and -IPIV(k) were interchanged and 
! 	   D(k-1:k,k-1:k) is a 2 by 2 diagonal block.
!         2. If UPLO = 'L' and IPIV(k) = IPIV(k+1) < 0, then rows and
! 	   columns (k + 1) and -IPIV(k) were interchanged and 
! 	   D(k:k+1,k:k+1) is a 2 by 2 diagonal block.
! INFO   Optional (output) INTEGER
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value.
!        > 0: if INFO = i, D(i,i) = 0. The factorization has been 
!             completed, but the block diagonal matrix D is singular, so
! 	    the solution could not be computed.
!        If INFO is not present and an error occurs, then the program is
!        terminated with an error message.
!-----------------------------------------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_SYSV'
    CHARACTER(LEN=6), PARAMETER :: BSNAME = 'SSYTRF'
!   .. LOCAL SCALARS ..
    CHARACTER(LEN=1) :: LUPLO
    INTEGER :: LINFO, ISTAT, ISTAT1, SIPIV, N, NRHS, LWORK, NB
!   .. LOCAL POINTERS ..
    INTEGER, POINTER :: LPIV(:)
    REAL(WP), POINTER :: WORK(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; N = SIZE(A,1); NRHS = SIZE(B,2)
    IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
    IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = SIZE(A,1); END IF
!   .. TEST THE ARGUMENTS
    IF( SIZE( A, 2 ) /= N .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B, 1 ) /= N .OR. NRHS < 0 ) THEN; LINFO = -2
    ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
    ELSE IF( SIPIV /= N )THEN; LINFO = -4
    ELSE IF ( N > 0 ) THEN
!  .. DETERMINE THE WORKSPACE
      IF( PRESENT(IPIV) )THEN; LPIV => IPIV
      ELSE; ALLOCATE( LPIV(N), STAT = ISTAT ); END IF
      IF( ISTAT == 0 )THEN
         NB = ILAENV_F77( 1, BSNAME, LUPLO, N, -1, -1, -1 )
         IF( NB <= 1 .OR. NB >= N ) NB = 1; LWORK = N*NB
         ALLOCATE(WORK(LWORK), STAT=ISTAT)
         IF( ISTAT /= 0 )THEN
            DEALLOCATE(WORK, STAT=ISTAT1); LWORK = 3*N
            ALLOCATE(WORK(LWORK), STAT=ISTAT)
            IF( ISTAT /= 0 ) THEN; LINFO = - 100
            ELSE; CALL ERINFO( -200, SRNAME, LINFO ); ENDIF
         ENDIF
         IF ( ISTAT == 0 ) &
!           .. CALL LAPACK77 ROUTINE
            CALL SYSV_F77( LUPLO, N, NRHS, A, N, LPIV, B, N, WORK, LWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(IPIV) )DEALLOCATE(LPIV, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE SSYSV_F95

SUBROUTINE LA_TEST_SGBSVX( FACT, TRANS, N, KL, KU, NRHS, AB, LDAB, AFB,&
     &  LDAFB, IPIV, EQUED, R, C, B, LDB, X, LDX, RCOND, FERR, BERR, &
     &  WORK, IWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 0.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September 29, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE LA_AUXMOD, ONLY: ERINFO
      USE F95_LAPACK, ONLY: LA_GBSVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      CHARACTER(LEN=1), INTENT(INOUT) :: EQUED
      CHARACTER(LEN=1), INTENT(IN) :: FACT, TRANS
      INTEGER, INTENT(IN) :: N, KL, KU, NRHS, LDAB, LDB, LDAFB, LDX
      INTEGER, INTENT(INOUT) :: INFO
      REAL(WP), INTENT(OUT) :: RCOND
!  .. Array Arguments ..
      INTEGER, INTENT(INOUT) :: IPIV(1:N), IWORK(*)
      REAL(WP), INTENT(INOUT) :: AB(1:LDAB,1:N), AFB(1:LDAFB,1:N), &
     &  B(1:LDB,1:N), BERR(1:NRHS), FERR(1:NRHS), WORK(*), &
     &  X(1:LDX,1:NRHS), R(1:N), C(1:N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GBSVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGBSVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      CHARACTER(LEN=1) :: IFACT, ITRANS, IEQUED
      INTEGER :: I, J, IAB1, IAB2, IB1, IB2, IX1, IX2, IAFB1, IAFB2, IIPIV, &
     &  IR, IC, IFERR, IBERR, IKL, IKU
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..

      IAB1 = KL+KU+1; IAB2 = N
      IB1 = N; IB2 = NRHS; IX1 = N; IX2 = NRHS
      IAFB1 =  2*KL+KU+1; IAFB2 = N; IIPIV = N; IFACT = FACT; ITRANS = TRANS
      IEQUED = EQUED; IR = N; IC = N; IFERR = NRHS; IBERR = NRHS
      IKL = KL; IKU = KU
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
        CASE(0)
          IF (NRHS == 1) THEN
            CALL LA_GBSVX( AB(1:IAB1,1:IAB2), B(1:IB1,1), X(1:IX1,1), KL, &
            AFB(1:IAFB1,1:IAFB2), IPIV(1:IIPIV), IFACT, ITRANS, EQUED, &
            R(1:IR), C(1:IC), FERR(1), BERR(1), RCOND, WORK(1) )
            INFO = INFOTC 
          ELSE
            CALL LA_GBSVX( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
            KL, AFB(1:IAFB1,1:IAFB2), IPIV(1:IIPIV), IFACT, ITRANS, EQUED, &
            R(1:IR), C(1:IC), FERR(1:IFERR), BERR(1:IBERR), RCOND, &
            WORK(1) )
            INFO = INFOTC  
          ENDIF
        CASE (1)
          IAB2 = 0
        CASE (2)
          IB1 = IAB2-1
        CASE (3)
    I3:   SELECT CASE(J)
            CASE(1)
              IX1 = IAB2-1
            CASE (2)
              IX2 = IB2-1
            CASE (3:)
              CALL UESTOP(SRNAMT)
          END SELECT I3
        CASE (4)
    I4:   SELECT CASE(J)
            CASE (1)
              IKL = - 1
            CASE (2)
              IKL = - 1
            CASE (3:)
              CALL UESTOP(SRNAMT)
          END SELECT I4
        CASE (5)
    I5:   SELECT CASE(J)
            CASE(1)
              iafb1 = iab1-1
            CASE (2)
              IAFB2 = iab2-1
            CASE (3:)
              CALL UESTOP(SRNAMT)
          END SELECT I5
        CASE (6)
          IIPIV = IAB2-1
        CASE (7)
    I7:   SELECT CASE(J)
            CASE(1)
              IFACT = 'T'
            CASE (2)
              SELECT CASE(NRHS)
                CASE (2:)
                  CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                  KL, AFB(1:IAFB1,1:IAFB2), FACT='F', INFO = INFO)
                CASE (1)
                  CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1), X(1:IX1,1), &
                  KL, AFB(1:IAFB1,1:IAFB2), FACT='F', INFO=INFO)
                CASE DEFAULT
                  CALL UESTOP(SRNAMT)
              END SELECT
            CASE (3)
              SELECT CASE(NRHS)
                CASE (2:)
                  CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                  KL, IPIV=IPIV(1:IIPIV), FACT='F', INFO=INFO)
                CASE (1)
                  CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1), X(1:IX1,1), &
                  KL, IPIV=IPIV(1:IIPIV), FACT='F', INFO=INFO)
                CASE DEFAULT
                  CALL UESTOP(SRNAMT)
              END SELECT
            CASE (4)
              SELECT CASE(NRHS)
                CASE (2:)
                  CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                  KL, FACT='F', INFO=INFO)
                CASE (1)
                  CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1), X(1:IX1,1), &
                  KL, FACT='F', INFO=INFO)
                CASE DEFAULT
                  CALL UESTOP(SRNAMT)
              END SELECT
            CASE (5:)
              CALL UESTOP(SRNAMT)
          END SELECT I7

        CASE (8)
          ITRANS = 'x'; IFACT = 'N'; IEQUED = 'N'
        CASE (9)
          IFACT = 'F'; ITRANS = 'N'
        I9:   SELECT CASE (J)
                CASE (1)
                  IEQUED = 'T'
                CASE (2)
                  IEQUED = 'R'
                  SELECT CASE (NRHS)
                    CASE (2:)
                      CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                      KL, AFB(1:IAFB1,1:IAFB2), IPIV(1:IIPIV), IFACT, ITRANS, IEQUED, &
                      INFO=INFO)
                    CASE (1)
                      CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1), X(1:IX1,1), &
                      AFB=AFB(1:IAFB1,1:IAFB2), IPIV=IPIV(1:IIPIV), FACT=IFACT, &
&                       TRANS=ITRANS, EQUED=IEQUED, &
                      INFO=INFO)
                    CASE DEFAULT
                      CALL UESTOP(SRNAMT)
                  END SELECT
                CASE (3)
                  IEQUED = 'B'
                  SELECT CASE (NRHS)
                    CASE (2:)
                      CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                      AFB=AFB(1:IAFB1,1:IAFB2), IPIV=IPIV(1:IIPIV), FACT=IFACT, &
&                       TRANS=ITRANS, EQUED=IEQUED, &
                      INFO=INFO)
                    CASE (1)
                      CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1), X(1:IX1,1), &
                      AFB=AFB(1:IAFB1,1:IAFB2), IPIV=IPIV(1:IIPIV), FACT=IFACT, &
&                       TRANS=ITRANS, EQUED=IEQUED, &
                      INFO=INFO)
                    CASE DEFAULT
                      CALL UESTOP(SRNAMT)
                  END SELECT
                CASE (4)
                  IEQUED = 'C'
                  SELECT CASE (NRHS)
                    CASE (2:)
                      CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                      AFB=AFB(1:IAFB1,1:IAFB2), IPIV=IPIV(1:IIPIV), FACT=IFACT, &
&                       TRANS=ITRANS, EQUED=IEQUED, &
                      INFO=INFO)
                    CASE (1)
                      CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1), X(1:IX1,1), &
                      AFB=AFB(1:IAFB1,1:IAFB2), IPIV=IPIV(1:IIPIV), FACT=IFACT, &
&                       TRANS=ITRANS, EQUED=IEQUED, &
                      INFO=INFO)
                    CASE DEFAULT
                      CALL UESTOP(SRNAMT)
                  END SELECT
                CASE (5:)
                  CALL UESTOP(SRNAMT)
              END SELECT I9
            CASE (10)
              IFACT = 'F'; R(1) = -1.0_WP; C = +1.0_WP
              I10:   SELECT CASE (J)
                       CASE(1)
                         IR = IAB2-1
                       CASE(2)
                         IEQUED = 'R'
                       CASE(3)
                         IEQUED = 'B'
                       CASE (4:)
                         CALL UESTOP(SRNAMT)
                     END SELECT I10
                     
            CASE (11)
              IFACT = 'F'; R = +1.0_WP; C(1) = -1.0_WP
              I11:  SELECT CASE (J)
                      CASE(1)
                        IC = IAB2-1
                      CASE(2)
                        IEQUED = 'C'
                      CASE(3)
                        IEQUED = 'B'
                      CASE (4:)
                        CALL UESTOP(SRNAMT)
                    END SELECT I11
            CASE (12)
            IFERR = IB2-1; R = +1.0_WP; C = +1.0_WP; IC = IAB2; IR = IAB2
            CASE (13)
            IBERR = IB2-1; R = +1.0_WP; C = +1.0_WP; IC = IAB2; IR = IAB2
            CASE (14:)
              CALL UESTOP(SRNAMT)
          END SELECT

          IF( .NOT. (( I == 7 .AND. ( J == 2 .OR. J == 3 .OR. J == 4 ) ) &
     &      .OR. ( I == 9 .AND. ( J == 2 .OR. J == 3 .OR. J == 4 ) )) &
     &      .AND. I/=0) THEN
            SELECT CASE (NRHS)
              CASE (2:)
                CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
                KL=IKL, AFB=AFB(1:IAFB1,1:IAFB2), IPIV=IPIV(1:IIPIV), FACT=IFACT, &
     &            TRANS=ITRANS, EQUED=IEQUED, &
     &            R=R(1:IR), C=C(1:IC), FERR=FERR(1:IFERR), BERR=BERR(1:IBERR), &
     &            RCOND=RCOND, &
                RPVGRW=WORK(1), INFO=INFO)
              CASE (1)

                IF( INFO /= 302 .AND. I /= 12 .AND. I /= 13 )THEN
                  CALL LA_GBSVX(AB(1:IAB1,1:IAB2), B(1:IB1,1), X(1:IX1,1), &
                  KL=IKL,  AFB=AFB(1:IAFB1,1:IAFB2), IPIV=IPIV(1:IIPIV), FACT=IFACT, &
     &              TRANS=ITRANS, EQUED=IEQUED, &
     &              R=R(1:IR), C=C(1:IC), FERR=FERR(1), BERR=BERR(1), RCOND=RCOND, &
     &              RPVGRW=WORK(1), INFO=INFO)
                ELSE
                  CALL ERINFO( -I, SRNAME, INFO )
                END IF
            END SELECT
          END IF
          EQUED = IEQUED 
          
          CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
        END SUBROUTINE LA_TEST_SGBSVX

!PROGRAM EXAMPLE
!  USE LA_PRECISION, ONLY: WP => SP
!  USE F77_LAPACK, ONLY: LA_GEQRF
!  IMPLICIT NONE
!  CHARACTER(LEN=*), PARAMETER :: FMT = '(7(1X,F9.3))'
!  INTEGER :: I, INFO, LDA, LWORK, M, N
!  REAL(WP), ALLOCATABLE :: A(:,:), TAU(:), WORK(:)
!  M = 5; N = 6; LDA = M; LWORK = -1
!  ALLOCATE( A(M,N), TAU(MIN(M,N)), WORK(MAX(1,N)) )
!  CALL RANDOM_NUMBER(A)
!  CALL LA_GEQRF( M, N, A, LDA, TAU, WORK, LWORK, INFO )
!  LWORK = INT(WORK(1)); DEALLOCATE( WORK )
!  ALLOCATE( WORK(LWORK) )
!  CALL LA_GEQRF( M, N, A, LDA, TAU, WORK, LWORK, INFO )
!  WRITE(*,*) 'INFO = ', INFO 
!  IF( INFO == 0 )THEN 
!    WRITE(*,*) 'Matrix A on exit:'
!    DO I = 1, M; WRITE (*,FMT) A(I,:); ENDDO
!  ENDIF
!END PROGRAM EXAMPLE
PROGRAM EXAMPLE 
  USE LA_PRECISION, ONLY: WP => SP 
  USE F77_LAPACK, ONLY: LA_GEQRF 
  IMPLICIT NONE 
  CHARACTER(LEN=*), PARAMETER :: FMT = '(7(1X,F9.3))' 
  INTEGER :: I, INFO, LDA, LWORK, M, N 
  REAL(WP), ALLOCATABLE :: A(:,:), TAU(:), WORK(:) 
  M = 5; N = 6; LDA = M; LWORK = -1 
  ALLOCATE( A(M,N), TAU(MIN(M,N)), WORK(MAX(1,N)) ) 
  CALL RANDOM_NUMBER(A) 
  CALL LA_GEQRF( M, N, A, LDA, TAU, WORK, LWORK, INFO ) 
  LWORK = INT(WORK(1)); DEALLOCATE( WORK ) 
  ALLOCATE( WORK(LWORK) ) 
  CALL LA_GEQRF( M, N, A, LDA, TAU, WORK, LWORK, INFO ) 
  WRITE(*,*) 'INFO = ', INFO  
  IF( INFO == 0 )THEN 
    WRITE(*,*) 'Matrix A on exit:' 
    DO I = 1, M; WRITE (*,FMT) A(I,:); ENDDO 
  ENDIF 
END PROGRAM EXAMPLE

SUBROUTINE LA_TEST_DPBSVX(FACT, UPLO, N, KD, NRHS, AB, LDAB, AFB, &
     &  LDAFB, EQUED, S, B, LDB, X, LDX, RCOND, FERR, BERR, WORK, &
     &  IWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     April 5, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_PBSVX
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, KD, NRHS, LDAB, LDB, LDAFB, LDX
   INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: FACT, UPLO
      CHARACTER(LEN=1), INTENT(INOUT) :: EQUED
      REAL(WP), INTENT(OUT) ::  RCOND 
!  .. Array Arguments ..
      REAL(WP), INTENT(INOUT) :: AB(1:LDAB,1:N), B(1:LDB,1:NRHS),&
     &  AFB(1:LDAFB, 1:N),  S(1:N)
      REAL(WP), INTENT(OUT) :: X(1:LDX,1:NRHS), WORK(1:3*N), FERR(1:NRHS), &
     &  BERR(1:NRHS)
      INTEGER, INTENT(OUT) :: IWORK(1:N) 
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_PBSVX'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DPBSVX'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IAB1, IAB2, IB1, IB2, IX1, IX2, IAFB1, IAFB2, &
     &  IS, IFERR, IBERR
      CHARACTER*1 :: IUPLO, IFACT, IEQUED
      logical :: lsame
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IAB1 = KD+1; IAB2 = N; IB1 = N; IB2 = NRHS; IUPLO=UPLO
   IX1 = N; IX2 = NRHS; IAFB1 = KD+1; IAFB2=N; IFACT=FACT
   IEQUED = EQUED; IS = N; IFERR = NRHS; IBERR = NRHS
   I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE(0)
      IF ( NRHS == 1 ) THEN
        CALL LA_PBSVX( AB(1:IAB1,1:IAB2), B(1:IB1,1), X(1:IX1,1),&
     &    IUPLO, AFB(1:IAFB1,1:IAFB2), IFACT, IEQUED, S(1:IS),&
     &    FERR(1), BERR(1), RCOND, INFO )
        INFO = INFOTC
      ELSE
        CALL LA_PBSVX( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
     &    IUPLO, AFB(1:IAFB1,1:IAFB2), IFACT, IEQUED, S(1:IS),&
     &    FERR(1: IFERR), BERR(1: IBERR), RCOND, INFO ) 
        INFO = INFOTC
      END IF
      CASE (1)
      IAB1 = -1
      CASE (2)
      IB1 = IAB1-1
      CASE (3)
      IX1 = IAB2 - 1
      CASE (4)
      IUPLO = 'T'
      CASE (5)
      IAFB2 = N+1
      CALL LA_PBSVX( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
     &  IUPLO, AFB(1:IAFB1,1:IAFB2), IFACT, IEQUED, S(1:IS),&
     &  FERR(1: IFERR), BERR(1: IBERR), RCOND, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (6)
      IFACT = 'T'
      CASE (7)
      IEQUED = 'T'
      IFACT  = 'F'
      CALL LA_PBSVX( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
     &  IUPLO, AFB(1:IAFB1,1:IAFB2), IFACT, IEQUED, S(1:IS),&
     &  FERR(1: IFERR), BERR(1: IBERR), RCOND, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (8)
      IS = IAB2 - 1
      CASE (9)
      IFERR = IX2 - 1
      CALL LA_PBSVX( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
     &  IUPLO, AFB(1:IAFB1,1:IAFB2), IFACT, IEQUED, &
     &  FERR=FERR(1: IFERR), BERR=BERR(1: IBERR), RCOND=RCOND, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (10)
      IBERR = IX2 - 1 
      CALL LA_PBSVX( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
     &  IUPLO, AFB(1:IAFB1,1:IAFB2), IFACT, IEQUED, &
     &  FERR=FERR(1: IFERR), BERR=BERR(1: IBERR), RCOND=RCOND, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE(:-1,11:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF( I /= 0 ) THEN
        SELECT CASE (NRHS)
        CASE (2:)
        IF (LSAME(IFACT,'F'))THEN
          CALL LA_PBSVX( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
     &      IUPLO, AFB(1:IAFB1,1:IAFB2), IFACT, IEQUED, S(1:IS),&
     &      FERR(1: IFERR), BERR(1: IBERR), RCOND, INFO )
        else
          CALL LA_PBSVX( AB(1:IAB1,1:IAB2), B(1:IB1,1:IB2), X(1:IX1,1:IX2),&
     &      IUPLO, FACT=IFACT, EQUED=IEQUED, S=S(1:IS),&
     &      FERR=FERR(1: IFERR), BERR=BERR(1: IBERR), RCOND=RCOND, INFO=INFO )
        endif
        
      CASE(1)
      CALL LA_PBSVX( AB(1:IAB1,1:IAB2), B(1:IB1,1), X(1:IX1,1),&
     &  IUPLO, AFB(1:IAFB1,1:IAFB2), IFACT, IEQUED, S(1:IS),&
     &  FERR(1), BERR(1), RCOND, INFO )
      CASE(:-1)
      CALL UESTOP(SRNAMT)
      END SELECT
  END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_DPBSVX
      

SUBROUTINE LA_TEST_DSYSVX( FACT, UPLO, N, NRHS, A, LDA, AF, LDAF, IPIV, &
     &  B, LDB, X, LDX, RCOND, FERR, BERR, WORK, LWORK, IWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     April 7, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => DP
      USE F95_LAPACK, ONLY: LA_SYSVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, NRHS, LDA, LDAF, LDB, LDX, LWORK
      INTEGER, INTENT(INOUT) :: INFO
      REAL(WP), INTENT(OUT) :: RCOND
      CHARACTER*1, INTENT(IN) :: FACT, UPLO  
!  .. Array Arguments ..
      INTEGER, INTENT(INOUT) :: IPIV(1:N)
      INTEGER :: IWORK(1: N)
      REAL(WP), INTENT(INOUT) :: AF(1:LDAF,1:N)
      REAL(WP), INTENT(OUT) :: X(1:LDX, 1:NRHS), &
     &  FERR(1: NRHS), BERR(1: NRHS)
      REAL(WP), INTENT(IN) :: A(1:LDA,1:N), B(1:LDB,1:NRHS), &
     &  WORK(1:LWORK)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SYSVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DSYSVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, IAF1, IAF2, IX1, IX2, IB1, IB2, IIPIV,&
     &  IFERR, IBERR
      CHARACTER*1 :: IUPLO, IFACT   
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IA1 = N; IA2 = N; IB1 = N; IB2 = NRHS; IUPLO= UPLO; IIPIV=N
      IX1 = N; IX2 = NRHS; IAF1 = N; IAF2 = N; IFACT=FACT
      IFERR = NRHS; IBERR = NRHS
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE(0)
      IF ( NRHS == 1 )  THEN
        CALL LA_SYSVX( A(1:IA1,1:IA2), B(1:IB1,1), X(1: IX1, 1), &
     &    UPLO, AF(1: IAF1, 1:IAF2), IPIV(1:IIPIV), IFACT, &
     &    FERR(1), BERR(1), RCOND,  INFO )
        INFO = INFOTC 
      ELSE
        CALL LA_SYSVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1, 1:IX2), &
     &    UPLO, AF(1 : IAF1, 1:IAF2), IPIV(1:IIPIV), IFACT,&
     &    FERR(1: IFERR), BERR(1 : IBERR), RCOND,  INFO )
        INFO = INFOTC
      END IF
      CASE (1)
      IA2 = IA1 - 1
      CASE (2)
      IB1 = IA1 - 1
      CASE(3)
      IX1 = IA1 - 1; IX2 = IB2 - 1
      CASE (4)
      IUPLO = 'T'
      CASE (5)
      IAF1 = IA1 - 1; IAF2 = IA1 - 1
      CASE (6)
      IIPIV = IA1 - 1
      CASE (7)
      IFACT = 'T'
      CALL LA_SYSVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1: IX1, 1:IX2), &
     &  IUPLO, AF(1: IAF1, 1:IAF2), IPIV(1:IIPIV), IFACT,&
     &  FERR(1: IFERR), BERR(1: IBERR), RCOND,  INFO ) 
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN  
      CASE(8)
      IFERR = IB2 - 1
      CALL LA_SYSVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1: IX1, 1:IX2), &
     &  IUPLO, AF(1: IAF1, 1:IAF2), IPIV(1:IIPIV), IFACT,&
     &  FERR(1: IFERR), BERR(1: IBERR), RCOND,  INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN                                 
      CASE(9)
      IBERR = IB2 - 1
      CALL LA_SYSVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1: IX1, 1:IX2), &
     &  IUPLO, AF(1: IAF1, 1:IAF2), IPIV(1:IIPIV), IFACT,&
     &  FERR(1: IFERR), BERR(1: IBERR), RCOND,  INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN                                 
      CASE(:-1,10:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF( I /= 0 ) THEN
        SELECT CASE (NRHS)
        CASE (2:)
        CALL LA_SYSVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1: IX1, 1:IX2), &
     &    IUPLO, AF(1: IAF1, 1:IAF2), IPIV(1:IIPIV), IFACT,&
     &    FERR(1: IFERR), BERR(1: IBERR), RCOND,  INFO )
        CASE(1)
        CALL LA_SYSVX( A(1:IA1,1:IA2), B(1:IB1,1), X(1: IX1,1), &
     &    IUPLO, AF(1 : IAF1, 1:IAF2), IPIV(1:IIPIV), IFACT,&
     &    FERR(1), BERR(1), RCOND, INFO ) 
        CASE(:-1)
        CALL UESTOP(SRNAMT)
      END SELECT
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      END SUBROUTINE LA_TEST_DSYSVX

PROGRAM LA_DGGEVX_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GGEVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: BALANC
      INTEGER :: I, INFO, N, ILO, IHI
      REAL(WP) :: ABNRM, BBNRM
!  .. LOCAL ARRAYS ..
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:)
   REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), VL(:,:), &
     &  VR(:,:), ALPHAR(:), ALPHAI(:), BETA(:), DUMMY(:,:)
      REAL(WP), ALLOCATABLE :: RCONDE(:), RCONDV(:), LSCALE(:), RSCALE(:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'DGGEVX ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N
   PRINT *, 'N = ', N
   ALLOCATE ( A(N,N), AA(N,N), ALPHAR(N), ALPHAI(N), BETA(N), &
     &  VL(N,N), VR(N,N), B(N,N), BB(N,N) )
      ALLOCATE(RCONDE(N), RCONDV(N), LSCALE(N), RSCALE(N))
!
   READ (NIN, *) AA, BB
   A=AA; B=BB
   WRITE(NOUT,*) 'The matrix A:'
   DO I = 1, N; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(I,:); ENDDO
   WRITE(NOUT,*) 'The matrix B:'
   DO I = 1, N; WRITE (NOUT,*) 'I = ', I; WRITE (NOUT,FMT) B(I,:); ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_DGGEVX LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   BALANC = 'N'   
   WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC=N, ILO, IHI, &
     &  LSCALE, RSCALE, ABNRM, BBNRM, RCONDE, RCONDV, INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC, ILO, IHI, LSCALE, RSCALE, ABNRM, BBNRM, RCONDE, RCONDV, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   WRITE(NOUT,*) ' Alphar:'
   WRITE(NOUT,FMT) ALPHAR
   WRITE(NOUT,*) ' Alphai:'
   WRITE(NOUT,FMT) ALPHAI
   WRITE(NOUT,*) ' Beta:'
   WRITE(NOUT,FMT) BETA
   WRITE(NOUT,*) 'VL:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VL(:,I); END DO
   WRITE(NOUT,*) 'VR:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VR(:,I); END DO
   WRITE(NOUT,*) 'ILO = ', ILO; WRITE(NOUT,*) 'IHI = ', IHI
   WRITE (NOUT,*) 'ABNRM = ', ABNRM;  WRITE (NOUT,*) 'BBNRM = ', BBNRM
   WRITE(NOUT,*) ' LSCALE :'; WRITE(NOUT,FMT) LSCALE
      WRITE(NOUT,*) ' RSCALE :'; WRITE(NOUT,FMT) RSCALE
      WRITE(NOUT,*) ' RCONDE :'; WRITE(NOUT,FMT) RCONDE
      WRITE(NOUT,*) ' RCONDV :'; WRITE(NOUT,FMT) RCONDV
!
   BALANC = 'P'   
   WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC=P, ILO, IHI, &
     &  LSCALE, RSCALE, ABNRM, BBNRM, RCONDE, RCONDV, INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC, ILO, IHI, LSCALE, RSCALE, ABNRM, BBNRM, RCONDE, RCONDV, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   WRITE(NOUT,*) ' Alphar:'
   WRITE(NOUT,FMT) ALPHAR
   WRITE(NOUT,*) ' Alphai:'
   WRITE(NOUT,FMT) ALPHAI
   WRITE(NOUT,*) ' Beta:'
   WRITE(NOUT,FMT) BETA
   WRITE(NOUT,*) 'VL:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VL(:,I); END DO
   WRITE(NOUT,*) 'VR:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VR(:,I); END DO
   WRITE(NOUT,*) 'ILO = ', ILO; WRITE(NOUT,*) 'IHI = ', IHI
   WRITE (NOUT,*) 'ABNRM = ', ABNRM;  WRITE (NOUT,*) 'BBNRM = ', BBNRM
   WRITE(NOUT,*) ' LSCALE :'; WRITE(NOUT,FMT) LSCALE
      WRITE(NOUT,*) ' RSCALE :'; WRITE(NOUT,FMT) RSCALE
      WRITE(NOUT,*) ' RCONDE :'; WRITE(NOUT,FMT) RCONDE
      WRITE(NOUT,*) ' RCONDV :'; WRITE(NOUT,FMT) RCONDV
!
   BALANC = 'S'   
   WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC=S, ILO, IHI, &
     &  LSCALE, RSCALE, ABNRM, BBNRM, RCONDE, RCONDV, INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC, ILO, IHI, LSCALE, RSCALE, ABNRM, BBNRM, RCONDE, RCONDV, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   WRITE(NOUT,*) ' Alphar:'
   WRITE(NOUT,FMT) ALPHAR
   WRITE(NOUT,*) ' Alphai:'
   WRITE(NOUT,FMT) ALPHAI
   WRITE(NOUT,*) ' Beta:'
   WRITE(NOUT,FMT) BETA
   WRITE(NOUT,*) 'VL:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VL(:,I); END DO
   WRITE(NOUT,*) 'VR:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VR(:,I); END DO
   WRITE(NOUT,*) 'ILO = ', ILO; WRITE(NOUT,*) 'IHI = ', IHI
   WRITE (NOUT,*) 'ABNRM = ', ABNRM;  WRITE (NOUT,*) 'BBNRM = ', BBNRM
   WRITE(NOUT,*) ' LSCALE :'; WRITE(NOUT,FMT) LSCALE
      WRITE(NOUT,*) ' RSCALE :'; WRITE(NOUT,FMT) RSCALE
      WRITE(NOUT,*) ' RCONDE :'; WRITE(NOUT,FMT) RCONDE
      WRITE(NOUT,*) ' RCONDV :'; WRITE(NOUT,FMT) RCONDV
!
   BALANC = 'B'   
   WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR,BALANC=B,&
     &  ILO, IHI, LSCALE, RSCALE, ABNRM, BBNRM, RCONDE, RCONDV, INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC, ILO, IHI, LSCALE, RSCALE, ABNRM, BBNRM, RCONDE, RCONDV, INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   WRITE(NOUT,*) ' Alphar:'
   WRITE(NOUT,FMT) ALPHAR
   WRITE(NOUT,*) ' Alphai:'
   WRITE(NOUT,FMT) ALPHAI
   WRITE(NOUT,*) ' Beta:'
   WRITE(NOUT,FMT) BETA
   WRITE(NOUT,*) 'VL:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VL(:,I); END DO
   WRITE(NOUT,*) 'VR:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) VR(:,I); END DO
   WRITE(NOUT,*) 'ILO = ', ILO; WRITE(NOUT,*) 'IHI = ', IHI
   WRITE (NOUT,*) 'ABNRM = ', ABNRM;  WRITE (NOUT,*) 'BBNRM = ', BBNRM
   WRITE(NOUT,*) ' LSCALE :'; WRITE(NOUT,FMT) LSCALE
      WRITE(NOUT,*) ' RSCALE :'; WRITE(NOUT,FMT) RSCALE
      WRITE(NOUT,*) ' RCONDE :'; WRITE(NOUT,FMT) RCONDE
      WRITE(NOUT,*) ' RCONDV :'; WRITE(NOUT,FMT) RCONDV      
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, INFO=INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
   WRITE(NOUT,*) 'A:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) A(:,I); END DO
   WRITE(NOUT,*) 'B:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) B(:,I); END DO
   WRITE(NOUT,*) ' Alphar:'
   WRITE(NOUT,FMT) ALPHAR
   WRITE(NOUT,*) ' Alphai:'
   WRITE(NOUT,FMT) ALPHAI
   WRITE(NOUT,*) ' Beta:'
   WRITE(NOUT,FMT) BETA
!STARTING THE ERROR RESULT TESTINGS
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( DUMMY, B, ALPHAR, ALPHAI, BETA, INFO=INFO )'
   A=AA
   CALL LA_GGEVX( DUMMY, B, ALPHAR, ALPHAI, BETA, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, DUMMY, ALPHAR, ALPHAI, BETA, INFO=INFO )'
   A=AA
   CALL LA_GGEVX( A, DUMMY, ALPHAR, ALPHAI, BETA, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 3
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR(1:N-1), ALPHAI, BETA, INFO=INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR(1:N-1), ALPHAI, BETA, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI(1:N-1), BETA, INFO=INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI(1:N-1), BETA, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA(1:N-1), INFO=INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA(1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!ERROR 6
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL(:,1:N-1), INFO=INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL(:,1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL(1:N-1,:), INFO=INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!ERROR 7
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VR=VR(1:N-1,:), INFO=INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VR=VR(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VR=VR(:,1:N-1), INFO = INFO )'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VR=VR(:,1:N-1), INFO = INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!ERROR 8
   BALANC = 'T'
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC=T, INFO = INFO)'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC='T', INFO = INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 11
   BALANC = 'T'
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC=B, LSCALE=LSCALE(1:N-1), INFO = INFO)'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC='B',  LSCALE=LSCALE(1:N-1), INFO = INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 12
   BALANC = 'T'
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC=B, RSCALE=RSCALE(1:N-1), INFO = INFO)'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC='B', RSCALE=RSCALE(1 :N-1),INFO = INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 15
   BALANC = 'T'
   WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC=B, &
     &  RSCALE=RSCALE(1:N-1), RCONDE=RCONDE(1:N-1), INFO = INFO)'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC='B', RSCALE=RSCALE(1 :N-1), RCONDE=RCONDE(1:N-1), INFO = INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
! ERROR 16
   BALANC = 'T'
   WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC=B, RSCALE=RSCALE(1:N-1), &
     &  RCONDV=RCONDV(1:N-1), INFO = INFO)'
   A=AA
   CALL LA_GGEVX( A, B, ALPHAR, ALPHAI, BETA, VL, VR, BALANC='B', RSCALE=RSCALE(1 :N-1), RCONDV=RCONDV(1:N-1), INFO = INFO)
   WRITE(NOUT,*) 'INFO = ', INFO
END PROGRAM LA_DGGEVX_ET_EXAMPLE

SUBROUTINE LA_TEST_ZGELSD( M, N, NRHS, A, LDA, B, LDB, S, RCOND, RANK,&
     &  WORK, LWORK, RWORK, IWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     September 10, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => DP
      USE F95_LAPACK, ONLY: LA_GELSD
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: M, N, NRHS, LDA, LDB
      INTEGER, INTENT(INOUT) :: INFO
      INTEGER, INTENT(OUT) :: RANK
      INTEGER, INTENT(IN) :: LWORK
      REAL(WP), INTENT(IN) :: RCOND
!  .. Array Arguments ..
      COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB,1:NRHS)
      COMPLEX(WP), INTENT(OUT) :: WORK(1:LWORK)
      INTEGER :: IWORK(1:3 * MIN(M,N) * MAX(M,N)*MAX(M,N) + 11 * MIN(M,N))
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!      
      REAL(WP) :: RWORK(1: 8*N+2*MAX(M,N)*MAX(M,N)+8*MAX(M,N)*MAX(M,N)+N*NRHS)
      REAL(WP), INTENT(OUT) :: S(1:MIN(M,N))
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GELSD'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZGELSD'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, IB1, IB2, IS
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      
!  .. Executable Statements ..
      IA1 = M; IA2 = N; IB1 = MAX(1,M,N); IB2 = NRHS; IS = MIN(M,N)
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE(0)
      IF (NRHS==1) THEN
        CALL LA_GELSD( A(1:IA1,1:IA2), B(1:IB1,1), RANK,&
     &    S(1:IS), RCOND, INFO )
        INFO = INFOTC
      ELSE
        CALL LA_GELSD( A(1:IA1,1:IA2), B(1:IB1,1:IB2), RANK,&
     &    S(1:IS), RCOND, INFO )
        INFO = INFOTC
      ENDIF
   CASE (2)
      IB1 = MAX(1, N, M) - 1
   CASE(4)
      IS = MIN (M, N) - 1
   CASE(:-1,1,3, 5:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF (I/=0) THEN
        SELECT CASE (NRHS) 
        CASE (2:)
        CALL LA_GELSD( A(1:IA1,1:IA2), B(1:IB1,1:IB2), RANK,&
     &    S(1:IS), RCOND, INFO )
        CASE(1)
        CALL LA_GELSD( A(1:IA1,1:IA2), B(1:IB1,1), RANK,&
     &    S(1:IS), RCOND, INFO )
        CASE(:-1)
        CALL UESTOP(SRNAMT)
      END SELECT
      ENDIF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_ZGELSD

SUBROUTINE LA_TEST_CPPSVX( FACT, UPLO, N, NRHS, AP, AFP, EQUED, S, B, &
&   LDB, X, LDX, RCOND, FERR, BERR, WORK, RWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     April 5, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_PPSVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, NRHS, LDB, LDX
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: FACT, UPLO
      CHARACTER(LEN=1), INTENT(INOUT) :: EQUED
      REAL(WP), INTENT(OUT) :: RCOND
!  .. Array Arguments ..
      COMPLEX(WP), INTENT(INOUT) :: AP(N*(N+1)/2), B(1:LDB,1:NRHS), &
     &  AFP(1: N*(N+1)/2)
      REAL(WP), INTENT(INOUT):: S(1:N)
      REAL(WP), INTENT(OUT) :: FERR(1:NRHS), BERR(1:NRHS)
      COMPLEX(WP), INTENT(OUT) :: X(1:LDX,1:NRHS), WORK(1:2*N)
      REAL(WP), INTENT(OUT) :: RWORK(1:N) 
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_PPSVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_CPPSVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IAP1,  IB1, IB2, IX1, IX2, IAFP, IS, &
     &  IFERR, IBERR
      CHARACTER*1 :: IUPLO, IFACT, IEQUED
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IAP1 = (N*(N+1))/2; IB1 = N; IB2 = NRHS; IUPLO= UPLO
      IX1=N; IX2=NRHS; IAFP = (N*(N+1))/2; IFACT=FACT; IS = N
      IBERR = NRHS; IFERR = NRHS
      I = INFO / 100; J = INFO - I*100
      
      SELECT CASE(I)
      CASE(0)
      IF (NRHS == 1) THEN
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO )
        INFO = INFOTC
      ELSE
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO )
        INFO = INFOTC
      END IF
      CASE (1)
      IAP1 = IAP1-1
      CASE (2)
      IB1 = IAP1-1
      CASE(3)
      IFACT = 'F'
      IX1 = IB1-1
      IF (NRHS == 1) THEN
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO )
      ELSE
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO )
      ENDIF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE(4)
      IUPLO='T'
      CASE (5)
      IAFP = IAP1 - 1
      CASE(6)
      IFACT = 'T'
      CASE (7)
      IFACT = 'F'
      IEQUED = 'T'
      IF (NRHS == 1) THEN
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    IEQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO )
      ELSE
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    IEQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO )
      ENDIF                      
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (8)
      IS = IB1 - 1
      CASE (9)
      IFACT = 'F' ;  S = +1.0_WP 
      IFERR = IB2 - 1
      IF (NRHS == 1) THEN
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO )
      ELSE
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO )
      ENDIF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN                                         
      CASE (10)
      IBERR = IB2 - 1; S = +1.0_WP; IFACT = 'F'
      IF (NRHS == 1) THEN
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO )
      ELSE
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO )
      ENDIF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN                                      
      CASE(:-1,11:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF( I /= 0 ) THEN
        SELECT CASE (NRHS)
        CASE (2:)
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO ) 
        CASE(1)
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO ) 
        CASE(:-1)
        CALL UESTOP(SRNAMT)
      END SELECT
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_CPPSVX
      

SUBROUTINE LA_TEST_SSPEVX( JOBS, RANGE, UPLO, N, AP, VL, VU, IL, IU, &
     &  ABSTOL, M, W, Z, LDZ, WORK, IWORK, IFAIL, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 25, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SPEVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, LDZ, IL, IU
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: JOBS, RANGE, UPLO
      INTEGER, INTENT(OUT) :: M
      REAL(WP), INTENT(IN) :: VL, VU, ABSTOL
!  .. Array Arguments ..
      REAL(WP), INTENT(INOUT) :: AP(1: N*(N+1)/2)
      REAL(WP), INTENT(OUT)::  W(1:N), Z(1: LDZ, 1: N)
      INTEGER, INTENT(OUT) :: IWORK(1: 5*N), IFAIL(1:N)
      REAL(WP) :: WORK(1:8*N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SPEVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SSPEVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IAP, IW, IZ1, IZ2, IIL, IIU
      REAL(WP) :: IVL, IVU, IABSTOL
      CHARACTER*1 :: IUPLO, IJOBS, IRANGE
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      LOGICAL LSAME
!  .. Executable Statements ..
      IAP = N*(N+1)/2; IUPLO = UPLO; IW = N; IJOBS = JOBS
      IZ1 =MAX(1,N); IZ2 = N; IWORK = N; IVL = VL; IVU=VU
      IIL = IL; IIU = IU; IABSTOL = ABSTOL; IRANGE=RANGE
      I = INFO / 100; J = INFO - I*100; M=0
      SELECT CASE(I)
      CASE (1)
      IAP = IAP - 1
      CASE (2)
      IW = IW - 1
      CASE (3)
      IUPLO = 'T'   
      CASE (4)
      IZ2 = IZ2 - 1
      IJOBS = 'V'
      CASE (5)
      IVL = IVU+1
      IJOBS='V'; IRANGE='V'
      CALL LA_SPEVX(AP(1:IAP), W(1:IW), IUPLO, Z(1:IZ1, 1:IZ2),&
     &  IVL, IVU, M=M, IFAIL=IFAIL, ABSTOL=IABSTOL, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (6)
      CALL LA_SPEVX(AP(1:IAP), W(1:IW), IUPLO, Z(1:IZ1, 1:IZ2),&
     &  IVL, IVU, IIL, IIU, M, IFAIL, IABSTOL, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (7)
      IIL = IIU+1
      IJOBS='V'; IRANGE='I'
      CALL LA_SPEVX(AP(1:IAP), W(1:IW), IUPLO, Z(1:IZ1, 1:IZ2),&
     &  IL=IIL, IU=IIU, M=M, IFAIL=IFAIL, ABSTOL=IABSTOL,INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN 
      CASE (8)
      IIU = IZ2 + 1;  IIL = IIU
      IJOBS='V'; IRANGE='I'
      CALL LA_SPEVX(AP(1:IAP), W(1:IW), IUPLO, Z(1:IZ1, 1:IZ2),&
     &  IL=IIL, IU=IIU, M=M, IFAIL=IFAIL, ABSTOL=IABSTOL,INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN                                   
      CASE (10)
      IJOBS='V'; IRANGE='V'
      CALL LA_SPEVX(AP(1:IAP), W(1:IW), IUPLO,&
     &  VL=IVL, VU=IVU, M=M, IFAIL=IFAIL, ABSTOL=IABSTOL, INFO=INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN 
      CASE(:-1,9,11:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF (LSAME(IJOBS, 'V')) THEN
        IF (LSAME (IRANGE, 'V')) THEN
          CALL LA_SPEVX(AP(1:IAP), W(1:IW), IUPLO, Z(1:IZ1, 1:IZ2),&
     &      IVL, IVU, M=M, IFAIL=IFAIL, ABSTOL=IABSTOL, INFO=INFO )
        ELSE IF (LSAME (IRANGE, 'I')) THEN
          CALL LA_SPEVX(AP(1:IAP), W(1:IW), IUPLO, Z(1:IZ1, 1:IZ2),&
     &      IL=IIL, IU=IIU, M=M, IFAIL=IFAIL, ABSTOL=IABSTOL,INFO=INFO )
        ELSE
          CALL LA_SPEVX(AP(1:IAP), W(1:IW), IUPLO, Z(1:IZ1, 1:IZ2),&
     &      M=M, IFAIL=IFAIL, ABSTOL=IABSTOL, INFO=INFO )
        ENDIF
      ELSE
        IF (LSAME (IRANGE, 'V')) THEN
          CALL LA_SPEVX(AP(1:IAP), W(1:IW), IUPLO, &
     &      VL=IVL, VU=IVU, M=M, ABSTOL=IABSTOL, INFO=INFO )
        ELSE IF (LSAME (IRANGE, 'I')) THEN
          CALL LA_SPEVX(AP(1:IAP), W(1:IW), IUPLO, &
     &      IL=IIL, IU=IIU, M=M, ABSTOL=IABSTOL, INFO=INFO )
        ELSE
          CALL LA_SPEVX(AP(1:IAP), W(1:IW), IUPLO, &
     &      M=M, ABSTOL=IABSTOL, INFO=INFO )
        END IF
      ENDIF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      END SUBROUTINE LA_TEST_SSPEVX
      

SUBROUTINE LA_TEST_SSYGV( ITYPE, JOBZ, UPLO, N, A, LDA, B, LDB, W, WORK, LWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 5, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_SYGV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: ITYPE, N, LDA, LDB, LWORK
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBZ, UPLO
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB, 1:N)
   REAL(WP), INTENT(OUT)::  W(1:N), WORK(1:LWORK)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SYGV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SSYGV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IW, IB1, IB2, IITYPE
   CHARACTER*1 :: IUPLO, IJOBZ   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IUPLO = UPLO; IW = N; IJOBZ = JOBZ
   IB1 = N; IB2 = N; IITYPE = ITYPE
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
       IA2 = IA1 - 1
     CASE (2)
       IB1 = IA1 - 1
     CASE (3)
       IW = IA1 - 1
     CASE (4)
       IITYPE = 22   
     CASE (5)
       IJOBZ = 'T'
     CASE (6)
       IUPLO = 'T'
     CASE(:-1,7:)
       CALL UESTOP(SRNAMT)
   END SELECT
   CALL LA_SYGV( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), W(1 :IW), &
&    IITYPE, IJOBZ, IUPLO, INFO )
   
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_SSYGV
      
      

SUBROUTINE ZHBGVX_F95( AB, BB,  W, UPLO, Z, VL, VU, IL, IU, &
      &         M, IFAIL, Q,  ABSTOL, INFO ) 
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP =>  DP
      USE LA_AUXMOD, ONLY: ERINFO, LSAME
      USE F77_LAPACK, ONLY: LAMCH_F77 => DLAMCH
      USE F77_LAPACK, ONLY: HBGVX_F77 => LA_HBGVX
!  .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
      INTEGER, INTENT(IN), OPTIONAL :: IL, IU
      INTEGER, INTENT(OUT), OPTIONAL :: INFO, M
      REAL(WP), INTENT(IN), OPTIONAL :: ABSTOL, VL, VU
!  .. ARRAY ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL, TARGET :: IFAIL(:)
      COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:), Q(:,:)
      COMPLEX(WP), INTENT(INOUT) :: AB(:,:), BB(:,:)
      REAL(WP), INTENT(OUT) :: W(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!     LA_SBGVX and LA_HBGVX compute selected eigenvalues and, optionally,
! the corresponding eigenvectors of the generalized eigenvalue problem
!                      A*z = lambda*B*z,
! where A and B are real symmetric in the case of LA_SBGVX and complex
! Hermitian in the case of LA_HBGVX. In both cases B is positive 
! definite. Matrices A and B are stored in a band format. Eigenvalues 
! and eigenvectors can be selected by specifying either a range of
! values or a range of indices for the desired eigenvalues.
! 
! =========
! 
!           SUBROUTINE LA_SBGVX / LA_HBGVX( AB, BB, W, UPLO=uplo, Z=z, &
!                   VL=vl, VU=vu, IL=il, IU=iu, M=m, IFAIL=ifail, Q=q, &
!                   ABSTOL=abstol, INFO=info )
!              <type>(<wp>), INTENT(INOUT) :: AB(:,:), BB(:,:)
!              REAL(<wp>), INTENT(OUT) :: W(:)
!              CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!              <type>(<wp>), INTENT(OUT), OPTIONAL :: Z(:,:)
!              REAL(<wp>), INTENT(IN), OPTIONAL :: VL, VU
!              INTEGER, INTENT(IN), OPTIONAL :: IL, IU
!              INTEGER, INTENT(OUT), OPTIONAL :: M
!              INTEGER, INTENT(OUT), OPTIONAL :: IFAIL(:)
!              <type>(<wp>), INTENT(OUT), OPTIONAL :: Q(:,:)
!              REAL(<wp>), INTENT(IN), OPTIONAL :: ABSTOL
!              INTEGER, INTENT(OUT), OPTIONAL :: INFO
!           where 
!              <type> ::= REAL | COMPLEX
!              <wp>   ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! AB       (input/output) REAL or COMPLEX array, shape (:,:) with 
!          size(AB,1) = ka + 1 and size(AB,2) = n, where ka is the number
! 	 of subdiagonals or superdiagonals in the band of A and n is 
! 	 the order of A and B.
!          On entry, the upper (if UPLO = 'U') or lower (if UPLO = 'L')
! 	 triangle of A in band storage. The ka + 1 diagonals of A are 
! 	 stored in the rows of AB so that the j-th column of A is 
! 	 stored in the j-th column of AB as follows:
! 	 if UPLO = 'U', AB(ka+1+i-j,j) = A(i,j) for max(1,j-ka)<=i<=j,
! 	                                            1<=j<=n
! 	 if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+ka),
!                  	                            1<=j<=n.
!        On exit, the contents of AB are destroyed.
! BB     (input/output) REAL or COMPLEX array, shape (:,:) with 
!        size(BB,1) = kb + 1 and size(BB,2) = n, where kb is the number
! 	 of subdiagonals or superdiagonals in the band of B.
!        On entry, the upper (if UPLO = 'U') or lower (if UPLO = 'L') 
! 	 triangle of matrix B in band storage. The kb + 1 diagonals of
! 	 B are stored in the rows of BB so that the j-th column of B
!        is stored in the j-th column of BB as follows:
! 	 if UPLO = 'U', BB(kb+1+i-j,j) = B(i,j) for max(1,j-kb)<=i<=j,
! 	                                            1<=j<=n
! 	 if UPLO = 'L', BB(1+i-j,j)    = B(i,j) for j<=i<=min(n,j+kb),
!                                                   1<=j<=n.
!        On exit, the factor S from the split Cholesky factorization 
! 	              B = S^H*S.
! W      (output) REAL array, shape (:) with size(W) = n.
!        The first M elements contain the selected eigenvalues in 
! 	 ascending order.
! UPLO   Optional (input) CHARACTER(LEN=1).
!            = 'U': Upper triangles of A and B are stored;
!            = 'L': Lower triangles of A and B are stored.
!        Default value: 'U'.
! Z      Optional (output) REAL or COMPLEX square array, shape (:,:) 
!        with size(Z,1) = n.
!        The first M columns of Z contain the orthonormal eigenvectors
! 	 corresponding to the selected eigenvalues, with the i-th 
!        column of Z containing the eigenvector associated with the
!        eigenvalue in W(i). The eigenvectors are normalized so that 
! 	 Z^H*B*Z = I . If an eigenvector fails to converge, then that 
! 	 column of Z contains the latest approximation to the 
! 	 eigenvector and the index of the eigenvector is returned in 
! 	 IFAIL.
! VL,VU  Optional (input) REAL.
!        The lower and upper bounds of the interval to be searched for 
! 	 eigenvalues. VL < VU.
!        Default values: VL = -HUGE(<wp>) and VU = HUGE(<wp>), where 
! 	 <wp> ::= KIND(1.0) | KIND(1.0D0).
!        Note: Neither VL nor VU may be present if IL and/or IU is 
! 	 present.
! IL,IU  Optional (input) INTEGER.
!        The indices of the smallest and largest eigenvalues to be 
! 	 returned. The IL-th through IU-th eigenvalues will be found.
! 	 1 <= IL <= IU <= size(A,1).
!        Default values: IL = 1 and IU = size(A,1).
!        Note: Neither IL nor IU may be present if VL and/or VU is 
! 	 present.
!        Note: All eigenvalues are calculated if none of the arguments
! 	 VL, VU, IL and IU are present.
! M      Optional (output) INTEGER.
!        The total number of eigenvalues found. 0 <= M <= size(A,1).
!        Note: If IL and IU are present then M = IU - IL + 1.
! IFAIL  Optional (output) INTEGER array, shape (:) with size(IFAIL)=n.
!        If INFO = 0, the first M elements of IFAIL are zero.
!        If INFO > 0, then IFAIL contains the indices of the 
! 	 eigenvectors that failed to converge.
!        Note: If Z is present then IFAIL should also be present.
! Q      Optional, (Output) REAL or COMPLEX square array, shape(:,:)
!        with size(Q,1) = n.
!        If Z is present, the matrix used in the reduction of 
! 	 A*z = lambda*B*z to tridiagonal form.
! ABSTOL Optional (input) REAL.
!        The absolute error tolerance for the eigenvalues. An 
! 	 approximate eigenvalue is accepted as converged when it is
! 	 determined to lie in an interval [a,b] of width less than or
! 	 equal to
!              ABSTOL + EPSILON(1.0_<wp>) * max(|a|,|b|),
!        where <wp> is the working precision. If ABSTOL <= 0, then 
! 	 EPSILON(1.0_<wp>) * ||T||1 will be used in its place, where
! 	 ||T||1 is the l1 norm of the tridiagonal matrix obtained by
! 	 reducing the generalized eigenvalue problem to tridiagonal 
! 	 form. Eigenvalues will be computed most accurately when ABSTOL
! 	 is set to twice the underflow threshold 
! 	            2 * LA_LAMCH(1.0_<wp>, 'S'), not zero.
!        Default value: 0.0_<wp>.
!        Note: If this routine returns with 0 < INFO <= n, then some 
! 	 eigenvectors did not converge.
!        Try setting ABSTOL to 2 * LA_LAMCH(1.0_<wp>, 'S').
! INFO   Optional (output) INTEGER.
!        = 0: successful exit.
!        < 0: if INFO = -i, the i-th argument had an illegal value
!        > 0: the algorithm failed to converge or matrix B is not 
! 	    positive definite:
!           <= n: the algorithm failed to converge; if INFO = i, 
! 	      then i eigenvectors failed to converge. Their indices 
! 	      are stored in array IFAIL.
!           > n: if INFO = n + i, for 1 <= i <= n, then the leading 
! 	      minor of order i of B is not positive definite. The 
! 	      factorization of B could not be completed and no
! 	      eigenvalues or eigenvectors were computed.
!        If INFO is not present and an error occurs, then the program 
! 	 is terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_HBGVX'
!  .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: LJOBZ, LUPLO, LRANGE
      INTEGER :: N, LINFO, LDAB, LDBB, LIL, LIU, LM, ISTAT, &
     &  SIFAIL, S1Z, S2Z, S1Q, S2Q, KAB, KBB
      INTEGER, TARGET :: ISTAT1(1)
      COMPLEX(WP), TARGET :: LLZ(1,1), LLQ(1,1)
      REAL(WP) :: LABSTOL, LVL, LVU
!  .. LOCAL ARRAYS ..
      INTEGER, POINTER :: IWORK(:), LIFAIL(:)
      COMPLEX(WP), POINTER :: WORK(:), LQ(:,:)
      REAL(WP), POINTER :: RWORK (:)
!  .. INTRINSIC FUNCTIONS ..
      INTRINSIC HUGE, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0
   KAB = SIZE(AB,1)-1; KBB = SIZE(BB,1)-1
   N = SIZE(AB,2); LDAB = MAX(1,SIZE(AB,1))
   LDBB = MAX(1, SIZE(BB,1))
   IF( PRESENT(IFAIL) )THEN; SIFAIL = SIZE(IFAIL); ELSE; SIFAIL = N; END IF
   IF( PRESENT(Q) )THEN; S1Q = SIZE(Q,1); S2Q = SIZE(Q,2)
   ELSE; S1Q = N; S2Q = N; END IF
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
   IF( PRESENT(VL) )THEN; LVL = VL; ELSE; LVL = -HUGE(LVL); ENDIF
   IF( PRESENT(VU) )THEN; LVU = VU; ELSE; LVU = HUGE(LVU); ENDIF
   IF( PRESENT(IL) )THEN; LIL = IL; ELSE; LIL = 1; ENDIF
   IF( PRESENT(IU) )THEN; LIU = IU; ELSE; LIU = N; ENDIF
   IF( PRESENT(Z) )THEN; S1Z = SIZE(Z,1); S2Z = SIZE(Z,2)
   ELSE; S1Z = 1; S2Z = 1; ENDIF
!  .. TEST THE ARGUMENTS
      IF( PRESENT(VL) .OR. PRESENT(VU) )THEN; LRANGE = 'V'
      ELSE IF( PRESENT(IL) .OR. PRESENT(IU) )THEN; LRANGE = 'I'
      ELSE; LRANGE = 'A' ; END IF
        
      IF( KAB < 0 .OR. N < 0 ) THEN; LINFO = -1
      ELSE  IF (KBB < 0) THEN; LINFO = -2
      ELSE IF( SIZE( W ) /= N )THEN; LINFO = -3
      ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
      ELSE IF( PRESENT(Z) .AND. ( S1Z /= N .OR. S2Z /= N ) )THEN; LINFO = -5
      ELSE IF( LVU < LVL )THEN; LINFO = -6
      ELSE IF( (PRESENT(VL) .OR. PRESENT(VU)) .AND. &
     &    (PRESENT(IL) .OR. PRESENT(IU)) )THEN; LINFO = -7
      ELSE IF( LRANGE == 'I' .AND. ( LIU.LT.MIN( N, LIL ) .OR. LIU.GT.N)) THEN; LINFO = -8
      ELSE IF( N < LIU )THEN; LINFO = -9
      ELSE IF( SIFAIL /= N .OR. PRESENT(IFAIL).AND..NOT.PRESENT(Z) )THEN; LINFO = -10
      ELSE IF( S1Q /= N .OR. S2Q /= N .OR. PRESENT(Q).AND..NOT.PRESENT(Z) )THEN; LINFO = -11
      ELSE IF( N > 0 )THEN
          IF( PRESENT(Z) ) THEN; LJOBZ = 'V'
            IF( PRESENT(IFAIL) )THEN; LIFAIL => IFAIL
            ELSE; ALLOCATE( LIFAIL(N), STAT=ISTAT ); END IF
            IF( ISTAT == 0 )THEN
              IF( PRESENT(Q) )THEN; LQ => Q
              ELSE; ALLOCATE( LQ(N,N), STAT=ISTAT ); END IF
            END IF
          ELSE; LJOBZ = 'N'; LIFAIL => ISTAT1; LQ => LLQ; S1Q =1; ENDIF
! .. DETERMINE THE WORKSPACE
          IF( ISTAT == 0 ) THEN
            ALLOCATE(IWORK(MAX(1,5*N)), WORK(MAX(1,N)), RWORK(MAX(1,7*N)), STAT=ISTAT)
            IF( ISTAT == 0 )THEN
              IF( PRESENT(ABSTOL) )THEN; LABSTOL = ABSTOL
              ELSE; LABSTOL = 2*LAMCH_F77('Safe minimum'); ENDIF
              IF (PRESENT (Z))  THEN
                CALL HBGVX_F77( LJOBZ, LRANGE, LUPLO, N, KAB, KBB, AB, LDAB, &
     &            BB, LDBB, LQ, S1Q, LVL, LVU, LIL, LIU, LABSTOL, LM, W, Z,& 
     &            S1Z, WORK, RWORK, IWORK, LIFAIL, LINFO )
              ELSE
	         CALL HBGVX_F77( LJOBZ, LRANGE, LUPLO, N, KAB, KBB, AB, LDAB, &
     &            BB, LDBB, LQ, S1Q, LVL, LVU, LIL, LIU, LABSTOL, LM, W, LLZ,& 
     &            S1Z, WORK, RWORK, IWORK, LIFAIL, LINFO )
              ENDIF 
                  IF( PRESENT(M) ) M = LM
                ELSE; LINFO = -100; END IF
                END IF
        IF( PRESENT(Z) .AND. .NOT.PRESENT(IFAIL) ) DEALLOCATE( LIFAIL, STAT=ISTAT1(1) )
        IF( PRESENT(Z) .AND. .NOT.PRESENT(Q) ) DEALLOCATE( LQ, STAT=ISTAT1(1) )
        DEALLOCATE(IWORK, WORK, RWORK,  STAT=ISTAT1(1))
      END IF
      CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE ZHBGVX_F95

              

      SUBROUTINE ZGESVX_F95( A, B, X, AF, IPIV, FACT, TRANS, EQUED, R, C, FERR, BERR, RCOND,     &
                             RPVGRW, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!     .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => DP
      USE LA_AUXMOD, ONLY: LSAME, ERINFO
      USE F77_LAPACK, ONLY: GESVX_F77 => LA_GESVX
!     .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!     .. SCALAR ARGUMENTS ..
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
      CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
!     .. ARRAY ARGUMENTS ..
      COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
      COMPLEX(WP), INTENT(OUT) :: X(:,:)
      INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: IPIV(:)
      REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: C(:), R(:)
      COMPLEX(WP), INTENT(INOUT), OPTIONAL, TARGET :: AF(:,:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: FERR(:), BERR(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_GESVX computes the solution to a real or complex linear system of
! equations of the form A*X = B, A^T*X = B or A^H*X = B, where A is a 
! square matrix and X and B are rectangular matrices or vectors.
!    LA_GESVX can also optionally equilibrate the system if A is poorly
! scaled, estimate the condition number of (the equilibrated) A, return 
! the pivot growth factor, and compute error bounds.
! 
! =========
! 
!     SUBROUTINE LA_GESVX ( A, B, X, AF=af, IPIV=ipiv, FACT=fact, &
!                  TRANS=trans, EQUED=equed, R=r, C=c, FERR=ferr, &
!                  BERR=berr, RCOND=rcond, RPVGRW=rpvgrw, &
!                  INFO=info )
!          <type>(<wp>), INTENT(INOUT) :: A(:,:), <rhs>
!          <type>(<wp>), INTENT(OUT) :: <sol>
!          <type>(<wp>), INTENT(INOUT), OPTIONAL :: AF(:,:)
!          INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
!          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT, &
!                                       TRANS
!          CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
!          REAL(<wp>), INTENT(INOUT), OPTIONAL :: R(:), C(:)
!          REAL(<wp>), INTENT(OUT), OPTIONAL :: <err>, RCOND, RPVGRW
!          INTEGER, INTENT(OUT), OPTIONAL :: INFO
!     where
!          <type> ::= REAL | COMPLEX
!          <wp>   ::= KIND(1.0) | KIND(1.0D0)
!          <rhs>  ::= B(:,:) | B(:)
!          <sol>  ::= X(:,:) | X(:)
!          <err>  ::= FERR(:), BERR(:) | FERR, BERR
! 
! Arguments
! =========
! 
! A         (input/output) REAL or COMPLEX square array, shape (:,:).
!           On entry, the matrix A or its equilibration:
!           If FACT = 'F' and EQUED /= 'N' then A has been equilibrated 
!           by the scaling factors in R and/or C during a previous call
! 	    to LA_GESVX.
!           On exit, if FACT = 'E', then the equilibrated version of A
! 	    is stored in A; otherwise, A is unchanged.
! B         (input/output) REAL or COMPLEX array, shape (:,:) with 
!           size(B,1) = size(A,1) or shape (:) with size(B) = size(A,1).
!           On entry, the matrix B.
!           On exit, the scaled version of B if the system has been 
!           equilibrated; otherwise, B is unchanged.
! X         (output) REAL or COMPLEX array, shape (:,:) with size(X,1) =
!           size(A,1) and size(X,2) = size(B,2), or shape (:) with 
! 	    size(X) = size(A,1).
!           The solution matrix X .
! AF        Optional (input or output) REAL or COMPLEX square array, 
!           shape (:,:) with the same size as A.
!           If FACT = 'F' then AF is an input argument that contains the
!           factors L and U of (the equilibrated) A returned by a
! 	    previous call to LA_GESVX.
!           If FACT /= 'F' then AF is an output argument that contains 
!           the factors L and U of (the equilibrated) A.
! IPIV      Optional (input or output) INTEGER array, shape (:) with 
!           size(IPIV) = size(A,1).
!           If FACT = 'F' then IPIV is an input argument that contains 
!           the pivot indices from the factorization of (the 
! 	    equilibrated) A, returned by a previous call to LA_GESVX.
!           If FACT /= 'F' then IPIV is an output argument that contains
!           the pivot indices from the factorization of (the
! 	    equilibrated) A.
! FACT      Optional (input) CHARACTER(LEN=1).
!           Specifies whether the factored form of the matrix A is 
!           supplied on entry, and, if not, whether the matrix A should
!           be equilibrated before it is factored.
!            = 'N': The matrix A will be copied to AF and factored (no 
! 	          equilibration).
!            = 'E': The matrix A will be equilibrated, then copied to AF
! 	          and factored.
!            = 'F': AF and IPIV contain the factored form of (the 
! 	          equilibrated) A.
!           Default value: 'N'.
! TRANS     Optional (input) CHARACTER(LEN=1).
!           Specifies the form of the system of equations:
!            = 'N': A*X = B (No transpose)
!            = 'T': A^T*X = B (Transpose)
!            = 'C': A^H*X = B (Conjugate transpose)
! EQUED     Optional (input or output) CHARACTER(LEN=1).
!           Specifies the form of equilibration that was done.
!           EQUED is an input argument if FACT = 'F', otherwise it is an
!           output argument:
!            = 'N': No equilibration (always true if FACT = 'N').
!            = 'R': Row equilibration, i.e., A has been premultiplied by
! 	          diag(R).
!            = 'C': Column equilibration, i.e., A has been postmultiplied 
! 	          by diag(C).
!            = 'B': Both row and column equilibration.
!           Default value: 'N'.
! R         Optional (input or output) REAL array, shape (:) with size(R)
!           = size(A,1). The row scale factors for A.
!           R is an input argument if FACT = 'F' and EQUED = 'R' or 'B'.
!           R is an output argument if FACT = 'E' and EQUED = 'R' or 'B'.
! C         Optional (input or output) REAL array, shape (:) with size(C) 
!           = size(A,1). The column scale factors for A.
!           C is an input argument if FACT = 'F' and EQUED = 'C' or 'B'.
!           C is an output argument if FACT = 'E' and EQUED = 'C' or 'B'.
! FERR      Optional (output) REAL array of shape (:), with size(FERR) =
!           size(X,2), or REAL scalar.
!           The estimated forward error bound for each solution vector 
!           X(j) (the j-th column of the solution matrix X). If XTRUE is 
!           the true solution corresponding to X(j) , FERR(j) is an 
! 	    estimated upper bound for the magnitude of the largest 
! 	    element in (X(j)-XTRUE) divided by the magnitude of the 
! 	    largest element in X(j). The estimate is as reliable as the
!           estimate for RCOND and is almost always a slight 
! 	    overestimate of the true error.
! BERR      Optional (output) REAL array of shape (:), with size(BERR) =
!           size(X,2), or REAL scalar.
!           The componentwise relative backward error of each solution 
!           vector X(j) (i.e., the smallest relative change in any
!           element of A or B that makes X(j) an exact solution).
! RCOND     Optional (output) REAL.
!           The estimate of the reciprocal condition number of (the 
!           equilibrated) A. If RCOND is less than the machine precision,
!           the matrix is singular to working precision. This condition 
!           is indicated by a return code of INFO > 0.
! RPVGRW    Optional (output) REAL.
!           The reciprocal pivot growth factor ||A||inf = ||U||inf. If
!           RPVGRW is much less than 1, then the stability of the LU 
!           factorization of the (equilibrated) matrix A could be poor.
!           This also means that the solution X , condition estimator 
!           RCOND, and forward error bound FERR could be unreliable. If
!           the factorization fails with 0 < INFO <= size(A,1), then
!           RPVGRW contains the reciprocal pivot growth factor for the 
!           leading INFO columns of A.
! INFO      Optional (output) INTEGER
!           = 0: successful exit.
!           < 0: if INFO = -i, the i-th argument had an illegal value.
!           > 0: if INFO = i, and i is
!               <= n: U(i,i) = 0. The factorization has been completed,
!                    but the factor U is singular, so the solution could 
! 		   not be computed.
!               = n+1: U is nonsingular, but RCOND is less than machine 
! 	           precision, so the matrix is singular to working 
! 		   precision. Nevertheless, the solution and error
!                    bounds are computed because the computed solution 
! 		   can be more accurate than the value of RCOND would 
! 		   suggest.
!           If INFO is not present and an error occurs, then the program 
! 	    is terminated with an error message.
!----------------------------------------------------------------------
!     .. PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GESVX'
!     .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: LFACT, LTRANS, LEQUED
      INTEGER :: ISTAT, ISTAT1, LD, LINFO, N, NRHS, S1AF, S2AF, SBERR, SC, SFERR, SIPIV, SR
      REAL(WP) :: LRCOND, MVR, MVC
!     .. LOCAL POINTERS ..
      INTEGER, POINTER :: LPIV(:)
      REAL(WP),  POINTER :: LC(:), LR(:), LFERR(:), LBERR(:), RWORK(:)
      COMPLEX(WP),  POINTER :: WORK(:), LAF(:, :)
!     .. INTRINSIC FUNCTIONS ..
      INTRINSIC MAX, PRESENT, SIZE, MINVAL, TINY
!     .. EXECUTABLE STATEMENTS ..
      LINFO = 0; ISTAT = 0; N = SIZE(A, 1); NRHS = SIZE(B, 2)
      LD = MAX(1,N)
      IF( PRESENT(RCOND) ) RCOND = 1.0_WP
      IF( PRESENT(RPVGRW) ) RPVGRW = 1.0_WP
      IF( PRESENT(FACT) )THEN
         LFACT = FACT
      ELSE
         LFACT='N'
      END IF
      IF( PRESENT(EQUED) .AND. LSAME(LFACT,'F') )THEN
         LEQUED = EQUED
      ELSE
         LEQUED='N'
      END IF
      IF( PRESENT(IPIV) )THEN
         SIPIV = SIZE(IPIV)
      ELSE
         SIPIV = N
      END IF
      IF( PRESENT(AF) )THEN
         S1AF = SIZE(AF,1); S2AF = SIZE(AF,2)
      ELSE
         S1AF = N; S2AF = N
      END IF
      IF( ( PRESENT(C) ) )THEN
         SC = SIZE(C)
      ELSE
         SC = N
      END IF
      IF( ( PRESENT(C) .AND. LSAME(LFACT,'F') ) .AND.                   &
     &    ( LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') ) )THEN
         MVC = MINVAL(C)
      ELSE
         MVC = TINY(1.0_WP)
      END IF
      IF( PRESENT(R) )THEN
         SR = SIZE(R)
      ELSE
         SR = N
      END IF
      IF( ( PRESENT(R) .AND. LSAME(LFACT,'F') ) .AND.                   &
     &    ( LSAME(LEQUED,'R') .OR. LSAME(LEQUED,'B') ) )THEN
         MVR = MINVAL(R)
      ELSE
         MVR = TINY(1.0_WP)
      END IF
      IF( PRESENT(FERR) )THEN
         SFERR = SIZE(FERR)
      ELSE
         SFERR = NRHS
      END IF
      IF( PRESENT(BERR) )THEN
         SBERR = SIZE(BERR)
      ELSE
         SBERR = NRHS
      END IF
      IF(PRESENT(TRANS))THEN
         LTRANS = TRANS
      ELSE
         LTRANS='N'
      END IF
!     .. TEST THE ARGUMENTS
      IF( SIZE(A, 2) /= N .OR. N < 0 )THEN
         LINFO = -1
      ELSE IF( SIZE(B, 1) /= N .OR. NRHS < 0 )THEN
         LINFO = -2
      ELSE IF( SIZE(X, 1) /= N .OR. SIZE(X, 2) /= NRHS )THEN
         LINFO = -3
      ELSE IF( S1AF /= N .OR. S2AF /= N ) THEN
         LINFO = -4
      ELSE IF( SIPIV /= N )THEN
         LINFO = -5
      ELSE IF( SR /= N .OR. MVR <= 0.0_WP )THEN
         LINFO = -9
      ELSE IF( SC /= N .OR. MVC <= 0.0_WP )THEN
         LINFO = -10
      ELSE IF( SFERR /= NRHS )THEN
         LINFO = -11
      ELSE IF( SBERR /= NRHS )THEN
         LINFO = -12
      ELSE IF( ( .NOT. ( LSAME(LFACT,'F') .OR. LSAME(LFACT,'N') .OR.    &
     &                 LSAME(LFACT,'E') ) ) .OR.                        &
     &    ( LSAME(LFACT,'F') .AND. .NOT.( PRESENT(AF) .AND.             &
     &      PRESENT(IPIV) ) ) )THEN
         LINFO = -6
      ELSE IF( .NOT.( LSAME(LTRANS,'N') .OR.  LSAME(LTRANS,'T') .OR.    &
     &               LSAME(LTRANS,'C') ) )THEN
         LINFO = -7
      ELSE IF( ( .NOT.( LSAME(LEQUED,'N') .OR. LSAME(LEQUED,'R') .OR.   &
     &       LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') )                 &
     &           .AND. LSAME(LFACT,'F') ) .OR.                          &
     &      ( ( LSAME(LEQUED,'R') .OR. LSAME(LEQUED,'B') ) .AND.        &
     &           .NOT.PRESENT(R) ) .OR.                                 &
     &      ( ( LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') ) .AND.        &
     &           .NOT.PRESENT(C) ) )THEN
         LINFO = -8
      ELSE IF ( N > 0 )THEN
         IF( .NOT.PRESENT(AF) ) THEN
            ALLOCATE( LAF(LD,N), STAT=ISTAT )
         ELSE
            LAF => AF
         END IF
         IF( ISTAT == 0 )THEN
            IF( .NOT.PRESENT(IPIV) )THEN
               ALLOCATE( LPIV(N), STAT=ISTAT )
            ELSE
               LPIV => IPIV
            END IF
         END IF
         IF( ISTAT == 0 )THEN
            IF( .NOT.PRESENT(R) )THEN
               ALLOCATE( LR(N), STAT=ISTAT )
            ELSE
               LR => R
            END IF
         END IF
         IF( ISTAT == 0 )THEN
            IF( .NOT.PRESENT(C) )THEN
               ALLOCATE( LC(N), STAT=ISTAT )
            ELSE
               LC => C
            END IF
         END IF
         IF( ISTAT == 0 )THEN
            IF( .NOT.PRESENT(FERR) )THEN
               ALLOCATE( LFERR(NRHS), STAT=ISTAT )
            ELSE
               LFERR => FERR
            END IF
         END IF
         IF( ISTAT == 0 )THEN
            IF( .NOT.PRESENT(BERR) )THEN
               ALLOCATE( LBERR(NRHS), STAT=ISTAT )
            ELSE
               LBERR => BERR
            END IF
         END IF
         IF( ISTAT == 0 )THEN
            ALLOCATE(WORK(2*N), RWORK(2*N), STAT=ISTAT )
         END IF
         IF( ISTAT == 0 )THEN
!           .. CALL LAPACK77 ROUTINE
            CALL GESVX_F77( LFACT, LTRANS, N, NRHS, A, LD, LAF, LD, LPIV, LEQUED, LR, LC, B, LD, &
                            X, LD, LRCOND, LFERR, LBERR, WORK, RWORK, LINFO )
         ELSE
            LINFO = -100
         END IF
         IF( .NOT.PRESENT(R) ) DEALLOCATE( LR, STAT=ISTAT1 )
         IF( .NOT.PRESENT(C) ) DEALLOCATE( LC, STAT=ISTAT1 )
         IF( .NOT.PRESENT(AF) ) DEALLOCATE( LAF, STAT=ISTAT1 )
         IF( .NOT.PRESENT(IPIV) ) DEALLOCATE( LPIV, STAT=ISTAT1 )
         IF( .NOT.PRESENT(FERR) ) DEALLOCATE( LFERR, STAT=ISTAT1 )
         IF( .NOT.PRESENT(BERR) ) DEALLOCATE( LBERR, STAT=ISTAT1 )
         IF( PRESENT(RPVGRW) ) RPVGRW=RWORK(1)
         IF( PRESENT(RCOND) ) RCOND=LRCOND
         IF( PRESENT(EQUED) .AND. .NOT.LSAME(LFACT,'F') ) EQUED=LEQUED
         DEALLOCATE( WORK, RWORK, STAT=ISTAT1 )
      END IF
      CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
      END SUBROUTINE ZGESVX_F95

SUBROUTINE LA_TEST_CGEGV(JOBVL, JOBVR, N, A, LDA, B, LDB, ALPHA, BETA, VL, LDVL, VR, LDVR, WORK, LWORK, RWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 5, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GEGV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDA, LDB, LDVL, LDVR, LWORK
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBVL, JOBVR
!  .. Array Arguments ..
   COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB, 1:N)
   COMPLEX(WP), INTENT(OUT):: WORK(1:LWORK)
   COMPLEX(WP), INTENT(OUT) :: ALPHA(1:N), BETA(1:N), &
&    VL(1: LDVL, 1:N), VR(1: LDVR, 1:N)
   REAL(WP), INTENT(OUT) :: RWORK(1:8*N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GEGV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_CGEGV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IALPHA, IBETA, IVL1, &
&    IVL2, IVR1, IVR2
   CHARACTER*1 :: IJOBVL, IJOBVR
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IJOBVL = JOBVL; IJOBVR = JOBVR
   IB1 = N; IB2 = N; IALPHA = N; IBETA = N
   IVL1 = N; IVL2 = N; IVR1 = N; IVR2 = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
       IA2 = IA1 - 1
     CASE (2)
       IB1 = IA1 - 1
     CASE (3)
       IALPHA = IA1 - 1
     CASE (4)
       IALPHA = IA1 - 1
     CASE (5)
       IBETA  = IA1 - 1
     CASE (6)
       IVL1 = IA1 - 1
     CASE (7)
       IVR1 = IA1 - 1
     CASE(:-1,8:)
       CALL UESTOP(SRNAMT)
   END SELECT

   IF (LSAME(IJOBVL,'V')) THEN
     IF (LSAME (IJOBVR, 'V')) THEN
       CALL LA_GEGV( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHA(1: IALPHA), &
&        BETA(1: IBETA), VL(1:IVL1,1:IVL2), &
&        VR(1:IVR1,1:IVR2), INFO)    
     ELSE
       CALL LA_GEGV( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHA(1: IALPHA), &
&        BETA(1: IBETA), VL(1:IVL1,1:IVL2), &
&        INFO = INFO)
     END IF
   ELSE 
     IF (LSAME (IJOBVR, 'V')) THEN
       CALL LA_GEGV( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHA(1: IALPHA), &
&        BETA(1: IBETA),&
&        VR = VR(1:IVR1,1:IVR2), INFO = INFO)
     ELSE
       CALL LA_GEGV( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHA(1: IALPHA), &
&        BETA(1: IBETA), &
&        INFO = INFO)
     END IF
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_CGEGV
      
      

SUBROUTINE LA_TEST_ZHBGV( JOBZ, UPLO, N, KA, KB, AB, LDAB, BB, LDBB, W, Z, LDZ, WORK, RWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 21, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_HBGV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, KA, KB, LDAB, LDBB, LDZ
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBZ, UPLO
!  .. Array Arguments ..
   COMPLEX(WP), INTENT(INOUT) :: AB(1:LDAB, 1:N), BB( 1:LDBB, 1:N)
   REAL(WP), INTENT(OUT):: W(1:N)
   COMPLEX(WP), INTENT(OUT) :: WORK(1:3*N), Z(1:LDZ, 1:N)
   REAL(WP) :: RWORK(1: 3*N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_HBGV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_ZHBGV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IAB1, IAB2, IW, IBB1, IBB2, IZ1, IZ2
   CHARACTER*1 :: IUPLO, IJOBZ   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IAB1 = KA + 1; IAB2 = N; IUPLO = UPLO; IW = N; IJOBZ = JOBZ
   IBB1 = KB + 1; IBB2 = N; IZ1 = N; IZ2 = N 
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
      IAB1  = IAB1 - 1
     CASE (2)
       IBB2 = IBB2 - 1
     CASE (3)
       IW = IW - 1
     CASE (4)
       IUPLO = 'T'
     CASE (5)
       IZ2 = IZ2 - 1
       IJOBZ = 'V'
     CASE(:-1,6:)
       CALL UESTOP(SRNAMT)
   END SELECT
   IF (LSAME(IJOBZ, 'V')) THEN
     CALL LA_HBGV( AB(1:IAB1, 1: IAB2), BB(1:IBB1, 1:IBB2), W(1 :IW), &
&       IUPLO, Z(1:IZ1, 1: IZ2), INFO )
   ELSE
     CALL LA_HBGV( AB(1:IAB1, 1: IAB2), BB(1:IBB1, 1:IBB2), W(1 :IW), &
&      IUPLO, INFO = INFO )
   END IF

   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_ZHBGV
      
      

SUBROUTINE SSPEV_F95( A, W, UPLO, Z, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: SPEV_F77 => LA_SPEV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. CHARACTER ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:)
   REAL(WP), INTENT(OUT) :: W(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!     LA_SPEV and LA_SPEVD compute all eigenvalues and, optionally, all
! eigenvectors of a real symmetric matrix A in packed storage.
!     LA_HPEV and LA_HPEVD compute all eigenvalues and, optionally, all
! eigenvectors of a complex Hermitian matrix A in packed storage.
!     LA_SPEVD and LA_HPEVD use a divide and conquer algorithm. If 
! eigenvectors are desired, they can be much faster than LA_SPEV and 
! LA_HPEV for large matrices but use more workspace.
! 
! =========
! 
!       SUBROUTINE LA_SPEV / LA_HPEV / LA_SPEVD / LA_HPEVD( AP, W, &
!                     UPLO=uplo, Z=z, INFO=info )
!           <type>(<wp>), INTENT(INOUT) :: AP(:)
!           REAL(<wp>), INTENT(OUT) :: W(:)
!           CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!           <type>(<wp>), INTENT(OUT), OPTIONAL :: Z(:,:)
!           INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!           <type> ::= REAL | COMPLEX
!           <wp>   ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! AP      (input/output) REAL or COMPLEX array, shape (:) with size(AP)=
!         n*(n+1)/2, where n is the order of A.
!         On entry, the upper or lower triangle of matrix A in packed 
!  	  storage. The elements are stored columnwise as follows:
!         if UPLO = 'U', AP(i+(j-1)*j/2)=A(i,j) for 1<=i<=j<=n;
!         if UPLO = 'L', AP(i+(j-1)*(2*n-j)/2)=A(i,j) for 1<=j<=i<=n.
!         On exit, AP is overwritten by values generated during the 
!         reduction of A to a tridiagonal matrix T . If UPLO = 'U', the
!         diagonal and first superdiagonal of T overwrite the correspond-
!         ing diagonals of A. If UPLO = 'L', the diagonal and first
! 	  subdiagonal of T overwrite the corresponding diagonals of A.
! W       (output) REAL array, shape (:) with size(W) = n.
!         The eigenvalues in ascending order.
! UPLO    Optional (input) CHARACTER(LEN=1).
!         = 'U': Upper triangle of A is stored;
!         = 'L': Lower triangle of A is stored.
!         Default value: 'U'.
! Z       Optional (output) REAL or COMPLEX square array, shape (:,:)
!         with size(Z,1) = n.
!         The columns of Z contain the orthonormal eigenvectors of A in
! 	  the order of the eigenvalues.
! INFO    Optional (output) INTEGER.
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value
!         > 0: if INFO = i, then i off-diagonal elements of an 
! 	  intermediate tridiagonal form did not converge to zero.
!         If INFO is not present and an error occurs, then the program is
! 	  terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_SPEV'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LUPLO, LJOBZ
   INTEGER :: N, NN, LINFO, LD, ISTAT, ISTAT1, S1Z, S2Z
   COMPLEX(WP) :: WW
!  .. LOCAL ARRAYS ..
   REAL(WP), TARGET :: LLZ(1,1)
   REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; NN = SIZE(A)
   WW = (-1+SQRT(1+8*REAL(NN,WP)))*0.5; N = INT(WW);  LD = MAX(1,N)
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
   IF( PRESENT(Z) )THEN; S1Z = SIZE(Z,1); S2Z = SIZE(Z,2); LJOBZ = 'V'
   ELSE; S1Z = 1; S2Z = 1; LJOBZ = 'N'; END IF
!  .. TEST THE ARGUMENTS
   IF( NN < 0 .OR. AIMAG(WW) /= 0 .OR. REAL(N,WP) /= REAL(WW) ) THEN; LINFO = -1
   ELSE IF( SIZE( W ) /= N )THEN; LINFO = -2
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
   ELSE IF( PRESENT(Z) .AND. ( S1Z /= LD .OR. S2Z /= N ) )THEN; LINFO = -4
   ELSE IF( N > 0 )THEN
!  .. DETERMINE THE WORKSPACE
      ALLOCATE(WORK(MAX(1,3*N)), STAT=ISTAT)
      IF( ISTAT == 0 ) THEN
         IF( PRESENT(Z) )THEN
   !     .. CALL LAPACK77 ROUTINE
          CALL SPEV_F77( LJOBZ, LUPLO, N, A, W, Z, S2Z, WORK, LINFO )
	 ELSE
	  CALL SPEV_F77( LJOBZ, LUPLO, N, A, W, LLZ, S2Z, WORK, LINFO )
	 ENDIF 
      ELSE; LINFO = -100; ENDIF
      DEALLOCATE(WORK,STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE SSPEV_F95

SUBROUTINE DPTSVX_F95(D, E, B, X, DF, EF, FACT, FERR, BERR, RCOND, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: PTSVX_F77 => LA_PTSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(IN) :: D(:)
   REAL(WP), INTENT(IN) :: E(:), B(:,:)
   REAL(WP), INTENT(OUT) :: X(:,:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: DF(:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: EF(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: FERR(:), BERR(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_PTSVX computes the solution to a linear system of equations 
! A*X = B, where A has tridiagonal form and is real symmetric or complex
! Hermitian and, in either case, positive definite, and where X and B are
! rectangular matrices or vectors.
!    LA_PTSVX can also optionally estimate the condition number of A and
! compute error bounds.
! 
! =========
! 
!     SUBROUTINE LA_PTSVX( D, E, B, X, DF=df, EF=ef, FACT=fact, &
!                  FERR=ferr, BERR=berr, RCOND=rcond, INFO=info )
!          REAL(<wp>), INTENT(IN) :: D(:)
!          <type>(<wp>), INTENT(IN) :: E(:), <rhs>
!          <type>(<wp>), INTENT(OUT) :: <sol>
!          REAL(<wp>), INTENT(INOUT), OPTIONAL :: DF(:)
!          <type>(<wp>), INTENT(INOUT), OPTIONAL :: EF(:)
!          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: FACT
!          REAL(<wp>), INTENT(OUT), OPTIONAL :: <err>, RCOND
!          INTEGER, INTENT(OUT), OPTIONAL :: INFO
!     where
!          <type> ::= REAL | COMPLEX
!          <wp>   ::= KIND(1.0) | KIND(1.0D0)
!          <rhs>  ::= B(:,:) | B(:)
!          <sol>  ::= X(:,:) | X(:)
!          <err>  ::= FERR(:), BERR(:) | FERR, BERR
! 
! Arguments
! =========
! 
! D       (input) REAL array, shape (:) with size(D) = n, where n is the 
!         order of A.
!         The diagonal of A.
! E       (input) REAL or COMPLEX array, shape (:) with size(E) = n-1.
!         The subdiagonal of A.
! B       (input) REAL or COMPLEX array, shape (:,:) with size(B,1) = n 
!         or shape (:) with size(B) = n.
!         The matrix B.
! X       (output) REAL or COMPLEX array, shape (:,:) with size(X,1) = n
!         and size(X,2) = size(B,2), or shape (:) with size(X) = n.
!         The solution matrix X .
! DF      Optional (input or output) REAL array, shape (:) with the same 
!         size as D.
!         If FACT = 'F', then DF is an input argument that contains the 
!         diagonal of D from the L*D*L^H factorization of A.
!         If FACT = 'N', then DF is an output argument that contains the
!         diagonal of D from the L*D*L^H factorization of A.
! EF      Optional (input or output) REAL or COMPLEX array, shape (:) with
!         the same size as E.
!         If FACT = 'F', then EF is an input argument that contains the 
!         subdiagonal of L from the L*D*L^H factorization of A.
!         If FACT = 'N', then EF is an output argument that contains the 
!         subdiagonal of L from the L*D*L^H factorization of A.
! FACT    Optional (input) CHARACTER(LEN=1).
!         Specifies whether the factored form of A has been supplied on
! 	  entry.
!           = 'N': The matrix A will be copied to DF and EF and factored.
!           = 'F': DF and EF contain the factored form of A.
!         Default value: 'N'.
! FERR    Optional (output) REAL array of shape (:), with 
!         size(FERR) = size(X,2), or REAL scalar.
!         The estimated forward error bound for each solution vector X(j)
! 	  (the j-th column of the solution matrix X). If XTRUE is the 
! 	  true solution corresponding to X(j), FERR(j) is an estimated 
!         upper bound for the magnitude of the largest element in 
! 	  (X(j)-XTRUE) divided by the magnitude of the largest element in
! 	  X(j).
! BERR    Optional (output) REAL array of shape (:), with size(BERR) = 
!         size(X,2), or REAL scalar.
!         The componentwise relative backward error of each solution 
!         vector X(j) (i.e., the smallest relative change in any element 
!         of A or B that makes X(j) an exact solution).
! RCOND   Optional (output) REAL.
!         The estimate of the reciprocal condition number of the matrix 
!         A. If RCOND is less than the machine precision, the matrix is 
!         singular to working precision. This condition is indicated by
!         a return code of INFO > 0.
! INFO    Optional (output) INTEGER
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: if INFO = i, and i is
!             <= n: the leading minor of order i of A is not positive 
! 	         definite, so the factorization could not be completed
! 		 unless i = n, and the solution and error bounds could 
! 		 not be computed. RCOND = 0 is returned.
!             = n+1: L is nonsingular, but RCOND is less than machine 
! 	         precision, so the matrix is singular to working 
! 		 precision. Nevertheless, the solution and error
!                  bounds are computed because the computed solution can
!                  be more accurate than the value of RCOND would suggest.
!         If INFO is not present and an error occurs, then the program is
! 	  terminated with an error message.
!-----------------------------------------------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_PTSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT
   INTEGER :: LINFO, NRHS, N, ISTAT, ISTAT1, SDF, SEF, SFERR, SBERR
   REAL(WP) :: LRCOND
!  .. LOCAL POINTERS ..
   REAL(WP),  POINTER :: LDF(:), LFERR(:), LBERR(:)
   REAL(WP),  POINTER :: WORK(:), LEF(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0
   N = SIZE(D); NRHS = SIZE(B,2)
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(DF) )THEN; SDF = SIZE(DF); ELSE; SDF = N; END IF
   IF( PRESENT(EF) )THEN; SEF = SIZE(EF); ELSE; SEF = N-1; END IF
   IF( PRESENT(FERR) )THEN; SFERR = SIZE(FERR); ELSE; SFERR = NRHS; END IF
   IF( PRESENT(BERR) )THEN; SBERR = SIZE(BERR); ELSE; SBERR = NRHS; END IF
!  .. TEST THE ARGUMENTS
   IF( N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE( E ) /= N-1 .AND. N /= 0 ) THEN; LINFO = -2
   ELSE IF( SIZE(B, 1) /= N .OR. NRHS < 0 )THEN; LINFO = -3
   ELSE IF( SIZE(X, 1) /= N .OR. SIZE(X, 2) /= NRHS )THEN; LINFO = -4
   ELSE IF( SDF /= N ) THEN; LINFO = -5
   ELSE IF( .NOT.( PRESENT(DF).AND.PRESENT(EF) ) &
       .AND.( PRESENT(DF).OR.PRESENT(EF) ) )THEN; LINFO = -5
   ELSE IF( SEF /= N-1 .AND. N>0 ) THEN; LINFO = -6
   ELSE IF( ( .NOT.LSAME(LFACT,'F') .AND. .NOT.LSAME(LFACT,'N') ) .OR. &
            ( LSAME(LFACT,'F') .AND. .NOT.PRESENT(DF) ) )THEN; LINFO = -7
   ELSE IF( SFERR /= NRHS )THEN; LINFO = -8
   ELSE IF( SBERR /= NRHS )THEN; LINFO = -9
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(DF) ) THEN; ALLOCATE( LDF(N), LEF(N-1), STAT=ISTAT )
      ELSE; LDF => DF; LEF => EF; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(FERR) )THEN; ALLOCATE( LFERR(NRHS), STAT=ISTAT )
         ELSE; LFERR => FERR; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(BERR) )THEN; ALLOCATE( LBERR(NRHS), STAT=ISTAT )
         ELSE; LBERR => BERR; END IF
      END IF
      IF( ISTAT == 0 ) ALLOCATE(WORK(2*N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
         CALL PTSVX_F77( LFACT, N, NRHS, D, E, LDF, LEF, B, N, X, N, LRCOND, &
                         LFERR, LBERR, WORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(DF) ) DEALLOCATE( LDF, LEF, STAT=ISTAT1 )
      IF( .NOT.PRESENT(FERR) ) DEALLOCATE( LFERR, STAT=ISTAT1 )
      IF( .NOT.PRESENT(BERR) ) DEALLOCATE( LBERR, STAT=ISTAT1 )
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      DEALLOCATE( WORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE DPTSVX_F95

PROGRAM LA_ZHPGVX_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
  USE LA_PRECISION, ONLY: WP => DP
  USE F95_LAPACK, ONLY: LA_HPGVX
!  .. IMPLICIT STATEMENT ..
  IMPLICIT NONE
!  .. PARAMETERS ..
  CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F7.3,1H,,F7.3,1H):))'
  INTEGER, PARAMETER :: NIN=5, NOUT=6
  CHARACTER(LEN=1) :: UPLO
!  .. LOCAL SCALARS ..
  INTEGER :: I, J, INFO, N, NS
  REAL(WP) :: VL, VU
  INTEGER ::  M, ITYPE, IL, IU 
!  .. LOCAL ARRAYS ..
  REAL(WP), ALLOCATABLE :: AA(:), BB(:), W(:)
  COMPLEX(WP), ALLOCATABLE :: A(:), B(:), Z(:,:)
  INTEGER, ALLOCATABLE :: IFAIL(:)   
!  .. EXECUTABLE STATEMENTS ..
  WRITE (NOUT,*) 'ZHPGVX ET_Example Program Results.'
  READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
  READ ( NIN, * ) N
  PRINT *, 'N = ', N
  NS = N*(N+1)/2
  ALLOCATE ( A(NS), AA(NS), B(NS), BB(NS), W(N), Z(N,N), IFAIL(N) )
!
  READ (NIN, *) AA, BB
  A=AA; B=BB
  WRITE(NOUT,*) 'The matrix A:'
  DO I = 1, N
    WRITE (NOUT,*) 'J = ', I; WRITE (NOUT,FMT) (A(J+(I-1)*I/2),J=1,I)
  ENDDO
  WRITE(NOUT,*) 'The matrix B:'
  DO I = 1, N
    WRITE (NOUT,*) 'J = ', I; WRITE (NOUT,FMT) (B(J+(I-1)*I/2),J=1,I)
  ENDDO
  ITYPE = 1; UPLO = 'L'; IL=1 ; IU=N; VL=-10; VU=10
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_ZHPGVX LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   UPLO = 'U'
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, 1, ''U'', Z, INFO=INFO )'
   A=AA; B=BB
   CALL LA_HPGVX( A, B, W, 1, UPLO, Z, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
   WRITE(NOUT,*) 'INFO = ', INFO
   WRITE(NOUT,*) 'The orthonormal eigenvectors of the matrix A stored in Z'
   DO I = 1, N
     WRITE(NOUT,FMT) Z(I,:)
   END DO    
!
   UPLO = 'U'
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, 2, ''U'', Z , INFO = INFO)'
   A=AA; B=BB
   CALL LA_HPGVX( A, B, W, 2, UPLO, Z, INFO = INFO )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
     WRITE(NOUT,*) 'INFO = ', INFO
!
        WRITE(NOUT,*)
        WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, 3, Z=Z, INFO=INFO )'
        A=AA; B=BB
        CALL LA_HPGVX( A, B, W, 3, Z=Z, INFO=INFO )
        WRITE(NOUT,*) ' EIGENVALUES:'
        WRITE(NOUT,FMT) W
        WRITE(NOUT,*) 'EIGENVECTORS:'
        DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
        WRITE(NOUT,*) 'INFO = ', INFO
!
        UPLO= 'L'
        WRITE(NOUT,*)
        WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, 1, Z, VL, VU, INFO=INFO )'
        A=AA; B=BB; W = HUGE(1.0_WP); Z = HUGE(1.0_WP)
        CALL LA_HPGVX( A, B, W, 1, Z=Z, VL=VL, VU=VU, INFO=INFO )
        WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
        WRITE(NOUT,FMT) W
        WRITE(NOUT,*) 'EIGENVECTORS:'
        DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
        WRITE(NOUT, *) 'The lower bound of the interval to be searched for eigenvalues VL= ', VL
        WRITE(NOUT, *) 'The upper bound of the interval to be searched for eigenvalues VU= ', VU  
!
        UPLO= 'L'
        WRITE(NOUT,*)
        WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, 1, Z, IL=IL, IU=IU, INFO=INFO )'
        A=AA; B=BB; W = HUGE(1.0_WP); Z = HUGE(1.0_WP)
        CALL LA_HPGVX( A, B, W, 1, Z=Z, IL=IL, IU=IU, INFO=INFO )
        WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
        WRITE(NOUT,FMT) W
        WRITE(NOUT,*) 'EIGENVECTORS:'
        DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
        WRITE(NOUT, *) 'The indices of the smallest eigenvalue to be returned: IL= ', IL
        WRITE(NOUT, *) 'The indices of the largest eigenvalue to be returned: IU= ', IU
!
        UPLO= 'U'
        WRITE(NOUT,*)
        WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, 1, UPLO=''U'', Z, IL=IL, IU=IU, M=M, &
     &    IFAIL=IFAIL, INFO=INFO )'
        A=AA; B=BB; W = HUGE(1.0_WP); Z = HUGE(1.0_WP)
        CALL LA_HPGVX( A, B, W, 1, UPLO, Z, IL=IL, IU=IU, M=M, IFAIL=IFAIL,INFO=INFO )
        WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
        WRITE(NOUT,FMT) W
        WRITE(NOUT,*) 'EIGENVECTORS:'
        DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
        WRITE(NOUT, *) 'The indices of the smallest eigenvalue to be returned: IL= ', IL
        WRITE(NOUT, *) 'The indices of the largest eigenvalue to be returned: IU= ', IU
        WRITE(NOUT,*) ' IFAIL  computed by LA_HPGVX:'
        WRITE(NOUT, *) IFAIL(:)
        WRITE(NOUT, *) 'The total number of eigenvalues found ', M 
! STARTING THE ERROR TESTS
!ERROR 1        
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HPGVX( A(1:5), B, W, INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_HPGVX( A(1:5), B, W, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!ERROR 2
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HPGVX( A, B(1:5), W, INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_HPGVX( A, B(1:5), W, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!ERROR 3
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W(1:N-1), INFO=INFO )'
   A=AA; B=BB; Z = HUGE(1.0_WP)
   CALL LA_HPGVX( A, B, W(1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!ERROR 4
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, 5, INFO=INFO )'
      A=AA; B=BB; Z = HUGE(1.0_WP)
      CALL LA_HPGVX( A, B, W, 5, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
!ERROR 5 
      UPLO = '9'
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, UPLO=''9'', INFO=INFO )'
      A=AA; B=BB; Z = HUGE(1.0_WP)
      CALL LA_HPGVX( A, B, W, UPLO=UPLO, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
      UPLO = 'U'
!ERROR 6 
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, Z=Z(1:N-1,:), INFO=INFO )'
      A=AA; B=BB; Z = HUGE(1.0_WP)
      CALL LA_HPGVX( A, B, W, Z=Z(1:N-1,:), INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO
!ERROR 6 
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, Z=Z(:,1:N-1), INFO=INFO )'
      A=AA; B=BB; Z = HUGE(1.0_WP)
      CALL LA_HPGVX( A, B, W, Z=Z(:,1:N-1), INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO      
!ERROR 7
      VL = 10; VU = -10
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, ITYPE, UPLO, Z, VL, VU, M=M, IFAIL=IFAIL, INFO=INFO )'
      A=AA; B=BB; Z = HUGE(1.0_WP)
      CALL LA_HPGVX( A, B, W, ITYPE, UPLO, Z, VL, VU, M=M, IFAIL=IFAIL, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO 
!ERROR 8
      VL = 10; VU=-10; IL = 1; IU = N
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, ITYPE, UPLO, Z, VL, VU, IL, IU, M, IFAIL, INFO=INFO )'
      A=AA; B=BB; Z = HUGE(1.0_WP)
      CALL LA_HPGVX( A, B, W, ITYPE, UPLO, Z, VL, VU, IL, IU, M, IFAIL, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO 
!ERROR 9
      IL=1; IU=N+1
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, ITYPE, UPLO, Z, IL=IL, IU=IU, M=M, IFAIL=IFAIL, INFO=INFO )'
      A=AA; B=BB; Z = HUGE(1.0_WP)
      CALL LA_HPGVX( A, B, W, ITYPE, UPLO, Z, IL=IL, IU=IU, M=M, IFAIL=IFAIL, INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO 
!ERROR 10
      IL=1; IU=N+1
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, ITYPE, UPLO, Z, IL=IL, IU=IU, M=M, IFAIL=IFAIL, INFO=INFO )'
      A=AA; B=BB; Z = HUGE(1.0_WP)
      CALL LA_HPGVX( A, B, W, ITYPE, UPLO, Z, IL=IL, IU=IU, M=M, IFAIL=IFAIL, INFO=INFO  )
      WRITE(NOUT,*) 'INFO = ', INFO 
! ERROR 12
      VL=-10; VU=10
      WRITE(NOUT,*)
      WRITE(NOUT,*) 'CALL LA_HPGVX( A, B, W, ITYPE, UPLO, Z, VL, VU, M=M, IFAIL=IFAIL(1:N-1), INFO=INFO )'
      A=AA; B=BB;
      CALL LA_HPGVX( A, B, W, ITYPE, UPLO, Z, VL, VU, M=M, IFAIL=IFAIL(1:N-1), INFO=INFO )
      WRITE(NOUT,*) 'INFO = ', INFO 
END PROGRAM LA_ZHPGVX_ET_EXAMPLE

      PROGRAM LA_HPGVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_HPGVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N, ITYPE, IL, IU, M, INFO
      REAL(WP), ALLOCATABLE :: W(:)
      REAL(WP) :: ABSTOL
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE :: IFAIL(:)
      COMPLEX(WP), ALLOCATABLE :: A(:), AA(:), B(:), BB(:), Z(:,:)
!  .. "Intrinsic Functions" ..
      INTRINSIC AIMAG, INT
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_HPGVX Example Program Results'
      N = 5
      ALLOCATE( A(N*(N+1)/2), AA(N*(N+1)/2), B(N*(N+1)/2), BB(N*(N+1)/2), &
                W(N), Z(N,N), IFAIL(N) )

      OPEN(UNIT=21,FILE='hpgvu.ma',STATUS='UNKNOWN')
      DO J=1,N*(N+1)/2
         READ(21,*) A(J)
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix A:'
      DO I=1,N*(N+1)/2
         WRITE(*,"('('(I3,1X,',',I3)')')") INT(A(I)), INT(AIMAG(A(I)))
      ENDDO
   

      OPEN(UNIT=21,FILE='hpgvu.mb',STATUS='UNKNOWN')
      DO J=1,N*(N+1)/2
         READ(21,*) B(J)
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix B:'
      DO I=1,N*(N+1)/2
         WRITE(*,"('('(I3,1X,',',I3)')')") INT(B(I)), INT(AIMAG(B(I)))
      ENDDO

      WRITE(*,*) "CALL LA_HPGVX( A, B, W, 2, Z=Z, IL=4, IU=5, M=M, ", &
                 "IFAIL=IFAIL, ABSTOL=1.0E-3_WP, INFO =INFO ) "
      ITYPE=2; IL=4; IU=5; ABSTOL=1e-3
      CALL LA_HPGVX( A, B, W, 2, Z=Z, IL=4, IU=5, M=M, &
                     IFAIL=IFAIL, ABSTOL=1.0E-3_WP, INFO = INFO )
      
      WRITE(*,*) 'W on exit:'
      DO I=1,N
         WRITE(*,"(5(E14.6,1X))") W(I)
      ENDDO

      WRITE(*,*) 'IFAIL on exit : ',IFAIL

      WRITE(*,*) 'M and INFO on exit:', M, INFO
      WRITE(*,*) 'Z on exit : '
      DO I=1,N
      WRITE(*,"(5(1H(,2(F12.10,1X),1H),1X))") (Z(I,J), J = 1,M)
      ENDDO

      END PROGRAM LA_HPGVX_EXAMPLE

!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
PROGRAM LA_DGTSVX_ET_EXAMPLE    
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GTSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, IFAIL, N, NRHS
   REAL(WP) :: RCOND
!  .. LOCAL ARRAYS ..
   INTEGER, ALLOCATABLE :: IPIV(:)
   REAL(WP), ALLOCATABLE :: DL(:), D(:), DU(:), B(:,:), &
             X(:,:), DLF(:), DF(:), DUF(:), DU2(:)
   REAL(WP), ALLOCATABLE :: DDL(:), DD(:), DDU(:), BB(:,:), FERR(:), BERR(:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'DGTSVX ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, NRHS
   PRINT *, 'N = ', N, ' NRHS = ', NRHS
   ALLOCATE ( DL(N-1), DDL(N-1), D(N), DD(N), DU(N-1), DDU(N-1), B(N,NRHS), BB(N,NRHS), &
         X(N,NRHS), IPIV(N), DLF(N-1), DF(N), DUF(N-1), DU2(N-2), FERR(NRHS), BERR(NRHS) )
!
        READ (NIN, *) DDU(:), DD(:), DDL(:)
        
      BB(1,:) = DD(1) + DDU(1)
!     BB(2:N-1,:) = DDL(1:N-2) + DD(2:N-1) + DDU(2:N-1)
      DO I = 2, N-1
         BB(I,:) = DDL(I-1) + DD(I) + DDU(I)
      ENDDO
      BB(N,:) = DDL(N-1) + DD(N-1)
      DO I = 1, NRHS
         BB(:,I) = BB(:,I)*I
      ENDDO
   DL = DDL; D = DD; DU = DDU; B = BB
      WRITE(NOUT,*) 'The matrix A:'
      WRITE (NOUT,*) 'DU '; WRITE (NOUT,FMT) DU
      WRITE (NOUT,*) 'D  '; WRITE (NOUT,FMT) D
      WRITE (NOUT,*) 'DL '; WRITE (NOUT,FMT) DL
      WRITE(NOUT,*) 'The RHS matrix B:'
      DO J = 1, NRHS
        WRITE (NOUT,*) 'RHS', J; WRITE (NOUT,FMT) B(:,J)
      ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_DDGTSVX LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GTSVX(DL, D, DU, B, X )'
   DL = DDL; D = DD; DU = DDU; B = BB
   CALL LA_GTSVX(DL, D, DU, B, X )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GTSVX:'
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GTSVX(DL, D, DU, B(1:N,1), X(1:N,1) )'
   DL = DDL; D = DD; DU = DDU; B = BB
   CALL LA_GTSVX(DL, D, DU, B(1:N,1), X(1:N,1) )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GTSVX:'
   WRITE (NOUT,FMT) X(:,1)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GTSVX(DL, D, DU, B, X, IPIV=IPIV)'
   DL = DDL; D = DD; DU = DDU; B = BB
   CALL LA_GTSVX(DL, D, DU, B, X, IPIV=IPIV )
   WRITE(NOUT,*) 'Pivots ', IPIV
   WRITE(NOUT,*)
   WRITE(NOUT,*) ' CALL LA_GTSVX(DL, D, DU, B(1:N,1), X(1:N,1), INFO=IFAIL )'
   DL = DDL; D = DD; DU = DDU; B = BB
   CALL LA_GTSVX(DL, D, DU, B(1:N,1), X(1:N,1), INFO=IFAIL )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GTSVX, INFO = ', IFAIL
   WRITE (NOUT,FMT) X(1:N,1)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GTSVX(DL, D, DU, B, X, DLF, DF, DUF, DU2, ', &
                 'IPIV, ''N'', ''N'', FERR, BERR, RCOND, IFAIL )'
   DL = DDL; D = DD; DU = DDU; B = BB; X = HUGE(1.0_WP)
   CALL LA_GTSVX(DL, D, DU, B, X, DLF, DF, DUF, DU2, IPIV, 'N', 'N', &
                   FERR, BERR, RCOND, IFAIL )
   WRITE(NOUT,*)'   X - the solution vectors computed by LA_GTSVX, INFO = ', &
                 IFAIL, ' RCOND = ', RCOND
   DO J = 1, NRHS; WRITE (NOUT,FMT) X(:,J); END DO
!
END PROGRAM LA_DGTSVX_ET_EXAMPLE

      PROGRAM LA_SSBEVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SBEVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, M, N, KD
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), W(:), Z(:,:), Q(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_SBEVX Example Program Results'
      N = 5; KD = 2;
      ALLOCATE( A(KD+1,N), W(N), Z(N,N), Q(N,N) )
   
      OPEN(UNIT=21,FILE='sbevu.ma',STATUS='UNKNOWN')
      DO I=1,KD+1 
         DO J=1,N
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix A:'
      DO I=1,KD+1; 
         WRITE(*,"(5(I3,1X))") INT(A(I,:)); 
      ENDDO
    
      WRITE(*,*) 'CALL LA_SBEVX( A, W, Z=Z, VL=-4.0_WP, VU=100.0_WP, M=M, Q=Q )'
      CALL LA_SBEVX( A, W, Z=Z, VL=-4.0_WP, VU=100.0_WP, M=M, Q=Q)
      
      WRITE(*,*) 'W on exit : '
      DO I=1,N
      WRITE(*,"(5(F9.5))") W(I)
      ENDDO
      WRITE(*,*) 'M = ',M
      
      WRITE(*,*) 'The matrix Q'
      WRITE(*,'(5(F9.5))') ((Q(I,J),J=1,N),I=1,N)
    
      END PROGRAM LA_SSBEVX_EXAMPLE

 SUBROUTINE SPBSV_F95( A, B, UPLO, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => SP
    USE LA_AUXMOD, ONLY: ERINFO, LSAME
    USE F77_LAPACK, ONLY: PBSV_F77 => LA_PBSV
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
!  
!     LA_PBSV computes the solution to a linear system of equations
! A*X = B, where A has band form and is real symmetric or complex
! Hermitian and, in either case, positive definite, and where X and B are
! rectangular matrices or vectors. The Cholesky decomposition is used to
! factor A as A = U^H*U if UPLO = 'U', or A = L*L^H if UPLO = 'L'
! where U is an upper triangular band matrix and L is a lower triangular 
! band matrix, each with the same number of superdiagonals or subdiagonals
! as A. The factored form of A is then used to solve the above system.
! 
! =========
! 
!      SUBROUTINE LA_PBSV( AB, B, UPLO=uplo, INFO=info )
!          <type>(<wp>), INTENT(INOUT) :: AB(:,:), <rhs>
!          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!          INTEGER, INTENT(OUT), OPTIONAL :: INFO
!      where
!          <type> ::= REAL | COMPLEX
!          <wp>   ::= KIND(1.0) | KIND(1.0D0)
!          <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! AB      (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(AB,1) = kd + 1 and size(AB,2) = n, where kd is the number
!         of superdiagonals or subdiagonals in the band and n is the 
!  	  order of A.
!         On entry, the upper (if UPLO = 'U') or lower (if UPLO = 'L') 
! 	  triangle of matrix A in band storage. The (kd + 1) diagonals of
! 	  A are stored in the rows of AB so that the j-th column of A is
! 	  stored in the j-th column of AB as follows:
! 	  if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j
! 	                                           1<=j<=n
!         if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd)
! 	                                           1<=j<=n.
!         On exit, the factor U or L from the Cholesky factorization 
!    	  A = U^H*U = L*L^H in the same storage format as A.
! B       (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(B,1) = n or shape (:) with size(B) = n.
!         On entry, the matrix B.
!         On exit, the solution matrix X .
! UPLO    Optional (input) CHARACTER(LEN=1)
!           = 'U': Upper triangle of A is stored;
!           = 'L': Lower triangle of A is stored.
!         Default value: 'U'.
! INFO    Optional (output) INTEGER.
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: if INFO = i, the leading minor of order i of A is not 
! 	     positive definite, so the factorization could not be 
! 	     completed and the solution could not be computed.
!         If INFO is not present and an error occurs, then the program 
! 	  is terminated with an error message.
!----------------------------------------------------------------------
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_PBSV'
!   .. LOCAL SCALARS ..
    CHARACTER(LEN=1) :: LUPLO
    INTEGER :: LINFO, KD, N, NRHS
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; KD = SIZE(A,1)-1; N = SIZE(A,2); NRHS = SIZE(B,2)
    IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; ENDIF
!   .. TEST THE ARGUMENTS
    IF( KD < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B, 1 ) /= N .OR. NRHS < 0 ) THEN; LINFO = -2
    ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -3
    ELSE IF ( N > 0 ) THEN
       CALL PBSV_F77( LUPLO, N, KD, NRHS, A, KD+1, B, N, LINFO )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO )
 END SUBROUTINE SPBSV_F95

SUBROUTINE LA_TEST_SSPEV( JOBS, UPLO, N, AP, W, Z, LDZ, WORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     May 14, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_SPEV
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDZ
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBS, UPLO
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: AP(1: N*(N+1)/2)
   REAL(WP), INTENT(OUT)::  W(N), Z(LDZ, N)
   REAL(WP) :: WORK(1:3*N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SPEV '
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SSPEV '
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IAP, IW, IZ1, IZ2, IWORK
   CHARACTER*1 :: IUPLO, IJOBS   
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
   LOGICAL LSAME
!  .. Executable Statements ..
   IAP = N*(N+1)/2; IUPLO = UPLO; IW = N; IJOBS = JOBS
   IZ1 =MAX(1,N); IZ2 = N; IWORK = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
     CASE (1)
       IAP = IAP - 1
     CASE (2)
       IW = IW - 1
     CASE (3)
       IUPLO = 'T'   
     CASE (4)
       IZ2 = IZ2 - 1
       IJOBS = 'V'
     CASE(:-1,5:)
       CALL UESTOP(SRNAMT)
   END SELECT
   if (lsame(IJOBS, 'V')) then
     CALL LA_SPEV(AP(1:IAP), W(1:IW), IUPLO, Z(1:IZ1, 1:IZ2),INFO )
   else
     CALL LA_SPEV(AP(1:IAP), W(1:IW), IUPLO, INFO=INFO )
   end if
   
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
 END SUBROUTINE LA_TEST_SSPEV
      
      

SUBROUTINE LA_TEST_SGGEV(JOBVL, JOBVR, N, A, LDA, B, LDB, ALPHAR, ALPHAI, BETA, VL, LDVL, VR, LDVR, WORK, LWORK, INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     SEPTEMBER 5, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GGEV
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, LDA, LDB, LDVL, LDVR, LWORK
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: JOBVL, JOBVR
!  .. Array Arguments ..
      REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB, 1:N)
      REAL(WP), INTENT(OUT):: WORK(1:LWORK)
      REAL(WP), INTENT(OUT) :: ALPHAR(1:N), ALPHAI(1:N), BETA(1:N), &
     &  VL(1: LDVL, 1:N), VR(1: LDVR, 1:N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GGEV '
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGGEV '
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, IB1, IB2, IALPHAI, IALPHAR, IBETA, IVL1, &
     &  IVL2, IVR1, IVR2
      CHARACTER*1 :: IJOBVL, IJOBVR
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      LOGICAL LSAME
!  .. Executable Statements ..
      IA1 = N; IA2 = N; IJOBVL = JOBVL; IJOBVR = JOBVR
      IB1 = N; IB2 = N; IALPHAR = N; IALPHAI = N; IBETA = N
      IVL1 = N; IVL2 = N; IVR1 = N; IVR2 = N
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE (1)
      IA2 = IA1 - 1
      CASE (2)
      IB1 = IA1 - 1
      CASE (3)
      IALPHAR = IA1 - 1
      CASE (4)
      IALPHAI = IA1 - 1
      CASE (5)
      IBETA  = IA1 - 1
      CASE (6)
      IJOBVL = 'V'; IJOBVR = 'N'
      IVL1 = IA1 - 1
      CALL LA_GGEV( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
     &  ALPHAI(1:IALPHAI), BETA(1: IBETA), VL(1:IVL1,1:IVL2), &
     &  INFO = INFO)
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (7)
      IJOBVL = 'N'; IJOBVR = 'V'  
      IVR1 = IA1 - 1
      CALL LA_GGEV( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
     &  ALPHAI(1:IALPHAI), BETA(1: IBETA),&
     &  VR = VR(1:IVR1,1:IVR2), INFO = INFO)
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN 
      CASE(:-1,8:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF (LSAME(IJOBVL,'V')) THEN
        IF (LSAME (IJOBVR, 'V')) THEN
          CALL LA_GGEV( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
     &      ALPHAI(1:IALPHAI), BETA(1: IBETA), VL(1:IVL1,1:IVL2), &
     &      VR(1:IVR1,1:IVR2), INFO)    
        ELSE
          CALL LA_GGEV( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
     &      ALPHAI(1:IALPHAI), BETA(1: IBETA), VL(1:IVL1,1:IVL2), &
     &      INFO = INFO)
        END IF
      ELSE
        IF (LSAME (IJOBVR, 'V')) THEN
          CALL LA_GGEV( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
     &      ALPHAI(1:IALPHAI), BETA(1: IBETA),&
     &      VR = VR(1:IVR1,1:IVR2), INFO = INFO)
        ELSE
          CALL LA_GGEV( A(1:IA1,1:IA2), B(1:IB1, 1:IB2), ALPHAR(1: IALPHAR), &
     &    ALPHAI(1:IALPHAI), BETA(1: IBETA), &
     &      INFO = INFO)
        END IF
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      END SUBROUTINE LA_TEST_SGGEV
      

      INTEGER FUNCTION LA_WS_GELS( VER, M, N, NRHS, TRANS )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
      USE LA_AUXMOD, ONLY: LSAME
      USE F77_LAPACK, ONLY: ILAENV_F77 => LA_ILAENV
!     .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!     .. SCALAR ARGUMENTS ..
      CHARACTER(LEN=1), INTENT(IN) :: TRANS, VER
      INTEGER, INTENT(IN) :: M, N, NRHS
!     .. PARAMETERS ..
      CHARACTER(LEN=5), PARAMETER :: NAME1='GEQRF', NAME2='ORMQR', NAME3='ORMLQ', NAME4='GELQF'
!     .. LOCAL SCALARS ..
      INTEGER :: NB, MN
      LOGICAL :: TPSD
!     .. INTRINSIC FUNCTIONS ..
      INTRINSIC MAX, MIN
!     .. EXECUTABLE STATEMENTS ..
      MN = MIN( M, N )
      IF( LSAME( TRANS, 'N' ) )THEN
        TPSD = .FALSE.
      ELSE
        TPSD = .TRUE.
      ENDIF
      IF( M.GE.N ) THEN
        NB = ILAENV_F77( 1, VER//NAME1, ' ', M, N, -1, -1 )
        IF( TPSD ) THEN
          NB = MAX( NB,ILAENV_F77( 1,VER//NAME2,'LN',M,NRHS,N,-1 ) )
        ELSE
          NB = MAX( NB, ILAENV_F77( 1,VER//NAME2,'LT',M,NRHS,N,-1 ) )
        END IF
      ELSE
        NB = ILAENV_F77( 1, VER//NAME4, ' ', M, N, -1, -1 )
        IF( TPSD ) THEN
          NB = MAX( NB, ILAENV_F77( 1,VER//NAME3,'LT',N,NRHS,M,-1 ) )
        ELSE
          NB = MAX( NB, ILAENV_F77( 1,VER//NAME3,'LN',N,NRHS,M,-1 ) )
        END IF
      END IF
      LA_WS_GELS = MN + MAX( M, N, NRHS )*NB
      END FUNCTION LA_WS_GELS

      SUBROUTINE ZERRST( PATH, NUNIT )
*
*  -- LAPACK test routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     April 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER*3        PATH
      INTEGER            NUNIT
*     ..
*
*  Purpose
*  =======
*
*  ZERRST tests the error exits for ZHETRD, ZUNGTR, CUNMTR, ZHPTRD,
*  ZUNGTR, ZUPMTR, ZSTEQR, CSTEIN, ZPTEQR, ZHBTRD,
*  ZHEEV, CHEEVX, CHEEVD, ZHBEV, CHBEVX, CHBEVD,
*  ZHPEV, CHPEVX, CHPEVD, and ZSTEDC.
*
*  Arguments
*  =========
*
*  PATH    (input) CHARACTER*3
*          The LAPACK path name for the routines to be tested.
*
*  NUNIT   (input) INTEGER
*          The unit number for output.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NMAX, LIW, LW
      PARAMETER          ( NMAX = 3, LIW = 12*NMAX, LW = 20*NMAX )
*     ..
*     .. Local Scalars ..
      CHARACTER*2        C2
      INTEGER            I, INFO, J, M, N, NT
*     ..
*     .. Local Arrays ..
      INTEGER            I1( NMAX ), I2( NMAX ), I3( NMAX ), IW( LIW ),
     &                   IN(100)
      DOUBLE PRECISION   D( NMAX ), E( NMAX ), R( LW ), RW( LW ),
     $                   X( NMAX )
      COMPLEX*16         A( NMAX, NMAX ), C( NMAX, NMAX ),
     $                   Q( NMAX, NMAX ), TAU( NMAX ), W( LW ),
     $                   Z( NMAX, NMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAMEN
      EXTERNAL           LSAMEN
*     ..
*     .. External Subroutines ..
      EXTERNAL           CHKXER, LA_TEST_ZHBEV, LA_TEST_ZHBEVD,
     &                   LA_TEST_ZHBEVX,
     &                   ZHBTRD, LA_TEST_ZHEEV,
     $                   LA_TEST_ZHEEVD, LA_TEST_ZHEEVR, LA_TEST_ZHEEVX,
     &  ZHETRD,
     &                   LA_TEST_ZHPEV,  LA_TEST_ZHPEVD,
     $                   ZHPEVX, ZHPTRD, ZPTEQR, ZSTEDC, ZSTEIN, ZSTEQR,
     $                   ZUNGTR, ZUNMTR, ZUPGTR, ZUPMTR
*     ..
*     .. Scalars in Common ..
      LOGICAL            LERR, OK
      CHARACTER*6        SRNAMT
      INTEGER            INFOT, NOUT
*     ..
*     .. Common blocks ..
      COMMON             / INFOC / INFOT, NOUT, OK, LERR
      COMMON             / SRNAMC / SRNAMT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE
*     ..
*     .. Executable Statements ..
*
      NOUT = NUNIT
      WRITE( NOUT, FMT = * )
      C2 = PATH( 2: 3 )
*
*     Set the variables to innocuous values.
*
      DO 20 J = 1, NMAX
         DO 10 I = 1, NMAX
            A( I, J ) = 1.D0 / DBLE( I+J )
   10    CONTINUE
   20 CONTINUE
      DO 30 J = 1, NMAX
         D( J ) = DBLE( J )
         E( J ) = 0.0D0
         I1( J ) = J
         I2( J ) = J
         TAU( J ) = 1.D0
   30 CONTINUE
      OK = .TRUE.
      NT = 0
*
*     Test error exits for the ST path.
*
      IF( LSAMEN( 2, C2, 'ST' ) ) THEN
*
*        ZHETRD
*
         SRNAMT = 'ZHETRD'
         INFOT = 1
         CALL ZHETRD( '/', 0, A, 1, D, E, TAU, W, 1, INFO )
         CALL CHKXER( 'ZHETRD', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL ZHETRD( 'U', -1, A, 1, D, E, TAU, W, 1, INFO )
         CALL CHKXER( 'ZHETRD', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL ZHETRD( 'U', 2, A, 1, D, E, TAU, W, 1, INFO )
         CALL CHKXER( 'ZHETRD', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL ZHETRD( 'U', 0, A, 1, D, E, TAU, W, 0, INFO )
         CALL CHKXER( 'ZHETRD', INFOT, NOUT, LERR, OK )
         NT = NT + 4
*
*        ZUNGTR
*
         SRNAMT = 'ZUNGTR'
         INFOT = 1
         CALL ZUNGTR( '/', 0, A, 1, TAU, W, 1, INFO )
         CALL CHKXER( 'ZUNGTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL ZUNGTR( 'U', -1, A, 1, TAU, W, 1, INFO )
         CALL CHKXER( 'ZUNGTR', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL ZUNGTR( 'U', 2, A, 1, TAU, W, 1, INFO )
         CALL CHKXER( 'ZUNGTR', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL ZUNGTR( 'U', 3, A, 3, TAU, W, 1, INFO )
         CALL CHKXER( 'ZUNGTR', INFOT, NOUT, LERR, OK )
         NT = NT + 4
*
*        ZUNMTR
*
         SRNAMT = 'ZUNMTR'
         INFOT = 1
         CALL ZUNMTR( '/', 'U', 'N', 0, 0, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'ZUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL ZUNMTR( 'L', '/', 'N', 0, 0, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'ZUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL ZUNMTR( 'L', 'U', '/', 0, 0, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'ZUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL ZUNMTR( 'L', 'U', 'N', -1, 0, A, 1, TAU, C, 1, W, 1,
     $                INFO )
         CALL CHKXER( 'ZUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL ZUNMTR( 'L', 'U', 'N', 0, -1, A, 1, TAU, C, 1, W, 1,
     $                INFO )
         CALL CHKXER( 'ZUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL ZUNMTR( 'L', 'U', 'N', 2, 0, A, 1, TAU, C, 2, W, 1, INFO )
         CALL CHKXER( 'ZUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 7
         CALL ZUNMTR( 'R', 'U', 'N', 0, 2, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'ZUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL ZUNMTR( 'L', 'U', 'N', 2, 0, A, 2, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'ZUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL ZUNMTR( 'L', 'U', 'N', 0, 2, A, 1, TAU, C, 1, W, 1, INFO )
         CALL CHKXER( 'ZUNMTR', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL ZUNMTR( 'R', 'U', 'N', 2, 0, A, 1, TAU, C, 2, W, 1, INFO )
         CALL CHKXER( 'ZUNMTR', INFOT, NOUT, LERR, OK )
         NT = NT + 10
*
*        ZHPTRD
*
         SRNAMT = 'ZHPTRD'
         INFOT = 1
         CALL ZHPTRD( '/', 0, A, D, E, TAU, INFO )
         CALL CHKXER( 'ZHPTRD', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL ZHPTRD( 'U', -1, A, D, E, TAU, INFO )
         CALL CHKXER( 'ZHPTRD', INFOT, NOUT, LERR, OK )
         NT = NT + 2
*
*        ZUPGTR
*
         SRNAMT = 'ZUPGTR'
         INFOT = 1
         CALL ZUPGTR( '/', 0, A, TAU, Z, 1, W, INFO )
         CALL CHKXER( 'ZUPGTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL ZUPGTR( 'U', -1, A, TAU, Z, 1, W, INFO )
         CALL CHKXER( 'ZUPGTR', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL ZUPGTR( 'U', 2, A, TAU, Z, 1, W, INFO )
         CALL CHKXER( 'ZUPGTR', INFOT, NOUT, LERR, OK )
         NT = NT + 3
*
*        ZUPMTR
*
         SRNAMT = 'ZUPMTR'
         INFOT = 1
         CALL ZUPMTR( '/', 'U', 'N', 0, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'ZUPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL ZUPMTR( 'L', '/', 'N', 0, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'ZUPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL ZUPMTR( 'L', 'U', '/', 0, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'ZUPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL ZUPMTR( 'L', 'U', 'N', -1, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'ZUPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 5
         CALL ZUPMTR( 'L', 'U', 'N', 0, -1, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'ZUPMTR', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL ZUPMTR( 'L', 'U', 'N', 2, 0, A, TAU, C, 1, W, INFO )
         CALL CHKXER( 'ZUPMTR', INFOT, NOUT, LERR, OK )
         NT = NT + 6
*
*        ZPTEQR
*
         SRNAMT = 'ZPTEQR'
         INFOT = 1
         CALL ZPTEQR( '/', 0, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'ZPTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL ZPTEQR( 'N', -1, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'ZPTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL ZPTEQR( 'V', 2, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'ZPTEQR', INFOT, NOUT, LERR, OK )
         NT = NT + 3
*
*        ZSTEIN
*
         SRNAMT = 'ZSTEIN'
         INFOT = 1
         CALL ZSTEIN( -1, D, E, 0, X, I1, I2, Z, 1, RW, IW, I3, INFO )
         CALL CHKXER( 'ZSTEIN', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL ZSTEIN( 0, D, E, -1, X, I1, I2, Z, 1, RW, IW, I3, INFO )
         CALL CHKXER( 'ZSTEIN', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL ZSTEIN( 0, D, E, 1, X, I1, I2, Z, 1, RW, IW, I3, INFO )
         CALL CHKXER( 'ZSTEIN', INFOT, NOUT, LERR, OK )
         INFOT = 9
         CALL ZSTEIN( 2, D, E, 0, X, I1, I2, Z, 1, RW, IW, I3, INFO )
         CALL CHKXER( 'ZSTEIN', INFOT, NOUT, LERR, OK )
         NT = NT + 4
*
*        ZSTEQR
*
         SRNAMT = 'ZSTEQR'
         INFOT = 1
         CALL ZSTEQR( '/', 0, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'ZSTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL ZSTEQR( 'N', -1, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'ZSTEQR', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL ZSTEQR( 'V', 2, D, E, Z, 1, RW, INFO )
         CALL CHKXER( 'ZSTEQR', INFOT, NOUT, LERR, OK )
         NT = NT + 3
*
*        ZSTEDC
*
         SRNAMT = 'ZSTEDC'
         INFOT = 1
         CALL ZSTEDC( '/', 0, D, E, Z, 1, W, 1, RW, 1, IW, 1, INFO )
         CALL CHKXER( 'ZSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL ZSTEDC( 'N', -1, D, E, Z, 1, W, 1, RW, 1, IW, 1, INFO )
         CALL CHKXER( 'ZSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL ZSTEDC( 'V', 2, D, E, Z, 1, W, 4, RW, 23, IW, 28, INFO )
         CALL CHKXER( 'ZSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL ZSTEDC( 'N', 2, D, E, Z, 1, W, 0, RW, 1, IW, 1, INFO )
         CALL CHKXER( 'ZSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 8
         CALL ZSTEDC( 'V', 2, D, E, Z, 2, W, 3, RW, 23, IW, 28, INFO )
         CALL CHKXER( 'ZSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL ZSTEDC( 'N', 2, D, E, Z, 1, W, 1, RW, 0, IW, 1, INFO )
         CALL CHKXER( 'ZSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL ZSTEDC( 'I', 2, D, E, Z, 2, W, 1, RW, 16, IW, 12, INFO )
         CALL CHKXER( 'ZSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL ZSTEDC( 'V', 2, D, E, Z, 2, W, 4, RW, 22, IW, 28, INFO )
         CALL CHKXER( 'ZSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL ZSTEDC( 'N', 2, D, E, Z, 1, W, 1, RW, 1, IW, 0, INFO )
         CALL CHKXER( 'ZSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL ZSTEDC( 'I', 2, D, E, Z, 2, W, 1, RW, 23, IW, 11, INFO )
         CALL CHKXER( 'ZSTEDC', INFOT, NOUT, LERR, OK )
         INFOT = 12
         CALL ZSTEDC( 'V', 2, D, E, Z, 2, W, 4, RW, 23, IW, 27, INFO )
         CALL CHKXER( 'ZSTEDC', INFOT, NOUT, LERR, OK )
         NT = NT + 11
*
*        ZHEEVD
*
         SRNAMT = 'ZHEEVD'
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_ZHEEVD('N', 'U', NMAX, A, NMAX, X, W, 1,
     &         RW, 1 , IW, 1, INFO )
             CALL CHKXER( 'ZHEEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVD('N', 'L', NMAX, A, NMAX, X, W, 1,
     &         RW, 1 , IW, 1, INFO )
             CALL CHKXER( 'ZHEEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVD('V', 'U', NMAX, A, NMAX, X, W, 1,
     &         RW,  1, IW, 1, INFO )
             CALL CHKXER( 'ZHEEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVD('V', 'L', NMAX, A, NMAX, X, W, 1,
     &         RW, 1, IW, 1, INFO )
             CALL CHKXER( 'ZHEEVD ', INFOT, NOUT, LERR, OK )
           END DO
         END DO 
         NT = NT + 12
*
*        ZHEEV
*
         SRNAMT = 'ZHEEV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_ZHEEV('N', 'U', NMAX, A, NMAX, X, W, 1,
     &         RW, INFO )
             CALL CHKXER( 'ZHEEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHEEV('N', 'L', NMAX, A, NMAX, X, W, 1,
     &         RW, INFO )
             CALL CHKXER( 'ZHEEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHEEV('V', 'U', NMAX, A, NMAX, X, W, 1,
     &         RW, INFO )
             CALL CHKXER( 'ZHEEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHEEV('V', 'L', NMAX, A, NMAX, X, W, 1,
     &         RW, INFO )
             CALL CHKXER( 'ZHEEV ', INFOT, NOUT, LERR, OK )
           END DO
         END DO
         NT = NT + 5
*
*        ZHEEVX
*
         SRNAMT = 'ZHEEVX'
         DO I = 1, 10
           IF (I/=9) THEN
             INFOT = I
             DO J = 1, 1
               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'N', 'A', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'N', 'A', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'N', 'V', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'N', 'V', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'N', 'I', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'N', 'I', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'V', 'A', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'V', 'A', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'V', 'V', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'V', 'V', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'V', 'I', 'U', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHEEVX( 'V', 'I', 'L', NMAX, A, NMAX,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0,
     &           M, X, Z, NMAX, W, NMAX, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHEEVX', INFOT, NOUT, LERR, OK )
             ENDDO
           ENDIF
         ENDDO  
         NT = NT + 10
*
*        ZHEEVR
*
         SRNAMT = 'ZHEEVR'
         DO I = 1,10
           IF(I/=9)THEN
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'N', 'A', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'N', 'A', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'N', 'V', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'N', 'V', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'N', 'I', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'N', 'I', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'V', 'A', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'V', 'A', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'V', 'V', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'V', 'V', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'V', 'I', 'U', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  

             INFO = J + 100*I
             CALL LA_TEST_ZHEEVR( 'V', 'I', 'L', NMAX, A, NMAX,
     &         0.0D0, 0.0D0, NMAX, NMAX, 0.0D0,
     &         M, R, Z, NMAX, IW, Q, 2*NMAX, RW, 24*NMAX,
     &         IW( 2*NMAX+1 ),
     &         10*NMAX, INFO )
             CALL CHKXER( 'ZHEEVR', INFOT, NOUT, LERR, OK )  
           ENDDO
         ENDIF
       ENDDO
         NT = NT + 12
*
*        ZHPEVD
*
         SRNAMT = 'ZHPEVD'
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_ZHPEVD('N', 'U', NMAX, A, X, Z, 1,
     &         W, 1, RW, 1, IW, 1, INFO )
             CALL CHKXER( 'ZHPEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHPEVD('N', 'L', NMAX, A, X, Z, 1,
     &         W, 1, RW, 1, IW, 1, INFO )
             CALL CHKXER( 'ZHPEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHPEVD('V', 'U', NMAX, A, X, Z, 1,
     &         W, 1, RW, 1, IW, 1, INFO )
             CALL CHKXER( 'ZHPEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHPEVD('V', 'L', NMAX, A, X, Z, 1,
     &         W, 1, RW, 1, IW, 1, INFO )
             CALL CHKXER( 'ZHPEVD ', INFOT, NOUT, LERR, OK )
           END DO
         END DO
         NT = NT + 13
*
*        ZHPEV
*
         SRNAMT = 'ZHPEV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_ZHPEV('N', 'U', NMAX, A, X, Z, 1,
     &         W, RW,  INFO )
             CALL CHKXER( 'ZHPEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHPEV('N', 'L', NMAX, A, X, Z, 1,
     &         W, RW, INFO )
             CALL CHKXER( 'ZHPEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHPEV('V', 'U', NMAX, A, X, Z, 1,
     &         W, RW, INFO )
             CALL CHKXER( 'ZHPEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHPEV('V', 'L', NMAX, A, X, Z, 1,
     &         W, RW, INFO )
             CALL CHKXER( 'ZHPEV ', INFOT, NOUT, LERR, OK )
           END DO
         END DO
         NT = NT + 4
*
*        ZHPEVX
*
         SRNAMT = 'ZHPEVX'
         DO I = 1, 10
           INFOT = I
           IF (I/=9) THEN
             DO J = 1, 1
               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'V', 'A', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'V', 'A', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'V', 'V', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'V', 'V', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'V', 'I', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'V', 'I', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'N', 'A', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'N', 'A', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'N', 'V', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'N', 'V', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'N', 'I', 'U', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHPEVX( 'N', 'I', 'L', NMAX, A,
     &           0.0D0, 0.0D0, 0, 0, 0.0D0, M,
     &           X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHPEVX', INFOT, NOUT, LERR, OK )

             ENDDO
           ENDIF
         ENDDO
         NT = NT + 8
*
*     Test error exits for the HB path.
*
      ELSE IF( LSAMEN( 2, C2, 'HB' ) ) THEN
*
*        ZHBTRD
*
         SRNAMT = 'ZHBTRD'
         INFOT = 1
         CALL ZHBTRD( '/', 'U', 0, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'ZHBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 2
         CALL ZHBTRD( 'N', '/', 0, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'ZHBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 3
         CALL ZHBTRD( 'N', 'U', -1, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'ZHBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 4
         CALL ZHBTRD( 'N', 'U', 0, -1, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'ZHBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 6
         CALL ZHBTRD( 'N', 'U', 1, 1, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'ZHBTRD', INFOT, NOUT, LERR, OK )
         INFOT = 10
         CALL ZHBTRD( 'V', 'U', 2, 0, A, 1, D, E, Z, 1, W, INFO )
         CALL CHKXER( 'ZHBTRD', INFOT, NOUT, LERR, OK )
         NT = NT + 6
*
*        ZHBEVD
*
         SRNAMT = 'ZHBEVD'
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_ZHBEVD('N', 'U', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, 1, RW, 1 , IW, 1, INFO )
             CALL CHKXER( 'ZHBEVD ', INFOT, NOUT, LERR, OK )
             INFO = J + 100*I
             CALL LA_TEST_ZHBEVD('N', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, 1, RW, 1 , IW, 1, INFO )
             CALL CHKXER( 'ZHBEVD ', INFOT, NOUT, LERR, OK )
             INFO = J + 100*I
             CALL LA_TEST_ZHBEVD('N', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, 1, RW, 1 , IW, 1, INFO )
             CALL CHKXER( 'ZHBEVD ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHBEVD('N', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, 1, RW, 1 , IW, 1, INFO )
             CALL CHKXER( 'ZHBEVD ', INFOT, NOUT, LERR, OK )
           END DO
         END DO
         NT = NT + 15
*
*        ZHBEV
*
         SRNAMT = 'ZHBEV '
         DO I = 1, 4
           IN(I) = 1
         END DO
         DO I = 1, 4
           INFOT = I
           DO J = 1, 1
             INFO = J + 100*I
             CALL LA_TEST_ZHBEV('N', 'U', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, RW,  INFO )
             CALL CHKXER( 'ZHBEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHBEV('N', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, RW, INFO )
             CALL CHKXER( 'ZHBEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHBEV('V', 'U', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, RW, INFO )
             CALL CHKXER( 'ZHBEV ', INFOT, NOUT, LERR, OK )

             INFO = J + 100*I
             CALL LA_TEST_ZHBEV('V', 'L', NMAX, NMAX, A, 1, X, Z, 1,
     &         W, RW, INFO )
             CALL CHKXER( 'ZHBEV ', INFOT, NOUT, LERR, OK )
           END DO
         END DO
         NT = NT + 6
*
*        ZHBEVX
*
         SRNAMT = 'ZHBEVX'
         DO I = 1, 11
           INFOT = I
           IF (I/=9) THEN
             DO J = 1, 11
               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'N', 'A', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'N', 'A', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'N', 'V', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'N', 'V', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'N', 'I', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'N', 'I', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'V', 'A', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'V', 'A', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'V', 'V', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'V', 'V', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'V', 'I', 'U', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

               INFO = J + 100*I
               CALL LA_TEST_ZHBEVX( 'V', 'I', 'L', NMAX, NMAX, A,
     &           NMAX, Q, NMAX, 0.0D0, 0.0D0, 0,
     &           0, 0.0D0, M, X, Z, NMAX, W, RW, IW, I3, INFO )
               CALL CHKXER( 'ZHBEVX', INFOT, NOUT, LERR, OK )

             ENDDO
           ENDIF
         ENDDO
         NT = NT + 11
      END IF
*
*     Print a summary line.
*
      IF( OK ) THEN
         WRITE( NOUT, FMT = 9999 )PATH, NT
      ELSE
         WRITE( NOUT, FMT = 9998 )PATH
      END IF
*
 9999 FORMAT( 1X, A3, ' routines passed the tests of the error exits',
     $      ' (', I3, ' tests done)' )
 9998 FORMAT( ' *** ', A3, ' routines failed the tests of the error ',
     $      'exits ***' )
*
      RETURN
*
*     End of ZERRST
*
      END

      SUBROUTINE DGGEVX_F95( A, B, ALPHAR, ALPHAI, BETA, VL, VR, &
     &  BALANC, ILO, IHI, LSCALE, RSCALE, ABNRM, BBNRM, RCONDE, RCONDV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => DP
      USE LA_AUXMOD, ONLY: ERINFO, LSAME
      USE F77_LAPACK, ONLY: GGEVX_F77 => LA_GGEVX
!  .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      INTEGER, INTENT(OUT), OPTIONAL :: ILO,IHI
      REAL(WP), INTENT(OUT), OPTIONAL :: ABNRM, BBNRM
!  .. ARRAY ARGUMENTS ..
      CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: BALANC
      REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: LSCALE(:), RSCALE(:), &
     &  RCONDE(:), RCONDV(:)
      REAL(WP), INTENT(OUT) :: ALPHAR(:), ALPHAI(:), BETA(:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: VL(:,:), VR(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!      LA_GGEVX computes for a pair of n-by-n real or complex matrices
! (A, B) the generalized eigenvalues in the form of scalar pairs 
! (alpha; beta) and, optionally, the left and/or right generalized 
! eigenvectors.
!      A generalized eigenvalue of the pair (A; B) is, roughly speaking, 
! a scalar of the form lambda = alpha / beta such that the matrix 
! A - lambda * B is singular. It is usually represented as the pair
! (alpha, beta), as there is a reasonable interpretation of the case 
! beta = 0 (even if alpha = 0).
!      A right generalized eigenvector corresponding to a generalized 
! eigenvalue lambda is a vector  v  such that ( A - lambda*B)* v = 0. 
! A left generalized eigenvector is a vector u such that 
! u^H*(A-lambda*B) = 0, where u^H is the conjugate-transpose of u.
!      The computation is based on the (generalized) real or complex 
! Schur form of (A, B). (See LA_GGES for details of this form.)
!      Optionally, LA_GGEVX also computes a balancing transformation 
! (to improve the conditioning of the eigenvalues and eigenvectors), 
! reciprocal condition numbers for the eigenvalues, and reciprocal 
! condition numbers for the right eigenvectors. The balancing 
! transformation consists of a permutation of rows and columns and/or a
! scaling of rows and columns.
! 
! ==========
! 
!    SUBROUTINE LA_GGEVX( A, B, <alpha>, BETA, VL=vl, &
!          VR=vr, BALANC=balanc, ILO=ilo, IHI=ihi, &
!          LSCALE=lscale, RSCALE=rscale, ABNRM=abnrm, &
!          BBNRM=bbnrm, RCONDE=rconde, RCONDV=rcondv, &
!          INFO=info )
!        <type>(<wp>), INTENT(INOUT) :: A(:,:), B(:,:)
!        <type>(<wp>), INTENT(OUT) :: <alpha(:)>, BETA(:)
!        <type>(<wp>), INTENT(OUT), OPTIONAL :: VL(:,:), VR(:,:)
!        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: BALANC
!        INTEGER, INTENT(OUT), OPTIONAL :: ILO, IHI
!        REAL(<wp>), INTENT(OUT), OPTIONAL :: LSCALE(:),
!             RSCALE(:), RCONDE(:), RCONDV(:)
!        REAL(<wp>), INTENT(OUT), OPTIONAL :: ABNRM, BBNRM
!        INTEGER, INTENT(OUT), OPTIONAL :: INFO
!     where
!        <type>     ::= REAL | COMPLEX
!        <wp>       ::= KIND(1.0) | KIND(1.0D0)
!        <alpha>    ::= ALPHAR, ALPHAI | ALPHA
!        <alpha(:)> ::= ALPHAR(:), ALPHAI(:) | ALPHA(:)
! 
! 
! Arguments
! =========
! 
! A        (input/output) REAL or COMPLEX square array, shape (:, :).
!          On entry, the matrix A.
!          On exit, A has been overwritten. If the left, the right or 
!          both generalized eigenvectors are computed, then A contains 
! 	   the first part of the real/complex Schur form of the
!          "balanced" versions of the matrix pair (A, B).
! B        (input/output) REAL or COMPLEX square array, shape (:, :) 
!          with size(B, 1) = size(A, 1).
!          On entry, the matrix B.
!          On exit, B has been overwritten. If the left, the right or 
! 	   both generalized eigenvectors are computed, then B contains 
! 	   the second part of the real/complex Schur form of the "bal-
!          anced" versions of the matrix pair (A, B).
! <alpha>  (output) REAL or COMPLEX array, shape (:) with 
!          size(<alpha>) = size(A, 1).
!          The values of alpha.
!          <alpha(:)> ::= ALPHAR(:), ALPHAI(:) |  ALPHA(:),
!          where
!          ALPHAR(:), ALPHAI(:) are of REAL type (for the real and 
! 	   imaginary parts) and ALPHA(:) is of COMPLEX type.
! BETA     (output) REAL or COMPLEX array, shape (:) with 
!          size(BETA) = size(A,1).
!          The values of beta.
!          Note: The generalized eigenvalues of the pair (A, B) are the
! 	   scalars lambda(j) = alpha(j) / beta(j) . These quotients
!          may easily over- or underflow, and beta(j) may even be zero. 
! 	   Thus, the user should avoid computing them naively.
!          Note: If A and B are real then complex eigenvalues occur in 
! 	   complex conjugate pairs. Each pair is stored consecutively. 
! 	   Thus a complex conjugate pair is given by
!                 lambda(j) = (ALPHAR(j) + i*ALPHAI(j))/BETA(j)
!                 lambda(j+1) = (ALPHAR(j+1) + i*ALPHAI(j+1))/BETA(j+1)
!          where
!              ALPHAI(j)/BETA(j)= - (ALPHAI(j+1)/BETA(j+1))
! VL       Optional (output) REAL or COMPLEX square array, shape (:, :)
!          with  size(VL, 1) = size(A, 1).
!         The left generalized eigenvectors u(j) are stored in the
!         columns of VL in the order of their eigenvalues. Each
!         eigenvector is scaled so the largest component has
!             |realpart| + |imag.part| = 1,
!         except that for eigenvalues with alpha = beta = 0, a zero
!         vector is returned as the corresponding eigenvector.
!         Note: If A and B are real then complex eigenvectors, like
!         their eigenvalues, occur in complex conjugate pairs. The real
!         and imaginary parts of the first eigenvector of the pair are
!         stored in VL(:,j) and VL(:,j+1) . Thus a complex conjugate
!         pair is given by
!         u(j) = VL(:,j) + i*VL(:,j+1), u(j+1) = VL(:,j) - i*VL(:,j+1)
! VR      Optional (output) REAL or COMPLEX square array, shape (:,:)
!         with size(VR,1) = size(A,1).
!         The right generalized eigenvectors v(j) are stored in the 
!         columns of VR in the order of their eigenvalues. Each 
! 	  eigenvector is scaled so the largest component has 
! 	  | realpart | + | imag.part | = 1,except that for eigenvalues
! 	  with alpha = beta = 0, a zero vector is returned as the 
! 	  corresponding eigenvector.
!         Note: If A and B are real then complex eigenvectors, like 
! 	  their eigenvalues, occur in complex conjugate pairs. The real
! 	  and imaginary parts of the first eigenvector of the pair are
! 	  stored in VR(:,j) and VR(:,j+1) . Thus a complex conjugate 
! 	  pair is given by
!         v(j) = VR(:,j) + i*VR(:,j+1), v(j+1) = VR(:,j) - i*VR(:,j+1)
! BALANC  Optional (input) CHARACTER(LEN=1).
!         Specifies the balance option to be performed.
!            = 'N': do not permute or scale;
!            = 'P': permute only;
!            = 'S': scale only;
!            = 'B': both permute and scale.
!         Default value: 'N".
!         Note: Computed reciprocal condition numbers will be for the
! 	  matrices after balancing. Permuting does not change condition
! 	  numbers (in exact arithmetic), but scaling does.
! ILO,IHI Optional (output) INTEGER.
!         ILO and IHI are integer values such that on exit A(i,j) = 0
! 	  and B(i,j) = 0 if i > j and j =1,...,ILO-1 or 
! 	  i = IHI+1,...,n.
! 	  If BALANC = 'N' or 'S', then ILO = 1 and IHI = n.
! LSCALE  Optional (output) REAL array, shape (:) with size(LSCALE) = 
!         size(A, 1).
!         Details of the permutations and scaling factors applied to 
! 	  the left side of A and B. If PL(j) is the index of the row 
! 	  interchanged with row j, and DL(j) is the scaling factor
!         applied to row j, then
!                 PL(j) = LSCALE(j),  j = 1,...,ILO-1 and IHI+1,..., n
! 	  and
! 	        DL(j) = LSCALE(j),  j = ILO, ..., IHI
! RSCALE  Optional (output) REAL array, shape (:), size(RSCALE) = 
!         size(A, 1).
!         Details of the permutations and scaling factors applied to the
! 	  right side of A and B. If PR(j) is the index of the column 
! 	  interchanged with column j, and DR(j) is the scaling factor 
! 	  applied to column j, then
!                PR(j) = RSCALE(j),  j = 1,...,ILO-1 and IHI+1,..., n
!         and
!                DR(j) = RSCALE(j),  j = ILO, ..., IHI
! ABNRM   Optional (output) REAL.
!         The l1 norm of A after balancing.
! BBNRM   Optional (output) REAL.
!         The l 1 norm of B after balancing.
! RCONDE  Optional (output) REAL array, shape (:) with size(RCONDE) = 
!         size(A, 1).
!         The reciprocal condition numbers of the eigenvalues.
! RCONDV  Optional (output) REAL array, shape (:) with size(RCONDE) = 
!         size(A, 1).
!         The estimated reciprocal condition numbers of the right 
! 	  eigenvectors. If the eigenvalues cannot be reordered to 
! 	  compute RCONDV(j) then RCONDV(j) is set to 0. This can only
!         occur when the true value would be very small.
! INFO    Optional (output) INTEGER.
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: if INFO = i, and i is 
! 	    <= n: The QZ iteration failed. No eigenvectors have been
! 	          calculated, but (alpha(j) , BETA(j) ) should be 
! 	   correct for j = INFO + 1,..., n.
!             = n+1: another part of the algorithm failed.
!             = n+2: a failure occurred during the computation of the
! 	          generalized eigenvectors.
!         If INFO is not present and an error occurs, then the program 
! 	is terminated with an error message.
!----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GGEVX'
!  .. LOCAL SCALARS ..
      CHARACTER(LEN=1) :: LJOBVL, LJOBVR, LBALANC, LSENSE
      INTEGER, SAVE :: LWORK = 0
      INTEGER :: N, LINFO, LD, ISTAT, S1VL, S2VL, S1VR, S2VR, &
     &  SALPHAR, SALPHAI, SBETA, LILO, LIHI, SRCONDE, SRCONDV, SLSCALE, SRSCALE
      REAL(WP) :: LABNRM, LBBNRM
!  .. LOCAL ARRAYS ..
      REAL(WP), TARGET :: LLVL(1,1), LLVR(1,1), WORKMIN(1)
      REAL(WP), POINTER :: LRCONDE(:), LRCONDV(:), LLSCALE(:), LRSCALE(:)
      REAL(WP), POINTER :: WORK(:)
      INTEGER, POINTER :: IWORK(:)
      LOGICAL, POINTER :: BWORK(:)
!  .. INTRINSIC FUNCTIONS ..
      INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(A,1); LD = MAX(1,N)
   SALPHAR = SIZE(ALPHAR); SALPHAI = SIZE(ALPHAI); SBETA = SIZE(BETA)
   IF( PRESENT(BALANC) )THEN; LBALANC = BALANC; ELSE; LBALANC = 'N'; ENDIF
   IF( PRESENT(LSCALE) )THEN; SLSCALE = SIZE(LSCALE); ELSE; SLSCALE = N; ENDIF
   IF( PRESENT(RSCALE) )THEN; SRSCALE = SIZE(RSCALE); ELSE; SRSCALE = N; ENDIF
   IF( PRESENT(RCONDE) )THEN; SRCONDE = SIZE(RCONDE); ELSE; SRCONDE = N; ENDIF
   IF( PRESENT(RCONDV) )THEN; SRCONDV = SIZE(RCONDV); ELSE; SRCONDV = N; ENDIF
   IF( PRESENT(VL) )THEN; S1VL = SIZE(VL,1); S2VL = SIZE(VL,2); LJOBVL = 'V'
   ELSE; S1VL = 1; S2VL = 1; LJOBVL = 'N'; END IF
   IF( PRESENT(VR) )THEN; S1VR = SIZE(VR,1); S2VR = SIZE(VR,2); LJOBVR = 'V'
   ELSE; S1VR = 1; S2VR = 1; LJOBVR = 'N'; END IF
!  .. TEST THE ARGUMENTS
   IF( N < 0 .OR. SIZE(A,2) /= N )THEN; LINFO = -1
   ELSE IF( SIZE(B,1) /= N .OR. SIZE(B,2) /= N )THEN; LINFO = -2
   ELSE IF( SALPHAR /= N )THEN; LINFO = -3
   ELSE IF( SALPHAI /= N )THEN; LINFO = -4
   ELSE IF( SBETA /= N )THEN; LINFO = -5
   ELSE IF( PRESENT(VL) .AND. ( S1VL /= N .OR. S2VL /= N ) )THEN; LINFO = -6
   ELSE IF( PRESENT(VR) .AND. ( S1VR /= N .OR. S2VR /= N ) )THEN; LINFO = -7
   ELSE IF( .NOT.( LSAME(LBALANC,'N') .OR. LSAME(LBALANC,'P') .OR. &
     &  LSAME(LBALANC,'S') .OR. LSAME(LBALANC,'B') ) )THEN; LINFO = -8
   ELSE IF( SLSCALE /= N )THEN; LINFO = -11
   ELSE IF( SRSCALE /= N )THEN; LINFO = -12
   ELSE IF( SRCONDE /= N )THEN; LINFO = -15
   ELSE IF( SRCONDV /= N )THEN; LINFO = -16
   ELSE IF( N > 0 )THEN
      IF( PRESENT(RCONDE).AND.PRESENT(RCONDV) )THEN; LSENSE = 'B'
      ELSE IF( PRESENT(RCONDE) )THEN; LSENSE = 'E'
      ELSE IF( PRESENT(RCONDV) )THEN; LSENSE = 'V'; ELSE; LSENSE = 'N'; ENDIF

      ALLOCATE(BWORK(N), STAT=ISTAT)
      IF (ISTAT /= 0) THEN; LINFO=-100; GOTO 1000; ENDIF

      ALLOCATE(IWORK(N+6), STAT=ISTAT)
      IF (ISTAT /= 0) THEN; LINFO=-100; GOTO 900; ENDIF

      IF( PRESENT(LSCALE) )THEN; LLSCALE => LSCALE
      ELSE; ALLOCATE( LLSCALE(N), STAT=ISTAT )
        IF (ISTAT /= 0) THEN; LINFO=-100; GOTO 800; ENDIF
      END IF

      IF( PRESENT(RSCALE) )THEN; LRSCALE => RSCALE
      ELSE; ALLOCATE( LRSCALE(N), STAT=ISTAT )
        IF (ISTAT /= 0) THEN; LINFO=-100; GOTO 700; ENDIF
      END IF

      IF( PRESENT(RCONDV) )THEN; LRCONDV => RCONDV
      ELSE; ALLOCATE( LRCONDV(N), STAT=ISTAT )
        IF (ISTAT /= 0) THEN; LINFO=-100; GOTO 600; ENDIF
      END IF

      IF( PRESENT(RCONDE) )THEN; LRCONDE => RCONDE
      ELSE; ALLOCATE( LRCONDE(N), STAT=ISTAT )
        IF (ISTAT /= 0) THEN; LINFO=-100; GOTO 500; ENDIF
      END IF 

! .. DETERMINE THE WORKSPACE ..
! .. QUERING THE SIZE OF WORKSPACE ..
      LWORK = -1
      IF (PRESENT (VL)) THEN
        IF (PRESENT (VR)) THEN
           CALL GGEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&             BETA, VL, S1VL, VR, S1VR, LILO, LIHI, LLSCALE, LRSCALE, LABNRM, LBBNRM, &
&             LRCONDE, LRCONDV, WORKMIN, LWORK, IWORK, BWORK, LINFO )
        ELSE
	   CALL GGEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&             BETA, VL, S1VL, LLVR, S1VR, LILO, LIHI, LLSCALE, LRSCALE, LABNRM, LBBNRM, &
&             LRCONDE, LRCONDV, WORKMIN, LWORK, IWORK, BWORK, LINFO )
        ENDIF
       ELSE
        IF (PRESENT (VR)) THEN
           CALL GGEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&             BETA, LLVL, S1VL, VR, S1VR, LILO, LIHI, LLSCALE, LRSCALE, LABNRM, LBBNRM, &
&             LRCONDE, LRCONDV, WORKMIN, LWORK, IWORK, BWORK, LINFO )
        ELSE
	   CALL GGEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&             BETA, LLVL, S1VL, LLVR, S1VR, LILO, LIHI, LLSCALE, LRSCALE, LABNRM, LBBNRM, &
&             LRCONDE, LRCONDV, WORKMIN, LWORK, IWORK, BWORK, LINFO )
        ENDIF
       ENDIF	
      LWORK = WORKMIN(1)
      
      ALLOCATE(WORK(LWORK), STAT=ISTAT)
      IF (ISTAT /= 0) THEN; LINFO=-100; GOTO 100; ENDIF
      IF (PRESENT (VL)) THEN
        IF (PRESENT (VR)) THEN
     	    CALL GGEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&             BETA, VL, S1VL, VR, S1VR, LILO, LIHI, LLSCALE, LRSCALE, LABNRM, LBBNRM,&
&             LRCONDE, LRCONDV, WORK, LWORK, IWORK, BWORK, LINFO )
        ELSE
	    CALL GGEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&             BETA, VL, S1VL, LLVR, S1VR, LILO, LIHI, LLSCALE, LRSCALE, LABNRM, LBBNRM,&
&             LRCONDE, LRCONDV, WORK, LWORK, IWORK, BWORK, LINFO )
        ENDIF
      ELSE
        IF (PRESENT (VR)) THEN
     	    CALL GGEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&             BETA, LLVL, S1VL, VR, S1VR, LILO, LIHI, LLSCALE, LRSCALE, LABNRM, LBBNRM,&
&             LRCONDE, LRCONDV, WORK, LWORK, IWORK, BWORK, LINFO )
        ELSE
	    CALL GGEVX_F77( LBALANC, LJOBVL, LJOBVR, LSENSE, N, A, LD, B, LD, ALPHAR, ALPHAI, &
&             BETA, LLVL, S1VL, LLVR, S1VR, LILO, LIHI, LLSCALE, LRSCALE, LABNRM, LBBNRM,&
&             LRCONDE, LRCONDV, WORK, LWORK, IWORK, BWORK, LINFO )
        ENDIF
      ENDIF	
      IF( LINFO == 0 ) LWORK = INT(WORK(1)+1)
      
      IF( PRESENT(ILO) ) ILO = LILO; IF( PRESENT(IHI) ) IHI = LIHI
      IF( PRESENT(ABNRM) ) ABNRM = LABNRM
      IF( PRESENT(BBNRM) ) BBNRM = LBBNRM

      DEALLOCATE(WORK)
100  IF (.NOT. PRESENT(RCONDE)) DEALLOCATE(LRCONDE) 
500  IF (.NOT. PRESENT(RCONDV)) DEALLOCATE(LRCONDV) 
600  IF (.NOT. PRESENT(RSCALE)) DEALLOCATE(LRSCALE)
700  IF (.NOT. PRESENT(LSCALE)) DEALLOCATE(LLSCALE)
800  DEALLOCATE (IWORK) 
900  DEALLOCATE (BWORK) 
     ENDIF
1000  CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE DGGEVX_F95

PROGRAM LA_CGESVX_ET_EXAMPLE
!
!  -- LAPACK95 INTERFACE DRIVER ROUTINE (VERSION 3.0) --
!     UNI-C, DENMARK; UNIV. OF TENNESSEE, USA; NAG LTD., UK
!     SEPTEMBER, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GESVX, LA_GETRF
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
   CHARACTER(LEN=*), PARAMETER :: FMT = '(4(1X,1H(,F9.3,1H,,F9.3,1H):))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: EQUED
   INTEGER :: I, J, INFO, N, NRHS
   REAL(WP) :: RPVGRW, RCOND, BERR1, FERR1
!  .. LOCAL ARRAYS ..
   INTEGER, ALLOCATABLE :: IPIV(:)
   REAL(WP), ALLOCATABLE :: AA(:,:), BB(:,:), FERR(:), BERR(:), R(:), C(:)
   COMPLEX(WP), ALLOCATABLE :: A(:,:), B(:,:), AF(:,:), X(:,:), B1(:), X1(:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'GESVX ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N, NRHS
   ALLOCATE ( IPIV(N), A(N,N), B(N,NRHS), AA(N,N), BB(N,NRHS), &
               FERR(NRHS), BERR(NRHS), R(N), C(N), AF(N,N), &
               X(N,NRHS), B1(N), X1(N) )
!
      DO I = 1, N
        READ (NIN, *) (AA(I, J), J = 1, N)
      ENDDO
      DO J = 1, NRHS
         BB(:,J) = SUM( AA, DIM=2)*J
      ENDDO
      A = AA; B = BB
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N
        WRITE (NOUT,FMT) A(I,:)
      ENDDO
      WRITE(NOUT,*) 'The RHS matrix B:'
      DO J = 1, NRHS
        WRITE (NOUT,FMT) B(:,J)
      ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_CGESVX LAPACK SUBROUTINE Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_GESVX( A, B, X )'
   WRITE(NOUT,*) 'ON ENTRY: A, B'
   WRITE(NOUT,*) '   A - the original matrix'
   WRITE(NOUT,*) '   B - the right hand side matrix'
   WRITE(NOUT,*) 'ON EXIT: X'
   A=AA; B=BB
   CALL LA_GESVX( A, B, X )
   WRITE(NOUT,*)'   The solution vectors X computed by LA_GESVX:'
   DO J = 1, NRHS
      WRITE (NOUT,FMT) X(:,J)
   END DO
   A=AA; B=BB
   B1(1:N)=B(1:N,1)
   CALL LA_GESVX( A, B1, X1 )
   WRITE(NOUT,*)'   The solution vector X computed by LA_GESVX:'
   WRITE (NOUT,FMT) X1(:)
! 
   WRITE(NOUT,*)
   WRITE(NOUT,*) "CALL LA_GESVX(A, B, X, AF, IPIV, FACT='F', TRANS='N')"
   WRITE(NOUT,*) 'ON ENTRY: A, B, AF, IPIV'
   WRITE(NOUT,*) '   A - the original matrix'
   WRITE(NOUT,*) '   B - the right hand side matrix'
   WRITE(NOUT,*) '   AF - the factors L U of matrix A'
   WRITE(NOUT,*) '   IPIV - the pivot'
   WRITE(NOUT,*) 'ON EXIT: X'
   A=AA; B=BB; AF=A
   CALL LA_GETRF(AF, IPIV)
   CALL LA_GESVX(A,B,X,AF,IPIV,FACT='F',TRANS='N')
   WRITE(NOUT,*)'   The solution vectors X computed by LA_GESVX:'
   DO J = 1, NRHS
      WRITE (NOUT,FMT) X(:,J)
   END DO
   A=AA; B=BB; AF=A
   B1(1:N)=B(1:N,1)
   CALL LA_GETRF(AF, IPIV)
   CALL LA_GESVX(A,B(:,1),X(:,1),AF,IPIV,FACT='F',TRANS='N')
   WRITE(NOUT,*)'   The solution vector X computed by LA_GESVX:'
   WRITE (NOUT,FMT) X(:,1)
   A=AA; B=BB; AF=A
   CALL LA_GETRF(AF, IPIV)
   CALL LA_GESVX(A, B, X, AF, IPIV, 'N', 'N', EQUED, &
                    R, C, FERR, BERR, RCOND, RPVGRW, INFO)
   WRITE(NOUT,*)'   The solution vectors X computed by LA_GESVX:'
   DO J = 1, NRHS
      WRITE (NOUT,FMT) X(:,J)
   END DO
   A=AA; B=BB; AF=A
   B1(1:N)=B(1:N,1)
   CALL LA_GETRF(AF, IPIV)
   CALL LA_GESVX( A, B1, X1, AF, IPIV, 'N', 'N', EQUED, &
                     R, C, FERR1, BERR1, RCOND, RPVGRW, INFO )
   WRITE(NOUT,*)'   The solution vector X computed by LA_GESVX:'
   WRITE (NOUT,FMT) X1(:)
!
END PROGRAM LA_CGESVX_ET_EXAMPLE

      PROGRAM LA_SGELS_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GELS
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, M, N, NRHS
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GELS Example Program Results'
      M=6; N = 4; NRHS = 3
      WRITE(*,'(5H N = , I4, 9H; NRHS = , I4)') N, NRHS
      ALLOCATE( A(M,N), AA(M,N), B(M,NRHS), BB(M,NRHS) )

      OPEN(UNIT=21,FILE='gels.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,M 
            READ(21,'(F2.0)') A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix A :'
      DO I=1,M;
         WRITE(*,"(24(F9.5))") A(I,:);
      ENDDO
      
      AA=A
      
      OPEN(UNIT=22,FILE='gels.mb',STATUS='UNKNOWN')
      DO J=1,NRHS
         DO I=1,M 
            READ(22,'(F3.0)') B(I,J)
         ENDDO
      ENDDO
      CLOSE(22)
      
      BB=B
      WRITE(*,*)'Matrix B :'
      DO I=1,M; 
         WRITE(*,"(3(F9.5))") B(I,:); 
      ENDDO
         
      WRITE(*,*) 'CALL LA_GELS( A, B )'
      CALL LA_GELS(  A, B )
      
      WRITE(*,*) 'The matrix B on exit :'
      DO I=1,M; 
         WRITE(*,"(3(E13.6))") B(I,:); 
      ENDDO
      WRITE(*,*)
      WRITE(*,*)' * EXAMPLE 2 * '
         
      WRITE(*,*)'Matrix A :'
      DO I=1,M;
         WRITE(*,"(24(F9.5))") AA(I,:);
      ENDDO       

      WRITE(*,*)'Matrix B(:,1) :'
      WRITE(*,"(F9.5)") BB(:,1); 
    
      WRITE(*,*) "CALL LA_GELS( A, B(:,1), 'T', INFO )"
      CALL LA_GELS( A, B(:,1), 'T', INFO )

      WRITE(*,*) 'The matrix B on exit :' 
      WRITE(*,"(E13.6)") B(:,1); 
     
      WRITE(*,*) 'INFO = ', INFO

      END PROGRAM LA_SGELS_EXAMPLE

SUBROUTINE ZGELSD_F95( A, B, RANK, S, RCOND, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
      USE LA_PRECISION, ONLY: WP => DP
      USE LA_AUXMOD, ONLY: ERINFO
      USE F77_LAPACK, ONLY: GELSD_F77 => LA_GELSD,  ILAENV_F77 => ILAENV
!   .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
      INTEGER, INTENT(OUT), OPTIONAL :: RANK
      INTEGER, INTENT(OUT), OPTIONAL :: INFO
      REAL(WP), INTENT(IN), OPTIONAL :: RCOND
!   .. ARRAY ARGUMENTS ..
      COMPLEX(WP), INTENT(INOUT) :: A(:,:), B(:,:)
      REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: S(:)
!----------------------------------------------------------------------
! 
! Purpose
! ======= 
!
!       LA_GELSS and LA_GELSD compute the minimum-norm least squares 
! solution to one or more real or complex linear systems A*x = b using
! the singular value decomposition of A. Matrix A is rectangular and may
! be rank-deficient. The vectors b and corresponding solution vectors x
! are the columns of matrices denoted B and X , respectively.
!       The effective rank of A is determined by treating as zero those 
! singular values which are less than RCOND times the largest singular 
! value. In addition to X , the routines also return the right singular
! vectors and, optionally, the rank and singular values of A.
!       LA_GELSD combines the singular value decomposition with a divide
! and conquer technique. For large matrices it is often much faster than 
! LA_GELSS but uses more workspace.
! 
! ==========
! 
!        SUBROUTINE LA_GELSS / LA_GELSD( A, B, RANK=rank, S=s, &
!                                          RCOND=rcond, INFO=info )
!             <type>(<wp>), INTENT( INOUT ) :: A( :, : ), <rhs>
!             INTEGER, INTENT(OUT), OPTIONAL :: RANK
!             REAL(<wp>), INTENT(OUT), OPTIONAL :: S(:)
!             REAL(<wp>), INTENT(IN), OPTIONAL :: RCOND
!             INTEGER, INTENT(OUT), OPTIONAL :: INFO
!        where
!             <type> ::= REAL | COMPLEX
!             <wp>   ::= KIND(1.0) | KIND(1.0D0)
!             <rhs>  ::= B(:,:) | B(:)
! 
! Arguments
! =========
! 
! A       (input/output) REAL or COMPLEX array, shape (:,:).
!         On entry, the matrix A.
!         On exit, the first min(size(A,1), size(A,2)) rows of A are 
!         overwritten with its right singular vectors, stored rowwise.
! B       (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(B,1) = max(size(A,1), size(A,2)) or shape (:) with 
!         size(B) = max(size(A,1), size(A,2)).
!         On entry, the matrix B.
!         On exit, the solution matrix X .
!         If size(A,1) >= size(A,2) and RANK = size(A,2), the residual 
!         sum-of-squares for the solution in a column of B is given by 
!         the sum of squares of elements in rows size(A,2)+1:size(A,1)
!         of that column.
! RANK    Optional (output) INTEGER.
!         The effective rank of A, i.e., the number of singular values 
!         of A which are greater than the product RCOND*sigma1 , where
!  	  sigma1 is the greatest singular value.
! S       Optional (output) REAL array, shape (:) with size(S) = 
!         min(size(A,1), size(A,2)).
!         The singular values of A in decreasing order.
!         The condition number of A in the 2-norm is
! 	  K2(A)= sigma1/sigma(min(size(A,1),size(A,2)) .
! RCOND   Optional (input) REAL.
!         RCOND is used to determine the effective rank of A.
!         Singular values sigma(i)<=RCOND*sigma1  are treated as zero.
!         Default value: 10*max(size(A,1), size(A,2))*EPSILON(1.0_<wp>),
!         where <wp> is the working precision.
! INFO    Optional (output) INTEGER.
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: the algorithm for computing the SVD failed to converge; 
! 	  if INFO = i,i off-diagonal elements of an intermediate 
! 	  bidiagonal form did not converge to zero.
!         If INFO is not present and an error occurs, then the program 
! 	  is terminated with an error message.
!----------------------------------------------------------------------
!   .. PARAMETERS ..
      CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GELSD'
!   .. LOCAL SCALARS ..
      INTEGER :: LINFO, ISTAT, LWORK, N, M, MN, NRHS, LRANK, SS, &
     &  LIWORK, SMLSIZ, NLVL, LRWORK
      REAL(WP) :: LRCOND
!   .. LOCAL POINTERS ..
      COMPLEX(WP), POINTER :: WORK(:)
      REAL(WP), POINTER :: LS(:)
      INTEGER, POINTER :: IWORK(:)
      REAL(WP), POINTER :: RWORK(:)
      COMPLEX(WP) :: WORKMIN(1)
      INTEGER :: IWORKMIN(1) 
      DOUBLE PRECISION  TWO
      PARAMETER       ( TWO = 2.0D0 ) 
!   .. INTRINSIC FUNCTIONS ..
      INTRINSIC SIZE, PRESENT, MAX, MIN, EPSILON
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2); NRHS = SIZE(B,2)
    MN = MIN(M,N)
       SMLSIZ = ILAENV_F77( 9, 'ZGELSD', ' ', 0, 0, 0, 0 )
       NLVL = MAX(INT(LOG(DBLE(MAX(1,MN))/DBLE(SMLSIZ+1))/LOG(TWO)),0)
! NEXT LINE SHOULD BE  LIWORK = 3 * MN * NLVL + 11 * MN, WHEN THE LAPACK CODE IS FIXED
       LIWORK = 2*(3 * MN * NLVL + 11 * MN)
       LRWORK = 8  * MN + 2*MN*SMLSIZ + 8*MN*NLVL + MN*NRHS
       
       LRWORK = 25000
       ALLOCATE(RWORK(LRWORK), STAT = ISTAT)
       IF (ISTAT /= 0) THEN ; LINFO=-100; GOTO 100; ENDIF
       
       IF( PRESENT(RCOND) )THEN; LRCOND = RCOND
       ELSE; LRCOND = 100*EPSILON(1.0_WP); ENDIF
       IF( PRESENT(S) )THEN; SS = SIZE(S); ELSE; SS =MN; ENDIF
!   .. TEST THE ARGUMENTS
       IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
       ELSE IF( SIZE( B, 1 ) /= MAX(1,M,N) .OR. NRHS < 0 ) THEN; LINFO = -2
       ELSE IF( SS /= MN ) THEN; LINFO = -4
       ELSE IF( LRCOND <= 0.0_WP ) THEN; LINFO = -5
       ELSE 
          IF( PRESENT(S) )THEN; LS => S
          ELSE
            ALLOCATE( LS(MN), STAT = ISTAT );
            IF (ISTAT /= 0) THEN ;
             LINFO=-200; GOTO 200; ENDIF
          END IF
          LWORK=-1
       
          CALL GELSD_F77( M, N, NRHS, A, MAX(1,M), B, MAX(1,M,N), &
     &         LS, LRCOND, LRANK, WORKMIN, LWORK, RWORK, IWORKMIN, LINFO )
          LWORK = WORKMIN(1)
! THE NEXT LINE SHOULD BE REMOVED, WHEN THE LAPACK CODE IS FIXED.
          LWORK = 10 * LWORK
          ALLOCATE( WORK(LWORK), IWORK(LIWORK), STAT = ISTAT )
          IF (ISTAT /= 0) THEN; 
	    LINFO=-300; GOTO 300
          ENDIF
       
          CALL GELSD_F77( M, N, NRHS, A, MAX(1,M), B, SIZE(B,1), &
     &      LS, LRCOND, LRANK, WORK, LWORK, RWORK, IWORK, LINFO )
       
          IF( PRESENT(RANK) ) RANK = LRANK
          DEALLOCATE(WORK, IWORK, STAT = ISTAT)
300       IF (.NOT. PRESENT(S)) DEALLOCATE(LS, STAT = ISTAT)
        END IF
200     DEALLOCATE(RWORK, STAT = ISTAT)
100     CALL ERINFO( LINFO, SRNAME, INFO, ISTAT ) 
END SUBROUTINE ZGELSD_F95

SUBROUTINE LA_TEST_CHEEVD( JOBZ, UPLO, N, A, LDA, W,  WORK, LWORK, RWORK, LRWORK, IWORK, LIWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark; 
!     May 26, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_HEEVD
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, LDA, LWORK, LRWORK, LIWORK
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: JOBZ, UPLO
!  .. Array Arguments ..
   COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N)
   COMPLEX(WP), INTENT(OUT) :: WORK(1: LWORK)
   REAL(WP), INTENT(OUT) ::  W(1:N)
   REAL(WP) :: RWORK(1: LRWORK)
   INTEGER, INTENT(OUT) :: IWORK(1: LIWORK)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_HEEVD'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_CHEEVD'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IW
   CHARACTER*1 :: IUPLO, IJOBZ
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = N; IA2 = N; IUPLO = UPLO; IJOBZ = JOBZ; IW = N; IWORK = LWORK
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE (1)
      IA2 = IA1-1
   CASE (2)
     IW = IW -1
   CASE (3)
     IJOBZ = 'T'
   CASE(4)
      IUPLO = 'T'   
   CASE(:-1,5:)
      CALL UESTOP(SRNAMT)
   END SELECT
        CALL LA_HEEVD( A(1:IA1, 1:IA2), W(1:IW), IJOBZ, IUPLO, INFO)

   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_CHEEVD

      PROGRAM LA_SGESVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GESVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N, NRHS
!  .. "Local Arrays" ..
      INTEGER, ALLOCATABLE :: IPIV(:)
      REAL(WP) :: RCOND, RPVGRW
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), X(:,:),BB(:,:), FERR(:), BERR(:)
      REAL(WP), ALLOCATABLE :: RR(:,:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SGESVX Example Program Results.'
      WRITE(*,*)'Size of matrix A, N = ?'
      READ ( *, * ) N
      WRITE(*,*)'Number of right hand sides, NRHS = ?'
      READ ( *, * ) NRHS
      ALLOCATE( A(N,N), AA(N,N), B(N,NRHS), X(N,NRHS),BB(N,NRHS), IPIV(N), RR(N,N), FERR(NRHS), BERR(NRHS) )

      OPEN(UNIT=21,FILE='gesv.ma',STATUS='UNKNOWN')
      DO J=1,N
      DO I=1,N 
         READ(21,'(F2.0)') AA(I,J)
      ENDDO  
      ENDDO
      CLOSE(21)

!      DO I = 1, N; READ (*, *) (RR(I, J), J = 1, N); ENDDO
!      AA=RR
      
      DO J = 1, NRHS; BB(:,J) = SUM( AA, DIM=2)*J; ENDDO
      
      WRITE(*,*) 'The matrix A:'
      DO I=1,N; WRITE(*,"(4(I3,1X),I3,1X)") INT(AA(I,:)); ENDDO
     
      WRITE(*,*) 'The RHS matrix B:'
      DO I=1,N; WRITE(*,"(2(I3,1X),I3,1X)") INT(BB(I,:)); ENDDO
        
      WRITE(*,*) 'CALL LA_GESVX( A, B, X, FERR=FERR, BERR=BERR, RCOND=RCOND, RPVGRW=RPVGRW )'
      A=AA; B=BB
      CALL LA_GESVX( A, B, X, FERR=FERR, BERR=BERR, RCOND=RCOND, RPVGRW=RPVGRW )
      
      WRITE(*,*) 'FERR = ', FERR
      WRITE(*,*) 'BERR = ', BERR
      WRITE(*,*) 'RCOND = ', RCOND
      WRITE(*,*) 'RPVGRW = ', RPVGRW

      WRITE(*,*) '\noindent'
      WRITE(*,*) 'The solution of the system $ A\,X = B $ is:'
      WRITE(*,*) '$$ X = \left( \begin{array}{rrr}'
      DO I=1,N; WRITE(*,"(2(F9.5,' & '),F9.5,' \\')") X(I,:); ENDDO
      WRITE(*,*) '\end{array} \right). $$'

      END PROGRAM LA_SGESVX_EXAMPLE

SUBROUTINE DSBGV_F95( A, B, W, UPLO, Z, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: SBGV_F77 => LA_SBGV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
   REAL(WP), INTENT(OUT) :: W(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: Z(:,:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_SBGV, LA_SBGVD, LA_HBGV and LA_HBGVD compute all eigenvalues and,
! optionally, all eigenvectors of the generalized eigenvalue problem
!                    A*z = lambda*B*z,
! where A and B are real symmetric in the cases of LA_SBGV and LA_SBGVD 
! and complex Hermitian in the cases of LA_HBGV and LA_HBGVD. Matrix B
! is positive definite. Matrices A and B are stored in a band format.
!    LA_SBGVD and LA_HBGVD use a divide and conquer algorithm. If 
! eigenvectors are desired, they can be much faster than LA_SBGV and 
! LA_HBGV for large matrices but use more workspace.
! 
! =========
! 
!         SUBROUTINE LA_SBGV / LA_SBGVD / LA_HBGV / LA_HBGVD( AB, BB, &
!                                        W, UPLO=uplo, Z=z, INFO=info )
!               <type>(<wp>), INTENT(INOUT) :: AB(:,:), BB(:,:)
!               REAL(<wp>), INTENT(OUT) :: W(:)
!               CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!               <type>(<wp>), INTENT(OUT), OPTIONAL :: Z(:,:)
!               INTEGER, INTENT(OUT), OPTIONAL :: INFO
!         where
!               <type> ::= REAL | COMPLEX
!               <wp>   ::= KIND(1.0) | KIND(1.0D0)
! 
! Arguments
! =========
! 
! AB      (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(AB,1) = ka + 1 and size(AB,2) = n, where ka is the number
! 	  of subdiagonals or superdiagonals in the band and n is the 
!    	  order of A and B.
!         On entry, the upper (if UPLO = 'U') or lower (if UPLO = 'L') 
! 	  triangle of matrix A in band storage. The ka + 1 diagonals of
! 	  A are stored in the rows of AB so that the j-th column of A
!         is stored in the j-th column of AB as follows:
!         if UPLO = 'U', AB(ka+1+i-j,j) = A(i,j) for max(1,j-ka)<=i<=j,
! 	                                           1<=j<=n
!         if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+ka),
! 	                                           1<=j<=n.
!         On exit, the contents of AB are destroyed.
! BB      (input/output) REAL or COMPLEX array, shape (:,:) with 
!         size(BB,1) = kb + 1 and size(BB,2) = n, where kb is the number
! 	  of subdiagonals or superdiagonals in the band of B.
!         On entry, the upper (if UPLO = 'U') or lower (if UPLO = 'L')
! 	  triangle of matrix B in band storage. The kb + 1 diagonals of
! 	  B are stored in the rows of BB so that the j-th column of B
!         is stored in the j-th column of BB as follows:
!         if UPLO = 'U', BB(kb+1+i-j,j) = B(i,j) for max(1,j-kb)<=i<=j,
! 	                                           1<=j<=n
!         if UPLO = 'L', BB(1+i-j,j)    = B(i,j) for j<=i<=min(n,j+kb),
! 	                                           1<=j<=n.
!         On exit, the factor S from the split Cholesky factorization
! 	  B = S^H*S.
! W       (output) REAL array, shape (:) with size(W) = n.
!         The eigenvalues in ascending order.
! UPLO    Optional (input) CHARACTER(LEN=1).
!           = 'U': Upper triangles of A and B are stored;
!           = 'L': Lower triangles of A and B are stored.
!         Default value: 'U'.
! Z       Optional (output) REAL or COMPLEX square array, shape (:,:)
!         with size(Z,1) = n.
!         The matrix Z of eigenvectors, normalized so that Z^H*B*Z = I.
! INFO    Optional (output) INTEGER.
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: the algorithm failed to converge or matrix B is not
! 	    positive definite:
!            <= n: if INFO = i, i off-diagonal elements of an 
! 	      intermediate tridiagonal form did not converge to 
! 	      zero.
!            > n: if INFO = n+i, for 1<=i<=n, then the leading minor of
! 	      order i of B is not positive definite. The factorization
! 	      of B could not be completed and no eigenvalues or
! 	      eigenvectors were computed.
!         If INFO is not present and an error occurs, then the program is
! 	  terminated with an error message.
!-----------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_SBGV'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBZ, LUPLO
   INTEGER :: LINFO, N, ISTAT, ISTAT1, S1Z, S2Z, KA, KB, &
              LDA, LDB
!  .. LOCAL ARRAYS ..
   REAL(WP), TARGET :: LLZ(1,1)
   REAL(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC SIZE, MAX, PRESENT
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; KA = SIZE(A,1)-1; N = SIZE(A,2); LDA = MAX(SIZE(A,1),1)
   ISTAT = 0; KB = SIZE(B,1)-1; LDB = MAX(SIZE(B,1),1)
   IF( PRESENT(Z) )THEN; S1Z = SIZE(Z,1); S2Z = SIZE(Z,2); LJOBZ = 'V'
   ELSE; S1Z = 1; S2Z = 1; LJOBZ = 'N'; END IF
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
!  .. TEST THE ARGUMENTS
   IF( KA < 0 .OR. N < 0 ) THEN; LINFO = -1
   ELSE IF( KB < 0 .OR. SIZE(B,2) /= N ) THEN; LINFO = -2
   ELSE IF( SIZE(W) /= N )THEN; LINFO = -3
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -4
   ELSE IF( PRESENT(Z) .AND. ( S1Z /= N .OR. S2Z /= N ) )THEN; LINFO = -5
   ELSE IF( N > 0 )THEN
      ALLOCATE(WORK(MAX(1,3*N)), STAT=ISTAT)
      IF( ISTAT == 0 )THEN
         IF( PRESENT(Z) )THEN
            CALL SBGV_F77( LJOBZ, LUPLO, N, KA, KB, A, LDA, B, LDB, W, Z, S1Z, &
                        WORK, LINFO )
         ELSE
	    CALL SBGV_F77( LJOBZ, LUPLO, N, KA, KB, A, LDA, B, LDB, W, LLZ, S1Z, &
                        WORK, LINFO )
         ENDIF			
      ELSE; LINFO = -100; ENDIF
      DEALLOCATE(WORK, STAT=ISTAT1)
   ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE DSBGV_F95

SUBROUTINE CGETRI_F95( A, IPIV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO
   USE F77_LAPACK, ONLY: GETRI_F77 => LA_GETRI, ILAENV_F77 => ILAENV
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
!  .. ARRAY ARGUMENTS ..
   INTEGER, INTENT(IN) :: IPIV(:)
   COMPLEX(WP), INTENT(INOUT) :: A(:,:)
!-----------------------------------------------------------------
!
! Purpose
! =======
!
! LA_GETRI computes the inverse of a matrix using the LU factorization 
! computed by LA_GETRF.
!
! Arguments
! =========
! SUBROUTINE LA_GETRI (A, IPIV, INFO)
!    <type>(<wp>), INTENT(INOUT)  :: A(:,:)
!    INTEGER, INTENT(IN) :: IPIV(:)
!    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!    where
!    <type> ::= REAL | COMPLEX
!    <wp>   ::= KIND(1.0) | KIND(1.0D0)
!
! =====================
!
! A      (input/output) either REAL or COMPLEX square array, shape (:,:),
!        size(A,1) == size(A,2).
!        On entry contains the factors L and U from the factorization
!           A = PLU as computed by LA_GETRF.
!        On exit, if INFO = 0, the inverse of the original matrix A.
!
! IPIV   (input) INTEGER array, shape (:), size(IPIV) == size(A,1).
!        The pivot indices from LA_GETRF; for 1<=i<=size(A,1), row i of
!        the matrix was interchanged with row IPIV(i).
!
! INFO   Optional (output) INTEGER.
!        If INFO is present
!           = 0: successful exit
!           < 0: if INFO = -k, the k-th argument had an illegal value
!           > 0: if INFO = k, U(k,k) is exactly zero.  The matrix is
!               singular and its inverse could not be computed.
!        If INFO is not present and an error occurs, then the program is
!           terminated with an error message.
!-----------------------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GETRI'
   CHARACTER(LEN=6), PARAMETER :: BSNAME = 'CGETRI'
!  .. LOCAL SCALARS ..
   INTEGER    :: LINFO, N, LD, LWORK, ISTAT, ISTAT1, NB
!  .. LOCAL ARRAY ..
   COMPLEX(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC SIZE, MAX
!  .. EXECUTABLE STATEMENTS ..
   N = SIZE(A,1); LINFO = 0; LD = MAX(1,N); ISTAT = 0
!  .. TEST THE ARGUMENTS
   IF( SIZE( A, 2 ) /= N .OR. N < 0 )THEN; LINFO = -1
   ELSE IF( SIZE( IPIV ) /= N )THEN; LINFO = -2
   ELSE IF( N > 0 )THEN
!     DETERMINE THE WORK SPACE.
      NB = ILAENV_F77( 1, BSNAME, ' ', N, -1, -1, -1 )
      IF( NB < 1 .OR. NB >= N )THEN; NB = 1; END IF
      LWORK = MAX( N*NB, 1 )
      ALLOCATE(WORK(LWORK), STAT=ISTAT)
      IF( ISTAT /= 0 )THEN; DEALLOCATE(WORK, STAT=ISTAT1)
         LWORK = MAX(1,N); ALLOCATE(WORK(LWORK), STAT=ISTAT)
         IF( ISTAT == 0 ) CALL ERINFO( -200, SRNAME, LINFO )
      END IF
      IF( LINFO == 0 )THEN
         CALL GETRI_F77( N, A, LD, IPIV, WORK, LWORK, LINFO )
      ELSE; LINFO = -100; END IF
      DEALLOCATE(WORK, STAT=ISTAT1)
   END IF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE CGETRI_F95

PROGRAM LA_DSPEVX_ET_EXAMPLE
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_SPEVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. PARAMETERS ..
      CHARACTER(LEN=*), PARAMETER :: FMT = '(8(1X,F10.3))'
   INTEGER, PARAMETER :: NIN=5, NOUT=6
!  .. LOCAL SCALARS ..
   INTEGER :: I, J, INFO, N, NS, M
!  .. LOCAL ARRAYS ..
   INTEGER, ALLOCATABLE :: IFAIL(:)
   REAL(WP), ALLOCATABLE :: AA(:), W(:)
   REAL(WP), ALLOCATABLE :: A(:), Z(:,:)
!  .. EXECUTABLE STATEMENTS ..
   WRITE (NOUT,*) 'DSPEVX ET_Example Program Results.'
   READ ( NIN, * )   ! SKIP HEADING IN DATA FILE
   READ ( NIN, * ) N
   PRINT *, 'N = ', N
   NS = N*(N+1)/2
   ALLOCATE ( A(NS), AA(NS), W(N), Z(N,N), IFAIL(N) )
!
      READ (NIN, *) AA
   A=AA
      WRITE(NOUT,*) 'The matrix A:'
      DO I = 1, N
        WRITE (NOUT,*) 'J = ', I; WRITE (NOUT,FMT) (A(J+(I-1)*I/2),J=1,I)
      ENDDO
!
   WRITE ( NOUT, * )'---------------------------------------------------------'
   WRITE ( NOUT, * )
   WRITE ( NOUT, * )'Details of LA_DSPEVX LAPACK Subroutine Results.'
   WRITE ( NOUT, * )
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, INFO=INFO )'
   A=AA
   CALL LA_SPEVX( A, W, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, Z=Z, INFO=INFO )'
   A=AA
   CALL LA_SPEVX( A, W, Z=Z, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, ''U'', Z )'
   A=AA
   CALL LA_SPEVX( A, W, 'U', Z )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, ''L'', Z )'
   A=AA
   CALL LA_SPEVX( A, W, 'L', Z )
   WRITE(NOUT,*) ' EIGENVALUES:'
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, VL=3.0_WP, M=M, INFO=INFO )'
   A=AA
   CALL LA_SPEVX( A, W, VL=3.0_WP, M=M, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO, ' EIGENVALUES:'
   WRITE(NOUT,*) 'The total number of eigenvalues found is ', M
   WRITE(NOUT,FMT) W(1:M)
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, ''U'', Z, -HUGE(1.0_WP), HUGE(1.0_WP), &'
   WRITE(NOUT,*) '          M=M, IFAIL=IFAIL, ABSTOL=2*EPSILON(1.0_WP), INFO=INFO )'
   A=AA; M=99999; IFAIL = 99999; Z = HUGE(1.0_WP); W = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, 'U', Z, -HUGE(1.0_WP), HUGE(1.0_WP), &
                  M=M, IFAIL=IFAIL, ABSTOL=2*EPSILON(1.0_WP), INFO=INFO )
   WRITE(NOUT,*) 'M, INFO, EIGENVALUES:', M, INFO
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
   WRITE(NOUT,*) 'IFAIL:'; WRITE (NOUT,*) IFAIL
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, ''U'', Z, IL=1, IU=N, M=M, IFAIL=IFAIL, &'
   WRITE(NOUT,*) '         ABSTOL= 2*EPSILON(1.0_WP), INFO=INFO )'
   A=AA; M=99999; IFAIL = 99999; Z = HUGE(1.0_WP); W = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, 'U', Z, IL=1, IU=N, M=M, IFAIL=IFAIL, &
                  ABSTOL=2*EPSILON(1.0_WP), INFO=INFO )
   WRITE(NOUT,*) 'M, INFO, EIGENVALUES:', M, INFO
   WRITE(NOUT,FMT) W
   WRITE(NOUT,*) 'EIGENVECTORS:'
   DO I = 1, N; WRITE(NOUT,*) 'I = ', I; WRITE (NOUT,FMT) Z(:,I); END DO
   WRITE(NOUT,*) 'IFAIL:'; WRITE (NOUT,*) IFAIL
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A(1:5), W, INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A(1:5), W, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W(1:N-1), INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W(1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, UPLO=''9'', INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, UPLO='9', INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, Z=Z(1:N-1,:), INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, Z=Z(1:N-1,:), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, Z=Z(:,1:N-1), INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, Z=Z(:,1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, VL=10.0_WP, VU=1.0_WP, INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, VL=10.0_WP, VU=1.0_WP, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, VL=1.0_WP, VU=2.0_WP, IL=1, INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, VL=1.0_WP, VU=2.0_WP, IL=1, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, IL=-1, INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, IL=-1, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, IL=N, IU=1, INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, IL=N, IU=1, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, IL=1, IU=N+1, INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, IL=1, IU=N+1, INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, IFAIL=IFAIL(1:N-1), INFO=INFO )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, IFAIL=IFAIL(1:N-1), INFO=INFO )
   WRITE(NOUT,*) 'INFO = ', INFO
!
   WRITE(NOUT,*)
   WRITE(NOUT,*) 'CALL LA_SPEVX( A, W, IFAIL=IFAIL )'
   A=AA; Z = HUGE(1.0_WP)
   CALL LA_SPEVX( A, W, IFAIL=IFAIL )
!
END!PROGRAM LA_DSPEVX_ET_EXAMPLE

SUBROUTINE LA_TEST_SSPSVX( FACT, UPLO, N, NRHS, AP, AFP, IPIV, B, LDB, X, LDX,&
     &  RCOND, FERR, BERR, WORK, IWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark;
!     April 7, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_SPSVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, NRHS, LDB, LDX
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: FACT, UPLO
      REAL(WP), INTENT(OUT) :: RCOND
!  .. Array Arguments ..
      INTEGER, INTENT(INOUT) :: IPIV(1:N)
      REAL(WP), INTENT(INOUT) :: AP(1:N*(N+1)/2), B(1:LDB,1:NRHS)
      REAL(WP), INTENT(INOUT) :: AFP(1: N*(N+1)/2)
      REAL(WP), INTENT(OUT) :: X(1:LDX,1: NRHS), WORK(1:3*N)
      REAL(WP), INTENT(OUT) :: FERR(1:NRHS), BERR(1:NRHS)
      INTEGER, INTENT(OUT) :: IWORK(1:N)
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_SPSVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SSPSVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IAP, IB1, IB2, IIPIV, IX1, IX2, IAFP, IFERR, &
     &  IBERR
      CHARACTER*1 :: IUPLO, IFACT   
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IAP = N*(N+1)/2; IB1 = N; IB2 = NRHS; IUPLO= UPLO; IIPIV=N
      IX1 = N; IX2 = NRHS; IAFP = N*(N+1)/2; IFACT=FACT; IFERR=NRHS
      IBERR = NRHS
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE(0)
      IF ( NRHS == 1 ) THEN
        CALL LA_SPSVX( AP(1:IAP), B(1:IB1,1), X(1:IX1,1), IUPLO, &
     &    AFP(1: IAFP), IPIV(1:IIPIV), IFACT, FERR(1), &
     &    BERR(1), RCOND, INFO )
        INFO = INFOTC
      ELSE
        CALL LA_SPSVX( AP(1:IAP), B(1:IB1,1:IB2), X(1:IX1,1:IX2), IUPLO, &
     &    AFP(1: IAFP), IPIV(1:IIPIV), IFACT, FERR(1:IFERR), &
     &    BERR(1: IBERR), RCOND, INFO )
        INFO = INFOTC
      END IF
      CASE (1)
      IAP = IAP - 1
      CASE (2)
      IB1 = IB1 - 1
      CASE (3)
      IX1 = IB1 - 1
      CASE (4)
      IUPLO = 'T'
      CASE (5)
      IAFP = IAP - 1
      CASE (6)
      IIPIV = IB1 - 1
      CASE (7)
      IFACT = 'T'
      CASE (8)
      IFERR = 7
      CALL LA_SPSVX( AP(1:IAP), B(1:IB1,1:IB2), X(1:IX1,1:IX2), IUPLO, &
     &  AFP(1: IAFP), IPIV(1:IIPIV), IFACT, FERR(1:IFERR), &
     &  BERR(1: IBERR), RCOND, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (9)
      IBERR = 7
      CALL LA_SPSVX( AP(1:IAP), B(1:IB1,1:IB2), X(1:IX1,1:IX2), IUPLO, &
     &  AFP(1: IAFP), IPIV(1:IIPIV), IFACT, FERR(1:IFERR), &
     &  BERR(1: IBERR), RCOND, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN  
      CASE(:-1,10:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF( I /= 0 ) THEN
        SELECT CASE (NRHS)
        CASE (2:)
        CALL LA_SPSVX( AP(1:IAP), B(1:IB1,1:IB2), X(1:IX1,1:IX2), IUPLO, &
     &    AFP(1: IAFP), IPIV(1:IIPIV), IFACT, FERR(1:IFERR), &
     &    BERR(1: IBERR), RCOND, INFO )
        CASE(1)
        CALL LA_SPSVX( AP(1:IAP), B(1:IB1,1), X(1:IX1, 1), IUPLO, &
     &    AFP(1: IAFP), IPIV(1:IIPIV), IFACT, FERR(1), &
     &    BERR(1), RCOND, INFO ) 
        CASE(:-1)
        CALL UESTOP(SRNAMT)
      END SELECT
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      END SUBROUTINE LA_TEST_SSPSVX

      PROGRAM LA_SGGES_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GGES
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, N, SDIM
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:), VSL(:,:)
      REAL(WP), ALLOCATABLE :: ALPHAR(:), ALPHAI(:), BETA(:), VSR(:,:)
!  .. "Intrinsic Functions" ..
      INTERFACE
         LOGICAL FUNCTION SELECT( X, Y, Z )
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT(IN) :: X, Y, Z
         END FUNCTION SELECT
      END INTERFACE
!  .. "Executable Statements" ..
      WRITE(*,*)'LA_GGES Example Program Results'
      N = 5
      ALLOCATE( A(N,N), AA(N,N), B(N,N), BB(N,N), ALPHAR(N), ALPHAI(N), BETA(N), VSL(N,N), VSR(N,N) )

      OPEN(UNIT=21,FILE='gges.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=A

      WRITE(*,*)'Matrix A : '
      DO I=1,N; 
         WRITE(*,"(5(I3,1X))") INT(A(I,:)); 
      ENDDO
    
      OPEN(UNIT=21,FILE='gges.mb',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      BB=B
    
      WRITE(*,*)'Matrix B : '
      DO I=1,N; 
         WRITE(*,"(5(I3,1X))") INT(B(I,:)); 
      ENDDO
    
      WRITE(*,*)
      WRITE(*,*) 'CALL LA_GGES( A, B, ALPHAR, ALPHAI, BETA )'
      CALL LA_GGES( A, B, ALPHAR, ALPHAI, BETA )
   
      WRITE(*,*)
      WRITE(*,*)'Matrix A on exit : '
      DO I=1,N; 
         WRITE(*,"(5(F9.5,1X))") A(I,:); 
      ENDDO
      
      WRITE(*,*)
      WRITE(*,*)'Matrix B on exit : '
      DO I=1,N; 
         WRITE(*,"(5(F9.5,1X))") B(I,:); 
      ENDDO
      
      WRITE(*,*)
      WRITE(*,*) 'ALPHAR on exit : '
      DO I=1,N
         WRITE(*,"(F9.5,1X)") ALPHAR(I); 
      ENDDO
      WRITE(*,*)'ALPHAI on exit : '
      DO I=1,N
         WRITE(*,"(F9.5,1X)") ALPHAI(I); 
      ENDDO
      WRITE(*,*)'BETA on exit : '
      DO I=1,N
         WRITE(*,"(F9.5,1X)") BETA(I); 
      ENDDO
      WRITE(*,*)
      WRITE(*,*)' Generalazed eigenvalues : '
      DO I=1,N
         WRITE(*,*) '(',ALPHAR(I)/BETA(I),',',ALPHAI(I)/BETA(I),')'
      ENDDO

      WRITE(*,*)
      WRITE(*,*)' * EXAMPLE 2 * '
      WRITE(*,*)
      WRITE(*,*) 'CALL LA_GGES( A, B, ALPHAR, ALPHAI, BETA, VSL, ', &
                               'VSR, SELECT, SDIM, INFO )'
      CALL LA_GGES( AA, BB, ALPHAR, ALPHAI, BETA, VSL, VSR, SELECT, &
                    SDIM, INFO )
   
      WRITE(*,*)
      WRITE(*,*)'Matrix A on exit : '
      DO I=1,N; 
         WRITE(*,"(5(F9.6,1X))") AA(I,:); 
      ENDDO
      
      WRITE(*,*)
      WRITE(*,*)'Matrix B on exit : '
      DO I=1,N; 
         WRITE(*,"(5(F9.6,1X))") BB(I,:); 
      ENDDO
      
      WRITE(*,*)
      WRITE(*,*) 'ALPHAR on exit : '
      WRITE(*,"(8(F9.6,1X))") ALPHAR(:); 
      WRITE(*,*)'ALPHAI on exit : '
      WRITE(*,"(8(F9.6,1X))") ALPHAI(:); 
      WRITE(*,*)'BETA on exit : '
      WRITE(*,"(8(F9.6,1X))") BETA(:); 
      WRITE(*,*)
      WRITE(*,*)' Generalazed eigenvalues : '
      DO I=1,N
         WRITE(*,*) '(',ALPHAR(I)/BETA(I),',',ALPHAI(I)/BETA(I),')'
      ENDDO

      WRITE(*,*)
      WRITE(*,*) 'VSL on exit : '
      DO I=1,N; 
         WRITE(*,"(5(F12.8,1X))") VSL(I,:); 
      ENDDO
   
      WRITE(*,*)
      WRITE(*,*) 'VSR on exit : '
      DO I=1,N; 
         WRITE(*,"(5(F12.8,1X))") VSR(I,:); 
      ENDDO
   
      WRITE(*,*)
      WRITE(*,*)'SDIM = ', SDIM

      WRITE(*,*)'INFO = ', INFO
      
      END PROGRAM LA_SGGES_EXAMPLE

! CONTAINS
    LOGICAL FUNCTION SELECT( ALPHAR, ALPHAI, BETA )
      USE LA_PRECISION, ONLY: WP => SP
      REAL(WP), INTENT(IN) :: ALPHAR, ALPHAI, BETA
      INTRINSIC EPSILON, ABS
!
      IF ( ABS(BETA) > EPSILON(1.0_WP) ) THEN
         IF ( ABS(ALPHAI/BETA) < 3.0_WP) THEN
            SELECT = .TRUE.
         ELSE
            SELECT = .FALSE.
         ENDIF
      ELSE
         SELECT = .FALSE.
      ENDIF

    END FUNCTION SELECT

SUBROUTINE LA_TEST_SGELSX( M, N, NRHS, A, LDA, B, LDB, JPVT, RCOND, RANK, WORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     April 19, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => SP
   USE F95_LAPACK, ONLY: LA_GELSX
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: M, N, NRHS, LDA, LDB
   INTEGER, INTENT(INOUT) :: INFO
   INTEGER, INTENT(IN) :: RANK
   REAL(WP), INTENT(IN) :: RCOND
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB,1:NRHS)
   REAL(WP), INTENT(OUT) :: WORK(1: MAX(MIN(M,N)+3*N*N +4*M*M, &
&    4*MIN(M,N)+NRHS*NRHS+4*M*M))
   INTEGER, INTENT(INOUT) :: JPVT(1:N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GELSX'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_SGELSX'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IA1, IA2, IB1, IB2, IJPVT
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IA1 = M; IA2 = N; IB1 = MAX(1,M,N); IB2 = NRHS; IJPVT = N
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
   CASE(0)
      IF (NRHS==1) THEN
        CALL LA_GELSX( A(1:IA1,1:IA2), B(1:IB1,1), RANK,  &
     &    JPVT=JPVT(1:IJPVT), RCOND=RCOND, INFO=INFO )
        INFO = INFOTC
      ELSE
        CALL LA_GELSX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), RANK, & 
     &    JPVT=JPVT(1:IJPVT),  RCOND=RCOND, INFO=INFO )
        INFO = INFOTC
      ENDIF 
   CASE (2)
      IB1 = MAX(1, N, M) -1
   CASE(4)
      IJPVT = IA2 - 1
   CASE(:-1,1,3, 5:)
      CALL UESTOP(SRNAMT)
   END SELECT
      IF( I /= 0) THEN
      SELECT CASE (NRHS)
      CASE (2:)
         CALL LA_GELSX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), RANK,&
     &         JPVT=JPVT(1:IJPVT), RCOND=RCOND, INFO=INFO )
      CASE(1)
         CALL LA_GELSX( A(1:IA1,1:IA2), B(1:IB1,1), RANK, &
     &         JPVT=JPVT(1 :IJPVT), RCOND=RCOND, INFO=INFO)
      CASE(:-1)
         CALL UESTOP(SRNAMT)
      END SELECT
   END IF
   CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_SGELSX

SUBROUTINE LA_TEST_DPPSVX( FACT, UPLO, N, NRHS, AP, AFP, EQUED, S, B, &
&   LDB, X, LDX, RCOND, FERR, BERR, WORK, IWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     April 5, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_PPSVX
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, NRHS, LDB, LDX
   INTEGER, INTENT(INOUT) :: INFO
   CHARACTER*1, INTENT(IN) :: FACT, UPLO
   CHARACTER(LEN=1), INTENT(INOUT) :: EQUED
   REAL(WP), INTENT(OUT) :: RCOND
!  .. Array Arguments ..
   REAL(WP), INTENT(INOUT) :: AP(N*(N+1)/2), B(1:LDB,1:NRHS), &
&    AFP(1: N*(N+1)/2), S(1:N)
   INTEGER, INTENT(OUT) :: IWORK(1:N)
   REAL(WP), INTENT(OUT) :: FERR(1:NRHS), BERR(1:NRHS)
   REAL(WP), INTENT(OUT) :: X(1:LDX,1:NRHS), WORK(1:3*N)
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_PPSVX'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DPPSVX'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
   INTEGER :: I, J, IAP1,  IB1, IB2, IX1, IX2, IAFP, IS, &
&    IFERR, IBERR
   CHARACTER*1 :: IUPLO, IFACT, IEQUED
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
   IAP1 = (N*(N+1))/2; IB1 = N; IB2 = NRHS; IUPLO= UPLO
   IX1=N; IX2=NRHS; IAFP = (N*(N+1))/2; IFACT=FACT; IS = N
   IBERR = NRHS; IFERR = NRHS
   I = INFO / 100; J = INFO - I*100

   SELECT CASE(I)
   CASE(0)
      IF (NRHS == 1) THEN
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
&         IUPLO, AFP(1:IAFP), IFACT, &
&         EQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO )
        INFO = INFOTC
      ELSE
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
&         IUPLO, AFP(1:IAFP), IFACT, &
&         EQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO )
        INFO = INFOTC
      END IF
   CASE (1)
      IAP1 = IAP1-1
   CASE (2)
     IB1 = IAP1-1
   CASE(3)
     IFACT = 'F'
     IX1 = IB1-1
     IF (NRHS == 1) THEN
       CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
&        IUPLO, AFP(1:IAFP), IFACT, &
&        EQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO )
     ELSE
       CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
&        IUPLO, AFP(1:IAFP), IFACT, &
&        EQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO )
     ENDIF
     CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
     RETURN
   CASE(4)
     IUPLO='T'
   CASE (5)
     IAFP = IAP1 - 1
   CASE(6)
     IFACT = 'T'
   CASE (7)
     IFACT = 'F'
     IEQUED = 'T'
     IF (NRHS == 1) THEN
       CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
     &   IUPLO, AFP(1:IAFP), IFACT, &
     &   IEQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO )
     ELSE
       CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &   IUPLO, AFP(1:IAFP), IFACT, &
     &   IEQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO )
     ENDIF                      
     CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
     RETURN
   CASE (8)
     IS = IB1 - 1
      CASE (9)
      IFACT = 'F' ;  S = +1.0_WP 
      IFERR = IB2 - 1
      IF (NRHS == 1) THEN
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO )
      ELSE
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO )
      ENDIF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN         
   CASE (10)
      IBERR = IB2 - 1; S = +1.0_WP; IFACT = 'F'
      IF (NRHS == 1) THEN
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO )
      ELSE
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &    IUPLO, AFP(1:IAFP), IFACT, &
     &    EQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO )
      ENDIF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN                                           
   CASE(:-1,11:)
      CALL UESTOP(SRNAMT)
  END SELECT
  IF( I /= 0 ) THEN
    SELECT CASE (NRHS)
      CASE (2:)
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
&         IUPLO, AFP(1:IAFP), IFACT, &
&         EQUED, S(1: IS), FERR(1:IFERR), BERR(1:IBERR), RCOND, INFO ) 
      CASE(1)
        CALL LA_PPSVX( AP(1:IAP1), B(1:IB1,1), X(1:IX1,1), &
&         IUPLO, AFP(1:IAFP), IFACT, &
&         EQUED, S(1: IS), FERR(1), BERR(1), RCOND, INFO ) 
      CASE(:-1)
        CALL UESTOP(SRNAMT)
    END SELECT
  END IF
  CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_DPPSVX

      PROGRAM LA_SGGESX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GGESX
!  .. "Local Scalars" ..
      INTEGER :: I, J, N
      INTERFACE
         LOGICAL FUNCTION SELECT(X, Y, Z)
           USE LA_PRECISION, ONLY: WP => SP
           REAL(WP), INTENT(IN) :: X, Y, Z 
         END FUNCTION SELECT
      END INTERFACE
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), RCONDE(:), RCONDV(:), VSL(:,:)
      REAL(WP), ALLOCATABLE :: ALPHAR(:), ALPHAI(:), BETA(:), VSR(:,:)  
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GGESX Example Program Results'
      N = 5
      ALLOCATE( A(N,N),  B(N,N), ALPHAR(N), ALPHAI(N), BETA(N), &
                VSL(N,N), VSR(N,N), RCONDE(2), RCONDV(2) )

      OPEN(UNIT=21,FILE='gges.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix A : '
      DO I=1,N; 
         WRITE(*,"(5(I3,1X))") INT(A(I,:)); 
      ENDDO

      OPEN(UNIT=21,FILE='gges.mb',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,N 
            READ(21,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      WRITE(*,*)'Matrix B : '
      DO I=1,N; 
         WRITE(*,"(5(I3,1X))") INT(B(I,:)); 
      ENDDO
   
      WRITE(*,*)
      WRITE(*,*) 'CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, SELECT=SELECT,', &
                               ' RCONDE=RCONDE, RCONDV=RCONDV )'
      CALL LA_GGESX( A, B, ALPHAR, ALPHAI, BETA, SELECT=SELECT, &
                     RCONDE=RCONDE, RCONDV=RCONDV )
      
      WRITE(*,*)
      WRITE(*,*)'RCONDE = ', RCONDE
      WRITE(*,*)'RCONDV = ', RCONDV

      END PROGRAM LA_SGGESX_EXAMPLE
! CONTAINS
    LOGICAL FUNCTION SELECT( ALPHAR, ALPHAI, BETA )
      USE LA_PRECISION, ONLY: WP => SP
      REAL(WP), INTENT(IN) :: ALPHAR, ALPHAI, BETA
      INTRINSIC EPSILON, ABS
!
      IF ( ABS(BETA) > EPSILON(1.0_WP) ) THEN
         IF ( ABS(ALPHAI/BETA) < 3.0_WP) THEN
            SELECT = .TRUE.
         ELSE
            SELECT = .FALSE.
         ENDIF
      ELSE
         SELECT = .FALSE.
      ENDIF

    END FUNCTION SELECT

SUBROUTINE SGBSVX_F95(A, B, X, KL, AFB, IPIV, FACT, TRANS, &
                      EQUED, R, C, FERR, BERR, RCOND, RPVGRW, INFO)
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: LSAME, ERINFO
   USE F77_LAPACK, ONLY: GBSVX_F77 => LA_GBSVX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
   CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
   INTEGER, INTENT(IN), OPTIONAL :: KL
   INTEGER, INTENT(OUT), OPTIONAL :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND, RPVGRW
!  .. ARRAY ARGUMENTS ..
   REAL(WP), INTENT(INOUT) :: A(:,:), B(:,:)
   REAL(WP), INTENT(OUT) :: X(:,:)
   INTEGER, INTENT(INOUT), OPTIONAL, TARGET :: IPIV(:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: AFB(:,:)
   REAL(WP), INTENT(INOUT), OPTIONAL, TARGET :: C(:), R(:)
   REAL(WP), INTENT(OUT), OPTIONAL, TARGET :: FERR(:), BERR(:)
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!    LA_GBSVX computes the solution to a real or complex linear system of
! equations of the form A*X = B, A^T*X = B or A^H*X = B, where A is a 
! square band matrix and X and B are rectangular matrices or vectors.
!    LA_GBSVX can also optionally equilibrate the system if A is poorly 
! scaled, estimate the condition number of (the equilibrated) A, return
! the pivot growth factor, and compute error bounds.
! 
! =========
! 
!       SUBROUTINE LA_GBSVX( AB, B, X, KL=kl, AFB=afb, IPIV=ipiv, &
!                  FACT=fact, TRANS=trans, EQUED=equed, R=r, C=c, &
!                  FERR=ferr, BERR=berr, RCOND=rcond, &
!                  RPVGRW=rpvgrw, INFO=info )
!          <type>(<wp>), INTENT(INOUT) :: AB(:,:), <rhs>
!          <type>(<wp>), INTENT(OUT) :: <sol>
!          INTEGER, INTENT(IN), OPTIONAL :: KL
!          <type>(<wp>), INTENT(INOUT), OPTIONAL :: AFB(:,:)
!          INTEGER, INTENT(INOUT), OPTIONAL :: IPIV(:)
!          CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS, FACT
!          CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: EQUED
!          REAL(<wp>), INTENT(INOUT), OPTIONAL :: C(:), R(:)
!          REAL(<wp>), INTENT(OUT), OPTIONAL :: <err>, RCOND, RPVGRW
!          INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!          <type> ::= REAL | COMPLEX
!          <wp>   ::= KIND(1.0) | KIND(1.0D0)
!          <rhs>  ::= B(:,:) | B(:)
!          <sol>  ::= X(:,:) | X(:)
!          <err>  ::= FERR(:), BERR(:) | FERR, BERR
! 
! Arguments
! =========
! 
! AB        (input/output) REAL or COMPLEX rectangular array, shape (:,:)
!           with size(AB,1) = kl + ku + 1 and size(AB,2) = n, where kl 
!           and ku are, respectively, the numbers of subdiagonals and 
!           superdiagonals in the band of A, and n is the order of A.
!           On entry, the matrix A or its equilibration in band storage.
!           The (kl + ku + 1) diagonals of A are stored in rows 1 to 
!           (kl + ku + 1) of AB, so that the j-th column of A is 
!           stored in the j-th column of AB as follows:
!           AB(ku+1+i-j,j) = A(i,j) for max(1,j-ku)<=i<=min(n,j+kl)
! 	                              1<=j<=n. 
!           The remaining elements in AB need not be set.
!           If FACT = 'F' and EQUED /= 'N' then A has been equilibrated
!           by the scaling factors in R and/or C during the previous call
!           to LA GBSVX.
!           On exit, if FACT = 'E', the equilibrated version of A is
!           stored in AB; otherwise, AB is unchanged.
! B         (input/output) REAL or COMPLEX array, shape (:,:) with 
!           size(B,1) = n or shape (:) with size(B) = n.
!           On entry, the matrix B.
!           On exit, the scaled version of B if the system has been 
!           equilibrated; otherwise, B is unchanged.
! X         (output) REAL or COMPLEX array, shape (:,:) with size(X,1)=n
!           and size(X,2) = size(B,2), or shape (:) with size(X) = n.
!           The solution matrix X .
! KL        Optional (input) INTEGER.
!           The number of subdiagonals in the band of A (KL = kl).
!           The number of superdiagonals in the band is given by
! 	    ku =  size(AB,1) - kl - 1.
!           Default value: (size(AB,1) - 1) / 2.
! AFB       Optional (input or output) REAL or COMPLEX rectangular array,
!           shape (:,:) with size(AFB,1) = 2*kl+ku+1 and size(AFB,2)=n
!           If FACT = 'F' then AFB is an input argument that contains the
!           details of the factorization of (the equilibrated) A returned 
!           by a previous call to LA_GBSVX.
!           If FACT /= 'F' then AFB is an output argument that contains 
!           the details of the factorization of (the equilibrated) A. U is
! 	    an upper triangular band matrix with (kl + ku + 1) diagonals.
!           These are stored in the first (kl + ku + 1) rows of AFB. The
!           multipliers that arise during the factorization are stored in
!           the remaining rows.
! IPIV      Optional (input or output) INTEGER array, shape (:) with 
!           size(IPIV) = n.
!           If FACT = 'F' then IPIV is an input argument that contains 
!           the pivot indices from the factorization of (the equilibrated)
!           A, returned by a previous call to LA_GBSVX.
!           If FACT /= 'F' then IPIV is an output argument that contains 
!           the pivot indices from the factorization of (the equilibrated)
! 	    A.
! FACT      Optional (input) CHARACTER(LEN=1).
!           Specifies whether the factored form of the matrix A is 
!           supplied on entry, and, if not, whether the matrix A should 
!           be equilibrated before it is factored.
!             = 'N': The matrix A will be copied to AFB and factored (no 
! 	           equilibration).
!             = 'E': The matrix A will be equilibrated, then copied to 
! 	           AFB and factored.
!             = 'F': AFB and IPIV contain the factored form of (the 
! 	           equilibrated) A.
!           Default value: 'N'.
! TRANS     Optional (input) CHARACTER(LEN=1).
!           Specifies the form of the system of equations:
!             = 'N': A*X = B (No transpose)
!             = 'T': A^T*X = B (Transpose)
!             = 'C': A^H*X = B (Conjugate transpose)
!           Default value: 'N'.
! EQUED     Optional (input or output) CHARACTER(LEN=1).
!           Specifies the form of equilibration that was done.
!           EQUED is an input argument if FACT = 'F', otherwise it is an
!           output argument:
!             = 'N': No equilibration (always true if FACT = 'N').
!             = 'R': Row equilibration, i.e., A has been premultiplied 
! 	           by diag(R).
!             = 'C': Column equilibration, i.e., A has been postmultiplied
! 	           by diag(C).
!             = 'B': Both row and column equilibration.
!           Default value: 'N'.
! R         Optional (input or output) REAL array, shape (:) with 
!           size(R) = size(A,1).
!           The row scale factors for A.
!           R is an input argument if FACT = 'F' and EQUED = 'R' or 'B'.
!           R is an output argument if FACT = 'E' and EQUED = 'R' or 'B'.
! C         Optional (input or output) REAL array, shape (:) with 
!           size(C) = size(A,1).
!           The column scale factors for A.
!           C is an input argument if FACT = 'F' and EQUED = 'C' or 'B'.
!           C is an output argument if FACT = 'E' and EQUED = 'C' or 'B'.
! FERR      Optional (output) REAL array of shape (:), with size(FERR) =
!           size(X,2), or REAL scalar.
!           The estimated forward error bound for each solution vector 
!           X(j) (the j-th column of the solution matrix X). If XTRUE is
!           the true solution corresponding to X(j), FERR(j) is an
!           estimated upper bound for the magnitude of the largest element
!           in (X(j)-XTRUE) divided by the magnitude of the largest 
! 	    element in X(j). The estimate is as reliable as the estimate
!           for RCOND and is almost always a slight overestimate of the 
!           true error.
! BERR      Optional (output) REAL array of shape (:), with size(BERR) =
!           size(X,2), or REAL scalar.
!           The componentwise relative backward error of each solution 
!   	    vector X(j) (i.e., the smallest relative change in any element
!           of A or B that makes X(j) an exact solution).
! RCOND     Optional (output) REAL.
!           The estimate of the reciprocal condition number of (the 
!           equilibrated) A. If RCOND is less than the machine precision,
! 	    the matrix is singular to working precision. This condition is
!           indicated by a return code of INFO > 0.
! RPVGRW    Optional (output) REAL.
!           The reciprocal pivot growth factor ||A||inf = ||U||inf. If 
! 	    RPVGRW is much less than 1, then the stability of the LU
! 	    factorization of the (equilibrated) matrix A could be poor. 
!           This also means that the solution X , condition estimator 
!           RCOND, and forward error bound FERR could be unreliable. If
! 	    the factorization fails with 0 < INFO <= size(A,1), then
!           RPVGRW contains the reciprocal pivot growth factor for the
!           leading INFO columns of A.
! INFO      Optional (output) INTEGER
!           = 0: successful exit.
!           < 0: if INFO = -i, the i-th argument had an illegal value.
!           > 0: if INFO = i, and i is
!             <= n: U(i,i) = 0. The factorization has been completed, 
! 	          but the factor U is singular, so the solution could
! 		  not be computed.
!             = n+1: U is nonsingular, but RCOND is less than machine 
! 	          precision, so the matrix is singular to working 
! 		  precision. Nevertheless, the solution and error 
! 		  bounds are computed because the computed solution can
! 		  be more accurate than the value of RCOND would suggest.
!           If INFO is not present and an error occurs, then the program 
! 	    is terminated with an error message.
!----------------------------------------------------------------------
!  .. PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GBSVX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LFACT, LTRANS, LEQUED
   INTEGER :: LINFO, NRHS, N, ISTAT, ISTAT1, SIPIV, S1AFB, S2AFB, &
              SC, SR, SFERR, SBERR, LD, LKL, LKU, LDA
   REAL(WP) :: LRCOND, MVR, MVC
!  .. LOCAL POINTERS ..
   INTEGER, POINTER :: IWORK(:), LPIV(:)
   REAL(WP),  POINTER :: LC(:), LR(:), LFERR(:), LBERR(:)
   REAL(WP),  POINTER :: WORK(:), LAFB(:, :)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE, MINVAL, TINY
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0
   LDA = SIZE(A,1); N = SIZE(A, 2); NRHS = SIZE(B, 2); LD = MAX(1,N)
   IF( PRESENT(KL) ) THEN; LKL = KL; ELSE; LKL = (LDA-1)/2; ENDIF
   LKU = LDA -LKL -1
   IF( PRESENT(RCOND) ) RCOND = 1.0_WP
   IF( PRESENT(RPVGRW) ) RPVGRW = 1.0_WP
   IF( PRESENT(FACT) )THEN; LFACT = FACT; ELSE; LFACT='N'; END IF
   IF( PRESENT(EQUED) .AND. LSAME(LFACT,'F') )THEN; LEQUED = EQUED
   ELSE; LEQUED='N'; END IF
   IF( PRESENT(IPIV) )THEN; SIPIV = SIZE(IPIV); ELSE; SIPIV = N; END IF
   IF( PRESENT(AFB) )THEN; S1AFB = SIZE(AFB,1); S2AFB = SIZE(AFB,2)
   ELSE; S1AFB = 2*LKL+LKU+1; S2AFB = N; END IF
   IF( ( PRESENT(C) ) )THEN; SC = SIZE(C); ELSE; SC = N; END IF
   IF( ( PRESENT(C) .AND. LSAME(LFACT,'F') ) .AND. &
       ( LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') ) )THEN; MVC = MINVAL(C)
   ELSE; MVC = TINY(1.0_WP); END IF
   IF( PRESENT(R) )THEN; SR = SIZE(R); ELSE; SR = N; END IF
   IF( ( PRESENT(R) .AND. LSAME(LFACT,'F') ) .AND. &
       ( LSAME(LEQUED,'R') .OR. LSAME(LEQUED,'B') ) )THEN; MVR = MINVAL(R)
   ELSE; MVR = TINY(1.0_WP); END IF
   IF( PRESENT(FERR) )THEN; SFERR = SIZE(FERR); ELSE; SFERR = NRHS; END IF
   IF( PRESENT(BERR) )THEN; SBERR = SIZE(BERR); ELSE; SBERR = NRHS; END IF
   IF(PRESENT(TRANS))THEN; LTRANS = TRANS; ELSE; LTRANS='N'; END IF
!  .. TEST THE ARGUMENTS
   IF( LDA < 0 .OR. N < 0 ) THEN; LINFO = -1
   ELSE IF( SIZE(B, 1) /= N .OR. NRHS < 0 )THEN; LINFO = -2
   ELSE IF( SIZE(X, 1) /= N .OR. SIZE(X, 2) /= NRHS )THEN; LINFO = -3
   ELSE IF( LKL < 0 .OR. LKU < 0 ) THEN; LINFO = -4
   ELSE IF( S1AFB /= 2*LKL+LKU+1 .OR. S2AFB /= N ) THEN; LINFO = -5
   ELSE IF( SIPIV /= N )THEN; LINFO = -6
   ELSE IF( SR /= N .OR. MVR <= 0.0_WP )THEN; LINFO = -10
   ELSE IF( SC /= N .OR. MVC <= 0.0_WP )THEN; LINFO = -11
   ELSE IF( SFERR /= NRHS )THEN; LINFO = -12
   ELSE IF( SBERR /= NRHS )THEN; LINFO = -13
   ELSE IF( ( .NOT. ( LSAME(LFACT,'F') .OR. LSAME(LFACT,'N') .OR. &
                    LSAME(LFACT,'E') ) ) .OR. &
       ( LSAME(LFACT,'F') .AND. .NOT.( PRESENT(AFB) .AND. PRESENT(IPIV) ) ) )THEN
      LINFO = -7
   ELSE IF( .NOT.( LSAME(LTRANS,'N') .OR.  LSAME(LTRANS,'T') .OR. &
                  LSAME(LTRANS,'C') ) )THEN; LINFO = -8
   ELSE IF( ( .NOT.( LSAME(LEQUED,'N') .OR. LSAME(LEQUED,'R') .OR. &
          LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') ) &
              .AND. LSAME(LFACT,'F') ) .OR. &
         ( ( LSAME(LEQUED,'R') .OR. LSAME(LEQUED,'B') ) .AND. &
              .NOT.PRESENT(R) ) .OR. &
         ( ( LSAME(LEQUED,'C') .OR. LSAME(LEQUED,'B') ) .AND. &
              .NOT.PRESENT(C) ) )THEN; LINFO = -9
   ELSE IF ( N > 0 )THEN
      IF( .NOT.PRESENT(AFB) ) THEN; ALLOCATE( LAFB(S1AFB,N), STAT=ISTAT )
      ELSE; LAFB => AFB; END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(IPIV) )THEN; ALLOCATE( LPIV(N), STAT=ISTAT )
         ELSE; LPIV => IPIV; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(R) )THEN; ALLOCATE( LR(N), STAT=ISTAT )
         ELSE; LR => R; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(C) )THEN; ALLOCATE( LC(N), STAT=ISTAT )
         ELSE; LC => C; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(FERR) )THEN; ALLOCATE( LFERR(NRHS), STAT=ISTAT )
         ELSE; LFERR => FERR; END IF
      END IF
      IF( ISTAT == 0 )THEN
         IF( .NOT.PRESENT(BERR) )THEN; ALLOCATE( LBERR(NRHS), STAT=ISTAT )
         ELSE; LBERR => BERR; END IF
      END IF
      IF( ISTAT == 0 ) ALLOCATE(WORK(3*N), IWORK(N), STAT=ISTAT )
      IF( ISTAT == 0 )THEN
         CALL GBSVX_F77( LFACT, LTRANS, N, LKL, LKU, NRHS, A, LDA, LAFB, S1AFB, &
                         LPIV, LEQUED, LR, LC, B, LD, X, LD, LRCOND, &
                         LFERR, LBERR, WORK, IWORK, LINFO )
      ELSE; LINFO = -100; END IF
      IF( .NOT.PRESENT(R) ) DEALLOCATE( LR, STAT=ISTAT1 )
      IF( .NOT.PRESENT(C) ) DEALLOCATE( LC, STAT=ISTAT1 )
      IF( .NOT.PRESENT(AFB) ) DEALLOCATE( LAFB, STAT=ISTAT1 )
      IF( .NOT.PRESENT(IPIV) ) DEALLOCATE( LPIV, STAT=ISTAT1 )
      IF( .NOT.PRESENT(FERR) ) DEALLOCATE( LFERR, STAT=ISTAT1 )
      IF( .NOT.PRESENT(BERR) ) DEALLOCATE( LBERR, STAT=ISTAT1 )
      IF( PRESENT(RCOND) ) RCOND=LRCOND
      IF( PRESENT(EQUED) .AND. .NOT.LSAME(LFACT,'F') ) EQUED=LEQUED
      IF( PRESENT(RPVGRW) ) RPVGRW=WORK(1)
      DEALLOCATE( WORK, IWORK, STAT=ISTAT1 )
   END IF
   CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
END SUBROUTINE SGBSVX_F95

SUBROUTINE LA_TEST_DGTSVX( FACT, TRANS, N, NRHS, DL, D, DU, DLF, DF,&
     &  DUF, DU2, IPIV, B, LDB, X, LDX, RCOND, FERR, BERR, WORK, &
     &  IWORK,INFO)
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     March 28, 1999
!
!  .. Use Statements ..
   USE LA_PRECISION, ONLY: WP => DP
   USE F95_LAPACK, ONLY: LA_GTSVX
!  .. Implicit Statement ..
   IMPLICIT NONE
!  .. Scalar Arguments ..
   INTEGER, INTENT(IN) :: N, NRHS, LDB, LDX
   INTEGER, INTENT(INOUT) :: INFO
      CHARACTER(LEN=1), INTENT(IN) :: FACT, TRANS
      REAL(WP), INTENT(OUT) :: RCOND
!  .. Array Arguments ..
      INTEGER, INTENT(INOUT) :: IPIV(1:N)
      INTEGER, INTENT(OUT) :: IWORK(1:N)  
      REAL(WP), INTENT(IN) :: B(1:LDB,1:NRHS)
      REAL(WP), INTENT(IN) :: DL(1:N-1), D(1:N), DU(1:N-1)
      REAL(WP), INTENT(INOUT) :: DF(1:N), DLF(1:N-1), DU2(1:N-2), &
     &  DUF(1:N-1)
      REAL(WP), INTENT(OUT) :: FERR(1:NRHS), BERR(1:NRHS), &
     &  X(1:LDX,1:NRHS), WORK(1:3*N)  
!  .. Parameters ..
   CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_GTSVX'
   CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_DGTSVX'
!  .. Common blocks ..
   INTEGER :: INFOTC
   COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IDU, ID, IDL,IB1, IB2, IX1, IX2, IDLF,&
     &  IDF, IDUF, IDU2, IIPIV, IFERR, IBERR
      CHARACTER(LEN=1) :: IFACT, ITRANS
!  .. Local Arrays ..
   LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
!  .. Executable Statements ..
      IDL = N-1; ID = N; IDU = N-1; IB1 = N; IB2 = NRHS
      IX1=N; IX2=NRHS;IDLF=N-1;IDF=N; IDUF=N-1; IDU2= N-2
      IIPIV = N; IFACT = FACT; ITRANS=TRANS; IFERR=NRHS
      IBERR = NRHS
   I = INFO / 100; J = INFO - I*100
   SELECT CASE(I)
    CASE(0)
      IF ( NRHS == 1 ) THEN
        CALL LA_GTSVX( DL(1:IDL), D(1:ID), DU(1:IDU), B(1:IB1, 1), &
     &    X(1:IX1, 1), DLF(1:IDLF), DF(1:IDF), DUF(1:IDUF), &
     &    DU2(1: IDU2), IPIV(1:IIPIV), IFACT, ITRANS, FERR(1), &
     &    BERR(1), RCOND, INFO )
        INFO = INFOTC
      ELSE
        CALL LA_GTSVX( DL(1:IDL), D(1:ID), DU(1:IDU), B(1:IB1, 1:IB2), &
     &    X(1:IX1, 1:IX2), DLF(1:IDLF), DF(1:IDF), DUF(1:IDUF), &
     &    DU2(1: IDU2), IPIV(1:IIPIV), IFACT, ITRANS, FERR(1:IFERR), &
     &    BERR(1: IBERR), RCOND, INFO )
        INFO = INFOTC
      END IF
      CASE (1)
      IDL = ID
      CASE(3)
      IDU = ID 
      CASE(4)
      IB1 = ID - 1
      CASE (5)
      IX1 = ID - 1
      CASE (6)
      IDLF = IDL - 1
      CASE (7)
      IDF = ID - 1
      CASE (8)
      IDUF = IDL - 1
      CASE (9)
      IDU2 = IDL - 3
      CASE (10)
      IIPIV = ID - 1
      CASE (11)
      IFACT = 'T'
      CASE (12)
      ITRANS = 'E'
      CASE (13)
      IFERR = IB2 - 1
      CASE (14)
      IBERR = IB2 - 1
      CASE(:-1,2,15:)
      CALL UESTOP(SRNAMT)
   END SELECT
      IF( I /= 0 ) THEN
      SELECT CASE (NRHS)
      CASE (2:)
      CALL LA_GTSVX( DL(1:IDL), D(1:ID), DU(1:IDU), B(1:IB1, 1:IB2), &
     &  X(1:IX1, 1:IX2), DLF(1:IDLF), DF(1:IDF), DUF(1:IDUF), &
     &  DU2(1: IDU2), IPIV(1:IIPIV), IFACT, ITRANS, FERR(1:IFERR), &
     &  BERR(1: IBERR), RCOND, INFO )
      CASE(1)
      CALL LA_GTSVX( DL(1:IDL), D(1:ID), DU(1:IDU), B(1:IB1, 1), &
     &  X(1:IX1, 1), DLF(1:IDLF), DF(1:IDF), DUF(1:IDUF), &
     &  DU2(1: IDU2), IPIV(1:IIPIV), IFACT, ITRANS, FERR(1), &
     &  BERR(1), RCOND, INFO ) 
      CASE(:-1)
      CALL UESTOP(SRNAMT)
      END SELECT
      END IF
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_DGTSVX
      

SUBROUTINE ZPOTRF_F95( A, UPLO, RCOND, NORM, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => DP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: POTRF_F77 => LA_POTRF, LANSY_F77 => LA_LANSY, &
                                  POCON_F77 => LA_POCON
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. CHARACTER ARGUMENTS ..
   CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM, UPLO
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL  :: INFO
   REAL(WP), INTENT(OUT), OPTIONAL :: RCOND
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(INOUT) :: A(:,:)
!-----------------------------------------------------------------
!
! Purpose
! =======
!
! LA_POTRF computes the Cholesky factorization of a real symmetric or
! complex Hermitian positive definite matrix A.
!
! The factorization has the form
!    A = U**H * U,  if UPLO = 'U', or
!    A = L * L**H,  if UPLO = 'L',
! where U is an upper triangular matrix and L is lower triangular.
!
! This is the block version of the algorithm, calling Level 3 BLAS.
!
! LA_POTRF optionally estimates the reciprocal of the condition number
! (in the 1-norm) of a real symmetric or complex Hermitian positive 
! definite matrix A.
! An estimate is obtained for norm(inv(A)), and the reciprocal of the
! condition number is computed as RCOND = 1 / (norm(A) * norm(inv(A))).
!
! =======
!
!    SUBROUTINE LA_POTRF( A, UPLO, RCOND, NORM, INFO )
!       <type>(<wp>), INTENT(INOUT) :: A(:,:)
!       CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
!       REAL(<wp>), INTENT(OUT), OPTIONAL :: RCOND
!       CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: NORM
!       INTEGER, INTENT(OUT), OPTIONAL :: INFO
!    where
!       <type> ::= REAL | COMPLEX
!       <wp>   ::= KIND(1.0) | KIND(1.0D0)
!
! Defaults
! ========
!
! 1. If UPLO is not present then UPLO = 'U' is assumed.
!
! Arguments
! =========
!
! A       (input/output) either REAL or COMPLEX square array, 
!         shape (:,:), size(A,1) == size(A,2) >= 0.
!         On entry, the symmetric (Hermitian) matrix A.  
!            If UPLO = 'U', the upper triangular part of A contains
!               the upper triangular part of the matrix A, and the 
!               strictly lower triangular part of A is not referenced.
!            If UPLO = 'L', the lower triangular part of A contains
!               the lower triangular part of the matrix A, and the
!               strictly upper triangular part of A is not referenced.
!         On exit, if INFO = 0, the factor U or L from the Cholesky
!            factorization A = U**H*U or A = L*L**H.
!
! UPLO    Optional, (input) CHARACTER*1
!         If UPLO is present then:
!            = 'U':  Upper triangle of A is stored;
!            = 'L':  Lower triangle of A is stored.
!         otherwise UPLO = 'U' is assumed.
!
! RCOND   Optional (output) REAL
!         The reciprocal of the condition number of the matrix A 
!         computed as RCOND = 1/(norm(A) * norm(inv(A))).
! NORM    Optional (input) CHARACTER*1
!         Specifies whether the 1-norm condition number or the
!         infinity-norm condition number is required:
!           If NORM is present then:
!              = '1', 'O' or 'o': 1-norm;
!              = 'I' or 'i': infinity-norm.
!           otherwise NORM = '1' is used.
!
! INFO    Optional, (output) INTEGER
!         If INFO is present:
!            = 0: successful exit
!            < 0: if INFO = -i, the i-th argument had an illegal value
!            > 0: if INFO = i, the leading minor of order i is not
!               positive definite, and the factorization could not be
!               completed.
!         If INFO is not present and an error occurs, then the program
!            is terminated with an error message.
!
! --------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_POTRF'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LNORM, LUPLO
   INTEGER :: LINFO, N, ISTAT, ISTAT1, LD
   REAL(WP) :: ANORM
!  .. LOCAL POINTERS ..
   REAL(WP), POINTER :: RWORK(:)
   COMPLEX(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC PRESENT, MAX
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; N = SIZE(A,1); LD = MAX(1,N); ISTAT = 0
   IF( PRESENT(UPLO) ) THEN; LUPLO = UPLO; ELSE; LUPLO = 'U'; END IF
   IF( PRESENT(NORM) ) THEN; LNORM = NORM; ELSE; LNORM = '1'; END IF
!  .. TEST THE ARGUMENTS
   IF( SIZE( A, 2 ) /= N .AND. N < 0 )THEN; LINFO = -1
   ELSE IF( .NOT.LSAME(LUPLO,'U') .AND. .NOT.LSAME(LUPLO,'L') )THEN; LINFO = -2
   ELSE IF( ( .NOT.PRESENT(RCOND) .AND. PRESENT(NORM) ) .OR. &
            ( .NOT.LSAME(LNORM,'I') .AND. .NOT.LSAME(LNORM,'O') &
              .AND. LNORM /= '1' ) ) THEN; LINFO = -4
   ELSE IF(  N > 0 )THEN
      IF( PRESENT(RCOND) ) THEN
!     .. COMPUTE THE NORM OF THE MATRIX A
         ALLOCATE(RWORK(N), STAT=ISTAT)
         IF( ISTAT == 0 )THEN; ANORM = LANSY_F77( LNORM, LUPLO, LD, A, N, RWORK )
         ELSE; LINFO = -100; END IF
         DEALLOCATE(RWORK, STAT=ISTAT1)
      END IF
!
      IF( LINFO == 0 ) THEN
!     .. COMPUTE THE CHOLESKY FACTORS OF THE MATRIX A
         CALL POTRF_F77( LUPLO, N, A, LD, LINFO )
!
         IF( PRESENT(RCOND) .AND. LINFO == 0 ) THEN
!        .. COMPUTE THE RECIPROCAL OF THE CONDITION NUMBER OF A
            IF( ANORM == 0.0_WP )THEN; RCOND = 0.0_WP
            ELSE; ALLOCATE(WORK(2*N), RWORK(N), STAT=ISTAT)
               IF( ISTAT == 0 )THEN
                  CALL POCON_F77( LUPLO, N, A, LD, ANORM, RCOND, &
                                  WORK, RWORK, LINFO )
               ELSE; LINFO = -100; END IF
               DEALLOCATE(WORK, RWORK, STAT=ISTAT1)
            END IF
         END IF
      END IF
   ELSE IF( PRESENT(RCOND) ) THEN; RCOND = 1.0_WP; ENDIF
   CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE ZPOTRF_F95

SUBROUTINE CGEESX_F95( A, W, VS, SELECT, SDIM, RCONDE, RCONDV, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!  .. USE STATEMENTS ..
   USE LA_PRECISION, ONLY: WP => SP
   USE LA_AUXMOD, ONLY: ERINFO, LSAME
   USE F77_LAPACK, ONLY: GEESX_F77 => LA_GEESX
!  .. IMPLICIT STATEMENT ..
   IMPLICIT NONE
!  .. SCALAR ARGUMENTS ..
   INTEGER, INTENT(OUT), OPTIONAL :: INFO, SDIM
   REAL(WP), INTENT(OUT), OPTIONAL :: RCONDE, RCONDV
!  .. ARRAY ARGUMENTS ..
   COMPLEX(WP), INTENT(INOUT) :: A(:,:)
   COMPLEX(WP), INTENT(OUT) :: W(:)
   COMPLEX(WP), INTENT(OUT), OPTIONAL, TARGET :: VS(:,:)
!  .. EXTERNAL ARGUMENTS ..
      INTERFACE
         FUNCTION SELECT(W)
            USE LA_PRECISION, ONLY: WP => SP
            COMPLEX(WP), INTENT(IN) :: W
            LOGICAL :: SELECT
         END FUNCTION SELECT
      END INTERFACE
   OPTIONAL :: SELECT
!----------------------------------------------------------------------
! 
! Purpose
! =======
! 
!     LA_GEESX computes for a real/complex square matrix A, the 
! eigenvalues, the real-Schur/complex-Schur form T , and, optionally, the
! matrix of Schur vectors Z, where Z is orthogonal/unitary. This gives the
! factorization
!                     A = Z*T*Z^H.
! Optionally, it also orders the eigenvalues on the diagonal of the Schur 
! form so that selected eigenvalues are at the top left, computes a 
! reciprocal condition number for the average of the selected eigenvalues
! and computes a reciprocal condition number for the right invariant 
! subspace corresponding to the selected eigenvalues. The leading columns
! of Z form an orthonormal basis for this invariant subspace.
! A real matrix is in real-Schur form if it is block upper triangular
! with 1 by 1 and 2 by 2 blocks along the main diagonal. 2 by 2 blocks 
! are standardized in the form
!                        [ a  b ]
! 	                 [ c  a ]
! where b*c < 0. The eigenvalues of such a block are a +/- Sqrt(b*c).
! 
! =========
! 
!       SUBROUTINE LA_GEESX( A, <w>, VS=vs, SELECT=select, SDIM=sdim, &
!                              RCONDE=rconde, RCONDV=rcondv, INFO=info )
!            <type>(<wp>), INTENT(INOUT) :: A(:,:)
!            <type>(<wp>), INTENT(OUT) :: <w(:)>
!            <type>(<wp>), INTENT(OUT), OPTIONAL :: VS(:,:)
!            INTERFACE
!               LOGICAL FUNCTION SELECT(<w(j)>)
!                  <type>(<wp>), INTENT(IN) :: <w(j)>
!               END FUNCTION SELECT
!            END INTERFACE
!            OPTIONAL :: SELECT
!            INTEGER, INTENT(OUT), OPTIONAL :: SDIM
!            REAL(<wp>), INTENT(OUT), OPTIONAL :: RCONDE, RCONDV
!            INTEGER, INTENT(OUT), OPTIONAL :: INFO
!       where
!            <type> ::= REAL | COMPLEX
!            <wp>   ::= KIND(1.0) | KIND(1.0D0)
!            <w>    ::= WR, WI | W
!            <w(:)> ::= WR(:), WI(:) | W(:)
!            <w(j)> ::= WR(j), WI(j) | W(j)
! 
! Arguments
! =========
! 
! A       (input/output) REAL or COMPLEX square array, shape (:,:).
!         On entry, the matrix A.
!         On exit, the Schur form T .
! <w>     (output) REAL or COMPLEX array, shape (:) with size(w) = 
!         size(A,1).
!         The computed eigenvalues in the order in which they appear on
!         the diagonal of the Schur form T.
!         <w(:)> ::= WR(:), WI(:) | W(:),
!         where
!         WR(:), WI(:) are of REAL type (for the real and imaginary 
!         parts) and W(:) is of COMPLEX type.
!         Note: If A is real, then a complex-conjugate pair appear 
!         consecutively, with the eigenvalue having the positive 
! 	  imaginary part appearing first.
! VS      Optional (output) REAL or COMPLEX square array, shape (:,:) 
!         with size(VS,1) = size(A,1).
!         The matrix Z of Schur vectors.
! SELECT  Optional (input) LOGICAL FUNCTION
!         LOGICAL FUNCTION SELECT( <w(j)>)
!            <type>(<wp>), INTENT(IN) :: <w(j)>
!         where
!            <type> ::= REAL | COMPLEX
!            <wp> ::= KIND(1.0) | KIND(1.0D0)
!            <w(j)> ::= WR(j), WI(j) | W(j)
!         1. SELECT must be declared as EXTERNAL or as an explicit 
! 	   interface in the calling (sub)program.
!         2. SELECT is called by LA_GEES for every computed eigenvalue
! 	   <w(j)> (but only once for a complex conjugate pair when A 
! 	   is real). It is used to select the eigenvalues that will be
!          ordered to the top left of the Schur form. The eigenvalue 
! 	   <w(j)> is selected if SELECT(<w(j)>) has the value .TRUE.
!         3. A selected complex eigenvalue may no longer satisfy 
! 	   SELECT(<w(j)>) = .TRUE. after ordering, since ordering may
!          change the value of complex eigenvalues (especially if the
!          eigenvalue is ill-conditioned). In this case INFO is set to
!          size(A,1) + 2 (see INFO below).
!         Note: Select must be present if SDIM, RCONDE and RCONDF are 
! 	  desired.
! SDIM    Optional (output) INTEGER.
!         The number of eigenvalues (after sorting) for which 
! 	  SELECT = .TRUE. (If A is real, complex conjugate pairs for which
! 	  SELECT = .TRUE. for either eigenvalue count as 2).
! RCONDE  Optional (output) REAL.
!         The reciprocal condition number for the average of the selected
! 	  eigenvalues.
! RCONDV  Optional (output) REAL.
!         The reciprocal condition number for the selected right 
! 	  invariant subspace.
! INFO    Optional (output) INTEGER.
!         = 0: successful exit.
!         < 0: if INFO = -i, the i-th argument had an illegal value.
!         > 0: if INFO = i, and i is
!              <= n: the QR algorithm failed to compute all the 
!                    eigenvalues; elements 1:ilo-1 and i+1:n of <w> 
!                    contain those eigenvalues which have converged. 
!                    VS contains the matrix which reduces A to its 
!                    partially converged Schur form.
!              = n+1: the eigenvalues could not be reordered because some
! 	             eigenvalues were not sufficiently separated (the 
!                    problem is very ill-conditioned).
!              = n+2: after reordering, some leading complex eigenvalues
!                    in the Schur form no longer satisfy SELECT = .TRUE. 
!                    This can be caused by ordinary roundoff or underflow
!                    due to scaling.
!              n is the order of A.
!         If INFO is not present and an error occurs, then the program is
!         terminated with an error message.
!------------------------------------------------------------------------
!  .. LOCAL PARAMETERS ..
   CHARACTER(LEN=8), PARAMETER :: SRNAME = 'LA_GEESX'
!  .. LOCAL SCALARS ..
   CHARACTER(LEN=1) :: LJOBVS, LSORT, LSENSE
   INTEGER, SAVE :: LWORK = 0
   INTEGER :: N, LINFO, LD, ISTAT, ISTAT1, S1VS, S2VS, LSDIM
   REAL(WP) :: LRCONDE, LRCONDV
!  .. LOCAL ARRAYS ..
   REAL(WP), POINTER :: RWORK(:)
   LOGICAL, TARGET :: LLBWORK(1)
   LOGICAL, POINTER :: BWORK(:)
   COMPLEX(WP), TARGET :: LLVS(1,1)
   COMPLEX(WP), POINTER :: WORK(:)
!  .. INTRINSIC FUNCTIONS ..
   INTRINSIC MAX, PRESENT, SIZE
!  .. EXECUTABLE STATEMENTS ..
   LINFO = 0; ISTAT = 0; N = SIZE(A,1); LD = MAX(1,N)
   IF( PRESENT(VS) )THEN; S1VS = SIZE(VS,1); S2VS = SIZE(VS,2); LJOBVS = 'V'
   ELSE; S1VS = 1; S2VS = 1; LJOBVS = 'N'; END IF
   IF( PRESENT(SDIM) .OR. PRESENT(SELECT) )THEN; LSORT = 'S'; ELSE; LSORT = 'N'; END IF
   IF( PRESENT(RCONDE).AND.PRESENT(RCONDV) )THEN; LSENSE = 'B'
   ELSE IF( PRESENT(RCONDE) )THEN; LSENSE = 'E'
   ELSE IF( PRESENT(RCONDV) )THEN; LSENSE = 'V'; ELSE; LSENSE = 'N'; ENDIF
   IF( .NOT. LSAME(LSENSE,'N') ) LSORT = 'S'
!  .. TEST THE ARGUMENTS
   IF( N < 0 .OR. SIZE(A,2) /= N )THEN; LINFO = -1
   ELSE IF( SIZE( W ) /= N )THEN; LINFO = -2
   ELSE IF( PRESENT(VS) .AND. ( S1VS /= N .OR. S2VS /= N ) )THEN; LINFO = -3
   ELSE IF( LSAME(LSORT,'S') .AND. .NOT.PRESENT(SELECT) )THEN; LINFO = -4
   ELSE IF( N > 0 )THEN
      IF( LSAME(LSORT,'S') )THEN
        ALLOCATE(BWORK(N),STAT=ISTAT)
        IF (ISTAT /= 0) THEN; LINFO = -100; GOTO 100; ENDIF
      ELSE; BWORK => LLBWORK; END IF

      ALLOCATE( RWORK(MAX(1,N)), STAT=ISTAT )
      IF (ISTAT /= 0) THEN; LINFO = -100; GOTO 200; ENDIF

      LWORK = MAX(1, 2*N, N*N/2)
      ALLOCATE(WORK(LWORK), STAT=ISTAT)
      IF (ISTAT /= 0) THEN; LINFO = -100; GOTO 300; ENDIF
      IF (PRESENT (VS)) THEN
          CALL GEESX_F77( LJOBVS, LSORT, SELECT, LSENSE, N, A, LD, LSDIM, W, &
     &        VS, S1VS, LRCONDE, LRCONDV, WORK, LWORK, &
     &        RWORK, BWORK, LINFO )
       ELSE
          CALL GEESX_F77( LJOBVS, LSORT, SELECT, LSENSE, N, A, LD, LSDIM, W, &
     &        LLVS, S1VS, LRCONDE, LRCONDV, WORK, LWORK, &
     &        RWORK, BWORK, LINFO )
      ENDIF  	
      IF( LINFO == 0 ) LWORK = INT(WORK(1)+1)

      IF( PRESENT(SDIM) ) SDIM = LSDIM
      IF( PRESENT(RCONDE) ) RCONDE = LRCONDE
      IF( PRESENT(RCONDV) ) RCONDV = LRCONDV
      IF( LSAME(LSORT,'S') ) DEALLOCATE(BWORK, STAT=ISTAT1)

      DEALLOCATE(WORK, STAT=ISTAT)
300   DEALLOCATE(RWORK, STAT=ISTAT )
200   IF( LSAME(LSORT,'S')) DEALLOCATE(BWORK,STAT=ISTAT)
    ENDIF
100 CALL ERINFO(LINFO,SRNAME,INFO,ISTAT)
END SUBROUTINE CGEESX_F95

SUBROUTINE LA_TEST_CPOSVX( FACT, UPLO, N, NRHS, A, LDA, AF, LDAF, EQUED, &
     &  S, B, LDB, X, LDX, RCOND, FERR, BERR, WORK, RWORK, INFO )
!
!  -- LAPACK95 interface driver routine (version 1.1) --
!     UNI-C, Denmark,
!     April 5, 1999
!
!  .. Use Statements ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_POSVX
!  .. Implicit Statement ..
      IMPLICIT NONE
!  .. Scalar Arguments ..
      INTEGER, INTENT(IN) :: N, NRHS, LDA, LDB, LDAF, LDX
      INTEGER, INTENT(INOUT) :: INFO
      CHARACTER*1, INTENT(IN) :: FACT, UPLO
      CHARACTER(LEN=1), INTENT(INOUT) :: EQUED
      REAL(WP), INTENT(OUT) :: RCOND 
!  .. Array Arguments ..
      COMPLEX(WP), INTENT(INOUT) :: A(1:LDA,1:N), B(1:LDB,1:NRHS), AF(1:LDAF,1:N)
      REAL(WP), INTENT(INOUT) :: S(1:N)
      REAL(WP), INTENT(OUT) :: FERR(1:NRHS), BERR(1:NRHS)
      COMPLEX(WP), INTENT(OUT) :: X(1:LDX,1:NRHS), WORK(1:3*N)
      REAL(WP), INTENT(OUT) :: RWORK(1:N) 
!  .. Parameters ..
      CHARACTER(LEN=8),  PARAMETER :: SRNAME = 'LA_POSVX'
      CHARACTER(LEN=14), PARAMETER :: SRNAMT = 'LA_TEST_CPOSVX'
!  .. Common blocks ..
      INTEGER :: INFOTC
      COMMON /LINFO95/ INFOTC
!  .. Local Scalars ..
      INTEGER :: I, J, IA1, IA2, IB1, IB2, IX1, IX2, IAF1, IAF2, IS,&
     &  IFERR, IBERR
      CHARACTER*1 :: IUPLO, IFACT, IEQUED
!  .. Local Arrays ..
      LOGICAL, SAVE :: CTEST = .TRUE., ETEST = .TRUE.
      LOGICAL LSAME
!  .. Executable Statements ..
      IA1 = N; IA2 = N; IB1 = N; IB2 = NRHS; IUPLO= UPLO; IFACT = FACT
      IX1 = N; IX2 = NRHS; IAF1 = N; IAF2 = N; IEQUED = EQUED; IS = N
      IFERR = NRHS; IBERR = NRHS
      I = INFO / 100; J = INFO - I*100
      SELECT CASE(I)
      CASE(0)
      IF (NRHS == 1) THEN
        IF (LSAME(IFACT,'F')) THEN
          CALL LA_POSVX( A(1:IA1,1:IA2), B(1:IB1,1), X(1:IX1,1), &
     &      IUPLO, AF(1:IAF1,1:IAF2), IFACT, IEQUED, S(1:IS), FERR(1),&
     &      BERR(1), RCOND, INFO )
        ELSE
          CALL LA_POSVX( A(1:IA1,1:IA2), B(1:IB1,1), X(1:IX1,1), &
     &      IUPLO, AF(1:IAF1,1:IAF2), IFACT, EQUED, S(1:IS), FERR(1),& 
     &      BERR(1), RCOND, INFO )
        ENDIF
        INFO = INFOTC
      ELSE
        IF (LSAME(IFACT,'F')) THEN
          CALL LA_POSVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &      IUPLO, AF(1:IAF1,1:IAF2), IFACT, IEQUED, S(1:IS), FERR(1:IFERR),&
     &      BERR(1: IBERR), RCOND, INFO )
        ELSE
          CALL LA_POSVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &      IUPLO, AF(1:IAF1,1:IAF2), IFACT, EQUED, S(1:IS), FERR(1:IFERR),&
     &      BERR(1: IBERR), RCOND, INFO )
        ENDIF
        INFO = INFOTC
      END IF
    CASE (1)
      IA2 = IA1 - 1
    CASE (2)
      IB1 = IA1 - 1
    CASE (3)
      IX1 = IA1 - 1
    CASE (4)
      IUPLO = 'T'
    CASE (5)
      IAF1 = IA1 - 1
    CASE (6)
      IFACT = 'T'
    CASE (7)
      IFACT = 'F'
      IEQUED = 'T'
      CALL LA_POSVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &  IUPLO, AF(1:IAF1,1:IAF2), IFACT, IEQUED, S(1:IS), FERR(1:IFERR),&
     &  BERR(1: IBERR), RCOND, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
    CASE (8)
      IS = IA1 - 1
    CASE (9)
      IFACT = 'F' ;  S = +1.0_WP
      IFERR = NRHS - 1
      CALL LA_POSVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &  IUPLO, AF(1:IAF1,1:IAF2), IFACT, IEQUED, S(1:IS), FERR(1:IFERR),&
     &  BERR(1: IBERR), RCOND, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN
      CASE (10); S = +1.0_WP
      IBERR = IB2 - 1
      CALL LA_POSVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &  IUPLO, AF(1:IAF1,1:IAF2), IFACT, IEQUED, S(1:IS), FERR(1:IFERR),&
     &  BERR(1: IBERR), RCOND, INFO )
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
      RETURN 
      CASE(:-1, 11:)
      CALL UESTOP(SRNAMT)
      END SELECT
      IF( I /= 0 ) THEN
        SELECT CASE (NRHS)
        CASE (2:)
        CALL LA_POSVX( A(1:IA1,1:IA2), B(1:IB1,1:IB2), X(1:IX1,1:IX2), &
     &    IUPLO, AF(1:IAF1,1:IAF2), IFACT, IEQUED, S(1:IS), FERR(1:IFERR),&
     &    BERR(1: IBERR), RCOND, INFO )
        CASE(1)
        CALL LA_POSVX( A(1:IA1,1:IA2), B(1:IB1,1), X(1:IX1,1), &
     &    IUPLO, AF(1:IAF1,1:IAF2), IFACT, IEQUED, S(1:IS), FERR(1),&
     &    BERR(1), RCOND, INFO )
        CASE(:-1)
        CALL UESTOP(SRNAMT)
      END SELECT
      END IF
      
      CALL LA_AUX_AA01( I, CTEST, ETEST, SRNAMT )
END SUBROUTINE LA_TEST_CPOSVX
      

      PROGRAM LA_CGGSVD_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_GGSVD
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, INFO, M, N, P, K, L
      REAL(WP), ALLOCATABLE :: ALPHA(:), BETA(:)
!  .. "Local Arrays" ..
      COMPLEX(WP), ALLOCATABLE :: A(:,:), AA(:,:), B(:,:), BB(:,:), U(:,:), V(:,:), Q(:,:)
!  .. "Intrinsic Functions" ..
      INTRINSIC REAL, AIMAG, INT
!  .. "Executable Statements" ..
      WRITE (*,*) 'LA_GGSVD Example Program Results'
      N = 3; M=5; P=2
      ALLOCATE( A(M,N), AA(M,N), B(P,N), BB(P,N), ALPHA(N), BETA(N), U(M,M), V(P,P), Q(N,N) )

      OPEN(UNIT=21,FILE='ggsvd.ma',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,M
            READ(21,*) A(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      AA=A

      WRITE(*,*)'Matrix A : '
      DO I=1,M      
         WRITE(*,"(3('('(I3,1X,',',I3)')',1X,1X))") INT(A(I,1)),INT(AIMAG(A(I,1))), &
              INT(A(I,2)),INT(AIMAG(A(I,2))), &  
              INT(A(I,3)),INT(AIMAG(A(I,3)))
      ENDDO
   
      OPEN(UNIT=21,FILE='ggsvd.mb',STATUS='UNKNOWN')
      DO J=1,N
         DO I=1,P
            READ(21,*) B(I,J)
         ENDDO
      ENDDO
      CLOSE(21)

      BB=B
      WRITE(*,*)
      WRITE(*,*)'Matrix B : '
      DO I=1,P
         WRITE(*,"(3('('(I3,1X,',',I3)')',1X,1X))") INT(B(I,1)), INT(AIMAG(B(I,1))), &
              INT(B(I,2)),INT(AIMAG(B(I,2))), &
              INT(B(I,3)),INT(AIMAG(B(I,3)))
      ENDDO

      WRITE(*,*)
      WRITE(*,*) "CALL LA_GGSVD( A, B, ALPHA, BETA, K, L ) "
      CALL LA_GGSVD( A, B, ALPHA, BETA, K, L )
     
      WRITE(*,*)'A on exit : ' 
      DO I=1,M;
         WRITE(*,"(3('('(E13.6,1X,',',E13.6)')',1X))") REAL(A(I,1)),AIMAG(A(I,1)), &
              REAL(A(I,2)),AIMAG(A(I,2)), &
              REAL(A(I,3)),AIMAG(A(I,3))
      ENDDO
      WRITE(*,*)
      WRITE(*,*)'ALPHA on exit : '
      DO I=1,N
         WRITE(*,"((E14.6,1X))") ALPHA(I)
      ENDDO
      WRITE(*,*)
      WRITE(*,*)'BETA on exit : '
      DO I=1,N
         WRITE(*,"((E14.6,1X))") BETA(I)
      ENDDO
      WRITE(*,*)
      WRITE(*,*)' K = ', K
      WRITE(*,*)' L = ', L
   
      WRITE(*,*)
      WRITE(*,*)' * EXAMPLE 2 * '
      WRITE(*,*)
      WRITE(*,*) "CALL LA_GGSVD( A, B, ALPHA, BETA, K, L, U, V, Q, INFO=INFO )"
      CALL LA_GGSVD(  AA, BB, ALPHA, BETA, K, L, U, V, Q , INFO=INFO )
    
      WRITE(*,*)'U on exit : '
      DO I=1,M;
         WRITE(*,"(5('('(E13.6,1X,',',1X,E13.6)')',1X))") REAL(U(I,1)), AIMAG(U(I,1)), &
              REAL(U(I,2)), AIMAG(U(I,2)), &
              REAL(U(I,3)), AIMAG(U(I,3)), &
              REAL(U(I,4)), AIMAG(U(I,4)), &
              REAL(U(I,5)), AIMAG(U(I,5))
      ENDDO
      WRITE(*,*)
      WRITE(*,*)'V on exit : '
      DO I=1,P;
         WRITE(*,"(2('('(E13.6,1X,',',E13.6)')',1X,1X))") REAL(V(I,1)), AIMAG(V(I,1)), &
              REAL(V(I,2)), AIMAG(V(I,2))
      ENDDO
      WRITE(*,*)
      WRITE(*,*)'Q on exit : '
      DO I=1,N;
         WRITE(*,"(3('('(E13.6,1X,',',E13.6)')',1X))") REAL(Q(I,1)), AIMAG(Q(I,1)), &
              REAL(Q(I,2)), AIMAG(Q(I,2)), &
              REAL(Q(I,3)), AIMAG(Q(I,3))
      ENDDO
      WRITE(*,*)       
      WRITE(*,*) ' INFO = ', INFO

      END PROGRAM LA_CGGSVD_EXAMPLE

      INTEGER FUNCTION LA_WS_GELSS( VER, M, N, NRHS )
!
!  -- LAPACK95 interface driver routine (version 1.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     May 31, 1997
!
!   .. USE STATEMENTS ..
      USE F77_LAPACK, ONLY: ILAENV_F77 => LA_ILAENV
!     .. IMPLICIT STATEMENT ..
      IMPLICIT NONE
!     .. SCALAR ARGUMENTS ..
      CHARACTER(LEN=1), INTENT(IN) :: VER
      INTEGER, INTENT(IN) :: M, N, NRHS
!     .. PARAMETERS ..
      CHARACTER(LEN=5), PARAMETER :: NAME1='GELSS', NAME2='GEQRF', NAME3='ORMQR', NAME4='GEBRD', &
                                     NAME5='ORMBR', NAME6='ORGBR', NAME7='GELQF', NAME8='ORMLQ'
!     .. LOCAL SCALARS ..
      INTEGER :: MNTHR, MINWRK, MAXWRK, MM, BDSPAC
!     .. INTRINSIC FUNCTIONS ..
      INTRINSIC MAX
!     .. EXECUTABLE STATEMENTS ..
      MNTHR = ILAENV_F77( 6, VER//NAME1, ' ', M, N, NRHS, -1 )
!
!     COMPUTE WORKSPACE
!      (NOTE: COMMENTS IN THE CODE BEGINNING "Workspace:" DESCRIBE THE
!       MINIMAL AMOUNT OF WORKSPACE NEEDED AT THAT POINT IN THE CODE,
!       AS WELL AS THE PREFERRED AMOUNT FOR GOOD PERFORMANCE.
!       NB REFERS TO THE OPTIMAL BLOCK SIZE FOR THE IMMEDIATELY
!       FOLLOWING SUBROUTINE, AS RETURNED BY ILAENV.)
!
      MINWRK = 1
      MAXWRK = 0
      MM = M
      IF( M.GE.N .AND. M.GE.MNTHR ) THEN
!
!        PATH 1A - OVERDETERMINED, WITH MANY MORE ROWS THAN COLUMNS
!
         MM = N
         MAXWRK = MAX(MAXWRK,N+N*ILAENV_F77(1,VER//NAME2,' ',M,N,-1,-1))
         MAXWRK = MAX( MAXWRK, N+NRHS*                                  &
     &            ILAENV_F77( 1, VER//NAME3, 'LT', M, NRHS, N, -1 ) )
      END IF
      IF( M.GE.N ) THEN
!
!        PATH 1 - OVERDETERMINED OR EXACTLY DETERMINED
!
!        COMPUTE WORKSPACE NEEDE FOR DBDSQR
!
         BDSPAC = MAX( 1, 5*N-4 )
         MAXWRK = MAX( MAXWRK, 3*N+( MM+N )*                            &
     &            ILAENV_F77( 1, VER//NAME4, ' ', MM, N, -1, -1 ) )
         MAXWRK = MAX( MAXWRK, 3*N+NRHS*                                &
     &            ILAENV_F77( 1, VER//NAME5, 'QLT', MM, NRHS, N, -1 ) )
         MAXWRK = MAX( MAXWRK, 3*N+( N-1 )*                             &
     &            ILAENV_F77( 1, VER//NAME6, 'P', N, N, N, -1 ) )
         MAXWRK = MAX( MAXWRK, BDSPAC )
         MAXWRK = MAX( MAXWRK, N*NRHS )
         MINWRK = MAX( 3*N+MM, 3*N+NRHS, BDSPAC )
         MAXWRK = MAX( MINWRK, MAXWRK )
      END IF
      IF( N.GT.M ) THEN
!
!        COMPUTE WORKSPACE NEEDE FOR DBDSQR
!
         BDSPAC = MAX( 1, 5*M-4 )
         MINWRK = MAX( 3*M+NRHS, 3*M+N, BDSPAC )
         IF( N.GE.MNTHR ) THEN
!
!           PATH 2A - UNDERDETERMINED, WITH MANY MORE COLUMNS
!           THAN ROWS
!
            MAXWRK = M + M*ILAENV_F77( 1,VER//NAME7,' ',M,N,-1,-1 )
            MAXWRK = MAX( MAXWRK, M*M+4*M+2*M*                          &
     &               ILAENV_F77( 1, VER//NAME4, ' ', M, M, -1, -1 ) )
            MAXWRK = MAX( MAXWRK, M*M+4*M+NRHS*                         &
     &               ILAENV_F77( 1,VER//NAME5,'QLT',M,NRHS,M,-1 ) )
            MAXWRK = MAX( MAXWRK, M*M+4*M+( M-1 )*                      &
     &               ILAENV_F77( 1, VER//NAME6, 'P', M, M, M, -1 ) )
            MAXWRK = MAX( MAXWRK, M*M+M+BDSPAC )
            IF( NRHS.GT.1 ) THEN
               MAXWRK = MAX( MAXWRK, M*M+M+M*NRHS )
            ELSE
               MAXWRK = MAX( MAXWRK, M*M+2*M )
            END IF
            MAXWRK = MAX( MAXWRK, M+NRHS*                               &
     &               ILAENV_F77( 1, VER//NAME8, 'LT', N, NRHS, M, -1 ) )
         ELSE
!
!           PATH 2 - UNDERDETERMINED
!
            MAXWRK = 3*M+(N+M)*ILAENV_F77(1,VER//NAME4,' ',M,N,-1,-1)
            MAXWRK = MAX( MAXWRK, 3*M+NRHS*                             &
     &               ILAENV_F77( 1,VER//NAME5,'QLT',M,NRHS,M,-1 ) )
            MAXWRK = MAX( MAXWRK, 3*M+M*                                &
     &               ILAENV_F77( 1, VER//NAME6, 'P', M, N, M, -1 ) )
            MAXWRK = MAX( MAXWRK, BDSPAC )
            MAXWRK = MAX( MAXWRK, N*NRHS )
         END IF
      END IF
      LA_WS_GELSS = M*M + 4*M*M + 3*N*N + NRHS*NRHS*NRHS
!     &  MAX( MINWRK, MAXWRK )
      END FUNCTION LA_WS_GELSS

      PROGRAM LA_SPOSVX_EXAMPLE

!  -- LAPACK95 EXAMPLE DRIVER ROUTINE (VERSION 1.0) --
!     UNI-C, DENMARK
!     DECEMBER, 1999
!
!  .. "Use Statements" ..
      USE LA_PRECISION, ONLY: WP => SP
      USE F95_LAPACK, ONLY: LA_POSVX
!  .. "Implicit Statement" ..
      IMPLICIT NONE
!  .. "Local Scalars" ..
      INTEGER :: I, J, N, NRHS
      CHARACTER(LEN=1) :: EQUED
!  .. "Local Arrays" ..
      REAL(WP), ALLOCATABLE :: A(:,:), B(:,:), X(:,:), S(:), &
                               FERR(:), BERR(:)
!  .. "Executable Statements" ..
      WRITE (*,*) 'SPOSVX Example Program Results'
      N = 5; NRHS = 3
      ALLOCATE ( A(N,N), B(N,NRHS), X(N,NRHS), S(N), FERR(NRHS), &
                 BERR(NRHS) )
    
      OPEN(UNIT=21,FILE='posv.ma',STATUS='UNKNOWN')
      DO I=1,N
         DO J=I,N
         READ(21,'(F3.0)') A(I,J);
         ENDDO
      ENDDO;
      CLOSE(21)

      A(:,1)=1E-6*A(:,1);A(1,2:N)=1E-6*A(1,2:N)

      DO J = 1, NRHS; DO I = 1, N
      B(I,J) = (SUM(A(I,I:N)) + SUM(A(1:I-1,I)))*J
      ENDDO; ENDDO
  
      WRITE(*,*) 'The array B :'
      DO J=1,NRHS; DO I = 1, N
       WRITE(*,'(10(I3,1X,1X),I3,1X)') INT(B(I,J)); 
      ENDDO; ENDDO
                                                        
      WRITE(*,*) 'CALL LA_POSVX( A, B, X, FACT="E", EQUED=EQUED, S=S )'
      CALL LA_POSVX(  A, B, X, FACT='E', EQUED=EQUED, S=S )
      
      WRITE(*,*)'EQUED = ', EQUED
      WRITE(*,*)'S = ', S
      WRITE(*,*)'FERR = ', FERR
      WRITE(*,*)'BERR = ', BERR

      WRITE(*,*) 'The solution of the system $ A\,X = B $ is:'
      WRITE(*,*) '$$ X = \left( \begin{array}{rrr}'
      DO I=1,N; WRITE(*,"(2(F9.5,' & '),F9.5,' \\')") X(I,:); ENDDO
      WRITE(*,*) '\end{array} \right). $$'
    
      END PROGRAM LA_SPOSVX_EXAMPLE

 SUBROUTINE DGELS1_F95( A, B, TRANS, INFO )
!
!  -- LAPACK95 interface driver routine (version 3.0) --
!     UNI-C, Denmark; Univ. of Tennessee, USA; NAG Ltd., UK
!     September, 2000
!
!   .. USE STATEMENTS ..
    USE LA_PRECISION, ONLY: WP => DP
    USE LA_AUXMOD, ONLY: ERINFO, LSAME, LA_WS_GELS
    USE F77_LAPACK, ONLY: GELS_F77 => LA_GELS
!   .. IMPLICIT STATEMENT ..
    IMPLICIT NONE
!   .. SCALAR ARGUMENTS ..
    CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
    INTEGER, INTENT(OUT), OPTIONAL :: INFO
!   .. ARRAY ARGUMENTS ..
    REAL(WP), INTENT(INOUT) :: A(:,:), B(:)
!   .. PARAMETERS ..
    CHARACTER(LEN=7), PARAMETER :: SRNAME = 'LA_GELS'
    CHARACTER(LEN=1), PARAMETER :: VER = 'D'
!   .. LOCAL SCALARS ..
    CHARACTER(LEN=1) :: LTRANS
    INTEGER :: LINFO, ISTAT, ISTAT1, LWORK, N, M
!   .. LOCAL POINTERS ..
    REAL(WP), POINTER :: WORK(:)
!   .. INTRINSIC FUNCTIONS ..
    INTRINSIC SIZE, PRESENT, MAX, MIN
!   .. EXECUTABLE STATEMENTS ..
    LINFO = 0; ISTAT = 0; M = SIZE(A,1); N = SIZE(A,2)
    IF( PRESENT(TRANS) )THEN; LTRANS = TRANS; ELSE; LTRANS = 'N'; ENDIF
!   .. TEST THE ARGUMENTS
    IF( M < 0 .OR. N < 0 ) THEN; LINFO = -1
    ELSE IF( SIZE( B ) /= MAX(1,M,N) ) THEN; LINFO = -2
    ELSE IF( .NOT.( LSAME(LTRANS,'N') .OR. LSAME(LTRANS,'T') ) )THEN; LINFO = -3
    ELSE
!   .. CALCULATE THE OPTIMAL WORKSPACE ..
       LWORK = LA_WS_GELS( VER, M, N, 1, LTRANS )
       ALLOCATE( WORK(LWORK), STAT = ISTAT )
       IF( ISTAT /= 0 ) THEN
          DEALLOCATE( WORK, STAT=ISTAT1 ); LWORK = MIN(M,N) + MAX(1,M,N)
          ALLOCATE( WORK(LWORK), STAT = ISTAT )
          IF( ISTAT /= 0 ) CALL ERINFO( -200, SRNAME, LINFO )
       END IF
       IF ( ISTAT == 0 ) THEN
!      .. CALL LAPACK77 ROUTINE
          CALL GELS_F77( LTRANS, M, N, 1, A, MAX(1,M), B, MAX(1,M,N), &
                         WORK, LWORK, LINFO )
       ELSE; LINFO = -100; END IF
       DEALLOCATE(WORK, STAT = ISTAT1 )
    END IF
    CALL ERINFO( LINFO, SRNAME, INFO, ISTAT )
 END SUBROUTINE DGELS1_F95
